VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Utf8MarcRecordClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit


' THIS IS THE OFFICIAL COPY OF THIS MODULE
' ACCEPT NO SUBSTITUTES

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryValueExString Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegQueryValueExLong Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Long, lpcbData As Long) As Long
Private Declare Function RegQueryValueExNull Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As Long, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

Private Const MAIN_KEY_CURRENTUSER = &H80000001
Private Const MAIN_KEY_LOCALMACHINE = &H80000002

Private Const REGTYPE_SZ As Long = 1
Private Const REGTYPE_DWORD As Long = 4

Private Const KEY_ALL_ACCESS = &H3F


' *******************************
' * constants and work areas related to generation of a sorting form for date-related subfields
' *******************************
' BC_MARKER and AD_MARKER precede dates of the indicated type; BC_MARKER must
'   have a lower collating sequence than AD_MARKER
Private Const BC_MARKER$ = "A"
Private Const AD_MARKER$ = "B"
' one or the other of the "span codes" separates the first date in the span
'   from the second date; it appears that the critical distinction is whether the
'   range includes one BC date and one AD date on the one hand, or two BC dates or
'   two AD dates on the other hand
' these should have a higher collating order than AD_MARKER
Private Const SPANCODE_DIFFERENT_ERA$ = "C"
Private Const SPANCODE_SAME_ERA$ = "D"
' we use this prefix if date 1 consists of year plus month (and day), to force
'   anything with the same year without specified month and day to come BEFORE
'   anything that has month and day; must have a higher collating order than the
'   two SPANCODE_ constants
Private Const DATE_1_EXTENSION_PREFIX$ = "E"
' these constants are used by the "subfield $y sorting form exceptions" subroutine
'   to tell the main routine how to proceed with the remainder of its work
Private Const SfdSortingFormYReturn_Nothing% = 0
Private Const SfdSortingFormYReturn_Normal% = 1
Private Const SfdSortingFormYReturn_AdjustLeadNumeric% = 2
' in the conversion of subfield $y text into the filing equivalent, we're probably
'   forcing them into a 4-digit space, even for B.C.; if it turns out that we need
'   to deal with longer dates (perhaps because of newly-discovered B.C. dates?), a
'   change to this constant will instantly re-size everything to correspond
Private Const SUBFIELD_Y_DATE_SIZE% = 4
' these two are pseudo-constants used in the conversion of subfield $y text into
'   the filing equivalent; their value is set at class initialization, based
'   on the value of SUBFIELD_Y_DATE_SIZE%
Private prvsSubfieldYZeroString$, prvsSubfieldYNineString$
Private prvlSubfieldYDateMaximum As Long
' the constant GEOLOGICAL_PERIODS$ contains all of the established geological period
'   names (which are actually sorted alphabetically), as well as those variant period names that
'   appear only in 4XX fields in authority records (the point of this routine isn't
'   to determine whether a subdivision is correct, but only to produce the correct
'   filing equivalent)
' we used this constant during development, because we wanted to separate off things in
'   $y that didn't contain dates but were correct (geological
'   periods), from things in $y that didn't contain dates but were incorrect
' now that we're in production we don't bother with this distinction any more; but
'   we'll leave the constant here in case it comes in handy later
Private Const GEOLOGICAL_PERIODS$ = "*ALGONKIAN*ARCHEAN*ARCHAEAN*CAMBRIAN*CARBONIFEROUS*CENOZOIC*CRETACEOUS*DEVONIAN*EOCENE*HOLOCENE*HURONIAN*JURASSIC*LAURENTIAN*MESOZOIC*MIOCENE*MISSISSIPPIAN*NEOCENE*NEOGENE*OLIGOCENE*ORDOVICIAN*PALEOCENE*PALEOGENE*PALEOZOIC*PENNSYLVANIAN*PERMIAN*PERMO CARBONIFEROUS*PLEISTOCENE*PLIOCENE*POSTGLACIAL*PRE CAMBRIAN*PRECAMBRIAN*PROTEROZOIC*QUATERNARY*SILURIAN*TERTIARY*TRIASSIC*"
' *******************************
' * end of constants and work areas related to generation of a sorting form for date-related subfields
' *******************************


Private Const prvsSeriesNumArticles$ = " A AN THE "
Private Const prvsSeriesNumCjkThWords$ = " DAI TI DI "
Private Const prvsSeriesNumCjkIgnoredWords$ = " BU BUNSATSU CHI CHUNG FEN GO HAO HEN KAN KOZA NEN PIEN SATSU SEIJI SETSU SHU SOSHO TSE ZHONG "
Private Const prvsSeriesNumHorsSeriesReplacement$ = "HORS SER"
Private Const prvsSeriesNumHorsWords$ = " H HORS "
Private Const prvsSeriesNumNewSeriesReplacement$ = "NEW SER"
Private Const prvsSeriesNumNewSeriesWords$ = " NFBD NS "
Private Const prvsSeriesNumNewWords$ = " ALTER ALTERA N NEW NEUE NUEVA NIEUWE NOU NOUV NOUVA NOUVELLE NOVA NOVAIA NUOV NUOVA NUWE NY "
Private Const prvsSeriesNumSeriesReplacement$ = "SER"
Private Const prvsSeriesNumSeriesWords$ = " COLLANA DIVISION DIZI DIZISI F FG FOL FOLDJDEN FOLJD FOLJDEN FOLGE KOLO P PERIODE RADA REDA REEKS REIHE REKKE S SARJA SER SERI SERIA SERIE SERIES SERIIA SERIJA SKUPINA "
Private Const prvsSeriesNumShortWordList$ = " & AN AND AT DE E FOR IN OF THE TO "
Private Const prvsSeriesNumSingleLetterCaptions$ = " D F H J N P R S T "
Private Const prvsSeriesNumSubstitutionString$ = " BOOKS *BOOK COMMAND CMND CMD *CD COLLOQUE CONGRESS *CONG SUPPLEMENTO SUPPLEMENTA SUPLEMENTO SUPP SUPPL SUPPLEMENT SUPPLEMENTBD SUPPLEMENTBAND SUPPLEMENTARY SUPPLEMENTS SUPPLEMENTUM *SUP"



Private Const prvsBeginMarkerForDiacriticLabels$ = "<-"
Private Const prvsEndMarkerForDiacriticLabels$ = "->"

Private Const prviSeriesNumMinimumInterestingLength% = 8

    ' tag plus location of the nonfiling indicator
Private Const CONST_AuthorityTagString$ = "130:2 430:2 530:2"
Private Const CONST_BibliographicTagString$ = "130:1 240:2 242:2 243:2 245:2 440:2 630:1 730:1 740:1 830:2"
Private Const CONST_CommunityInfoString$ = "245:2 440:2 630:1 730:1 740:1"

#Const WithDebug = 0 ' -1 ' 0 ' -1
#Const CharacterSetDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0
#Const CharacterSetOutDebug = 0 ' -1
' this one writes to a file:
#Const DecomposeUnicodeCharactersDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0
#Const DigestRecordDebug = 0 ' -1 ' 0 ' -2 ' 0 ' -1
#Const DigestSfdTextDebug = 0 ' -1  ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0
#Const FldAddDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0
#Const FldChangeDebug = 0 ' -1
#Const FldFindLastDebug = 0 ' -1
#Const FldInsertAfterDebug = 0 ' -1 ' 0 ' -1
#Const FldTextDebug = 0 ' -1 ' 0 ' -1
#Const IsMarcDebug = 0 ' -1
#Const Marc2MsoftAsciiDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 ' -1 ' 0
#Const Marc2PlainTextDebug = 0 ' -1
#Const Marc2SacoProposalDebug = 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 ' -1 ' 0
#Const MarcRecordInDebug = 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 ' -1 ' 0
#Const MarcRecordInDebugShort = 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 ' -1 ' 0
#Const MarcRecordModifiedDebug = 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 ' -1 ' 0
#Const NormalizeWholeFieldDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0
#Const NormCallNumberDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0
#Const NormStringDebug = 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0
#Const NormStringDebugFull = 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0
#Const ReplaceCharactersDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0
#Const ResetCurrentFieldDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0
#Const SafeMidDebug = 0 ' -1
#Const SeriesPolicyLocalDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 'e -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0
#Const SetFldOrderDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1
#Const SetFieldSortGroupFromTagDebug = 0 ' -1 ' 0 ' -1
#Const SetFieldSortGroupFromTagEndgameDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1
#Const SetSfdOrderDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0
#Const SfdAddDebug = 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0
#Const SfdFindLastDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0
#Const SfdInsertAfterDebug = 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0
#Const SfdTextFormattedDebug = 0 ' -1
#Const TestSfdPositionDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0
#Const TranslateCharacterSetDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0
#Const TranslateMarc2Utf8Debug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0
#Const TranslateMarc2Utf8FindBreakDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0
#Const TranslateUtf82MarcOneFieldDebug = 0 ' -1 '0 '-1
#Const TranslateMarc2Utf8TextDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 -1 ' 0 ' -1 ' 0
#Const TranslateMarc2Utf8TextErrorOnlyDebug = 0 ' -1 ' 0 ' -1
#Const TranslateUtf8ToMarcDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0
#Const TranslateUtf8ToMarcTextDebug = 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0 ' -1 ' 0

Const DefaultSortingIndicatorFor653Field$ = "9"

Const TextFormatted_HexEquivalents% = 0
Const TextFormatted_Default% = TextFormatted_HexEquivalents%
Const TextFormatted_Latin1% = 1
Const TextFormatted_Latin1Extended% = 2
Const TextFormatted_Raw% = 3
Const TextFormatted_SacoProposal% = 4
Const TextFormatted_HexEquivalentsExcept880Raw% = 5
Const TextFormatted_Latin1AsUtf8% = 6
Const TextFormatted_PlainText% = 7
Const TextFormatted_Latin1NoDelimiters% = 8
Const TextFormatted_Latin1WithDots% = 9
Const TextFormatted_RtfText% = 10
Const TextFormatted_RtfTextWithLabels% = 11
Const TextFormatted_RtfTextNoDelimiters% = 12
Const TextFormatted_RtfTextNormalizedNaco% = 13
Const TextFormatted_RtfTextNormalizedPlain% = 14

#Const StandardSingleLetterAbbreviationHandling = False
' probably NOT add Serbian word "kolo" unless you can determine that it's really a caption word
' add? HALFTE; VOLYM; GROUP
' add? GUide (probably not)
' what about COLLECTION?
' add? atlas
' ? brief
' FASE is probably just a typo for FASC
' VIP may be typo for VYP
' ZEHNT added for Geschichtsblatter des deutschen hugenotten Vereins, e.V
' DI experimentally added--why wasn't it here before?  If this turns out to be a bad idea, remove it from
'   the list, and footnote that the list of captions doesn't necessarily include 'em all
#If StandardSingleLetterAbbreviationHandling Then
    Private Const prvsSeriesNumIgnoredWords1$ = " AARSSKRIFT AASTAK AASTAKAIK ABD ABDR ABDRUCK ABH ABHAND ABHANDLUNG ABHANDLUNGEN ABSCHN ABSCHNITT ABSTRACT ABT ABTEIL ABTEILUNG ABTH ABTHEIL ABTHEILUNG ADAD ADD ADDENDUM AFD AFDELING AFL AFLEVERING ALADAD ALBUM AL KITAB ALQISM ALSIFR AN AND ANEJO ANEXO ANN ANNEE ANNEX ANNO ANO ANY ARBEITSPAPIER ARG ARGANG ARGGRAFFIAD ARSSKRIFT ART ARTICLE AUSSTELLUNG AVD AVDELNING AVHANDLINGER AVIV BAND BANDCHEN BANDE BD BDE BDCHEN BDCHN BEIHEFT BEIHEFTE BEILAG BEILAGEN BEITRAG BERICHT BHFT BIL BILANGAN BILDHEFT BIND BK BKS BLATT BLOCK BOOK BOOKLET BOOKS BROCHURE BUCH BUCHER BUL BULL BULLETIN CAHIER CAHIERS CASSETTE CAT CATALOG CATALOGO CATALOGUE CATALOGUS CH CHAP CHAPBOOK CHAPITRE CHAPTER CHIH CIS CISLO COMUNICACAO CONFERENCE CONTRIBUTION CORPUS COURSE CUADERNO "
    Private Const prvsSeriesNumIgnoredWords2$ = " D DAI DEEL DEL DEELEN DELEN DIL DISC DOC DOCUMENT DOCUMENTO DOKUMENT DOSSIER DRUCK DZEL EINZELAUSG ERGANZUNGSBAND ERGANZUNGSBD ERGANZUNGSHEFT ESTUDIO ESTUDIOS ETUDE ETUDES EXTRA FASC FASCICOLO FASE FASCICLE FASCICULE FASZ FASZIKEL FG FICHE FICHES FILM FOL FOLJD FOLJDEN FOLGE FORUM FS GRADE GRADES GRANTHANKAH GROUP GRUNNA GUIDE GUIDE-BOOK GUIDES GUIDEBOOK "
    Private Const prvsSeriesNumIgnoredWords3$ = " H HAFT HALB HALB-BD HALBBAND HALBBD HANDBOOK HANDLIST HAO HAPUTABTH HDBK HEFT HEFTE HELEK HF HFT HFTE HOV HOVERET IMLEABHAR ISSUE ITEM ITEMS IWE J JAARG JAARGANG JAHR JAHRESREIHE JAHRG JAHRGAG JAHRGANG JG JHRG KAN KAP KAPITEL KEREK KEREKH KITAB KN KNJ KNIGA KNIHA KOMPLEKT LEAFLET LECTURE LEHRHEFT LEVEL LEVELS LEVNADSTECKNINGAR LFG LIBER LIBRO LIEFERUNG LIBROS LIST LIVR LIVRAISON LIVRE MANUAL MAP MAPPE MEMOIRE MEMORIA MICROCOPY MIS MODULE MONOGRAFIA MONOGRAFIE MONOGRAPH MONOGRAPHS MONOGRAPHY MUJALLAD "
    'private Const prvsSeriesNumIgnoredWords4$ = " NIVEL NIZ NO NOMBOR NOMOR NOS NOTE NR NRS NUM NUMBER NUMERO NUMMER OPUS PAGE PAGES PAMPHLET PAPER PAPERS PARS PART PARTE PARTES PARTIE PARTIES PARTS POS POSITION PROGRAM PT PTS PTES PUB PUBLICACI PUBLICACION PUBLICATION PT QUADERNI QUADERNO R RADA RAEKKE REEK REEKS REEL REELS REIHE REIRE RELEASE REP REPORT REPT RESEARCH ROC ROCNIK ROCZ ROCZNIK ROK RPT SCHRIFT SEC SECT SECTION SECTIONS SECTS SEFER SEGMENT SELECTIONS SER SERIE SERIES SERIIA SESS SESSION SET SHEET SKUPINA SONDERBAND SONDERBD SPECIAL STAGE STUCK STUDIA STUDIESTUK STUDY SUP SUPLEMENTO SUPP SUPPL SUPPLEMENT SUPPLEMENTARY SUPPLEMENTS SUPPLEMENTUM T TAPE TEIL TEILBAND TEILBD TEXT TEXTBAND TEXTS THEIL THROUGH TITRE TOM TOME TOMO TOMUS TOPIC TRACT UNIT V VEROFFENTLICHUNG VEROFFENTLICHUNGEN VERSLAG VOL VOLS VOLUME VOLUMEN VOLUMES VYP WHOLE WORK WORKING YEAR ZESZ "
    Private Const prvsSeriesNumIgnoredWords4$ = " NIDE NIDE-T NIDOS NIVEL NIZ NO NOMBOR NOMOR NOS NOTE NOVA NR NRS NUM NUMBER NUMERO NUMERUS NUMMER OBRA OEUVRE OPUS OSA PAGE PAGES PAM PAMPHLET PAPER PAPERS PARATEMA PARS PART PARTE PARTES PARTIE PARTIES PARTS PERIODICAL PHASE PIRSUM POS POSITION PRAPARANDENHEFT PROGRAM PT PTE PTIE PTS PTES PUB PUBBLICAZIONE PUBBLICAZIONI PUBLICACI PUBLICACIO PUBLICACION PUBLICATION PUBLICATIONS PT QISM QUADERNI QUADERNO R RADA RAEKKE RAPPORT RECUEIL REDA REEK REEKS REKKE REEL REELS REG REIHE REIRE RELATORIO RELEASE REP REPORT REPT RESEARCH ROC ROCNIK ROCZ ROCZNIK ROK RPT "
    Private Const prvsSeriesNumIgnoredWords5$ = " SA SAGGI SARJA SATSU SAYI SAYISI SB SBORNIK SCHRIFT SEC SECT SECTIO SECTION SECTIONS SECTS SEFER SEGMENT SELECTIONS SER SERIE SERIES SERIIA SERIJA SESS SESSION SET SEZ SEZIONE SHEET SIFR SKRIFTER SKUPINA SONDERBAND SONDERBD SPECIAL STAGE STUCK STUDIA STUDIE STUDIEN STUDIES STUDIESTUK STUDY STUK SV SVAZEK SVAZOK SZ T TAGUNGSBD TAPE TEIL TEILBAND TEILBD TEXT TESTI TEXTE TEXTBAND TEXTS TH THEIL THEME THROUGH TI TITLE TITRE TITULO TL TOM TOME TOMO TOMOS TOMUS TOPIC TRACT TSUKAN UNIT UNITS V VED VEREINSJAHR VERHANDELING VEROFFENTLICHUNG VEROFFENTLICHUNGEN VERSLAG VIP VO VOL VOLS VOLUME VOLUMEN VOLUMES VOLYM VORTRAG VORTRAGE VYP WHOLE WORK WORKING WORKSHOP YEAR ZAHL ZEHNT ZESZ ZESZYT ZV "
#Else
    Private Const prvsSeriesNumIgnoredWords1$ = " AARSSKRIFT AASTAK AASTAKAIK ABD ABDR ABDRUCK ABH ABHAND ABHANDLUNG ABHANDLUNGEN ABSCHN ABSCHNITT ABSTRACT ABT ABTEIL ABTEILUNG ABTH ABTHEIL ABTHEILUNG ADAD ADD ADDENDUM AFD AFDELING AFL AFLEVERING ALADAD ALBUM ALKITAB ALQISM ALSIFR AN AND ANEJO ANEXO ANN ANNEE ANNEX ANNO ANO ANY ARBEITSPAPIER ARG ARGANG ARGGRAFFIAD ARSSKRIFT ART ARTICLE AUSSTELLUNG AVD AVDELNING AVHANDLINGER AVIV BAND BANDCHEN BANDE BD BDE BDCHEN BDCHN BEIHEFT BEIHEFTE BEILAG BEILAGEN BEITRAG BERICHT BHFT BIL BILANGAN BILDHEFT BIND BK BKS BLATT BLOCK BOOK BOOKLET BOOKS BROCHURE BUCH BUCHER BUL BULL BULLETIN CAHIER CAHIERS CASSETTE CAT CATALOG CATALOGUE CH CHAP CHAPBOOK CHAPITRE CHAPTER CHIH CIS CISLO COMUNICACAO CONFERENCE CONTRIBUTION CORPUS COURSE CUADERNO "
    Private Const prvsSeriesNumIgnoredWords2$ = " DAI DEEL DEL DEELEN DELEN DIL DISC DOC DOCUMENT DOCUMENTO DOKUMENT DOSSIER DRUCK DZEL EINZELAUSG ERGANZUNGSBAND ERGANZUNGSBD ERGANZUNGSHEFT ESTUDIO ESTUDIOS ETUDE ETUDES EXTRA FASC FASCICOLO FASE FASCICLE FASCICULE FASZ FASZIKEL FG FICHE FICHES FILM FOL FOLJD FOLJDEN FOLGE FORUM FS GRADE GRADES GRANTHANKAH GROUP GRUNNA GUIDE GUIDE-BOOK GUIDES GUIDEBOOK "
    Private Const prvsSeriesNumIgnoredWords3$ = " HAFT HALB HALB-BD HALBBAND HALBBD HANDBOOK HANDLIST HAO HAUPTABTH HDBK HEFT HEFTE HELEK HF HFT HFTE HOV HOVERET IMLEABHAR ISSUE ITEM ITEMS IWE JAARG JAARGANG JAHR JAHRESREIHE JAHRG JAHRGAG JAHRGANG JG JHRG KAN KAP KAPITEL KEREK KEREKH KITAB KN KNJ KNIGA KNIHA KOMPLEKT LEAFLET LECTURE LEHRHEFT LEVEL LEVELS LEVNADSTECKNINGAR LFG LIBER LIBR LIBROS LIEFERUNG LIST LIVR LIVRAISON LIVRE MANUAL MAP MAPPE MEMOIRE MEMORIA MICROCOPY MIS MODULE MONOGRAFIA MONOGRAFIE MONOGRAPH MONOGRAPHS MONOGRAPHY MUJALLAD "
    'private Const prvsSeriesNumIgnoredWords4$ = " NIVEL NIZ NO NOMBOR NOMOR NOS NOTE NR NRS NUM NUMBER NUMERO NUMMER OPUS PAGE PAGES PAMPHLET PAPER PAPERS PARS PART PARTE PARTES PARTIE PARTIES PARTS POS POSITION PROGRAM PT PTS PTES PUB PUBLICACI PUBLICACION PUBLICATION PT QUADERNI QUADERNO R RADA RAEKKE REEK REEKS REEL REELS REIHE REIRE RELEASE REP REPORT REPT RESEARCH ROC ROCNIK ROCZ ROCZNIK ROK RPT SCHRIFT SEC SECT SECTION SECTIONS SECTS SEFER SEGMENT SELECTIONS SER SERIE SERIES SERIIA SESS SESSION SET SHEET SKUPINA SONDERBAND SONDERBD SPECIAL STAGE STUCK STUDIA STUDIESTUK STUDY SUP SUPLEMENTO SUPP SUPPL SUPPLEMENT SUPPLEMENTARY SUPPLEMENTS SUPPLEMENTUM T TAPE TEIL TEILBAND TEILBD TEXT TEXTBAND TEXTS THEIL THROUGH TITRE TOM TOME TOMO TOMUS TOPIC TRACT UNIT V VEROFFENTLICHUNG VEROFFENTLICHUNGEN VERSLAG VOL VOLS VOLUME VOLUMEN VOLUMES VYP WHOLE WORK WORKING YEAR ZESZ "
    Private Const prvsSeriesNumIgnoredWords4$ = " NIDE NIDE-T NIDOS NIVEL NIZ NO NOMBOR NOMOR NOS NOTE NR NRS NUM NUMBER NUMERO NUMERUS NUMMER OBRA OEUVRE OPUS OSA PAGE PAGES PAM PAMPHLET PAPER PAPERS PARATEMA PARS PART PARTE PARTES PARTIE PARTIES PARTS PERIODICAL PHASE PIRSUM POS POSITION PRAPARANDENHEFT PROGRAM PT PTE PTIE PTS PTES PUB PUBBLICAZIONE PUBBLICAZIONI PUBLICACI PUBLICACIO PUBLICACION PUBLICATION PUBLICATIONS PT QISM QUADERNI QUADERNO RADA RAEKKE RAPPORT RECUEIL REDA REEK REEKS REEL REELS REG REIHE REIRE REKKE RELATORIO RELEASE REP REPORT REPT RESEARCH ROC ROCNIK ROCZ ROCZNIK ROK RPT "
    Private Const prvsSeriesNumIgnoredWords5$ = " SA SAGGI SARJA SATSU SAYI SAYISI SB SBORNIK SCHRIFT SEC SECT SECTIO SECTION SECTIONS SECTS SEFER SEGMENT SELECTIONS SER SERIE SERIES SERIIA SERIJA SESS SESSION SET SEZ SEZIONE SHEET SIFR SKRIFTER SKUPINA SONDERBAND SONDERBD SPECIAL STAGE STUCK STUDIA STUDIE STUDIEN STUDIES STUDIESTUK STUDY STUK SV SVAZEK SVAZOK SZ TAGUNGSBD TAPE TEIL TEILBAND TEILBD TEXT TESTI TEXTE TEXTBAND TEXTS TH THEIL THEME THROUGH TI TITLE TITRE TITULO TL TOM TOME TOMO TOMOS TOMUS TOPIC TRACT TSUKAN UNIT UNITS VED VEREINSJAHR VERHANDELING VEROFFENTLICHUNG VEROFFENTLICHUNGEN VERSLAG VIP VO VOL VOLS VOLUME VOLUMEN VOLUMES VOLYM VORTRAG VORTRAGE VYP WHOLE WORK WORKING WORKSHOP YEAR ZAHL ZEHNT ZESZ ZESZYT ZV "
#End If

Private prvsSerNumTheseBecomeSpacesFirst$, prvsSerNumPunctuation$, prvsSeriesNumIgnoredWords$
Private prvsSerNumRemoveTheseIfFirst$, prvsSerNumCaptionSubstitute$
Private prvsSerNumStringOfSuperscripts$, prvsSerNumStringOfSubscripts$


Const TranslateCode_M2O$ = "M2O"
Const TranslateCode_M2V$ = "M2V"
Const TranslateCode_O2M$ = "O2M"
Const TranslateCode_O2V$ = "O2V"
Const TranslateCode_V2M$ = "V2M"
Const TranslateCode_V2O$ = "V2O"

Const TranslateType_M2O% = 0
Const TranslateType_M2V% = 1
Const TranslateType_O2M% = 2
Const TranslateType_O2V% = 3
Const TranslateType_V2M% = 4
Const TranslateType_V2O% = 5

Const FixedFieldDisplay_NOTIS% = 0
Const FixedFieldDisplay_OCLC% = 1
Const FixedFieldDisplay_OCLCMonospaced% = 2

Const SERIESNUMBERNORM_StraightPcc% = 1
Const SERIESNUMBERNORM_PadOutNumbers% = 2
Const SERIESNUMBERNORM_Level3% = 3
Const SERIESNUMBERNORM_Level4% = 4

Enum SeriesNumberingNormType
    JustPcc = SERIESNUMBERNORM_StraightPcc%
    PadNumbers = SERIESNUMBERNORM_PadOutNumbers%
    PadNumbersRemoveCaption = SERIESNUMBERNORM_Level3%
    Complete = SERIESNUMBERNORM_Level4%
End Enum

Enum FixedFieldDisplayType
    notis = FixedFieldDisplay_NOTIS%
    oclc = FixedFieldDisplay_OCLC%
    OclcMonospaced = FixedFieldDisplay_OCLCMonospaced%
End Enum

Enum Marc2MsoftAsciiType
    Latin1Text = TextFormatted_Latin1%
    latin1textextended = TextFormatted_Latin1Extended%
    Latin1TextAsUtf8 = TextFormatted_Latin1AsUtf8%
    Latin1TextWithDots = TextFormatted_Latin1WithDots%
End Enum

Enum TextFormattedType
    HexEquivalents = TextFormatted_HexEquivalents%
    HexEquivalentsExcept880 = TextFormatted_HexEquivalentsExcept880Raw%
    latin1 = TextFormatted_Latin1%
    Latin1NoDelimiters = TextFormatted_Latin1NoDelimiters%
    'latin1asutf8 = TextFormatted_Latin1AsUtf8%
    Latin1extended = TextFormatted_Latin1Extended%
    Latin1WithDots = TextFormatted_Latin1WithDots%
    PlainText = TextFormatted_PlainText%
    Raw = TextFormatted_Raw%
    rtfText = TextFormatted_RtfText%
    RtfTextNoDelimiters = TextFormatted_RtfTextNoDelimiters%
    RtfTextNormalizedNaco = TextFormatted_RtfTextNormalizedNaco%
    RtfTextNormalizedPlain = TextFormatted_RtfTextNormalizedPlain%
    rtfTextwithlabels = TextFormatted_RtfTextWithLabels%
    SacoProposal = TextFormatted_SacoProposal%
    TextFormattedDefault = TextFormatted_HexEquivalents%
End Enum

Enum MarcTranslateType
    MarcToOclc = TranslateType_M2O%
    MarcToVoyager = TranslateType_M2V%
    OclcToMarc = TranslateType_O2M%
    OclcToVoyager = TranslateType_O2V%
    VoyagerToMarc = TranslateType_V2M%
    VoyagerToOclc = TranslateType_V2O%
End Enum


' the CHARACTERSET_CODES_FOR_880_ constants are the MARC escape-codes for the various
'   recognized character sets. note that although we recognize many character
'   sets in either the G0 or G1 positions, when we're translating from
'   UTF-8 to MARC-8 we only use certain values (the extended characters
'   are always in G1, for example)
Private Const CHARACTERSET_CODES_FOR_880_BasicAsG0$ = "(B"
Private Const CHARACTERSET_CODES_FOR_880_HebrewAsG0$ = "(2"
Private Const CHARACTERSET_CODES_FOR_880_BasicCyrillicAsG0$ = "(N"
Private Const CHARACTERSET_CODES_FOR_880_BasicArabicAsG0$ = "(3"
Private Const CHARACTERSET_CODES_FOR_880_GreekAsG0$ = "(S"
Private Const CHARACTERSET_CODES_FOR_880_CJKAsG0$ = "$1"
Private Const CHARACTERSET_CODES_FOR_880_ExtendedCyrillicAsG1$ = ")Q"
Private Const CHARACTERSET_CODES_FOR_880_ExtendedArabicAsG1$ = ")4"
Private Const CHARACTERSET_CODES_FOR_880_ExtendedLatinAsG1$ = ")!E"


Const XmlExportType_MarcXML% = 0
Const XmlExportType_MODS% = 1
Const XmlExportType_DublinCoreRdf% = 2
Const XmlExportType_MADS% = 3
Const XmlExportType_DublinCoreOAI% = 4
Const XmlExportType_MODSAquifer% = 5

Enum XmlExportType
    DublinCoreOai = XmlExportType_DublinCoreOAI%
    DublinCoreRdf = XmlExportType_DublinCoreRdf%
    MADS = XmlExportType_MADS%
    MarcXml = XmlExportType_MarcXML%
    MODS = XmlExportType_MODS%
    MODSaquifer = XmlExportType_MODSAquifer%
End Enum

Private Type MarcSubfield
    Code As String
    Text As String
    Norm As String
    NormNaco As String
    NextSubfield As Integer
    PrevSubfield As Integer
    SortGroup As Integer
    SortInstruction As Integer
    SortString As String
    Deleted As Boolean
    Boolean1 As Boolean
    Boolean2 As Boolean
End Type

Private Type DIACRITICARRAYTYPE
    Diacritic As String
    CombiningClass As Integer
    Order As Integer
End Type

Private Type CHARACTERARRAY
    From As Boolean
    To As String
End Type

Private Type MarcField
    Tag As String
    Ind As String
    IsControl As Boolean
    SortInstruction As String
    SortInstructionExtension As String
    Changed As Boolean
    Deleted As Boolean
    Boolean1 As Boolean
    Boolean2 As Boolean
    Directory As String
    NextField As Integer
    PrevField As Integer
    FirstSubfield As Integer ' the array element that represents the initial subfield in the field
    LastSubfield As Integer ' the array element that represents the terminal subfield in the field
    SubfieldMax As Integer ' the size of the Subfield() array
    SubfieldLast As Integer ' the highest element used in the Subfield() array
    SubfieldOrderPointer As Integer ' pointer to element in the subfield order array for this tag
    Subfield() As MarcSubfield ' each subfield in the field
End Type

Private Type FieldOrderType
    Begin As String
    End As String
    SortInstruction As Integer
End Type

Private Const FULLSTOP_Integral% = 1
Private Const FULLSTOP_Remove% = 2
Private Const FULLSTOP_Unknown% = 3

' return values for the 'is the subdivision in the right
'   place' function, and things that reference it
Private Const SUBFIELDPOSITION_OK% = 0
Private Const SUBFIELDPOSITION_MoveLeft% = -1
Private Const SUBFIELDPOSITION_MoveUp% = SUBFIELDPOSITION_MoveLeft%
Private Const SUBFIELDPOSITION_MoveRight% = 1
Private Const SUBFIELDPOSITION_MoveDown% = SUBFIELDPOSITION_MoveRight%


' the MARC-8 'character sets' or 'code pages'; these are the
'  values returned by the "translate unicode 2 marc' function
'  in the character object
Private Const CHARACTERTABLE_Basic$ = "1"
Private Const CHARACTERTABLE_3Greeks$ = "2"
Private Const CHARACTERTABLE_Subscript$ = "3"
Private Const CHARACTERTABLE_Superscript$ = "4"
Private Const CHARACTERTABLE_Hebrew$ = "5" ' this is 'basic'; but tere is no extended
Private Const CHARACTERTABLE_BasicCyrillic$ = "6"
Private Const CHARACTERTABLE_BasicArabic$ = "7"
Private Const CHARACTERTABLE_Greek$ = "8" ' this is 'basic'; but tere is no extended
Private Const CHARACTERTABLE_CJK$ = "9"
Private Const CHARACTERTABLE_ExtendedCyrillic$ = ":"
Private Const CHARACTERTABLE_ExtendedArabic$ = ";"


Private Const Marc8Category_Basic$ = CHARACTERTABLE_Basic$
Private Const Marc8Category_SuperscriptSubscript$ = CHARACTERTABLE_Subscript$ ' just to pick one of the two
Private Const Marc8Category_Greek$ = CHARACTERTABLE_Greek$ ' including the 3 greeks we're not supposed to use ...
Private Const Marc8Category_Hebrew$ = CHARACTERTABLE_Hebrew$
Private Const Marc8Category_Cyrillic$ = CHARACTERTABLE_BasicCyrillic$ ' not distinguishing basic and extended
Private Const Marc8Category_Arabic$ = CHARACTERTABLE_BasicArabic$ ' not distinguishing basic and extended
Private Const Marc8Category_Unknown$ = "?"

' convert this constant into its ASCII value subtract 48; and multiply this
'   remainder by 6 to transform it into an offset into the following hyphen-delimited string
' the first character (0) is the MARC-8'code table' number; same as above, with extensions
' the second character (1) is the code to use for the set in non-880 fields after escape ("?"=illegal in non-880);
' 4rd-5th chars (3-4) are the code to use after escape in 880 field
' ignore other characters--turned out not to be needed
'                                             1      2      3      4      5      6      7      8      9      :      ;
'                                             012345 012345 012345 012345 012345 012345 012345 012345 012345 012345 012345
Private Const CharSetU2MTranslation$ = "*****-1s s  -2g*g *-3b b  -4p p  -5? (2 -6? (N -7? (3 -8g*(S*-9? $1 -:? (Q -;? (4 "

' these are always allowed in non-880 fields
Private Const CHARACTERSET_Non880$ = "1234sgbp"
' only alpha, beta, gamma allowed in non-880 fields (even though they're not spozed to be used)
Private Const CHARACTERSET_GreekCodes$ = "8(S"

Private Const CALLNOTYPE_LC$ = "0"
Private Const CALLNOTYPE_Dewey$ = "1"
Private Const CALLNOTYPE_NLM$ = "2"
Private Const CALLNOTYPE_SuDocs$ = "3"
Private Const CALLNOTYPE_Other$ = "8"
Private Const CALLNOTYPE_LcCode$ = "L"
Private Const CALLNOTYPE_DeweyCode$ = "D"
Private Const CALLNOTYPE_NlmCode$ = "N"
Private Const CALLNOTYPE_SuDocsCode$ = "S"
Private Const CALLNOTYPE_OtherCode$ = "O"

Private Const RECORDFORMAT_Authority$ = "A"
Private Const RECORDFORMAT_Book$ = "B"
Private Const RECORDFORMAT_Data$ = "D"
Private Const RECORDFORMAT_Film$ = "F"
Private Const RECORDFORMAT_Holding$ = "H"
Private Const RECORDFORMAT_CommunityInformation$ = "Q"
Private Const RECORDFORMAT_Map$ = "P"
Private Const RECORDFORMAT_Mixed$ = "U"
Private Const RECORDFORMAT_Music$ = "M"
Private Const RECORDFORMAT_Serial$ = "S"
Private Const RECORDFORMAT_Classification$ = "W"
Private Const RECORDFORMAT_Unknown$ = "?"

Private Const SFDORDER_NoSegmentInThisOrder% = 0 ' a list of subfields, not enclosed in brackets
Private Const SFDORDER_SegmentRandom% = 1 ' list of subfields enclosed in brackets preceded by "#"
Private Const SFDORDER_SegmentWithLead% = 2 ' list of subfields with lead character provided preceded by "!"
Private Const SFDORDER_SegmentWithSingleLead% = 3 ' NOT USED: list of subfields; lead repeated but only first is first
Private Const SFDORDER_OccursInMultipleSegments% = 4 ' NOT USED: lead subfield may appear in more than one segment
Private Const SFDORDER_OccursInMultipleSegmentsLast% = 5 ' NOT USED? same as #4, but for the *last* occurrence of the thingie


Private Type SFDORDERSUBTYPE
    Type As Integer
    Sfds As String
End Type

Private Type SFDORDERTYPE
    Tag As String
    Order() As SFDORDERSUBTYPE
    Last As Integer
    Max As Integer
    Duplicates As String
    SfdSegments As String
End Type

Private Const CHARACTERSET_AmbiguousVO$ = "X"
Private Const CHARACTERSET_AmbiguousVM$ = "Y"
Private Const CHARACTERSET_Generic$ = "M"
Private Const CHARACTERSET_Latin1$ = "L" ' ONLY for character set in
Private Const CHARACTERSET_MARC$ = CHARACTERSET_Generic$
Private Const CHARACTERSET_OCLC$ = "O"
Private Const CHARACTERSET_Utf8$ = "U"
Private Const CHARACTERSET_Utf8LcPattern$ = "ULC"
Private Const CHARACTERSET_Voyager$ = "V"

Private Const SUBFIELDS_Personal$ = "abcdfgklmnoprsqt"
Private Const SUBFIELDS_Corporate$ = "abcdfgklmnoprst"
Private Const SUBFIELDS_Conference$ = "acdefgklnpsqt"
Private Const SUBFIELDS_UniformTitle$ = "adfgklmnoprst"
Private Const SUBFIELDS_Topical$ = "abcd"
Private Const SUBFIELDS_Geographic$ = "a"
Private Const SUBFIELDS_Form$ = "ab"
Private Const SUBFIELDS_Other$ = "abcdefghijklmnopqrstuvwxyz"
Private Const SUBFIELDS_SubjectSubdivisions$ = "vxyz"

Private Const CONST_BibLevelMeansSerial$ = "bis"
Private Const Const_NumString$ = "0123456789"
Private Const CONST_PunctuationToKeepForAWhile$ = "!#$%&'()*+,-./:;<=>?@[\]{|}" + """"
' the following can't be proper constants because we have to use Chr() or
'   something else fancy to define their values; see the
'   object's initialization code
Private CONST_Currency$
Private CONST_Math$
Private CONST_UpperEndUpperCase$
Private CONST_UpperEndLowerCase$
Private CONST_LowerCaseAlpha$ ' = "abcdefghijklmnopqrstuvwxyz"
Private CONST_UpperCaseAlpha$ ' = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
Private CONST_LowerCaseAlphaExtension$
Private CONST_UpperCaseAlphaExtension$

Private GenericSlashL$, GenericSlashO$, GenericSlashD$, GenericThorn$, GenericAE$, GenericOE$, GenericHookO$
Private genericHookU$, GenericScriptL$, GenericAlpha$, GenericBeta$, GenericGamma$
Private GenericDegree$, GenericPressing$, GenericCopyright$, GenericSharp$
Private GenericInvertedQuestionMark$, GenericInvertedExclamationMark$, GenericCurly$
Private GenericSuperSubPlus$, GenericSuperSubMinus$, GenericSuperSubParensL$, GenericSuperSubParensR$
Private gblsSortingIndicatorFor653Field$, m_sVoyagerAllowsOclcDoesNot$

Private Marc8DiacriticsAbove$, Marc8DiacriticsOther$, UTF8DiacriticsAbove$, Utf8DiacriticsOther$
Private Marc8Diacritics$, Utf8Diacritics$, OldUtf8Alif$, NewUtf8Alif$


Private Const MARC_Subscripts$ = "0123456789+-()"
Private Const MARC_Greek$ = "abc"

Private Const NORMALIZATIONSCHEME_Pcc$ = "P"
Private Const NORMALIZATIONSCHEME_Voyager$ = "V"

Private Const SORTINSTRUCTION_7XX% = 1
Private Const SORTINSTRUCTION_Generic% = 2
Private Const SORTINSTRUCTION_Indicator2% = 3
Private Const SORTINSTRUCTION_Local% = 4
Private Const SORTINSTRUCTION_Reference% = 5
Private Const SORTINSTRUCTION_Tag% = 6
Private Const SORTINSTRUCTION_Sfd8PlusTag% = 7 ' subfield $8, then the tag (holdings only, one suspects)
Private Const SORTINSTRUCTION_Paired880s% = 8 ' added 20061116
Private Const SORTINSTRUCTION_LeaveOrderAlone% = 9 ' added 20061117
Private Const SORTINSTRUCTION_Paired880sLC% = 10 ' added 20080229

Private Const Utf8_ControlCharacter$ = "Cc"
Private Const Utf8_ControlCharacterFormatting$ = "Cf"
Private Const Utf8_ControlOther$ = "Co"
Private Const Utf8_ControlSurrogate$ = "Cs"
Private Const Utf8_LetterLowercase$ = "Ll"
Private Const Utf8_LetterModifier$ = "Lm"
Private Const Utf8_LetterOther$ = "Lo"
Private Const Utf8_LetterUppercase$ = "Lu"
Private Const Utf8_LetterTitlecase$ = "Lt"
Private Const Utf8_MarkEnclosing$ = "Me"
Private Const Utf8_MarkNonSpacing$ = "Mn"
Private Const Utf8_MarkSpacingCombining$ = "Mc"
Private Const Utf8_NumberDecimal$ = "Nd"
Private Const Utf8_NumberLetter$ = "Nl"
Private Const Utf8_NumberOther$ = "No"
Private Const Utf8_PunctuationConnector$ = "Pc"
Private Const Utf8_PunctuationDash$ = "Pd"
Private Const Utf8_PunctuationClose$ = "Pe"
Private Const Utf8_PunctuationFinalQuote$ = "Pf"
Private Const Utf8_PunctuationInitialQuote$ = "Pi"
Private Const Utf8_PunctuationOther$ = "Po"
Private Const Utf8_PunctuationOpen$ = "Ps"
Private Const Utf8_Line$ = "Zl"
Private Const Utf8_Paragraph$ = "Zp"
Private Const Utf8_Space$ = "Zs"
Private Const Utf8_Substitution$ = "ZZ" ' gls-defined
Private Const Utf8_SymbolCurrency$ = "Sc"
Private Const Utf8_SymbolModifier$ = "Sk"
Private Const Utf8_SymbolMath$ = "Sm"
Private Const Utf8_SymbolOther$ = "So"


Private m_sLeader$, m_sDirectory$, m_sFields$, m_sMarcIn$, m_sMarcOut$, m_sFieldOrderFolder$
Private m_sTagWanted$, m_sFieldWanted$, m_sSubfieldWanted$, m_sSubfieldTextWanted$, m_sRecordFormat$
Private m_sNuc$, m_SubjectListCode$, m_sNorm$, m_sNorm2$, m_sNormalizationScheme$
Private m_sCharacterSetIn$, m_sCharacterSetOut$, m_sCharacterEncodingScheme$, m_sQuote$
Private m_sDeclaredCharacterSetIn$, m_sDefaultCharacterSet$, m_sRecordInProgress$
Private m_sAsciiMaximum$, m_sAboveAsciiMinimum$, m_sOclcScreenDelim$, m_sMarc8DiacriticsAboveHere$
Private m_sOclcGreeksEtc$, m_sVoyagerGreeksEtc$, m_sIsMarcErrorText$, m_sLocalNucString$
Private m_sFieldsToTestForEmptySubfieldsBib$, m_sFieldsToTestForEmptySubfieldsHold$, m_sFieldsToTestForEmptySubfieldsAuth$

Private m_sDefaultLeader$, m_sLocal5$, m_sFieldsWithSubfieldsOutOfOrder$
Private m_sDefault008A$, m_sDefault008B$, m_sDefault008D$, m_sDefault008F$, m_sDefault008H$
Private m_sDefault008M$, m_sDefault008P$, m_sDefault008Q$, m_sDefault008S$, m_sDefault008U$, m_sDefault008W$

Private m_bIsAuthority As Boolean, m_bMarcRecordTranslated As Boolean
Private m_bDebugging As Boolean, m_bUtf8 As Boolean, m_bUtf8LcPattern As Boolean, m_bOmitFieldOrderTest As Boolean, m_bOmitSubfieldOrderTest As Boolean
Private m_bFieldWasFound As Boolean, m_bFldAtTop As Boolean, m_bFldAtBottom As Boolean
Private m_bSfdWasFound As Boolean, m_bSfdAtTop As Boolean, m_bSfdAtBottom As Boolean, m_bMarcRecordModified As Boolean
Private m_bAustralianSubdivisionPractice As Boolean, m_bFieldsOutOfOrder As Boolean, m_bSubfieldsOutOfOrder As Boolean
Private m_bMakeNoChange As Boolean, m_bFldOrderChanged As Boolean, m_bSfdOrderChanged As Boolean
Private m_bNewRecord As Boolean, m_bPreserveLeadingNumericSubfields As Boolean, m_bIgnoreSfdOrder As Boolean
Private prvbHaveSeriesNumberingPunctuation As Boolean

Private gblbTestOrderStuff As Boolean, gblbSkipSubfieldOrderTest As Boolean
Private gblbInternalSfdAdd As Boolean

Private prvsSortExtensionMarker$

Private m_iFldPointer%, m_iFirstField%, m_iMarcCtr%, m_i008Ptr%
Private m_iLastField%, m_iSubfieldPtr%
Private m_i008Length%, m_iSfdPointer%, m_iSubfieldOrderPointer%

Private m_aDiacritic() As DIACRITICARRAYTYPE
Private m_iDiacriticLast%, m_iDiacriticMax%

Dim aCharacter() As CHARACTERARRAY
Dim iCharacterLast%, iCharacterMax%
Dim sCharacterSetup$

Dim MarcArray() As MarcField

Private gblaFieldOrderAuth() As FieldOrderType, gblaFieldOrderBib() As FieldOrderType, gblaFieldOrderHold() As FieldOrderType
Private gbliFieldOrderAuthLast%, gbliFieldOrderAuthMax%, gbliFieldOrderBibLast%, gbliFieldOrderBibMax%
Private gbliFieldOrderHoldLast%, gbliFieldOrderHoldMax%
Private gblaFieldOrderOther() As FieldOrderType
Private gbliFieldOrderOtherLast%, gbliFieldOrderOtherMax%
Private gblaSfdOrder As SFDORDERTYPE

Private gblaSubfieldOrderBib() As SFDORDERTYPE, gblaSubfieldOrderAuth() As SFDORDERTYPE, gblaSubfieldOrderHold() As SFDORDERTYPE
Private gbliSubfieldOrderBibLast%, gbliSubfieldOrderBibMax%, gbliSubfieldOrderAuthLast%, gbliSubfieldOrderAuthMax%
Private gbliSubfieldOrderHoldLast%, gbliSubfieldOrderHoldMax%
Private gblaSubfieldOrderOther() As SFDORDERTYPE
Private gbliSubfieldOrderOtherLast%, gbliSubfieldOrderOtherMax%

Private prvbPair880sWithRomanizedFieldsBib As Boolean, prvbPair880sWithRomanizedFieldsAuth As Boolean, prvbPair880sWithRomanizedFieldsHold As Boolean
Private prvbPair880sWithRomanizedFieldsBibLC As Boolean, prvbPair880sWithRomanizedFieldsAuthLC As Boolean, prvbPair880sWithRomanizedFieldsHoldLC As Boolean

' most if not all of the following ONLY apply to non-Unicode records

Private MARC_BritishPound$, MARC_Eth$, MARC_Flat$
Private MARC_ScriptL$, OCLC_ScriptL$, Voyager_ScriptL$
Private MARC_Degree$, Voyager_Degree$, OCLC_Degree$
Private MARC_Pressing$, Voyager_Pressing$, OCLC_Pressing$
Private MARC_Copyright$, Voyager_Copyright$, OCLC_Copyright$
Private MARC_Sharp$, Voyager_Sharp$, OCLC_Sharp$
Private MARC_InvertedQuestion$, Voyager_InvertedQuestion$, OCLC_InvertedQuestion$
Private MARC_InvertedExclamation$, Voyager_InvertedExclamation$, OCLC_InvertedExclamation$
Private MARC_Dagger$, Voyager_Dagger$, OCLC_Dagger$, Utf8DiacriticsWithNoMarc8Equivalents$
Private MARC_LogicalOr$, Voyager_LogicalOr$, OCLC_LogicalOr$
Private MARC_LogicalNot$, Voyager_LogicalNot$, OCLC_LogicalNot$
Private Voyager_Subscripts$, Voyager_Superscripts$, Voyager_Greek$
' 20021114: order of +-() changed to conform to character order within Voyager

Private AscGenericDegree%, AscGenericPressing%, AscGenericCopyright%, AscGenericSharp%, AscGenericInvertedQuestionMark%, AscGenericInvertedExclamationMark%

Private MyMarcCharacter As New Utf8CharClass
Private MyPrevChar As New Utf8CharClass
Private MyNextChar As New Utf8CharClass

Private gblbInitialDigestion As Boolean

Private prvaWithStack() As String
Private prvlWithStackLast As Long, prvlWithStackMax As Long
Public Sub IdentifySubfield6Pieces(ByVal sIncomingSubfield6Text$, ByRef sReturnTag$, ByRef sReturnSequence$, ByRef sReturnSuffix$)

    Dim lPtr As Long
    
    Dim sChar$
    
    
    sReturnSequence$ = ""
    
    
    ' we're going to assume that the first 3 characters are the tag
    sReturnTag$ = Mid(sIncomingSubfield6Text$, 1, 3)
    sIncomingSubfield6Text$ = Mid(sIncomingSubfield6Text$, 4)
    
    ' strip off everything up to but not including the first numeral that follows
    '   the tag (probably just a hyphen)
    Do While Len(sIncomingSubfield6Text$) > 0
        If InStr("0123456789", Mid(sIncomingSubfield6Text$, 1, 1)) > 0 Then
            Exit Do
        End If
        sIncomingSubfield6Text$ = Mid(sIncomingSubfield6Text$, 2)
    Loop
    
    ' all of the consecutive numerals are part of the sequence number
    Do While Len(sIncomingSubfield6Text$) > 0
        sChar$ = Mid(sIncomingSubfield6Text$, 1, 1)
        If InStr("0123456789", sChar$) = 0 Then
            Exit Do
        End If
        sReturnSequence$ = sReturnSequence$ + sChar$
        sIncomingSubfield6Text$ = Mid(sIncomingSubfield6Text$, 2)
    Loop
    ' left-pad with zeroes
    If Len(sReturnSequence$) < 2 Then
        sReturnSequence$ = Right("00" + sReturnSequence$, 2)
    End If
    
    ' anything that remains must be the suffix: must be in the proper form
    sReturnSuffix$ = Trim(sIncomingSubfield6Text$)
    If Len(sReturnSuffix$) > 0 Then
        If Mid(sReturnSuffix$, 1, 1) <> "/" Then
            sReturnSuffix$ = "/" + sReturnSuffix$
        End If
    End If
    
    
End Sub

Public Function GenerateNacoFormFromRaw(ByVal sTag$, ByVal sField$) As String

    Dim iRc%
    
    Dim sSfc$, sNextSfc$, sSfd$, sNorm$
    
    
    If Mid(sField$, 1, 1) = MarcDelimiter Then
        sSfc$ = Mid(sField$, 2, 1)
        sField$ = Mid(sField$, 3)
    Else
        sSfc$ = "a"
    End If
    
    Do While Len(sField$) > 0
        iRc% = InStr(sField$, MarcDelimiter)
        If iRc% > 0 Then
            sNextSfc$ = Mid(sField$, iRc% + 1, 1)
            sSfd$ = Mid(sField$, 1, iRc% - 1)
            sField$ = Mid(sField$, iRc% + 2)
        Else
            sSfd$ = sField$
            sField$ = ""
        End If
        If sSfc$ = "a" Then
            ' assumed to be the first subfield in the string!
            ' retain the first comma within $a
            sSfd$ = Trim(sSfd$)
            iRc% = InStr(sSfd$, ",")
            If iRc% < Len(sSfd$) And iRc% > 0 Then
                sNorm$ = MarcDelimiter + sSfc$ + NormString(Mid(sSfd$, 1, iRc% - 1)) + ", " + NormString(Mid(sSfd$, iRc% + 1))
            Else
                sNorm$ = MarcDelimiter + sSfc$ + NormString(sSfd$)
            End If
        ElseIf InStr("0123456789w", sSfc$) > 0 Then
            ' 20100108: do nothing with these subfields
        Else
            sNorm$ = sNorm$ + MarcDelimiter + sSfc$ + NormString(sSfd$)
        End If
        
        sSfc$ = sNextSfc$
    Loop
    
    GenerateNacoFormFromRaw = sNorm$

End Function

Public Function MsoftAscii2Marc(ByVal sIn$) As String

    ' convert a string in displayablr ASCII into MARC text
    ' NOTE that this is a convenience for the translation of
    '   some things such as window captions; but this does NOT
    '   reverse the action of Marc2MsoftAscii--that function's work
    '   results in the loss of some information, which cannot be reversed
    
    
    Dim sJunk$
    
    Dim iChr%
    
    Dim lCtr As Long
    
    'Debug.Print "UTF8? " + str(m_bUtf8)
    If Not m_bUtf8 Then
        For lCtr = Len(sIn$) To 1 Step -1 ' this IS BY DEFINITION a single-byte string
            iChr% = Asc(Mid(sIn$, lCtr, 1))
            'Debug.Print Trim(str(iChr%)) + " >" + Mid(sIn$, lCtr, 15)
            Select Case iChr%
                Case Is < 128
                    ' keep all of these as is
                Case Is < 180
                    Select Case iChr%
                        Case 128
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "euro")
                        Case 133
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "...")
                        Case 136 ' circumflex all by itself?
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Circumflex)
                        Case 137
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "0/00")
                        Case 138 ' hacek-S
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Hacek + "S")
                        Case 139 ' less than?
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "<")
                        Case 140 ' OE
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8OEUpper)
                        Case 142 ' hacek-Z
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Hacek + "Z")
                        Case 145 ' grave all by itself?
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Grave)
                        Case 146 ' miag. znak (or is this accent acute?)
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8MiagkiiZnak)
                        Case 147 ' leftward leaning double quotation mark?
                            sIn$ = SafeStuff(sIn$, lCtr, 1, Chr(34))
                        Case 148 'tverd. znak
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8TvyerdiZnak)
                        Case 150
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "-")
                        Case 151
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "--")
                        Case 152 ' tilde all by itself
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Tilde)
                        Case 153
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "(TM)")
                        Case 154 ' hacek-s
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Hacek + "s")
                        Case 155 ' greater than?
                            sIn$ = SafeStuff(sIn$, lCtr, 1, ">")
                        Case 156 ' oe
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8OELower)
                        Case 158 ' hacek-z
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Hacek + "z")
                        Case 159 ' umlaut-Y
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Umlaut + "Y")
                        Case 161 ' inverted bang
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8ExclamationInverted(m_sCharacterSetOut$))
                        Case 162
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "cent")
                        Case 163 ' pound sign
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8BritishPound)
                        Case 165
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "yen")
                        Case 168 ' umlaut all by itself
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Umlaut)
                        Case 169 ' copyright
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Copyright(m_sCharacterSetOut$))
                        Case 170 ' superscript 'a'
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "a")
                        Case 171
                            sIn$ = SafeStuff(sIn$, lCtr, 1, Chr(34))
                        Case 173
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "-")
                        Case 174 ' registered
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Registered)
                        Case 176 ' degree sign
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Degree(m_sCharacterSetOut$))
                        Case 177 ' plus/minus
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8PlusMinus)
                        Case 178 ' superscript '2'
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Superscript2(m_sCharacterSetOut$))
                        Case 179 ' superscript '3'
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Superscript3(m_sCharacterSetOut$))
                        Case Else
                            'Debug.Print "Removing " + Trim(str(iChr%))
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "")
                    End Select
                Case Is < 220
                    Select Case iChr%
                        Case 180 ' acute all by itself?
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Acute)
                        Case 181
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "mu")
                        Case 183 ' medial dot
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "*")
                        Case 184
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8HookLeft)
                        Case 185 ' superscript '1'
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Superscript1(m_sCharacterSetOut$))
                        Case 186 ' superscript '0'
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Superscript0(m_sCharacterSetOut$))
                        Case 187
                            sIn$ = SafeStuff(sIn$, lCtr, 1, Chr(34))
                        Case 188
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "1/4")
                        Case 189
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "1/2")
                        Case 190
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "3/4")
                        Case 191 ' inverted question mark
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8QuestionInverted(m_sCharacterSetOut$))
                        Case 192 ' grave-A
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Grave + "A")
                        Case 193 ' acute-A
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Acute + "A")
                        Case 194 ' circumflex-A
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Circumflex + "A")
                        Case 195 ' tilde-A
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Tilde + "A")
                        Case 196 ' umlaut-A
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Umlaut + "A")
                        Case 197 ' angstrom-A
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Angstrom + "A")
                        Case 198 ' AE
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8AEUpper)
                        Case 199 ' cedilla-C
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Cedilla + "C")
                        Case 200 ' grave-E
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Grave + "E")
                        Case 201 ' acute-E
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Acute + "E")
                        Case 202 ' circumflex-E
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Circumflex + "E")
                        Case 203 ' umlaut-E
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Umlaut + "E")
                        Case 204 ' grave-I
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Grave + "I")
                        Case 205 ' acute-I
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Acute + "I")
                        Case 206 ' circumflex-I
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Circumflex + "I")
                        Case 207 ' umlaut-I
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Umlaut + "I")
                        Case 208 ' slash-D
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8DSlashUpper)
                        Case 209 ' tilde-N
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Tilde + "N")
                        Case 210 ' grave-O
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Grave + "O")
                        Case 211 ' acute-O
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Acute + "O")
                        Case 212 ' circumflex-O
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Circumflex + "O")
                        Case 213 ' tilde-O
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Tilde + "O")
                        Case 214 ' umlaut-O
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Umlaut + "O")
                        Case 215 ' 'times'
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "x")
                        Case 216 ' slash-O
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8OSlashUpper)
                        Case 217 ' grave-U
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Grave + "U")
                        Case 218 ' acute-U
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Acute + "U")
                        Case 219 ' circumflex-U
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Circumflex + "U")
                        Case Else
                            'Debug.Print "Removing " + Trim(str(iChr%))
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "")
                    End Select
                Case Else ' 220 and higher
                    Select Case iChr%
                        Case 220 ' umlaut-U
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Umlaut + "U")
                        Case 221 ' acute-Y
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Acute + "Y")
                        Case 222 ' Thorn
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8ThornUpper)
                        Case 223 ' German ss ' formerly: beta
                            ' 20041116: it appears that this is not beta at all, but estzet (or whatever)
                            '   instead
                            'sIn$ = SafeStuff(sIn$, lctr, 1, MyMarcCharacter.Marc8Beta(m_sCharacterSetOut$))
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "ss")
                        Case 224 ' grave-a
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Grave + "a")
                        Case 225 ' acute-a
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Acute + "a")
                        Case 226 ' circumflex-a
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Circumflex + "a")
                        Case 227 ' tilde-a
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Tilde + "a")
                        Case 228 ' umlaut-a
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Umlaut + "a")
                        Case 229 ' angstrom-a
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Angstrom + "a")
                        Case 230 'ae
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8AELower)
                        Case 231 ' cedilla-c
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Cedilla + "c")
                        Case 232 ' grave-e
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Grave + "e")
                        Case 233 ' acute-e
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Acute + "e")
                        Case 234 ' circumflex-e
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Circumflex + "e")
                        Case 235 ' umlaut-e
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Umlaut + "e")
                        Case 236 ' grave-I
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Grave + "i")
                        Case 237 ' acute-i
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Acute + "i")
                        Case 238 ' circumflex-i
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Circumflex + "i")
                        Case 239 ' umlaut-i
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Umlaut + "i")
                        Case 240 ' eth
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Eth)
                        Case 241 ' tilde-n
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Tilde + "n")
                        Case 242 ' grave-o
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Grave + "o")
                        Case 243 ' acute-o
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Acute + "o")
                        Case 244 ' circumflex-o
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Circumflex + "o")
                        Case 245 ' tilde-o
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Tilde + "o")
                        Case 246 ' umlaut-o
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Umlaut + "o")
                        Case 248 ' slash-o
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8OSlashLower)
                        Case 249 ' grave-u
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Grave + "u")
                        Case 250 ' acute-u
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Acute + "u")
                        Case 251 ' circumflex-u
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Circumflex + "u")
                        Case 252 ' umlaut-u
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Umlaut + "u")
                        Case 253 ' acute-y
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Acute + "y")
                        Case 254 ' lowercase thorn
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8ThornLower)
                        Case 255 ' umlaut-y
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Marc8Umlaut + "y")
                        Case Else
                            'Debug.Print "Removing " + Trim(str(iChr%))
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "")
                    End Select
            End Select ' the main groups
        Next ' lctr
        
    Else ' UTF-8
    
        For lCtr = Len(sIn$) To 1 Step -1 ' the input string IS BY DEFINITION a single-byte string
            iChr% = Asc(Mid(sIn$, lCtr, 1))
            Select Case iChr%
                Case Is < 128
                    ' keep all of these as is
                Case Is < 180
                    Select Case iChr%
                        Case 128
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "euro")
                        Case 133
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "...")
                        Case 136 ' circumflex all by itself?
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8Circumflex)
                        Case 137
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "0/00")
                        Case 138 ' hacek-S
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "S" + MyMarcCharacter.Utf8Hacek)
                        Case 139 ' less than?
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "<")
                        Case 140 ' OE
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8OEUpper)
                        Case 142 ' hacek-Z
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "Z" + MyMarcCharacter.Utf8Hacek)
                        Case 145 ' grave all by itself?
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8Grave)
                        Case 146 ' miag. znak (or is this accent acute?)
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8MiagkiiZnak)
                        Case 147 ' leftward leaning double quotation mark?
                            sIn$ = SafeStuff(sIn$, lCtr, 1, Chr(34))
                        Case 148 'tverd. znak
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8TvyerdiZnak)
                        Case 150
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "-")
                        Case 151
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "--")
                        Case 152 ' tilde all by itself
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8Tilde)
                        Case 153
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "(TM)")
                        Case 154 ' hacek-s
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "s" + MyMarcCharacter.Utf8Hacek)
                        Case 155 ' greater than?
                            sIn$ = SafeStuff(sIn$, lCtr, 1, ">")
                        Case 156 ' oe
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8OELower)
                        Case 158 ' hacek-z
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "z" + MyMarcCharacter.Utf8Hacek)
                        Case 159 ' umlaut-Y
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "Y" + MyMarcCharacter.Utf8Umlaut)
                        Case 161 ' inverted bang
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8ExclamationInverted)
                        Case 162
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "cent")
                        Case 163 ' pound sign
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8BritishPound)
                        Case 165
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "yen")
                        Case 168 ' umlaut all by itself
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8Umlaut)
                        Case 169 ' copyright
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8Copyright)
                        Case 170 ' superscript 'a'
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "a")
                        Case 171
                            sIn$ = SafeStuff(sIn$, lCtr, 1, """")
                        Case 173
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "-")
                        Case 174 ' registered
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8Registered)
                        Case 176 ' degree sign
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8Degree)
                        Case 177 ' plus/minus
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8PlusMinus)
                        Case 178 ' superscript '2'
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8Superscript2)
                        Case 179 ' superscript '3'
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8Superscript3)
                        Case Else
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "")
                    End Select
                Case Is < 220
                    Select Case iChr%
                        Case 180 ' acute all by itself?
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8Acute)
                        Case 181
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "mu")
                        Case 183
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "*")
                        Case 184
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8HookLeft)
                        Case 185 ' superscript '1'
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8Superscript1)
                        Case 186 ' superscript '0'
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8Superscript0)
                        Case 187
                            sIn$ = SafeStuff(sIn$, lCtr, 1, """")
                        Case 188
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "1/4")
                        Case 189
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "1/2")
                        Case 190
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "3/4")
                        Case 191 ' inverted question mark
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8QuestionInverted)
                        Case 192 ' grave-A
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "A" + MyMarcCharacter.Utf8Grave)
                        Case 193 ' acute-A
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "A" + MyMarcCharacter.Utf8Acute)
                        Case 194 ' circumflex-A
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "A" + MyMarcCharacter.Utf8Circumflex)
                        Case 195 ' tilde-A
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "A" + MyMarcCharacter.Utf8Tilde)
                        Case 196 ' umlaut-A
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "A" + MyMarcCharacter.Utf8Umlaut)
                        Case 197 ' angstrom-A
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "A" + MyMarcCharacter.Utf8Angstrom)
                        Case 198 ' AE
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8AEUpper)
                        Case 199 ' cedilla-C
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "C" + MyMarcCharacter.Utf8Cedilla)
                        Case 200 ' grave-E
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "E" + MyMarcCharacter.Utf8Grave)
                        Case 201 ' acute-E
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "E" + MyMarcCharacter.Utf8Acute)
                        Case 202 ' circumflex-E
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "E" + MyMarcCharacter.Utf8Circumflex)
                        Case 203 ' umlaut-E
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "E" + MyMarcCharacter.Utf8Umlaut)
                        Case 204 ' grave-I
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "I" + MyMarcCharacter.Utf8Grave)
                        Case 205 ' acute-I
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "I" + MyMarcCharacter.Utf8Acute)
                        Case 206 ' circumflex-I
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "I" + MyMarcCharacter.Utf8Circumflex)
                        Case 207 ' umlaut-I
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "I" + MyMarcCharacter.Utf8Umlaut)
                        Case 208 ' slash-D
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8DSlashUpper)
                        Case 209 ' tilde-N
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "N" + MyMarcCharacter.Utf8Tilde)
                        Case 210 ' grave-O
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "O" + MyMarcCharacter.Utf8Grave)
                        Case 211 ' acute-O
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "O" + MyMarcCharacter.Utf8Acute)
                        Case 212 ' circumflex-O
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "O" + MyMarcCharacter.Utf8Circumflex)
                        Case 213 ' tilde-O
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "O" + MyMarcCharacter.Utf8Tilde)
                        Case 214 ' umlaut-O
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "O" + MyMarcCharacter.Utf8Umlaut)
                        Case 215 ' 'times'
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "x")
                        Case 216 ' slash-O
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8OSlashUpper)
                        Case 217 ' grave-U
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "U" + MyMarcCharacter.Utf8Grave)
                        Case 218 ' acute-U
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "U" + MyMarcCharacter.Utf8Acute)
                        Case 219 ' circumflex-U
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "U" + MyMarcCharacter.Utf8Circumflex)
                        Case Else
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "")
                    End Select
                Case Else ' 220 and higher
                    Select Case iChr%
                        Case 220 ' umlaut-U
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "U" + MyMarcCharacter.Utf8Umlaut)
                        Case 221 ' acute-Y
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "Y" + MyMarcCharacter.Utf8Acute)
                        Case 222 ' Thorn
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8ThornUpper)
                        Case 223 ' beta
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8Beta)
                        Case 224 ' grave-a
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "a" + MyMarcCharacter.Utf8Grave)
                        Case 225 ' acute-a
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "a" + MyMarcCharacter.Utf8Acute)
                        Case 226 ' circumflex-a
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "a" + MyMarcCharacter.Utf8Circumflex)
                        Case 227 ' tilde-a
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "a" + MyMarcCharacter.Utf8Tilde)
                        Case 228 ' umlaut-a
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "a" + MyMarcCharacter.Utf8Umlaut)
                        Case 229 ' angstrom-a
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "a" + MyMarcCharacter.Utf8Angstrom)
                        Case 230 'ae
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8AELower)
                        Case 231 ' cedilla-c
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "c" + MyMarcCharacter.Utf8Cedilla)
                        Case 232 ' grave-e
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "e" + MyMarcCharacter.Utf8Grave)
                        Case 233 ' acute-e
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "e" + MyMarcCharacter.Utf8Acute)
                        Case 234 ' circumflex-e
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "e" + MyMarcCharacter.Utf8Circumflex)
                        Case 235 ' umlaut-e
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "e" + MyMarcCharacter.Utf8Umlaut)
                        Case 236 ' grave-I
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "i" + MyMarcCharacter.Utf8Grave)
                        Case 237 ' acute-i
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "i" + MyMarcCharacter.Utf8Acute)
                        Case 238 ' circumflex-i
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "i" + MyMarcCharacter.Utf8Circumflex)
                        Case 239 ' umlaut-i
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "i" + MyMarcCharacter.Utf8Umlaut)
                        Case 240 ' eth
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8Eth)
                        Case 241 ' tilde-n
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "n" + MyMarcCharacter.Utf8Tilde)
                        Case 242 ' grave-o
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "o" + MyMarcCharacter.Utf8Grave)
                        Case 243 ' acute-o
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "o" + MyMarcCharacter.Utf8Acute)
                        Case 244 ' circumflex-o
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "o" + MyMarcCharacter.Utf8Circumflex)
                        Case 245 ' tilde-o
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "o" + MyMarcCharacter.Utf8Tilde)
                        Case 246 ' umlaut-o
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "o" + MyMarcCharacter.Utf8Umlaut)
                        Case 248 ' slash-o
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8OSlashLower)
                        Case 249 ' grave-u
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "u" + MyMarcCharacter.Utf8Grave)
                        Case 250 ' acute-u
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "u" + MyMarcCharacter.Utf8Acute)
                        Case 251 ' circumflex-u
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "u" + MyMarcCharacter.Utf8Circumflex)
                        Case 252 ' umlaut-u
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "u" + MyMarcCharacter.Utf8Umlaut)
                        Case 253 ' acute-y
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "y" + MyMarcCharacter.Utf8Acute)
                        Case 254 ' lowercase thorn
                            sIn$ = SafeStuff(sIn$, lCtr, 1, MyMarcCharacter.Utf8ThornLower)
                        Case 255 ' umlaut-y
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "y" + MyMarcCharacter.Utf8Umlaut)
                        Case Else
                            sIn$ = SafeStuff(sIn$, lCtr, 1, "")
                    End Select
            End Select ' the main groups
        Next ' lctr
    End If
    
    MsoftAscii2Marc = sIn$

End Function


Private Function RegGetValue(ByVal lMainKey As Long, ByVal sSubKey$, ByVal sValueName$) As String

    Dim lReturnedKeyType As Long, lReturnCode As Long, lKeyHandle As Long
    Dim lDataLength As Long, lReturnValue As Long
    Dim lMode As Long, lReserved As Long, lOptions As Long
    
    Dim sReturnedString$


    
    lOptions = 0
    lMode = KEY_ALL_ACCESS
    If lMainKey& >= &H80000000 And lMainKey& <= &H80000006 Then
        lReturnCode = RegOpenKeyEx(lMainKey&, sSubKey$, lOptions, lMode, lKeyHandle)
        If lReturnCode <> ERROR_SUCCESS Then
            RegGetValue = vbNullString
            Exit Function     'No key open, so exit
        End If

        lReserved = 0
        lReturnCode = RegQueryValueExNull(lKeyHandle, sValueName$, lReserved, lReturnedKeyType, 0&, lDataLength)
        Select Case lReturnedKeyType
            Case REGTYPE_SZ
                sReturnedString$ = String(lDataLength + 1, 0)
                lReturnCode = RegQueryValueExString(lKeyHandle, sValueName$, lReserved, lReturnedKeyType&, sReturnedString$, lDataLength)
                If lReturnCode <> ERROR_SUCCESS Then
                    RegGetValue = vbNullString   'Value probably doesn't exist
                Else
                    RegGetValue = Left$(sReturnedString$, lDataLength - 1)
                End If
            Case REGTYPE_DWORD
                lReturnCode = RegQueryValueExLong(lKeyHandle, sValueName$, lReserved, lReturnedKeyType&, lReturnValue, 4)
                If lReturnCode = ERROR_SUCCESS Then
                    RegGetValue = CStr(lReturnValue)
                End If
            'Case Else
                ' all other types are not supported
        End Select
            
        'Always close opened keys.
        lReturnCode = RegCloseKey(lKeyHandle)
    End If

End Function


Public Function BreakLongLinesForPrinter(ByVal sIn$) As String

    ' 20040211: created from FRFGD2Breakup in old UtilMisc
    ' this is utf-8 safe because we only break at characters that
    '   are the same in marc8 and Utf8; the intervening
    '   stuff can be anything no problem
    
    
    Dim sOut$
        
    Dim lWidth As Long
    
    Dim iBreak%
    
    
    lWidth = Printer.ScaleWidth
    
    Do
        If Len(sIn$) < 150 Then
            If Printer.TextWidth(sIn$) < lWidth Then
                If Len(sOut$) > 0 Then
                    sOut$ = sOut$ + vbCrLf
                End If
                sOut$ = sOut$ + sIn$
                Exit Do
            End If
        End If
        For iBreak% = 150 To 40 Step -1
            If InStr(MyMarcCharacter.MarcDelimiter + "| -", Mid(sIn$, iBreak%, 1)) > 0 Then
                If Printer.TextWidth(Mid(sIn$, 1, iBreak% - 1)) < lWidth Then
                    If Len(sOut$) > 0 Then
                        sOut$ = sOut$ + vbCrLf
                    End If
                    sOut$ = sOut$ + Mid(sIn$, 1, iBreak% - 1)
                    sIn$ = "        " + Trim(Mid(sIn$, iBreak% + 1))
                    Exit For
                End If
            End If
        Next ' ibreak%
        If iBreak% < 40 Then ' we didn't find any break!
            ' break at an arbitrary point
            If Len(sOut$) > 0 Then
                sOut$ = sOut$ + vbCrLf
            End If
            If Not m_bUtf8 Then
                sOut$ = sOut$ + Mid(sIn$, 1, 60)
                sIn$ = "     " + Trim(Mid(sIn$, 61))
            Else
                iBreak% = MyMarcCharacter.Utf8CharFindFirstOctet(sIn$, 60)
                sOut$ = sOut$ + Mid(sIn$, 1, iBreak% - 1)
                sIn$ = "     " + Trim(Mid(sIn$, iBreak%))
            End If
        End If
    Loop
    
    BreakLongLinesForPrinter = sOut$
    
End Function


Public Function TestForCallNumber(ByVal sIndicators$, ByVal sField$, Optional ByVal sTNP$ = "Superscript6Superscript6.") As Boolean

    ' you're handed indicators and text from an 852 field
    ' the optional table name prefix gives us a clever way to
    '   perform Northwestern-only options without something
    '   like gblbNorthwestern ...
    
    ' 20040210: transferred from old UtilMisc
    '   and utf-8 ok
    
    Dim iRc%
    
    Dim sH$, sCall$, sLocation$
    
    
    ' default value: there is no call number in this 852 field
    TestForCallNumber = False
    
    If ExtractSubfield(sField$, "i", sCall$) > 0 Then
        If Len(NormString(sCall$)) > 0 Then
            ' looks like a call number to us: no Northwestern-specific
            '   things-that-are-not-call-numbers have $i in them
            TestForCallNumber = True
            Exit Function
        End If
    End If
    If ExtractSubfield(sField$, "h", sH$) > 0 Then
        ' we have $h: maybe this is a call number, maybe not
        ' and now an interetesting question: is there a call number
        '   assigned here already?
        ' 20010809: also allow blank indicators to fall into this test--seems to be
        '   an archaism from the NOTIS conversion
        If Len(NormString(sH$)) > 0 Then
            If InStr("8 ", Mid(sIndicators$, 1, 1)) > 0 Then ' mid ok
                ' a bit more difficult matter: does it contain a call number?
                ' 20060503: we were formerly comparing the raw form of the TNP,
                '   which meant that if people used "nwudb." instead of "NWUDB." the test would
                '   fail and they wouldn't be considered NUL people; so we switched from a literal
                '   comparison to a normalized comparison
                If NormString(sTNP$) = "NWUDB" Then
                    ' there will probably be yet other exceptions, where there's something
                    '   in subfield $h that doesn't imply an assigned number; but
                    '   there is at least "in process" and maybe these others
                    ' 20010530: of course, if there is no $h at all (even though
                    '   the indicator is '8') then we're still in business
                    sCall$ = Trim(NormString(sH$))
                    If Len(sCall$) > 0 Then
                        If InStr(sCall$, "IN PROCESS") = 0 And InStr(sCall$, "ON ORDER") = 0 And InStr(sCall$, "APPRO") = 0 And InStr(sCall$, "YANK") = 0 Then
                            ExtractSubfield sField$, "b", sLocation$
                            ' maybe this is a NOTIS-II number?
                            ' if it is NOTIS-II, then we're going to pretend there isn't a number here at all
                            ' this logic cribbed from CollectLocations in NOTIS version
                            iRc% = InStr(sCall$, "-")
                            If iRc% = 3 And sLocation$ = "nchin" Then
                                If CharIsNumeric(Mid(sCall$, 1, 1)) And CharIsNumeric(Mid(sCall$, 2, 1)) And CharIsNumeric(Mid(sCall$, 4, 1)) Then
                                    Exit Function ' with return of "no call number"
                                End If
                            End If
                            TestForCallNumber = True
                        End If
                    End If
                Else
                    ' 20060425: branch added to fill a hole in the logic
                    ' $h present, indicator 8 or blank, not Northwestern: there is a call number
                    TestForCallNumber = True
                End If
            Else ' first indicator anything other than '8'/' ', and $h present
                'Debug.Print "Indicators other"
                TestForCallNumber = True
                ' there *must* be an assigned call number already; we can't
                '   use this record
            End If ' what's the first indicator in the 852?
        Else
            ' $h is empty: return False
        End If
    'Else
        ' if there is no $h or $i, then there is no call number, no matter what
        ' return default value of False
    End If ' is $h present at all?


End Function

Public Sub ExpandPlaceAbbreviation(ByRef sZ2$, ByVal sOldField$, ByRef sField$)

    ' 20040210: copied from UtilMisc
    ' NOTE that we're assuming that we're getting things in 'good' characters, with no Unicode silliness mixed in
    ' NOTE the difference between this routine and the function FillOutAbbreviation in ValidIt; that
    '   function is concerned solely with spelling out abbreviations, while this function is
    '   concerned with constructing the form used in indirect subdivision that corresponds to
    '   an abbreviation
    ' every attempt should be made to keep these two routines parallel
    
    
    Select Case UCase(Mid(sZ2$, 1, 1))
        Case "A", "B", "C", "D"
            Select Case NormString(sZ2$)
                Case "A C T", "ACT"
                    If m_bAustralianSubdivisionPractice Then
                        sZ2$ = "Australian Capital Territory"
                    Else
                        sZ2$ = "Australia"
                        sField$ = sOldField$
                    End If
                Case "ALA"
                    sZ2$ = "Alabama"
                Case "ALTA"
                    sZ2$ = "Alberta"
                Case "ARIZ"
                    sZ2$ = "Arizona"
                Case "ARK"
                    sZ2$ = "Arkansas"
                Case "B C", "BC"
                    sZ2$ = "British Columbia"
                Case "CAL", "CALIF"
                    sZ2$ = "California"
                Case "COLO"
                    sZ2$ = "Colorado"
                Case "CONN"
                    sZ2$ = "Connecticut"
                Case "D C", "DC"
                    sField$ = sOldField$
                    sZ2$ = ""
                ' not going to bother here with "D.F."
                Case "DEL"
                    sZ2$ = "Delaware"
            End Select
        Case "E", "F", "G", "H", "I"
            Select Case NormString(sZ2$)
                Case "FLA"
                    sZ2$ = "Florida"
                Case "GA"
                    sZ2$ = "Georgia"
                Case "ILL"
                    sZ2$ = "Illinois"
                Case "IND"
                    sZ2$ = "Indiana"
            End Select
        Case "J", "K", "L"
            Select Case NormString(sZ2$)
                Case "KAN"
                    sZ2$ = "Kansas"
                ' case "KOREA" ' we MIGHT want to guess this is Korea (South); but let's leave it alone
                Case "KY"
                    sZ2$ = "Kentucky"
                Case "LA"
                    sZ2$ = "Louisiana"
            End Select
        Case "M"
            Select Case NormString(sZ2$)
                Case "ME"
                    sZ2$ = "Maine"
                Case "MAN"
                    sZ2$ = "Manitoba"
                Case "MD"
                    sZ2$ = "Maryland"
                Case "MASS"
                    sZ2$ = "Massachusetts"
                Case "MICH"
                    sZ2$ = "Michigan"
                Case "MINN"
                    sZ2$ = "Minnesota"
                Case "MISS"
                    sZ2$ = "Mississippi"
                Case "MO"
                    sZ2$ = "Missouri"
                Case "MONT"
                    sZ2$ = "Montana"
            End Select
        Case "N"
            Select Case NormString(sZ2$)
                Case "NEB"
                    sZ2$ = "Nebraska"
                Case "NEV"
                    sZ2$ = "Nevada"
                Case "N B", "NB"
                    sZ2$ = "New Brunswick"
                Case "N H", "NH"
                    sZ2$ = "New Hampshire"
                Case "N J", "NJ"
                    sZ2$ = "New Jersey"
                Case "N L", "NL"
                    sZ2$ = "Newfoundland and Labrador"
                Case "N M", "NM"
                    sZ2$ = "New Mexico"
                Case "N Y", "NY", "NEW YORK STATE"
                    sZ2$ = "New York (State)"
                Case "N Z", "NZ"
                    sZ2$ = "New Zealand"
                Case "NFLD"
                    sZ2$ = "Newfoundland"
                Case "N C", "NC"
                    sZ2$ = "North Carolina"
                Case "N D", "ND"
                    sZ2$ = "North Dakota"
                Case "N S", "NS"
                    sZ2$ = "Nova Scotia"
                Case "N S W", "NSW"
                    If m_bAustralianSubdivisionPractice Then
                        sZ2$ = "New South Wales"
                    Else
                        sZ2$ = "Australia"
                        sField$ = sOldField$
                    End If
                Case "N T"
                    If m_bAustralianSubdivisionPractice Then
                        sZ2$ = "Northern Territory"
                    Else
                        sZ2$ = "Australia"
                        sField$ = sOldField$
                    End If
                Case "N W T", "NWT"
                    sZ2$ = "Northwest Territories"
            End Select
        Case "O", "P", "Q", "R"
            Select Case NormString(sZ2$)
                Case "OKLA"
                    sZ2$ = "Oklahoma"
                Case "ONT"
                    sZ2$ = "Ontario"
                Case "OR"
                    sZ2$ = "Oregon"
                Case "PA"
                    sZ2$ = "Pennsylvania"
                Case "P E I", "PEI"
                    sZ2$ = "Prince Edward Island"
                Case "P R", "PR"
                    sZ2$ = "Puerto Rico"
                Case "QLD"
                    If m_bAustralianSubdivisionPractice Then
                        sZ2$ = "Queensland"
                    Else
                        sZ2$ = "Australia"
                        sField$ = sOldField$
                    End If
                Case "QUEBEC"
                    sZ2$ = "Qu\'ebec (Province)"
                Case "R I", "RI"
                    sZ2$ = "Rhode Island"
                Case "RUSSIA"
                    sZ2$ = "Russia (Federation)"
            End Select
        Case "S", "T", "U"
            Select Case NormString(sZ2$)
                Case "S AUST", "SAUST"
                    If m_bAustralianSubdivisionPractice Then
                        sZ2$ = "South Australia"
                    Else
                        sZ2$ = "Australia"
                        sField$ = sOldField$
                    End If
                Case "SASK"
                    sZ2$ = "Saskatchewan"
                Case "S C", "SC"
                    sZ2$ = "South Carolina"
                Case "S D", "SD"
                    sZ2$ = "South Dakota"
                Case "T H"
                    sZ2$ = "Hawaii"
                Case "TAS"
                    If m_bAustralianSubdivisionPractice Then
                        sZ2$ = "Tasmania"
                    Else
                        sZ2$ = "Australia"
                        sField$ = sOldField$
                    End If
                Case "TENN"
                    sZ2$ = "Tennessee"
                Case "TEX"
                    sZ2$ = "Texas"
            End Select
        Case "V", "W", "X", "Y", "Z"
            Select Case NormString(sZ2$)
                Case "VT"
                    sZ2$ = "Vermont"
                Case "V I", "VI"
                    sZ2$ = "Virgin Islands"
                    'sZ1$ = "V.I."
                Case "VA"
                    sZ2$ = "Virginia"
                Case "VIC"
                    If m_bAustralianSubdivisionPractice Then
                        sZ2$ = "Victoria"
                    Else
                        sZ2$ = "Australia"
                        sField$ = sOldField$
                    End If
                Case "WASH"
                    sZ2$ = "Washington (State)"
                Case "W A", "WA"
                    If m_bAustralianSubdivisionPractice Then
                        sZ2$ = "Western Australia"
                    Else
                        sZ2$ = "Australia"
                        sField$ = sOldField$
                    End If
                Case "W VA", "WVA"
                    sZ2$ = "West Virginia"
                Case "WIS"
                    sZ2$ = "Wisconsin"
                Case "WYO"
                    sZ2$ = "Wyoming"
                Case "YUKON", "YUKON TERRITORY"
                    ' 20070306: changed from Yukon Territory, which has been
                    '   wrong for a long time ...
                    sZ2$ = "Yukon"
            End Select
    End Select
    
End Sub

Public Function IndirectSubdivisionForm(ByRef sHeading$) As String

    ' convert a geographic heading into its putative indirect subdivision form
    ' accurate enough for perhaps 80% of headings, but far from all; the rest
    '   will have to be done "by hand"
    
    ' we're handed a geographic heading that contains only subfield $a
    
    ' 20040210: copied from UtilMisc; we eventually need a much smarter version ...
    
    
    Dim iOk%, iParensAt%, iJunk%, iBadAt%, iRc%, iItem%, iSingle%
    Dim sField$, sTest$, sSave$, sZ1$, sZ2$, sZ2a$, sZ2b$, sJunk$, sOldField$


    iRc% = InStr(sHeading$, MyMarcCharacter.MarcDelimiter + "a")
    If iRc% > 0 Then
        sField$ = Trim(Mid(sHeading$, iRc% + 2))
    Else
        sField$ = Trim(sHeading$)
    End If
    
    sOldField$ = sField$
    
    iRc% = InStr(sField$, "(")
    If iRc% > 0 Then
        sZ2$ = Mid(sField$, iRc% + 1)
        sField$ = Trim(Mid(sField$, 1, iRc% - 1))
        If Right(sZ2$, 1) = ")" Then
            sZ2$ = Mid(sZ2$, 1, Len(sZ2$) - 1)
        End If
    Else ' it's something like "France" or whatnot (we hope!)
        IndirectSubdivisionForm = MyMarcCharacter.MarcDelimiter + "z" + sField$
        Exit Function
    End If

    iRc% = InStr(sZ2$, " :")
    If iRc% > 0 Then
        sZ2a$ = Trim(Mid(sZ2$, 1, iRc% - 1))
        sZ2b$ = Trim(Mid(sZ2$, iRc% + 2))
        sJunk$ = NormString(sZ2a$)
        If IndirectSubdivisionFormIsJurisdiction(sJunk$) Then
            ' then #2 must be the place name
            sZ1$ = sZ1$ + " (" + sZ2a$ + ")"
            sZ2$ = sZ2b$
        Else
            sJunk$ = NormString(sZ2b$)
            If IndirectSubdivisionFormIsJurisdiction(sJunk$) Then
                sZ1$ = sZ1$ + " (" + sZ2b$ + ")"
                sZ2$ = sZ2a$
            End If
        End If
    Else
        If IndirectSubdivisionFormIsJurisdiction(sJunk$) Then
            IndirectSubdivisionForm = sOldField$
            Exit Function
        End If
    End If
        
    
    ' the thing we have in sZ2 is the putative larger place
    '   through which we're going to divide
    
    ExpandPlaceAbbreviation sZ2$, sOldField$, sField$
    ' formulate the return value
    
    If Len(sZ2$) > 0 Then
        IndirectSubdivisionForm = MyMarcCharacter.MarcDelimiter + "z" + sZ2$ + MyMarcCharacter.MarcDelimiter + "z" + sField$
    Else
        IndirectSubdivisionForm = MyMarcCharacter.MarcDelimiter + "z" + sField$
    End If

End Function




Public Function IndirectSubdivisionFormIsJurisdiction(ByRef sIn$) As Boolean

        
    If InStr(sIn$, "EXTINCT") > 0 Or InStr(sIn$, "KINGDOM") > 0 Or InStr(sIn$, "DUCHY") > 0 Or sIn$ = "LAKE" Or sIn$ = "TOWN" Or sIn$ = "TOWNSHIP" Or sIn$ = "REGION" Or sIn$ = "STATE" Then
        IndirectSubdivisionFormIsJurisdiction = True
    Else
        IndirectSubdivisionFormIsJurisdiction = False
    End If

End Function

Public Function NormalizeStandardNumber(ByRef sStandardNumberTag$, ByRef sStandardNumberText$) As String

    Dim sCopy$, sKeepString$
    Dim iRc%
    
    ' always uppercase everything
    
    Select Case sStandardNumberTag$
        Case "010", "020"
            sCopy$ = Trim(SafeUCase(sStandardNumberText$))
            ' remove all except numerals, alphas and space
            sKeepString$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 "
            NormalizeStandardNumberKeepOnlyCharacters sCopy$, sKeepString$
            ' remove multiple spaces
            sCopy$ = RemoveRepeatedCharacters(sCopy$, " ")
        Case "022"
            sCopy$ = Trim(SafeUCase(sStandardNumberText$))
            ' 20020214: perhaps beginning version 2000: hyphens become spaces instead of nothing
            sKeepString$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789- "
            ' remove all except numerals, alphas and space
            NormalizeStandardNumberKeepOnlyCharacters sCopy$, sKeepString$
            ' hyphens become spaces
            Do
                iRc% = InStr(sCopy$, "-")
                If iRc% = 0 Then
                    Exit Do
                End If
                If iRc% = 1 Then
                    sCopy$ = "  " + Mid(sCopy$, 2)
                Else
                    sCopy$ = Mid(sCopy$, 1, iRc% - 1) + " " + Mid(sCopy$, iRc% + 1)
                End If
            Loop
            ' remove multiple spaces
            sCopy$ = RemoveRepeatedCharacters(sCopy$, " ")
        Case "035"
            sCopy$ = Trim(SafeUCase(sStandardNumberText$))
            If Mid(sCopy$, 1, 1) = "(" Then
                ' remove any *initial* NUC code (but retain any others!).
                ' retain all punctuation (as it seems)
                ' this behavior is correct: both opening and closing parens must
                '   be present
                iRc% = InStr(sCopy$, ")")
                If iRc% > 0 Then
                    sCopy$ = Trim(Mid(sCopy$, iRc% + 1))
                End If
                ' we do NOT remove multiple spaces!
                'GoSub NormStandardNumberSpacesOut
            End If
        Case Else ' unknown tag: return exactly what we're given
            sCopy$ = sStandardNumberText$
    End Select

    NormalizeStandardNumber = Trim(sCopy$)
    
End Function


Public Property Get MarcRecordIn() As String

    MarcRecordIn = m_sMarcIn$
    
End Property

Public Function ReplaceCharacters(ByVal sIn$, ByVal sCharacterToRemove$, Optional sReplacementCharacter$ = "", Optional ByVal bReplaceMultipleSpacesWithSingle As Boolean = False) As String

    ' 20040210: converted from single-purpose NoHyphens in UtilMisc
    ' NOTE that this is transparent to utf-8--ASSUMING the caller sends us whole characters!
    
    
    Dim iLen%
    
    Dim lPtr As Long
    

    iLen% = Len(sCharacterToRemove$)
    
    If iLen% = 0 Or sCharacterToRemove$ = sReplacementCharacter$ Then
        ReplaceCharacters = sIn$
        Exit Function
    End If
    
    For lPtr = Len(sIn$) To 1 Step -1
        If Mid(sIn$, lPtr, iLen%) = sCharacterToRemove$ Then
            sIn = SafeStuff(sIn$, lPtr, iLen%, sReplacementCharacter$)
        End If
    Next
    
    ' 20050420: ReplaceMultipleSpacesWithSingle added to provide for instances (such as
    '   substituting characters in fixed-length strings such as the two indicators) where
    '   two adjacent spaces are in fact appropriate
    If bReplaceMultipleSpacesWithSingle Then
        If sReplacementCharacter$ = " " Then
            sIn$ = RemoveRepeatedCharacters(sIn$, " ")
        End If
    End If
    
    ReplaceCharacters = sIn$
    
End Function

Public Property Let MarcRecordIn(ByVal sMarcRecord$)

    Dim sField$, sSaveCharacterSetOut$
    
    Dim iPtr%
    
    Dim lBad As Long, lPtr As Long


    m_sMarcIn$ = ""
    m_sLeader$ = ""
    m_sDirectory$ = ""
    m_sFields$ = ""
    m_iMarcCtr% = 0 ' formerly -1
    m_bIsAuthority = False
    m_i008Ptr% = -1
    m_iFirstField% = -1
    m_iLastField% = -1
    ' 20050131: ONLY reset the value of m_bUtf8 in
    '   harmony with CharacterSetOut
    'm_bUtf8 = False
    m_sCharacterEncodingScheme$ = " "
    m_sFieldsWithSubfieldsOutOfOrder$ = ""
    m_bFieldsOutOfOrder = False
    m_bSubfieldsOutOfOrder = False
#If MarcRecordModifiedDebug = -1 Then
    Debug.Print "MRM set to false"
#End If
    m_bMarcRecordModified = False
    m_bNewRecord = False
    m_bFldOrderChanged = False
    m_bSfdOrderChanged = False
    
    ' if there isn't actually any MARC record, then
    '   leave the rest of this alone, having first
    '   set some variables to their ground state
    If Len(sMarcRecord$) = 0 Then
        Exit Property
    End If
    
#If MarcRecordInDebug = -1 Or MarcRecordInDebugShort = -1 Then
    Debug.Print "MRI record received: >" + Mid(sMarcRecord$, 1, 50)
#End If


    m_sLeader$ = Mid(sMarcRecord$, 1, 24) ' mid ok
    lPtr = Rat(m_sLeader$, "45")
    If lPtr > 0 And lPtr < 21 Then
        Do While lPtr < 21
            sMarcRecord$ = SafeStuff(sMarcRecord$, lPtr, 0, " ")
            lPtr = lPtr + 1
        Loop
    End If


    If IsMarc(sMarcRecord$) Then
#If MarcRecordInDebug = -1 Then
        Debug.Print "Record Is MARC"
#End If
        ' we'll preserve the record as received--no translation,
        '   no cleanup, no nothing--so the container can always
        '   retrieve it if needed
        ' 20060802: turning this off here; reinstituted later; having this
        '   set to something when there isn't actually a record to translate
        '   seems to cause the odd problem
        'm_sMarcIn$ = sMarcRecord$
        ' allow this direct manipulation to stand for now; we also have
        '   a FldMoveFirst at the bottom of this routine
        m_iFldPointer% = 0
        ' allow this direct manipulation to standard for now; the
        '   FldMoveFirst at the bottom will set the pointer to
        '   this field's first subfield
        m_iSfdPointer% = 0
        m_sTagWanted$ = ""
        ' assume that the record is in the character set that
        '   the outside told us it was (see below for additional
        '   tests of this proposition)
        m_sCharacterSetIn$ = m_sDeclaredCharacterSetIn$
#If MarcRecordInDebug = -1 Then
        Debug.Print "Assumed IN character set: >" + m_sCharacterSetIn$ + "<"
#End If

        ' we minimally assign leader,directory,and fields here
        m_sLeader$ = Mid(sMarcRecord$, 1, 24) ' mid ok
        ' NOTE that now that we've set m_sLeader$, we can in this routine invoke
        '   GetLeaderValue (instead of Mid()), with its better self-documentation
        '   of starting position
        
        ' 20090529: it's unclear *why* the following is here; but obviously we're
        '   adjusting for some badly-formed leaders that must have caused us
        '   a problem at some point in the past; "45" should normally appear
        '   in the leader at one-based position 21 (Leader/20 and Leader/21:
        '   length of starting character position and length of length of field
        '   position)
        lPtr = Rat(m_sLeader$, "45")
        If lPtr > 0 And lPtr < 21 Then ' should be at leader/20
            Do While lPtr < 21
                sMarcRecord$ = SafeStuff(sMarcRecord$, lPtr, 0, " ")
                lPtr = lPtr + 1
            Loop
            m_sLeader$ = Mid(sMarcRecord$, 1, 24)
        End If
        
        ' recall that now that we've set m_sLeader$, we can invoke GetLeaderValue,
        '   with its better self-documentation of starting position
        If GetLeaderValue(6, 1) = "z" Then
            m_bIsAuthority = True
        End If
        m_sRecordFormat$ = SetFormatCode(m_sLeader$)
        
        ' if we're going to be testing field order, then
        '   make sure the appropriate field order array is
        '   fully configured
        If gblbTestOrderStuff Then
            gblbTestOrderStuff = False
            Select Case m_sRecordFormat$
                Case "A"
                    If gbliFieldOrderAuthLast% = 0 Then
                        SetDefaultFldOrderAuth
                    Else
                        TestLastFieldOrderRule gblaFieldOrderAuth(), gbliFieldOrderAuthLast%, gbliFieldOrderAuthMax%
                    End If
                    If gbliSubfieldOrderAuthLast% = 0 Then
                        SetDefaultSfdOrderAuth
                    Else
                        TestLastSfdOrderRule gblaSubfieldOrderAuth(), gbliSubfieldOrderAuthLast%, gbliSubfieldOrderAuthMax%
                    End If
                Case "B", "D", "F", "M", "P", "S", "U"
                    If gbliFieldOrderBibLast% = 0 Then
                        SetDefaultFldOrderBib
                    Else
                        TestLastFieldOrderRule gblaFieldOrderBib(), gbliFieldOrderBibLast%, gbliFieldOrderBibMax%
                    End If
                    If gbliSubfieldOrderBibLast% = 0 Then
                        SetDefaultSfdOrderBib
                    Else
                        TestLastSfdOrderRule gblaSubfieldOrderBib(), gbliSubfieldOrderBibLast%, gbliSubfieldOrderBibMax%
                    End If
                Case "H"
                    If gbliFieldOrderHoldLast% = 0 Then
                        SetDefaultFldOrderHold
                    Else
                        TestLastFieldOrderRule gblaFieldOrderHold(), gbliFieldOrderHoldLast%, gbliFieldOrderHoldMax%
                    End If
                    If gbliSubfieldOrderHoldLast% = 0 Then
                        SetDefaultSfdOrderHold
                    Else
                        TestLastSfdOrderRule gblaSubfieldOrderHold(), gbliSubfieldOrderHoldLast%, gbliSubfieldOrderHoldMax%
                    End If
                Case Else
                    'Debug.Print "OTHER"
                    If gbliFieldOrderOtherLast% = 0 Then
                        SetDefaultFldOrderOther
                    Else
                        TestLastFieldOrderRule gblaFieldOrderOther(), gbliFieldOrderOtherLast%, gbliFieldOrderOtherMax%
                    End If
                    If gbliSubfieldOrderOtherLast% = 0 Then
                        SetDefaultSfdOrderOther
                    Else
                        TestLastSfdOrderRule gblaSubfieldOrderOther(), gbliSubfieldOrderOtherLast%, gbliSubfieldOrderOtherMax%
                    End If
            End Select
        End If
        
        ' 20020120: examine leader for character encoding scheme; this will
        '   direct use of translation, normalization and so on
        m_sCharacterEncodingScheme$ = GetLeaderValue(9, 1) ' leader/09: character encoding scheme
#If MarcRecordInDebug = -1 Then
        Debug.Print "Encoding scheme: >" + m_sCharacterEncodingScheme$ + "<"
#End If
        If m_sCharacterEncodingScheme$ = "a" Then ' from leader/09
            ' the record says that it is in Unicode on arrival
            ' this fact overrides whatever it might have been
            '   that the outside told us
            m_sCharacterSetIn$ = CHARACTERSET_Utf8$
        Else
            ' record says that it is *not* in Unicode
            ' branch added 20040802: if the record is NOT Unicode but
            '   it's supposed to be, then we're going to have to try to figure
            '   out the record's character encoding scheme, and
            '   reset ourselves accordingly
            If m_sCharacterSetIn$ = "U" Then
                m_sCharacterSetIn$ = Mid(CharacterizeCharacterSet(sMarcRecord$), 1, 1)
                ' 20060529: resolve ambiguity here! this is of course frightfully
                '   arbitrary of us; but how could we possibly know that what we have is
                '   an LC record that came via OCLC?
                Select Case m_sCharacterSetIn$
                    Case CHARACTERSET_AmbiguousVO$ ' "X"
                        m_sCharacterSetIn$ = "V"
                    Case CHARACTERSET_AmbiguousVM$ ' "Y"
                        m_sCharacterSetIn$ = "M"
                End Select
            'Else
                ' the record says that it is not in Unicode, AND the
                '   container program tells us that the record is not in
                '   Unicode; so we'll assume that the container program
                '   knows what it's doing
            End If
        End If
#If MarcRecordInDebug = -1 Then
        Debug.Print "Calculated character set in: : >" + m_sCharacterSetIn$
#End If
        
        ' the Base Address of Data is where the record directory ends
        '   and the variable fields begin
        lBad = Val(GetLeaderValue(12, 5))

        ' we TEMPORARILY turn off record translation, by setting
        '   CharacterSetOut same as CharacterSetIn; but save the
        '   original CharacterSetOut setting so we can restore it
        '   later (and at that time translate the record into the
        '   desired character set)
        sSaveCharacterSetOut$ = CharacterSetOut
        If m_bUtf8LcPattern Then
            sSaveCharacterSetOut$ = CHARACTERSET_Utf8LcPattern$
        End If
#If MarcRecordInDebug = -1 Then
        Debug.Print "About to set CSO"
#End If
        CharacterSetOut = CharacterSetIn
#If MarcRecordInDebug = -1 Then
        Debug.Print "Just set CSO"
#End If
        ' 20060802: now that we've turned off translation (done while
        '   m_sMarcIn is null, as set above), we can safely
        '   declare to the rest of the module that we've got a record
        m_sMarcIn$ = sMarcRecord$
        
        ' NOTE that we fix bytes 22 and 23 (which may arrive from
        '   OCLC with wacky values) at the time we assemble
        '   MarcRecordOut, so there's no real need to clean 'em
        '   up here--no one will ever see them (unless they
        '   ask via GetLeaderValue)
         
        ' subtract 1 from the Base Address of Data so that
        '   we exclude the field mark at end of directory (who
        '   needs it?); and remove the leader (which we've
        '   already separately removed, above)
        m_sDirectory$ = Mid(Mid(sMarcRecord$, 1, lBad - 1), 25)
        ' when you extract the variable fields, add 1 to the
        '   Base Address of Data so that you again skip over the
        '   fieldmark at the end of the record directory
        m_sFields$ = Mid(sMarcRecord$, lBad + 1) ' mid ok
        ' and then remove the end-of-record mark at the end of the
        '   fields assembly (we can't do this in one step because we don't
        '   know the length until we've done the previous step)
        m_sFields$ = Mid(m_sFields$, 1, Len(m_sFields$) - 1) ' mid ok
        
        ' 20060913: if we're coming in with Unicode, replace the "old alif"
        '   with the "new alif"; we can do this simply, because
        '   the old and new alifs are the same length and this won't
        '   throw the record directory numbers off
        If m_sCharacterSetIn$ = "U" Then
            m_sFields$ = ReplaceCharacters(m_sFields$, OldUtf8Alif$, NewUtf8Alif$)
        End If
        
        ' the record is always maintained internally in the character set
        '   to be supplied as output (that is, once we're doine with this
        '   routine)

#If MarcRecordInDebug = -1 Then
        Debug.Print "Sets: >" + m_sCharacterSetIn$ + ":" + m_sCharacterSetOut$ + "<"
#End If
        
        ' using the record directory as your guide, chop up the variable
        '   fields cluster into an array of fields; and each variable field
        '   into an array of subfilds
        DigestRecord ' only place this is called; does not use With, or call anything that uses With
#If MarcRecordInDebug = -1 Then
        Debug.Print "Text at point A; char set in: " + m_sCharacterSetIn$
        Debug.Print TextFormatted(HexEquivalents, OclcMonospaced, "001 035 245 411 880")
        DoEvents
#End If
        
        ' 20050204: if this is a Unicode record, then decompose any composed
        '   characters before we do anything else, so we know what we're dealing with
        ' this routine performs other substitutions as well, to force the record
        '   as much as possible into the proper MARC-like shape
        If m_sCharacterSetIn$ = "U" Then
#If MarcRecordInDebug = -1 Then
            Debug.Print "Decomposing characters"
            DoEvents
#End If
            DecomposeUnicodeCharacters
        End If
        
#If MarcRecordInDebug = -1 Then
        Debug.Print "Before translation " + CharacterSetOut + ":" + sSaveCharacterSetOut$ + ":" + m_sCharacterSetIn$
        Debug.Print TextFormatted(HexEquivalents, OclcMonospaced, "001 035 245 411 880")
        DoEvents
#End If
        ' 20050816: for some reason, doing translation by calling
        '   "translatecharacterset" directly caused a problem--sometimes,
        '   a field got skipped
        ' we find that if we call this routine indirectly, by changing
        '   the output character set, that everything is OK
        ' this *may* have something to do with the fact that normalization
        '   is based on character set out, and at the time we do the original
        '   field-adding the fields are not actually in the output
        '   character set yet; and it's possible that the "real" fix lies not
        '   so much in the different way we call for translation per se, but
        '   the fact that the output character set is set to match the input
        '   set until we actually do the translation
#If True Then
        If CharacterSetOut <> sSaveCharacterSetOut$ Then
#If MarcRecordInDebug = -1 Then
            Debug.Print "Forcing CSO"
            DoEvents
#End If
            CharacterSetOut = sSaveCharacterSetOut$
        End If
#Else ' no longer used
        If m_sCharacterSetIn$ <> m_sCharacterSetOut$ Then
#If MarcRecordInDebug = -1 Then
            Debug.Print "Going into translation"
            DoEvents
#End If
            TranslateCharacterSet
        ElseIf m_bUtf8 Then
            ' 20070303: added for LC pattern: add markers to 880s if not already present
            If m_bUtf8LcPattern Then
                FldMoveTop
                Do While FldFindNext("880")
                    lPtr = FldPointer
                    FldText = TranslateMarc2Utf8OneFieldLcPattern("880", FldText)
                    FldPointer = lPtr
                Loop
            End If
        End If
#End If
#If MarcRecordInDebug = -1 Then
        Debug.Print "After translation"
        Debug.Print TextFormatted(0)
#End If
        
        
        'DumpArray
        'Debug.Print TextFormatted(latin1)
        
        ' 20050616: the record may not have had the
        '   order of fields and subfields changed simply
        '   by being read in; or maybe it has
        SeeIfSortOrderChanged
        
        'DumpArray
        
        ' put ourselves at the beginning of the first
        '   field in the record; ready for action
        FldMoveFirst

#If MarcRecordInDebug = -1 Then
    Else
        Debug.Print "Record is not MARC"
#End If
        
    End If

    FldChangedClearAll
    
End Property

Public Function IsMarc(ByVal sSuspect$) As Boolean

    ' todo: make this more elaborate, and also tidier
    
    Dim i%, sLeader$, sDirectory$, sNumString$
    
    Dim lMarcLen As Long, lBad As Long, lSuspectLen As Long
    
    sNumString$ = "0123456789"
    
    ' set default value: not a MARC record
    IsMarc = False
    m_sIsMarcErrorText$ = ""
#If IsMarcDebug = -1 Then
    Debug.Print "IsMarc entry with " + Trim(str(Len(sSuspect$))) + " characters beginning: >" + Mid(sSuspect$, 1, 24) + "<"
#End If
    ' the record must have some minimum length
    lSuspectLen = Len(sSuspect$)
    If lSuspectLen < 50 Then
#If IsMarcDebug = -1 Then
        Debug.Print "Too short"
#End If
        m_sIsMarcErrorText$ = "Too short to be a MARC record"
        Exit Function ' with false return value
    End If
    ' the first 5 characters must be numerals
    If InStr(sNumString$, Mid(sSuspect$, 1, 1)) = 0 Or InStr(sNumString$, Mid(sSuspect$, 2, 1)) = 0 Or InStr(sNumString$, Mid(sSuspect$, 3, 1)) = 0 Or InStr(sNumString$, Mid(sSuspect$, 4, 1)) = 0 Or InStr(sNumString$, Mid(sSuspect$, 5, 1)) = 0 Then ' mid ok
#If IsMarcDebug = -1 Then
        Debug.Print "First 5 not numeric"
#End If
        m_sIsMarcErrorText$ = "First 5 characters not all numeric"
        Exit Function ' with false return value
    End If
    
    ' determine the nominal length of the MARC record
    lMarcLen = Val(Mid(sSuspect$, 1, 5)) ' mid ok
    ' the input record must be at least this long
    If lSuspectLen < lMarcLen Then
#If IsMarcDebug = -1 Then
        Debug.Print "Length doesn't correspond"
#End If
        m_sIsMarcErrorText$ = "Record length in leader does not match actual record length"
        Exit Function ' with false return value
    End If
    
    ' get the base address of data
    lBad = Val(Mid(sSuspect$, 13, 5)) ' mid ok
    ' the input record must be at least this long
    If lBad > lMarcLen Then
#If IsMarcDebug = -1 Then
        Debug.Print "BAD too long"
#End If
        m_sIsMarcErrorText$ = "Base address of data longer than record length"
        Exit Function
    End If
    
    ' exract the leader
    sLeader$ = Mid(sSuspect$, 1, 24) ' mid ok
    'Debug.Print ">" + sLeader$ + "<"
    ' 20090106: if BAD is totally bad, it's not MARC (in theory, the shortest BAD would have to be
    '   at least 12 to provide for at least the 008, but we'll worry about that later)
    If lBad < 1 Then
#If IsMarcDebug = -1 Then
        Debug.Print "BAD no good"
#End If
        m_sIsMarcErrorText$ = "Base address of data unacceptable"
        Exit Function
    End If
    lBad = lBad + 25
    ' extract the directory
    'Debug.Print str(lBad) + " >" + Mid(sSuspect$, 1, 40)
    If Mid(sSuspect$, lBad - 25, 1) <> MyMarcCharacter.MarcEndOfField Then
#If IsMarcDebug = -1 Then
        Debug.Print "Directory has no EOF"
#End If
        m_sIsMarcErrorText$ = "Directory does not end with end-of-field character"
        Exit Function
    End If
    
    sDirectory$ = Mid(sSuspect$, 1, lBad) ' mid ok
    sDirectory$ = Mid(sDirectory$, 25) ' mid ok
    ' the directory must end with the end-of-field character
    sDirectory$ = Mid(sDirectory$, 1, Len(sDirectory$) - 1) ' mid ok
    
    If Mid(sSuspect$, lSuspectLen, 1) <> MyMarcCharacter.MarcEndOfRecord Then
#If IsMarcDebug = -1 Then
        Debug.Print "Record has no EOR"
#End If
        m_sIsMarcErrorText$ = "Record does not end with end-of-record character"
        Exit Function
    End If
    If Mid(sSuspect$, lSuspectLen - 1, 1) <> MyMarcCharacter.MarcEndOfField Then
#If IsMarcDebug = -1 Then
        Debug.Print "Last field has no EOF"
#End If
        m_sIsMarcErrorText$ = "Last field does not end with end-of-field character"
        Exit Function
    End If
    
    ' note that we do not here attempt to reconcile the length of anything
    '   to anything: whatever is left in the record (which we have already
    '   determined to be "long enough") is the fields
   
    ' set final return value: this is indeedy a MARC record!
    IsMarc = True
    
End Function

Public Function FldFindFirst(ByVal sTagToFind$, Optional ByVal sNormalizedFieldText$ = "") As Boolean
    
    ' 20040616: tag to find may actually be a *list* of tags
    ' 20040616: allow optional normalized field text
    
    
    Dim iDirPtr%, iTagLen%, iDirLen%
    
    Dim sTagWanted$, sTags$, sTag$
    
    Dim bText As Boolean
    
        
    DoEvents
        
        
    ' start out by clearing any previous stuff lying around
    FldFindFirst = False
    
    m_bFldAtTop = False
    m_bFldAtBottom = False
    m_bSfdAtTop = False
    m_bSfdAtBottom = False
    
    m_sFieldWanted$ = NormString(sNormalizedFieldText$)
    If Len(m_sFieldWanted$) > 0 Then
        bText = True
    End If
    
    sTagToFind$ = UCase(RemoveRepeatedCharacters(sTagToFind$, " "))
    If Len(sTagToFind$) > 0 Then
        m_sTagWanted$ = sTagToFind$
    End If
    
    If Len(m_sTagWanted$) < 1 Then
        FldPointer = -1
        Exit Function
    End If
    
    ' find the tag already
    FldMoveFirst
    While FldWasFound
        If Not FldDeleted Then
            If TagCompare(m_sTagWanted$, FldTag) Then
                If bText Then
                    If Mid(FldNorm, 1, Len(m_sFieldWanted$)) = m_sFieldWanted$ Then
                        FldFindFirst = True
                        Exit Function
                    'Else
                        ' continue looking for other fields that match
                    End If
                Else
                    FldFindFirst = True
                    Exit Function
                End If
            End If
        End If
        FldMoveNext
    Wend
    
    ' tag not found: we're outside the record
    FldPointer = -1
    
End Function

Public Property Let FldText(ByVal vNewValue As String)


#If FldTextDebug = -1 Then
    Debug.Print "Let FldText entry " + str(FldPointer)
#End If
    If FldPointer > -1 Then
        
        ' 20060913: if the supplied value is null, explicitly to remove all of the subfields
        If Len(vNewValue) = 0 Then
            SfdMoveFirst
            Do
                SfdDelete
                If Not SfdMoveNext Then
                    Exit Do
                End If
            Loop
        Else
            ' 20050506: force subfield $a if missing
            ' 20050621: but not if this is a control field!
            If Mid(vNewValue, 1, 1) <> MarcDelimiter And Mid(FldTag, 1, 2) <> "00" Then
                vNewValue = MarcDelimiter + "a" + vNewValue
            End If
            ResetCurrentField FldTag, FldInd, vNewValue
        End If
    
    End If
    
End Property
Public Property Get FldText() As String

    Dim iPtr%
    
    Dim sReturn$
    

    If FldPointer > -1 Then
        With MarcArray(FldPointer)
#If WithDebug = -1 Then
            PushWith "FldText"
#End If
            iPtr% = .FirstSubfield
            If Mid(.Tag, 1, 2) = "00" Then
                ' control field--the first "subfield" is the while thing
                If iPtr% > -1 Then
                    sReturn$ = .Subfield(iPtr%).Text
                End If
            Else
                ' we have a non-control veriable field--collect all of the subfields
                On Error GoTo FldTextNoField
                While iPtr% > -1
                    If Not .Subfield(iPtr%).Deleted Then
                        ' 20040615: do not trim spaces from subfield text
                        sReturn$ = sReturn$ + MyMarcCharacter.MarcDelimiter + .Subfield(iPtr%).Code + .Subfield(iPtr%).Text
                    End If
                    iPtr% = .Subfield(iPtr%).NextSubfield
                Wend
FT_IndexErrorResume:
                On Error GoTo 0
            End If
            FldText = sReturn$
#If WithDebug = -1 Then
            PopWith "FldText"
#End If
        End With
    Else
        FldText = ""
    End If
    
FldTextNoFieldResume:

    On Error GoTo 0
    Exit Property
    
FT_IndexError:

    Resume FT_IndexErrorResume
    
FldTextNoField:

    FldText = ""
    Resume FldTextNoFieldResume
    
End Property


Public Function FldFindNext(Optional sTagToFind$ = "", Optional ByVal sNormalizedFieldText$ = "") As Boolean

    ' find the occurrence of some tag following the current field
    ' to find the next occurrence of the tag used in fldfindfirst, supply no
    '   parameter here; we'll expose the next field with the same tag
    ' to find the first occurrence of *any* tag following the current
    '   field, supply the tag parameter (1 to 3 digits) here
    
    Dim iDirPtr%, iTagLen%, iDirLen%
    
    Dim sField$, sTags$, sTag$
    
    Dim bText As Boolean
    
    
    m_bFldAtTop = False
    m_bFldAtBottom = False
    m_bSfdAtTop = False
    m_bSfdAtBottom = False
    
    FldFindNext = False
    
    If Len(sNormalizedFieldText$) > 0 Then
        m_sFieldWanted$ = NormString(sNormalizedFieldText$)
        If Len(m_sFieldWanted$) > 0 Then
            bText = True
        End If
    Else
        If Len(m_sFieldWanted$) > 0 Then
            bText = True
        End If
    End If
    
    If Len(sTagToFind$) > 0 Then
        m_sTagWanted$ = UCase(RemoveRepeatedCharacters(sTagToFind$, " "))
    End If
    
    If Len(m_sTagWanted$) < 1 Then
        Exit Function
    End If
    
    ' exit if we're already at the end of the record
    If Not FldWasFound Then
        Exit Function
    End If
    
    ' find the tag already
    While FldMoveNext
        'Debug.Print "FNF " + str(FldPointer)
        If Not FldDeleted Then
            If TagCompare(m_sTagWanted$, FldTag) Then
                If bText Then
                    If Mid(FldNorm, 1, Len(m_sFieldWanted$)) = m_sFieldWanted$ Then
                        FldFindNext = True
                        Exit Function
                    End If
                Else
                    FldFindNext = True
                    Exit Function
                End If
            End If
        End If
    Wend

    ' tag not found
    FldPointer = -1
    
End Function

Public Sub FldAdd(ByVal sNewTag$, Optional ByVal sNewIndicators$, Optional ByVal sNewFieldText$, Optional ByVal bForceToFirstPosition As Boolean = False)


    Dim iNextField%, iPrevField%, iCurrent%, iSaveNext%, iSavePrev%, iSaveLast%
    Dim iCtr%, i008Len%, iArrayElementForNewField%, iRc%
    
    Dim sSortInstruction$, sSortInstructionExtension$, sModifiedExtension$
    
    Dim bControl As Boolean, bTextSupplied As Boolean, bDebug As Boolean, bSortExtensionPresent As Boolean
    Dim b880SortingNeeded As Boolean
    
    
#If FldAddDebug = -1 Then
    If sNewTag$ = "411" Then
        Debug.Print "FA :" + sNewTag$ + ":" + sNewIndicators$ + ":" + sNewFieldText$ + ":"
        Debug.Print vbTab + CharToHex(sNewFieldText$)
        bDebug = True
    Else
        Debug.Print "FA :" + sNewTag$ + ":" + sNewIndicators$ + ":" + sNewFieldText$ + ":"
        Debug.Print vbTab + CharToHex(sNewFieldText$)
        bDebug = True
    End If
    
#End If

    If sNewTag$ = "880" Then
FldAddConvertTo880:
        Select Case MarcRecordFormat
            Case "A"
                b880SortingNeeded = prvbPair880sWithRomanizedFieldsAuth
            Case "B", "D", "F", "M", "P", "S", "U"
                b880SortingNeeded = prvbPair880sWithRomanizedFieldsBib
            Case Else
                b880SortingNeeded = prvbPair880sWithRomanizedFieldsHold
        End Select
    Else ' not an 880 field
        ' 20080416: if we're handed a new non-880 field that contains
        '   subfield $6 AND IF the tag in subfield $6 matches the tag
        '   proper, then we're going to assume that this is supposed
        '   to be an 880 field
        ' (added for a badly-constructed record from our Chinese vendor CIBTC)
        iCtr% = InStr(sNewFieldText$, MarcDelimiter + "6")
        If iCtr% > 0 Then
            If sNewTag$ = Mid(sNewFieldText$, iCtr% + 2, 3) Then
                sNewTag$ = "880"
                GoTo FldAddConvertTo880
            End If
        End If
    End If
    
#If FldAddDebug = -1 Then
    If sNewTag$ = "880" Then
        bDebug = True
        Debug.Print "Fld add: >" + sNewTag$ + ":" + sNewIndicators$ + ":" + sNewFieldText$ + "<"
    End If
    'DumpArray
#End If

    sNewTag$ = sNewTag$
    sNewIndicators$ = sNewIndicators$
    sNewFieldText$ = sNewFieldText$
    bForceToFirstPosition = bForceToFirstPosition
    
    ' 20040920: if the field being 'added' is an 008 field and
    '   if the record already contains an 008 field, then
    '   replace the existing 008 field with the supplied new field
    ' this avoids the embarassment of multiple 008 fields in the
    '   record; we inserted this test specifically because we accidentally created
    '   a record with two 008s using 'legal' code
    ' todo: note that other field-repeatability considerations might in the future
    '   be applied here and elsewhere; but this would require more detailed
    '   knowledge of MARC definitions which we're trying mightily hard
    '   to avoid
    If sNewTag$ = "008" Then
        If m_i008Ptr% > -1 Then
            Change008Value 0, sNewFieldText$
            Exit Sub
        End If
    End If
    
    ' check out the tag
    If Len(sNewTag$) <> 3 Then
        Exit Sub
    End If
    ' note that the tests here are more restrictive that those provided by CharIsNumeric (which would
    '   allow superscripts and subscripts; and, under Unicode, other stuff
    If InStr("0123456789", Mid(sNewTag$, 1, 1)) = 0 Or InStr("0123456789", Mid(sNewTag$, 2, 1)) = 0 Or InStr("0123456789", Mid(sNewTag$, 3, 1)) = 0 Then ' mid ok
        Exit Sub
    End If
    
    ' we will use the 'sort signature' to determine a field's location within the record
    ' the new field will be added at the *last* place in the record consonant with this
    '   sort signature
    ' the signature consists of a group number, plus additional information that varies
    '   from one group to another
#If True Then
    ' this code employs the new-fangled field-order mechanism
    ' 20061116: maybe fake things, depending on value of tag
    sSortInstruction$ = SetFieldSortGroupFromTag(sNewTag$, sNewIndicators$, sNewFieldText$)
    'Debug.Print sNewTag$ + ":" + sSortInstruction$ + " " + sNewFieldText$
#Else
    ' code used before definition of new-fangled field-order mechanism:
    '   sort control fields in one group by tag, other fields in a second
    '   group by first character of the tag
    If Mid(sNewTag$, 1, 2) = "00" Then
        sSortInstruction$ = "001" + sNewTag$
    Else
        sSortInstruction$ = "002" + Mid(sNewTag$, 1, 1)
    End If
#End If


#If FldAddDebug = -1 Then
    If bDebug Then
        Debug.Print "Signature: >" + sSortInstruction$ + "< " + sNewFieldText$
    End If
#End If
    ' point to the array member that contains the rules
    '   for sorting the subfields in this variable field; this
    '   routine makes a copy of the appropriate array member in
    '   another global place (so we don't have to ask format-related
    '   questions each time we handle a subfield in this field)
    SetSubfieldSortGroupFromTag sNewTag$
    
    If Len(sNewFieldText$) > 0 Then
        bTextSupplied = True
    End If
    
    ' check out the indicators, and do other tag-dependent stuff
    If Mid(sNewTag$, 1, 2) = "00" Then ' mid ok
        bControl = True
        ' control fields can't have indicators!
        sNewIndicators$ = ""
        If bTextSupplied > 0 Then
            If Mid(sNewFieldText$, 1) = MyMarcCharacter.MarcDelimiter Then ' mid ok
                sNewFieldText$ = Mid(sNewFieldText$, 3) ' mid ok
            End If
        End If
        ' 20040721: holdings 008 must have only 32 characters (not the sometimes
        '   Voyager default of 40 (!)
        ' in earlier versions of this code (in pre-Unicode programs) we first tested
        '   the trailing characters to make sure they are blanks; but we've discarded
        '   that test here because it was always true--and in any case, we always want
        '   to make this change, no matter what the content of the field
        ' note that in some records, the correct action would be to insert one or more spaces
        '   somewhere *within* the 008; but we have no way in this generic routine to know this
        If sNewTag$ = "008" Then
            Select Case MarcRecordFormat
                Case "H"
                    i008Len% = 32
                Case Else
                    i008Len% = 40
            End Select
            If Len(sNewFieldText$) <> i008Len% Then
                sNewFieldText$ = Mid(sNewFieldText$ + Space(i008Len%), 1, i008Len%)
            End If
        End If
    Else
        ' not a 'control' field; 010-999
        ' force indicators to length of 2 (meaning that they'll both be blanks
        '   if the outside didn't supply 'em) and then test for goodness
        sNewIndicators$ = Mid(sNewIndicators$ + "  ", 1, 2)
        ' idicators must be numerals or blanks (this removes any fill characters)
        If InStr("0123456789 ", Mid(sNewIndicators$, 1, 1)) = 0 Then
            sNewIndicators$ = SafeStuff(sNewIndicators$, 1, 1, " ")
        End If
        If InStr("0123456789 ", Mid(sNewIndicators$, 2, 1)) = 0 Then ' mid ok
            sNewIndicators$ = SafeStuff(sNewIndicators$, 2, 1, " ")
        End If
        If bTextSupplied Then
            ' the new field should begin with a subfield code;
            '   if not, assume $a
            If Mid(sNewFieldText$, 1, 1) <> MyMarcCharacter.MarcDelimiter Then ' mid ok
                sNewFieldText$ = MyMarcCharacter.MarcDelimiter + "a" + sNewFieldText$
            End If
        End If
        
        ' set length for comparison during following search, and set
        '   subfield $w information if relevant
        
    End If
    
#If WithDebug = -1 Then
    'DisplayWithStack
#End If
    ' add a new element to the array of fields; this element
    '   will hold the new field
    m_iMarcCtr% = m_iMarcCtr% + 1
    ReDim Preserve MarcArray(0 To m_iMarcCtr%)
    iArrayElementForNewField% = m_iMarcCtr% - 1
        
    ' fill the new array element with tag-level stuff
    With MarcArray(iArrayElementForNewField%)
#If WithDebug = -1 Then
        PushWith "FldAdd"
#End If
        'Debug.Print "Fld add " + sNewTag$ + ":" + sSortInstruction$
        .Changed = True
        .Tag = sNewTag$
        .Ind = sNewIndicators$
        iRc% = InStr(sSortInstruction$, prvsSortExtensionMarker$)
        If iRc% > 0 Then
            sSortInstructionExtension$ = Mid(sSortInstruction$, iRc%)
            sSortInstruction$ = Mid(sSortInstruction$, 1, iRc% - 1)
            .SortInstruction = sSortInstruction$
            .SortInstructionExtension = sSortInstructionExtension$
            bSortExtensionPresent = True
        Else
            .SortInstruction = sSortInstruction$
            .SortInstructionExtension = ""
        End If
        .LastSubfield = -1
        .FirstSubfield = -1
        .SubfieldLast = -1
        .IsControl = bControl
        .Deleted = False
#If WithDebug = -1 Then
        PopWith "FldAdd"
#End If
    End With
    
    ' make this field the current field
    FldPointer = iArrayElementForNewField%

    ' we want to have direct access to the table entry for the 008 field
    If sNewTag$ = "008" Then
        m_i008Ptr% = iArrayElementForNewField%
    End If
    
    
    ' deal with field order
    If m_iMarcCtr% = 1 Then
        ' this is the first member in the array, i.e., the first
        '   variable field in the record
        ' this means that it's both the first and the last field
        '   for the time being
        m_iFirstField% = 0
        m_iLastField% = 0
        ' there is no next or previous field yet
        MarcArray(iArrayElementForNewField%).NextField = -1
        MarcArray(iArrayElementForNewField%).PrevField = -1
    Else
        ' we're adding some field other than the first field in the record
        ' change the field that used to be the last
        '   field in the array, so that its 'next' element
        '   ponts to the new field
        ' many of these changes to field order are TEMPORARY and will be altered by
        '   the following code
        ' the formerly last field in the record is now followed by
        '   the new field
        MarcArray(m_iLastField%).NextField = iArrayElementForNewField%
        ' the new field is now preceded by the
        '   formerly last field in the array
        MarcArray(iArrayElementForNewField%).PrevField = m_iLastField%
        ' the new field's 'next' element is nothing, because
        '   the new field is the last field in the record (at
        '   least until we deal with field-order stuff)
        MarcArray(iArrayElementForNewField%).NextField = -1
        ' the new field is, at least temporarily, the last field
        '   in the record
        iSaveLast% = m_iLastField%
        m_iLastField% = iArrayElementForNewField%
        
        ' having temporarily inserted the new field into the record,
        '   determine the 'correct' location for the field
        
        ' 20061116: include the sorting extension for 880 fields, if present, in the examination
        ' note that sSortInstructionExtension$ ONLY has a non-zero length if we are interested in
        '   pairing 880s with their associated field; the questions are exactly equivalent
        If Len(sSortInstructionExtension$) > 0 Then
        
            ' 20100207: new logic:
            ' if incoming tag is NOT 880
            '   formulate extension + " G" as modified extension
            '   if record contains sort instruction + modified extension
            '      add non-880 field ahead of this 880 field
            '   else
            '      standard logic (but now ignoring the extension)
            ' else (incoming tag IS 880)
            '   formulate extension - "G" as modified extension
            '   if record cotnains sort instruction + modified extension
            '      add 880 field after this non-880 field
            '   else
            '      standard logic (but now ignoring the extension)
#If True Then
            If MarcArray(iArrayElementForNewField%).Tag <> "880" Then
                sModifiedExtension$ = sSortInstructionExtension$ + " G"
                iCurrent% = m_iFirstField%
                Do
                    If Not MarcArray(iCurrent%).Deleted Then
                        If iCurrent% <> iArrayElementForNewField% Then
                            If MarcArray(iCurrent%).SortInstruction = sSortInstruction$ Then
                                If MarcArray(iCurrent%).SortInstructionExtension = sModifiedExtension$ Then
FA_Insert880FieldAheadOfCurrentField:
                                    'Debug.Print "Adding: " + MarcArray(iArrayElementForNewField%).Tag + " as " + sSortInstruction$ + ":" + sSortInstructionExtension$ + " before: "
                                    'Debug.Print "     " + MarcArray(iCurrent%).SortInstruction + ":" + MarcArray(iCurrent%).SortInstructionExtension
                                    iPrevField% = MarcArray(iCurrent%).PrevField
                                    iNextField% = MarcArray(iCurrent%).NextField
                                    ' the incoming non-880 field goes BEFORE the current 880 field
                                    m_bMarcRecordModified = True
                                    iSaveNext% = MarcArray(iArrayElementForNewField%).NextField
                                    iSavePrev% = MarcArray(iArrayElementForNewField%).PrevField
                                    ' the new field's previous field is the newly next field's previous field
                                    MarcArray(iArrayElementForNewField%).PrevField = iPrevField%
                                    ' the newly next field's previous field is our new field
                                    MarcArray(iCurrent%).PrevField = iArrayElementForNewField%
                                    ' the field that preceded the field at which we stopped is now
                                    '   followed by the new field
                                    MarcArray(iPrevField%).NextField = iArrayElementForNewField%
                                    ' the new field's next field is the pointer to the field
                                    '   at which we've stopped
                                    '   (more exactly, it's the field pointed to by the 'next' element
                                    '   copied from the field that used to precede the newly next field--which
                                    '   is of course the same as newly next field itself)
                                    MarcArray(iArrayElementForNewField%).NextField = iCurrent%
                                    ' the next element of the field that formerly preceded the newly-added
                                    '   field is set to the former new field's next element (which really
                                    '   should be -1)
                                    MarcArray(iSavePrev%).NextField = iSaveNext%
                                    GoTo FldAddFindNewLastField
                                End If
                            End If
                        End If
                    End If
                    If MarcArray(iCurrent%).NextField = -1 Then
                        Exit Do
                    End If
                    iCurrent% = MarcArray(iCurrent%).NextField
                Loop
            Else
                ' this IS an 880 field
                ' we're looking for an existing field with the same group but no "880 field" extension
                sModifiedExtension$ = Trim(Mid(sSortInstructionExtension$, 1, Len(sSortInstructionExtension$) - 1))
                iCurrent% = m_iFirstField%
                Do
                    If iCurrent% <> iArrayElementForNewField% Then
                        If MarcArray(iCurrent%).SortInstruction = sSortInstruction$ Then
                            If MarcArray(iCurrent%).SortInstructionExtension = sModifiedExtension$ Then
                                ' the incoming 880 field goes AFTER the current field
                                ' if there is a next field, simply move to it, and then
                                '   insert ahead of it; if there is no next field, then fall through
                                '   and the new field will become the last field (which it already is,
                                '   funnily enough)
                                If MarcArray(iCurrent%).NextField > -1 And MarcArray(iCurrent%).NextField <> iArrayElementForNewField% Then
                                    iCurrent% = MarcArray(iCurrent%).NextField
                                    GoTo FA_Insert880FieldAheadOfCurrentField
                                Else
                                    GoTo FldAddFindNewLastField
                                End If
                            End If
                        End If
                    End If
                    If MarcArray(iCurrent%).NextField = -1 Then
                        Exit Do
                    End If
                    iCurrent% = MarcArray(iCurrent%).NextField
                Loop
            End If
                        
            ' if we get here, we're going to use standard logic for determining field position
                        
            GoTo FldAdd_StandardFieldOrderRules

#Else
            iCurrent% = m_iFirstField%
            Do
                iPrevField% = MarcArray(iCurrent%).PrevField
                iNextField% = MarcArray(iCurrent%).NextField
                If iCurrent% <> iArrayElementForNewField% Then
                    If MarcArray(iCurrent%).SortInstruction = sSortInstruction$ Then
                        If MarcArray(iCurrent%).SortInstructionExtension = sSortInstructionExtension$ Then
                            ' it should NEVER be the case that two fields have the same instruction!
                            ' this would appear to be illogical! but still:
                            GoTo FldAddWithExtensionBeforeCurrent
                        ElseIf Len(sSortInstructionExtension$) > 0 And Len(MarcArray(iCurrent%).SortInstructionExtension) > 0 And Mid(sSortInstructionExtension$, 1, Len(MarcArray(iCurrent%).SortInstructionExtension)) = MarcArray(iCurrent%).SortInstructionExtension Then
                            ' 20061205: this clause added
                            ' the new field should immediately follow the current field
                            If iNextField% = iArrayElementForNewField% Then
                                ' do nothing
                            ElseIf iNextField% <> -1 Then
                                MarcArray(MarcArray(iArrayElementForNewField%).PrevField).NextField = MarcArray(iArrayElementForNewField%).NextField
                                MarcArray(iArrayElementForNewField%).NextField = MarcArray(iCurrent%).NextField
                                MarcArray(iArrayElementForNewField%).PrevField = MarcArray(iNextField%).PrevField
                                MarcArray(iCurrent%).NextField = iArrayElementForNewField%
                                MarcArray(iNextField%).PrevField = iArrayElementForNewField%
                            End If
                            GoTo FldAddFindNewLastField
                        ElseIf MarcArray(iCurrent%).SortInstructionExtension > sSortInstructionExtension$ And Len(MarcArray(iCurrent%).SortInstructionExtension) > 0 And Len(sSortInstructionExtension$) > 0 Then
FldAddWithExtensionBeforeCurrent:
                            ' the incoming field goes before the current field
                            m_bMarcRecordModified = True
                            iSaveNext% = MarcArray(iArrayElementForNewField%).NextField
                            iSavePrev% = MarcArray(iArrayElementForNewField%).PrevField
                            ' the new field's previous field is the newly next field's previous field
                            MarcArray(iArrayElementForNewField%).PrevField = iPrevField%
                            ' the newly next field's previous field is our new field
                            MarcArray(iCurrent%).PrevField = iArrayElementForNewField%
                            ' the field that preceded the field at which we stopped is now
                            '   followed by the new field
                            MarcArray(iPrevField%).NextField = iArrayElementForNewField%
                            ' the new field's next field is the pointer to the field
                            '   at which we've stopped
                            '   (more exactly, it's the field pointed to by the 'next' element
                            '   copied from the field that used to precede the newly next field--which
                            '   is of course the same as newly next field itself
                            MarcArray(iArrayElementForNewField%).NextField = iCurrent%
                            ' the next element of the field that formerly preceded the newly-added
                            '   field is set to the former new field's next element (which really
                            '   should be -1)
                            MarcArray(iSavePrev%).NextField = iSaveNext%
                            GoTo FldAddFindNewLastField
                        'Else
                            ' the instructions are the same, and the current field's extension is LOWER
                            '   than the incoming field's extension: continue with the next field
                        End If
                    ElseIf MarcArray(iCurrent%).SortInstruction > sSortInstruction$ Then
                        ' sort instructions out of order: new field goes here
                        GoTo FldAddWithExtensionBeforeCurrent
                    End If
                End If
                If iNextField% = -1 Then
                    Exit Do
                End If
                iCurrent% = iNextField%
            Loop
#End If
        
        ElseIf MarcArray(iArrayElementForNewField%).Tag = "880" And b880SortingNeeded Then
        
#If FldAddDebug = -1 Then
            If bDebug Then
                Debug.Print "Attempting to find home for 880 field with extension"
            End If
#End If
            iCurrent% = m_iFirstField%
            Do
                iPrevField% = MarcArray(iCurrent%).PrevField
                iNextField% = MarcArray(iCurrent%).NextField
#If FldAddDebug = -1 Then
                If bDebug Then
                    Debug.Print "Comparing signatures: >" + MarcArray(iCurrent%).SortInstruction + "< >" + sSortInstruction$ + "< deleted? " + str(MarcArray(iCurrent%).Deleted)
                End If
#End If
                If MarcArray(iCurrent%).SortInstruction = sSortInstruction$ And Not MarcArray(iCurrent%).Deleted Then
#If FldAddDebug = -1 Then
                    If bDebug Then
                        Debug.Print "Comparing extensions: >" + MarcArray(iCurrent%).SortInstructionExtension + "< >" + sSortInstructionExtension$ + "< deleted? " + str(MarcArray(iCurrent%).Deleted)
                        Debug.Print "Current " + str(iCurrent%) + " previous: " + str(iPrevField%) + " next " + str(iNextField%)
                    End If
#End If
                    If MarcArray(iCurrent%).SortInstructionExtension = Mid(sSortInstructionExtension$, 1, Len(MarcArray(iCurrent%).SortInstructionExtension)) Then
                        ' the 880 goes after this field
                        ' if there *is* a next field, then move to that field and insert
                        '   ahead of it
                        ' [if there is no next field, leave things alone because the new field
                        '   is already in the correct place (the end)]
                        If iNextField% > -1 Then
                            MarcArray(MarcArray(iArrayElementForNewField%).PrevField).NextField = -1
                            MarcArray(iArrayElementForNewField%).NextField = MarcArray(iCurrent%).NextField
                            MarcArray(iCurrent%).NextField = iArrayElementForNewField%
                            If MarcArray(iArrayElementForNewField%).NextField > -1 Then
                                MarcArray(MarcArray(iArrayElementForNewField%).NextField).PrevField = iArrayElementForNewField%
                            End If
                            MarcArray(iArrayElementForNewField%).PrevField = iCurrent%
#If FldAddDebug = -1 Then
                            If bDebug Then
                                Debug.Print "Switched pointers"
                            End If
#End If
                            GoTo FldAddFindNewLastField
                        End If
                    End If
                End If
                If iNextField% = -1 Then
                    Exit Do
                End If
                iCurrent% = iNextField%
            Loop
        
        Else ' not 880 field
        
FldAdd_StandardFieldOrderRules:

            iCurrent% = m_iFirstField%
            Do
                iPrevField% = MarcArray(iCurrent%).PrevField
                iNextField% = MarcArray(iCurrent%).NextField
#If FldAddDebug = -1 Then
                If bDebug Then
                    Debug.Print str(iCurrent%) + " >" + sSortInstruction$ + "< >" + MarcArray(iCurrent%).SortInstruction + "< " + str(MarcArray(iCurrent%).Deleted)
                End If
#End If
                ' todo: 20050628: why do we take 'deleted' into account here?  don't all
                '   fields get sorted correctly, even if not present in the finished
                '   record? (but this will only be an issue if a program deletes a
                '   field, and then un-deletes it)
                If sSortInstruction$ < MarcArray(iCurrent%).SortInstruction And Not MarcArray(iCurrent%).Deleted Then
                    ' the new field goes above the 'current' field: we have found the field
                    '   in front of (or above) which the new field belongs
AddFieldAddInFront:
#If FldAddDebug = -1 Then
                    If bDebug Then
                        Debug.Print "Add " + sNewTag$ + " in front " + str(iPrevField%) + " " + str(iNextField%)
                    End If
#End If
                    If iPrevField% <> -1 Then
                        ' the new field was not added before the very first one: somewhere
                        '   else (at the middle; at the end)
                        ' the field-before-we're-adding-a-new-field
                        '   is here called the "newly next" field
                        If Not TestFieldOrder Or MakeNoChange Then
                            ' 20040610: if we want to change the order of fields but
                            '   we've been told not to, then don't; but remember for later
                            '   that fields are out of order
                            m_bFieldsOutOfOrder = True
                        Else
#If MarcRecordModifiedDebug = -1 Then
                            Debug.Print "MRM fld add"
#End If
                            m_bMarcRecordModified = True
                            iSaveNext% = MarcArray(iArrayElementForNewField%).NextField
                            iSavePrev% = MarcArray(iArrayElementForNewField%).PrevField
                            ' the new field's previous field is the newly next field's previous field
                            MarcArray(iArrayElementForNewField%).PrevField = iPrevField%
                            ' the newly next field's previous field is our new field
                            MarcArray(iCurrent%).PrevField = iArrayElementForNewField%
                            ' the field that preceded the field at which we stopped is now
                            '   followed by the new field
                            MarcArray(iPrevField%).NextField = iArrayElementForNewField%
                            ' the new field's next field is the pointer to the field
                            '   at which we've stopped
                            '   (more exactly, it's the field pointed to by the 'next' element
                            '   copied from the field that used to precede the newly next field--which
                            '   is of course the same as newly next field itself
                            MarcArray(iArrayElementForNewField%).NextField = iCurrent%
                            ' the next element of the field that formerly preceded the newly-added
                            '   field is set to the former new field's next element (which really
                            '   should be -1)
                            MarcArray(iSavePrev%).NextField = iSaveNext%
                            
FldAddFindNewLastField:
                            ' follow the chain through to find the proper "last field"
                            Do
#If FldAddDebug = -1 Then
                                If bDebug Then
                                    Debug.Print "Finding new next " + str(iCurrent%) + " into " + str(MarcArray(iCurrent%).NextField)
                                End If
#End If
                                If MarcArray(iCurrent%).NextField = -1 Then
                                    m_iLastField% = iCurrent%
                                    Exit Do
                                End If
                                ' 20050622: if, by accident, we have somehow or other
                                '   ended up with the 'next field' marker set to the
                                '   current array number, then we're going to pretend we're
                                '   at the end and hope for the best
                                ' NOTE that this does NOT fix the problem whereby we accidentally
                                '   end up with the 'next field' pointer set to the current
                                '   field; this is only a band-aid. we have treated not the
                                '   symptom, not found a cure
                                If MarcArray(iCurrent%).NextField = iCurrent% Then
                                    m_iLastField% = iCurrent%
                                    Exit Do
                                End If
                                
                                iCurrent% = MarcArray(iCurrent%).NextField
                            Loop
                        End If
                    Else
                        ' the new field needs to become the very first field
                        If Not TestFieldOrder Or MakeNoChange Then
                            m_bFieldsOutOfOrder = True
                        Else
#If MarcRecordModifiedDebug = -1 Then
                            Debug.Print "MRM fld add 2"
#End If
                            m_bMarcRecordModified = True
#If True Then
                            ' 20040921: appears to be something very wrong; let's try
                            '   this revised business
                            ' the formerly first field now has a previous field--our
                            '   new field
                            MarcArray(m_iFirstField%).PrevField = iArrayElementForNewField%
                            ' the new field has no previous field
                            MarcArray(iArrayElementForNewField%).PrevField = -1
                            ' the new field now has a next field--the formerly first field
                            MarcArray(iArrayElementForNewField%).NextField = m_iFirstField%
                            ' the new field is now the first field in the record
                            m_iFirstField% = iArrayElementForNewField%
                            ' m_ilastfield regains its original setting
                            m_iLastField% = iSaveLast%
                            ' the restored last field no longer has a next field
                            MarcArray(m_iLastField%).NextField = -1
#Else
                            MarcArray(iCurrent%).PrevField = -1
                            MarcArray(iArrayElementForNewField%).NextField = m_iFirstField%
                            m_iFirstField% = iCurrent%
#End If
                        End If
                    End If
                    Exit Do
                ElseIf sSortInstruction$ = MarcArray(iCurrent%).SortInstruction Then
#If FldAddDebug = -1 Then
                    Debug.Print str(bSortExtensionPresent) + " >" + sSortInstruction$ + "< >" + MarcArray(iCurrent%).SortInstruction + "< : >" + sSortInstructionExtension$ + "< >" + MarcArray(iCurrent%).SortInstructionExtension + "<"
#End If
                    If bSortExtensionPresent Then
                        If sSortInstructionExtension$ < MarcArray(iCurrent%).SortInstruction Then
                            ' sort signatures same; extension indicates that new field belongs
                            '   ahead of an existing one (for example, the 880 field was added before
                            '   the field to which it is paired ...)
                            'If MarcArray(iCurrent%).NextField = -1 Then
                            '    MarcArray(iCurrent%).NextField = iArrayElementForNewField%
                            'End If
                            'MarcArray(iArrayElementForNewField%).PrevField = iCurrent%
                            GoTo AddFieldAddInFront
                        End If
                    End If
                    ' the new field sorts in the same place as the
                    '   current field
                    If bForceToFirstPosition Then
                        ' we want to make the new field the first of its group
                        GoTo AddFieldAddInFront
                    'Else
                        ' same group, but not force to first: continue searching
                        '   until you either hit end of record or hit a sort instruction
                        '   that's higher than the new field's instruction; this will
                        '   cause the new field to be the last one in its group
                    End If
                'Else
                    ' the new field's sort signature is higher than then current
                    '   field's sort signature: continue
                End If
                
                ' if we have reached the end of the array without finding
                '   a proper home for the new field, then
                '   it's already set to be the LAST element in the array
                '   and we're done with it
                If iNextField% = -1 Then
                    Exit Do
                End If
                
                ' not having found the correct place for the new field
                '    yet, point to the next field and try again
                iCurrent% = iNextField%
            Loop
        End If ' 880 that we need to swap, or something else?
    End If

    ' now add each subfield to the field
    If bTextSupplied Then
#If FldAddDebug = -1 Then
        If bDebug Then
            Debug.Print "Ind before subfield text: >" + MarcArray(iArrayElementForNewField%).Ind + "<"
        End If
#End If
        'DigestSubfieldText MarcArray(iArrayElementForNewField%), sNewFieldText$
        DigestSubfieldText iArrayElementForNewField%, sNewFieldText$
#If FldAddDebug = -1 Then
        If bDebug Then
            Debug.Print "Ind after subfield text: >" + MarcArray(iArrayElementForNewField%).Ind + "<"
        End If
#End If
    End If
    
End Sub

Public Function TranslateDiacriticsIntoLabels(ByVal sText$) As String

    Dim iLen%
    
    Dim lPtr As Long
    
    ' 20071101: the action of this function is now reversed by TranslateLabelsIntoDiacritics
    ' 20071101: changed constants for markers
    
    If m_bUtf8 Then
        lPtr = Len(sText$)
        Do While lPtr > 1
            lPtr = MyMarcCharacter.Utf8CharFindFirstOctet(sText$, lPtr)
            MyMarcCharacter.Utf8Char = Mid(sText$, lPtr)
            Select Case MyMarcCharacter.Utf8Char
                Case "_"
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "underscore (spacing)" + prvsEndMarkerForDiacriticLabels$)
                Case "~"
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "tilde (spacing)" + prvsEndMarkerForDiacriticLabels$)
                Case "^"
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "circumflex (spacing)" + prvsEndMarkerForDiacriticLabels$)
                Case MarcAlif
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "alif" + prvsEndMarkerForDiacriticLabels$)
                Case MarcAyn
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "ayn" + prvsEndMarkerForDiacriticLabels$)
                Case MarcMiagkiiZnak
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "miagkii znak" + prvsEndMarkerForDiacriticLabels$)
                Case MarcTverdiiZnak
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "tverdii znak" + prvsEndMarkerForDiacriticLabels$)
                Case MarcDotMiddle
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "dot middle" + prvsEndMarkerForDiacriticLabels$)
                Case MarcFlat
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "flat" + prvsEndMarkerForDiacriticLabels$)
                Case MarcOHookUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "O hook" + prvsEndMarkerForDiacriticLabels$)
                Case MarcUHookUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "U hook" + prvsEndMarkerForDiacriticLabels$)
                Case MarcOSlashUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "O slash" + prvsEndMarkerForDiacriticLabels$)
                Case MarcLSlashUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "L slash" + prvsEndMarkerForDiacriticLabels$)
                Case MarcDSlashUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "D slash" + prvsEndMarkerForDiacriticLabels$)
                Case MarcThornUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "Thorn" + prvsEndMarkerForDiacriticLabels$)
                Case MarcAEUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "AE ligature" + prvsEndMarkerForDiacriticLabels$)
                Case MarcOEUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "OE ligature" + prvsEndMarkerForDiacriticLabels$)
                Case MarcLSlashLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "l slash" + prvsEndMarkerForDiacriticLabels$)
                Case MarcOSlashLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "o slash" + prvsEndMarkerForDiacriticLabels$)
                Case MarcDSlashLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "d slash" + prvsEndMarkerForDiacriticLabels$)
                Case MarcThornLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "thorn" + prvsEndMarkerForDiacriticLabels$)
                Case MarcAELower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "ae ligature" + prvsEndMarkerForDiacriticLabels$)
                Case MarcOELower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "oe ligature" + prvsEndMarkerForDiacriticLabels$)
                Case MarcIDotless
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "i without dot" + prvsEndMarkerForDiacriticLabels$)
                Case MarcBritishPound
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "pound sterling" + prvsEndMarkerForDiacriticLabels$)
                Case MarcEth
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "eth" + prvsEndMarkerForDiacriticLabels$)
                Case MarcOHookLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "o hook" + prvsEndMarkerForDiacriticLabels$)
                Case MarcUHookLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "u hook" + prvsEndMarkerForDiacriticLabels$)
                Case MarcDegree
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "degree" + prvsEndMarkerForDiacriticLabels$)
                Case MarcLScript
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "l script" + prvsEndMarkerForDiacriticLabels$)
                Case MarcSharp
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "sharp" + prvsEndMarkerForDiacriticLabels$)
                Case MarcQuestionInverted
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "? inverted" + prvsEndMarkerForDiacriticLabels$)
                Case MarcExclamationInverted
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "! inverted" + prvsEndMarkerForDiacriticLabels$)
                Case MarcQuestionPseudo ' e0
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "pseudo question" + prvsEndMarkerForDiacriticLabels$)
                Case MarcGrave
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "grave" + prvsEndMarkerForDiacriticLabels$)
                Case MarcAcute
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "acute" + prvsEndMarkerForDiacriticLabels$)
                Case MarcCircumflex
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "circumflex (non-spacing)" + prvsEndMarkerForDiacriticLabels$)
                Case MarcTilde
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "tilde (non-spacing)" + prvsEndMarkerForDiacriticLabels$)
                Case MarcMacron
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "macron" + prvsEndMarkerForDiacriticLabels$)
                Case MarcBreve
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "breve" + prvsEndMarkerForDiacriticLabels$)
                Case MarcDotAbove
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "dot above" + prvsEndMarkerForDiacriticLabels$)
                Case MarcUmlaut
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "umlaut" + prvsEndMarkerForDiacriticLabels$)
                Case MarcHacek
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "hacek" + prvsEndMarkerForDiacriticLabels$)
                Case MarcAngstrom
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "angstrom" + prvsEndMarkerForDiacriticLabels$)
                Case MarcLigatureLeft
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "ligature left half" + prvsEndMarkerForDiacriticLabels$)
                Case MarcLigatureRight
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "ligature right half" + prvsEndMarkerForDiacriticLabels$)
                Case MarcCommaHighOffCenter
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "high comma off-center" + prvsEndMarkerForDiacriticLabels$)
                Case MarcAcuteDouble
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "double acute" + prvsEndMarkerForDiacriticLabels$)
                Case MarcCandrabindu
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "candrabindu" + prvsEndMarkerForDiacriticLabels$)
                Case MarcCedilla
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "cedilla" + prvsEndMarkerForDiacriticLabels$)
                Case MarcHookRight
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "right hook" + prvsEndMarkerForDiacriticLabels$)
                Case MarcDotBelow
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "dot below" + prvsEndMarkerForDiacriticLabels$)
                Case MarcDotBelowDouble
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "double dot below" + prvsEndMarkerForDiacriticLabels$)
                Case MarcCircleBelow
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "circle below" + prvsEndMarkerForDiacriticLabels$)
                Case MarcUnderscoreDouble
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "double underscore" + prvsEndMarkerForDiacriticLabels$)
                Case MarcUnderscore
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "underscore (non-spacing)" + prvsEndMarkerForDiacriticLabels$)
                Case MarcHookLeft
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "left hook" + prvsEndMarkerForDiacriticLabels$)
                Case MarcCedillaRight
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "inverted cedilla" + prvsEndMarkerForDiacriticLabels$)
                Case MarcUpadhmaniya
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "upadhmaniya" + prvsEndMarkerForDiacriticLabels$)
                Case MarcTildeDoubleLeft
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "double tilde left half" + prvsEndMarkerForDiacriticLabels$)
                Case MarcTildeDoubleRight
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "double tilde right half" + prvsEndMarkerForDiacriticLabels$)
                Case MarcCommaHighCentered
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "high comma centered" + prvsEndMarkerForDiacriticLabels$)
                Case MarcRightToLeftMarker
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "RTL" + prvsEndMarkerForDiacriticLabels$)
                Case MarcLeftToRightMarker
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "LTR" + prvsEndMarkerForDiacriticLabels$)
                Case MarcLeftToRightEmbedding
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "LTRE" + prvsEndMarkerForDiacriticLabels$)
                Case MarcRightToLeftEmbedding
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "RTLE" + prvsEndMarkerForDiacriticLabels$)
                Case MarcPopDirectionalFormatting
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "PDF" + prvsEndMarkerForDiacriticLabels$)
                Case MarcLeftToRightOverride
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "LTRO" + prvsEndMarkerForDiacriticLabels$)
                Case MarcRightToLeftOverride
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "RTLO" + prvsEndMarkerForDiacriticLabels$)
            End Select
            lPtr = lPtr - 1
        Loop
    Else
        For lPtr = Len(sText$) To 1 Step -1
            Select Case Mid(sText$, lPtr, 1)
                Case "_"
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "underscore (spacing)" + prvsEndMarkerForDiacriticLabels$)
                Case "~"
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "tilde (spacing)" + prvsEndMarkerForDiacriticLabels$)
                Case "^"
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "circumflex (spacing)" + prvsEndMarkerForDiacriticLabels$)
                Case MarcAlif
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "alif" + prvsEndMarkerForDiacriticLabels$)
                Case MarcAyn
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "ayn" + prvsEndMarkerForDiacriticLabels$)
                Case MarcMiagkiiZnak
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "miagkii znak" + prvsEndMarkerForDiacriticLabels$)
                Case MarcTverdiiZnak
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "tverdii znak" + prvsEndMarkerForDiacriticLabels$)
                Case MarcDotMiddle
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "dot middle" + prvsEndMarkerForDiacriticLabels$)
                Case MarcFlat
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "flat" + prvsEndMarkerForDiacriticLabels$)
                Case MarcOHookUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "O hook" + prvsEndMarkerForDiacriticLabels$)
                Case MarcUHookUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "U hook" + prvsEndMarkerForDiacriticLabels$)
                Case MarcOSlashUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "O slash" + prvsEndMarkerForDiacriticLabels$)
                Case MarcLSlashUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "L slash" + prvsEndMarkerForDiacriticLabels$)
                Case MarcDSlashUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "D slash" + prvsEndMarkerForDiacriticLabels$)
                Case MarcThornUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "Thorn" + prvsEndMarkerForDiacriticLabels$)
                Case MarcAEUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "AE ligature" + prvsEndMarkerForDiacriticLabels$)
                Case MarcOEUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "OE ligature" + prvsEndMarkerForDiacriticLabels$)
                Case MarcLSlashLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "l slash" + prvsEndMarkerForDiacriticLabels$)
                Case MarcOSlashLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "o slash" + prvsEndMarkerForDiacriticLabels$)
                Case MarcDSlashLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "d slash" + prvsEndMarkerForDiacriticLabels$)
                Case MarcThornLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "thorn" + prvsEndMarkerForDiacriticLabels$)
                Case MarcAELower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "ae ligature" + prvsEndMarkerForDiacriticLabels$)
                Case MarcOELower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "oe ligature" + prvsEndMarkerForDiacriticLabels$)
                Case MarcIDotless
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "i without dot" + prvsEndMarkerForDiacriticLabels$)
                Case MarcBritishPound
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "pound sterling" + prvsEndMarkerForDiacriticLabels$)
                Case MarcEth
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "eth" + prvsEndMarkerForDiacriticLabels$)
                Case MarcOHookLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "o hook" + prvsEndMarkerForDiacriticLabels$)
                Case MarcUHookLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "u hook" + prvsEndMarkerForDiacriticLabels$)
                Case MarcDegree
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "degree" + prvsEndMarkerForDiacriticLabels$)
                Case MarcLScript
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "l script" + prvsEndMarkerForDiacriticLabels$)
                Case MarcSharp
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "sharp" + prvsEndMarkerForDiacriticLabels$)
                Case MarcQuestionInverted
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "? inverted" + prvsEndMarkerForDiacriticLabels$)
                Case MarcExclamationInverted
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "! inverted" + prvsEndMarkerForDiacriticLabels$)
                Case MarcQuestionPseudo ' e0
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "pseudo question" + prvsEndMarkerForDiacriticLabels$)
                Case MarcGrave
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "grave" + prvsEndMarkerForDiacriticLabels$)
                Case MarcAcute
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "acute" + prvsEndMarkerForDiacriticLabels$)
                Case MarcCircumflex
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "circumflex (non-spacing)" + prvsEndMarkerForDiacriticLabels$)
                Case MarcTilde
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "tilde (non-spacing)" + prvsEndMarkerForDiacriticLabels$)
                Case MarcMacron
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "macron" + prvsEndMarkerForDiacriticLabels$)
                Case MarcBreve
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "breve" + prvsEndMarkerForDiacriticLabels$)
                Case MarcDotAbove
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "dot above" + prvsEndMarkerForDiacriticLabels$)
                Case MarcUmlaut
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "umlaut" + prvsEndMarkerForDiacriticLabels$)
                Case MarcHacek
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "hacek" + prvsEndMarkerForDiacriticLabels$)
                Case MarcAngstrom
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "angstrom" + prvsEndMarkerForDiacriticLabels$)
                Case MarcLigatureLeft
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "ligature left half" + prvsEndMarkerForDiacriticLabels$)
                Case MarcLigatureRight
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "ligature right half" + prvsEndMarkerForDiacriticLabels$)
                Case MarcCommaHighOffCenter
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "high comma off-center" + prvsEndMarkerForDiacriticLabels$)
                Case MarcAcuteDouble
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "double acute" + prvsEndMarkerForDiacriticLabels$)
                Case MarcCandrabindu
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "candrabindu" + prvsEndMarkerForDiacriticLabels$)
                Case MarcCedilla
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "cedilla" + prvsEndMarkerForDiacriticLabels$)
                Case MarcHookRight
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "right hook" + prvsEndMarkerForDiacriticLabels$)
                Case MarcDotBelow
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "dot below" + prvsEndMarkerForDiacriticLabels$)
                Case MarcDotBelowDouble
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "double dot below" + prvsEndMarkerForDiacriticLabels$)
                Case MarcCircleBelow
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "circle below" + prvsEndMarkerForDiacriticLabels$)
                Case MarcUnderscoreDouble
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "double underscore" + prvsEndMarkerForDiacriticLabels$)
                Case MarcUnderscore
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "underscore (non-spacing)" + prvsEndMarkerForDiacriticLabels$)
                Case MarcHookLeft
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "left hook" + prvsEndMarkerForDiacriticLabels$)
                Case MarcCedillaRight
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "inverted cedilla" + prvsEndMarkerForDiacriticLabels$)
                Case MarcUpadhmaniya
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "upadhmaniya" + prvsEndMarkerForDiacriticLabels$)
                Case MarcTildeDoubleLeft
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "double tilde left half" + prvsEndMarkerForDiacriticLabels$)
                Case MarcTildeDoubleRight
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "double tilde right half" + prvsEndMarkerForDiacriticLabels$)
                Case MarcCommaHighCentered
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, prvsBeginMarkerForDiacriticLabels$ + "high comma centered" + prvsEndMarkerForDiacriticLabels$)
            End Select
        Next
    End If
    
    TranslateDiacriticsIntoLabels = sText$
    
End Function

Private Sub Class_Initialize()

    Dim sFill$
    
    Dim iPtr%
    
    gblsSortingIndicatorFor653Field$ = DefaultSortingIndicatorFor653Field$
    
    
    ' these two "subfield $y" pseudo-constants are used in
    '   converting a text-form subfield $y into the
    '   sorting equivalent
    ' in sort of a sideways manner, calculate the highest year allowed in either the
    '   beginning or the ending date
    prvsSubfieldYNineString$ = String(SUBFIELD_Y_DATE_SIZE%, "9") ' so for size of 4, we have "9999"
    prvlSubfieldYDateMaximum = Val(prvsSubfieldYNineString$) ' so for size of 4, we have 9999
    ' this is a string of zeros of the proper size
    prvsSubfieldYZeroString$ = String(SUBFIELD_Y_DATE_SIZE%, "0")
    
    ' 2006117: by default, do nothing at all with field order (this is a
    '   major change in policy, but in keeping with what we need to do elsewhere
    '   regarding the 880s: we don't want to change field order unless we've
    '   been told explicitly to do so)
    ClearFldOrder "A"
    SetFldOrder "A", "000", "999", SORTINSTRUCTION_LeaveOrderAlone%
    ClearFldOrder "B"
    SetFldOrder "B", "000", "999", SORTINSTRUCTION_LeaveOrderAlone%
    ClearFldOrder "H"
    SetFldOrder "H", "000", "999", SORTINSTRUCTION_LeaveOrderAlone%
    
    'Debug.Print "CLASS INITIALIZES"
    
    ' the following group are also exposed as read-only properties, in case the
    '   outside world wants them
    
    ' NOTE that we set default values for the field-order and
    '   subfield-order arrays only when we need 'em: when we discover that
    '   we don't have any information yet but we need something
    
    ' 20000124: add degree, pressing, copyright, sharp, inverted
    '   question and inverted exclamation to the mix
    ' these MARC character constants only apply to non-Unicode records; for
    '   records in UTF-8 encoding, everything stays just where it is
    ' NOTE that we do not yet know the OCLC values for
    '   degree, pressing, copyright, sharp, inverted question
    '   and inverted exclamation; in the absence of other
    '   information we are going to use the MARC values and
    '   hope for the best (these haven't been implemented by
    '   OCLC yet, so there's no damage yet)
    ' (these charcters are in OCLC's special character entry panel,
    '   but OCLC won't accept fields that contain them)

    CONST_Currency$ = "$" + Chr(185) ' B9=185=british pound
    CONST_Math$ = "+-=" + Chr(171) ' AB=171=plus/minus
    
    CONST_LowerCaseAlpha$ = "abcdefghijklmnopqrstuvwxyz"
    CONST_UpperCaseAlpha$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    
    OldUtf8Alif$ = Chr(202) + Chr(190)
    NewUtf8Alif$ = Chr(202) + Chr(188)
    
    '                                                                 S-hacek    OE         Z-hacek    Y=umlaut
    CONST_UpperCaseAlphaExtension$ = CONST_UpperCaseAlphaExtension$ + Chr(138) + Chr(140) + Chr(142) + Chr(159)
    '                                                                 s-hacek    oe         z-hacek    y-umlaut
    CONST_LowerCaseAlphaExtension$ = CONST_LowerCaseAlphaExtension$ + Chr(154) + Chr(156) + Chr(158) + Chr(255)
    
    '                                                                 A-grave    A-acute    A-chapeau  A-tilde    A-umlaut   A-angstrom AE
    CONST_UpperCaseAlphaExtension$ = CONST_UpperCaseAlphaExtension$ + Chr(192) + Chr(193) + Chr(194) + Chr(195) + Chr(196) + Chr(197) + Chr(198)
    '                                                                 a-grave    a-acute    a-chapeau  a-tilde    a-umlaut   a-angstrom ae
    CONST_LowerCaseAlphaExtension$ = CONST_LowerCaseAlphaExtension$ + Chr(224) + Chr(225) + Chr(226) + Chr(227) + Chr(228) + Chr(229) + Chr(230)
    
    '                                                                 C-cedilla  E-grave    E-acute    E-chapeau  E-umlaut   I-grave    I-acute    I-chapeau  I-umlaut
    CONST_UpperCaseAlphaExtension$ = CONST_UpperCaseAlphaExtension$ + Chr(199) + Chr(200) + Chr(201) + Chr(202) + Chr(203) + Chr(204) + Chr(205) + Chr(206) + Chr(207)
    '                                                                 c-cedilla  e-grave    e-acute    e-chapeau  e-umlaut   i-grave    i-acute    i-chapeau  i-umlaut
    CONST_LowerCaseAlphaExtension$ = CONST_LowerCaseAlphaExtension$ + Chr(231) + Chr(232) + Chr(233) + Chr(234) + Chr(235) + Chr(236) + Chr(237) + Chr(238) + Chr(239)
    
    '                                                                 D-bar      N-tilde    O-grave    O-acute    O-chapeau  O-tilde    O-umlaut   O-slash
    CONST_UpperCaseAlphaExtension$ = CONST_UpperCaseAlphaExtension$ + Chr(208) + Chr(209) + Chr(210) + Chr(211) + Chr(212) + Chr(213) + Chr(214) + Chr(216)
    '                                                                 eth        n-tilde    o-grave    o-acute    o-chapeau  o-tilde   o-umlaut    o-slash
    CONST_LowerCaseAlphaExtension$ = CONST_LowerCaseAlphaExtension$ + Chr(240) + Chr(241) + Chr(242) + Chr(243) + Chr(244) + Chr(245) + Chr(246) + Chr(248)
    
    '                                                                 U-grave    U-acute    U-chapeau  U-umlaut   Y-acute    Thorn
    CONST_UpperCaseAlphaExtension$ = CONST_UpperCaseAlphaExtension$ + Chr(217) + Chr(218) + Chr(219) + Chr(220) + Chr(221) + Chr(222)
    '                                                                 u-grave    u-acute    u-chapeau  u-umlaut   y-acute    thorn
    CONST_LowerCaseAlphaExtension$ = CONST_LowerCaseAlphaExtension$ + Chr(249) + Chr(250) + Chr(251) + Chr(252) + Chr(253) + Chr(254)


    GenericSlashL$ = Chr(161)
    GenericSlashO$ = Chr(162)
    GenericSlashD$ = Chr(163)
    GenericThorn$ = Chr(164)
    GenericAE$ = Chr(165)
    GenericOE$ = Chr(166)
    GenericHookO$ = Chr(172)
    genericHookU = Chr(173)
    GenericAlpha$ = Chr(175)
    GenericBeta$ = Chr(190)
    GenericGamma$ = Chr(191)
    GenericDegree$ = Chr(192)
    GenericScriptL$ = Chr(193)
    GenericPressing$ = Chr(194)
    GenericCopyright$ = Chr(195)
    GenericSharp$ = Chr(196)
    GenericInvertedQuestionMark$ = Chr(197)
    GenericInvertedExclamationMark$ = Chr(198)
    GenericSuperSubPlus$ = Chr(202)
    GenericSuperSubMinus$ = Chr(203)
    GenericSuperSubParensL$ = Chr(204)
    GenericSuperSubParensR$ = Chr(205)
    GenericCurly$ = "{"
    
    m_sQuote$ = Chr(34)
    
    AscGenericDegree% = Asc(GenericDegree)
    AscGenericPressing% = Asc(GenericPressing)
    AscGenericCopyright% = Asc(GenericCopyright)
    AscGenericSharp% = Asc(GenericSharp)
    AscGenericInvertedQuestionMark% = Asc(GenericInvertedQuestionMark)
    AscGenericInvertedExclamationMark% = Asc(GenericInvertedExclamationMark)
    
    AustralianSubdivisionPractice = False
    
    prvsSortExtensionMarker$ = Chr(31) + "6"
    
    ' these two MUST be parallel: upper- and lower-case equivalents must be in the
    '   same relative positions
    CONST_UpperEndLowerCase$ = Chr(177) + Chr(178) + Chr(179) + Chr(180) + Chr(181) + Chr(182) + Chr(188) + Chr(189)
    CONST_UpperEndUpperCase$ = Chr(161) + Chr(162) + Chr(163) + Chr(164) + Chr(165) + Chr(166) + Chr(172) + Chr(173)
    
    ' 20050222: there has been some question about the character used on screen for ayn; confirmed
    '   just now through direct experiment that it's chr(187)
    ' 20050614: although alpha, beta and gamma are listed here, we do not actually make
    '   the substitution indicated here for them, because these characters are currently
    '   not allowed in OCLC; see the following m_sVoyagerAllowsOclcDoesNot$ pseudo-constant
    '                   alpha      beta       gamma      super 1    super 2    super 3    super 4    super 5    super 6    super 7    super 8    super 9    super 0    super +    super -    super (    super )    sub 1      sub 2      sub 3      sub 4      sub 5      sub 6      sub 7      sub 8      sub 9      sub 0      sub +      sub -      sub (      sub )      script-l   delim      fill       ayn
    m_sOclcGreeksEtc$ = Chr(193) + Chr(194) + Chr(196) + Chr(145) + Chr(146) + Chr(147) + Chr(148) + Chr(149) + Chr(150) + Chr(151) + Chr(152) + Chr(153) + Chr(144) + Chr(157) + Chr(156) + Chr(154) + Chr(155) + Chr(129) + Chr(130) + Chr(131) + Chr(132) + Chr(133) + Chr(134) + Chr(135) + Chr(136) + Chr(137) + Chr(128) + Chr(140) + Chr(141) + Chr(138) + Chr(139) + Chr(190) + Chr(223) + Chr(252) ' + Chr(187)
    '                      alpha      beta       gamma      sub 1      sub 2      sub 3      sub 4      sub 5      sub 6      sub 7      sub 8      sub 9      sub 0      sub +      sub -      sub (      sub )      super 1    super 2     uper 3    super 4    super 5    super 6    super 7    super 8    super 9    super 0    super +    super -    super (    super )    script-l   delim           fill       ayn
    m_sVoyagerGreeksEtc$ = Chr(175) + Chr(190) + Chr(191) + Chr(209) + Chr(210) + Chr(211) + Chr(212) + Chr(213) + Chr(214) + Chr(215) + Chr(216) + Chr(217) + Chr(208) + Chr(218) + Chr(219) + Chr(220) + Chr(221) + Chr(193) + Chr(194) + Chr(195) + Chr(196) + Chr(197) + Chr(198) + Chr(199) + Chr(200) + Chr(201) + Chr(192) + Chr(202) + Chr(203) + Chr(204) + Chr(205) + Chr(160) + MarcDelimiter + MarcFill ' + MarcAyn
    
    ' 20050614: this string added, to provide "text" equivalents for characters that MARC
    '   allows but OCLC does not; we translated from the Voyager version of each character to
    '   something else
    '                              alpha                   beta                   gamma                   phonorecord         copyright           sharp             inverted ?        inverted !        degree (super 0)
    m_sVoyagerAllowsOclcDoesNot$ = Chr(175) + "[alpha] " + Chr(190) + "[beta] " + Chr(191) + "[gamma] " + Chr(146) + "(p) " + Chr(147) + "(c) " + Chr(148) + "# " + Chr(149) + "? " + Chr(150) + "! " + Chr(144) + Chr(128) + " "
    
    m_sAsciiMaximum$ = Chr(127)
    m_sAboveAsciiMinimum$ = Chr(128)
    m_sMarc8DiacriticsAboveHere$ = Chr(223)
    m_sOclcScreenDelim$ = Chr(223)
    
    MARC_BritishPound$ = Chr(185)
    MARC_Eth$ = Chr(186)
    MARC_Flat$ = Chr(169)

    'MarcEscape = Chr(27)
    
    MARC_Degree$ = Chr(192)
    Voyager_Degree$ = Chr(144)
    OCLC_Degree$ = Chr(192)
    
    MARC_ScriptL$ = Chr(193)
    OCLC_ScriptL$ = Chr(190)
    Voyager_ScriptL$ = Chr(160)
    
    MARC_Pressing$ = Chr(194)
    Voyager_Pressing$ = Chr(146)
    OCLC_Pressing$ = Chr(194)
    
    MARC_Copyright$ = Chr(195)
    Voyager_Copyright$ = Chr(147)
    OCLC_Copyright$ = Chr(195)
    
    MARC_Sharp$ = Chr(196)
    Voyager_Sharp$ = Chr(148)
    OCLC_Sharp$ = Chr(196)
    
    MARC_InvertedQuestion$ = Chr(197)
    Voyager_InvertedQuestion$ = Chr(149)
    OCLC_InvertedQuestion$ = Chr(197)
    
    MARC_InvertedExclamation$ = Chr(198)
    Voyager_InvertedExclamation$ = Chr(150)
    OCLC_InvertedExclamation$ = Chr(198)
    
    ' the dagger, logical or and logical not appear to be
    '   Voyager inventions to make LC happy; they don't
    '   have an equivalent in MARC or OCLC
    
    MARC_Dagger$ = "[dagger]"
    Voyager_Dagger$ = Chr(187)
    OCLC_Dagger$ = "[dagger]"
    
    MARC_LogicalOr$ = "[logical 'or' symbol]"
    Voyager_LogicalOr$ = Chr(1)
    OCLC_LogicalOr$ = "[logical 'or' symbol]"
    
    MARC_LogicalNot$ = "[logical 'not' symbol]"
    Voyager_LogicalNot$ = Chr(1)
    OCLC_LogicalNot$ = "[logical 'not' symbol]"
    
    CharacterSetIn = CHARACTERSET_Voyager$
    m_sDeclaredCharacterSetIn$ = CHARACTERSET_Voyager$
    CharacterSetOut = CHARACTERSET_Voyager$
    
    m_sRecordFormat$ = "B"
    m_sLocal5$ = Chr(31) + "5---"
    
    NormalizationScheme = "V"
    m_sDefaultCharacterSet$ = "V"
    
    ' 20021114: order of +-() changed to conform to character order within Voyager
    'Voyager_Subscripts$ = Chr(192) + Chr(193) + Chr(194) + Chr(195) + Chr(196) + Chr(197)
    Voyager_Greek$ = Chr(175) + Chr(190) + Chr(191)
    Voyager_Superscripts$ = Chr(192) + Chr(193) + Chr(194) + Chr(195) + Chr(196) + Chr(197) + Chr(198) + Chr(199) + Chr(200) + Chr(201) + Chr(202) + Chr(203) + Chr(204) + Chr(205)
    Voyager_Subscripts$ = Chr(208) + Chr(209) + Chr(210) + Chr(211) + Chr(212) + Chr(213) + Chr(214) + Chr(215) + Chr(216) + Chr(217) + Chr(218) + Chr(219) + Chr(220) + Chr(221)
    
    ' it's entirely possible that the default 008 fields will need to be adjusted from
    '   time to time
    
    sFill$ = MyMarcCharacter.MarcFill
    
    ' we'll set the date into the default 008 fields when we create each record
    '                                         1         2                      3
    '                  0123456    7         89012345678901234567    8         90123456789
    m_sDefault008A$ = "000000n" + sFill$ + " aaannaabn          " + sFill$ + "n ana     d"
    
    '                            1         2         3
    '                  0123456789012345678901234567890123456789
    m_sDefault008B$ = "000000n                      000 0     d"
    
    '                            1         2                      3
    '                  01234567890123456789012345    6         7890123456789
    m_sDefault008D$ = "000000n                   " + sFill$ + "   000 0    d"
    
    '                            1                             2                  3
    '                  012345678901234567    8        9        0         123456789012    3         456789
    m_sDefault008F$ = "000000n           " + sFill$ + sFill$ + sFill$ + "            " + sFill$ + "     d"
        
    ' 20070306: per David Bucknum, change default value of 008/06 from invalid 'u' to '0' (unknown)
    ' 20070306: per David Bucknum, change default value of 008/05 (part 0f 008/00-05)
    '   from incorrect '2' '0' (this has no real meaning, as the real date gets inserted)
    '                            1         2         3
    '                  01234567890123456789012345678901
    m_sDefault008H$ = "0000000u    8   1001uu   0000000"
    
    '                            1                             2                  3
    '                  012345678901234567    8        9        0         1234567890123456789
    m_sDefault008M$ = "000000n           " + sFill$ + sFill$ + sFill$ + "                  d"
    
    '                            1         2                      3
    '                  0123456789012345678901234    5         67890123456789
    m_sDefault008P$ = "000000n                  " + sFill$ + "     0       d"
    
    '                            1
    '                  01234567890123
    m_sDefault008Q$ = "000000aaaaaaaa"
    
    '                            1                      2         3
    '                  0123456789012345678    9         01234567890123456789
    m_sDefault008S$ = "000000n            " + sFill$ + "         0         d"
    
    ' we'll set *both* dates when we create the record
    '                            1         2         3
    '                  01234567890123456789012345678901
    m_sDefault008U$ = "0000000u    0   1001aa   0000000"
    
    '                            1
    '                  012345678901234
    m_sDefault008W$ = "000000uuuuuuunk"
    
    ' additional positions in the leader are supplied at the time of record creation; it is
    '  not likely that categorical modifications will be necessary
    '                              1         2
    '                    012345678901234567890123
    m_sDefaultLeader$ = "00000n    2200000n  4500"
    
    With MyMarcCharacter
        ' 20050315: Marc8DiacriticsAbove and Marc8DiacriticsBelow and
        '   their Unicode parallels no longer play any
        '   direct role in the translation of diacritics; but they are still used as
        '   convenient tests for diacritic-ness, so we'll leave them alone
        ' the pseudo-constants Marc8Diacritics and Utf8Diacritics are now used
        '   in the Unicode/MARC8 conversion
        Marc8DiacriticsAbove$ = .Marc8Acute + .Marc8AcuteDouble + .Marc8Angstrom + .Marc8Breve + .Marc8Candrabindu + .Marc8Circumflex + .Marc8CommaHighCentered + .Marc8CommaHighOffCenter + .Marc8DotAbove + .Marc8Grave + .Marc8Hacek + .Marc8LigatureLeft + .Marc8LigatureRight + .Marc8Macron + .Marc8QuestionPseudo + .Marc8Tilde + .Marc8TildeDoubleLeft + .Marc8TildeDoubleRight + .Marc8Umlaut
        ' 20040714: dot middle is no longer considered a diacritic
        'Marc8DiacriticsOther$ = .Marc8Cedilla + .Marc8CedillaRight + .Marc8CircleBelow + .Marc8DotBelow + .Marc8DotBelowDouble + .Marc8DotMiddle + .Marc8HookLeft + .Marc8HookRight + .Marc8Underscore + .Marc8UnderscoreDouble + .Marc8Upadhmaniya
        Marc8DiacriticsOther$ = .Marc8Cedilla + .Marc8CedillaRight + .Marc8CircleBelow + .Marc8DotBelow + .Marc8DotBelowDouble + .Marc8HookLeft + .Marc8HookRight + .Marc8Underscore + .Marc8UnderscoreDouble + .Marc8Upadhmaniya
        ' 20061012: 0342, 0343, 0344 (used in Greek) added to diacritics agove
        UTF8DiacriticsAbove$ = .Utf8Acute + .Utf8AcuteDouble + .Utf8Angstrom + .Utf8Breve + .Utf8Candrabindu + .Utf8Circumflex + .Utf8CommaHighCentered + .Utf8CommaHighOffCenter + .Utf8DotAbove + .Utf8Grave + .Utf8Hacek + .Utf8LigatureLeft + .Utf8LigatureRight + .Utf8Macron + .Utf8QuestionPseudo + .Utf8Tilde + .Utf8TildeDoubleLeft + .Utf8TildeDoubleRight + .Utf8Umlaut + .UcsHex2Utf8("0342") + .UcsHex2Utf8("0343") + .UcsHex2Utf8("0344")
        'Utf8DiacriticsOther$ = .Utf8Cedilla + .Utf8CedillaRight + .Utf8CircleBelow + .Utf8DotBelow + .Utf8DotBelowDouble + .Utf8DotMiddle + .Utf8HookLeft + .Utf8HookRight + .Utf8Underscore + .Utf8UnderscoreDouble + .Utf8Upadhmaniya
        ' 20061012: 0344 added (greek)
        Utf8DiacriticsOther$ = .Utf8Cedilla + .Utf8CedillaRight + .Utf8CircleBelow + .Utf8DotBelow + .Utf8DotBelowDouble + .Utf8HookLeft + .Utf8HookRight + .Utf8Underscore + .Utf8UnderscoreDouble + .Utf8Upadhmaniya + .UcsHex2Utf8("0345")
        
        ' 20050314: alternative handling for diacritic ordering, taking into account the
        '   Unicode combining classes
        ' these will eventuall make obsolete the pseudo-constants Marc8DiacriticsAbove,
        '   Marc8DiacriticsOther and their Utf8 parallels
        ' NOTE that we're only worried here about diacritics that are part of the MARC-8
        '   character set, used in non-880 contexts, and in the "plain text" parts of
        '   880s
        ' diacritics used in the fancy parts of 880 fields are on their own!
        ' diacritics used with non-roman alphabets are on their own!
        ' the two strings constitute tables of diacritics, in units of 4 or 6 characters:
        '   1 or more characters for each diacritic (MARC 8 values are
        '     1 byte long; Utf8 values are 2-3 bytes long
        '   3 characters for the character representation of the diacritic's
        '      Unicode combining class
        ' the offset and length of the diacritic (which is known) gives us the starting
        '   point for the combining class code
        
        ' for output we sort these by class number, in ascending order
        ' for translating from/into unicode, we reverse the order
        '   of items in class 230
        ' class 202: attached below
        ' class 220: below
        ' class 230: above
        ' class 232: above right
        
        '                   E0/224                         E1/225                E2/226
        Marc8Diacritics$ = .Marc8QuestionPseudo + "230" + .Marc8Grave + "230" + .Marc8Acute + "230"
        '                                      E3/227                     E4/228                E5/229
        Marc8Diacritics$ = Marc8Diacritics$ + .Marc8Circumflex + "230" + .Marc8Tilde + "230" + .Marc8Macron + "230"
        '                                      E6/230                E7/231                   E8/232
        Marc8Diacritics$ = Marc8Diacritics$ + .Marc8Breve + "230" + .Marc8DotAbove + "230" + .Marc8Umlaut + "230"
        '                                      E9/233                EA/234                   EB/235                       EC/236
        Marc8Diacritics$ = Marc8Diacritics$ + .Marc8Hacek + "230" + .Marc8Angstrom + "230" + .Marc8LigatureLeft + "230" + .Marc8LigatureRight + "230"
        '                                      ED/237                             EE/238                      EF/239
        Marc8Diacritics$ = Marc8Diacritics$ + .Marc8CommaHighOffCenter + "232" + .Marc8AcuteDouble + "230" + .Marc8Candrabindu + "230"
        '                                      F0/240                  F1/241                    F2/242
        Marc8Diacritics$ = Marc8Diacritics$ + .Marc8Cedilla + "202" + .Marc8HookRight + "202" + .Marc8DotBelow + "220"
        '                                      F3/243                         F4/244                              F5/245
        Marc8Diacritics$ = Marc8Diacritics$ + .Marc8DotBelowDouble + "220" + .Marc8CircleBelow + "220" + .Marc8UnderscoreDouble + "220"
        '                                      F6/246                     F7/247                   F8/248
        Marc8Diacritics$ = Marc8Diacritics$ + .Marc8Underscore + "220" + .Marc8HookLeft + "220" + .Marc8CedillaRight + "220"
        '                                      F9/249                      FA/250                          FB/251
        Marc8Diacritics$ = Marc8Diacritics$ + .Marc8Upadhmaniya + "220" + .Marc8TildeDoubleLeft + "220" + .Marc8TildeDoubleRight + "220"
        '                                      FC/252, FD/253 not defined
        '                                      FE/254
        Marc8Diacritics$ = Marc8Diacritics$ + .Marc8CommaHighCentered + "230"
        '                                      FF/255 not defined
        
        
        '                   0309                         0300                 0301
        Utf8Diacritics$ = .Utf8QuestionPseudo + "230" + .Utf8Grave + "230" + .Utf8Acute + "230"
        '                                    0302                      0303                 0304
        Utf8Diacritics$ = Utf8Diacritics$ + .Utf8Circumflex + "230" + .Utf8Tilde + "230" + .Utf8Macron + "230"
        '                                    0306                 0307                    0308
        Utf8Diacritics$ = Utf8Diacritics$ + .Utf8Breve + "230" + .Utf8DotAbove + "230" + .Utf8Umlaut + "230"
        '                                    030C                 030A                    FE20                        FE21
        Utf8Diacritics$ = Utf8Diacritics$ + .Utf8Hacek + "230" + .Utf8Angstrom + "230" + .Utf8LigatureLeft + "230" + .Utf8LigatureRight + "230"
        '                                    0315                              030B                       0310
        Utf8Diacritics$ = Utf8Diacritics$ + .Utf8CommaHighOffCenter + "232" + .Utf8AcuteDouble + "230" + .Utf8Candrabindu + "230"
        '                                    0327                   0328                     0323
        Utf8Diacritics$ = Utf8Diacritics$ + .Utf8Cedilla + "202" + .Utf8HookRight + "202" + .Utf8DotBelow + "220"
        '                                    0324                          0325                       0333
        Utf8Diacritics$ = Utf8Diacritics$ + .Utf8DotBelowDouble + "220" + .Utf8CircleBelow + "220" + .Utf8UnderscoreDouble + "220"
        '                                    0332                      0326                    031C
        Utf8Diacritics$ = Utf8Diacritics$ + .Utf8Underscore + "220" + .Utf8HookLeft + "220" + .Utf8CedillaRight + "220"
        '                                    032E                       FE22                           FE23
        Utf8Diacritics$ = Utf8Diacritics$ + .Utf8Upadhmaniya + "220" + .Utf8TildeDoubleLeft + "220" + .Utf8TildeDoubleRight + "220"
        '                                    0313
        Utf8Diacritics$ = Utf8Diacritics$ + .Utf8CommaHighCentered + "230"
        
        ' 20061012: greeks added; we're guessing at the combining classes
        Utf8Diacritics$ = Utf8Diacritics$ + .UcsHex2Utf8("0342") + "230" + .UcsHex2Utf8("0343") + "230" + .UcsHex2Utf8("0344") + "230" + .UcsHex2Utf8("0345") + "220"
        
    End With
    
    ReadValidationConfiguration
    
End Sub

Public Sub NewRecord(ByVal sRecordType$, Optional ByVal sBibliographicLevel$ = "m")

    ' UTF-8 safe: none of the manipulation done here involves multi-octet characters
    
    Dim iCtr%, iPrev%
    Dim s008$, sCharacterEncoding$, s005$, sYyyyMmDd$
    
    'Debug.Print "New.  UTF8? " + str(m_bUtf8)
    
    m_sMarcIn$ = ""
    m_bNewRecord = True
    
    ' todo: why aren't other things also reset to their
    '   ground states?
    m_bFldOrderChanged = False
    m_bSfdOrderChanged = False
    
    
    'Debug.Print "NEW RECORD"
    
    ' in all cases, classification holdings and authority records have no bib level!
    If InStr("wuvxyz", sRecordType$) > 0 Then
         sBibliographicLevel$ = " "
    End If
    
    'Debug.Print "New.  UTF8? " + str(m_bUtf8)
    If m_bUtf8 Then
        sCharacterEncoding$ = "a"
    Else
        sCharacterEncoding$ = " "
    End If
    
    m_iFirstField = -1
    m_iLastField = -1
    ReDim MarcArray(0)
    m_i008Ptr% = -1
    m_iMarcCtr = 0
    
    ' the leader is an "exposed" field independent of the variable fields
    m_sLeader$ = m_sDefaultLeader$
    ChangeLeaderValue 6, sRecordType$
    ' NOTE that earlier on, we set bibliographic level to blank if we're in
    '   a format that doesn't actually use this byte for anything; so it's at worst harmless
    '   and perhaps even desirable if we call ChangeLeaderValue for byte 07
    ChangeLeaderValue 7, sBibliographicLevel$
    ChangeLeaderValue 9, sCharacterEncoding$
    
    m_sRecordFormat$ = SetFormatCode() ' based on m_sLeader, which we've just fixed up
    
    Select Case m_sRecordFormat$
        Case "A"
            If gbliFieldOrderAuthLast% = 0 Then
                SetDefaultFldOrderAuth
            Else
                TestLastFieldOrderRule gblaFieldOrderAuth(), gbliFieldOrderAuthLast%, gbliFieldOrderAuthMax%
            End If
        Case "B", "D", "F", "M", "P", "S", "U"
            If gbliFieldOrderBibLast% = 0 Then
                SetDefaultFldOrderBib
            Else
                TestLastFieldOrderRule gblaFieldOrderBib(), gbliFieldOrderBibLast%, gbliFieldOrderBibMax%
            End If
        Case "H"
            If gbliFieldOrderHoldLast% = 0 Then
                SetDefaultFldOrderHold
            Else
                TestLastFieldOrderRule gblaFieldOrderHold(), gbliFieldOrderHoldLast%, gbliFieldOrderHoldMax%
            End If
        Case Else
            If gbliFieldOrderOtherLast% = 0 Then
                SetDefaultFldOrderOther
            Else
                TestLastFieldOrderRule gblaFieldOrderOther(), gbliFieldOrderOtherLast%, gbliFieldOrderOtherMax%
            End If
    End Select
    
    FldAdd "005", "", Format$(Now, "yyyymmddhhnnss") + ".0"
    sYyyyMmDd$ = Mid(FldText, 3, 6)
    
    ' in all records set the date of creation to the current date
    FldAdd "008", "", Default008(m_sRecordFormat$, sYyyyMmDd$)
    
    ' in holdings records, set the 'date of report' also to the current date
    If m_sRecordFormat$ = "H" Then
        Change008Value 26, sYyyyMmDd$
    End If
    
End Sub

Public Property Get Nuc() As String

    'Debug.Print "Getting NUC: >" + m_sNuc$ + "<"
    Nuc = m_sNuc

End Property

Public Property Let Nuc(ByVal vNewValue As String)

    m_sNuc$ = RemoveRepeatedCharacters(Trim(vNewValue), " ")

    If Len(m_sNuc$) > 0 Then
        m_sLocalNucString$ = Chr(31) + "5" + ReplaceCharacters(vNewValue, " ", " " + Chr(31) + "5")
        m_sLocal5$ = Chr(31) + "5" + vNewValue
    End If
    
    'Debug.Print "Set NUC: >" + m_sNuc$ + "< >" + m_sLocal5$ + "< >" + m_sLocalNucString$ + "<"
    
End Property

Public Function Get008Value(ByVal Marc008Position As Integer, ByVal Marc008Length As Integer) As String

    Dim s008$
    
    ' remember that the "position" being requested is the MARC format's
    '   zero-based value, so we have to remember to increment the
    '   position number by one to make it work in the program's one-based world
    
    On Error GoTo G008VGetError
    'Debug.Print "Arrival with " + str(m_i008Ptr%)
    'Debug.Print "Looking for 008 value " + str(m_i008Ptr%) + " limit " + str(UBound(MarcArray()))
    'Debug.Print "First subfield " + str(MarcArray(m_i008Ptr%).FirstSubfield) + " " + str(LBound(MarcArray(m_i008Ptr%).Subfield())) + " " + str(UBound(MarcArray(m_i008Ptr%).Subfield()))
    If m_i008Ptr% > -1 And Marc008Position > -1 And Marc008Length > 0 And (Marc008Position + Marc008Length < 41) Then
        s008$ = MarcArray(m_i008Ptr%).Subfield(MarcArray(m_i008Ptr%).FirstSubfield).Text
        Get008Value = Mid(s008$, Marc008Position + 1, Marc008Length) ' mid ok
    Else
        Get008Value = ""
    End If
    
G008VGetErrorResume:

    On Error GoTo 0
    Exit Function
    
G008VGetError:

    Get008Value = Space(Marc008Length)
    Resume G008VGetErrorResume
    
End Function

Public Sub Change008Value(ByVal iStartingPosition%, ByVal sNew008Value$)

    ' utf-8 safe: only single-octet values allowed
    
    Dim iLen%, iMarc008Position%
        
    ' remember that the "position" being requested is the MARC format's
    '   zero-based value, so we have to remember to increment the
    '   position number by one to make it work in the program's one-based world    iMarc008Position% = Val(Mid(MARC008Valu, 1, 2)) + 1
    iMarc008Position% = iStartingPosition% + 1 ' mid ok
    
    'If iMarc008Position% = 0 Then
        ' 20040828: this clause was formerly empty, now it's commented out
        ' we're now out this clause because we want to be clear about
        '   our intentions: we need now to be able
        '   to shift the date of record creation to make possible the
        '   reporting of all obsolete content designation by the validation
        '   DLL, which depends on 008/00-05
    'End If
    
    iLen = Len(sNew008Value$)
    If m_i008Ptr% > -1 Then
        If iLen% + iMarc008Position > 41 Or iLen% = 0 Or iMarc008Position > 40 Then
            Exit Sub
        End If
        ' since this is a control field, we don't need to do the formality of
        '   doing a 'reset' of the field
        MarcArray(m_i008Ptr%).Subfield(MarcArray(m_i008Ptr%).FirstSubfield).Text = SafeStuff(MarcArray(m_i008Ptr%).Subfield(MarcArray(m_i008Ptr%).FirstSubfield).Text, iMarc008Position%, iLen%, sNew008Value$)
        MarcArray(m_i008Ptr%).Changed = True
    End If
    
End Sub

Private Sub DigestRecord()

    ' we have successfully received a MARC record from the
    '   outside word, and the outside world wants us to
    '   convert the record into our tabular format
    
    ' 20030702: routine now adjusts itself for unexpected (MARC but not MARC21) values
    '   in leader/22 and leader/23 (this is just to be fancy)
    ' however, we do not (yet!) adjust our behavior based on the values of
    '   indicator count and subfield code count
    
    Dim lBad As Long, lStart As Long, lLength As Long, lDirPtr As Long
    Dim lFldPointerBefore As Long
    
    Dim iControl%, iDirectoryInterval%, iLengthOfLengthPortion%, iLengthOfOffsetPortion%
    Dim iOffsetOfOffsetPortion%
    
    Dim sTag$, sInd$, sField$, sDirectoryElement$
    
    Const iLengthOfTagPortion% = 3 ' this never varies in any recognizable MARC record
    
        
    
    ' get base address of data, subtract 25, and
    '   divide by 12 to determine number of variable
    '   fields in the record
    lBad = (Val(Mid(m_sLeader$, 13, 5)) - 25) / 12 ' mid ok
    
    iLengthOfLengthPortion% = 4 ' Val(Mid(m_sLeader$, 23, 1)) ' leader/22
    iLengthOfOffsetPortion% = 5 ' Val(Mid(m_sLeader$, 24, 1)) ' leader/23
    
    iDirectoryInterval% = iLengthOfTagPortion% + iLengthOfLengthPortion% + iLengthOfOffsetPortion%  ' will be 12 for standard MARC records
    iOffsetOfOffsetPortion% = iLengthOfTagPortion% + iLengthOfLengthPortion%  ' will be 7 for standard MARC records
    
    m_iFirstField = -1
    m_iLastField = -1
    ReDim MarcArray(0)
    m_iMarcCtr = 0
    
    gblbInitialDigestion = True
    
    ' add each field in the raw record to the array of fields
    For lDirPtr = 1 To Len(m_sDirectory$) Step iDirectoryInterval%
        sDirectoryElement$ = Mid(m_sDirectory$, lDirPtr, iDirectoryInterval%)
        sTag$ = Mid(m_sDirectory$, lDirPtr, iLengthOfTagPortion%)  ' mid ok
        lLength = Val(Mid(m_sDirectory$, lDirPtr + iLengthOfTagPortion%, iLengthOfLengthPortion%)) - 1  ' note that we trim the EOF here ' mid ok
        ' note that we increment starting position by one, because
        '   VB 6 is one-based, not zero-based
        lStart = Val(Mid(m_sDirectory$, lDirPtr + iOffsetOfOffsetPortion%, iLengthOfOffsetPortion%)) + 1 ' mid ok
        If lLength < 1 Then
            'Debug.Print "Less than one"
        Else
            sField$ = Mid(m_sFields$, lStart, lLength) ' mid ok
#If DigestRecordDebug = -1 Then
            Debug.Print "DR: " + sTag$ + ":" + Mid(sField$, 1, 2) + ":" + Mid(sField$, 3)
            Debug.Print vbTab + CharToHex(Mid(sField$, 3))
#End If
            lFldPointerBefore = FldPointer
            If Mid(sTag$, 1, 2) <> "00" Then ' mid ok
                FldAdd sTag$, Mid(sField$, 1, 2), Mid(sField$, 3) ' mid ok
            Else
                FldAdd sTag$, "", sField$
                If sTag$ = "008" Then
                    m_i008Length% = Len(sField$) ' len ok: need number of octets (and it's never Unicode anyway)
                End If
            End If
            ' 20060221: we're only going to modify the array further if we actually added
            '   a field
            ' this was occasioned by a bib record whose first directory element bore
            '   the tag "0 4"; this tag was rejected by FldAdd, so FldPointer remained
            '   at its ground value of -1, which of course caused an explosion
            '   here
            ' the best solution is not to modify the array unless we actually added a field, which
            '   we do now by keeping track of the highest array element before and after the
            '   attempt to add the field
            If lFldPointerBefore <> FldPointer Then
                MarcArray(FldPointer).Directory = sDirectoryElement$
            End If
        End If
    Next ' lDirPtr
    
    gblbInitialDigestion = False

End Sub

Public Property Get Leader() As String

    Leader = m_sLeader$
    
End Property

Public Property Let Leader(ByVal vNewValue As String)

    ' 20040503: "Let" added for use by the fixed-field editor and ValidIt, which
    '   seem to need to be able to insert the entire leader all at once;
    '   this is not normally by done by containers, though
    
    ' the supplied leader must contain at least 24 characters!
    If Len(vNewValue) < 24 Then
        Exit Property
    End If
    
    'Debug.Print "LEADER >" + vNewValue + "<"
    
    ' we are, however, ONLY going to allow the overlay
    '   of certain parts of the leader
    ChangeLeaderValue 5, Mid(vNewValue, 6, 1) ' 000/05: record status (6th char)
    ChangeLeaderValue 6, Mid(vNewValue, 7, 1) ' 000/06: type of record (7th char)
    ChangeLeaderValue 7, Mid(vNewValue, 8, 1) ' 000/07: [bibliographic level] (8th char)
    ChangeLeaderValue 8, Mid(vNewValue, 9, 1) ' 000/08: [type of control] (9th char)
    ChangeLeaderValue 9, Mid(vNewValue, 10, 1) ' 000/09: character encoding scheme (10th char)
    
    ChangeLeaderValue 17, Mid(vNewValue, 18, 1) ' 000/17: encoding level (18th char)
    ChangeLeaderValue 18, Mid(vNewValue, 19, 1) ' 000/18: descriptive cataloging form (19th char)
    ChangeLeaderValue 19, Mid(vNewValue, 20, 1) ' 000/19: linked record requirement (20th char)
        
    'Debug.Print "END LEADER"
    
    m_sLeader$ = vNewValue

End Property


Public Function NormalizeWholeField(ByVal sNormalizationScheme$, ByVal sMarcFormat$, ByVal sTag$, ByVal sIndicators$, ByVal sInputText$, Optional ByRef sReturnedSubfieldsOfInterestButNotNormalized$) As String

    Dim sInput$, sOutput$, schr$, sSfc$, sSfd$, sNextSfc$
    Dim sSubfieldsOfInterest$, sSaveScheme$
    
    Dim iPtr%, iRc%
    
    Dim bPCC As Boolean
    
    
#If NormalizeWholeFieldDebug = -1 Then
    Debug.Print "NWF entry: " + sMarcFormat$ + " " + sTag$ + ":" + sIndicators$ + ":" + sInputText$
#End If
    
    sSaveScheme$ = NormalizationScheme
    If sNormalizationScheme$ = NORMALIZATIONSCHEME_Pcc$ Then
        NormalizationScheme = NORMALIZATIONSCHEME_Pcc$
        bPCC = True
    Else
        NormalizationScheme = NORMALIZATIONSCHEME_Voyager$
    End If
   
    sSubfieldsOfInterest$ = ListSubfieldsForNormalization(sMarcFormat$, sTag$)
    
    sReturnedSubfieldsOfInterestButNotNormalized$ = ""
    
#If NormalizeWholeFieldDebug = -1 Then
    Debug.Print "Interesting: " + sTag$ + " " + sSubfieldsOfInterest$
#End If
    
    ' make a copy of the input text (not strictly necessary)
    sInput$ = sInputText$
    ' we will start with subfield $a
    ' if none, we'll start with whatever we have and assume it starts with $a
    iPtr% = InStr(sInput$, MyMarcCharacter.MarcDelimiter + "a")
    If iPtr% > 0 Then
        sInput$ = Trim(Mid(sInput$, iPtr% + 2)) ' mid ok
    End If
    sSfc$ = "a"
    
    Do ' for each subfield in the string
        iRc% = InStr(sInput$, MyMarcCharacter.MarcDelimiter)
        Select Case iRc%
            Case 0 ' this is the last subfield
                sSfd$ = Trim(sInput$)
                sInput$ = ""
            Case 1 ' current subfield is empty; set pointers and continue
                sNextSfc$ = Mid(sInput$, 2, 1)
                sInput$ = Trim(Mid(sInput$, 3))
                GoTo NormalizeWholeFieldNextSubfield
            Case Else ' delimiter somewhere in the middle of the field
                sSfd$ = Trim(Mid(sInput$, 1, iRc% - 1))
                sNextSfc$ = Mid(sInput$, iRc% + 1, 1)
                sInput$ = Mid(sInput$, iRc% + 2)
        End Select
#If NormalizeWholeFieldDebug = -1 Then
        Debug.Print "At top of loop: >" + sOutput$ + "< >" + sSfc$ + "< >" + sSfd$ + "< >" + sInput$ + "< >" + NormString(sSfd$) + "<"
#End If
        If InStr(sSubfieldsOfInterest$, sSfc$) > 0 Then
            If sSfc$ = "a" Then
                ' OK for nonfiling zone, too
                sSfd$ = RemoveNonfilingCharacters(sMarcFormat$, sTag$, sIndicators$, sSfd$)
                sReturnedSubfieldsOfInterestButNotNormalized$ = sReturnedSubfieldsOfInterestButNotNormalized$ + MyMarcCharacter.MarcDelimiter + "a" + sSfd$
#If NormalizeWholeFieldDebug = -1 Then
                Debug.Print "Nonfiling: >" + sSfd$ + "<"
#End If
                If bPCC Then
                    sOutput$ = sOutput$ + MyMarcCharacter.MarcDelimiter + "a"
                    iPtr% = InStr(sSfd$, ",")
                    If iPtr > 0 And iPtr% < Len(sSfd$) Then
                        sOutput$ = sOutput$ + NormString(Mid(sSfd$, 1, iPtr% - 1)) + ", " + NormString(Mid(sSfd$, iPtr% + 1))
                    Else
                        sOutput$ = sOutput$ + NormString(sSfd$)
                    End If
                Else
                    sOutput$ = sOutput$ + " " + NormString(sSfd$)
                End If
            Else
                sReturnedSubfieldsOfInterestButNotNormalized$ = sReturnedSubfieldsOfInterestButNotNormalized$ + MyMarcCharacter.MarcDelimiter + sSfc + sSfd$
                If bPCC Then
                    ' 20070727: for authority records, do not add $w, or numeric subfields
                    ' NOTE that we may choose to do something similar for bib records (such as $e)
                    If sMarcFormat$ = "A" And InStr("w0123456789", sSfc$) > 0 Then
                        ' do nothing
                    Else
                        sOutput$ = sOutput$ + MyMarcCharacter.MarcDelimiter + sSfc$ + NormString(sSfd$)
                    End If
                Else
                    sOutput$ = sOutput$ + " " + NormString(sSfd$)
                End If
            End If
        End If
NormalizeWholeFieldNextSubfield:
        If Len(sInput$) = 0 Then
            Exit Do
        End If
#If NormalizeWholeFieldDebug = -1 Then
        Debug.Print "At bottom of loop >" + sOutput$ + "<"
        Debug.Print "Next sfd: " + sNextSfc$
#End If
        sSfc$ = sNextSfc$
    Loop
        
    NormalizeWholeField = Trim(RemoveRepeatedCharacters(sOutput$, " "))

    NormalizationScheme = sSaveScheme$

End Function

Public Property Get MarcRecordOut() As String

    Dim sDirectory$, sFields$, sField$, sTag$
    Dim iPtr%, iLenDir%, iDirEnd%, iNext%, iPrevious%
    Dim iNext2%, iPrevious1%
    
    Dim sLead$, sRest$, sLow$, sHigh$
    
    Dim bChanged As Boolean
    
    
    If m_iMarcCtr% < 1 Then
        MarcRecordOut = ""
        Exit Property
    End If
    
    iPtr% = m_iFirstField%
    
    If iPtr% < 0 Then
        Exit Property
    End If
    
    iPtr = FldPointer
    FldPointer = m_iFirstField%
    Do
        If FldPointer < 0 Then
            Exit Do
        End If
        If Not FldDeleted Then
            sTag$ = FldTag
            ' no indicators for control fields
            sField$ = FldText
            If Len(sField$) > 0 Then
                sField$ = FldInd + sField$
                If Right(sField$, 1) <> MyMarcCharacter.MarcEndOfField Then ' right ok
                    sField$ = sField$ + MyMarcCharacter.MarcEndOfField
                End If
                If Len(sTag$) = 3 And Len(sField$) > 0 Then
                    sDirectory$ = sDirectory$ + sTag$ + Right("0000" + Trim(str(Len(sField$))), 4) + Right("00000" + Trim(str(Len(sFields$))), 5) ' right ok
                    sFields$ = sFields$ + sField$
                End If
            End If
        End If
        'Debug.Print "Field: " + str(FldPointer) + " next " + str(MarcArray(FldPointer).NextField)
        FldPointer = MarcArray(FldPointer).NextField
    Loop
    FldPointer = iPtr%
    

    ' 20030702: Jack Fitzpatrick discovered that OCLC records with 'action'
    '   characters--or a blank--cause BatchCat to bark; so we're going to make
    '   sure that the finished record has good stuff in it
    If Mid(m_sLeader$, 23, 2) <> "00" Then ' leader/22 and leader/23
        m_sLeader$ = Mid(m_sLeader$, 1, 22) + "00"
    End If

    ' 20060913: substitute alif as required; we can do this simply, because
    '   the old and new things are the same length
    If m_bUtf8 Then
        sFields$ = ReplaceCharacters(sFields$, OldUtf8Alif$, NewUtf8Alif$)
    End If

    
    'Debug.Print "Finished leader: >" + m_sLeader$ + "<"
    ' assemble the leader and the directory
    sDirectory$ = m_sLeader$ + sDirectory$ + MyMarcCharacter.MarcEndOfField
    ' set the base address of data: MARC 12 (13th character and up)
    sDirectory$ = SafeStuff(sDirectory$, 13, 5, Right("00000" + Trim(str(Len(sDirectory$))), 5))  ' right ok ' stuff ok
    ' assemble the complete record
    sDirectory$ = sDirectory$ + sFields$ + MyMarcCharacter.MarcEndOfRecord
    ' set final record length and set return value at the same time
    MarcRecordOut = Right("00000" + Trim(str(Len(sDirectory$))), 5) + Mid(sDirectory$, 6) ' right ok ' mid ok

    'Debug.Print "Final record: " + Right("00000" + Trim(str(Len(sDirectory$))), 5) + Mid(sDirectory$, 6) ' right ok ' mid ok
    
End Property



Public Function GetLeaderValue(ByVal MarcLeaderPosition As Integer, ByVal MarcLeaderLength As Integer) As String

    Dim sX$
    
    ' remember that the "position" being requested is the MARC format's
    '   zero-based value, so we have to remember to increment the
    '   position number by one to make it work in the program's
    '   one-based world
    
    If Len(m_sLeader$) = 0 Or MarcLeaderPosition > 23 Or MarcLeaderPosition + MarcLeaderLength > 24 Then
        'GetLeaderValue = Space(MARCLeaderLength)
        GetLeaderValue = ""
    Else
        GetLeaderValue = Mid(m_sLeader$, MarcLeaderPosition + 1, MarcLeaderLength) ' mid ok
    End If
    
End Function


Public Sub ChangeLeaderValue(ByVal iStartingPosition%, ByVal sNewLeaderValue$)

    ' change a value in the current record's leader
    
    ' UTF-8 safe: only single-octet characters allowed
    
    Dim iLen%, iMarcLeaderPosition%
        
    Dim sOldEncoding$
    
    
    'Debug.Print "CLV " + str(iStartingPosition%) + " >" + sNewLeaderValue$ + "<"
    
    ' remember that the "position" being requested is the MARC format's
    '   zero-based value, so we have to remember to increment the
    '   position number by one to make it work in the program's one-based world    iMarcLeaderPosition% = Val(Mid(MARCLeaderValu, 1, 2)) + 1
    iMarcLeaderPosition% = iStartingPosition% + 1
    
    iLen = Len(sNewLeaderValue$)
    If iLen% + iMarcLeaderPosition > 25 Or iLen% = 0 Or iMarcLeaderPosition > 24 Or Len(m_sLeader$) < 24 Then
        Exit Sub
    End If
    
    ' special rules for leader/06 (type of record): only within certain formats (we can't change
    '   an authority record to holdings)
    ' the value blank here means that we've got a brand-new leader for a
    '   new record that hasn't got any format code at all yet--so obviously
    '   we don't want to forbid that change!
    If iStartingPosition% = 6 And Mid(m_sLeader$, 7, 1) <> " " Then
        Select Case Mid(m_sLeader$, 7, 1) ' Leader/06
            Case "a", "c", "d", "e", "f", "g", "i", "j", "k", "m", "o", "p", "r", "t" ' bibliographic
                If InStr("acdefgijkmoprt", Mid(sNewLeaderValue$, 1, 1)) = 0 Then
                    Exit Sub
                End If
            Case "z", "q", "w" ' authority, classification, community information
                Exit Sub
            Case "u", "v", "x", "y" ' holdings
                If InStr("uvxy", Mid(sNewLeaderValue$, 1, 1)) = 0 Then
                    Exit Sub
                End If
            Case Else
                Exit Sub
        End Select
    End If
    
    ' save the previous character set encoding value before
    '   you actually change the byte (whichever byte it might be)
    sOldEncoding$ = Mid(m_sLeader$, 10, 1)
    
    ' here we actually change the leader value
    m_sLeader$ = SafeStuff(m_sLeader$, iMarcLeaderPosition%, iLen%, sNewLeaderValue$) ' stuff ok
    
    ' if we've changed the character set byte in the record, we must perforce translate the
    '   record to suit the new value
    ' NOTE that at least for the present we're only allowing two possibilities: UTF-8 and
    '   the default set, which is Voyager for now
    If iStartingPosition% = 9 Then
        If GetLeaderValue(9, 1) <> sOldEncoding$ Then
            Select Case GetLeaderValue(9, 1)
                Case "a"
                    CharacterSetOut = "U"
                Case " "
                    CharacterSetOut = m_sDefaultCharacterSet$
                Case Else
                    m_sLeader$ = SafeStuff(m_sLeader$, iMarcLeaderPosition%, 1, " ")
                    CharacterSetOut = m_sDefaultCharacterSet$
            End Select
        End If
    End If
        
    
    If iStartingPosition% = 6 Or iStartingPosition% = 7 Then
        m_sRecordFormat$ = SetFormatCode() ' based on m_sLeader$
        ' NOTE that this affects the 008, but the container
        '   program is going to have to deal with this!
    End If
    
End Sub

Private Sub ResetCurrentField(ByVal sTag$, ByVal sIndicators$, ByVal sField$)

    ' change the current field (the field in the array of fields
    '   pointed to by fldpointer) to new values as specified by user's input parameters
    
    Dim sNewTag$, sNewIndicators$, sNewField$, sOldTag$, sOldIndicators$, s21$, s22$, sW$, s6$
    Dim sSortSignatureExtension$
    
    Dim iPrevious%, iNext%, iDirPtr%, iNextSave%, iSfdPtrSave%, iClcl%

    Dim sSortSignature$, sNumericSubfields$
    
    Dim bFound As Boolean, bInSitu As Boolean
    
    Dim lSfdPointer As Long
    
    
#If ResetCurrentFieldDebug = -1 Then
    Debug.Print "Entered RCF " + sTag$ + ":" + sIndicators$ + ":" + sField$
    Debug.Print vbTab + "Over " + FldTag + ":" + FldInd + ":" + FldText
#End If

    iSfdPtrSave% = m_iSfdPointer%
    
    sSortSignature$ = SetFieldSortGroupFromTag(sTag$, sIndicators$, sField$)
    iNext% = InStr(sSortSignature$, prvsSortExtensionMarker$)
    If iNext% > 0 Then
        sSortSignatureExtension$ = Mid(sSortSignature$, iNext%)
        sSortSignature$ = Mid(sSortSignature$, 1, iNext% - 1)
    End If
#If ResetCurrentFieldDebug = -1 Then
    Debug.Print "Signature etc: >" + sTag$ + ":" + sSortSignature$ + ":" + sSortSignatureExtension$ + "<"
#End If

    SetSubfieldSortGroupFromTag sTag$
#If ResetCurrentFieldDebug = -1 Then
    Debug.Print "Set sort group OK"
#End If
    
    FldChanged = True
    
    ' preserve pointers to the next and previous fields
    iNext% = FldNext
    iPrevious% = FldPrev
   
    ' 20060519: preserve numeric subfields if that's what you want to do
#If ResetCurrentFieldDebug = -1 Then
    Debug.Print "Preserve leading numerics?"
#End If
    If PreserveLeadingNumericSubfields Then
        lSfdPointer = SfdPointer
        SfdMoveTop
        Do
            Select Case SfdCode
                Case Is > "9"
                    Exit Do
                Case "0" To "9"
                    If InStr(sField$, MarcDelimiter + SfdCode) = 0 Then
                        sNumericSubfields$ = MarcDelimiter + SfdCode + SfdText
                    End If
            End Select
            If Not SfdMoveNext Then
                Exit Do
            End If
        Loop
        SfdPointer = lSfdPointer
#If ResetCurrentFieldDebug = -1 Then
        Debug.Print "Retained numerics: >" + sNumericSubfields$ + "<"
#End If
    End If
    
    ' 20060519: these were being saved, but it appears that we have never
    '   used them for anything; maybe something will turn up
    sOldTag$ = FldTag
    sOldIndicators$ = FldInd
    
    If Len(sTag$) > 0 Then
        sNewTag$ = sTag$
        sNewIndicators$ = sIndicators$
        ' 20060519: when building the field text, paste on any
        '   leading numeric subfields if we extracted any in the
        '   earlier step
        sNewField$ = sNumericSubfields$ + sField$
    Else
        sNewTag$ = FldTag
        sNewIndicators$ = FldInd
        ' 20060519: when building the field text, paste on any
        '   leading numeric subfields if we extracted any in the
        '   earlier step
        sNewField$ = sNumericSubfields$ + FldText
    End If
    
#If ResetCurrentFieldDebug = -1 Then
    Debug.Print "Instructions: >" + MarcArray(FldPointer).SortInstruction + "< >" + sSortSignature$ + "<"
    'iNext% = 7 / 0
#End If
    
    If InStr(sNewField$, MarcDelimiter + "6") > 0 Then
        bInSitu = False
        bInSitu = True
        MarcArray(FldPointer).SortInstructionExtension = sSortSignatureExtension$
    'If MarcArray(FldPointer).SortInstruction = sSortSignature$ And MarcArray(FldPointer).SortInstructionExtension = sSortSignatureExtension$ And Len(MarcArray(FldPointer).SortInstructionExtension) > 0 And Len(sSortSignatureExtension$) > 0 Then
    ElseIf MarcArray(FldPointer).SortInstruction = sSortSignature$ And MarcArray(FldPointer).SortInstructionExtension = sSortSignatureExtension$ Then
        ' signature is the same: the current site is still OK
        bInSitu = True
    Else
        ' the changed field's signature is different
        ' assume the new field does NOT fit into the same slot as
        '   its previous incarnation
        If MarcArray(FldPointer).SortInstructionExtension <> sSortSignatureExtension$ And Len(MarcArray(FldPointer).SortInstructionExtension) > 0 And Len(sSortSignatureExtension$) > 0 Then
            bInSitu = False
        Else
#If ResetCurrentFieldDebug = -1 Then
            Debug.Print "Possibly not in situ " + str(FldNext) + " " + str(FldPrev)
#End If
            bInSitu = False
            If FldNext > -1 Then
                If MarcArray(FldNext).SortInstruction >= sSortSignature$ Then
                    ' the next field's signature is greater than (or same as) the field-being-changed's
                    '   new signature: as far as the next field goes, the
                    '   changed field can stay where it is
                    If FldPrev > -1 Then
                        If MarcArray(FldPrev).SortInstruction <= sSortSignature$ Then
                            ' the field-being changed is in proper relation to the next field,
                            '   and it is in proper relation to the previous field; so
                            '   the changed field can stay where it is
                            bInSitu = True
                        End If
                    Else
                        ' the field-being-changed is in proper relation to the next field
                        '   and there is no previous field; so the field-being-changed
                        '   is still in the right place
                        bInSitu = True
                    End If
                'Else
                    ' the next field's signature is less than the field-being-changed's
                    '   new signature, meaning the new field goes somewhere
                    '   after the next field; so we'll keep bInSitu at its
                    '   current value of False
                End If
            ElseIf FldPrev > -1 Then
                ' no next field, but there's a previous field
                If MarcArray(FldPrev).SortInstruction <= sSortSignature$ Then
                    bInSitu = True
                End If
            Else
                ' the current field is the first and only field
                '   in the record
                bInSitu = True
            End If
        End If
    End If
#If ResetCurrentFieldDebug = -1 Then
    Debug.Print "In situ? " + str(bInSitu)
#End If
    
    If bInSitu Then
        
        ' we can put the new field in the same place as the previous one
        ' leave the array pointers alone: just
        '   change the information in the current element
        
        With MarcArray(FldPointer)
#If WithDebug = -1 Then
            PushWith "ResetCurrentField"
#End If
            .SubfieldLast = -1
            .FirstSubfield = -1
            .LastSubfield = -1
            .Tag = sNewTag$
            .SortInstruction = sSortSignature$
            
            If Mid(FldTag, 1, 2) = "00" Then ' mid ok
                .IsControl = True
                .Ind = ""
            Else
                .IsControl = False
                .Ind = Mid(sNewIndicators$ + "  ", 1, 2)
            End If
#If WithDebug = -1 Then
            PopWith "ResetCurrentField"
#End If
            
        End With
        
        DigestSubfieldText FldPointer, sNewField$
        'DigestSubfieldText MarcArray(FldPointer), sNewField$
        
        ' we want to have direct access to the table entry for the 008 field
        If sNewTag$ = "008" Then
            m_i008Ptr% = FldPointer
        End If
        
        ' this field is already exposed as the current field,
        '   so we don't need to do anything with FldPointer
        
    Else ' ALWAYS false if $6 is present
    
        ' the user has modified something critical to do with the field pointed to by the
        '   current array pointer, so we need to reverse the action of
        '   the "expose field" thingie
        
        ' NOTE THIS IMPORTANT STEP: we are deleting
        '   the current field before we then re-add it
        
#If ResetCurrentFieldDebug = -1 Then
        Debug.Print "NOT in situ; about to delete " + FldTag
#End If
        ' deleting a field simply means that we set a property in the
        '   array; there is no "with" involved, or anything like that
        FldDelete
        
#If ResetCurrentFieldDebug = -1 Then
        Debug.Print "About to add " + FldTag
#End If
        ' pretend the field is a new one
        ' this will entail setting FieldsOutOfOrder if we're not
        '   actually allowed to change field order ...
        If Mid(FldTag, 1, 2) = "00" Then ' mid ok
            FldAdd sNewTag$, "", sNewField$
        Else
            FldAdd sNewTag$, sNewIndicators$, sNewField$
        End If
        
        ' point to this item, which is the last item
        '   in our array
        FldPointer = m_iMarcCtr% - 1
    
    End If
    
    m_iSfdPointer% = iSfdPtrSave%
    
#If ResetCurrentFieldDebug = -1 Then
    Debug.Print "Exited RCF"
#End If
    
End Sub

Public Property Get FldNorm() As String

    Dim sTag$, sIndicators$, sField$
    
    If FldPointer > -1 Then
    
        sTag$ = MarcArray(FldPointer).Tag
        sIndicators$ = MarcArray(FldPointer).Ind
        sField$ = FldText
        FldNorm = NormalizeWholeField(NORMALIZATIONSCHEME_Voyager$, m_sRecordFormat$, sTag$, sIndicators$, sField$)
        
    Else
        Debug.Print "Asking for FldNorm when fldpointer is -1"
    End If
    
End Property



Public Property Get IsAuthority() As Boolean

    IsAuthority = m_bIsAuthority

End Property


Public Sub FldDelete()

    If FldPointer > -1 Then
        MarcArray(FldPointer).Deleted = True
    End If

End Sub

Public Sub FldInsertAfter(ByVal sNewTag$, ByVal sNewInd$, ByVal sNewFieldText$)

    ' removed from the parameter string:
    ' , Optional ByVal bForce As Boolean = False
    
    Dim sSortInstruction$, sSortInstructionExtension$
    
    Dim iLen%, iRc%
    
    Dim bControl As Boolean
    
    
#If FldInsertAfterDebug = -1 Then
    Debug.Print "FldInsertAfter: >" + sNewTag$ + "< >" + sNewInd$ + "< >" + ReplaceCharacters(sNewFieldText$, MarcDelimiter, "$") + "<"
#End If
    ' if there aren't any fields yet, just add this one in the normal manner (the routine
    '   called here does its own parameter inspection)
    If m_iMarcCtr% = 0 Then
#If FldInsertAfterDebug = -1 Then
        Debug.Print "Exit because this is the first field"
#End If
        FldAdd sNewTag$, sNewInd$, sNewFieldText$
        Exit Sub
    End If
    
    ' 20061117: if this is an 880 field that contains $6, then
    '   we're going to use the standard "add" code
    If sNewTag$ = "880" And InStr(sNewFieldText$, MarcDelimiter + "6") > 0 Then
#If FldInsertAfterDebug = -1 Then
        Debug.Print "Exit because of 880 exception"
#End If
        FldAdd sNewTag$, sNewInd$, sNewFieldText$
        Exit Sub
    End If
    
    ' see explanation for this code in FldAdd
    If sNewTag$ = "008" Then
        ' if the
        If m_i008Ptr% > -1 Then
            Change008Value 0, sNewFieldText$
            Exit Sub
        End If
    End If
    
    ' make sure the tag has a legal shape
    If Len(sNewTag$) <> 3 Then
        Exit Sub
    End If
    If InStr("0123456789", Mid(sNewTag$, 1, 1)) = 0 Or InStr("0123456789", Mid(sNewTag$, 2, 1)) = 0 Or InStr("0123456789", Mid(sNewTag$, 3, 1)) = 0 Then ' mid ok
        Exit Sub
    End If
    
    ' 20040922: test removed--can add subfields later, if desired
    ' we have to have some field text
    'If Len(sNewFieldText$) < 1 Then
    '    Exit Sub
    'End If
    
    
    ' check out the indicators, and do other tag-dependent stuff
    If Mid(sNewTag$, 1, 2) = "00" Then ' mid ok
        bControl = True
        ' control fields can't have indicators!
        sNewInd$ = ""
        If Mid(sNewFieldText$, 1, 1) = MyMarcCharacter.MarcDelimiter Then ' mid ok
            sNewFieldText$ = Mid(sNewFieldText$, 3) ' mid ok
        End If
    Else
        ' reject if no indicators, or if indicators
        '   don't measure up
        iLen% = Len(sNewInd$)
        If iLen% > 0 Then
            If iLen% <> 2 Then
                Exit Sub
            End If
            If InStr("0123456789 ", Mid(sNewInd$, 1, 1)) = 0 Or InStr("0123456789 ", Mid(sNewInd$, 2, 1)) = 0 Then ' mid ok
                Exit Sub
            End If
        End If
        ' the new field should begin with a subfield code;
        '   if not, assume $a
        If Len(sNewFieldText$) > 0 Then
            If Mid(sNewFieldText$, 1, 1) <> MyMarcCharacter.MarcDelimiter Then ' mid ok
                sNewFieldText$ = MyMarcCharacter.MarcDelimiter + "a" + sNewFieldText$
            End If
        End If
    End If
    
    ' add a new element to the array of fields, and include
    '   default values for NextField and PrevField
    m_iMarcCtr% = m_iMarcCtr% + 1
    ReDim Preserve MarcArray(m_iMarcCtr%)
    
    
    ' fill in the new element
    MarcArray(m_iMarcCtr% - 1).Tag = sNewTag$
    MarcArray(m_iMarcCtr% - 1).Ind = sNewInd$
    MarcArray(m_iMarcCtr% - 1).Deleted = False
    MarcArray(m_iMarcCtr% - 1).IsControl = bControl
    sSortInstruction$ = SetFieldSortGroupFromTag(sNewTag$, sNewInd$, sNewFieldText$)
#If FldInsertAfterDebug = -1 Then
    Debug.Print "Instruction: >" + ReplaceCharacters(sSortInstruction$, MarcDelimiter, "$") + "<"
#End If
    
    ' 20061117: allow for sort extension
    iRc% = InStr(sSortInstruction$, prvsSortExtensionMarker$)
    If iRc% > 0 Then
        sSortInstructionExtension$ = Mid(sSortInstruction$, iRc%)
        sSortInstruction$ = Mid(sSortInstruction$, 1, iRc% - 1)
        MarcArray(m_iMarcCtr% - 1).SortInstruction = sSortInstruction$
        MarcArray(m_iMarcCtr% - 1).SortInstructionExtension = sSortInstructionExtension$
    Else
        MarcArray(m_iMarcCtr% - 1).SortInstruction = sSortInstruction$
    End If
    ' 20061117: NOTE that because we already know that this is not an 880 field that
    '   contains subfield $6, in the code that follows we do not have to deal with
    '   880 $6 the way we do in the simple FldAdd routine
#If FldInsertAfterDebug = -1 Then
    Debug.Print "Instruction and extension: >" + sSortInstruction$ + "< >" + sSortInstructionExtension$ + "<"
#End If
    
    If sNewTag$ = "008" Then
        m_i008Ptr% = m_iMarcCtr% - 1
    End If
    
    ' use dummy values for these two, temporarily
    MarcArray(m_iMarcCtr% - 1).NextField = -1
    MarcArray(m_iMarcCtr% - 1).PrevField = -1
        
    If MarcArray(FldPointer).NextField = -1 Then
        ' we are trying to add this as the new last field in the array
        If MarcArray(FldPointer).SortInstruction <= sSortInstruction$ Then
            ' this new home is in fact OK
            MarcArray(m_iMarcCtr% - 1).NextField = -1 ' which MarcArray(fldpointer).NextField actually is
            MarcArray(FldPointer).NextField = m_iMarcCtr% - 1
            MarcArray(m_iMarcCtr% - 1).PrevField = FldPointer
            ' we don't need to reset MarcArray(fldpointer).PrevField, as it isn't changing
            m_iLastField% = m_iMarcCtr% - 1
        Else
FldInsertAfterUseStandardAdd:
            ' the program-specified home for the new field is NOT suitable
            ' remove the field we very nearly added
            m_iMarcCtr% = m_iMarcCtr% - 1
            ReDim Preserve MarcArray(m_iMarcCtr%)
            ' make up our own mind about where the field goes
            ' this will entail setting FieldsOutOfOrder if we're not
            '   actually allowed to change field order ...
            FldAdd sNewTag$, sNewInd$, sNewFieldText$
            Exit Sub
        End If
    Else
        ' we are adding this somewhere within the table
        ' if the new field belongs in this new spot, then it's OK
        If MarcArray(FldPointer).SortInstruction <= sSortInstruction$ Then
            ' 20040617: allow for the possibility that there is no next field
            If MarcArray(FldPointer).NextField > -1 Then
                If MarcArray(MarcArray(FldPointer).NextField).SortInstruction >= sSortInstruction$ Then
                    ' the new field's own previous field is the current field's next field's previous field
                    '   (this really should be the same as the pointer to the current field)
                    MarcArray(m_iMarcCtr% - 1).PrevField = MarcArray(MarcArray(FldPointer).NextField).PrevField
                    ' the new field's next field's previous field is the new field's number
                    MarcArray(MarcArray(FldPointer).NextField).PrevField = m_iMarcCtr% - 1
                    ' the new field's next field is the current field's next field
                    MarcArray(m_iMarcCtr% - 1).NextField = MarcArray(FldPointer).NextField
                    ' the current field's next field is the new field
                    MarcArray(FldPointer).NextField = m_iMarcCtr% - 1
                'Else
                    ' the field is already in the right place
                End If
            'Else
                ' there being no next field, this compare is not possible; so assume we're
                '   in the right place
            End If
        Else
            ' the program-specified home for the new field is NOT suitable
            ' this will entail setting FieldsOutOfOrder if we're not
            '   actually allowed to change field order ...
            GoTo FldInsertAfterUseStandardAdd
        End If
    End If
    
    ' the new field is the current field
    FldPointer = m_iMarcCtr% - 1
    
    ' add the field's text (if any)
    If Len(sNewFieldText$) > 0 Then
        'DigestSubfieldText MarcArray(m_iMarcCtr% - 1), sNewFieldText$
        DigestSubfieldText m_iMarcCtr% - 1, sNewFieldText$
    End If
    
End Sub

Public Sub FldInsertBefore(ByVal sNewTag$, ByVal sNewInd$, ByVal sNewFieldText$)


    Dim bControl As Boolean
    
    Dim iLen%, iRc%
    
    Dim sSortSignature$, sSortSignatureExtension$
    
    
    ' removed from the parameter string:
    ' , Optional ByVal bForce As Boolean = False
    
    If m_iMarcCtr% = 0 Then
        FldAdd sNewTag$, sNewInd$, sNewFieldText$
        Exit Sub
    End If
    
    ' 20061117: if this is an 880 field that contains $6, then
    '   we're going to use the standard "add" code
    If sNewTag$ = "880" And InStr(sNewFieldText$, MarcDelimiter + "6") > 0 Then
        FldAdd sNewTag$, sNewInd$, sNewFieldText$
        Exit Sub
    End If
    
    ' see explanation foro this code in FldAdd
    If sNewTag$ = "008" Then
        ' if the
        If m_i008Ptr% > -1 Then
            Change008Value 0, sNewFieldText$
            Exit Sub
        End If
    End If
    
    ' check out the tag
    If Len(sNewTag$) <> 3 Then
        Exit Sub
    End If
    If InStr("0123456789", Mid(sNewTag$, 1, 1)) = 0 Or InStr("0123456789", Mid(sNewTag$, 2, 1)) = 0 Or InStr("0123456789", Mid(sNewTag$, 3, 1)) = 0 Then ' mid ok
        Exit Sub
    End If
    
    ' 20040921: test removed (OK to add the subfields later)
    ' check out the field
    'If Len(sNewFieldText$) < 1 Then
    '    Exit Sub
    'End If
    
    
    ' check out the indicators, and do other tag-dependent stuff
    If Mid(sNewTag$, 1, 2) = "00" Then ' mid ok
        ' control fields can't have indicators!
        bControl = True
        sNewInd$ = ""
        If Mid(sNewFieldText$, 1, 1) = MyMarcCharacter.MarcDelimiter Then ' mid ok
            sNewFieldText$ = Mid(sNewFieldText$, 3) ' mid ok
        End If
    Else
        ' reject if no indicators, or if indicators
        '   don't measure up
        iLen% = Len(sNewInd$)
        If iLen% > 0 Then
            If iLen% <> 2 Then
                Exit Sub
            End If
            If InStr("0123456789 ", Mid(sNewInd$, 1, 1)) = 0 Or InStr("0123456789 ", Mid(sNewInd$, 2, 1)) = 0 Then ' mid ok
                ' MsgBox "Indicators really bad"
                Exit Sub
            End If
        End If
        ' the new field should begin with a subfield code;
        '   if not, assume $a
        If Len(sNewFieldText$) > 0 Then
            If Mid(sNewFieldText$, 1, 1) <> MyMarcCharacter.MarcDelimiter Then ' mid ok
                sNewFieldText$ = MyMarcCharacter.MarcDelimiter + "a" + sNewFieldText$
            End If
        End If
    End If

    ' add a new element to the array of fields, and include
    '   default values for NextField and PrevField
    m_iMarcCtr% = m_iMarcCtr% + 1
    ReDim Preserve MarcArray(m_iMarcCtr%)
    
    
    ' fill in the new element
    MarcArray(m_iMarcCtr% - 1).Tag = sNewTag$
    MarcArray(m_iMarcCtr% - 1).Ind = sNewInd$
    MarcArray(m_iMarcCtr% - 1).Deleted = False
    MarcArray(m_iMarcCtr% - 1).IsControl = bControl
    sSortSignature$ = SetFieldSortGroupFromTag(sNewTag$, sNewInd$, sNewFieldText$)
    ' 20061117: allow for sort extension
    iRc% = InStr(sSortSignature$, prvsSortExtensionMarker$)
    If iRc% > 0 Then
        MarcArray(m_iMarcCtr% - 1).SortInstruction = Mid(sSortSignature$, 1, iRc% - 1)
        MarcArray(m_iMarcCtr% - 1).SortInstructionExtension = Mid(sSortSignature$, iRc%)
        sSortSignatureExtension$ = MarcArray(m_iMarcCtr% - 1).SortInstructionExtension
    Else
        MarcArray(m_iMarcCtr% - 1).SortInstruction = sSortSignature$
    End If
    ' 20061117: NOTE that because we already know that this is not an 880 field that
    '   contains subfield $6, in the code that follows we do not have to deal with
    '   880 $6 the way we do in the simple FldAdd routine
    
    
    If sNewTag$ = "008" Then
        m_i008Ptr% = m_iMarcCtr% - 1
    End If
    
    ' use dummy values for these two, temporarily
    MarcArray(m_iMarcCtr% - 1).NextField = -1
    MarcArray(m_iMarcCtr% - 1).PrevField = -1
        
    If MarcArray(FldPointer).PrevField = -1 Then
        ' we are adding this as the new first field in the array
        If MarcArray(FldPointer).SortInstruction >= sSortSignature$ Then
            MarcArray(m_iMarcCtr% - 1).PrevField = -1 '
            MarcArray(FldPointer).PrevField = m_iMarcCtr% - 1
            MarcArray(m_iMarcCtr% - 1).NextField = FldPointer
            ' we don't need to reset MarcArray(fldpointer).NextField
            m_iFirstField% = m_iMarcCtr% - 1
        Else
FldInsertBeforeUseStandardAdd:
            ' the program-specified home for the new field is NOT suitable
            ' remove the field we very nearly added
            m_iMarcCtr% = m_iMarcCtr% - 1
            ReDim Preserve MarcArray(m_iMarcCtr%)
            ' make up our own mind about where the field goes
            ' this will entail setting FieldsOutOfOrder if we're not
            '   actually allowed to change field order ...
            FldAdd sNewTag$, sNewInd$, sNewFieldText$
            Exit Sub
        End If
    Else ' previous field is not -1: there is a prevoius field
        
        ' if the new field belongs in this new spot, then it's OK
        If MarcArray(FldPointer).SortInstruction <= sSortSignature$ Then
            ' it's in proper relation to the previous field
            ' 20040617: we discover that there may or may not be a next field; so we
            '   have to allow for both, don't we?
            If MarcArray(FldPointer).NextField > -1 Then
                If MarcArray(MarcArray(FldPointer).NextField).SortInstruction >= sSortSignature$ Then
                    ' the new field's next field is the current' field's previous field's next field
                    MarcArray(m_iMarcCtr% - 1).NextField = MarcArray(MarcArray(FldPointer).PrevField).NextField
                    ' the current field's next field is the new field
                    MarcArray(MarcArray(FldPointer).PrevField).NextField = m_iMarcCtr% - 1
                    ' the new field's previous field is the current field's previous field
                    MarcArray(m_iMarcCtr% - 1).PrevField = MarcArray(FldPointer).PrevField
                    ' the current field's previous field is the new field
                    MarcArray(FldPointer).PrevField = m_iMarcCtr% - 1
                'Else
                    ' the field is in proper relation to the next field, too
                End If
            'Else
                ' there is no next field, so the field is OK
            End If
        Else
            ' the program-specified home for the new field is NOT suitable
            ' this will entail setting FieldsOutOfOrder if we're not
            '   actually allowed to change field order ...
            GoTo FldInsertBeforeUseStandardAdd
        End If
    End If

    FldPointer = m_iMarcCtr% - 1
    
    If Len(sNewFieldText$) > 0 Then
        'DigestSubfieldText MarcArray(m_iMarcCtr% - 1), sNewFieldText$
        DigestSubfieldText m_iMarcCtr% - 1, sNewFieldText$
    End If
    
End Sub

Public Property Get FldTag() As String

    If FldPointer > -1 Then
        FldTag = MarcArray(FldPointer).Tag
    Else
        FldTag = ""
    End If

End Property

Public Property Let FldTag(ByVal vNewValue As String)

    If FldPointer > -1 Then
#If ResetCurrentFieldDebug = -1 Then
        Debug.Print "RCF from fldTag"
#End If
        ResetCurrentField vNewValue, FldInd, FldText
    'Else
        'FldTag = ""
    End If
    
End Property


Public Property Get Fld008Length() As Integer

    ' todo: is it possible for us to reset the 008 field if the length is wrong?
    
    Fld008Length = m_i008Length%

End Property


Public Property Get CharacterSetIn() As String

    If Len(m_sCharacterSetIn$) > 0 Then
        CharacterSetIn = m_sCharacterSetIn$
    Else
        CharacterSetIn = m_sDeclaredCharacterSetIn$
    End If
    
End Property

Public Property Let CharacterSetIn(ByVal vNewValue As String)

#If CharacterSetDebug = -1 Then
    Debug.Print "CSI set >" + vNewValue + "<"
#End If
    
    Select Case Mid(vNewValue, 1, 1) ' mid ok
        Case CHARACTERSET_Voyager$
            m_sDeclaredCharacterSetIn$ = CHARACTERSET_Voyager$
        Case CHARACTERSET_OCLC$
            m_sDeclaredCharacterSetIn$ = CHARACTERSET_OCLC$
        Case CHARACTERSET_MARC$
            m_sDeclaredCharacterSetIn$ = CHARACTERSET_MARC$
        Case CHARACTERSET_Utf8$
            m_sDeclaredCharacterSetIn$ = CHARACTERSET_Utf8$
        Case CHARACTERSET_Latin1$
            m_sDeclaredCharacterSetIn$ = CHARACTERSET_Latin1$
        Case Else
            Debug.Print "CSI: >" + vNewValue + "<"
            Err.Raise 380, "MarcClass", "Invalid value for CharacterSetIn property", "", 0
    End Select

End Property

Public Property Get CharacterSetOut() As String

    CharacterSetOut = m_sCharacterSetOut

End Property

Public Property Let CharacterSetOut(ByVal vNewValue As String)

    Dim sSaveIn$, sSaveOut$
    
    
#If CharacterSetDebug = -1 Or CharacterSetOutDebug = -1 Then
    Debug.Print "Set CSO " + vNewValue
#If WithDebug = -1 Then
    Debug.Print "WithStack At CSO"
    DisplayWithStack
#End If
#End If

    ' capture the record as it exists before any translation has taken place
    m_sRecordInProgress$ = MarcRecordOut
    
    sSaveIn$ = m_sCharacterSetIn$
    sSaveOut$ = m_sCharacterSetOut$
    
    ' because we inspect the value of this property frequently, and based on the
    '   suspicion that it might be just a tad more efficient to test a boolean
    '   than to a character comparison, we're translating this code also into
    '   a Utf8/NonUtf8 boolean
    Select Case UCase(Mid(Trim(vNewValue), 1, 1)) ' mid ok
        Case CHARACTERSET_Voyager$
            m_sCharacterSetOut$ = CHARACTERSET_Voyager$
            m_bUtf8 = False
        Case CHARACTERSET_OCLC$
            m_sCharacterSetOut$ = CHARACTERSET_OCLC$
            m_bUtf8 = False
        Case CHARACTERSET_MARC$
            m_sCharacterSetOut$ = CHARACTERSET_MARC$
            m_bUtf8 = False
        Case CHARACTERSET_Utf8$
            m_sCharacterSetOut$ = CHARACTERSET_Utf8$
            m_bUtf8 = True
            If vNewValue = CHARACTERSET_Utf8LcPattern$ Then
                m_bUtf8LcPattern = True
            Else
                m_bUtf8LcPattern = False
            End If
        Case CHARACTERSET_Latin1$
            m_sCharacterSetOut$ = CHARACTERSET_Latin1$
            m_bUtf8 = False
        Case Else
            Err.Raise 380, "MarcClass", "Invalid value for CharacterSetOut property: " + vNewValue, "", 0
    End Select

    ' any time this property changes, it means we have to
    '   translate the current record to the new set
    ' 20040802: the 'current record' may be either a record
    '   supplied by the outside, or one we're creating ourselves
#If CharacterSetDebug = -1 Or CharacterSetOutDebug = -1 Then
    Debug.Print "Len " + str(Len(m_sMarcIn$)) + " " + str(m_bNewRecord) + " :" + m_sCharacterSetOut$ + ":" + sSaveOut$ + ":"
#End If
    If Len(m_sMarcIn$) > 0 Or m_bNewRecord Then
        If m_sCharacterSetOut$ <> sSaveOut$ Then
#If CharacterSetDebug = -1 Or CharacterSetOutDebug = -1 Then
            Debug.Print "Forcing translation from " + sSaveOut$ + " to " + vNewValue
#End If
            ' the record is currently held in the set described by the
            '   previous "out" property; this is, temporarily, the "in"
            '   property
            m_sCharacterSetIn$ = sSaveOut$
            TranslateCharacterSet
            ' set the "in" property back to its original value
            m_sCharacterSetIn$ = sSaveIn$
        End If
    End If
    
End Property

Private Sub TranslateCharacterSet()

    m_bMarcRecordTranslated = False
    
    
#If TranslateCharacterSetDebug = -1 Then
    Debug.Print "TCS in >" + m_sCharacterSetIn$ + "< out >" + m_sCharacterSetOut$ + "<"
#End If

    Select Case m_sCharacterSetIn$
        Case CHARACTERSET_MARC$
            Select Case m_sCharacterSetOut$
                Case CHARACTERSET_OCLC$
                    TranslateMarc2OCLC
                Case CHARACTERSET_Voyager$
                    TranslateMarc2Voyager
                Case CHARACTERSET_Utf8$
                    TranslateMarc2Utf8
            End Select
        Case CHARACTERSET_Latin1$
            Select Case m_sCharacterSetOut$
                Case CHARACTERSET_MARC$, CHARACTERSET_OCLC$, CHARACTERSET_Voyager$
                    TranslateLatin12Marc8
                Case CHARACTERSET_Utf8$
                    TranslateLatin12Utf8
            End Select
        Case CHARACTERSET_OCLC$
            Select Case m_sCharacterSetOut$
                Case CHARACTERSET_MARC$
                    TranslateOCLC2Marc
                Case CHARACTERSET_Voyager$
                    TranslateOCLC2Voyager
                Case CHARACTERSET_Utf8$
                    TranslateMarc2Utf8
            End Select
        Case CHARACTERSET_Voyager$
            Select Case m_sCharacterSetOut$
                Case CHARACTERSET_OCLC$
                    TranslateVoyager2OCLC
                Case CHARACTERSET_MARC$
                    TranslateVoyager2Marc
                Case CHARACTERSET_Utf8$
                    TranslateMarc2Utf8
            End Select
        Case CHARACTERSET_Utf8$
            ' one routine handles them all--the routine itself does the
            '   differentiations necessary
            TranslateUtf82Marc
    End Select
    
End Sub

Private Sub TranslateMarc2OCLC()

    Dim sField$, sTag$
    Dim iPtr%, iChanged%, iRc%
    Dim sLead$, sRest$, sLow$, sHigh$
    
    ' i *think* all we have to worry about is the silly script-l stuff
    
    ' 20000124:
    ' NOTE that since we are assuming that the "new" characters other than
    '   script-l are the same in OCLC and MARC, we don't have to worry
    '   about them (yet)
    
    SetUpTranslation TranslateType_M2O% '"M2O"
    
    TranslateWholeRecordAtOnce
    Exit Sub
    
    If InStr(m_sRecordInProgress$, MARC_ScriptL$) > 0 Then
        TranslateEverythingExcept880
    End If
    
    If InStr(m_sRecordInProgress$, MarcEscape) > 0 Then
        TranslateFieldsWithEscapeCharacters
    End If
        
End Sub

Private Sub TranslateMarc2Voyager()

    Dim sField$, sTag$, sOldChar$, sNewChar$
    Dim sLeft$, sRest$, sPiece$
    
    Dim iPtr%, iChanged%, iRc%, iCtr%
    Dim sLead$, sChar$, sInString$, sOutString$
    
    ' 20000124: add to script-l all of the other "dislocated" characters
    
    SetUpTranslation TranslateType_M2V% ' "M2V"
    
    TranslateWholeRecordAtOnce
    Exit Sub
    
    ' the order of these two routines here doesn't matter, as the supers and subs aren't yet in the
    '   conflicting area
    If InStr(m_sRecordInProgress$, aCharacter(1).From) > 0 Or InStr(m_sRecordInProgress$, aCharacter(2).From) > 0 Or InStr(m_sRecordInProgress$, aCharacter(3).From) > 0 Or InStr(m_sRecordInProgress$, aCharacter(4).From) > 0 Or InStr(m_sRecordInProgress$, aCharacter(5).From) > 0 Or InStr(m_sRecordInProgress$, aCharacter(6).From) > 0 Or InStr(m_sRecordInProgress$, aCharacter(7).From) > 0 Then
        TranslateEverythingExcept880
    End If

    ' handle the escape characters
    If InStr(m_sRecordInProgress$, MarcEscape) > 0 Then
        TranslateFieldsWithEscapeCharacters
    End If
    
    Exit Sub
    
End Sub

Private Sub TranslateOCLC2Marc()

    Dim sField$, sTag$
    Dim iPtr%, iChanged%, iRc%
    Dim sLead$, sRest$, sLow$, sHigh$
    
    ' i *think* all we have to worry about is the silly script-l stuff
    ' 20000124: that is, until we *know* whether OCLC is using the
    '   MARC locations for degree, pressing and other "new" characters
    
    SetUpTranslation TranslateType_O2M% ' "O2M"
    
    TranslateWholeRecordAtOnce
    Exit Sub
    
    If InStr(m_sRecordInProgress$, OCLC_ScriptL$) > 0 Then
        TranslateEverythingExcept880
    End If
    
    ' since OCLC already puts supers and subs in the MARC place, this routine shouldn't be doing much!
    ' in fact, to be efficient, we could probably comment this out ...
    If InStr(m_sRecordInProgress$, MarcEscape) > 0 Then
        TranslateFieldsWithEscapeCharacters
    End If
    
End Sub

Private Sub TranslateOCLC2Voyager()

    Dim sField$, sTag$, sOldChar$, sNewChar$
    Dim iPtr%, iChanged%, iRc%
    Dim sLead$, sRest$, sChar$, sInString$, sOutString$
    
    ' we have to deal with the script-l stuff, and also the super/subs and
    '   the greeks
    
    SetUpTranslation TranslateType_O2V% ' "O2V"
    
    TranslateWholeRecordAtOnce
    Exit Sub
    
    If InStr(m_sRecordInProgress$, OCLC_Degree$) > 0 Or InStr(m_sRecordInProgress$, OCLC_ScriptL$) > 0 Or InStr(m_sRecordInProgress$, OCLC_Pressing$) > 0 Or InStr(m_sRecordInProgress$, OCLC_Copyright$) > 0 Or InStr(m_sRecordInProgress$, OCLC_Sharp$) > 0 Or InStr(m_sRecordInProgress$, OCLC_InvertedQuestion$) > 0 Or InStr(m_sRecordInProgress$, OCLC_InvertedExclamation$) > 0 Then
        TranslateEverythingExcept880
    End If

    If InStr(m_sRecordInProgress$, MarcEscape) > 0 Then
        TranslateFieldsWithEscapeCharacters
    End If
    
End Sub

Private Sub TranslateVoyager2Marc()

    Dim sField$, sTag$, sOldChar$, sNewChar$
    Dim iPtr%, iChanged%, iRc%, iCtr%
    Dim sLead$, sRest$, sChar$, sInString$, sOutString$
    
    ' we have to deal with the script-l stuff, and also the super/subs and
    '   the greeks
    
    If Len(m_sMarcIn$) = 0 Then
        'Debug.Print "No record"
        Exit Sub
    End If
    
    SetUpTranslation TranslateType_V2M% ' "V2M"
    
    TranslateWholeRecordAtOnce
    Exit Sub
    
    
    ' 20021113: order of these two routines reversed
    ' if these were the other way, then we'd be translating the degree sign and so on into
    '   exactly the character set area occupied also by the Voyager superscripts and
    '   subscripts--so things like the degree would be translated twice, and end up
    '   as superscript characters (!)
    ' there's no way to know in advance whether or not the translation will be needed
    '   (that is, unless we do 24 "instr" thingies)
    TranslateFieldsWithEscapeCharactersTheHardWay
    
    If InStr(m_sRecordInProgress$, Voyager_Degree$) > 0 Or InStr(m_sRecordInProgress$, Voyager_ScriptL$) > 0 Or InStr(m_sRecordInProgress$, Voyager_Pressing$) > 0 Or InStr(m_sRecordInProgress$, Voyager_Copyright$) > 0 Or InStr(m_sRecordInProgress$, Voyager_Sharp$) > 0 Or InStr(m_sRecordInProgress$, Voyager_InvertedQuestion$) > 0 Or InStr(m_sRecordInProgress$, Voyager_InvertedExclamation$) > 0 Or InStr(m_sRecordInProgress$, Voyager_Dagger$) > 0 Then
        TranslateEverythingExcept880
    End If
    
End Sub

Private Sub TranslateVoyager2OCLC()

    Dim sField$, sTag$, sOldChar$, sNewChar$
    Dim iPtr%, iChanged%, iRc%, iCtr%
    Dim sLead$, sRest$, sChar$, sInString$, sOutString$
    
    ' 20000124: add in all the "new" characters
    ' remember that we don't actually know what the OCLC values are for any of this except
    '   script-l, so we're assuming the MARC values
    
    SetUpTranslation TranslateType_V2O% ' "V2O"
    
    TranslateWholeRecordAtOnce
    Exit Sub
    
    If InStr(m_sRecordInProgress$, Voyager_Degree$) > 0 Or InStr(m_sRecordInProgress$, Voyager_ScriptL$) > 0 Or InStr(m_sRecordInProgress$, Voyager_Pressing$) > 0 Or InStr(m_sRecordInProgress$, Voyager_Copyright$) > 0 Or InStr(m_sRecordInProgress$, Voyager_Sharp$) > 0 Or InStr(m_sRecordInProgress$, Voyager_InvertedQuestion$) > 0 Or InStr(m_sRecordInProgress$, Voyager_InvertedExclamation$) > 0 Then
        TranslateEverythingExcept880
        'Debug.Print "After TEE880 " + TextRaw
    End If
       
    ' there is no easy way to do this!  has to be brute force!
    TranslateFieldsWithEscapeCharactersTheHardWay
    'Debug.Print "After TFWECTHW " + TextRaw
    
End Sub

Public Property Get FldInd() As String

    If FldPointer > -1 Then
        If MarcArray(FldPointer).IsControl Or Mid(FldTag, 1, 2) = "00" Then
            FldInd = ""
        Else
            FldInd = MarcArray(FldPointer).Ind
        End If
    Else
        FldInd = ""
    End If
        
End Property

Public Property Let FldInd(ByVal vNewValue As String)

    If FldPointer > -1 Then
        If Not MarcArray(FldPointer).IsControl Then
            'DumpArray
#If ResetCurrentFieldDebug = -1 Then
        Debug.Print "RCF from fldInd 1"
#End If
            ResetCurrentField FldTag, vNewValue, FldText
            'DumpArray
        Else
#If ResetCurrentFieldDebug = -1 Then
        Debug.Print "RCF from fldInd 2"
#End If
            ResetCurrentField FldTag, "", FldText
        End If
    End If
    
End Property

Public Property Get MarcRecordTranslated() As Boolean

    MarcRecordTranslated = m_bMarcRecordTranslated

End Property


Private Sub TranslateOneCharacter(ByRef sField$, ByVal sOldChar$, ByVal sNewChar$, ByRef bChanged As Boolean)

    Dim iRc%, iLen%
    
    iLen% = Len(sOldChar$)
    
    Do
        iRc% = InStr(sField$, sOldChar$)
        If iRc% = 0 Then
            Exit Do
        End If
        'Debug.Print "replacing " + sOldChar$ + " with " + sNewChar$ + "< " + sField$
        sField$ = SafeStuff(sField$, iRc%, iLen%, sNewChar$)  ' stuff ok
        bChanged = True
    Loop

End Sub

Private Sub TranslateRemainder(ByRef sField$, ByRef bChanged As Boolean)

    Dim iRc%, iCtr%, iAsc%
    Dim sLead$, sChar$, sRest$, sInString$, sOutString$, sOutput$, sSave$

    
    Select Case sCharacterSetup$
        Case "L2M"
            sSave$ = sField$
            sField$ = MsoftAscii2Marc(sField$)
            If sSave$ <> sField$ Then
                bChanged = True
            End If
        Case "V2M", "V2O"
            ' simply scan through the supplied text one character
            '   at a time, from right to left, and make substitutions
            '   for Voyager-defined superscripts etc.
            For iCtr% = Len(sField$) To 1 Step -1
                iAsc% = Asc(Mid(sField$, iCtr%, 1))
                If aCharacter(iAsc%).From Then
                    sField$ = SafeStuff(sField$, iCtr%, 1, aCharacter(iAsc%).To)
                    bChanged = True
                End If
            Next ' ictr%
        Case "M2V", "O2V"
            Do
                iRc% = InStr(sField$, MarcEscape)
                If iRc% = 0 Then
                    For iCtr% = Len(sField$) To 1 Step -1
                        iAsc% = Asc(Mid(sField$, iCtr%, 1))
                        If aCharacter(iAsc%).From Then
                            sField$ = SafeStuff(sField$, iCtr%, 1, aCharacter(iAsc%).To)
                            bChanged = True
                        End If
                    Next ' ictr%
                    sOutput$ = sOutput$ + sField$
                    Exit Do
                End If
                sLead$ = Mid(sField$, 1, iRc% - 1)
                sChar$ = Mid(sField$, iRc% + 1, 1)
                sRest$ = Mid(sField$, iRc% + 2)
                sField$ = ""
                
                If sChar$ = "(" Then
                    sChar$ = sChar$ + Mid(sRest$, 1, 1)
                    sRest$ = Mid(sRest$, 2)
                End If
                
                iRc% = InStr(sRest$, MarcEscape)
                If iRc% > 0 Then
                    sField$ = Mid(sRest$, iRc%)
                    sRest$ = Mid(sRest$, 1, iRc% - 1)
                End If
                
                iRc% = InStr(sRest$, MyMarcCharacter.MarcDelimiter)
                If iRc% > 0 Then
                    sField$ = Mid(sRest$, iRc%) + sField$
                    sRest$ = Mid(sRest$, 1, iRc% - 1)
                End If
                
                Select Case sChar$
                    Case "g"
                        sInString$ = MARC_Greek$
                        sOutString$ = Voyager_Greek$
                    Case "b"
                        sInString$ = MARC_Subscripts$
                        sOutString$ = Voyager_Subscripts$
                    Case "s", "(B"
                        For iCtr% = Len(sRest$) To 1 Step -1
                            iAsc% = Asc(Mid(sRest$, iCtr%, 1))
                            If aCharacter(iAsc%).From Then
                                sRest$ = SafeStuff(sRest$, iCtr%, 1, aCharacter(iAsc%).To)
                                bChanged = True
                            End If
                        Next ' ictr%
                        'Debug.Print "lead >" + sLead$ + "< rest >" + sRest + "<"
                        sLead$ = sLead$ + sRest$
                        GoTo TranslateMarc2VoyagerReassemble
                    Case Else ' better be 'p'!
                        sInString$ = MARC_Subscripts$ ' same for superscripts
                        sOutString$ = Voyager_Superscripts$
                End Select
                Do ' for each of the characters in the string
                    sChar$ = Mid(sRest$, 1, 1)
                    sRest$ = Mid(sRest$, 2)
                    iRc% = InStr(sInString$, sChar$)
                    'Debug.Print "TR BI  " + str(iRc%) + " " + sChar$ + sRest$
                    If iRc% > 0 Then
                        bChanged = True
                        sLead$ = sLead$ + Mid(sOutString$, iRc%, 1)
                    Else ' leave it out!
                        bChanged = True
                    End If
                    'Debug.Print "TR OC >" + sLead$ + "< >" + sRest$ + "< >" + sField$ + "<"
                    If Len(sRest$) = 0 Then
                        Exit Do
                    End If
                Loop
TranslateMarc2VoyagerReassemble:
                sOutput$ = sOutput$ + sLead$
                'If Len(sField$) = 0 Then
                '    sField$ = sLead$
                '    Exit Do
                'Else
                '    sField$ = sLead$ + sField$ ' and continue
                'End If
            Loop
            sField$ = sOutput$
        
        ' case "M2O", "O2M": no translation required
    
    End Select
    
    'Debug.Print "TR exit: >" + sField$ + "<"

End Sub

Private Sub Translate880Field(ByVal sxField$, ByVal bChanged As Boolean)

    ' perform a specialized, piece-by-piece translation of the
    '   880 field, skipping altogether those parts of the 880 field
    '   that are marked as being in something other than the
    '   standard character set
    
    Dim sRest$, sField$, sPiece$, sLeft$, sNewField$
    
    Dim sCode$, sNextCode$
    
    Dim iRc%, iCtr%
    
    ' 20011031: completely rewritten to overcome serious bugs in the existing
    '   version (including infinite loop)
    iRc% = InStr(sxField$, MarcEscape)
    If iRc% = 0 Then
        TranslateRemainder sxField$, bChanged
        Exit Sub
    End If
    sPiece$ = Mid(sxField$, 1, iRc% - 1)
    sCode$ = Mid(sxField$, iRc% + 1, 1)
    sField$ = Mid(sxField$, iRc% + 2)
    
        
    Translate880FieldTranslateThePiece sPiece$, bChanged
    
    sNewField$ = sPiece$
    'Debug.Print "Pieces after first piece: >" + sNewField$ + "< >" + sField$ + "<"
    
    ' you now have in sField$ the string following an 'escape' code; handle the remaining bits
    Do
        'Debug.Print "At top of loop:"
        'Debug.Print "   >" + sNewField$ + "< >" + sCode$ + "< >" + sNextCode$ + "<"
        'Debug.Print "   >" + sField$ + "<"
        iRc% = InStr(sField$, MarcEscape)
        If iRc% = 0 Then
            sPiece$ = sField$
            sField$ = ""
        Else
            sPiece$ = Mid(sField$, 1, iRc% - 1)
            sNextCode$ = Mid(sField$, iRc% + 1, 1)
            sField$ = Mid(sField$, iRc% + 2)
        End If
        If InStr("psgb", sCode$) > 0 Then
            Translate880FieldTranslateThePiece sPiece$, bChanged
        'else
            ' leave it alone!
        End If
        sNewField$ = sNewField$ + MarcEscape + sCode$ + sPiece$
        If Len(sField$) = 0 Then
            Exit Do
        End If
        sCode$ = sNextCode$
    Loop
    
    If sNewField$ <> sxField$ Then
        bChanged = True
        sxField$ = sNewField$
    End If
    
    Exit Sub
    
#If False Then
    sField$ = sxField$
    sRest$ = sField$
    sField$ = ""
    sPiece$ = ""
    
    
    ' scan through until you hit the first escape
    '   sequence that goes to one of the weird character
    '   sets: this should be subfield $6 and at least the $a marker, but perhaps
    '   more
    Do
        iRc% = InStr(sRest$, MarcEscape)
        If iRc% = 0 Then
            Exit Do
        End If
        If InStr("bpgs", Mid(sRest$, iRc% + 1, 1)) = 0 Then
            sField$ = sField$ + Mid(sRest$, 1, iRc% - 1)
            sRest$ = Mid(sRest$, iRc%)
            Exit Do
        Else
            sField$ = sField$ + Mid(sRest$, 1, iRc% + 2)
            sRest$ = Mid(sRest, iRc% + 3)
            ' and continue working on the thing
        End If
    Loop
    ' if there is any stuff that comes before the first of the weird
    '   characters (and there should be: subfield $6 if nothing else),
    '   then translate that business
    If Len(sField$) > 0 Then
        For iCtr% = 1 To iCharacterLast%
            TranslateOneCharacter sField$, aCharacter(iCtr%).From, aCharacter(iCtr%).To, bChanged
        Next ' ictr%
        TranslateRemainder sPiece$, bChanged
    End If
    ' you now have in sField the text-up-to-the-first-weird-character-marker,
    '   and in sRest the remainder of the field
    ' run through the remainder, looking for the parts that are "normal"
    '   characters; and translate each of them
    Do
        iRc% = InStr(sRest$, MarcEscape + "(B")
        If iRc% = 0 Then
            Exit Do
        End If
        sField$ = sField$ + Mid(sRest$, 1, iRc% + 2)
        sRest$ = Mid(sRest$, iRc% + 3)
        sPiece$ = ""
        If Len(sRest$) > 0 Then
            Do
                iRc% = InStr(sRest$, MarcEscape)
                If iRc% = 0 Then
                    sPiece$ = sPiece$ + sRest$
                    sRest$ = ""
                    Exit Do
                End If
                If InStr("sbpg", Mid(sRest$, iRc% + 1, 1)) > 0 Then
                    sPiece$ = sPiece$ + Mid(sRest$, 1, iRc%)
                    sPiece$ = Mid(sPiece$, iRc% + 1)
                Else
                    ' some other escape sequence
                    If iRc% > 1 Then
                        sPiece$ = sPiece$ + Mid(sRest$, 1, iRc% - 1)
                        sRest$ = Mid(sRest$, iRc%)
                    End If
                    Exit Do
                End If
            Loop
        Else
            sField$ = sField$
            Exit Do
        End If
        ' you have now in sPiece the characters of interest, if any
        ' and you have in sRest any remaining part of the field
        ' if there is nothing to do, then we must be all done
        If Len(sPiece$) = 0 Then
            sField$ = sLeft$ + sRest$
            Exit Do
        End If
        For iCtr% = 1 To iCharacterLast%
            TranslateOneCharacter sField$, aCharacter(iCtr%).From, aCharacter(iCtr%).To, bChanged
        Next ' ictr%
        TranslateRemainder sPiece$, bChanged
        sField$ = sField$ + sPiece$
    Loop
    
    
    ' make sure you pick up any leftovers
    sField$ = sField$ + sRest$


    If sField$ <> sxField$ Then
        bChanged = True
        sxField$ = sField$
    End If
    
#End If
    
    
End Sub

Private Sub TranslateEverythingExcept880()

    Dim iCtr%
    
    Dim bChanged As Boolean
    
    Dim sField$
    
    FldPointer = m_iFirstField%
    Do
        If FldPointer < 0 Then
            Exit Do
        End If
        If Not FldIsControl Then
            sField$ = FldText
            bChanged = False
            If FldTag <> "880" Then
                For iCtr% = 1 To iCharacterLast%
                    TranslateOneCharacter sField$, aCharacter(iCtr%).From, aCharacter(iCtr%).To, bChanged
                Next ' ictr%
            End If
            If bChanged Then
#If ResetCurrentFieldDebug = -1 Then
                Debug.Print "RCF from TEE880"
#End If
                ResetCurrentField FldTag, FldInd, sField$
                m_bMarcRecordTranslated = True
            End If
        End If
        FldPointer = FldNext
    Loop

End Sub

Private Sub TranslateFieldsWithEscapeCharacters()
    
    Dim bChanged As Boolean
    
    Dim sField$
    
    FldMoveTop
    Do While FldMoveNext
        If Not FldIsControl Then
            sField$ = FldText
            If InStr(sField$, MarcEscape) > 0 Then
                bChanged = False
                If FldTag = "880" Then
                    Translate880Field sField$, bChanged
                Else ' is this an 880 field?
                    TranslateRemainder sField$, bChanged
                End If
                If bChanged Then
#If ResetCurrentFieldDebug = -1 Then
                    Debug.Print "RCF from TFWEC"
#End If
                    ResetCurrentField FldTag, FldInd, sField$
                    m_bMarcRecordTranslated = True
                End If
            'Else field contains no 880 field: it's already been translated
            End If
        End If
    Loop

End Sub

Private Sub TranslateFieldsWithEscapeCharactersTheHardWay()

    Dim bChanged As Boolean
    
    Dim sField$
    
    FldPointer = m_iFirstField%
    Do
        If FldPointer < 0 Then
            Exit Do
        End If
        On Error GoTo TFWECTHWError
        If Not FldIsControl Then
            sField$ = FldText
            bChanged = False
            If FldTag <> "880" Then
                TranslateRemainder sField$, bChanged
            Else
                Translate880Field sField$, bChanged
            End If
            If bChanged Then
#If ResetCurrentFieldDebug = -1 Then
                Debug.Print "RCF from TFWECTHW"
#End If
                ResetCurrentField FldTag, FldInd$, sField$
                m_bMarcRecordTranslated = True
            End If
        End If
        FldPointer = FldNext
    Loop
    
TFWECTHWErrorResume:

    Exit Sub
    
TFWECTHWError:

    Resume TFWECTHWErrorResume
    
End Sub



Public Property Get FldNormNACO() As String

    Dim sTag$, sIndicators$, sField$, sScheme$
    
    sTag$ = MarcArray(FldPointer).Tag
    sIndicators$ = MarcArray(FldPointer).Ind
    sField$ = FldText
    FldNormNACO = NormalizeWholeField(NORMALIZATIONSCHEME_Pcc$, m_sRecordFormat$, sTag$, sIndicators$, sField$)
    
    
End Property


Public Property Get CharacterEncodingScheme() As String

    CharacterEncodingScheme = m_sCharacterEncodingScheme$

End Property

Public Property Get NormalizationScheme() As String

    NormalizationScheme = m_sNormalizationScheme$
    
End Property

Public Property Let NormalizationScheme(ByVal vNewValue As String)

    m_sNormalizationScheme$ = UCase(Mid(Trim(vNewValue), 1, 1)) ' mid ok

    Select Case m_sNormalizationScheme$
        Case NORMALIZATIONSCHEME_Pcc$
        Case NORMALIZATIONSCHEME_Voyager$
        Case Else
            Err.Raise 380, "MarcClass", "Invalid value for NormalizationScheme property", "", 0
    End Select

    MyMarcCharacter.NormalizationScheme = m_sNormalizationScheme$
    
End Property

Public Property Get MarcRecordFormat() As String

    MarcRecordFormat = m_sRecordFormat$
    
End Property


Private Sub TranslateMarc2Utf8()

    Dim iCtr%, iNonfiling%, iIndicator%, iPtr%, iEscape%
    
    Dim bChanged As Boolean, bError As Boolean, m_bUtf8Save As Boolean
    
    Dim sField$, sNonfiling$, sChar$, sPiece$, sRemainder$
    Dim sTag$, sIndicators$
    
    Dim lFldPointer As Long, lFldLast As Long
    
    m_bUtf8Save = m_bUtf8
    m_bUtf8 = True
    
    iPtr% = FldPointer
    
#If TranslateMarc2Utf8Debug = -1 Then
    Debug.Print "TranslateMarc2Utf8 entry with:"
    Debug.Print TextFormatted(HexEquivalents)
#End If

    ' 20060801: save the pointer to the last field in our array, so we can
    '   easily identify fields added as a result of this work (we don't want
    '   to "translate" a field we've already translated once!)
    lFldLast = m_iMarcCtr%
    
    FldMoveTop
    
    Do While FldMoveNext
        ' 20060801: use of fldpointer instituted, so we don't skip over things
        '   when the translation of a field changes its position in the record!
        ' also, we need to skip fields added as a result of the work done here, so that
        '   we do not in effect translate them, then translate them again
#If TranslateMarc2Utf8Debug = -1 Then
        Debug.Print "MovedNext"
        DoEvents
        Debug.Print "Candidate: " + FldTag + ":" + FldTextFormatted(HexEquivalents)
#End If
        lFldPointer = FldPointer
        If lFldPointer >= lFldLast Then
#If TranslateMarc2Utf8Debug = -1 Then
            Debug.Print vbTab + "Skipped because new"
#End If
            GoTo TranslateMarc2Utf8NextField
        End If
        ' 20050719: in previous versions we did not skip deleted
        '   fields. but it turns out that in some instances during the
        '   translation we will end up deleting a field and adding a new field that sorts ahead
        '   of the deleted field; so we keep coming back to the already-deleted field and
        '   deleting it again, ad infinitum
        ' in order for this to work properly, we have disabled the FldUndelete function
        '   as well; once something is gone it's gone
        If FldDeleted Then
#If TranslateMarc2Utf8Debug = -1 Then
            Debug.Print vbTab + "Skipped because deleted"
#End If
            GoTo TranslateMarc2Utf8NextField
        End If
        Select Case FldTag
            Case "005", "006", "007", "008"
                ' these fixed-length fields remain untouched (other 00X fields shouldn't contain any
                '   high-end characters, but we're going on the assumption of bad data,
                '   and we'll translate 'em. if we ever translate such a record back again, we'll catch it then
                ' todo: translate these fields too; but convert any character not in set 1 into
                '   a fill character
            Case Else
                ' including 001, 003: we'll translate these and hope for the best
                FldLoadInfo sTag$, sIndicators$, sField$
#If TranslateMarc2Utf8Debug = -1 Then
                Debug.Print vbTab + "Working with: " + FldTextFormatted(HexEquivalents)
#End If
                TranslateMarc2Utf8OneField MarcRecordFormat, sTag$, sIndicators$, sField$, bChanged, bError ' ignoring value of Error
                If bChanged Then
#If TranslateMarc2Utf8Debug = -1 Then
                    Debug.Print vbTab + "Changed:  >" + sField$ + "<"
#End If
#If FldChangeDebug = -1 Then
                    Debug.Print "FldChange from TM2UTF8"
#End If
                    FldChange sTag$, sIndicators$, sField$
#If TranslateMarc2Utf8Debug = -1 Then
                    Debug.Print vbTab + "FOrmatted:>" + FldTextFormatted(HexEquivalents)
#End If
                    m_bMarcRecordTranslated = True
                End If
        End Select
TranslateMarc2Utf8NextField:
#If TranslateMarc2Utf8Debug = -1 Then
        Debug.Print vbTab + "Ready to reset pointer"
#End If
        FldPointer = lFldPointer
#If TranslateMarc2Utf8Debug = -1 Then
        Debug.Print vbTab + "Pointer reset"
#End If
    Loop
               
    ' Unicode records don't need the 066 field
    Do While FldFindFirst("066")
        FldDelete
    Loop

    ' set leader/09 to 'utf-8' to signal this change
    m_sLeader$ = SafeStuff(m_sLeader$, 10, 1, "a")
    
    FldPointer = iPtr%
    
    m_bUtf8 = m_bUtf8Save
    
    Exit Sub

End Sub

Private Sub MoveMarcDiacritics2Utf8(ByRef sField$, ByRef bChanged As Boolean)

    Dim iRc%, iCtr%, iAsc%
    Dim sLead$, sChar$, sRest$, sInString$, sOutString$, sOutput$, sDiacritics$

    ' simply move the diacritics to their new home; no translation, yet
    
    For iCtr% = 1 To Len(sField$)
        sChar$ = Mid(sField$, iCtr%, 1)
        iAsc% = Asc(sChar$)
        If iAsc% < 224 Then ' non-diacritic
            sOutput$ = sOutput$ + sChar$
            If Len(sDiacritics$) > 0 Then
                sOutput$ = sOutput$ + sDiacritics$
                sDiacritics$ = ""
                bChanged = True
            End If
        Else ' diacritic
            sDiacritics$ = sDiacritics$ + sChar$
        End If
    Next ' ictr%

    If Len(sDiacritics$) > 0 Then
        sOutput$ = sOutput$ + sDiacritics$
        bChanged = True
        sField$ = sOutput$
    ElseIf bChanged Then
        sField$ = sOutput$
    End If
        
End Sub

Private Sub TranslateRemainder2Utf8(ByRef sField$, ByRef bChanged As Boolean)

    Dim iRc%, iCtr%, iAsc%
    Dim sLead$, sChar$, sRest$, sInString$, sOutString$, sOutput$, sDiacritics$

    ' simply move the diacritics to their new home; no translation, yet
    For iCtr% = Len(sField$) To 1 Step -1
        sChar$ = Mid(sField$, iCtr%, 1)
        iAsc% = Asc(sChar$)
        Select Case iAsc%
            Case Is < 224
                sOutput$ = sOutput$ + sChar$
                If Len(sDiacritics$) > 0 Then
                    sOutput$ = sOutput$ + sDiacritics$
                    sDiacritics$ = ""
                    bChanged = True
                End If
            Case Is < 240
                Select Case iAsc%
                    Case 224
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0309")
                    Case 225
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0300")
                    Case 226
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0301")
                    Case 227
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0302")
                    Case 228
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0303")
                    Case 229
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0304")
                    Case 230
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0306")
                    Case 231
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0307")
                    Case 232
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0308")
                    Case 233
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("030C")
                    Case 234
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("030A")
                    Case 235
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("FE20")
                    Case 236
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("FE21")
                    Case 237
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0315")
                    Case 238
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("030B")
                    Case 239
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0310")
                End Select
            Case Else ' < 256
                Select Case iAsc%
                    Case 240
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0327")
                    Case 241
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0328")
                    Case 242
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0323")
                    Case 243
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0324")
                    Case 244
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0325")
                    Case 245
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0333")
                    Case 246
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0332")
                    Case 247
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0326")
                    Case 248
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("031C")
                    Case 249
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("032E")
                    Case 250
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("FE22")
                    Case 251
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("FE23")
                    'Case 252
                    'Case 253
                    Case 254
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.UcsHex2Utf8("0313")
                    'Case 255
                End Select
        End Select
        
    Next ' ictr%

    If Len(sDiacritics$) > 0 Then
        sOutput$ = sOutput$ + sDiacritics$
        bChanged = True
    End If

    sField$ = sDiacritics$
    
End Sub

Private Sub TranslateMarcText2Utf8(ByRef sField$, ByRef bChanged As Boolean)

    ' translate a piece of non-UTF8 text (which might be a single character, a word, or a whole field--
    '   but not a whole record--into UTF8
    
    Dim sOutput$, sChar$, sDiacritics$, sCharacterSet$, sString$
    
    Dim iAsc%
    
    Dim lPtr As Long, lPtr2 As Long, lLen As Long
    
    lLen = Len(sField$)
    
    
    ' now translate the individual characters into Utf8
    lPtr = 1
    Do
        sChar$ = Mid(sField$, lPtr, 1)
        iAsc% = Asc(sChar$)
        Select Case iAsc%
            Case Is < 128
                If iAsc% = 27 Then
                    sCharacterSet$ = Mid(sField$, lPtr + 1, 1)
                    If sCharacterSet$ = "s" Then
                        ' return to standard set: just skip the label and continue
                        lPtr = lPtr + 1
                    Else
                        ' greek, super, sub
                        lPtr = lPtr + 2 ' skip esc and char set label
                        lPtr2 = InStr(Mid(sField$, lPtr), MarcEscape) - 1
                        If lPtr2 < 1 Then
                            lPtr2 = Len(Mid(sField, lPtr))
                        End If
                        sString$ = Mid(sField$, lPtr, lPtr2)
                        ' lPtr now pointing at last char in strung; when we increment, will point to
                        '  next escape and we'll begin again
                        lPtr = lPtr + lPtr2 - 1
                        For lPtr2 = 1 To Len(sString$)
                            sChar$ = Mid(sString$, lPtr2, 1)
                            Select Case sCharacterSet$
                                Case "g"
                                    Select Case sChar$
                                        Case "a"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Alpha
                                            bChanged = True
                                        Case "b"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Beta
                                            bChanged = True
                                        Case "c"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Gamma
                                            bChanged = True
                                    End Select
                                Case "b"
                                    Select Case sChar$
                                        Case "0"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript0
                                            bChanged = True
                                        Case "1"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript1
                                            bChanged = True
                                        Case "2"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript2
                                            bChanged = True
                                        Case "3"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript3
                                            bChanged = True
                                        Case "4"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript4
                                            bChanged = True
                                        Case "5"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript5
                                            bChanged = True
                                        Case "6"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript6
                                            bChanged = True
                                        Case "7"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript7
                                            bChanged = True
                                        Case "8"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript8
                                            bChanged = True
                                        Case "9"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript9
                                            bChanged = True
                                        Case "+"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8SubscriptPlus
                                            bChanged = True
                                        Case "-"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8SubscriptMinus
                                            bChanged = True
                                        Case "("
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8SubscriptParensLeft
                                            bChanged = True
                                        Case ")"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8SubscriptParensRight
                                            bChanged = True
                                    End Select
                                Case "p"
                                    Select Case sChar$
                                        Case "0"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript0
                                            bChanged = True
                                        Case "1"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript1
                                            bChanged = True
                                        Case "2"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript2
                                            bChanged = True
                                        Case "3"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript3
                                            bChanged = True
                                        Case "4"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript4
                                            bChanged = True
                                        Case "5"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript5
                                            bChanged = True
                                        Case "6"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript6
                                            bChanged = True
                                        Case "7"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript7
                                            bChanged = True
                                        Case "8"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript8
                                            bChanged = True
                                        Case "9"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript9
                                            bChanged = True
                                        Case "+"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8SuperscriptPlus
                                            bChanged = True
                                        Case "-"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8SuperscriptMinus
                                            bChanged = True
                                        Case "("
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8SuperscriptParensLeft
                                            bChanged = True
                                        Case ")"
                                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8SuperscriptParensRight
                                            bChanged = True
                                    End Select
                            End Select
                            If Len(sDiacritics$) > 0 Then
                                sOutput$ = sOutput$ + sDiacritics$
                                sDiacritics$ = ""
                                bChanged = True
                            End If
                        Next ' lptr2
                    End If
                Else ' 0 to 127 except for 27
                    sOutput$ = sOutput$ + sChar$
                    If Len(sDiacritics$) > 0 Then
                        sOutput$ = sOutput$ + sDiacritics$
                        sDiacritics$ = ""
                        bChanged = True
                    End If
                End If
            Case Is < 144
                Select Case iAsc%
                    Case 136
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8NonSortBegin
                        bChanged = True
                    Case 137
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8NonSortEnd
                        bChanged = True
                    Case 141
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8JoinerZeroWidth
                        bChanged = True
                    Case 142
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8NonJoinerZeroWidth
                        bChanged = True
                End Select
                If Len(sDiacritics$) > 0 Then
                    sOutput$ = sOutput$ + sDiacritics$
                    sDiacritics$ = ""
                    bChanged = True
                End If
            Case Is < 160
                If CharacterSetIn = "V" Then
                    Select Case iAsc%
                        Case 144
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Degree
                            bChanged = True
                        Case 146
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Pressing
                            bChanged = True
                        Case 147
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Copyright
                            bChanged = True
                        Case 148
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Sharp
                            bChanged = True
                        Case 149
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8QuestionInverted
                            bChanged = True
                        Case 150
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8ExclamationInverted
                            bChanged = True
                    End Select
                End If
                If Len(sDiacritics$) > 0 Then
                    sOutput$ = sOutput$ + sDiacritics$
                    sDiacritics$ = ""
                    bChanged = True
                End If
            Case Is < 176
                Select Case iAsc%
                    Case 160
                        If CharacterSetIn = "V" Then
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8LScript
                            bChanged = True
                        End If
                    Case 161
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8LSlashUpper
                        bChanged = True
                    Case 162
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8OSlashUpper
                        bChanged = True
                    Case 163
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8DSlashUpper
                        bChanged = True
                    Case 164
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8ThornUpper
                        bChanged = True
                    Case 165
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8AEUpper
                        bChanged = True
                    Case 166
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8OEUpper
                        bChanged = True
                    Case 167
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8MiagkiiZnak
                        bChanged = True
                    Case 168
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8DotBelow
                        bChanged = True
                    Case 169
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8Flat
                        bChanged = True
                    Case 170
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8Registered
                        bChanged = True
                    Case 171
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8PlusMinus
                        bChanged = True
                    Case 172
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8OHookUpper
                        bChanged = True
                    Case 173
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8UHookUpper
                        bChanged = True
                    Case 174
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8Alif
                        bChanged = True
                    Case 175
                        If CharacterSetIn = "V" Then
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Alpha
                            bChanged = True
                        End If
                End Select
                If Len(sDiacritics$) > 0 Then
                    sOutput$ = sOutput$ + sDiacritics$
                    sDiacritics$ = ""
                    bChanged = True
                End If
            Case Is < 192
                Select Case iAsc%
                    Case 176
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8Ayn
                        bChanged = True
                    Case 177
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8LSlashLower
                        bChanged = True
                    Case 178
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8OSlashLower
                        bChanged = True
                    Case 179
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8DSlashLower
                        bChanged = True
                    Case 180
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8ThornLower
                        bChanged = True
                    Case 181
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8AELower
                        bChanged = True
                    Case 182
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8OELower
                        bChanged = True
                    Case 183
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8TvyerdiZnak
                        bChanged = True
                    Case 184
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8IDotless
                        bChanged = True
                    Case 185
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8BritishPound
                        bChanged = True
                    Case 186
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8Eth
                        bChanged = True
                    Case 188
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8OHookLower
                        bChanged = True
                    Case 189
                        sOutput$ = sOutput$ + MyMarcCharacter.Utf8UHookLower
                        bChanged = True
                    Case 190
                        Select Case CharacterSetIn
                            Case "O" ' script l
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8LScript
                                bChanged = True
                            Case "V"
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8Beta
                                bChanged = True
                        End Select
                    Case 191
                        If CharacterSetIn = "V" Then
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Gamma
                            bChanged = True
                        End If
                End Select
                If Len(sDiacritics$) > 0 Then
                    sOutput$ = sOutput$ + sDiacritics$
                    sDiacritics$ = ""
                    bChanged = True
                End If
            Case Is < 208
                Select Case CharacterSetIn
                    Case "O", "M"
                        Select Case iAsc%
                            Case 192
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8Degree
                                bChanged = True
                            Case 193 ' doesn't actually exist in oclc
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8LScript
                                bChanged = True
                            Case 194
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8Pressing
                                bChanged = True
                            Case 195
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8Copyright
                                bChanged = True
                            Case 196
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8Sharp
                                bChanged = True
                            Case 197
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8QuestionInverted
                                bChanged = True
                            Case 198
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8ExclamationInverted
                                bChanged = True
                        End Select
                    Case "V"
                        Select Case iAsc%
                            Case 192
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript0
                                bChanged = True
                            Case 193
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript1
                                bChanged = True
                            Case 194
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript2
                                bChanged = True
                            Case 195
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript3
                                bChanged = True
                            Case 196
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript4
                                bChanged = True
                            Case 197
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript5
                                bChanged = True
                            Case 198
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript6
                                bChanged = True
                            Case 199
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript7
                                bChanged = True
                            Case 200
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript8
                                bChanged = True
                            Case 201
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8Superscript9
                                bChanged = True
                            Case 202
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8SuperscriptPlus
                                bChanged = True
                            Case 203
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8SuperscriptMinus
                                bChanged = True
                            Case 204
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8SuperscriptParensLeft
                                bChanged = True
                            Case 205
                                sOutput$ = sOutput$ + MyMarcCharacter.Utf8SuperscriptParensRight
                                bChanged = True
                        End Select
                End Select
                If Len(sDiacritics$) > 0 Then
                    sOutput$ = sOutput$ + sDiacritics$
                    sDiacritics$ = ""
                    bChanged = True
                End If
            Case Is < 224
                If CharacterSetIn = "V" Then
                    Select Case iAsc%
                        Case 208
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript0
                            bChanged = True
                        Case 209
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript1
                            bChanged = True
                        Case 210
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript2
                            bChanged = True
                        Case 211
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript3
                            bChanged = True
                        Case 212
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript4
                            bChanged = True
                        Case 213
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript5
                            bChanged = True
                        Case 214
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript6
                            bChanged = True
                        Case 215
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript7
                            bChanged = True
                        Case 216
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript8
                            bChanged = True
                        Case 217
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8Subscript9
                            bChanged = True
                        Case 218
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8SubscriptPlus
                            bChanged = True
                        Case 219
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8SubscriptMinus
                            bChanged = True
                        Case 220
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8SubscriptParensLeft
                            bChanged = True
                        Case 221
                            sOutput$ = sOutput$ + MyMarcCharacter.Utf8SubscriptParensRight
                            bChanged = True
                    End Select
                End If
                If Len(sDiacritics$) > 0 Then
                    sOutput$ = sOutput$ + sDiacritics$
                    sDiacritics$ = ""
                    bChanged = True
                End If
            Case Is < 240
                Select Case iAsc%
                    Case 224
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8QuestionPseudo
                        bChanged = True
                    Case 225
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8Grave
                        bChanged = True
                    Case 226
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8Acute
                        bChanged = True
                    Case 227
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8Circumflex
                        bChanged = True
                    Case 228
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8Tilde
                        bChanged = True
                    Case 229
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8Macron
                        bChanged = True
                    Case 230
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8Breve
                        bChanged = True
                    Case 231
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8DotAbove
                        bChanged = True
                    Case 232
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8Umlaut
                        bChanged = True
                    Case 233
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8Hacek
                        bChanged = True
                    Case 234
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8Angstrom
                        bChanged = True
                    Case 235
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8LigatureLeft
                        bChanged = True
                    Case 236
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8LigatureRight
                        bChanged = True
                    Case 237
                        ' 20040212: in the previous version, there was a note saying 'this one does not change
                        '   position'; and adding the character to output instead of diacritics; it
                        '   is not clear why this was so, and because it's a combining mark i've put it
                        '   with the other diacritics
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8CommaHighOffCenter
                        bChanged = True
                    Case 238
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8AcuteDouble
                        bChanged = True
                    Case 239
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8Candrabindu
                        bChanged = True
                End Select
            Case Else
                Select Case iAsc%
                    Case 240
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8Cedilla
                        bChanged = True
                    Case 241
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8HookRight
                        bChanged = True
                    Case 242
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8DotBelow
                        bChanged = True
                    Case 243
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8DotBelowDouble
                        bChanged = True
                    Case 244
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8CircleBelow
                        bChanged = True
                    Case 245
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8UnderscoreDouble
                        bChanged = True
                    Case 246
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8Underscore
                        bChanged = True
                    Case 247
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8HookLeft
                        bChanged = True
                    Case 248
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8CedillaRight
                        bChanged = True
                    Case 249
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8Upadhmaniya
                        bChanged = True
                    Case 250
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8TildeDoubleLeft
                        bChanged = True
                    Case 251
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8TildeDoubleRight
                        bChanged = True
                    Case 254
                        sDiacritics$ = sDiacritics$ + MyMarcCharacter.Utf8CommaHighCentered
                        bChanged = True
                End Select
        End Select
        lPtr = lPtr + 1
        If lPtr > lLen Then
            Exit Do
        End If
    Loop
    
    If Len(sDiacritics$) > 0 Then
        sOutput$ = sOutput$ + sDiacritics$
        bChanged = True
    End If
    
    If bChanged Then
        sField$ = sOutput$
    End If
    
   
End Sub

Private Sub TranslateMarc880Field2Utf8(ByRef sField$, ByRef bChanged As Boolean)

    ' perform a specialized, piece-by-piece translation of the
    '   880 field, skipping altogether those parts of the 880 field
    '   that are marked as being in something other than the
    '   marc-8 character set (these are already in utf-8)
    
    Dim sRest$, sPiece$, sLeft$, sNewField$
    
    Dim sCode$, sNextCode$
    
    Dim iRc%, iCtr%
    
    ' 20011031: completely rewritten to overcome serious bugs in the existing
    '   version (including infinite loop)
     
    iRc% = InStr(sField$, MarcEscape)
    If iRc% = 0 Then ' most common case: no escape sequences
        TranslateMarcText2Utf8 sField$, bChanged
        Exit Sub
    End If
    sPiece$ = Mid(sField$, 1, iRc% - 1)
    sCode$ = Mid(sField$, iRc% + 1, 1)
    sField$ = Mid(sField$, iRc% + 2)
    
    ' this first piece must be in the native character set
    TranslateMarcText2Utf8 sPiece$, bChanged
    
    sNewField$ = sPiece$
    
    ' you now have in sField$ the string following an 'escape' code, and in sCode the escape
    '   character itself; handle the remaining bits
    Do
        iRc% = InStr(sField$, MarcEscape)
        If iRc% = 0 Then
            sPiece$ = sField$
            sField$ = ""
        Else
            sPiece$ = Mid(sField$, 1, iRc% - 1)
            sNextCode$ = Mid(sField$, iRc% + 1, 1)
            sField$ = Mid(sField$, iRc% + 2)
        End If
        Select Case sCode$
            Case "s"
                TranslateMarcText2Utf8 sPiece$, bChanged
            Case "p"
            Case "b"
            Case "g"
            'Case Else
                ' leave alone!
        End Select
        
        
        If InStr("psgb", sCode$) > 0 Then
            ' 20091207: gosub that is only used once
            '   changed to inline code
            'GoSub TranslateMarc880Field2Utf8OnePiece
            For iCtr% = 1 To iCharacterLast%
                TranslateMarcText2Utf8 sPiece$, bChanged
            Next ' ictr%
        'else
            ' leave it alone!
        End If
        sNewField$ = sNewField$ + MarcEscape + sCode$ + sPiece$
        If Len(sField$) = 0 Then
            Exit Do
        End If
        sCode$ = sNextCode$
    Loop
    
    If sNewField$ <> sField$ Then
        bChanged = True
        sField$ = sNewField$
    End If
    
    Exit Sub
    
    
#If False Then
TranslateMarc880Field2Utf8OnePiece:

    For iCtr% = 1 To iCharacterLast%
        TranslateMarcText2Utf8 sPiece$, bChanged
    Next ' ictr%
    
    Return
#End If

End Sub

Private Sub TranslateUtf82Marc()

    Dim iPtr%, iCtr%, iNonfiling%, iIndicator%
    
    Dim bChanged As Boolean, bError As Boolean
    
    Dim sTag$, sIndicators$, sField$, sNonfiling$, sChar$, sCharacterSetsPresent$, s066$, sPiece$
    
    Dim lLast As Long, lFldPointer As Long
    
    
#If TranslateUtf8ToMarcDebug = -1 Then
    Debug.Print "*****************************"
    Debug.Print "TranslateUtf82Marc entry"
#End If

    iPtr% = FldPointer
    
    lLast = m_iMarcCtr%
    FldMoveTop
    Do While FldMoveNext
        lFldPointer = FldPointer
#If TranslateUtf8ToMarcTextDebug = -1 Then
        Debug.Print "last " + str(lLast) + " current " + str(lFldPointer) + " deleted " + str(FldDeleted) + " " + FldTag + ":" + FldTextFormatted(HexEquivalents)
#End If
        If lFldPointer < lLast And Not FldDeleted Then
            Select Case FldTag
                Case "000" To "009"
                    ' these remain untouched
                Case Else
                    FldLoadInfo sTag$, sIndicators$, sField$
                    TranslateUtf82MarcOneField sCharacterSetsPresent$, sTag$, sField$, bChanged, bError
                    If bChanged Then
                        FldText = sField$
                        m_bMarcRecordTranslated = True
                    End If
            End Select
        End If
        FldPointer = lFldPointer
    Loop
    
    ' convert the string of codes representing character sets present in the record into
    '   an 066 field, and add it to the record
    ' remove any existing 066 fields
    FldMoveTop
    Do While FldFindFirst("066")
        FldDelete
    Loop
    
    ' remove multiple spaces from the string
    sCharacterSetsPresent$ = RemoveRepeatedCharacters(Trim(sCharacterSetsPresent$), " ")
    s066$ = TranslateUtf82MarcCharacterSetString(sCharacterSetsPresent$, MyMarcCharacter.MarcDelimiter + "c")
    
    If Len(s066$) > 0 Then
        ' 20060724: delete any 066 that Endeavor in its "wisdom" didn't delete
        '   when it converted a database to Unicode
        FldAddGeneric "066", "  ", s066$, 3
    End If
    
    ' this is now a non-UTF8 record
    m_sLeader$ = SafeStuff(m_sLeader$, 10, 1, " ")

    FldPointer = iPtr%
    
#If TranslateUtf8ToMarcDebug = -1 Then
    Debug.Print "TranslateUtf82Marc exit"
    Debug.Print "*****************************"
#End If
    
End Sub

Private Sub TranslateUtf8880Field2Marc(ByRef sxField$, ByRef bChanged As Boolean)
    
    ' 20050722: as far as I can tell, this private routine is never invoked;
    '   so there's no reason to keep it around
    
#If False Then

    ' perform a specialized, piece-by-piece translation of the
    '   880 field, skipping altogether those parts of the 880 field
    '   that are marked as being in something other than the
    '   standard character set
    
    Dim sRest$, sPiece$, sLeft$, sNewField$, sField$
    
    Dim sCode$, sNextCode$
    
    Dim iRc%, iCtr%
    
    'Debug.Print "Trans: >" + sxField$ + "<"
    
    ' 20011031: completely rewritten to overcome serious bugs in the existing
    '   version (including infinite loop)
    iRc% = InStr(sxField$, MarcEscape)
    If iRc% = 0 Then
        sPiece$ = sxField$
        GoSub TranslateMarc880Field2Utf8OnePiece
        sxField$ = sPiece$
        'TranslateUtf8Text2Marc sxField$, bChanged
        Exit Sub
    End If
    sPiece$ = Mid(sxField$, 1, iRc% - 1)
    sCode$ = Mid(sxField$, iRc% + 1, 1)
    sField$ = Mid(sxField$, iRc% + 2)
    
    GoSub TranslateMarc880Field2Utf8OnePiece
    
    sNewField$ = sPiece$
    
    ' you now have in sField$ the string following an 'escape' code; handle the remaining bits
    Do
        iRc% = InStr(sField$, MarcEscape)
        If iRc% = 0 Then
            sPiece$ = sField$
            sField$ = ""
        Else
            sPiece$ = Mid(sField$, 1, iRc% - 1)
            sNextCode$ = Mid(sField$, iRc% + 1, 1)
            sField$ = Mid(sField$, iRc% + 2)
        End If
        If InStr("psgb", sCode$) > 0 Then
            GoSub TranslateMarc880Field2Utf8OnePiece
        'else
            ' leave it alone!
        End If
        sNewField$ = sNewField$ + MarcEscape + sCode$ + sPiece$
        If Len(sField$) = 0 Then
            Exit Do
        End If
        sCode$ = sNextCode$
    Loop
    
    If sNewField$ <> sxField$ Then
        bChanged = True
        sxField$ = sNewField$
    End If
    
    Exit Sub
    
    
TranslateMarc880Field2Utf8OnePiece:

    For iCtr% = 1 To iCharacterLast%
        TranslateUtf8Text2Marc sPiece$, bChanged
    Next ' ictr%
    
    Return

#End If

End Sub

Public Sub FldChange(ByVal sTag$, ByVal sIndicators$, ByVal sField$)

    ' changes the tag, indicators and field text of the current field array element
    
    'Debug.Print "Fld change entry " + str(FldPointer) + " " + sTag$ + ":" + sIndicators$ + ":" + sField$
    
    If FldPointer > -1 Then
#If ResetCurrentFieldDebug = -1 Then
        Debug.Print "RCF from fldChange"
#End If
        ResetCurrentField sTag$, sIndicators$, sField$
    End If

End Sub

Public Property Get TextFormatted(Optional ByVal iOutput As TextFormattedType = TextFormattedDefault, Optional ByVal iFixedFieldFormat As FixedFieldDisplayType = OclcMonospaced, Optional ByVal sTagList$ = "", Optional bIncludeRtfWrapper As Boolean = True, Optional ByVal iRtfFontSizeInPoints% = 10) As String

    ' provides the current record in flattened "text" format
    
    ' 20050317: option for OCLC-style fixed fields added (took a while to elaborate fully)
    ' 20060529: optional tag list parameter added to produce abbreviated lists
    ' 20070522: changed default display from NOTIS to OCLC monospaced
    
#If True Then

    ' experimental version, trying (for RTF) for different font for monospaced fixed fields
    
    Dim sOutput$, sTag$, sIndicators$, sField$, s008$, sLineBreak$
    Dim sFontTbl$, sColorTbl$, sStyleSheet$
    
    Dim iRc%, iCtr%, iLeftIndent%, iFieldNumber%
    
    Dim lFieldPointer As Long, lPtr2 As Long
    
    Dim bTagList As Boolean, bRTF As Boolean, bWhiteBackground As Boolean
    
    
    If iOutput = TextFormatted_RtfText% Or iOutput = TextFormatted_RtfTextWithLabels% Or iOutput = TextFormatted_RtfTextNormalizedPlain% Or iOutput = TextFormatted_RtfTextNormalizedNaco% Then
        If bIncludeRtfWrapper Then
            bRTF = True
        End If
        sLineBreak$ = "\par " ' changing this has follow-on effects for other things!  be cautious!
    Else
        sLineBreak$ = vbCrLf
    End If
    
    If Len(sTagList$) > 0 Then
        bTagList = True
    End If
    
    On Error GoTo 0
    
    ' save the current field pointer!
    lFieldPointer = FldPointer
    
    If iOutput = TextFormatted_Raw% Then
        If bTagList Then
            If InStr(sTagList$, "000") = 0 Then
                GoTo TextFormattedNoLeader
            End If
        End If
        sOutput$ = " 000" + "     " + m_sLeader$
TextFormattedNoLeader:
    Else
        If bTagList Then
            If InStr(sTagList$, "008") = 0 Then
                GoTo TextFormattedNo008
            End If
        End If
        ' isolate the 008 field
        FldFindFirst "008"
        If FldWasFound Then
            ' the beginning part of the output string is made up of "fixed fields" drawn
            '   from the leader and 008 fields
            s008$ = FldText
            ' replace fills with question marks
            Do
                iRc% = InStr(s008$, MyMarcCharacter.MarcFill)
                If iRc% = 0 Then
                    Exit Do
                End If
                s008$ = SafeStuff(s008$, iRc%, 1, "?")
            Loop
            Select Case iFixedFieldFormat
                Case FixedFieldDisplay_NOTIS%
                    Select Case m_sRecordFormat$
                        Case "A"
                            If bRTF Then
                                sOutput$ = "\f1"
                            End If
                            sOutput$ = sOutput$ + "RT" + " " + Mid(m_sLeader$, 7, 1) + " STAT" + " " + Mid(m_sLeader$, 6, 1) + " E/LVL" + " " + Mid(m_sLeader$, 18, 1) + " CHAR " + Mid(m_sLeader$, 10, 1) + " "
                            ' 008/8, 008/17
                            sOutput$ = sOutput$ + "FMT" + " " + "A " + " LANG" + " " + Mid(s008$, 9, 1) + " SUBD" + " " + Mid(s008$, 18, 1) + sLineBreak$
                            ' 008/39, 008/7, 008/38, 008/32
                            sOutput$ = sOutput$ + "SRC" + " " + Mid(s008$, 40, 1) + " ROM" + " " + Mid(s008$, 8, 1) + " MOD" + " " + Mid(s008$, 39, 1) + " UNIQUE" + " " + Mid(s008$, 33, 1)
                            ' 008/28, 008/11, 008/6
                            sOutput$ = sOutput$ + " GOVT" + " " + Mid(s008$, 29, 1) + " S/SYS" + " " + Mid(s008$, 12, 1) + " D/I" + " " + Mid(s008$, 7, 1)
                            ' 008/13, 008/12
                            sOutput$ = sOutput$ + " NUM" + " " + Mid(s008$, 14, 1) + " S/TYP" + " " + Mid(s008$, 13, 1) + sLineBreak$
                            ' 008/14, 008/15, 008/16
                            sOutput$ = sOutput$ + "NAME" + " " + Mid(s008$, 15, 1) + " SUBJ" + " " + Mid(s008$, 16, 1) + " SER" + " " + Mid(s008$, 17, 1)
                            ' 008/9, 008/33, 008/29
                            sOutput$ = sOutput$ + " KIND" + " " + Mid(s008$, 10, 1) + " H/ESTAB" + " " + Mid(s008$, 34, 1) + " T/EVAL" + " " + Mid(s008$, 30, 1)
                            ' 008/31/, 008/10
                            sOutput$ = sOutput$ + " IP" + " " + Mid(s008$, 32, 1) + " RULES" + " " + Mid(s008$, 11, 1)
                        Case "B", "D", "F", "M", "P", "S", "U"
                            sOutput$ = " RT" + " " + Mid(m_sLeader$, 7, 1) + " BL" + " " + Mid(m_sLeader$, 8, 1) + " STAT" + " " + Mid(m_sLeader$, 6, 1) + " E/LVL" + " " + Mid(m_sLeader$, 18, 1) + " DCF " + Mid(m_sLeader$, 19, 1) + " CHAR " + Mid(m_sLeader$, 10, 1) + sLineBreak$
                            Select Case Mid(m_sLeader$, 7, 1)
                                Case "a", "t" ' B or S
                                    'Debug.Print "B or s"
                                    If SerialBibliographicRecord(m_sLeader$) Then
                                    'If InStr("bs", Mid(m_sleader$, 8, 1)) > 0 Then
                                        ' 20070522: original code includes sOutput twice!
                                        'sOutput$ = sOutput$ + "FMT" + " " + "S " + sOutput$ + " SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + " OA" + " " + Mid(s008$, 34, 1) + " REPRO" + " " + Mid(s008$, 24, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4) + sLineBreak$
                                        sOutput$ = "FMT" + " " + "S " + sOutput$ + "SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + " OA" + " " + Mid(s008$, 34, 1) + " REPRO" + " " + Mid(s008$, 24, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4) + sLineBreak$
                                        sOutput$ = sOutput$ + "CONT" + " " + Mid(s008$, 25, 4) + " S/T" + " " + Mid(s008$, 22, 1) + " FREQ" + " " + Mid(s008$, 19, 1) + " REG" + " " + Mid(s008$, 20, 1) + " MED" + " " + Mid(s008$, 23, 1) + " GOVT" + " " + Mid(s008$, 29, 1) + " ISDS" + " " + Mid(s008$, 21, 1) + " CONF" + " " + Mid(s008$, 30, 1) + " SLE" + " " + Mid(s008$, 35, 1) + sLineBreak$
                                    Else
                                        ' 20070522: original code includes sOutput twice!
                                        'sOutput$ = sOutput$ + "FMT" + " " + "B " + sOutput$ + " SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + " T/AUD" + " " + Mid(s008$, 23, 1) + " REPRO" + " " + Mid(s008$, 24, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4) + sLineBreak$
                                        sOutput$ = "FMT" + " " + "B " + sOutput$ + "SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + " T/AUD" + " " + Mid(s008$, 23, 1) + " REPRO" + " " + Mid(s008$, 24, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4) + sLineBreak$
                                        sOutput$ = sOutput$ + "CONT" + " " + Mid(s008$, 25, 4) + " ILLUS" + " " + Mid(s008$, 19, 4) + " GOVT" + " " + Mid(s008$, 29, 1) + " BIOG" + " " + Mid(s008$, 35, 1) + " FEST" + " " + Mid(s008$, 31, 1) + " CONF" + " " + Mid(s008$, 30, 1) + " LITF" + " " + Mid(s008$, 34, 1) + " INDX" + " " + Mid(s008$, 32, 1) + sLineBreak$
                                    End If
                                Case "m" ' D
                                    sOutput$ = sOutput$ + "FMT" + " " + "D " + sOutput$ + "SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + " T/AUD" + " " + Mid(s008$, 23, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4) + sLineBreak$
                                    sOutput$ = sOutput$ + "DF/TYP" + " " + Mid(s008$, 27, 1) + " GOVT" + " " + Mid(s008$, 29, 1)
                                Case "g", "k", "o", "r" ' F
                                    sOutput$ = sOutput$ + "FMT" + " " + "F " + sOutput$ + "SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + "T/AUD" + " " + Mid(s008$, 22, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4) + sLineBreak$
                                    sOutput$ = sOutput$ + "T/MAT" + " " + Mid(s008$, 34, 1) + " TECH" + " " + Mid(s008$, 35, 1) + " GOVT" + " " + Mid(s008$, 29, 1) + " A/MAT" + " " + Mid(s008$, 23, 5) + " R/TIME" + " " + Mid(s008$, 19, 3)
                                Case "c", "d", "i", "j" ' M
                                    sOutput$ = sOutput$ + "FMT" + " " + "M " + sOutput$ + " SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + " T/AUD" + " " + Mid(s008$, 23, 1) + " REPRO" + " " + Mid(s008$, 24, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4) + sLineBreak$
                                    sOutput$ = sOutput$ + "F/COMP" + " " + Mid(s008$, 19, 2) + " SCORE" + " " + Mid(s008$, 21, 1) + " A/MAT" + " " + Mid(s008$, 25, 6) + " L/TEXT" + " " + Mid(s008$, 31, 2)
                                Case "e", "f" ' P
                                    sOutput$ = sOutput$ + "FMT" + " " + "P " + sOutput$ + " SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + "CM/TYP" + " " + Mid(s008$, 25, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4) + sLineBreak$
                                    sOutput$ = sOutput$ + "BME" + " " + Mid(s008$, 23, 3) + " RELIEF" + " " + Mid(s008$, 19, 4) + " SP/FORM" + " " + Mid(s008$, 34, 2) + " GOVT" + " " + Mid(s008$, 29, 1) + " INDX" + " " + Mid(s008$, 32, 1)
                                Case "b", "p" ' U: archival/mixed materials
                                    sOutput$ = sOutput$ + "FMT" + " " + "U " + sOutput$ + " SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + " REPRO" + " " + Mid(s008$, 24, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4) + sLineBreak$
                            End Select
                        Case "H"
                            sOutput$ = "FMT" + " " + "H RT" + " " + Mid(m_sLeader$, 7, 1) + " STAT" + " " + Mid(m_sLeader$, 6, 1) + " E/LVL" + " " + Mid(m_sLeader$, 18, 1) + " CHAR " + Mid(m_sLeader$, 10, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "R/STAT" + " " + Mid(s008$, 7, 1) + " MTHD" + " " + Mid(s008$, 8, 1) + " DT/CAN" + " " + Mid(s008$, 9, 4) + " G/RTN" + " " + Mid(s008$, 13, 1) + " S/RTN" + " " + Mid(s008$, 14, 3) + " CMPLT" + " " + Mid(s008$, 17, 1) + " LEND" + " " + Mid(s008$, 21, 1) + " REPOL" + " " + Mid(s008$, 22, 1) + " LAN" + " " + Mid(s008$, 23, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "SEP/COMP" + " " + Mid(s008$, 26, 1) + " RPT/DT" + " " + Mid(s008$, 27, 6)
                        Case Else ' including community information and classification
                            sOutput$ = sOutput$ + vbCr$ + vbLf$ + s008$
                    End Select
                Case FixedFieldDisplay_OCLC%
TextFormatted_MonospacedNotYetDefined:
                    Select Case m_sRecordFormat$
                        Case "A"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + " Entered: " + Mid(s008$, 1, 6) + " Char: " + Mid(m_sLeader$, 10, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + Mid(m_sLeader$, 7, 1) + " Upd status: " + Mid(s008$, 32, 1) + " Enc lvl: " + Mid(m_sLeader$, 18, 1) + " Source: " + Mid(s008$, 40, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Roman: " + Mid(s008$, 8, 1) + " Ref status: " + Mid(s008$, 30, 1) + " Mod rec: " + Mid(s008$, 39, 1) + " Name use: " + Mid(s008$, 15, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Govt agn: " + Mid(s008$, 29, 1) + " Auth status: " + Mid(s008$, 34, 1) + " Subj: " + Mid(s008$, 12, 1) + " Subj use: " + Mid(s008$, 16, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Series: " + Mid(s008$, 13, 1) + " Auth/ref: " + Mid(s008$, 10, 1) + " Geo subd: " + Mid(s008$, 7, 1) + " Ser use: " + Mid(s008$, 17, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Ser num: " + Mid(s008$, 14, 1) + " Name: " + Mid(s008$, 33, 1) + " Subdiv tp: " + Mid(s008$, 18, 1) + " Rules: " + Mid(s008$, 11, 1) + sLineBreak$
                        Case "B"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + " Entered: " + Mid(s008$, 1, 6) + " Char: " + Mid(m_sLeader$, 10, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + Mid(m_sLeader$, 7, 1) + " ELvl: " + Mid(m_sLeader$, 18, 1) + " Srce: " + Mid(s008$, 40, 1) + " Audn: " + Mid(s008$, 23, 1) + " Ctrl: " + Mid(m_sLeader$, 9, 1) + " Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + Mid(m_sLeader$, 8, 1) + " Form: " + Mid(s008$, 24, 1) + " Conf: " + Mid(s008$, 30, 1) + " Biog: " + Mid(s008$, 35, 1) + " MRec: " + Mid(s008$, 39, 1) + " Ctry: " + Mid(s008$, 16, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "Cont: " + Mid(s008$, 25, 4) + " GPub: " + Mid(s008$, 29, 1) + " LitF: " + Mid(s008$, 34, 1) + " Indx: " + Mid(s008$, 32, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + " Ills: " + Mid(s008$, 19, 4) + " Fest: " + Mid(s008$, 31, 1) + " DtSt: " + Mid(s008$, 7, 1) + " Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                        Case "D"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + " Entered: " + Mid(s008$, 1, 6) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + " ELvl: " + Mid(m_sLeader$, 18, 1) + " Srce: " + Mid(s008$, 40, 1) + " Audn: " + " " + Mid(s008$, 23, 1) + " Ctrl: " + Mid(m_sLeader$, 9, 1) + " Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + " File: " + Mid(s008$, 27, 1) + " GPub: " + Mid(s008$, 29, 1) + " MRec: " + " " + Mid(s008$, 39, 1) + " Ctry: " + " " + Mid(s008$, 16, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + " DtSt: " + Mid(s008$, 7, 1) + " Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                        Case "F"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + " Entered: " + Mid(s008$, 1, 6) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + Mid(m_sLeader$, 7, 1) + " ELvl: " + Mid(m_sLeader$, 18, 1) + " Srce: " + Mid(s008$, 40, 1) + " Audn: " + " " + Mid(s008$, 23, 1) + " Ctrl: " + Mid(m_sLeader$, 9, 1) + " Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + Mid(m_sLeader$, 8, 1) + " Form: " + " GPub: " + Mid(s008$, 29, 1) + " Time: " + Mid(s008$, 19, 3) + " MRec: " + Mid(s008$, 39, 1) + " Ctry: " + Mid(s008$, 16, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + " TMat: " + Mid(s008$, 34, 1) + " Tech: " + " " + Mid(s008$, 35, 1) + " DtSt: " + Mid(s008$, 7, 1) + " Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                        Case "H"
                            ' 20050317: there is no OCLC convention for this so we're going to use NOTIS
                            '   conventions and people can complain all they want
                            sOutput$ = "FMT" + " " + "H RT" + " " + Mid(m_sLeader$, 7, 1) + " STAT" + " " + Mid(m_sLeader$, 6, 1) + " E/LVL" + " " + Mid(m_sLeader$, 18, 1) + " CHAR " + Mid(m_sLeader$, 10, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "R/STAT" + " " + Mid(s008$, 7, 1) + " MTHD" + " " + Mid(s008$, 8, 1) + " DT/CAN" + " " + Mid(s008$, 9, 4) + " G/RTN" + " " + Mid(s008$, 13, 1) + " S/RTN" + " " + Mid(s008$, 14, 3) + " CMPLT" + " " + Mid(s008$, 17, 1) + " LEND" + " " + Mid(s008$, 21, 1) + " REPOL" + " " + Mid(s008$, 22, 1) + " LAN" + " " + Mid(s008$, 23, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "SEP/COMP" + " " + Mid(s008$, 26, 1) + " RPT/DT" + " " + Mid(s008$, 27, 6)
                        Case "M"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + " Entered: " + Mid(s008$, 1, 6) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + " ELvl: " + Mid(m_sLeader$, 18, 1) + " Srce: " + Mid(s008$, 40, 1) + " Audn: " + " " + Mid(s008$, 23, 1) + " Ctrl: " + Mid(m_sLeader$, 9, 1) + " Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + Mid(m_sLeader$, 8, 1) + " Form: " + Mid(s008$, 21, 1) + " Comp: " + " " + Mid(s008$, 19, 2) + " AccM: " + Mid(s008$, 25, 6) + " MRec: " + Mid(s008$, 39, 1) + " Ctry: " + Mid(s008$, 16, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + " FMus: " + " LTxt: " + Mid(s008$, 31, 2) + " DtSt: " + Mid(s008$, 7, 1) + " Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                        Case "P"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + " Entered: " + Mid(s008$, 1, 6) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + Mid(m_sLeader$, 7, 1) + " ELvl: " + Mid(m_sLeader$, 18, 1) + " Srce: " + Mid(s008$, 40, 1) + " Relf: " + Mid(s008$, 19, 4) + " Ctrl: " + Mid(m_sLeader$, 9, 1) + " Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + Mid(m_sLeader$, 8, 1) + " Form: " + Mid(s008$, 24, 1) + " GPub: " + Mid(s008$, 29, 1) + " SpFm: " + " " + Mid(s008$, 34, 2) + " MRec: " + Mid(s008$, 39, 1) + " Ctry: " + Mid(s008$, 16, 3)
                            sOutput$ = sOutput$ + "CrTp: " + Mid(s008$, 25, 1) + " Indx: " + Mid(s008$, 32, 1) + " Proj: " + Mid(s008$, 23, 2) + " DtSt: " + Mid(s008$, 7, 1) + " Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + sLineBreak$
                        Case "S"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + " Entered: " + Mid(s008$, 1, 6) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + Mid(m_sLeader$, 7, 1) + " ELvl: " + Mid(m_sLeader$, 18, 1) + " Srce: " + Mid(s008$, 40, 1) + " GPub: " + Mid(s008$, 29, 1) + " Ctrl: " + "Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + Mid(m_sLeader$, 8, 1) + " Form: " + Mid(s008$, 24, 1) + " Conf: " + Mid(s008$, 30, 1) + " Freq: " + " " + Mid(s008$, 19, 1) + " MRec: " + Mid(s008$, 39, 1) + " Ctry: " + Mid(s008$, 16, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "S/L: " + Mid(s008$, 35, 1) + " Orig: " + Mid(s008$, 23, 1) + "EntW: " + Mid(s008$, 25, 1) + " Regl: " + Mid(s008$, 20, 1) + " ISSN: " + Mid(s008$, 21, 1) + " Alph: " + Mid(s008$, 34, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + " SrTp: " + Mid(s008$, 22, 1) + " Cont: " + Mid(s008$, 26, 3) + " DtSt: " + Mid(s008$, 7, 1) + " Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                        Case "U"
                            ' 20050317: didn't yet bother to get the OCLC version of this
                            sOutput$ = "FMT" + " " + "U " + sOutput$ + " SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + " REPRO" + " " + Mid(s008$, 24, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4)
                        Case Else
                            ' community information?  classification?
                            sOutput$ = sOutput$ + vbCr$ + sLineBreak$ + s008$
                    End Select
                Case FixedFieldDisplay_OCLCMonospaced%
                    Select Case m_sRecordFormat$
                        Case "A"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + "  Entered: " + Mid(s008$, 1, 6) + " Char:      " + Mid(m_sLeader$, 10, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Type:     " + Mid(m_sLeader$, 7, 1) + "  Upd status:  " + Mid(s008$, 32, 1) + "  Enc lvl:   " + Mid(m_sLeader$, 18, 1) + "  Source:   " + Mid(s008$, 40, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Roman:    " + Mid(s008$, 8, 1) + "  Ref status:  " + Mid(s008$, 30, 1) + "  Mod rec:   " + Mid(s008$, 39, 1) + "  Name use: " + Mid(s008$, 15, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Govt agn: " + Mid(s008$, 29, 1) + "  Auth status: " + Mid(s008$, 34, 1) + "  Subj:      " + Mid(s008$, 12, 1) + "  Subj use: " + Mid(s008$, 16, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Series:   " + Mid(s008$, 13, 1) + "  Auth/ref:    " + Mid(s008$, 10, 1) + "  Geo subd:  " + Mid(s008$, 7, 1) + "  Ser use:  " + Mid(s008$, 17, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Ser num:  " + Mid(s008$, 14, 1) + "  Name:        " + Mid(s008$, 33, 1) + "  Subdiv tp: " + Mid(s008$, 18, 1) + "  Rules:    " + Mid(s008$, 11, 1) + sLineBreak$
                        Case "B"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + "  Entered: " + Mid(s008$, 1, 6) + "  Char:    " + Mid(m_sLeader$, 10, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + Mid(m_sLeader$, 7, 1) + "  ELvl: " + Mid(m_sLeader$, 18, 1) + "     Srce: " + Mid(s008$, 40, 1) + "  Audn: " + Mid(s008$, 23, 1) + "  Ctrl: " + Mid(m_sLeader$, 9, 1) + "  Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + Mid(m_sLeader$, 8, 1) + "  Form: " + Mid(s008$, 24, 1) + "     Conf: " + Mid(s008$, 30, 1) + "  Biog: " + Mid(s008$, 35, 1) + "  MRec: " + Mid(s008$, 39, 1) + "  Ctry: " + Mid(s008$, 16, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "         Cont: " + Mid(s008$, 25, 4) + "  GPub: " + Mid(s008$, 29, 1) + "  LitF: " + Mid(s008$, 34, 1) + "  Indx: " + Mid(s008$, 32, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + "  Ills: " + Mid(s008$, 19, 4) + "  Fest: " + Mid(s008$, 31, 1) + "  DtSt: " + Mid(s008$, 7, 1) + "  Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                        Case "D"
                            ' not defined yet: use non-monospaced
                            GoTo TextFormatted_MonospacedNotYetDefined
                        Case "F"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + "  Entered: " + Mid(s008$, 1, 6) + "  Char:    " + Mid(m_sLeader$, 10, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + Mid(m_sLeader$, 7, 1) + "  ELvl: " + Mid(m_sLeader$, 18, 1) + "  Srce: " + Mid(s008$, 40, 1) + "  Audn: " + Mid(s008$, 23, 1) + "    Ctrl: " + Mid(m_sLeader$, 9, 1) + "  Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + Mid(m_sLeader$, 8, 1) + "  Form: " + Mid(s008$, 30, 1) + "  GPub: " + Mid(s008$, 29, 1) + "  Time: " + Mid(s008$, 19, 3) + "  MRec: " + Mid(s008$, 39, 1) + "  Ctry: " + Mid(s008$, 16, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + "  TMat: " + Mid(s008$, 34, 1) + "  Tech: " + Mid(s008$, 35, 1) + "  DtSt: " + Mid(s008$, 7, 1) + "    Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                        Case "M"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + "  Entered: " + Mid(s008$, 1, 6) + "  Char:    " + Mid(m_sLeader$, 10, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + Mid(m_sLeader$, 7, 1) + "  ELvl: " + Mid(m_sLeader$, 18, 1) + "  Srce: " + Mid(s008$, 40, 1) + "   Audn: " + Mid(s008$, 23, 1) + "       Ctrl: " + Mid(m_sLeader$, 9, 1) + "  Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + Mid(m_sLeader$, 8, 1) + "  Form: " + Mid(s008$, 30, 1) + "  Comp: " + Mid(s008$, 19, 2) + "  AccM: " + Mid(s008$, 25, 6) + "  MRec: " + Mid(s008$, 39, 1) + "  Ctry: " + Mid(s008$, 16, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "       " + "  Part: " + Mid(s008$, 22, 1) + "  TrAr: " + Mid(s008$, 34, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + "  FMus: " + Mid(s008$, 21, 1) + "  LTxt: " + Mid(s008$, 31, 2) + "  DtSt: " + Mid(s008$, 7, 1) + "       Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                        Case "P"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + "  Entered: " + Mid(s008$, 1, 6) + "  Char:    " + Mid(m_sLeader$, 10, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + Mid(m_sLeader$, 7, 1) + "  ELvl: " + Mid(m_sLeader$, 18, 1) + "  Srce: " + Mid(s008$, 40, 1) + "   Relf: " + Mid(s008$, 19, 4) + "  Ctrl: " + Mid(m_sLeader$, 9, 1) + "  Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + Mid(m_sLeader$, 8, 1) + "  Form: " + Mid(s008$, 30, 1) + "  GPub: " + Mid(s008$, 29, 1) + "   SpFm: " + Mid(s008$, 34, 2) + "    MRec: " + Mid(s008$, 39, 1) + "  Ctry: " + Mid(s008$, 16, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "CrTp: " + Mid(s008$, 26, 1) + "  Indx: " + Mid(s008$, 32, 1) + "  Proj: " + Mid(s008$, 23, 2) + "  DtSt: " + Mid(s008$, 7, 1) + "     Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                        Case "S"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + "  Entered: " + Mid(s008$, 1, 6) + "  Char:    " + Mid(m_sLeader$, 10, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + Mid(m_sLeader$, 7, 1) + "  ELvl: " + Mid(m_sLeader$, 18, 1) + "  Srce: " + Mid(s008$, 40, 1) + "    GPub: " + Mid(s008$, 29, 1) + "  Ctrl: " + Mid(m_sLeader$, 9, 1) + "  Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + Mid(m_sLeader$, 8, 1) + "  Form: " + Mid(s008$, 24, 1) + "  Conf: " + Mid(s008$, 30, 1) + "    Freq: " + Mid(s008$, 19, 1) + "  MRec: " + Mid(s008$, 39, 1) + "  Ctry: " + Mid(s008$, 16, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "S/L:  " + Mid(s008$, 35, 1) + "  Orig: " + Mid(s008$, 23, 1) + "  EntW: " + Mid(s008$, 25, 1) + "    Regl: " + Mid(s008$, 20, 1) + "  Alph: " + Mid(s008$, 34, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + "  SrTp: " + Mid(s008$, 22, 1) + "  Cont: " + Mid(s008$, 26, 3) + "  DtSt: " + Mid(s008$, 7, 1) + "  Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                        Case "U"
                            ' not defined yet: use non-monospaced
                            GoTo TextFormatted_MonospacedNotYetDefined
                        Case Else
                            ' we haven't bothered yet to set up the monospaced display for
                            '   other formats
                            GoTo TextFormatted_MonospacedNotYetDefined
                    End Select
            End Select
        End If
    End If ' raw fixed fields, or labeled?
TextFormattedNo008:
    
    If bRTF Then
        sOutput$ = sOutput$ + "\f0\fs" + Trim(str(iRtfFontSizeInPoints% * 2)) + " "
    End If
    
    If bRTF Then
        sOutput$ = sOutput$ + "\f0"
    End If
    FldMoveTop
    Do While FldMoveNext
        If Not FldDeleted Then
            If bTagList Then
                If InStr(sTagList$, FldTag) = 0 Then
                    GoTo TextFormattedNextFieldPlease
                End If
            End If
            lPtr2 = FldPointer
            sTag$ = FldTag
            sIndicators$ = FldInd
            sField$ = FldText
            Select Case sTag$
                Case "008"
                    If iOutput = TextFormatted_Raw% Then
                        sOutput$ = sOutput$ + sLineBreak$ + " " + sTag$ + "     " + Marc2HexDisplay(sField$)
                    End If
                Case Is < "010"
                    If bRTF Then
                        sOutput$ = sOutput$ + sLineBreak$ + " \f1 " + sTag$ + "     \f0 " + Marc2HexDisplay(sField$)
                    Else
                        If FldChanged Then
                            sOutput$ = sOutput$ + sLineBreak$ + "*" + sTag$ + "     " + Marc2HexDisplay(sField$)
                        Else
                            sOutput$ = sOutput$ + sLineBreak$ + " " + sTag$ + "     " + Marc2HexDisplay(sField$)
                        End If
                    End If
                Case Else
                    If bRTF Then
                        ' we can't get this stinkin' background color stuff to work; AND if we
                        '   put stuff in the wrong place, we break "find the text in the original
                        '   record" so we're back to a single possibility for now
                        'If bWhiteBackground Then
                            sOutput$ = sOutput$ + sLineBreak$ + " \f1 " + sTag$ + ":" + sIndicators$ + ": \f0 " + FldTextFormatted(iOutput)
                        'Else
                        '    sOutput$ = sOutput$ + sLineBreak$ + " \f1 " + sTag$ + ":" + sIndicators$ + ": \f0 " + FldTextFormatted(iOutput)
                        'End If
                        'bWhiteBackground = Not bWhiteBackground
                    Else ' all non-RTF formats
                        If FldChanged Then
                            sOutput$ = sOutput$ + sLineBreak$ + "*" + sTag$ + ":" + sIndicators$ + ": " + FldTextFormatted(iOutput)
                        Else
                            sOutput$ = sOutput$ + sLineBreak$ + " " + sTag$ + ":" + sIndicators$ + ": " + FldTextFormatted(iOutput)
                        End If
                    End If
            End Select
            FldPointer = lPtr2
TextFormattedNextFieldPlease:
        End If
    Loop
    
    If bRTF Then
        sFontTbl$ = "{\fonttbl"
        sFontTbl$ = sFontTbl$ + "{\f0\fswiss\fprq2\fcharset0 Arial Unicode MS;}"
        sFontTbl$ = sFontTbl$ + "{\f1\fmodern\frpq1\fcharset0 Courier New;}"
        sFontTbl$ = sFontTbl$ + "}"
        
        sStyleSheet$ = "{\stylesheet {\ql \li0\ri0\widctlpar\wrapdefault\aspalpha\aspnum\faauto\adjustright\rin0\lin0\itap0 \fs24\lang1033\langfe1033\cgrid\langnp1033\langfenp1033 \snext0 Normal;}{\*\cs10 \additive \ssemihidden Default Paragraph Font;}{\*\ts11\tsrowd\trftsWidthB3\trpaddl108\trpaddr108\trpaddfl3\trpaddft3\trpaddfb3\trpaddfr3\trcbpat1\trcfpat1\tblind0\tblindtype3\tscellwidthfts0\tsvertalt\tsbrdrt\tsbrdrl\tsbrdrb\tsbrdrr\tsbrdrdgl\tsbrdrdgr\tsbrdrh\tsbrdrv \ql \li0\ri0\widctlpar\wrapdefault\aspalpha\aspnum\faauto\adjustright\rin0\lin0\itap0 \fs20\lang1024\langfe1024\cgrid\langnp1024\langfenp1024 \snext11 \ssemihidden Normal Table;}}"
        
        'sStyleSheet$ = "{\stylesheet"
        'sStyleSheet$ = sStyleSheet$ + "{\ql \li0\ri0\widctlpar\wrapdefault\aspalpha\aspnum\faauto\adjustright\rin0\lin0\itap0 \fs24\lang1033\langfe1033\cgrid\langnp1033\langfenp1033 \snext0 Normal;}"
        'sStyleSheet$ = sStyleSheet$ + "{\*\cs10 \additive \ssemihidden Default Paragraph Font;}"
        'sStyleSheet$ = sStyleSheet$ + "{\*\ts11\tsrowd\trftsWidthB3\trpaddl108\trpaddr108\trpaddfl3\trpaddft3\trpaddfb3\trpaddfr3\tblind0\tblindtype3\tscellwidthfts0\tsvertalt\tsbrdrt\tsbrdrl\tsbrdrb\tsbrdrr\tsbrdrdgl\tsbrdrdgr\tsbrdrh\tsbrdrv"
        'sStyleSheet$ = sStyleSheet$ + "\ql \li0\ri0\widctlpar\wrapdefault\aspalpha\aspnum\faauto\adjustright\rin0\lin0\itap0 \fs20\lang1024\langfe1024\cgrid\langnp1024\langfenp1024 \snext11 \ssemihidden Normal Table;}}"
        
        ' this is the default table with one addition at the end: this is light green, for use
        '   if we ever figure out how to alternate background colors
        sColorTbl$ = "{\colortbl;\red0\green0\blue0;\red0\green0\blue255;\red0\green255\blue255;\red0\green255\blue0;\red255\green0\blue255;\red255\green0\blue0;\red255\green255\blue0;\red255\green255\blue255;\red0\green0\blue128;\red0\green128\blue128;\red0\green128\blue0;\red128\green0\blue128;\red128\green0\blue0;\red128\green128\blue0;\red128\green128\blue128;\red192\green192\blue192;\red225\green255\blue225;\red225\green255\blue225;}"

                
        'sOutput$ = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033" + sFontTbl$ + sColorTbl$ + "\viewkind4\uc1\pard\f1\fs" + Trim(str(iRtfFontSizeInPoints% * 2)) + " " & sOutput$ & "\par}"
        ' appropriate values for iLeftIndent:
        '   8 points: 900
        '  12 points: 1300 (more or less)
        '  14 points: 1500 (more or less)
        '  20 points: 2000
        ' we'll settle on this formula:
        iLeftIndent% = iRtfFontSizeInPoints% * 100
        sOutput$ = "{\rtf1\ansi\ansicpg1252\deff0\formshade\deflang1033" + sStyleSheet$ + sFontTbl$ + sColorTbl$ + "\viewkind4\uc1\pard\plain \ql \fi-" + Trim(str(iLeftIndent%)) + "\li" + Trim(str(iLeftIndent%)) + "\ri0\widctlpar\wrapdefault\aspalpha\aspnum\faauto\adjustright\rin0\lin360\itap0\lang1033\langfe1033\cgrid\langnp1033\langfenp1033\f1\fs" + Trim(str(iRtfFontSizeInPoints% * 2)) + " " & sOutput$ & "\par}"
        
        'Debug.Print sOutput$
        
    End If ' RTF?
    
    TextFormatted = sOutput$
    FldPointer = lFieldPointer

#Else
    
    Dim sOutput$, sTag$, sIndicators$, sField$, s008$, sLineBreak$
    
    Dim iRc%, iCtr%
    
    Dim lFieldPointer As Long, lPtr2 As Long
    
    Dim bTagList As Boolean
    
    
    If Len(sTagList$) > 0 Then
        bTagList = True
    End If
    
    On Error GoTo 0
    
    If iOutput = TextFormatted_RtfText% Then
        'sLineBreak$ = "\line "
        sLineBreak$ = "\par "
    Else
        sLineBreak$ = vbCrLf
    End If
    'Debug.Print "Setting line break for " + str(iOutput) + " as: >" + sLineBreak$ + "<"
    
    ' save the current field pointer!
    lFieldPointer = FldPointer
    
    If iOutput = TextFormatted_Raw% Then
        If bTagList Then
            If InStr(sTagList$, "000") = 0 Then
                GoTo TextFormattedNoLeader
            End If
        End If
        sOutput$ = " 000" + "     " + m_sLeader$
TextFormattedNoLeader:
    Else
        If bTagList Then
            If InStr(sTagList$, "008") = 0 Then
                GoTo TextFormattedNo008
            End If
        End If
        ' isolate the 008 field
        FldFindFirst "008"
        If FldWasFound Then
            ' the beginning part of the output string is made up of "fixed fields" drawn
            '   from the leader and 008 fields
            s008$ = FldText
            ' replace fills with question marks
            Do
                iRc% = InStr(s008$, MyMarcCharacter.MarcFill)
                If iRc% = 0 Then
                    Exit Do
                End If
                s008$ = SafeStuff(s008$, iRc%, 1, "?")
            Loop
            Select Case iFixedFieldFormat
                Case FixedFieldDisplay_NOTIS%
                    Select Case m_sRecordFormat$
                        Case "A"
                            sOutput$ = " RT" + " " + Mid(m_sLeader$, 7, 1) + " STAT" + " " + Mid(m_sLeader$, 6, 1) + " E/LVL" + " " + Mid(m_sLeader$, 18, 1) + " CHAR " + Mid(m_sLeader$, 10, 1) + " "
                            ' 008/8, 008/17
                            sOutput$ = sOutput$ + "FMT" + " " + "A " + " LANG" + " " + Mid(s008$, 9, 1) + " SUBD" + " " + Mid(s008$, 18, 1) + sLineBreak$
                            ' 008/39, 008/7, 008/38, 008/32
                            sOutput$ = sOutput$ + "SRC" + " " + Mid(s008$, 40, 1) + " ROM" + " " + Mid(s008$, 8, 1) + " MOD" + " " + Mid(s008$, 39, 1) + " UNIQUE" + " " + Mid(s008$, 33, 1)
                            ' 008/28, 008/11, 008/6,
                            sOutput$ = sOutput$ + " GOVT" + " " + Mid(s008$, 29, 1) + " S/SYS" + " " + Mid(s008$, 12, 1) + " D/I" + " " + Mid(s008$, 7, 1)
                            ' 008/13, 008/12
                            sOutput$ = sOutput$ + " NUM" + " " + Mid(s008$, 14, 1) + " S/TYP" + " " + Mid(s008$, 13, 1) + sLineBreak$
                            ' 008/14, 008/15, 008/16
                            sOutput$ = sOutput$ + "NAME" + " " + Mid(s008$, 15, 1) + " SUBJ" + " " + Mid(s008$, 16, 1) + " SER" + " " + Mid(s008$, 17, 1)
                            ' 008/9, 008/33, 008/29
                            sOutput$ = sOutput$ + " KIND" + " " + Mid(s008$, 10, 1) + " H/ESTAB" + " " + Mid(s008$, 34, 1) + " T/EVAL" + " " + Mid(s008$, 30, 1)
                            ' 008/31/, 008/10
                            sOutput$ = sOutput$ + " IP" + " " + Mid(s008$, 32, 1) + " RULES" + " " + Mid(s008$, 11, 1)
                        Case "B", "D", "F", "M", "P", "S", "U"
                            sOutput$ = " RT" + " " + Mid(m_sLeader$, 7, 1) + " BL" + " " + Mid(m_sLeader$, 8, 1) + " STAT" + " " + Mid(m_sLeader$, 6, 1) + " E/LVL" + " " + Mid(m_sLeader$, 18, 1) + " DCF " + Mid(m_sLeader$, 19, 1) + " CHAR " + Mid(m_sLeader$, 10, 1) + sLineBreak$
                            Select Case Mid(m_sLeader$, 7, 1)
                                Case "a", "t" ' B or S
                                    'Debug.Print "B or s"
                                    If SerialBibliographicRecord(m_sLeader$) Then
                                    'If InStr("bs", Mid(m_sleader$, 8, 1)) > 0 Then
                                        sOutput$ = sOutput$ + "FMT" + " " + "S " + sOutput$ + " SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + " OA" + " " + Mid(s008$, 34, 1) + " REPRO" + " " + Mid(s008$, 24, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4) + sLineBreak$
                                        sOutput$ = sOutput$ + "CONT" + " " + Mid(s008$, 25, 4) + " S/T" + " " + Mid(s008$, 22, 1) + " FREQ" + " " + Mid(s008$, 19, 1) + " REG" + " " + Mid(s008$, 20, 1) + " MED" + " " + Mid(s008$, 23, 1) + " GOVT" + " " + Mid(s008$, 29, 1) + " ISDS" + " " + Mid(s008$, 21, 1) + " CONF" + " " + Mid(s008$, 30, 1) + " SLE" + " " + Mid(s008$, 35, 1) + sLineBreak$
                                    Else
                                        'Debug.Print "B"
                                        sOutput$ = sOutput$ + "FMT" + " " + "B " + sOutput$ + " SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + " T/AUD" + " " + Mid(s008$, 23, 1) + " REPRO" + " " + Mid(s008$, 24, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4) + sLineBreak$
                                        sOutput$ = sOutput$ + "CONT" + " " + Mid(s008$, 25, 4) + " ILLUS" + " " + Mid(s008$, 19, 4) + " GOVT" + " " + Mid(s008$, 29, 1) + " BIOG" + " " + Mid(s008$, 35, 1) + " FEST" + " " + Mid(s008$, 31, 1) + " CONF" + " " + Mid(s008$, 30, 1) + " LITF" + " " + Mid(s008$, 34, 1) + " INDX" + " " + Mid(s008$, 32, 1) + sLineBreak$
                                    End If
                                Case "m" ' D
                                    sOutput$ = sOutput$ + "FMT" + " " + "D " + sOutput$ + " SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + " T/AUD" + " " + Mid(s008$, 23, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4) + sLineBreak$
                                    sOutput$ = sOutput$ + "DF/TYP" + " " + Mid(s008$, 27, 1) + " GOVT" + " " + Mid(s008$, 29, 1)
                                Case "g", "k", "o", "r" ' F
                                    sOutput$ = sOutput$ + "FMT" + " " + "F " + sOutput$ + " SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + "T/AUD" + " " + Mid(s008$, 22, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4) + sLineBreak$
                                    sOutput$ = sOutput$ + "T/MAT" + " " + Mid(s008$, 34, 1) + " TECH" + " " + Mid(s008$, 35, 1) + " GOVT" + " " + Mid(s008$, 29, 1) + " A/MAT" + " " + Mid(s008$, 23, 5) + " R/TIME" + " " + Mid(s008$, 19, 3)
                                Case "c", "d", "i", "j" ' M
                                    sOutput$ = sOutput$ + "FMT" + " " + "M " + sOutput$ + " SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + " T/AUD" + " " + Mid(s008$, 23, 1) + " REPRO" + " " + Mid(s008$, 24, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4) + sLineBreak$
                                    sOutput$ = sOutput$ + "F/COMP" + " " + Mid(s008$, 19, 2) + " SCORE" + " " + Mid(s008$, 21, 1) + " A/MAT" + " " + Mid(s008$, 25, 6) + " L/TEXT" + " " + Mid(s008$, 31, 2)
                                Case "e", "f" ' P
                                    sOutput$ = sOutput$ + "FMT" + " " + "P " + sOutput$ + " SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + "CM/TYP" + " " + Mid(s008$, 25, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4) + sLineBreak$
                                    sOutput$ = sOutput$ + "BME" + " " + Mid(s008$, 23, 3) + " RELIEF" + " " + Mid(s008$, 19, 4) + " SP/FORM" + " " + Mid(s008$, 34, 2) + " GOVT" + " " + Mid(s008$, 29, 1) + " INDX" + " " + Mid(s008$, 32, 1)
                                Case "b", "p" ' U: archival/mixed materials
                                    sOutput$ = sOutput$ + "FMT" + " " + "U " + sOutput$ + " SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + " REPRO" + " " + Mid(s008$, 24, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4) + sLineBreak$
                            End Select
                        Case "H"
                            sOutput$ = "FMT" + " " + "H RT" + " " + Mid(m_sLeader$, 7, 1) + " STAT" + " " + Mid(m_sLeader$, 6, 1) + " E/LVL" + " " + Mid(m_sLeader$, 18, 1) + " CHAR " + Mid(m_sLeader$, 10, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "R/STAT" + " " + Mid(s008$, 7, 1) + " MTHD" + " " + Mid(s008$, 8, 1) + " DT/CAN" + " " + Mid(s008$, 9, 4) + " G/RTN" + " " + Mid(s008$, 13, 1) + " S/RTN" + " " + Mid(s008$, 14, 3) + " CMPLT" + " " + Mid(s008$, 17, 1) + " LEND" + " " + Mid(s008$, 21, 1) + " REPOL" + " " + Mid(s008$, 22, 1) + " LAN" + " " + Mid(s008$, 23, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "SEP/COMP" + " " + Mid(s008$, 26, 1) + " RPT/DT" + " " + Mid(s008$, 27, 6)
                        Case Else ' including community information and classification
                            sOutput$ = sOutput$ + vbCr$ + vbLf$ + s008$
                    End Select
                Case FixedFieldDisplay_OCLC%
TextFormatted_MonospacedNotYetDefined:
                    Select Case m_sRecordFormat$
                        Case "A"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + " Entered: " + Mid(s008$, 1, 6) + " Char: " + Mid(m_sLeader$, 10, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + Mid(m_sLeader$, 7, 1) + " Upd status: " + Mid(s008$, 32, 1) + " Enc lvl: " + Mid(m_sLeader$, 18, 1) + " Source: " + Mid(s008$, 40, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Roman: " + Mid(s008$, 8, 1) + " Ref status: " + Mid(s008$, 30, 1) + " Mod rec: " + Mid(s008$, 39, 1) + " Name use: " + Mid(s008$, 15, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Govt agn: " + Mid(s008$, 29, 1) + " Auth status: " + Mid(s008$, 34, 1) + " Subj: " + Mid(s008$, 12, 1) + " Subj use: " + Mid(s008$, 16, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Series: " + Mid(s008$, 13, 1) + " Auth/ref: " + Mid(s008$, 10, 1) + " Geo subd: " + Mid(s008$, 7, 1) + " Ser use: " + Mid(s008$, 17, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Ser num: " + Mid(s008$, 14, 1) + " Name: " + Mid(s008$, 33, 1) + " Subdiv tp: " + Mid(s008$, 18, 1) + " Rules: " + Mid(s008$, 11, 1) + sLineBreak$
                        Case "B"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + " Entered: " + Mid(s008$, 1, 6) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + Mid(m_sLeader$, 7, 1) + " ELvl: " + Mid(m_sLeader$, 18, 1) + " Srce: " + Mid(s008$, 40, 1) + " Audn: " + Mid(s008$, 23, 1) + " Ctrl: " + Mid(m_sLeader$, 9, 1) + " Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + Mid(m_sLeader$, 8, 1) + " Form: " + Mid(s008$, 24, 1) + " Conf: " + Mid(s008$, 30, 1) + " Biog: " + Mid(s008$, 35, 1) + " MRec: " + Mid(s008$, 39, 1) + " Ctry: " + Mid(s008$, 16, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "Cont: " + Mid(s008$, 25, 4) + " GPub: " + Mid(s008$, 29, 1) + " LitF: " + Mid(s008$, 34, 1) + " Indx: " + Mid(s008$, 32, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + " Ills: " + Mid(s008$, 19, 4) + " Fest: " + Mid(s008$, 31, 1) + " DtSt: " + Mid(s008$, 7, 1) + " Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                        Case "D"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + " Entered: " + Mid(s008$, 1, 6) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + " ELvl: " + Mid(m_sLeader$, 18, 1) + " Srce: " + Mid(s008$, 40, 1) + " Audn: " + " " + Mid(s008$, 23, 1) + " Ctrl: " + Mid(m_sLeader$, 9, 1) + " Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + " File: " + Mid(s008$, 27, 1) + " GPub: " + Mid(s008$, 29, 1) + " MRec: " + " " + Mid(s008$, 39, 1) + " Ctry: " + " " + Mid(s008$, 16, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + " DtSt: " + Mid(s008$, 7, 1) + " Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                        Case "F"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + " Entered: " + Mid(s008$, 1, 6) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + Mid(m_sLeader$, 7, 1) + " ELvl: " + Mid(m_sLeader$, 18, 1) + " Srce: " + Mid(s008$, 40, 1) + " Audn: " + " " + Mid(s008$, 23, 1) + " Ctrl: " + Mid(m_sLeader$, 9, 1) + " Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + Mid(m_sLeader$, 8, 1) + " Form: " + " GPub: " + Mid(s008$, 29, 1) + " Time: " + Mid(s008$, 19, 3) + " MRec: " + Mid(s008$, 39, 1) + " Ctry: " + Mid(s008$, 16, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + " TMat: " + Mid(s008$, 34, 1) + " Tech: " + " " + Mid(s008$, 35, 1) + " DtSt: " + Mid(s008$, 7, 1) + " Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                        Case "H"
                            ' 20050317: there is no OCLC convention for this so we're going to use NOTIS
                            '   conventions and people can complain all they want
                            sOutput$ = "FMT" + " " + "H RT" + " " + Mid(m_sLeader$, 7, 1) + " STAT" + " " + Mid(m_sLeader$, 6, 1) + " E/LVL" + " " + Mid(m_sLeader$, 18, 1) + " CHAR " + Mid(m_sLeader$, 10, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "R/STAT" + " " + Mid(s008$, 7, 1) + " MTHD" + " " + Mid(s008$, 8, 1) + " DT/CAN" + " " + Mid(s008$, 9, 4) + " G/RTN" + " " + Mid(s008$, 13, 1) + " S/RTN" + " " + Mid(s008$, 14, 3) + " CMPLT" + " " + Mid(s008$, 17, 1) + " LEND" + " " + Mid(s008$, 21, 1) + " REPOL" + " " + Mid(s008$, 22, 1) + " LAN" + " " + Mid(s008$, 23, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "SEP/COMP" + " " + Mid(s008$, 26, 1) + " RPT/DT" + " " + Mid(s008$, 27, 6)
                        Case "M"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + " Entered: " + Mid(s008$, 1, 6) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + " ELvl: " + Mid(m_sLeader$, 18, 1) + " Srce: " + Mid(s008$, 40, 1) + " Audn: " + " " + Mid(s008$, 23, 1) + " Ctrl: " + Mid(m_sLeader$, 9, 1) + " Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + Mid(m_sLeader$, 8, 1) + " Form: " + Mid(s008$, 21, 1) + " Comp: " + " " + Mid(s008$, 19, 2) + " AccM: " + Mid(s008$, 25, 6) + " MRec: " + Mid(s008$, 39, 1) + " Ctry: " + Mid(s008$, 16, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + " FMus: " + " LTxt: " + Mid(s008$, 31, 2) + " DtSt: " + Mid(s008$, 7, 1) + " Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                        Case "P"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + " Entered: " + Mid(s008$, 1, 6) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + Mid(m_sLeader$, 7, 1) + " ELvl: " + Mid(m_sLeader$, 18, 1) + " Srce: " + Mid(s008$, 40, 1) + " Relf: " + Mid(s008$, 19, 4) + " Ctrl: " + Mid(m_sLeader$, 9, 1) + " Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + Mid(m_sLeader$, 8, 1) + " Form: " + Mid(s008$, 24, 1) + " GPub: " + Mid(s008$, 29, 1) + " SpFm: " + " " + Mid(s008$, 34, 2) + " MRec: " + Mid(s008$, 39, 1) + " Ctry: " + Mid(s008$, 16, 3)
                            sOutput$ = sOutput$ + "CrTp: " + Mid(s008$, 25, 1) + " Indx: " + Mid(s008$, 32, 1) + " Proj: " + Mid(s008$, 23, 2) + " DtSt: " + Mid(s008$, 7, 1) + " Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + sLineBreak$
                        Case "S"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + " Entered: " + Mid(s008$, 1, 6) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + Mid(m_sLeader$, 7, 1) + " ELvl: " + Mid(m_sLeader$, 18, 1) + " Srce: " + Mid(s008$, 40, 1) + " GPub: " + Mid(s008$, 29, 1) + " Ctrl: " + "Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + Mid(m_sLeader$, 8, 1) + " Form: " + Mid(s008$, 24, 1) + " Conf: " + Mid(s008$, 30, 1) + " Freq: " + " " + Mid(s008$, 19, 1) + " MRec: " + Mid(s008$, 39, 1) + " Ctry: " + Mid(s008$, 16, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "S/L: " + Mid(s008$, 35, 1) + " Orig: " + Mid(s008$, 23, 1) + "EntW: " + Mid(s008$, 25, 1) + " Regl: " + Mid(s008$, 20, 1) + " ISSN: " + Mid(s008$, 21, 1) + " Alph: " + Mid(s008$, 34, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + " SrTp: " + Mid(s008$, 22, 1) + " Cont: " + Mid(s008$, 26, 3) + " DtSt: " + Mid(s008$, 7, 1) + " Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                        Case "U"
                            ' 20050317: didn't yet bother to get the OCLC version of this
                            sOutput$ = "FMT" + " " + "U " + sOutput$ + " SRC" + " " + Mid(s008$, 40, 1) + " PLACE" + " " + Mid(s008$, 16, 3) + " LANG" + " " + Mid(s008$, 36, 3) + " MOD" + " " + Mid(s008$, 39, 1) + " REPRO" + " " + Mid(s008$, 24, 1) + " D/CODE" + " " + Mid(s008$, 7, 1) + " DT/1" + " " + Mid(s008$, 8, 4) + " DT/2" + " " + Mid(s008$, 12, 4)
                        Case Else
                            ' community information?  classification?
                            sOutput$ = sOutput$ + vbCr$ + sLineBreak$ + s008$
                    End Select
                Case FixedFieldDisplay_OCLCMonospaced%
                    Select Case m_sRecordFormat$
                        Case "A"
                            ' 20051019: monospaced OCLC defined for authorities; others
                            '   may come later ...
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + "  Entered: " + Mid(s008$, 1, 6) + " Char:      " + Mid(m_sLeader$, 10, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Type:     " + Mid(m_sLeader$, 7, 1) + "  Upd status:  " + Mid(s008$, 32, 1) + "  Enc lvl:   " + Mid(m_sLeader$, 18, 1) + "  Source:   " + Mid(s008$, 40, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Roman:    " + Mid(s008$, 8, 1) + "  Ref status:  " + Mid(s008$, 30, 1) + "  Mod rec:   " + Mid(s008$, 39, 1) + "  Name use: " + Mid(s008$, 15, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Govt agn: " + Mid(s008$, 29, 1) + "  Auth status: " + Mid(s008$, 34, 1) + "  Subj:      " + Mid(s008$, 12, 1) + "  Subj use: " + Mid(s008$, 16, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Series:   " + Mid(s008$, 13, 1) + "  Auth/ref:    " + Mid(s008$, 10, 1) + "  Geo subd:  " + Mid(s008$, 7, 1) + "  Ser use:  " + Mid(s008$, 17, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Ser num:  " + Mid(s008$, 14, 1) + "  Name:        " + Mid(s008$, 33, 1) + "  Subdiv tp: " + Mid(s008$, 18, 1) + "  Rules:    " + Mid(s008$, 11, 1) + sLineBreak$
                        Case "B"
                            sOutput$ = "Rec stat: " + Mid(m_sLeader$, 6, 1) + "  Entered: " + Mid(s008$, 1, 6) + sLineBreak$
                            sOutput$ = sOutput$ + "Type: " + Mid(m_sLeader$, 7, 1) + "  ELvl: " + Mid(m_sLeader$, 18, 1) + "     Srce: " + Mid(s008$, 40, 1) + "  Audn: " + Mid(s008$, 23, 1) + "  Ctrl: " + Mid(m_sLeader$, 9, 1) + "  Lang: " + Mid(s008$, 36, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "BLvl: " + Mid(m_sLeader$, 8, 1) + "  Form: " + Mid(s008$, 24, 1) + "     Conf: " + Mid(s008$, 30, 1) + "  Biog: " + Mid(s008$, 35, 1) + "  MRec: " + Mid(s008$, 39, 1) + "  Ctry: " + Mid(s008$, 16, 3) + sLineBreak$
                            sOutput$ = sOutput$ + "         Cont: " + Mid(s008$, 25, 4) + "  GPub: " + Mid(s008$, 29, 1) + "  LitF: " + Mid(s008$, 34, 1) + "  Indx: " + Mid(s008$, 32, 1) + sLineBreak$
                            sOutput$ = sOutput$ + "Desc: " + Mid(m_sLeader$, 19, 1) + "  Ills: " + Mid(s008$, 19, 4) + "  Fest: " + Mid(s008$, 31, 1) + "  DtSt: " + Mid(s008$, 7, 1) + "  Dates: " + Mid(s008$, 8, 4) + "," + Mid(s008$, 12, 4) + sLineBreak$
                        Case Else
                            'Debug.Print "Looping for unrecognized record type " + m_sRecordFormat$
                            GoTo TextFormatted_MonospacedNotYetDefined
                    End Select
            End Select
        End If
    End If ' raw fixed fields, or labeled?
TextFormattedNo008:
    
    'Debug.Print "FFDS: >" + sOutput$ + "<"
    FldMoveTop
    Do While FldMoveNext
        If Not FldDeleted Then
            If bTagList Then
                If InStr(sTagList$, FldTag) = 0 Then
                    GoTo TextFormattedNextFieldPlease
                End If
            End If
            lPtr2 = FldPointer
            sTag$ = FldTag
            sIndicators$ = FldInd
            sField$ = FldText
            Select Case sTag$
                Case "008"
                    If iOutput = TextFormatted_Raw% Then
                        sOutput$ = sOutput$ + sLineBreak$ + " " + sTag$ + "     " + Marc2HexDisplay(sField$)
                    End If
                Case Is < "010"
                    sOutput$ = sOutput$ + sLineBreak$ + " " + sTag$ + "     " + Marc2HexDisplay(sField$)
                Case Else
                    sOutput$ = sOutput$ + sLineBreak$ + " " + sTag$ + ":" + sIndicators$ + ": " + FldTextFormatted(iOutput)
            End Select
            FldPointer = lPtr2
TextFormattedNextFieldPlease:
        End If
    Loop
    
    'Debug.Print "Output after variables: >" + sOutput$ + "<"
    If bIncludeRtfWrapper And iOutput = TextFormatted_RtfText% Then
        sOutput$ = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033" & "{\fonttbl{\f0\fswiss\fprq2\fcharset0 Arial Unicode MS;}}" & "\viewkind4\uc1\pard\f0\fs" + Trim(str(iRtfFontSizeInPoints% * 2)) + " " & sOutput$ & "\par}"
    End If
    
    TextFormatted = sOutput$
    FldPointer = lFieldPointer

#End If

End Property

Public Function Marc2HexDisplay(ByVal sField$) As String
    
    ' convert a piece of text (in either MARC21 or UTF-8 or Unicode) into
    '   a "displayable" form in which all high-end characters are replaced by
    '   their hexadecimal equivalents in a way that "should" permit the
    '   reverse translation

    Dim iCharLen%, iVal%
    
    Dim sOutput$, sChar$
    
    Dim lPtr As Long, lLen As Long, lLoop As Long


    ' 20060106: this appears to output "\&H\&H\&H" when fed a null string; let's
    '   just stem this at the outset
    If Len(sField$) = 0 Then
        Marc2HexDisplay = ""
        Exit Function
    End If
        
    ' the utf and 'other' versions should actually return
    '   the same value ...
    If m_bUtf8 Then
        lLen = Len(sField$)
        lPtr = 1
        Do
            iCharLen% = MyMarcCharacter.Utf8CharOctets(Mid(sField$, lPtr, 1))
            If iCharLen% = 1 Then
                sOutput$ = sOutput$ + Mid(sField$, lPtr, 1)
            Else
                For lLoop = lPtr To lPtr + iCharLen% - 1
                    sOutput$ = sOutput$ + "\&H" + MyMarcCharacter.Char2Hex(Mid(sField$, lLoop, 1))
                Next ' lPtr
            End If
            lPtr = lPtr + iCharLen%
            If lPtr > lLen Then
                Exit Do
            End If
        Loop
    Else
        For lPtr = 1 To Len(sField$)
            sChar$ = Mid(sField$, lPtr, 1)
            Select Case Asc(sChar$)
                Case Is < 31
                    sOutput$ = sOutput$ + "\&H" + MyMarcCharacter.Char2Hex(sChar$)
                Case Is < 128
                    sOutput$ = sOutput$ + sChar$
                Case Else
                    sOutput$ = sOutput$ + "\&H" + MyMarcCharacter.Char2Hex(sChar$)
            End Select
        Next
    End If
    
    Do
        lPtr = InStr(sOutput$, MyMarcCharacter.MarcDelimiter)
        If lPtr = 0 Then
            Exit Do
        End If
        sOutput$ = SafeStuff(sOutput$, lPtr, 1, "|")
    Loop
    
    Marc2HexDisplay = sOutput$
        
End Function


Public Sub ClearFldOrder(ByVal sMarcFormat$)

#If SetFldOrderDebug = -1 Then
    Debug.Print "Clear field order " + sMarcFormat$ + " " + str(m_iMarcCtr%)
#End If

    If m_iMarcCtr% <> 0 Then
        Exit Sub
    End If
    
    gblbTestOrderStuff = True
    

    Select Case sMarcFormat$
        Case "A"
            gbliFieldOrderAuthLast% = 0
            prvbPair880sWithRomanizedFieldsAuth = False
            prvbPair880sWithRomanizedFieldsAuthLC = False
        Case "B", "D", "F", "M", "P", "S", "U"
            gbliFieldOrderBibLast% = 0
            prvbPair880sWithRomanizedFieldsBib = False
            prvbPair880sWithRomanizedFieldsBibLC = False
        Case "H"
            gbliFieldOrderHoldLast% = 0
            prvbPair880sWithRomanizedFieldsHold = False
            prvbPair880sWithRomanizedFieldsHoldLC = False
        Case Else
            gbliFieldOrderOtherLast% = 0
    End Select
    
End Sub

Public Sub SetFldOrder(ByVal sMarcFormat$, ByVal sBeginTag$, ByVal sEndTag$, ByVal iSortMethod%)

    
#If SetFldOrderDebug = -1 Then
    Debug.Print "Set field order " + sMarcFormat$ + " " + sBeginTag$ + " " + sEndTag$ + " " + str(iSortMethod%) + " " + str(m_iMarcCtr%)
#End If

    If m_iMarcCtr% <> 0 Then
        Exit Sub
    End If
    
    ' 20061116: added
    ' 20070306: restructured to provide *some kind of correct behavor* even when
    '   we arrive with an improper definition
    ' 20070829: restructured to provide exceptional handling for LC needs
    Select Case iSortMethod%
        Case SORTINSTRUCTION_Paired880s%
            Select Case sMarcFormat$
                Case "A"
                    prvbPair880sWithRomanizedFieldsAuth = True
                Case "B", "D", "F", "M", "P", "S", "U"
                    prvbPair880sWithRomanizedFieldsBib = True
                Case Else ' holdings, and also "other"
                    prvbPair880sWithRomanizedFieldsHold = True
            End Select
            If sBeginTag$ = "880" And (Len(sEndTag$) = 0 Or sEndTag$ = "880") Then
                Exit Sub
            End If
            iSortMethod% = SORTINSTRUCTION_Generic%
        Case SORTINSTRUCTION_Paired880sLC%
            Select Case sMarcFormat$
                Case "A"
                    prvbPair880sWithRomanizedFieldsAuth = True
                    prvbPair880sWithRomanizedFieldsAuthLC = True
                Case "B", "D", "F", "M", "P", "S", "U"
                    prvbPair880sWithRomanizedFieldsBib = True
                    prvbPair880sWithRomanizedFieldsBibLC = True
                Case Else ' holdings, and also "other"
                    prvbPair880sWithRomanizedFieldsHold = True
                    prvbPair880sWithRomanizedFieldsHoldLC = True
            End Select
            If sBeginTag$ = "880" And (Len(sEndTag$) = 0 Or sEndTag$ = "880") Then
                Exit Sub
            End If
            iSortMethod% = SORTINSTRUCTION_Generic%
    End Select
    
    ' if we get to this point with an improper "paired 880s" instruction, patch things up
    '   as best as you can
    
    If iSortMethod% = SORTINSTRUCTION_Paired880s% Then
    End If
    
    Select Case sMarcFormat$
        Case "A"
            gbliFieldOrderAuthLast% = gbliFieldOrderAuthLast% + 1
            If gbliFieldOrderAuthLast% > gbliFieldOrderAuthMax% Then
                gbliFieldOrderAuthMax% = gbliFieldOrderAuthMax% + 5
                ReDim Preserve gblaFieldOrderAuth(0 To gbliFieldOrderAuthMax%)
            End If
            gblaFieldOrderAuth(gbliFieldOrderAuthLast%).Begin = sBeginTag$
            gblaFieldOrderAuth(gbliFieldOrderAuthLast%).End = sEndTag$
            gblaFieldOrderAuth(gbliFieldOrderAuthLast%).SortInstruction = iSortMethod%
        Case "B", "D", "F", "M", "P", "S", "U"
            gbliFieldOrderBibLast% = gbliFieldOrderBibLast% + 1
            If gbliFieldOrderBibLast% > gbliFieldOrderBibMax% Then
                gbliFieldOrderBibMax% = gbliFieldOrderBibMax% + 5
                ReDim Preserve gblaFieldOrderBib(0 To gbliFieldOrderBibMax%)
            End If
            gblaFieldOrderBib(gbliFieldOrderBibLast%).Begin = sBeginTag$
            gblaFieldOrderBib(gbliFieldOrderBibLast%).End = sEndTag$
            gblaFieldOrderBib(gbliFieldOrderBibLast%).SortInstruction = iSortMethod%
        Case "H"
            gbliFieldOrderHoldLast% = gbliFieldOrderHoldLast% + 1
            If gbliFieldOrderHoldLast% > gbliFieldOrderHoldMax% Then
                gbliFieldOrderHoldMax% = gbliFieldOrderHoldMax% + 5
                ReDim Preserve gblaFieldOrderHold(0 To gbliFieldOrderHoldMax%)
            End If
            gblaFieldOrderHold(gbliFieldOrderHoldLast%).Begin = sBeginTag$
            gblaFieldOrderHold(gbliFieldOrderHoldLast%).End = sEndTag$
            gblaFieldOrderHold(gbliFieldOrderHoldLast%).SortInstruction = iSortMethod%
        Case Else
            gbliFieldOrderOtherLast% = gbliFieldOrderOtherLast% + 1
            If gbliFieldOrderOtherLast% > gbliFieldOrderOtherMax% Then
                gbliFieldOrderOtherMax% = gbliFieldOrderOtherMax% + 5
                ReDim Preserve gblaFieldOrderOther(0 To gbliFieldOrderOtherMax%)
            End If
            gblaFieldOrderOther(gbliFieldOrderOtherLast%).Begin = sBeginTag$
            gblaFieldOrderOther(gbliFieldOrderOtherLast%).End = sEndTag$
            gblaFieldOrderOther(gbliFieldOrderOtherLast%).SortInstruction = iSortMethod%
    End Select
    
End Sub

Private Function SetFieldSortGroupFromTag(ByVal sTag$, ByVal sIndicators$, ByVal sText$) As String

    ' return the field sorting group (pointer into the field-sorting array) and
    '   the sorting instruction code (the method to be appllied to that group in
    '   the array) for some supplied MARC tag
    
    Dim iReturn%, iCtr%
    
    Dim sLabel$, s6$, sSequence$, sReturn$
    
    Dim bSwapTags As Boolean
    
    
#If SetFieldSortGroupFromTagDebug = -1 Then
    Debug.Print "SFSGFT: " + sTag$ + ":" + sIndicators$ + ":" + sText$
#End If
    SetSubfieldSortGroupFromTag sTag$
    
    ' 20061116: if we're talking about an 880 field, then maybe we want to
    '   switch the sort order from whatever order would otherwise befall the
    '   880 field, to "paired". we achieve the grosser part of "paired-ness"
    '   by setting the tag to use in determining the sort instruction to the
    '   tag from subfield $6
    If sTag$ = "880" Then
        bSwapTags = False
        If Len(sText$) > 0 Then
            Select Case MarcRecordFormat
                Case "A"
                    bSwapTags = prvbPair880sWithRomanizedFieldsAuth
                Case "B", "D", "F", "M", "P", "S", "U"
                    bSwapTags = prvbPair880sWithRomanizedFieldsBib
                Case Else
                    bSwapTags = prvbPair880sWithRomanizedFieldsHold
            End Select
#If SetFieldSortGroupFromTagDebug = -1 Then
            Debug.Print "Swap tags? " + str(bSwapTags) + " " + str(prvbPair880sWithRomanizedFieldsBibLC)
#End If
            If bSwapTags Then
                iCtr% = InStr(sText$, MarcDelimiter + "6")
                If iCtr% > 0 Then
                    sTag$ = Trim(Mid(sText$, iCtr% + 2))
                    sSequence$ = Mid(sTag$, 4)
                    sTag$ = Mid(sTag$, 1, 3) ' we will swap tags, no matter what
                    
                    
                    ' 20070829: David Bucknum added this to allow field pairing of 6xxs
                    '   LC always uses "4" (Source not specified) as the 2nd indicator in the 880 $6 6xx-xx field
                    '   This changes it to "0" for proper pairing with the 6xx field
                    ' we'll elaborate the structure here in case we need it later
                    Select Case MarcRecordFormat
                        'Case "A"
                        '    If prvbPair880sWithRomanizedFieldsAuthLC Then
                        '    End If
                        Case "B", "D", "F", "M", "P", "S", "U"
                            If prvbPair880sWithRomanizedFieldsBibLC Then
                                If Mid(sTag$, 1, 1) = "6" And Mid(sIndicators$, 2, 1) = "4" Then
                                    sIndicators$ = Mid(sIndicators$, 1, 1) + "0"
                                End If
                            End If
                        'Case Else ' better be holdings!
                        '    If prvbPair880sWithRomanizedFieldsHoldLC Then
                        '    End If
                    End Select
                    
                    iCtr% = InStr(sSequence$, MarcDelimiter)
                    If iCtr% > 0 Then ' it better be!
                        sSequence$ = Mid(sSequence$, 1, iCtr% - 1)
                    End If
                    ' 20061121: only use the extension if we're
                    '   talking *paired* fields; if we have an unpaired 880 field (sequence
                    '   number is zero) we will just use the tag all by itself
                    If Len(sSequence$) > 0 Then
                        If Abs(Val(sSequence$)) > 0 Then
                            sSequence$ = prvsSortExtensionMarker$ + Right("000" + Trim(str(Abs(Val(sSequence$)))), 3)
                            sSequence$ = sSequence$ + " G" ' forcing the 880 to come after the corresponding field
                        End If
                    Else
                        sSequence$ = prvsSortExtensionMarker$ + "000"
                    End If
                Else
                    bSwapTags = False
                End If
            End If
        End If
    Else
        ' this is not an 880 field; but if we're interested in
        '   pairing up 880s with their mates and this field contains
        '   $6, then we need to know that, too
        If Len(sText$) > 0 Then
            Select Case MarcRecordFormat
                Case "A"
                    bSwapTags = prvbPair880sWithRomanizedFieldsAuth
                Case "B", "D", "F", "M", "P", "S", "U"
                    bSwapTags = prvbPair880sWithRomanizedFieldsBib
                Case Else
                    bSwapTags = prvbPair880sWithRomanizedFieldsHold
            End Select
            If bSwapTags Then
                iCtr% = InStr(sText$, MarcDelimiter + "6")
                If iCtr% > 0 Then
                    sSequence$ = Mid(Trim(Mid(sText$, iCtr% + 2)), 4)
                    iCtr% = InStr(sSequence$, MarcDelimiter)
                    If iCtr% > 0 Then ' it better be!
                        sSequence$ = Mid(sSequence$, 1, iCtr% - 1)
                    End If
                    If Len(sSequence$) > 0 Then
                        ' 20061121: only use the extension if we're
                        '   talking *paired* fields; if we have an unpaired non-880 field (sequence
                        '   number is zero) we will just use the tag all by itself
                        If Abs(Val(sSequence$)) > 0 Then
                            sSequence$ = prvsSortExtensionMarker$ + Right("000" + Trim(str(Abs(Val(sSequence$)))), 3)
                        End If
                    End If
                Else
                    bSwapTags = False
                End If
            End If
        End If
    End If
    
    Select Case MarcRecordFormat
        Case "A"
            For iCtr% = 1 To gbliFieldOrderAuthLast%
                If sTag$ >= gblaFieldOrderAuth(iCtr%).Begin And sTag$ <= gblaFieldOrderAuth(iCtr%).End Then
                    SetFieldSortGroupFromTagEndgame sLabel$, iCtr%, gblaFieldOrderAuth(iCtr%).SortInstruction, sTag$, sIndicators$, sText$
                    If sLabel$ = "*" Then
                        sReturn$ = sLabel$
                    Else
                        sReturn$ = sLabel$ + sSequence$
                    End If
                    GoTo SFSGFT_Return
                End If
            Next ' ictr%
            SetFieldSortGroupFromTagEndgame sLabel$, gbliFieldOrderAuthLast%, gblaFieldOrderAuth(gbliFieldOrderAuthLast%).SortInstruction, sTag$, sIndicators$, sText$
            If sLabel$ = "*" Then
                sReturn$ = sLabel$
            Else
                sReturn$ = sLabel$ + sSequence$
            End If
        Case "H"
            For iCtr% = 1 To gbliFieldOrderHoldLast%
                If sTag$ >= gblaFieldOrderHold(iCtr%).Begin And sTag$ <= gblaFieldOrderHold(iCtr%).End Then
                    SetFieldSortGroupFromTagEndgame sLabel$, iCtr%, gblaFieldOrderHold(iCtr%).SortInstruction, sTag$, sIndicators$, sText$
                    If sLabel$ = "*" Then
                        sReturn$ = sLabel$
                    Else
                        sReturn$ = sLabel$ + sSequence$
                    End If
                    GoTo SFSGFT_Return
                End If
            Next ' ictr%
            SetFieldSortGroupFromTagEndgame sLabel$, gbliFieldOrderHoldLast%, gblaFieldOrderHold(gbliFieldOrderHoldLast%).SortInstruction, sTag$, sIndicators$, sText$
            If sLabel$ = "*" Then
                sReturn$ = sLabel$
            Else
                sReturn$ = sLabel$ + sSequence$
            End If
        Case "B", "D", "F", "M", "P", "S", "U"
            For iCtr% = 1 To gbliFieldOrderBibLast%
                If sTag$ >= gblaFieldOrderBib(iCtr%).Begin And sTag$ <= gblaFieldOrderBib(iCtr%).End Then
                    SetFieldSortGroupFromTagEndgame sLabel$, iCtr%, gblaFieldOrderBib(iCtr%).SortInstruction, sTag$, sIndicators$, sText$
                    If sLabel$ = "*" Then
                        sReturn$ = sLabel$
                    Else
                        sReturn$ = sLabel$ + sSequence$
                    End If
                    GoTo SFSGFT_Return
                End If
            Next ' ictr%
            SetFieldSortGroupFromTagEndgame sLabel$, gbliFieldOrderBibLast%, gblaFieldOrderBib(gbliFieldOrderBibLast%).SortInstruction, sTag$, sIndicators$, sText$
            If sLabel$ = "*" Then
                sReturn$ = sLabel$
            Else
                sReturn$ = sLabel$ + sSequence$
            End If
        Case Else ' "Q", "W"
            For iCtr% = 1 To gbliFieldOrderOtherLast%
                If sTag$ >= gblaFieldOrderOther(iCtr%).Begin And sTag$ <= gblaFieldOrderOther(iCtr%).End Then
                    SetFieldSortGroupFromTagEndgame sLabel$, iCtr%, gblaFieldOrderOther(iCtr%).SortInstruction, sTag$, sIndicators$, sText$
                    If sLabel$ = "*" Then
                        sReturn$ = sLabel$
                    Else
                        sReturn$ = sLabel$ + sSequence$
                    End If
                    GoTo SFSGFT_Return
                End If
            Next ' ictr%
            SetFieldSortGroupFromTagEndgame sLabel$, iCtr%, gblaFieldOrderOther(gbliFieldOrderOtherLast%).SortInstruction, sTag$, sIndicators$, sText$
            If sLabel$ = "*" Then
                sReturn$ = sLabel$
            Else
                sReturn$ = sLabel$ + sSequence$
            End If
    End Select
    
SFSGFT_Return:

#If SetFieldSortGroupFromTagDebug = -1 Then
    Debug.Print "SFSGFT exit: " + sReturn$ + "<"
#End If
    SetFieldSortGroupFromTag = sReturn$
    
End Function

Public Property Get FldWasFound() As Boolean

    FldWasFound = m_bFieldWasFound

End Property



Public Function CharacterizeCharacterSet(Optional ByVal sMarcRecord$ = "") As String

    ' this function returns a code that describes the character set used to
    '   represent data in the current MARC record
    ' this function is called repeatedly by the function of the same name in the
    '   MARC file object to determine the character set repertoire used in
    '   an entire file
    
    Dim sIllegal$, sRecordToInspect$
    
    Dim iPtr%, iRc%
    
    Dim lPtr As Long
    
    Dim bMarcOCLC As Boolean, bMarcVoyager As Boolean
    Dim bVoyager As Boolean, bNone As Boolean, bCommon As Boolean
    Dim bOCLC As Boolean, bAmbiguousVO As Boolean, bAmbiguousVM As Boolean, bIllegal As Boolean
    
    Dim bHeader As Boolean
    
    Dim a(0 To 255) As Boolean
    
    
    If Len(sMarcRecord$) > 0 Then
        sRecordToInspect$ = sMarcRecord$
        If Mid(sRecordToInspect$, 10, 1) = "a" Then
            CharacterizeCharacterSet = CHARACTERSET_Utf8$
            Exit Function
        End If
    Else
        sRecordToInspect$ = m_sMarcIn$
        If CharacterEncodingScheme = "a" Then
            CharacterizeCharacterSet = CHARACTERSET_Utf8$
            Exit Function
        End If
    End If
        
    
    ' default value: unknown
    CharacterizeCharacterSet = CHARACTERSET_Generic$
    
    ' find each character used in this record, and mark it
    '   in our array as "used"
    ' 20050308: do NOT include the record leader in this
    '   calculation, mostly because of the stray characters
    '   OCLC puts into leader/22 (this can cause a record to be
    '   labeled as having the Voyager character set, for example)
    'For lPtr = 1 To Len(sRecordToInspect$)
    For lPtr = 25 To Len(sRecordToInspect$)
        'If Asc(Mid(sRecordToInspect$, lPtr, 1)) = 2 Then
            'Debug.Print Mid(sRecordToInspect, 1, 60)
            'Debug.Print Mid(sRecordToInspect, lPtr, 60)
        'End If
        a(Asc(Mid(sRecordToInspect$, lPtr, 1))) = True
    Next ' lptr
    
    ' categorize the characters in the record: do this by
    '   character groups
    
    ' we use sIllegal to contain a list of individual characters found
    '   in the record that are not in fact valid MARC characters under
    '   any circumstance; we then report these as part of our
    '   return code. having found the illegal characters, we then mark
    '   them in the array as 'not present' so they don't affect any of
    '   our work in determining character sets
    
    ' characters below #26 are illegal
    '   in all character sets
    For iPtr% = 0 To 26
        If a(iPtr%) Then
            sIllegal$ = sIllegal$ + Trim(str(iPtr%)) + " "
            a(iPtr%) = False
        End If
    Next ' iPtr%
    
    ' character #27 is OK in the MARC and OCLC character sets
    
    ' character #28 is illegal
    If a(28) Then
        sIllegal$ = sIllegal$ + "28 "
        a(28) = False
    End If
    
    ' characters 29, 30 31 and 32-126 are Legal
    
    ' characters 127 to 143 are illegal
    For iPtr% = 127 To 143
        If a(iPtr%) Then
            sIllegal$ = sIllegal$ + Trim(str(iPtr%)) + " "
            a(iPtr%) = False
        End If
    Next ' iPtr%
    
    ' 144 is Voyager degree sign
    If a(145) Then
        sIllegal$ = sIllegal$ + "145 "
        a(145) = False
    End If
    
    ' 146-150 are Voyager characters
    
    For iPtr% = 151 To 159
        If a(iPtr%) Then
            sIllegal$ = sIllegal$ + Trim(str(iPtr%)) + " "
            a(iPtr%) = False
        End If
    Next ' iPtr%
    For iPtr% = 206 To 207
        If a(iPtr%) Then
            sIllegal$ = sIllegal$ + Trim(str(iPtr%)) + " "
            a(iPtr%) = False
        End If
    Next ' iPtr%
    For iPtr% = 222 To 223
        If a(iPtr%) Then
            sIllegal$ = sIllegal$ + Trim(str(iPtr%)) + " "
            a(iPtr%) = False
        End If
    Next ' iPtr%
    ' 20080123: it is not clear to me why we would declare 238 and 239 to be
    '   illegal, as they are perfectly nice characters and were never part of
    '   any ambiguous character set
    'For iPtr% = 238 To 239
    '    If a(iPtr%)  Then
    '        sIllegal$ = sIllegal$ + Trim(str(iPtr%)) + " "
    '        a(iPtr%) = False
    '    End If
    'Next
    For iPtr% = 252 To 253
        If a(iPtr%) Then
            sIllegal$ = sIllegal$ + Trim(str(iPtr%)) + " "
            a(iPtr%) = False
        End If
    Next ' iPtr%
    If a(255) Then
        sIllegal$ = sIllegal$ + "255 "
        a(255) = False
    End If
    
    ' the following characters are common to all character sets, and
    '   so may be ignored
    For iPtr% = 29 To 126
        a(iPtr%) = False
    Next ' iPtr%
    For iPtr% = 161 To 174
        a(iPtr%) = False
    Next ' iPtr%
    For iPtr% = 176 To 186
        a(iPtr%) = False
    Next ' iPtr%
    For iPtr% = 188 To 189
        a(iPtr%) = False
    Next ' iPtr%
    For iPtr% = 224 To 251
        a(iPtr%) = False
    Next ' iPtr%
    If a(254) Then
        a(254) = False
    End If
    
    ' what's left as "true" (if anything) are characters
    '   that are not common to all character sets
    For iPtr% = 27 To 255
        If a(iPtr%) Then
            Select Case iPtr%
                Case 27 ' escape
                    bMarcOCLC = True
                Case 144 ' degree sign
                    'Debug.Print "144"
                    bVoyager = True
                Case 146 To 150 ' (p) (c) sharp ? !
                    'Debug.Print "146+"
                    bVoyager = True
                Case 160 ' script-l
                    'Debug.Print "160"
                    bVoyager = True
                Case 175 ' alpha
                    'Debug.Print "175"
                    bVoyager = True
                Case 187 ' dagger
                    'Debug.Print "187"
                    bVoyager = True
                Case 190 ' beta or script-l
                    'Debug.Print "190"
                    bAmbiguousVO = True
                Case 191 ' gamma
                    'Debug.Print "191"
                    bVoyager = True
                Case 192 To 198
                    'Debug.Print "192+"
                    bAmbiguousVM = True
                Case 199 To 205
                    'Debug.Print "199+"
                    bVoyager = True
                Case 208 To 221
                    'Debug.Print "208+"
                    bVoyager = True
                Case Else
            End Select
        End If
    Next ' iptr%
    
    If Len(sIllegal$) > 0 Then
        sIllegal$ = "Illegal character(s): " + Trim(sIllegal$)
    End If
    
    'If Not bMarcOCLC Then
    '    Debug.Print "MV " + str(bMarcVoyager) + " V " + str(bVoyager) + " none " + str(bNone) + " Common " + str(bCommon) + " OCLC " + str(bOCLC) + " aVO " + str(bAmbiguousVO) + " aVM " + str(bAmbiguousVM) + " ileeg " + str(bIllegal)
    'End If
    
    ' having inspected every character in the record, formulate a return code
    '   based on what you've found
    If bAmbiguousVM Then
        'If Not bMarcOCLC Then
        'Debug.Print "AVM"
        'End If
        If bMarcOCLC Then
            CharacterizeCharacterSet = Trim(CHARACTERSET_OCLC + " " + sIllegal$)
            Exit Function
        End If
        If bVoyager Then
            CharacterizeCharacterSet = Trim(CHARACTERSET_Voyager + " " + sIllegal$)
        Else
            CharacterizeCharacterSet = Trim(CHARACTERSET_AmbiguousVM + " " + sIllegal$)
        End If
        Exit Function
    End If
    If bAmbiguousVO Then
        'If Not bMarcOCLC Then
        'Debug.Print "AVO"
        'End If
        If bVoyager Then
            CharacterizeCharacterSet = Trim(CHARACTERSET_Voyager + " " + sIllegal$)
        ElseIf bMarcOCLC Then
            CharacterizeCharacterSet = Trim(CHARACTERSET_OCLC + " " + sIllegal$)
        Else
            CharacterizeCharacterSet = Trim(CHARACTERSET_AmbiguousVO + " " + sIllegal$)
        End If
        Exit Function
    End If
    If bVoyager Then
        'If Not bMarcOCLC Then
        'Debug.Print "V"
        'End If
        If bMarcOCLC Then
            CharacterizeCharacterSet = Trim(CHARACTERSET_AmbiguousVO + " " + sIllegal$)
        Else
            CharacterizeCharacterSet = Trim(CHARACTERSET_Voyager + " " + sIllegal$)
        End If
        Exit Function
    End If
    If bMarcOCLC Then
        'If Not bMarcOCLC Then
        'Debug.Print "MO"
        'End If
        CharacterizeCharacterSet = Trim(CHARACTERSET_MARC + " " + sIllegal$)
        Exit Function
    End If
    If bOCLC Then
        'If Not bMarcOCLC Then
        'Debug.Print "O"
        'End If
        CharacterizeCharacterSet = Trim(CHARACTERSET_OCLC + " " + sIllegal$)
        Exit Function
    End If
    
        'If Not bMarcOCLC Then
        'Debug.Print "DEFAULT"
        'End If
    
    ' this return value means: generic MARC 21 record, with no special characters of any kind
    CharacterizeCharacterSet = Trim(CHARACTERSET_Generic + " " + sIllegal$)

End Function

Public Function NationalAuthorityRecord(ByRef sReturnedAuthorityStandardNumber$) As Boolean

    ' determines whether or not the current authority record is a 'national' record
    
    ' UTF-8 safe
    
    Dim sMyLeader$, sMyDirectory$, sMyFields$, sTag$, sIndicators$, sField$
    
    Dim lPtr As Long
    
    
    ' assume that this is NOT a national-level authority record
    NationalAuthorityRecord = False
    sReturnedAuthorityStandardNumber$ = ""
    
    ' if the current record isn't an authority record, then we're all done
    If m_sRecordFormat$ <> "A" Then
        Exit Function
    End If
    
    lPtr = FldPointer
    
    ' maybe it's from the Library of Congress
    If FldFindFirst("010") Then
        sReturnedAuthorityStandardNumber$ = "010: " + FldText
        NationalAuthorityRecord = True
        FldPointer = lPtr
        Exit Function
    End If
    
    ' maybe it's a MeSH record in our database
    FldMoveTop
    Do While FldFindNext("035")
        If InStr(FldNorm, "DNLM") > 0 Or InStr(FldNorm, "DLC") > 0 Then
            ' 20041119: test for DLC thrown in
            sReturnedAuthorityStandardNumber$ = "035: " + FldText
            NationalAuthorityRecord = True
            FldPointer = lPtr
            Exit Function
        ElseIf InStr("*SH *N *NO *NR*", Mid(FldNorm, 1, 2)) > 0 Then
            ' 20041119: this test added for authority records in Voyager test databases, which
            '   appear to have the LC 010 moved to the 035 with no prefix
            NationalAuthorityRecord = True
            FldPointer = lPtr
            Exit Function
        End If
    Loop
    
    ' maybe it's a MeSH record at home in the NLM database
    If FldFindFirst("040") Then
        If InStr(FldText, MyMarcCharacter.MarcDelimiter + "aDNLM") > 0 Then
            sReturnedAuthorityStandardNumber$ = ""
            NationalAuthorityRecord = True
            FldPointer = lPtr
            Exit Function
        End If
    End If
    
    ' return with default value: not national
    
    FldPointer = lPtr

End Function
Public Function SerialBibliographicRecord(Optional ByVal sLeader$ = "") As Boolean

    ' UTF-8 safe: leader codes are always single-octet records
    
    ' determine whether a set of codes indicate serialness
    
    ' the principal use of this is within our own SetFormatCode function; but it may
    '   find use in other contexts
    
    ' three possibilities: we're supplied with
    '   a whole MARC leader
    '   the record type and bib level codes
    '   nothing--we'll use the current record's leader
    
    Dim iStart%
    
    Dim sBlock$
    
    ' default value: not a serial
    SerialBibliographicRecord = False
    
    ' based on the length of the incoming string, determine whether
    '   to look at bytes 06-07, or the first 2 characters
    ' NOTE that this is actually a very crude test; but if the outside
    '   is behaving properly, then it'll be just fine
    Select Case Len(sLeader$)
        Case 0
            If Len(m_sLeader$) = 0 Then
                Exit Function
            End If
            sBlock$ = Mid(m_sLeader$, 7, 2) ' leader/06 and leader/07
        Case 2
            sBlock$ = sLeader$
        Case Is > 6
            sBlock$ = Mid(sLeader$, 7, 2) ' assume it's a regulation record leader
        Case Else
            Exit Function
    End Select
    
    If Mid(sBlock$, 1, 1) = "a" Then
        If InStr(CONST_BibLevelMeansSerial$, Mid(sBlock$, 2, 1)) > 0 Then
            SerialBibliographicRecord = True
        End If
    End If

End Function



Public Function SetFormatCode(Optional ByVal sMarcLeader$ = "") As String

    ' 20010926: checked against current MARC definitions
    ' 20010926: added return code "H" for holdings and "A" for authority
    ' 20020220: determination of serial-ness now assigned to a central
    '   function so when this changes we only have to change one thing
    
    Dim sLeader$
    
    Dim iPtr%
    
    If Len(sMarcLeader$) > 0 Then
        sLeader$ = sMarcLeader$
        If Len(sLeader$) < 24 Then
            iPtr% = 1
        Else
            iPtr% = 7
        End If
    Else
        sLeader$ = m_sLeader$
        iPtr% = 7
    End If
    
    Select Case Mid(sLeader$, iPtr%, 1)
        Case "a", "t" ' books
            If SerialBibliographicRecord(sLeader$) Then
                SetFormatCode = RECORDFORMAT_Serial$
            Else
                SetFormatCode = RECORDFORMAT_Book$
            End If
        Case "c", "d", "i", "j" ' music/recordings
            SetFormatCode = RECORDFORMAT_Music$
        Case "e", "f" ' cartographic
            SetFormatCode = RECORDFORMAT_Map$
        Case "g", "k", "o", "r" ' "visual" stuff
            SetFormatCode = RECORDFORMAT_Film$
        Case "m" ' data files
            SetFormatCode = RECORDFORMAT_Data$
        Case "b", "p" ' mixed materials
            SetFormatCode = RECORDFORMAT_Mixed$
        Case "v", "x", "y", "u"
            SetFormatCode = RECORDFORMAT_Holding$
        Case "z"
            SetFormatCode = RECORDFORMAT_Authority$
        Case "q"
            SetFormatCode = RECORDFORMAT_CommunityInformation$
        Case "w"
            SetFormatCode = RECORDFORMAT_Classification$
        Case Else
            'Debug.Print "Unknown leader: >" + sLeader$ + "<"
            ' obsolete code 'h' (microform) not recognized
            ' obsolete code 'n' (special instructional material) not recognized
            SetFormatCode = RECORDFORMAT_Unknown$
    End Select

End Function


Public Function ReduceSeriesNumberingToPattern1(ByVal sSeriesNumbering$) As String

    ' UTF-8 safe: container must declare the character set
    
    ' convert series numbering--authority 642/a or bibliographic 4Superscript6/v or 8Superscript6v--to a
    '   pattern so authority and bibliographic information can be compared more or less
    '   reliably
    ' based on series numbering work group report: this is scheme A
    
    Dim sJunk$, sSave$
    
    Dim iRc%
    
    ' give us a crude normalization of the text in question
    If m_bUtf8 Then
        sSave$ = NormalizationScheme
        NormalizationScheme = "V"
        sJunk$ = Trim(NormString(sSeriesNumbering$))
        NormalizationScheme = sSave$
    Else
        sJunk$ = Trim(NormString(sSeriesNumbering$))
    End If
    
    ' 20040510: trial new-fangled thingie: if the text begins
    '   with something that appears to mean "new series", then
    '   throw that designation away
    ' NOTE that this list also appears in the Pattern2 function; and
    '   will need to be added to from time to time
    If Mid(sJunk$, 1, 4) = "N F " Then
        sJunk$ = Trim(Mid(sJunk$, 5))
    ElseIf Mid(sJunk$, 1, 8) = "NEW SER " Then
        sJunk$ = Trim(Mid(sJunk$, 9))
    ElseIf Mid(sJunk$, 1, 9) = "NOUV SER " Then
        sJunk$ = Trim(Mid(sJunk$, 10))
    End If
    ' 20040929: remove "etc" at the right end--why didn't we think
    '   of this before?
    If Right(sJunk$, 4) = " ETC" Then
        sJunk$ = Trim(Mid(sJunk$, 1, Len(sJunk$) - 4))
    End If
    ' replace all numerals with zeroes
    For iRc% = Len(sJunk$) To 1 Step -1
        If InStr(Const_NumString$, Mid(sJunk$, iRc%, 1)) > 0 Then
            sJunk$ = SafeStuff(sJunk$, iRc%, 1, "0")
        End If
    Next
    
    ' replace multiple zeroes with single ones
    Do
        iRc% = InStr(sJunk$, "0 0")
        If iRc% = 0 Then
            Exit Do
        End If
        sJunk$ = SafeStuff(sJunk$, iRc%, 2, "")
    Loop
    sJunk$ = RemoveRepeatedCharacters(sJunk$, "0")
    
    ' remove "etc" from the end
    If Len(sJunk$) > 4 Then
        If Right(sJunk$, 1) = " ETC" Then
            sJunk$ = Mid(sJunk$, 1, Len(sJunk$) - 4)
        End If
    End If

    ' and that's our numbering pattern
    ReduceSeriesNumberingToPattern1 = sJunk$

End Function

Public Function AddSpacesAroundDelimiters(ByVal sInputMarcString$) As String

    ' UTF-8 safe because delimiters and subfield codes may only be one
    '   octet apiece
    
    Dim sJunk$
    
    Dim lPtr As Long
    
    sJunk$ = sInputMarcString$
    
    For lPtr = Len(sJunk$) - 1 To 1 Step -1
        If Mid(sJunk$, lPtr, 1) = MyMarcCharacter.MarcDelimiter Then
            sJunk$ = SafeStuff(sJunk$, lPtr + 2, 0, " ")
            If lPtr > 1 Then
                sJunk$ = SafeStuff(sJunk$, lPtr, 0, " ")
            End If
        End If
    Next ' lptr
    
    AddSpacesAroundDelimiters = sJunk$

End Function


Public Function RemoveSpacesAroundDelimiters(ByVal sText$) As String

    ' UTF-8 safe: uses Mid in a safe way
    
    Dim iRc%
    
    For iRc% = Len(sText$) To 1 Step -1
        If Mid(sText$, iRc%, 1) = MyMarcCharacter.MarcDelimiter Then
            sText$ = Mid(sText$, 1, iRc% + 1) + Trim(Mid(sText$, iRc% + 2))
            If iRc% > 1 Then
                If Mid(sText$, iRc% - 1, 1) = " " Then
                    sText$ = Trim(Mid(sText$, 1, iRc% - 1)) + Mid(sText$, iRc%)
                End If
            End If
        End If
    Next

    RemoveSpacesAroundDelimiters = sText$

End Function

Public Function RemoveSpaces(ByVal sText$) As String

    ' UTF-8 safe: we're only dealing with literal spaces here
    
    Dim iRc%
    
    Do
        iRc% = InStr(sText$, " ")
        If iRc% = 0 Then
            Exit Do
        End If
        sText$ = SafeStuff(sText$, iRc%, 1, "")
    Loop
    
    RemoveSpaces$ = sText$

End Function


Public Function RemoveDelimiters(ByVal sMarcText$, Optional ByVal sDelimiterReplacement$ = "") As String

    ' either remove subfield codes altogether, or replace them with
    '   something else
    
    ' UTF-8 safe: we're using Stuff on things known to contain only
    '   low-end characters
    
    Dim lPtr As Long
    
    Dim bReplacement As Boolean
    
    If Len(sDelimiterReplacement$) > 0 Then
        If sDelimiterReplacement$ = MyMarcCharacter.MarcDelimiter Then
            sDelimiterReplacement$ = "$"
        End If
        If sDelimiterReplacement$ <> " " Then
            bReplacement = True
        End If
    End If
    
    Do
        lPtr = InStr(sMarcText$, MyMarcCharacter.MarcDelimiter)
        If lPtr = 0 Then
            Exit Do
        End If
        If bReplacement Then
            sMarcText$ = SafeStuff(sMarcText$, lPtr, 1, sDelimiterReplacement$)
        Else
            sMarcText$ = SafeStuff(sMarcText$, lPtr, 2, " ")
        End If
    Loop
    
    RemoveDelimiters = sMarcText$

End Function


Public Function LeftPad(ByVal sIn$, ByVal iFinishedLengthInOctets%, Optional ByVal sPaddingCharacter$ = "0") As String

    ' UTF-8 safe because length specified in octets; we can only hope that
    '   this is only used by container programs when it's safe to do (most of the
    '   time, it's going to be used to left-pad a string of numerals with zeroes,
    '   which is perfectly safe)
    ' note that by referencing the built-in String$ function, we're also assuming
    '   that the supplied padding character is a single-octet character
    
    LeftPad = Right(String$(iFinishedLengthInOctets%, sPaddingCharacter$) + sIn$, iFinishedLengthInOctets%)

End Function

Public Function ReduceSeriesNumberingToPattern2(ByVal sSeriesNumbering$) As String

    ' UTF-8 safe: container must declare the character set
    
    ' convert series numbering--authority 642/a or bibliographic 4Superscript6/v or 8Superscript6v--to a
    '   pattern so authority and bibliographic information can be compared more or less
    '   reliably
    ' based on series numbering work group report: this is scheme B

    Dim sJunk$, sUcase$
    
    Dim iLen%, iRc%, iOctets%
    
    Dim lPtr As Long, lPtr2 As Long, lLength As Long
    
    sUcase$ = SafeUCase(sJunk$)
    ' so much is utf-8 neutral
    If Right(sUcase$, 5) = " ETC." Then
        sJunk = Trim(Mid(sJunk$, 1, Len(sJunk$) - 4))
        If Right(sJunk$, 1) = "," Then
            sJunk = Trim(Mid(sJunk$, 1, Len(sJunk$) - 1))
        End If
    End If
    
    ' 20040510: trial new-fangled thingie: if the text begins
    '   with something that appears to mean "new series", then
    '   throw that designation away
    ' NOTE that this list also appears in the Pattern1 function; and
    '   will need to be added to from time to time
    ' 20040929: but at this point we have NOT yet normalized the
    '   string; so we have to try lots of possibilities, including
    '   the punctuation
    If Mid(sUcase$, 1, 4) = "N.F." Then
        sJunk$ = Trim(Mid(sJunk$, 5))
    ElseIf Mid(sUcase$, 1, 5) = "N. F." Then
        sJunk$ = Trim(Mid(sJunk$, 6))
    ElseIf Mid(sUcase$, 1, 8) = "NEW SER." Then
        sJunk$ = Trim(Mid(sJunk$, 9))
    ElseIf Mid(sUcase$, 1, 8) = "NEW SER " Then
        sJunk$ = Trim(Mid(sJunk$, 9))
    ElseIf Mid(sUcase$, 1, 9) = "NOUV.SER." Then
        sJunk$ = Trim(Mid(sJunk$, 10))
    ElseIf Mid(sUcase$, 1, 9) = "NOUV SER " Then
        sJunk$ = Trim(Mid(sJunk$, 10))
    ElseIf Mid(sUcase$, 1, 10) = "NOUV. SER." Then
        sJunk$ = Trim(Mid(sJunk$, 11))
    End If
    
    sJunk$ = sSeriesNumbering$
    
    If m_bUtf8 Then
    
        lLength = Len(sJunk$)
        lPtr = 1
        Do
            MyMarcCharacter.Utf8Char = Mid(sJunk$, lPtr)
            ' get ready for the next character
            iOctets% = MyMarcCharacter.Utf8CharOctets
            
            Select Case MyMarcCharacter.Utf8CharCategory
                Case "Lu", "Lt" ' uppercase or titlecase
                    If lPtr > 1 Then ' current character is not the first one
                        lPtr2 = MyMarcCharacter.Utf8CharFindFirstOctet(sJunk$, lPtr - 1)
                        MyMarcCharacter.Utf8Char = Mid(sJunk$, lPtr2)
                        If MyMarcCharacter.Utf8CharCategory = "Ll" Then
                            If lPtr + iOctets% < lLength Then
                                MyMarcCharacter.Utf8Char = Mid(sJunk$, lPtr + iOctets%)
                                If MyMarcCharacter.Utf8CharCategory <> "Ll" Then
                                    sJunk$ = SafeStuff(sJunk$, iRc%, iOctets%, "A")
                                End If
                            Else
                                sJunk$ = SafeStuff(sJunk$, iRc%, iOctets%, "A")
                            End If
                        End If
                    Else ' we're at the first character
                        If lPtr + iOctets% < lLength Then ' more than 1 character in the string
                            MyMarcCharacter.Utf8Char = Mid(sJunk$, lPtr + iOctets%)
                            If MyMarcCharacter.Utf8CharCategory <> "Ll" Then
                                sJunk$ = SafeStuff(sJunk$, iRc%, iOctets%, "A")
                            End If
                        Else
                            sJunk$ = "A"
                        End If
                    End If
                Case "Nd", "Nl", "No" ' numbers of any kind
                    sJunk$ = SafeStuff(sJunk$, lPtr, MyMarcCharacter.Utf8CharOctets, "0")
            End Select
            ' move to the next character
            lPtr = lPtr + iOctets%
            If lPtr > lLength Then
                Exit Do
            End If
        Loop ' for each character in the string
        
    Else ' not UTF-8
    
        iLen% = Len(sJunk$)
        For iRc% = Len(sJunk$) To 1 Step -1
            If InStr(CONST_UpperCaseAlpha$, Mid(sJunk$, iRc%, 1)) > 0 Then
                If iRc% > 1 Then
                    If InStr(CONST_LowerCaseAlpha$, Mid(sJunk$, iRc% - 1, 1)) = 0 Then
                        If iRc% < iLen% Then
                            If InStr(CONST_LowerCaseAlpha$, Mid(sJunk$, iRc% + 1, 1)) = 0 Then
                                ' uppercase letter, not preceded by lowercase letter, now followed
                                '   by lowercase letter
                                sJunk$ = SafeStuff(sJunk$, iRc%, 1, "A")
                            ' no else
                            End If
                        Else
                            ' uppercase letter, not preceded by lowercase letter, at end
                            '   of the string
                            sJunk$ = SafeStuff(sJunk$, iRc%, 1, "A")
                        End If
                    ' no else
                    End If
                Else
                    If iLen% > 1 Then
                        If CharCategory(Mid(sJunk$, iRc% + 1, 1)) <> Utf8_LetterLowercase$ Then
                            ' uppercase letter at beginning of the string
                            sJunk$ = SafeStuff(sJunk$, iRc%, 1, "A")
                        ' no else
                        End If
                    Else
                        sJunk$ = "A"
                    End If
                End If
            End If
        Next
        ' replace all numberals with zeroes
        For iRc% = Len(sJunk$) To 1 Step -1
            If InStr(Const_NumString$, Mid(sJunk$, iRc%, 1)) > 0 Then
                sJunk$ = SafeStuff(sJunk$, iRc%, 1, "0")
            End If
        Next
        
    End If ' UTF-8 or not?
    
    ' one way or another, we've got a string in which we've replace the uppercase
    '   character with "A" and the numerals with "0"
    
    ' the following is all UTF-8 safe, because we're looking for low-end stuff only
    
    ' replace various kinds of repeated zeroes with a single zero
    Do
        iRc% = InStr(sJunk$, "0 0")
        If iRc% = 0 Then
            Exit Do
        End If
        sJunk$ = SafeStuff(sJunk$, iRc%, 2, "")
    Loop
    Do
        iRc% = InStr(sJunk$, "0-0")
        If iRc% = 0 Then
            Exit Do
        End If
        sJunk$ = SafeStuff(sJunk$, iRc%, 2, "")
    Loop
    Do
        iRc% = InStr(sJunk$, "0,0")
        If iRc% = 0 Then
            Exit Do
        End If
        sJunk$ = SafeStuff(sJunk$, iRc%, 2, "")
    Loop
    Do
        iRc% = InStr(sJunk$, "0, 0")
        If iRc% = 0 Then
            Exit Do
        End If
        sJunk$ = SafeStuff(sJunk$, iRc%, 3, "")
    Loop
    Do
        iRc% = InStr(sJunk$, "0.0")
        If iRc% = 0 Then
            Exit Do
        End If
        sJunk$ = SafeStuff(sJunk$, iRc%, 2, "")
    Loop
    sJunk$ = RemoveRepeatedCharacters(sJunk$, "0")
    
    ' remove various occurrences of "multple character strings"
    sJunk$ = RemoveRepeatedCharacters(sJunk$, "A")
    
    If Right(sJunk$, 2) = "A." Then
        sJunk = Trim(Mid(sJunk$, 1, Len(sJunk$) - 1))
    End If
    If Right(sJunk$, 2) = "0." Then
        sJunk = Trim(Mid(sJunk$, 1, Len(sJunk$) - 1))
    End If

    ReduceSeriesNumberingToPattern2 = sJunk$

End Function
Public Function Convert533Sfd7To539(ByVal s533Subfield7$) As String

    ' receives subfield $7 from a 533 field and converts it into the OCLC
    '   539 field, with each data element in a separate subfield
    
    ' UTF-8 safe because 533/7 is a control subfield, which should contain only
    '   single-octet characters
    
    ' todo: convert things that are all-fill to nulls
    
    Dim sOut$, sJunk$
    
    Dim iLen%
    
    If Mid(s533Subfield7$, 1, 1) = MyMarcCharacter.MarcDelimiter Then
        ' 20040615: rtrim substituted for plain ol' trim
        s533Subfield7$ = RTrim(Mid(s533Subfield7$, 3))
    End If
    
    iLen% = Len(s533Subfield7$)
    
    If iLen% > 0 Then
        sJunk$ = Trim(Mid(s533Subfield7$, 1, 1)) ' byte 00: publication status
        If Len(sJunk$) > 0 Then
            sOut$ = MyMarcCharacter.MarcDelimiter + "a" + sJunk$ ' becomes $a
        End If
        If iLen% > 4 Then
            sJunk$ = Trim(Mid(s533Subfield7$, 2, 4)) ' bytes 01-04: date 1
            If Len(sJunk$) > 3 Then
                sOut$ = sOut$ + MyMarcCharacter.MarcDelimiter + "b" + sJunk$ ' becomes $b
            End If
            If iLen% > 8 Then
                sJunk$ = Trim(Mid(s533Subfield7$, 6, 4)) ' bytes 05-08: date 2
                If Len(sJunk$) > 3 Then
                    sOut$ = sOut$ + MyMarcCharacter.MarcDelimiter + "c" + sJunk$ ' becomes $c
                End If
                If iLen% > 11 Then
                    sJunk$ = Trim(Mid(s533Subfield7$, 10, 3)) ' bytes 09-11 : place of publication
                    If Len(sJunk$) > 2 Then
                        sOut$ = sOut$ + MyMarcCharacter.MarcDelimiter + "d" + sJunk$ ' becomes $d
                    End If
                    If iLen% > 12 Then
                        sJunk$ = Trim(Mid(s533Subfield7$, 13, 1)) ' byte 12: frequency
                        If Len(sJunk$) > 0 Then
                            sOut$ = sOut$ + MyMarcCharacter.MarcDelimiter + "e" + sJunk$ ' becomes $e
                        End If
                        If iLen% > 13 Then
                            sJunk$ = Trim(Mid(s533Subfield7$, 14, 1)) ' byte 13: regularity
                            If Len(sJunk$) > 0 Then
                                sOut$ = sOut$ + MyMarcCharacter.MarcDelimiter + "f" + sJunk$ ' becomes $f
                            End If
                            If iLen% > 14 Then
                                sJunk$ = Trim(Mid(s533Subfield7$, 15, 1)) ' byte 14: form of item
                                If Len(sJunk$) > 0 Then
                                    sOut$ = sOut$ + MyMarcCharacter.MarcDelimiter + "g" + sJunk$ ' becomes $g
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End If
    End If
    
    Convert533Sfd7To539 = sOut$

End Function


Public Function RemoveRepeatedCharacters(ByVal sOriginalString$, Optional ByVal sSingleCharToRemoveIfMultiple$ = " ") As String

    ' replace consecutive multiple occurrences of a character (most likely: the space)
    '   with a single occurrence of that character
    
    ' UTF-8 safe because the supplied character may be one or more octets; we don't
    '   check; and we remove the proper number of octets, instead of assuming
    '   one octet per character
    
    Dim sInput$, sDoubleChar$
    Dim iLen%
    
    Dim lPtr As Long, lLen As Long
    
    
    sDoubleChar$ = sSingleCharToRemoveIfMultiple$ + sSingleCharToRemoveIfMultiple$
    
    lLen = Len(sSingleCharToRemoveIfMultiple$)
    
    Do
        lPtr = InStr(sOriginalString$, sDoubleChar$)
        If lPtr = 0 Then
            Exit Do
        End If
        sOriginalString$ = SafeStuff(sOriginalString$, lPtr, lLen, "")
    Loop
    
    RemoveRepeatedCharacters = sOriginalString$

End Function


Public Function ExtractSubfield(ByVal sOriginalField$, ByVal sSubfieldCodeWithoutDelimiter$, ByRef sReturnedSubfieldText$, Optional ByVal lStartingPosition As Long = 1) As Long
    
    ' return the first or subsequent occurrence of a subfield within a variable field
    
    ' to find the first occurrence of a subfield within a field, invoke this
    '   function with lStartingPosition set to 1 (its default value); the function
    '   returns the location of the text of the subfield within the original field, and
    '   the text of the subfield itself as the sReturnedSubfieldText parameter
    ' to find each subsequent occurrence of the same subfield within the same field, invoke this
    '   function with the value returned by the previous invocation as lStartingPosition
    
    ' UTF-8 safe because delimiters and subfield codes are single-octet characters, and
    '   this function is ignorant of the contents of the subfield
    
    Dim lRc As Long, lRc2 As Long
    
    ' default value: nothing found
    sReturnedSubfieldText$ = ""
    ExtractSubfield = 0
    
    'Debug.Print "ExSfd: >" + sOriginalField$ + "< >" + sSubfieldCodeWithoutDelimiter$ + "<"
    'Debug.Print "Starting position: " + str(lStartingPosition)
    
    Select Case Len(sSubfieldCodeWithoutDelimiter$)
        Case 1
            lRc = InStr(Mid(sOriginalField$, lStartingPosition), MyMarcCharacter.MarcDelimiter + sSubfieldCodeWithoutDelimiter$)
        Case 0
            Exit Function ' with "not found" values
        Case Else
            lRc = InStr(Mid(sOriginalField$, lStartingPosition), sSubfieldCodeWithoutDelimiter$)
    End Select
    
    'Debug.Print "At: " + str(lRc)
    If lRc = 0 Then
        Exit Function ' with "not found" values
    End If
    
    ' we've found the subfield of interest
    sReturnedSubfieldText$ = Trim(Mid(sOriginalField$, lRc + lStartingPosition + 1))
    'Debug.Print "ret text: >" + sReturnedSubfieldText$ + "<"
    lRc2 = InStr(sReturnedSubfieldText$, MyMarcCharacter.MarcDelimiter)
    If lRc2 > 0 Then
        sReturnedSubfieldText$ = Trim(Mid(sReturnedSubfieldText$, 1, lRc2 - 1))
    End If

    'Debug.Print "Retval: " + str(lStartingPosition + lRc + 1)
    ExtractSubfield = lStartingPosition + lRc + 1
    
End Function
Public Function CheckISXN(ByVal sIsbnOrIssn$) As Boolean

    ' this function inspects an ISBN, ISSN or ISMN, and returns a value indicating
    '   that it is good or bad
    
    ' the supplied thing must be stripped of subfield codes and accompanying
    '   text--just the number itself, please
    
    ' UTF-8 safe exactly because we should only be getting the number itself:
    '   and the number itself should only contain single-octet characters
    
    ' 20030712: add capacity to handle 13-character ISBNs
    ' 20040421: add ISMN, too
    
    
    Dim iLen%, iPtr%, iMultiplier%
    Dim lTotal As Long
    Dim sCheck$, sThing$
    
    ' set default value: does not check out
    CheckISXN = False
    
    sThing$ = SafeUCase(sIsbnOrIssn$)
    
    ' remove any hyphens
    If InStr(sThing$, "-") > 0 Then
        Do
            iLen% = InStr(sThing$, "-")
            If iLen% = 0 Then
                Exit Do
            End If
            sThing$ = SafeStuff(sThing$, iLen%, 1, "")
        Loop
    End If
    
    iLen% = Len(sThing$)
    If iLen% <> 8 And iLen% <> 10 And iLen% <> 13 Then
        Exit Function
    End If
    
    If Mid(sThing$, 1, 1) = "M" Then
        ' must be an ISMN
        lTotal = 3
        iMultiplier% = 1
        For iPtr% = 2 To 10
            lTotal = lTotal + (iMultiplier * Val(Mid(sThing$, iPtr%, 1)))
            If iMultiplier% = 1 Then
                iMultiplier% = 3
            Else
                iMultiplier% = 1
            End If
        Next ' iptr
        
        If lTotal Mod 10 = 0 Then
            CheckISXN = True
        'Else
            ' default return value is already False
        End If
        Exit Function ' exit here if handling an ISMN
    End If
    
    ' if we get here, then the thing is either an ISBN or an ISSN;
    '   ISMNs have been excluded already
    
    sCheck$ = Right(sThing$, 1)
    Select Case sCheck$
        Case "X"
            lTotal = 10
        Case "0" To "9"
            lTotal = Val(sCheck$)
        Case Else
            Exit Function
    End Select
    
    
    ' the big test: does the thing compute?
    If iLen% = 13 Then
        ' cf http://www.isbn.org/standards/home/isbn/transition.asp
        lTotal = 0
        iMultiplier% = 1
        For iPtr% = 1 To iLen% - 1
            lTotal = lTotal + (Val(Mid(sThing$, iPtr%, 1)) * iMultiplier%)
            If iMultiplier% = 1 Then
                iMultiplier% = 3
            Else
                iMultiplier% = 1
            End If
        Next ' iptr%
        ' see note about redundancy in the 'convert' routine
        If Right(sThing$, 1) <> Trim(str((10 - (lTotal Mod 10)) Mod 10)) Then
            Exit Function
        End If
    Else
        iMultiplier% = iLen%
        For iPtr% = 1 To iLen% - 1
            sCheck$ = Mid(sThing$, iPtr%, 1)
            If InStr(Const_NumString$, sCheck$) = 0 Then
                Exit Function
            End If
            lTotal = lTotal + (Val(sCheck$) * iMultiplier%)
            iMultiplier% = iMultiplier% - 1
        Next ' iptr%
        If lTotal Mod 11 <> 0 Then
            Exit Function
        End If
    End If
    
    CheckISXN = True
    ' everything is OK: return

End Function


Public Function ConvertISBN13To10(ByVal s13CharacterISBN$) As String

    ' given a 13-characterr ISBN, convert it to the 10-character format
    '   used before 2007
    
    ' added 20040421
    
    ' see http://www.isbn.org/standards/home/isbn/transition.asp
    
    
    Dim iCtr%, iWeight%
    
    Dim lTotal As Long
    
    Dim sISBN$, sExtension$
    
    
    ConvertISBN13To10 = s13CharacterISBN$
    
    ' remove any hyphens
    Do
        iCtr% = InStr(s13CharacterISBN$, "-")
        If iCtr% = 0 Then
            Exit Do
        End If
        s13CharacterISBN$ = SafeStuff(s13CharacterISBN$, iCtr%, 1, "")
    Loop
    
    ' snap off any 'extension' that may be present
    For iCtr% = 1 To Len(s13CharacterISBN$)
        If InStr("0123456789X-", Mid(s13CharacterISBN$, iCtr%, 1)) = 0 Then
            sExtension$ = Mid(s13CharacterISBN$, iCtr%)
            s13CharacterISBN$ = Mid(s13CharacterISBN$, 1, iCtr% - 1)
            Exit For
        End If
    Next ' ictr%
    
    iCtr% = Len(s13CharacterISBN$)
    ' set the basic string, including the new '978' prefix--and
    '   discard the current check digit
    If iCtr% < 13 Then
        Exit Function
    End If
    
    If Mid(s13CharacterISBN$, 1, 3) = "978" Then
        sISBN$ = Mid(s13CharacterISBN$, 4, 9)
    Else
        Exit Function
    End If
    
    iWeight% = 10
    lTotal = 0
    For iCtr% = 1 To 9
        lTotal = lTotal + (iWeight% * (Val(Mid(sISBN$, iCtr%, 1))))
        iWeight% = iWeight% - 1
    Next ' ictr%
    
    iWeight% = 11 - (lTotal Mod 11)
    If iWeight = 10 Then
        ConvertISBN13To10 = sISBN$ + "X"
    Else
        ConvertISBN13To10 = sISBN$ + Trim(str(iWeight%))
    End If
    
End Function

Public Function FldMoveFirst(Optional bSkipDeletedFields As Boolean = True) As Boolean

    FldPointer = m_iFirstField%
    
    ' 20070727: move to the first non-deleted field
    If bSkipDeletedFields Then
        If FldPointer > -1 Then
            Do While FldDeleted
                DoEvents
                FldMoveNext False
                If FldPointer < 0 Then
                    Exit Do
                End If
            Loop
        End If
    End If
    
    FldMoveFirst = FldWasFound
    
    m_bFldAtTop = False
    m_bFldAtBottom = False
    m_bSfdAtTop = False
    m_bSfdAtBottom = False
    
End Function

Public Function FldMoveNext(Optional bSkipDeletedFields As Boolean = True) As Boolean

    Static iCtr%
    
    
    iCtr% = iCtr% + 1
    'Debug.Print "Moving next; skip? " + str(bSkipDeletedFields) + " " + str(iCtr% + 1)
    If m_bFldAtTop Then
        FldPointer = m_iFirstField%
    Else
        FldPointer = FldNext
    End If
    
    ' 20070727: move to the first non-deleted field
    If bSkipDeletedFields Then
        If FldPointer > -1 Then
            Do While FldDeleted
                DoEvents
                FldMoveNext False ' no infinite recursion please; we'll decide for ourselves
                If FldPointer < 0 Then
                    Exit Do
                End If
            Loop
        End If
    End If
    
    FldMoveNext = FldWasFound
    
    m_bFldAtTop = False
    m_bFldAtBottom = False
    m_bSfdAtTop = False
    m_bSfdAtBottom = False
    
    iCtr% = iCtr% - 1
    
End Function

Public Function FldMovePrev(Optional bSkipDeletedFields As Boolean = True) As Boolean

    If m_bFldAtBottom Then
        FldPointer = m_iLastField%
    Else
        FldPointer = FldPrev
    End If
    
    ' 20070727: move to the first non-deleted field
    If bSkipDeletedFields Then
        If FldPointer > -1 Then
            Do While FldDeleted
                DoEvents
                FldMovePrev False ' we'll decide for ourselves; no infinite recursion, please!
                If FldPointer < 0 Then
                    Exit Do
                End If
            Loop
        End If
    End If
    
    FldMovePrev = FldWasFound
    
    m_bFldAtTop = False
    m_bFldAtBottom = False
    m_bSfdAtTop = False
    m_bSfdAtBottom = False
    
End Function

Public Function FldMoveLast(Optional bSkipDeletedFields As Boolean = True) As Boolean

    FldPointer = m_iLastField%

    ' 20070727: move to the last non-deleted field
    If bSkipDeletedFields Then
        If FldPointer > -1 Then
            Do While FldDeleted
                DoEvents
                FldMovePrev False
                If FldPointer < 0 Then
                    Exit Do
                End If
            Loop
        End If
    End If
    
    FldMoveLast = FldWasFound
    
    
    m_bFldAtTop = False
    m_bFldAtBottom = False
    m_bSfdAtTop = False
    m_bSfdAtBottom = False
    
End Function


Public Function RemoveNonfilingCharacters(ByVal sRecordType$, ByVal sTag$, ByRef sIndicators$, ByVal sField$) As String

    ' UTF-8 safe: separate handling provided
    
    ' NOTE that the iindicators parameter here is ByRef--this routine CHANGES the
    '   received text. if the routine removes nonfiling characters, the routine adjusts
    '   the indicators and returns the changed the field text
    
    ' NOTE further that this routine is already set up to handle the "nonfiling zone" characters,
    '   even though they are not at the time of writing to be used in MARC records
    
    Dim iNonfilingIndicator%, iNonfiling%, iA%, iOctets%
    
    Dim sTagString$, sPrefix$
    
    Dim lPtr As Long, lPtr2 As Long, lEnd As Long
    
    Dim bZone As Boolean, bChanged As Boolean
    
    
    ' assume that the output is the same as the input
    RemoveNonfilingCharacters = sField$
    
    
    ' set list of fields with nonfilers
    Select Case sRecordType$
        Case "A"
            sTagString$ = CONST_AuthorityTagString$
        Case "B", "D", "F", "M", "P", "S", "U"
            sTagString$ = CONST_BibliographicTagString$
        Case "Q"
            sTagString$ = CONST_CommunityInfoString$
        Case Else
            ' holdings and classifciation don't have any!
            sTagString$ = "Superscript6Superscript6Superscript6X"
    End Select
    
        
    ' deal first with the nonfiling zone
    
#If True Then
    ' 20060317: the nonfling zone is now handled by a separate routine, so that
    '   we can invoke this as a separate thingie when we need to
    If RemoveNonfilingZone(sField$) Then
        RemoveNonfilingCharacters = sField$
        ' if we came here with a nonzero nonfiling characters indicator,
        '   set it to zero because it's no longer relevant (recalling that the
        '   indicators are passed ByRef so we can reset them as necessary)
        iNonfiling% = InStr(sTagString$, sTag$)
        If iNonfiling% > 0 Then
            iNonfilingIndicator% = Val(Mid(sTagString$, iNonfiling% + 4, 1))
            If iNonfilingIndicator% > 0 Then
                If InStr("123456789", Mid(sIndicators$, iNonfilingIndicator%, 1)) > 0 Then
                    sIndicators$ = SafeStuff(sIndicators$, iNonfilingIndicator%, 1, "0")
                End If
            End If
        End If
        GoTo RemoveNonfilingCharacters_Exit
    End If
#Else
    ' 20060317: replaced by the preceeding call to a separate routine
    If m_bUtf8 Then
        If InStr(Trim(sField$), MyMarcCharacter.Utf8NonSortBegin) = 1 Then
            bZone = True
            lPtr = InStr(sField$, MyMarcCharacter.Utf8NonSortBegin) ' repoint, considering leading spaces
            lPtr2 = InStr(sField$, MyMarcCharacter.Utf8NonSortEnd)
            If lPtr2 > 0 Then
                sField$ = Mid(sField$, lPtr2 + 1)
                bChanged = True
            End If
        End If
        
    Else ' not UTF-8
        If InStr(Trim(sField$), MyMarcCharacter.MarcNonSortBegin) = 1 Then
            bZone = True
            lPtr = InStr(sField$, MyMarcCharacter.MarcNonSortBegin)
            lPtr2 = InStr(sField$, MyMarcCharacter.MarcNonSortEnd)
            If lPtr2 > 0 Then
                sField$ = Mid(sField$, lPtr2 + 1)
                bChanged = True
            End If
        End If
    End If
#End If

    ' we're going to be looking at text that begins just after the
    '   $a marker (if there isn't any, we're assuming that the
    '   text supplied begins with $a)
    iA% = InStr(sField$, MarcDelimiter + "a")
    If iA% > 0 Then
        sPrefix$ = Mid(sField$, 1, iA% + 1)
        sField$ = Mid(sField$, iA% + 2)
    End If

    ' does this field have a nonfiling indicator?
    iNonfiling% = InStr(sTagString$, sTag$)
    If iNonfiling% > 0 Then
        
        ' get the position of the nonfiling indicator
        iNonfilingIndicator% = Val(Mid(sTagString$, iNonfiling% + 4, 1))
        ' get the value of the nonfiling indicator
        iNonfiling% = Val(Mid(sIndicators$, iNonfilingIndicator%, 1))
        ' 20040621: and set it to zero so you don't accidentally do this twice!
        sIndicators$ = SafeStuff(sIndicators$, iNonfilingIndicator%, 1, "0")
        
        If iNonfiling% > 0 Then
            bChanged = True
            ' field contains nonfiling characters
            If m_bUtf8 Then
                Do
                    iOctets% = MyMarcCharacter.Utf8CharOctets(Mid(sField$, 1, 1))
                    sField$ = Mid(sField$, iOctets% + 1)
                    iNonfiling% = iNonfiling% - 1
                    If iNonfiling = 0 Then
                        Exit Do
                    End If
                    If Len(sField$) = 0 Then
                        Exit Do
                    End If
                Loop
            Else
                sField$ = Mid(sField$, iNonfiling% + 1)
            End If
            
        End If ' was the nonfiling indicator >0?
        
    End If ' does this field have a nonfiling indicator?
    
    
    ' return the whole field, with first word in $a neatly uppercased
    If bChanged Then
        RemoveNonfilingCharacters = sPrefix$ + UCaseFirstWord(sField$)
    End If
    
    ' we branch here if the supplied text contained a nonfiling zone: the
    '   return value is already set
RemoveNonfilingCharacters_Exit:

End Function

Public Function CLCL(ByVal sString1$, ByVal sString2$) As Long

    ' this compares two character strings and returns the point of
    '   difference, if any
    ' if there is no difference, this returns zero
    
    ' UTF-8 safe: separate handling provided
    
    Dim lLen1 As Long, lLen2 As Long, lMax As Long, lPtr As Long
        
    Dim iOctets1%
    
    Dim sChar1$
    
    ' set default value: strings are the same
    CLCL = 0
    
    ' fine our two lengths, in octets
    lLen1 = Len(sString1$)
    lLen2 = Len(sString2$)
    
    ' find the shorter of the two lengths: we'll use just
    '   this much for comparison
    lMax = lLen1
    If lLen2 < lMax Then
        lMax = lLen2
    End If
    ' if the shorter length is zero, we're already done; if
    '   both are zero we'll retain the default return
    '   value of 0; else we'll point to the first character
    '   as the first point of difference
    If lMax = 0 Then
        If lLen1 > 0 Then
            CLCL = 1
        End If
        Exit Function
    End If
        
    ' here we to the actual comparisons, hopping out
    '   at the first sign of a difference
    If Not m_bUtf8 Then
        For lPtr = 1 To lMax
            If Mid(sString1$, lPtr, 1) <> Mid(sString2$, lPtr, 1) Then
                Exit For
            End If
        Next ' lptr
        
    Else ' UNICODE
    
        lPtr = 1
        Do
            ' get the next character from the first string
            '   and save information about it
            MyMarcCharacter.Utf8Char = Mid(sString1$, lPtr)
            sChar1$ = MyMarcCharacter.Utf8Char
            iOctets1% = MyMarcCharacter.Utf8CharOctets
            ' get the next character from the second string
            MyMarcCharacter.Utf8Char = Mid(sString2$, lPtr)
            ' if the lengths are different they're obviously not
            '   the same character
            If iOctets1% <> MyMarcCharacter.Utf8CharOctets Then
                Exit Do
            End If
            ' if they're not the same then they're not the same
            If sChar1$ <> MyMarcCharacter.Utf8Char Then
                Exit Do
            End If
            ' move to the next character if any
            lPtr = lPtr + iOctets1%
            If lPtr > lMax Then
                Exit Do
            End If
        Loop
        
    End If ' UNICODE or not?
    
    ' if we didn't find any difference, then we're going
    '   to exit with the return value of zero
    ' if we exited the routine either at or before the
    '   last character, then we're going to return the
    '   pointer to the difference-point as the value of the
    '   function
    If lPtr > lMax Then
        ' this is OK: loop exited when completed and we've got
        '   the default value of zero already set
    Else
        ' we found a difference and it's right here
        CLCL = lPtr
    End If

End Function

Public Function LCaseFirstWord(ByVal sString$) As String

    Dim sChar$, sLeft$
    
    Dim lPtr As Long, lLen As Long
    
    Dim iOctets%, iRc%
    
    lLen = Len(sString$)
    If lLen = 0 Then
        LCaseFirstWord = ""
        Exit Function
    End If
    
    ' default value: same as initial value
    LCaseFirstWord = sString$
    
    If Mid(sString$, 1, 1) = MyMarcCharacter.MarcDelimiter Then
        sLeft$ = Mid(sString$, 1, 2)
        sString$ = Mid(sString$, 3)
    End If
    
    lPtr = 1
    If m_bUtf8 Then
        Do
            iOctets% = MyMarcCharacter.Utf8CharOctets(Mid(sString$, lPtr, 1))
            MyMarcCharacter.Utf8Char = Mid(sString, lPtr, iOctets%)
            Select Case MyMarcCharacter.Utf8CharCategory
                'Case Utf8_ControlCharacter$ ' "Cc"
                'Case Utf8_ControlCharacterFormatting$ ' "Cf"
                'Case Utf8_ControlOther$ ' "Co"
                'Case Utf8_ControlSurrogate$ ' "Cs"
                Case Utf8_LetterLowercase$ ' "Ll"
                    Exit Do
                'Case Utf8_LetterModifier$ ' "Lm"
                'Case Utf8_LetterOther$ ' "Lo"
                Case Utf8_LetterUppercase$ ' "Lu"
                    If lPtr > 1 Then
                        LCaseFirstWord = sLeft$ + Mid(sString$, 1, lPtr - 1) + MyMarcCharacter.Utf8CharLCase + Mid(sString$, lPtr + iOctets%)
                    Else
                        LCaseFirstWord = sLeft$ + MyMarcCharacter.Utf8CharLCase + Mid(sString$, lPtr + iOctets%)
                    End If
                    Exit Do
                Case Utf8_LetterTitlecase$ ' "Lt"
                    Exit Do
                'Case Utf8_MarkEnclosing$ ' "Me"
                'Case Utf8_MarkNonSpacing$ ' "Mn"
                'Case Utf8_MarkSpacingCombining$ ' "Mc"
                Case Utf8_NumberDecimal$ ' "Nd"
                    Exit Do
                Case Utf8_NumberLetter$ ' "Nl"
                    Exit Do
                Case Utf8_NumberOther$ ' "No"
                    Exit Do
                'Case Utf8_PunctuationConnector$ ' "Pc"
                'Case Utf8_PunctuationDash$ ' "Pd"
                'Case Utf8_PunctuationClose$ ' "Pe"
                'Case Utf8_PunctuationFinalQuote$ ' "Pf"
                'Case Utf8_PunctuationInitialQuote$ ' "Pi"
                'Case Utf8_PunctuationOther$ ' "Po"
                'Case Utf8_PunctuationOpen$ ' "Ps"
                'Case Utf8_Line$ ' "Zl"
                'Case Utf8_Paragraph$ ' "Zp"
                'Case Utf8_Space$ ' "Zs"
                'Case Utf8_Substitution$ ' "ZZ" ' gls-defined
                Case Utf8_SymbolCurrency$ ' "Sc"
                    Exit Do
                'Case Utf8_SymbolModifier$ ' "Sk"
                Case Utf8_SymbolMath$ ' "Sm"
                    Exit Do
                'Case Utf8_SymbolOther$ ' "So"
            End Select
            lPtr = lPtr + iOctets%
            If lPtr > lLen Then
                Exit Do
            End If
        Loop
    Else ' NOT utf-8
        For lPtr = 1 To Len(sString$)
            sChar$ = Mid(sString$, lPtr, 1)
            If InStr(CONST_LowerCaseAlpha$, sChar$) Then
                ' first character already lowercased
                Exit For
            ElseIf InStr(CONST_UpperCaseAlpha$, sChar$) > 0 Then
                ' lowercase the alpha character
                LCaseFirstWord = sLeft$ + SafeStuff(sString$, lPtr, 1, LCase(sChar$))
                Exit For
            ElseIf InStr(Const_NumString$, sChar$) > 0 Then
                Exit For
            ElseIf InStr(CONST_Currency$, sChar$) > 0 Then
                Exit For
            ElseIf InStr(CONST_Math$, sChar$) > 0 Then
                Exit For
            Else
                iRc% = InStr(sChar$, CONST_UpperEndUpperCase$)
                If iRc% > 0 Then
                    LCaseFirstWord = sLeft$ + SafeStuff(sString$, lPtr, 1, Mid(CONST_UpperEndLowerCase, iRc%, 1))
                    Exit For
                End If
                iRc% = InStr(sChar$, CONST_UpperEndLowerCase$)
                If iRc% > 0 Then
                    Exit For
                End If
            End If
        Next ' lptr
    End If
    
End Function

Public Function SafeMid(ByVal sSourceString$, ByVal lStart As Long, Optional ByVal lLengthInCharacters As Long = -1, Optional ByVal bStartIsGivenInUtf8CharactersNotOctets As Boolean = False) As String

    ' UTF-8 safe: separate handling provided
    
    Dim lCount As Long, lStartOctets As Long, lOctetLength As Long, lEnd As Long, lPtr As Long
    
    Dim iOctets%
    
    ' starting position may be given in terms of either octets (most likely) or
    '   utf-8 characters (1, 2 or 3 octets); optional boolean tells us witch
    
    ' if we're not provided with a length, we're being told
    '   that we want everything in the string, starting with
    '   the character of interest; so we'll use an arbitrary
    '   length (the length of the entire input
    '   string) to force this behavior
    
    If lLengthInCharacters = -1 Then
        lLengthInCharacters = Len(sSourceString$)
    End If
    
    ' nothing wanted: easy
    If lLengthInCharacters < 1 Then
        SafeMid = ""
        Exit Function
    End If
    
    'must start at least at the start
    If lStart < 1 Then
        lStart = 1
    End If
    
    ' if this isn't UTF-8, then we can use
    '   the built-in Mid function
    If Not m_bUtf8 Then
        SafeMid = Mid(sSourceString$, lStart, lLengthInCharacters)
        Exit Function
    End If
    
    ' if we need to, translate the start given in terms of utf-8 characters to
    '   the number of octets
    If bStartIsGivenInUtf8CharactersNotOctets And lStart > 1 Then
        lStartOctets = 1
        lCount = 1
        Do
            iOctets% = MyMarcCharacter.Utf8CharOctets(Mid(sSourceString$, lStartOctets, 1))
            lStartOctets = lStartOctets + iOctets%
            lCount = lCount + 1
            If lCount >= lStart Then
                Exit Do
            End If
        Loop
    Else
        lStartOctets = lStart
    End If
    
    lEnd = Len(sSourceString$)
    
    ' if the start is beyond the end, nothing to return
    If lStartOctets > lEnd Then
        SafeMid = ""
        Exit Function
    End If
    
#If SafeMidDebug = -1 Then
    Debug.Print "SafeMide calculated start: " + str(lStartOctets)
#End If
    ' count over the proper # of utf-8 'characters'
    lCount = 0
    lPtr = lStartOctets
    Do
        ' 20061129: we need to add in the displacement in octets: otherwise we're just
        '   looking at the same character every time
        iOctets% = MyMarcCharacter.Utf8CharOctets(Mid(sSourceString$, lPtr + lOctetLength, 1))
#If SafeMidDebug = -1 Then
        Debug.Print "Octets for >" + Mid(sSourceString$, lPtr + lOctetLength, 1) + "< " + str(iOctets%)
#End If
        lOctetLength = lOctetLength + iOctets%
        lCount = lCount + 1
        If lCount >= lLengthInCharacters Then
            Exit Do
        End If
    Loop
    If lOctetLength < 1 Then
        SafeMid = ""
        Exit Function
    End If
    SafeMid = Mid(sSourceString$, lStartOctets, lOctetLength)

End Function


Public Function Rat(ByVal sSourceString$, ByVal sStringToFind$) As Long

    ' UTF-8 safe: we're getting whole characters, so the representation
    '   form doesn't matter at all
    
    Dim lCtr As Long, lLen As Long, lLen2 As Long
    
    ' default value: not found
    Rat = 0
    
    ' we have to be looking for something!
    lLen = Len(sStringToFind$)
    If lLen = 0 Then
        Exit Function
    End If
    
    ' we have to have something to scan!
    lLen2 = Len(sSourceString$)
    If lLen2 = 0 Then
        Exit Function
    End If
    ' the source must be no shorter than the target
    If lLen2 < lLen Then
        Exit Function
    End If
    
    ' calculate the earliest place in the source string that the
    '   target string might be located
    lLen2 = (lLen2 - lLen) + 1
    
    ' scan backwards, looking for a match
    For lCtr = lLen2 To 1 Step -1
        If Mid(sSourceString$, lCtr, lLen) = sStringToFind$ Then
            Rat = lCtr
            Exit Function
        End If
    Next ' lCtr
    
    ' if we got here, not found: exit with return value of zero

End Function

Public Function SafeRight(ByVal sSourceString$, ByVal lLengthInCharacters As Long) As String

    ' UTF-8 safe: separate handling provided
    
    ' for UTF-8, the length is the length *in characters* not the length in octets
    ' if we know the number of octets for a UTF-8 string, we can use the built-in Right function

    Dim lPtr As Long
    
    Dim sOutput$
    
    Dim iCtr%, iAsc%
    
    
    If Not m_bUtf8 Then
        ' for non-UTF8, the number of characters is equal to the
        '   number of octets, so there is no ambiguity
        SafeRight = Right(sSourceString$, lLengthInCharacters)
        Exit Function
    End If
    
    ' if we get here, we're Unicode
    
    ' default value: whole thing
    sOutput$ = sSourceString$
    
    For lPtr = Len(sSourceString$) To 1 Step -1
        ' back up to find start of next character
        iAsc% = Asc(Mid(sSourceString$, lPtr, 1))
        If iAsc% And 128 Then ' 1xxxxxxx
            If iAsc% And 64 Then ' 11xxxxxx
                ' 11X: first octet of multi-byte character
                ' fall through
            Else ' 10xxxxxxx
                ' not the first octet in this character; skip over the
                '   character-counting busines and back up one more
                '   character
                GoTo Utf8StringRightBackUpOne
            End If
        'Else 0X: single-octet character
            ' shouldn't happen because we've excluded the MARC-8 characters
            '   already
            ' fall through
        End If
        ' if we fall through to here, we've hit the first
        '   octet in a multi-byte character
        ' count this character
        iCtr% = iCtr + 1
        If iCtr% >= lLengthInCharacters Then
            ' we've extracted all the characters we want
            sOutput$ = Mid(sSourceString$, lPtr)
            Exit For
        End If
Utf8StringRightBackUpOne:
    Next ' lptr
    
    SafeRight = sOutput$

End Function

Public Function SafeStuff(ByVal sOriginalText$, ByVal lStartingPositionInOctets As Long, ByVal iLengthToRemoveInOctets%, ByVal sReplacementText$) As String

    ' this accepts a character string, the offset of the
    '   replacement site, the number of characters to remove,
    '   and the replacement text (or ""), and returns
    '   a modified character string.  Use this instead of
    '   multiple InStr functions operating on a single string

    ' UTF-8 safe because the container program must give us the starting position in terms
    '   of octets, and must tell us how many octets to remove (not the number of characters); and we
    '   insert whatever string the container gives us, without regard to character set repertoire
    
    Dim lLen1 As Long
    
    lLen1 = Len(sOriginalText$)
    
    On Error GoTo StuffBigOlError
    
    If iLengthToRemoveInOctets% < 1 Then ' nothing to remove; includes invalid negative removal!
        Select Case lStartingPositionInOctets ' replacement position
            Case Is < 2 ' includes replacement before the beginning!
                SafeStuff = sReplacementText$ + sOriginalText$
            Case Is > lLen1 ' formerly: >=
                SafeStuff = sOriginalText$ + sReplacementText$
            Case Else
                SafeStuff = Mid(sOriginalText$, 1, lStartingPositionInOctets - 1) + sReplacementText$ + Mid(sOriginalText$, lStartingPositionInOctets)
        End Select
    Else ' removal length is >0
        If lLen1 > 0 Then
            ' the string-into-which-to-put-things is not empty, so removal
            '   is an at least theoretical possibility
            Select Case lStartingPositionInOctets ' replacement position
                Case Is < 1 ' invalid; includes replacement well before the beginning!
                    SafeStuff = sReplacementText$ + sOriginalText$
                Case Is < 2
                    SafeStuff = sReplacementText$ + Mid(sOriginalText$, iLengthToRemoveInOctets% + 1)
                Case Is > lLen1 ' formerly: >=
                    SafeStuff = Mid(sOriginalText$, 1, lStartingPositionInOctets - 1) + sReplacementText$
                Case Else ' equal
                    SafeStuff = Mid(sOriginalText$, 1, lStartingPositionInOctets - 1) + sReplacementText$ + Mid(sOriginalText$, lStartingPositionInOctets + iLengthToRemoveInOctets%)
            End Select
        Else
            ' the string-into-which-to-put-things is actually empty, so
            '   we obviously can't remove anything from it; so all we could
            '   possibly be left with, is the thing we were to stick into
            '   the string
            SafeStuff = sReplacementText$
        End If
    End If

StuffBigOlErrorResume:

    Exit Function

StuffBigOlError:

    'lLen1 = MsgBox(">" + sOriginalText$ + "< " + str(lStartingPosition) + " " + str(iLengthToRemoveInOctets%) + " >" + sReplacementText$ + "<", 0, "Error in Stuff function")
    SafeStuff = ""
    Resume StuffBigOlErrorResume

End Function

Public Function NormalizeCallNumber(ByVal sCallNumber$, ByVal sCallNumbertype$) As String

    ' normalize a given call number of a given type according to Voyager conventions
    
    Dim sCopy$, sCurrent$, sPrev$, sChar$, sPrefix$, sWork$, sPrevNonSpace$, sLabel$, sTail$
    Dim sPiece$, sElement$, sPseudoPeriod$, sDecimals$, sBasicChars$, sJunk$, SINGLE_SPACE$
    Dim sLeft$, sRight$, sLeftLead$, sLeftTrail$, sDiacriticLow$
    
    Dim iPtr%, iRc%, iRc2%, iCtr%, iPad%
    Dim iSpace1%, iSpace2%, iLengthToDecimal%, iLengthOfPrimary%, iLenCopy%
    Dim iLen%, iHyphenAt%, iHyphenCtr%
    
    Dim bHitFirstHyphenWord As Boolean, bJunk As Boolean, bWithinHyphenWord As Boolean
    Dim bSlashHit As Boolean, bSlashHacked As Boolean, bColonFaked As Boolean, bNewSegment As Boolean
    Dim bPreviousWasSpecial As Boolean
    
    Const iLcLengthToFirstCutter% = 19
    SINGLE_SPACE$ = Chr(255)
    sPseudoPeriod$ = Chr(255)
    sDiacriticLow$ = Chr(223)
    
    ' default value: nothing
    NormalizeCallNumber = ""
    
    
#If NormCallNumberDebug% = -1 Then
    Debug.Print "*****************************************"
    Debug.Print "Raw:  >" + sCallNumber$ + "< >" + sCallNumbertype$ + "<"
#End If
    
    ' we assume that the received call number has been formatted
    '   in an acceptable manner
    
    On Error GoTo NormCallNumberError
    
    ' we replace delimiter/subfield code pairs with spaces, and remove surrounding spaces
    sCopy$ = Trim(RemoveDelimiters(sCopy$, ""))
    #If NormCallNumberDebug% = -1 Then
        Debug.Print "With delims removed: >" + sCopy$ + "<"
    #End If
    
    
    Select Case sCallNumbertype$
    
        Case CALLNOTYPE_Dewey$, CALLNOTYPE_DeweyCode$
        
            ' break the thing into "segments" *first* (based on alternation between
            '   numeric characters and non-numeric characters); then concatenate segments
            '   that have the same type and are adjacent; and finally apply the
            '   normalization logic on a segment-by-segment basis
            sCopy$ = SafeUCase(sCallNumber$)
            sWork$ = ""
            MyPrevChar.Utf8Char = sCopy$ ' this is what was formerly called 'sPrev$'
            Do
                DoEvents
                ' isolate the next charcter in the call number
                MyMarcCharacter.Utf8Char = sCopy$ ' extract the next character
                sCopy$ = Mid(sCopy$, MyMarcCharacter.Utf8CharOctets + 1) ' safely remove the first character
                'Debug.Print ">" + MyMarcCharacter.Utf8Char + "< >" + sCopy$ + "< " + MyMarcCharacter.Utf8CharCategory + " " + str(MyMarcCharacter.Utf8CharOctets)
                If MyMarcCharacter.Utf8CharCategory = Utf8_NumberDecimal$ Then
                    ' current character is a numeral
                    If MyPrevChar.Utf8CharCategory = Utf8_NumberDecimal$ Then
                        ' we're switching from one numeric to another: just add the character
                        sWork$ = sWork$ + MyMarcCharacter.Utf8Char
                    Else
                        ' we're switching from numeric to non-numeric: add a space
                        sWork$ = sWork$ + " " + MyMarcCharacter.Utf8Char
                    End If
                Else
                    ' current character is not a numeral
                    If MyMarcCharacter.Utf8CharCategory <> Utf8_LetterUppercase$ Then
                        ' current character is neither numeral nor alpha character:
                        '   probably punctuation
                        Select Case MyMarcCharacter.Utf8Char
                            Case " "
                                If Right(sWork$, 1) <> " " Then
                                    sWork$ = sWork$ + " "
                                End If
                                MyMarcCharacter.Utf8Char = " "
                            Case "-", "/", ";", ",", ":", "[", "(", "]", ")"
                                sWork$ = sWork$ + " " + MyMarcCharacter.Utf8Char + " "
                                MyMarcCharacter.Utf8Char = " "
                            Case "."
                                ' retain the full stop ONLY if the following character is a numeral
                                MyNextChar.Utf8Char = sCopy$
                                If MyNextChar.Utf8CharCategory = Utf8_NumberDecimal$ Then
                                    ' following character is a decimal: retain it
                                    If MyPrevChar.Utf8CharCategory = Utf8_NumberDecimal$ Then
                                        ' the previous character is also a numeral:
                                        '   no spaces around the full stop
                                        sWork$ = sWork$ + "."
                                    Else
                                        ' previous charcter is a non-numeral (alpha?): add a space
                                        '   before the full stop
                                        sWork$ = sWork$ + " ."
                                    End If
                                    MyMarcCharacter.Utf8Char = "8"
                                Else ' next is not a number
                                    sWork$ = sWork$ + " "
                                    MyMarcCharacter.Utf8Char = "a"
                                End If
                                ' and fake the "current character" so that
                                '   we don't introduce an unnecessary "shift" after
                                '   the full stop
#If NormCallNumberDebug% = -1 Then
                                    Debug.Print "sChar reset: >" + MyMarcCharacter.Utf8Char + "<"
#End If
                            Case Else
                                ' neither alpha nor full stop (diacritics, unrecognized
                                '   punctuation, who-knows-what): ignore the character altogether
                                ' TYPICAL EXAMPLE: a hyphen; we want to close this up, and not
                                '   insert a space
                                ' fake the "current character" so that we won't introduce
                                '   an unnecessary break at this point
                                If Len(sWork$) > 0 Then
                                    MyMarcCharacter.Utf8Char = MyPrevChar.Utf8Char
                                Else
                                    MyMarcCharacter.Utf8Char = sWork$
                                End If
                        End Select
                    Else
#If NormCallNumberDebug% = -1 Then
                        Debug.Print "Upper case alpha; norm: >" + MyMarcCharacter.Utf8CharNorm + "<"
#End If
                        ' current character is upper-case alpha
                        ' note that we're switching here from the uppercase form
                        '   of the letter to the normalized form
                        ' the uppercase form might well be the uppercase
                        '   ligature AE; for this we want to end up with the
                        '   two charcters 'A' and 'E'; and so forth
                        If MyPrevChar.Utf8CharCategory = Utf8_NumberDecimal$ Then
                            ' we're shifting from numeric to non-numeric: add a space
                            sWork$ = sWork$ + " " + MyMarcCharacter.Utf8CharNorm
                        Else
                            ' previous and current are both alphabetic: just add the
                            '   character to the string
                            sWork$ = sWork$ + MyMarcCharacter.Utf8CharNorm
                        End If
                    End If
                End If
                If Len(sCopy$) = 0 Then
#If NormCallNumberDebug% = -1 Then
                        Debug.Print "Reached end: >" + sWork$ + "< >" + MyMarcCharacter.Utf8Char + "< >" + sCopy$ + "<"
#End If
                    Exit Do
                End If
                MyPrevChar.Utf8Char = MyMarcCharacter.Utf8Char
            Loop ' for each character in the raw call number
            
            ' remove any trailing full stop
            If Right(sWork$, 1) = "." Then ' doesn't need to be 'safe'
                sWork$ = Mid(sWork$, 1, Len(sWork$) - 1) ' doesn't need to be 'safe'
            End If
            ' remove any multiple spaces that may be present
            sWork$ = RemoveRepeatedCharacters(Trim(sWork$), " ")
#If NormCallNumberDebug% = -1 Then
                Debug.Print "Before padding with zeroes: >" + sWork$ + "<"
#End If

            ' find the first numeral; if it is part of a 'word' that has
            '   fewer than 3 characters, add leading zero(s)
            ' this appears to be safe also for UTF-8 strings
            For iRc% = 1 To Len(sWork$)
                If InStr(Const_NumString$, Mid(sWork$, iRc%, 1)) > 0 Then
                    ' we've found the first numeral
                    iCtr% = InStr(Mid(sWork$, iRc%), " ")
                    If iCtr% = 0 Then
                        iCtr% = InStr(Mid(sWork$, iRc%), ".")
                    End If
                    If iCtr% < 4 And iCtr% > 0 Then
                        sWork$ = SafeStuff(sWork$, iRc%, 0, String(3 - (iCtr% - 1), "0"))
                    End If
                    Exit For
                End If
            Next ' irc%
            
        Case CALLNOTYPE_LC$, CALLNOTYPE_NLM$, CALLNOTYPE_LcCode$, CALLNOTYPE_NlmCode$
        
            'Debug.Print "LC"
            ' 20020112: this has been confirmed by experiment: multiple spaces removed from the
            '   raw string before we look at it in detail
            ' ALSO reduce multiple hyphens to a single hyphen
            sCopy$ = RemoveRepeatedCharacters(RemoveRepeatedCharacters(Trim(sCallNumber$)), "-")
            sCopy$ = SafeUCase(sCopy$)
            ' remove trailing full stops
            ' doesn't need to be 'safe'
            Do
                'Debug.Print "Copy: >" + sCopy$ + "<"
                If Right(sCopy$, 1) <> "." Then ' original value: "If Right(sCopy$, 1) = 0" [with no quotes or nothing around the value; meaning unclear]
                    Exit Do
                End If
                sCopy$ = Trim(Mid(sCopy$, 1, Len(sCopy$) - 1))
            Loop
#If NormCallNumberDebug% = -1 Then
            Debug.Print "With multiple spaces etc. removed >" + sCopy$ + "<"
#End If

            ' remove the leading alphabetic portion
            For iCtr% = 1 To 5 ' now safely removing up to 5 characters, not up to 5 octets
                ' stop when you hit the first non-upper-case letter
                MyMarcCharacter.Utf8Char = sCopy$
                If MyMarcCharacter.Utf8CharCategory <> Utf8_LetterUppercase$ Then
                    Exit For
                End If
                sWork$ = sWork$ + MyMarcCharacter.Utf8Char
                sCopy$ = Mid(sCopy$, MyMarcCharacter.Utf8CharOctets + 1)
                If Len(sCopy$) = 0 Then
                    Exit For
                End If
            Next ' ictr%
#If NormCallNumberDebug% = -1 Then
            Debug.Print "Leading alpha removed >" + sWork$ + "< >" + sCopy$ + "<"
#End If
            
            ' 20011019: earlier versions have handled this differently; but for
            '   Voyager 2000 at least, the alpha is whatever length it is, plus
            '   one space
            ' sWork now contains the normalized alphabetic business
            iLengthOfPrimary% = Len(sWork$)
            If iLengthOfPrimary% > 0 Then
                ' 20020112: the length of the business up to the first cutter
                '   depends of the length of the alphabetic portion: it's
                '   17 more characters
                iLengthOfPrimary% = iLengthOfPrimary% + 17
                sWork$ = Trim(sWork$) + " "
            Else
                ' goodness knows what we've got here--but we're going to
                '   need SOME kind of value here!
                iLengthOfPrimary% = 20
            End If
            
            ' remove any leading blanks from the remainder of the call number
            sCopy = Trim(sCopy$)
            ' sCopy should now begin with at least one numeral

            ' isolate the leading numeric portion, identifying along the way
            '   the location of any decimal point (this decimal point affects, but
            '   does not become part of, the normalized string)
            sPrefix$ = ""
            For iCtr% = 1 To 10
                MyMarcCharacter.Utf8Char = sCopy$
                If MyMarcCharacter.Utf8CharCategory = Utf8_NumberDecimal$ Then
                    sPrefix$ = sPrefix$ + MyMarcCharacter.Utf8Char
                ElseIf MyMarcCharacter.Utf8Char = "." Then
#If NormCallNumberDebug% = -1 Then
                    Debug.Print "Decimal encountered at " + str(iCtr%) + " >" + sPrefix$ + "< >" + sCopy$ + "<"
#End If
                    ' if the decimal does not immediately precede a numeral, then we
                    '   don't care about it
                    MyNextChar.Utf8Char = Mid(sCopy$, 2)
                    If MyNextChar.Utf8CharCategory <> Utf8_NumberDecimal$ Then
#If NormCallNumberDebug% = -1 Then
                        Debug.Print "Next character is not decimal: >" + sCopy$ + "<"
#End If
                        Exit For
                    End If
                    ' the decimal does indeed precede a numeral
                    ' do nothing (most expecially, don't add it to the string
                    '   of numbers): continue with the *next* character
                    ' 20010308: but do remember how long the thing was up to
                    '   the decimal point (so you can center the string of digits
                    '   properly within the allotted space)
                    iLengthToDecimal% = Len(sPrefix$)
                Else
                    ' current character is not numeric, and not a full stop:
                    '   you're all done
                    Exit For
                End If
                sCopy$ = Mid(sCopy$, MyMarcCharacter.Utf8CharOctets + 1)
                If Len(sCopy$) = 0 Then
                    Exit For
                End If
            Next ' ictr%; remove up to 10 characters as the alphabetic prefix
            #If NormCallNumberDebug% = -1 Then
                Debug.Print "Length to decimal: " + str(iLengthToDecimal%) + " >" + sWork$ + "< >" + sPrefix$ + "<"
            #End If
            
            ' we believe that the following is safe, as sPrefix$ can only contain
            '   numerals
            Select Case iLengthToDecimal%
                Case 0
                    ' number so far contains no decimal point: just a whole number
                    If Len(sPrefix$) < 5 Then ' should be most common case!
                        ' pad on the left to a length of 4
                        sPrefix$ = Right(Space(4) + sPrefix$, 4)
                    'Else do nothing: leave it alone
                    End If
                Case Is < 5
                    ' add enough spaces on the left to make the now-omitted
                    '   decimal come at the right column
                    sPrefix$ = Space(4 - iLengthToDecimal%) + sPrefix$
                'Case Else ': leave it alone
            End Select
            
            ' 20020112: the length of the business up to the first cutter depends on the
            '   number of alphabetic characters in the lead portion; we calculated
            '   this length a bit earlier
            ' all appears to be safe
            sWork$ = Mid(sWork$ + sPrefix$ + Space(iLengthOfPrimary%), 1, iLengthOfPrimary%)
            
            ' remove any leading spaces from the remainder of the
            '   call number (safe)
            sCopy$ = Trim(sCopy$)
            
            ' 20020112: if we have another leading numeral, then we include it at the
            '   right end of this primary area--even when that numeral is
            '   attached to an alphabetic character
            ' given:
            '   P#123#############  and 1985 as the next thing, we end up with:
            '   P#123########1985#
            #If NormCallNumberDebug% = -1 Then
                Debug.Print "Before removing numerical stuff"
                Debug.Print ">" + sCopy$ + "< >" + Const_NumString$ + "<"
            #End If
            sJunk$ = ""
            Do
                MyMarcCharacter.Utf8Char = Mid(sCopy$, 1, 1)
                #If NormCallNumberDebug% = -1 Then
                    Debug.Print "Char: >" + MyMarcCharacter.Utf8Char + "<"
                #End If
                If MyMarcCharacter.Utf8CharCategory <> Utf8_NumberDecimal$ Then
                    Exit Do
                End If
                sJunk$ = sJunk$ + MyMarcCharacter.Utf8Char
                sCopy$ = Mid(sCopy$, MyMarcCharacter.Utf8CharOctets + 1)
                If Len(sCopy$) = 0 Then
                    Exit Do
                End If
            Loop
            iRc% = Len(sJunk$) + 1
            
            ' remove any leading hyphens from
            '   the remainder of the call number
            ' all this is safe enough
            sCopy$ = Trim(sCopy$)
            Do
                If Mid(sCopy$, 1, 1) <> "-" Then
                    Exit Do
                End If
                sCopy$ = Mid(sCopy$, 2)
                If Len(sCopy$) = 0 Then
                    Exit Do
                End If
            Loop
            
            #If NormCallNumberDebug% = -1 Then
                Debug.Print "Pieces after removing numerical stuff"
                Debug.Print ">" + sJunk$ + "< >" + sCopy$ + "< " + str(iRc%)
            #End If
            If iRc% > 1 Then
                ' there was a string of digits following the numeric portion of the
                '   classification
                ' insert this into the 'leading' portion of the call number (see example
                '   above in comments) UNLESS the next character is AGAIN a numeral,
                '   in which case we do NOT do this after all
                If Len(sCopy$) > 0 Then
                    MyMarcCharacter.Utf8Char = sCopy$
                    If MyMarcCharacter.Utf8CharCategory = Utf8_NumberDecimal$ Then
                        ' put it back on to the working string
                        sCopy$ = sJunk$ + " " + sCopy$
                        GoTo NormCallNumberLcSkipLeadNumericStuff
                    End If
                End If
                ' insert the extracted number string (year, probably) into
                '   the leading portion of the call number
                ' all this appears to be safe enough
                sWork$ = Mid(sWork$, 1, Len(sWork$) - iRc%) + sJunk$ + " "
            End If
NormCallNumberLcSkipLeadNumericStuff:
            
            ' we SHOULD now be at the first cutter block
            ' remove any leading full stop
            If Mid(sCopy$, 1, 1) = "." Then
                sCopy$ = Trim(Mid(sCopy$, 2))
            End If
            MyPrevChar.Utf8Char = " "
            
            #If NormCallNumberDebug% = -1 Then
                Debug.Print "Ready to look at first cutter block: >" + sWork$ + "< >" + sCopy$ + "<"
            #End If
            
            ' 20020104: instituted the following to replace an earlier attempt
            iLenCopy% = Len(sCopy$)
            #If NormCallNumberDebug% = -1 Then
                Debug.Print "Remainder: >" + sCopy$ + "<"
            #End If
            
            ' 20030705: realigned to use new character-handling model
            Do
NormCallNumberLcReadyForNextCharacter:
                If Len(sCopy$) = 0 Then
                    Exit Do
                End If
                MyMarcCharacter.Utf8Char = sCopy$
                sCopy$ = Mid(sCopy$, MyMarcCharacter.Utf8CharOctets + 1) ' safe
                If MyMarcCharacter.Utf8CharOctets = 1 Then
                    If MyMarcCharacter.Utf8CharAsc > 127 Then
                        sChar$ = MyMarcCharacter.Utf8CharNorm
                    Else ' may still be punctuation, you know!
                        sChar$ = MyMarcCharacter.Utf8CharUCase
                    End If
                Else
                    sChar$ = MyMarcCharacter.Utf8CharNorm
                End If
                
                #If NormCallNumberDebug% = -1 Then
                    Debug.Print "raw >" + MyMarcCharacter.Utf8Char + "< norm >" + sChar$ + "< prev >" + MyPrevChar.Utf8Char + "< >" + sWork$ + "<"
                #End If
                If Len(sChar$) = 0 Then
                    GoTo NormCallNumberLcReadyForNextCharacter
                End If
                Select Case sChar$
                    Case ","
                        #If NormCallNumberDebug% = -1 Then
                            Debug.Print "Hit comma " + str(iHyphenCtr%) + " " + str(bHitFirstHyphenWord)
                        #End If
                        ' special rules apply if we're finishing up a word that contains
                        '   hyphens
                        bWithinHyphenWord = False
                        If iHyphenCtr% > 0 Then
                            If Not bHitFirstHyphenWord Then
                                bHitFirstHyphenWord = True
                                ' this is a comma following the first word-containing-a-hyphen
                                If Len(sCopy$) > 0 Then
                                    #If NormCallNumberDebug% = -1 Then
                                        Debug.Print "Not at end; next char: >" + Mid(sCopy$, 1, 1) + "<"
                                    #End If
                                    If Mid(sCopy$, 1, 1) = " " Then ' safe enough
                                        ' no preceding space added
                                        sWork$ = sWork$ + ","
                                        MyPrevChar.Utf8Char = ","
                                    Else
                                        sWork$ = sWork$ + ", "
                                        MyPrevChar.Utf8Char = " "
                                    End If
                                    GoTo NormCallNumberLcReadyForNextCharacter
                                End If
                            End If
                        End If
                        ' if the comma is not preceded by a space or a numeral, add a space
                        If Right(sWork$, 1) <> " " Then
                            sWork$ = sWork$ + " ,"
                        Else
                            sWork$ = sWork$ + ","
                        End If
                        MyPrevChar.Utf8Char = ","
                        ' if the comma is not followed by a space, add one
                        If Len(sCopy$) > 0 Then
                            If Mid(sCopy$, 1, 1) <> " " Then
                                sWork$ = sWork$ + " "
                                MyPrevChar.Utf8Char = " "
                            End If
                        End If
                    Case ")", "]"
                        ' closing parens gets no preceding space if it's part of hyphen group
                        If iHyphenCtr% > 0 Then
                            sWork$ = sWork$ + sChar$ + " "
                        Else
                            If MyPrevChar.Utf8Char <> " " Then
                                sWork$ = sWork$ + " " + sChar$ + " "
                            Else
                                sWork$ = sWork$ + sChar$ + " "
                            End If
                        End If
                        MyPrevChar.Utf8Char = " "
                    Case "/"
                        ' becomes a space if we don't alraedy have one
                        ' UNLESS we're within a hyphenated word in which case it
                        '   just drops out
                        If bWithinHyphenWord Then
                            GoTo NormCallNumberLcReadyForNextCharacter
                        End If
                        If Right(sWork$, 1) <> " " Then
                            sWork$ = sWork$ + " "
                            MyPrevChar.Utf8Char = " "
                        End If
                    Case " "
                        #If NormCallNumberDebug% = -1 Then
                            Debug.Print "Hit space >" + sWork$ + "<"
                        #End If
                        bWithinHyphenWord = False
                        ' becomes 3 spaces EXCEPT after the first word that
                        '   contains a hyphen, in which case it becomes 2 spaces (!)
                        ' UNLESS it is between two alphas, in which case it still
                        '   becomes 3 spaces
                        ' UNLESS we already have 3 spaces, in which case we add two more
                        If Right(sWork$, 3) = "   " Then ' this paragraph is safe
                            sWork$ = sWork$ + "  "
                        Else
                            sWork$ = Trim(sWork$) + "   "
                        End If
                        If iHyphenCtr% > 0 Then
                            If Not bHitFirstHyphenWord And MyMarcCharacter.Utf8Char <> "," Then
                                If MyMarcCharacter.Utf8Char = "A" Then ' any alphabetic
                                    If Len(sCopy$) > 0 Then
                                        MyNextChar.Utf8Char = sCopy$
                                        If MyNextChar.Utf8CharCategory = Utf8_LetterUppercase$ Then
                                            ' both preceded and followed by spaces
                                            ' for ease of construction just plaster on
                                            '   an extra one that we'll actually throw away
                                            '   in just a tick
                                            sWork$ = sWork$ + " "
                                        End If
                                    End If
                                End If
                                sWork$ = Mid(sWork$, 1, Len(sWork$) - 1)
                            End If
                            bHitFirstHyphenWord = True
                        End If
                        MyPrevChar.Utf8Char = " "
                        #If NormCallNumberDebug% = -1 Then
                            Debug.Print "After space >" + sWork$ + "<"
                        #End If
                    Case SINGLE_SPACE$ ' (chr(255)): this may now be irrelevant ...
                        sWork$ = sWork$ + " "
                        MyPrevChar.Utf8Char = " "
                    Case "."
                        bWithinHyphenWord = False
                        ' if the full stop lies between two numerals, retain the full stop and
                        '   pretend nothing is wrong (leave 'previous' set to
                        '   numeral)
                        If MyPrevChar.Utf8Char = "0" Then
                            MyNextChar.Utf8Char = sCopy$
                            If MyNextChar.Utf8CharCategory = Utf8_NumberDecimal$ Then
                                sWork$ = sWork$ + "."
                                ' it won't matter what sPrev is, really
                                GoTo NormCallNumberLcReadyForNextCharacter
                            End If
                        End If
                        ' if the following character is a numeral, retain the
                        '   full stop, preceding it with a space if none is there
                        '   already; otherwise, replace the full stop with a space
                        If Len(sCopy$) > 0 Then
                            MyNextChar.Utf8Char = sCopy$
                            If MyNextChar.Utf8CharCategory = Utf8_NumberDecimal$ Then
                                If Right(sWork$, 1) <> " " Then
                                    sWork$ = sWork$ + " ."
                                Else
                                    sWork$ = sWork$ + "."
                                End If
                                MyPrevChar.Utf8Char = "."  ' not that it'll really matter
                            Else
                                If Right(sWork$, 1) <> " " Then
                                    sWork$ = sWork$ + " "
                                    MyPrevChar.Utf8Char = " "
                                End If
                            End If
                        Else ' the full stop is last character in the raw call number
                            If Right(sWork$, 1) <> " " Then
                                sWork$ = sWork$ + " "
                                MyPrevChar.Utf8Char = " "
                            End If
                        End If
                    Case "-"
                        bWithinHyphenWord = True
                        ' a trailing hyphen immediately following a
                        '   group of numerals causes that group of
                        '   numerals to be treated as a range
                        #If NormCallNumberDebug% = -1 Then
                            Debug.Print "Hyphen"
                        #End If
                        If Len(sCopy$) = 0 Or (Len(sCopy$) > 0 And Mid(sCopy$, 1, 1) = " ") Then
                            #If NormCallNumberDebug% = -1 Then
                                Debug.Print "Trailing hyphen"
                            #End If
                            ' this is a trailing hyphen
                            ' isolate the previous word from the normalized-string-so-far
                            sJunk$ = Trim(sWork$)
                            iRc% = Rat(sJunk$, " ") ' this is safe
                            If iRc% > 0 Then
                                ' it oughtta be!
                                ' add internal spaces to right-justify this group into
                                '   a 4-character space
                                If InStr(Const_NumString$, Mid(sJunk$, iRc% + 1, 1)) > 0 Then ' safe enough
NormCallNumberLcPadGroupInto4:
                                    iRc2% = Len(sJunk$) - iRc%
                                    If iRc2% < 4 And iRc2% > 0 Then
                                        sWork$ = SafeStuff(sWork$, iRc% + 1, 0, Space(4 - iRc2%))
                                    End If
                                ElseIf Mid(sJunk$, iRc% + 1, 1) = "." Then ' safe enough
                                    If InStr(Const_NumString$, Mid(sJunk$, iRc% + 2, 1)) > 0 Then ' safe enough
                                        iRc% = iRc% + 1
                                        GoTo NormCallNumberLcPadGroupInto4
                                    End If
                                End If
                            End If
                            If Right(sWork$, 1) <> " " Then ' safe
                                sWork$ = sWork$ + " "
                            End If
                            MyPrevChar.Utf8Char = " "
                        Else
                            ' hyphen is not a trailing hyphen, it's an
                            '   INTERMEDIATE hyphen
                            #If NormCallNumberDebug% = -1 Then
                                Debug.Print "Intermediate hyphen"
                            #End If
                            ' we have special handling if this is the first intermediate
                            '   hyphen we've encountered
                            If Not bHitFirstHyphenWord Then
                                #If NormCallNumberDebug% = -1 Then
                                    Debug.Print "This is the first hyphenated word"
                                #End If
                                iHyphenCtr% = iHyphenCtr% + 1
                                Select Case iHyphenCtr%
                                    Case 1 ' first hyphen in first hyphen-containing word
                                        #If NormCallNumberDebug% = -1 Then
                                            Debug.Print "This is the first hyphen found"
                                        #End If
                                        ' if the preceding 'word' is lead-numeric, normalized it
                                        '   into a space-of-4
                                        sJunk$ = Trim(sWork$)
                                        ' note that we can't use a simple 'rat' here (unless we do 2
                                        '   of 'em and compare the results to each other) because
                                        '   the last "numeric word" of interest is preceded by
                                        '   either a full stop OR a space
                                        For iRc% = Len(sJunk$) To 1 Step -1 ' safe enough
                                            If InStr(" .", Mid(sJunk$, iRc%, 1)) > 0 Then
                                                Exit For
                                            End If
                                        Next ' irc%
                                        If iRc% < 0 Then
                                            iRc% = 0
                                        End If
                                        #If NormCallNumberDebug% = -1 Then
                                            Debug.Print "preceding space at " + str(iRc%) + " >" + Mid(sJunk$, iRc%) + "<"
                                        #End If
                                        If iRc% > 0 Then
                                            ' it oughtta be!
                                            ' add internal spaces to right-justify this group into
                                            '   a 4-character space
                                            If InStr(Const_NumString$, Mid(sJunk$, iRc% + 1, 1)) > 0 Then
NormCallNumberDealWithNumerals:
                                                #If NormCallNumberDebug% = -1 Then
                                                    Debug.Print "Inserting spaces at " + str(iRc%) + " >" + Mid(sWork$, 1, iRc%) + "< >" + Mid(sWork$, iRc% + 1) + "<"
                                                #End If
                                                iRc2% = Len(sJunk$) - iRc%
                                                If iRc2% < 4 And iRc2% > 0 Then
                                                    sWork$ = SafeStuff(sWork$, iRc% + 1, 0, Space(4 - iRc2%))
                                                End If
                                                #If NormCallNumberDebug% = -1 Then
                                                    Debug.Print "               after" + str(iRc%) + " >" + sWork$ + "<"
                                                #End If
                                            ElseIf Mid(sJunk$, iRc% + 1, 1) = "." Then
                                                If InStr(Const_NumString$, Mid(sJunk$, iRc% + 2, 1)) > 0 Then
                                                    iRc% = iRc% + 1
                                                    GoTo NormCallNumberDealWithNumerals
                                                End If
                                            End If
                                        End If
                                        ' the hyphen itself becomes a space
                                        sWork$ = sWork$ + " "
                                        ' if the next group is lead-numeric, also
                                        '   add spaces to make it normalized-in-four
                                        iCtr% = 1 ' iPtr% + 1
                                        Do
                                            If InStr(Const_NumString$, Mid(sCopy$, iCtr%, 1)) = 0 Then
                                                Exit Do
                                            End If
                                            iCtr% = iCtr% + 1
                                            If iCtr% > Len(sCopy$) Then
                                                Exit Do
                                            End If
                                        Loop
                                        If iCtr% > 1 Then
                                            sWork$ = sWork$ + Space(4 - (iCtr% - (iPtr% + 1)))
                                        End If
                                        MyPrevChar.Utf8Char = " "
                                    Case 2 ' second hyphen in first hyphen-containing word
                                        ' we ignore this hyphen and continue with the next
                                        '   character EVEN IF we thereby stick two numerics
                                        '   together
                                        ' BUT WE DO NOT stick two alphas together
                                        If MyPrevChar.Utf8Char = "A" Then
                                            sWork$ = sWork$ + " "
                                            MyPrevChar.Utf8Char = " "
                                        End If
                                    Case Else ' third etc. hyphen in first hyphen-containing word
                                        ' this hyphen becomes a single space
                                        If Right$(sWork$, 1) <> " " Then
                                            sWork$ = sWork$ + " "
                                            MyPrevChar.Utf8Char = " "
                                        End If
                                End Select
                            Else ' hyphen in some 'word' after the first one
                                #If NormCallNumberDebug% = -1 Then
                                    Debug.Print "Hyphen in some word after the first one >" + sWork$ + "<"
                                #End If
                                ' this becomes a single space
                                If Right$(sWork$, 1) <> " " Then
                                    sWork$ = sWork$ + " "
                                    MyPrevChar.Utf8Char = " "
                                End If
                            End If
                        End If
                    Case "0" To "9"
                        If MyPrevChar.Utf8Char = "A" Then
                            sWork$ = sWork$ + " " + sChar$
                        Else
                            sWork$ = sWork$ + sChar$
                        End If
                        MyPrevChar.Utf8Char = "0"
                    Case "A" To "Z"
NormalizeCallNumberUseNormalizedForm:
                        If bWithinHyphenWord Then
                            sWork$ = sWork$ + MyMarcCharacter.Utf8CharNorm
                            MyPrevChar.Utf8Char = "A"
                            GoTo NormCallNumberLcReadyForNextCharacter
                        End If
                        If MyPrevChar.Utf8Char = "0" Then
                            sWork$ = sWork$ + " " + MyMarcCharacter.Utf8CharNorm
                        Else
                            sWork$ = sWork$ + MyMarcCharacter.Utf8CharNorm
                        End If
                        MyPrevChar.Utf8Char = "A"
                    Case Else
                        ' deal here with uppercase ligature AE, etc.
                        If MyMarcCharacter.Utf8CharCategory = Utf8_LetterUppercase$ Then
                            GoTo NormalizeCallNumberUseNormalizedForm
                        End If
                        ' other punctuation: assuming we just add spaces
                        If MyPrevChar.Utf8Char <> " " Then
                            sWork$ = sWork$ + " " + MyMarcCharacter.Utf8Char + " "
                        Else
                            sWork$ = sWork$ + MyMarcCharacter.Utf8Char + " "
                        End If
                        MyPrevChar.Utf8Char = " "
                End Select
            Loop ' until string is empty (test is at the top of the loop)
            
            ' no trailing blanks!
            sWork$ = Trim(sWork$)
            

        Case CALLNOTYPE_SuDocs$, CALLNOTYPE_SuDocsCode$
            
            sCopy$ = SafeUCase(sCallNumber$)
            'Debug.Print "Raw  : >" + sCallNumber$ + "<"
            'Debug.Print "Ucase: >" + sCopy$ + "<"
            
            ' 20030808: attempt to rewrite
            ' use of Instr and Mid here is declared UTF-8 safe: we're looking at this
            '   point for the literal characters
            iRc% = InStr(sCopy$, ":") ' this paragraph is safe enough
            If iRc% = 0 Then
                sCopy$ = sCopy$ + ":"
                iRc% = InStr(sCopy$, ":")
                bColonFaked = True
            End If
            
            ' divide the number into pieces, at the colon
            ' if we faked the colon, sTail$ will
            '   not have anything in it
            If iRc% < Len(sCopy$) Then
                sTail$ = Trim(Mid(sCopy$, iRc% + 1))
                sLeft$ = Trim(Mid(sCopy$, 1, iRc% - 1))
            Else
                sLeft$ = Trim(Mid(sCopy$, 1, iRc% - 1))
                ' leaving sTail$ at null
            End If
                        
            sPrev$ = " "
            While Len(sLeft$) > 0
                If Not m_bUtf8 Then
                    sChar$ = Mid(sLeft$, 1, 1)
                    sLeft$ = Mid(sLeft$, 2)
                Else
                    MyNextChar.Utf8Char = sLeft$
                    sChar$ = MyNextChar.Utf8Char
                    sLeft$ = Mid(sLeft$, MyNextChar.Utf8CharOctets + 1)
                End If
                
                
                Select Case sChar$
                    Case "A" To "Z"
                        If sPrev$ = "0" Then
                            sWork$ = sWork$ + " " + sChar$
                        Else
                            sWork$ = sWork$ + sChar$
                        End If
                        sPrev$ = "A"
                    Case "a" To "z"
                        If sPrev$ = "0" Then
                            sWork$ = sWork$ + " " + UCase(sChar$)
                        Else
                            sWork$ = sWork$ + UCase(sChar$)
                        End If
                        sPrev$ = "A"
                    Case "0" To "9"
                        If sPrev$ = "A" Then
                            sWork$ = sWork$ + " "
                        End If
                        Do While InStr("0123456789", Mid(sLeft$, 1, 1)) > 0
                            sChar$ = sChar$ + Mid(sLeft$, 1, 1)
                            sLeft$ = Mid(sLeft$, 2)
                            If Len(sLeft$) = 0 Then
                                Exit Do
                            End If
                        Loop
                        If Len(sChar$) > 0 Then
                            sChar$ = Right("    " + sChar$, 4)
                        End If
                        sWork$ = sWork$ + sChar$
                        sPrev$ = "0"
                    Case " "
                        If Right(sWork$, 1) <> " " Then
                            sWork$ = sWork$ + " "
                        End If
                        sPrev$ = " "
                    Case ".", "/", "-"
                        sWork$ = Trim(sWork$) + "  "
                        sPrev$ = " "
                End Select
            Wend
            
            sWork$ = Trim(sWork$) + "  " + MyNextChar.MarcDelimiter + " "
            sPrev$ = " "
            
            
            ' different rules to the right of the colon
            
            ' remove spaces that separate numerals
            sTail$ = Trim(sTail$)
            Do
                iRc% = InStr(sTail$, "  ")
                If iRc% = 0 Then
                    Exit Do
                End If
                sTail$ = SafeStuff(sTail$, iRc%, 1, "")
            Loop
            For iRc% = Len(sTail$) To 1 Step -1
                'Debug.Print str(iRc%) + " >" + sTail$ + "< >" + Mid(sTail$, iRc%, 1) + "<"
                If Mid(sTail$, iRc%, 1) = " " Then
                    'Debug.Print "Space >" + Mid(sTail$, iRc% - 1, 1) + "< >" + Mid(sTail$, iRc% + 1, 1)
                    If InStr("0123456789", Mid(sTail$, iRc% - 1, 1)) > 0 And InStr("0123456789", Mid(sTail$, iRc% + 1, 1)) > 0 Then
                        sTail$ = SafeStuff(sTail$, iRc%, 1, "")
                    End If
                End If
            Next ' irc%
            
            While Len(sTail$) > 0
                If Not m_bUtf8 Then
                    sChar$ = Mid(sTail$, 1, 1)
                    sTail$ = Mid(sTail$, 2)
                    'Debug.Print ">" + sWork$ + "< >" + sChar$ + "< >" + sTail$ + "<"
                    Select Case sChar$
                        Case "A" To "Z"
                            If sPrev$ = "0" Then
                                sWork$ = sWork$ + " " + sChar$
                            Else
                                sWork$ = sWork$ + sChar$
                            End If
                            sPrev$ = "A"
                        Case "a" To "u", "w" To "z"
                            If sPrev$ = "0" Then
                                sWork$ = sWork$ + " " + UCase(sChar$)
                            Else
                                sWork$ = sWork$ + UCase(sChar$)
                            End If
                            sPrev$ = "A"
                        Case "v"
                            If Right(sWork$, 1) = " " Then
                                If Mid(sTail$, 1, 1) = "." Then
                                    sWork$ = sWork$ + "v ."
                                    sTail$ = LTrim(Mid(sTail$, 2))
                                Else
                                    sWork$ = sWork$ + "V"
                                End If
                            Else
                                If sPrev$ = "0" Then
                                    sWork$ = sWork$ + " V"
                                Else
                                    sWork$ = sWork$ + "V"
                                End If
                            End If
                            sPrev$ = "A"
                        Case "0" To "9"
                            'Debug.Print ">" + sWork$ + "< >" + sChar$ + "<"
                            If sPrev$ = "A" Then
                                sWork$ = sWork$ + " " + sChar$
                            Else
                                sWork$ = sWork$ + sChar$
                            End If
                            sPrev$ = "0"
                        Case " "
                            'Debug.Print "space etc. >" + sWork$ + "< >" + sTail$ + "<"
                            If Right(sWork$, 1) <> " " Then
                                'Debug.Print "     Adding space"
                                sWork$ = sWork$ + " "
                            End If
                            sPrev$ = " "
                        Case "/"
                            If Len(sTail$) > 0 Then
                                If Mid(sTail$, 1, 1) <> " " Then
                                    Select Case sPrev$
                                        Case "0"
                                            sTail$ = Trim(sTail$)
                                            ' DO NOT USE UCASE ON THE FOLLOWING
                                            If InStr("ABCDEFGHIJKLMNOPQRSTUVWXYZ", Mid(sTail$, 1, 1)) > 0 Then
                                                ' NO SPACE GOES HERE
                                                sPrev$ = "A"
                                            Else
                                                sWork$ = sWork$ + " "
                                                sPrev$ = " "
                                            End If
                                        Case "A"
                                            If InStr("0123456789", Mid(sTail$, 1, 1)) > 0 Then
                                                sWork$ = sWork$ + " "
                                                sPrev$ = " "
                                            Else
                                                sPrev$ = "A"
                                            End If
                                    End Select
                                End If
                            End If
                        Case "."
                            sWork$ = sWork$ + " ."
                            sTail$ = LTrim(sTail$)
                            If Len(sTail$) > 0 Then
                                Select Case Mid(sTail$, 1, 1)
                                    Case "0" To "0"
                                        sPrev$ = "0"
                                    Case "A" To "Z", "a" To "z"
                                        sPrev$ = "A"
                                    Case Else
                                        sPrev$ = " "
                                End Select
                            End If
                        Case "-"
                            If sPrev$ = "0" Then
                                iRc% = Rat(sWork$, " ")
                                'Debug.Print "IRC: " + str(iRc%)
                                If Len(sWork$) - iRc% < 5 Then
                                    sWork$ = Mid(sWork$, 1, iRc%) + Right("    " + Mid(sWork$, iRc% + 1), 4)
                                End If
                            End If
                            sWork$ = Trim(sWork$) + " "
                            sPrev$ = " "
                            
                            sChar$ = ""
                            Do While InStr("0123456789", Mid(sTail$, 1, 1)) > 0
                                sChar$ = sChar$ + Mid(sTail$, 1, 1)
                                sTail$ = Mid(sTail$, 2)
                                If Len(sTail$) = 0 Then
                                    Exit Do
                                End If
                            Loop
                            If Len(sChar$) > 0 Then
                                sChar$ = Right("    " + sChar$, 4)
                                sWork$ = sWork$ + sChar$
                                sPrev$ = "0"
                            End If
                    End Select
                    
                Else
                    MyNextChar.Utf8Char = sTail$
                    sChar$ = MyNextChar.Utf8Char
                    sTail$ = Mid(sTail$, MyNextChar.Utf8CharOctets + 1)
                End If
            Wend
            
            
#If False Then
            iRc% = InStr(sCopy$, ":") ' this paragraph is safe enough
            If iRc% = 0 Then
                sCopy$ = sCopy$ + ":"
                iRc% = InStr(sCopy$, ":")
                bColonFaked = True
            End If
            
            ' divide the number into pieces, at the colon
            ' if we faked the colon, sTail$ will
            '   not have anything in it
            If iRc% < Len(sCopy$) Then
                sTail$ = Trim(Mid(sCopy$, iRc% + 1))
                sWork$ = Trim(Mid(sCopy$, 1, iRc% - 1))
            Else
                sWork$ = Trim(Mid(sCopy$, 1, iRc% - 1))
                ' leaving sTail$ at null
            End If
            
            ' remove any misleading trailing slashes in the lefthand portion
            If Right(sWork$, 1) = "/" Then ' safe
                bSlashHacked = True
                sWork$ = Trim(Mid(sWork$, 1, Len(sWork$) - 1)) ' safe
            End If
            
            Do
                If Len(sWork$) = 0 Then
                    Exit Do
                End If
                ' we are grandly assuming that we're alternating from
                '   an alphabetic sequence to a numeric sequence and
                '   so on, until we're done with the "left of colon" thingie
                
                ' deal first with the stuff to the left of the colon
                ' first, remove the alphabetic portion
                NormCallNumberRemoveSuDocsAlphas sWork$, sPiece$, bSlashHit
                If Len(sPiece$) > 0 Then
                    sPrefix$ = LTrim(sPrefix$ + " " + sPiece$)
                End If
                
                If Len(sWork$) = 0 Then
                    Exit Do
                End If
                
                ' now isolate the next segment, which *should* be numerals
                NormCallNumberRemoveSuDocsNumerals sWork$, sPiece$, bSlashHit, bSlashHacked, sElement$
                If Len(sPiece$) > 0 Then
                    sPrefix$ = LTrim(sPrefix$ + " " + sPiece$) ' ltrim is safe
                End If
                
            Loop
            
            If Not bColonFaked Then
                sWork$ = sPrefix$ + "  " + MyMarcCharacter.MarcDelimiter
            Else
                sWork$ = sPrefix$
            End If
            
            If Len(sTail$) > 0 Then
            
                ' add the mandatory space here
                sWork$ = sWork$ + " "
                
                ' we work through this string, separating it into its numeric and alphabetic groups; there is
                '   special handling for numeral groups that consist of hyphenated numerals (why, I
                '   can't imagine)
                
                ' there are additional considerations: adjacent numeric and alphabetic groups
                '   that are separated in the input string by a space are concatenated (but
                '   *not* when that space is the result of the replacement of a piece
                '   of punctuation by a space)
                
                ' this moving of Tail to Copy is just so we can use a
                '   modified version of the LC-digestion routine here, rather than
                '   go through and make sure we've changed all "sCopy" to "sTail" properly
                sCopy$ = sTail$
                
                ' reduce all instances of slash-space to slash
                Do
                    iRc% = InStr(sCopy$, "/ ")
                    If iRc% = 0 Then
                        Exit Do
                    End If
                    sCopy$ = SafeStuff(sCopy$, iRc% + 1, 1, "")
                Loop
                ' reduce all instances of hyphen-space to hyphen
                Do
                    iRc% = InStr(sCopy$, "- ")
                    If iRc% = 0 Then
                        Exit Do
                    End If
                    sCopy$ = SafeStuff(sCopy$, iRc% + 1, 1, "")
                Loop
                
                ' set the 'previous character' to the first remaining character
                '   in the string
                MyPrevChar.Utf8Char = sCopy$
                                
                'added 19990113
                'unsure of the exact principle here; what we want to do is avoid the
                '   retention of the first full stop in the normalization
                '   of "S.HRG. 105-338" while retaining the second full stop
                iRc% = InStr(sCopy$, ".")
                If iRc% > 0 Then
                    If Mid(sCopy$, iRc% + 1, 1) <> " " Then
                        ' full stop is not followed by a space; replace the full
                        '   stop with a marker
                        sCopy$ = SafeStuff(sCopy$, iRc%, 1, MyMarcCharacter.MarcDelimiter)
                    End If
                End If
                        
                bNewSegment = True
                Do
NormCallNumberSudocsNextSegment:
                    If Len(sCopy$) = 0 Then
                        Exit Do
                    End If
                    DoEvents
                    MyMarcCharacter.Utf8Char = sCopy$
                    sCopy$ = Mid(sCopy$, MyMarcCharacter.Utf8CharOctets + 1)
                    If bNewSegment Then
NormCallNumberSudocsNewSegment:
                        bPreviousWasSpecial = False
                        bNewSegment = False
                        If MyMarcCharacter.Utf8CharCategory = Utf8_NumberDecimal$ Then
NormCallNumberSudocsNewSegmentForce:
                            If InStr(". ", Right(sWork$, 1)) = 0 Then ' safe
                                sWork$ = sWork$ + " "
                            End If
                            sElement$ = MyMarcCharacter.Utf8Char
                            ' isolate the remainder of this numeric segment
                            ' if this segment consists entirely of numerals separated
                            '   by hyphens, handle it differently
                            For iCtr% = 1 To Len(sCopy$) ' safe enough
                                If InStr("0123456789-", Mid(sCopy$, iCtr%, 1)) > 0 Then
                                    sElement$ = sElement$ + Mid(sCopy$, iCtr%, 1)
                                Else
                                    Exit For
                                End If
                            Next ' irc%
                            iRc% = InStr(sElement$, "-")
                            If iRc% > 0 And iRc% <> Len(sElement$) Then
                                ' the string is all numerics, and it contains an intermediate hyphen
                                ' irc% points to the first non-numeric character; throw away
                                '   stuff we've now picked up
                                ' remove this newly-extracted element (this is all safe)
                                If iCtr% < Len(sCopy$) Then
                                    sCopy$ = Mid(sCopy$, iCtr%)
                                Else
                                    sCopy$ = ""
                                End If
                                iPad% = 4
                                Do ' for each hyphen segment within the extracted string
                                    iRc% = InStr(sElement$, "-")
                                    If iRc% = 0 Then
                                        sPiece$ = sElement$
                                        sElement$ = ""
                                        sWork$ = sWork$ + Right("     " + sPiece$, iPad%)
                                        iPad% = 5
                                    ElseIf iRc% > 1 Then
                                        sPiece$ = Trim(Mid(sElement$, 1, iRc% - 1))
                                        sElement$ = Trim(Mid(sElement$, iRc% + 1))
                                        sWork$ = sWork$ + Right("     " + sPiece$, iPad%)
                                        iPad% = 5
                                    Else
                                        sElement$ = Mid(sElement$, 2)
                                    End If
                                    If Len(sElement$) = 0 Then
                                        Exit Do
                                    End If
                                Loop
                                MyMarcCharacter.Utf8Char = "0"
                                MyPrevChar.Utf8Char = "0"
                                bPreviousWasSpecial = True
                                GoTo NormCallNumberSudocsNextSegment
                            End If ' does this segment have an internal hyphen?
                        End If ' does this new segment start with a numeral?
                    End If ' is this a new segment?
                    
                    
                    If MyMarcCharacter.Utf8CharCategory = Utf8_LetterUppercase$ Then
                        Select Case MyPrevChar.Utf8CharCategory
                            Case Utf8_LetterUppercase$
                                ' normal: just add the character
                                sWork$ = sWork$ + MyMarcCharacter.Utf8CharNorm
                            Case Utf8_NumberDecimal$
                                ' switching modes: include a space here
                                If InStr(" .", Right(sWork$, 1)) = 0 Then
                                    sWork$ = sWork$ + " "
                                End If
                                sWork$ = sWork$ + MyMarcCharacter.Utf8CharNorm
                            Case Else
                                sWork$ = sWork$ + MyMarcCharacter.Utf8CharNorm
                        End Select
                    ElseIf MyMarcCharacter.Utf8CharCategory = Utf8_NumberDecimal$ Then
                        Select Case MyPrevChar.Utf8CharCategory
                            Case Utf8_NumberDecimal$
                                ' normal: just add the numeral
                                sWork$ = sWork$ + MyMarcCharacter.Utf8Char
                            Case Utf8_LetterUppercase$
                                ' see if this is a new numeric segment
                                sElement$ = MyMarcCharacter.Utf8Char
                                ' isolate the remainder of this numeric segment
                                ' if this segment consists entirely of numerals separated
                                '   by hyphens, handle it differently
                                For iCtr% = 1 To Len(sCopy$)
                                    If InStr("0123456789-", Mid(sCopy$, iCtr%, 1)) > 0 Then
                                        sElement$ = sElement$ + Mid(sCopy$, iCtr%, 1)
                                    Else
                                        Exit For
                                    End If
                                Next ' irc%
                                iRc% = InStr(sElement$, "-")
                                If iRc% > 0 And iRc% <> Len(sElement$) Then
                                    GoTo NormCallNumberSudocsNewSegment
                                End If
                                'switching modes: precede by a space
                                sWork$ = sWork$ + " " + MyMarcCharacter.Utf8Char
                            Case Else
                                ' previous must be a space: just add the character
                                sWork$ = sWork$ + MyMarcCharacter.Utf8Char
                        End Select
                    ElseIf sChar$ = " " Then
                        ' if the character after the space is of the same type as
                        '   the character before the space, do nothing now; and set current
                        '   character to previous character so we don't switch types next time
                        '   around!
                        ' BUT take the space out if the "real" previous character is a full stop!
                        ' another exception: if the space separates two numeric segments AND if
                        '   the previous numeric segment has multiple spaces, then remove the
                        '   multiple spaces AND do not include any space just here
                        If Len(sCopy$) > 0 Then
                            MyMarcCharacter.Utf8Char = sCopy$
                            If Right(sWork$, 1) <> "." Then ' safe
                                If MyPrevChar.Utf8CharCategory = Utf8_NumberDecimal$ And MyMarcCharacter.Utf8CharCategory = Utf8_NumberDecimal$ Then
                                    If Not bPreviousWasSpecial Then
                                        ' do nothing here; stick 'em together
                                    Else
                                        iSpace1% = Rat(sWork$, "  ")
                                        If iSpace1% > 0 Then
                                            iSpace2% = Rat(sWork$, " ")
                                            If iSpace2% > 0 Then ' it better be!
                                                If iSpace1% + 1 = iSpace2% Then
                                                    ' this is the problem thing: remove now all existing
                                                    '   multiple spaces
                                                    Do
                                                        iSpace1% = Rat(sWork$, "  ")
                                                        iSpace2% = Rat(sWork$, " ")
                                                        If iSpace1% = 0 Or iSpace2% = 0 Then
                                                            Exit Do
                                                        End If
                                                        If iSpace1% + 1 <> iSpace2% Then
                                                            Exit Do
                                                        End If
                                                        sWork$ = SafeStuff(sWork$, iSpace1%, 1, "")
                                                    Loop
                                                    ' and we will NOT add a space here
                                                End If
                                            End If
                                        End If
                                    End If
                                ElseIf MyPrevChar.Utf8CharCategory = Utf8_LetterUppercase$ And MyMarcCharacter.Utf8CharCategory = Utf8_LetterUppercase$ Then
                                    ' this is just to filter these out so anything else
                                    '   ends up in the "else" clause
                                Else
                                    If Right(sWork$, 1) <> " " Then
                                        ' replace the space with a space
                                        sWork$ = sWork$ + " "
                                    End If
                                End If
                            End If
                        Else ' must be all done!
                            Exit Do
                        End If
                    ElseIf MyMarcCharacter.Utf8Char = "-" Then
                        ' if this separates alpha from numeric group, add a space; and it's a new segment
                        MyNextChar = sCopy$
                        If InStr(CONST_UpperCaseAlpha$, Right(sWork$, 1)) > 0 And MyNextChar.Utf8CharCategory = Utf8_NumberDecimal$ And Len(sCopy$) > 0 Then
                            sWork$ = sWork$ + " "
                            bNewSegment = True
                            sElement$ = "-"
                            ' isolate the remainder of this numeric segment
                            ' if this segment consists entirely of numerals separated
                            '   by hyphens, handle it differently
                            For iCtr% = 1 To Len(sCopy$)
                                If InStr("0123456789-", Mid(sCopy$, iCtr%, 1)) > 0 Then
                                    sElement$ = sElement$ + Mid(sCopy$, iCtr%, 1)
                                Else
                                    Exit For
                                End If
                            Next ' irc%
                            iRc% = InStr(sElement$, "-")
                            If iRc% > 0 And iRc% <> Len(sElement$) Then
                                bNewSegment = False
                                GoTo NormCallNumberSudocsNewSegmentForce
                            End If
                        End If
                    ElseIf MyMarcCharacter.Utf8Char = MyMarcCharacter.MarcDelimiter Then
                        sWork$ = sWork$ + " "
                        bNewSegment = True
                    ElseIf MyMarcCharacter.Utf8Char = "." Then
                        If Len(sCopy$) = 0 Then
                            Exit Do
                        End If
                        sWork$ = sWork$ + " ."
                        MyMarcCharacter.Utf8Char = sCopy$
                        bNewSegment = True
                    ElseIf MyMarcCharacter.Utf8Char = "," Then
                        If Len(sCopy$) = 0 Then
                            Exit Do
                        End If
                        sWork$ = sWork$ + " "
                        MyMarcCharacter.Utf8Char = sCopy$
                        bNewSegment = True
                    ElseIf MyMarcCharacter.Utf8Char = "/" Then
                        bNewSegment = True
                        If Len(sCopy$) > 0 Then
                            If Not bPreviousWasSpecial Then
                                MyNextChar = sCopy$
                                If MyPrevChar.Utf8CharCategory = Utf8_NumberDecimal$ And MyNextChar.Utf8CharCategory = Utf8_NumberDecimal$ Then
                                    If Right(sWork$, 1) <> " " Then
                                        sWork$ = sWork$ + " "
                                    End If
                                ElseIf MyPrevChar.Utf8CharCategory = Utf8_NumberDecimal$ And MyNextChar.Utf8CharCategory = Utf8_LetterUppercase$ Then
                                    If Right(sWork$, 1) <> " " Then
                                        sWork$ = sWork$ + " "
                                    End If
                                Else
                                    If Right(sWork$, 1) <> " " Then
                                        sWork$ = sWork$ + " "
                                    End If
                                    ' for some reason, do NOT add any space!
                                End If
                            Else ' previous *was* special: do nothing at all
                                ' this is *not* a new segment!
                                bNewSegment = False
                            End If
                            MyMarcCharacter.Utf8Char = sCopy$
                        Else
                            Exit Do
                        End If
                    Else
                        If Len(sCopy$) = 0 Then
                            Exit Do
                        End If
                        sWork$ = sWork$ + " "
                    End If
                    MyPrevChar.Utf8Char = MyMarcCharacter.Utf8Char
                Loop
            End If
#End If

        Case Else ' CALLNOTYPE_Other$, CALLNOTYPE_OtherCode$, "*"
        
            ' 20040914: we formerly explicitly losted the "other" call number
            '   types here, but it appears we were also feeding this one with all
            '   kinds of ridiculous things; so we're going to make this into a
            '   "case else" instead; could be fixed (with breakage to existing code
            '   if we switched to an ENUM for the parameter ...
            
            ' upper-case the thing, remove duplicate spaces, remove
            '   leading/trailing spaces, and get out of here
            '   make sure there are no duplicate spaces, and return
            sWork$ = Trim(RemoveRepeatedCharacters(SafeUCase(sCallNumber$), " "))
            
    End Select
        
    NormalizeCallNumber = sWork$
    
    #If NormCallNumberDebug% = -1 Then
        Debug.Print "At end: >" + sWork$ + "<"
    #End If
    
NormCallNumberExit:

    On Error GoTo 0
    Exit Function

NormCallNumberError:

    'iRc% = MsgBox(Error(Err), 0, "norm call number " + sLabel$)
    Resume NormCallNumberExit
            
End Function


Public Function SafeUCase(ByVal sSourceString$) As String

    ' UTF-8 safe: separate handling provided
    
    Dim lPtr As Long, lEnd As Long

    Dim iOctets%, iRc%
    
    Dim sOut$, sChar$
    
    
    If Not m_bUtf8 Then
        For lPtr = 1 To Len(sSourceString$)
            sChar$ = Mid(sSourceString$, lPtr, 1)
            iRc% = InStr(CONST_LowerCaseAlpha$, sChar$)
            If iRc% > 0 Then
                sSourceString$ = SafeStuff(sSourceString$, lPtr, 1, Mid(CONST_UpperCaseAlpha$, iRc%, 1))
#If False Then
            Else
                ' 20060707: turned off because this ONLY works when we're uppercasing
                '   something that's already been translated into MsoftAscii
                ' I don't know when we *do* this, but I can only believe that most
                '   of the time we are not doing this, but are instead
                '   safely uppercasing a plain old MARC string
                ' for example, we do NOT want to convert E8 (umlaut in MARC, but
                '   grave-e in MsoftAscii) to C8 (superscript 8 in Voyager, but
                '   grave-E in MsoftAscii)
#If True Then
                iRc% = InStr(CONST_LowerCaseAlphaExtension$, sChar$)
                If iRc% > 0 Then
                    'Debug.Print CONST_LowerCaseAlphaExtension$ + " " + str(iRc%)
                    'Debug.Print CONST_UpperCaseAlphaExtension$
                    sSourceString$ = SafeStuff(sSourceString$, lPtr, 1, Mid(CONST_UpperCaseAlphaExtension$, iRc%, 1))
                End If
#Else
                iRc% = InStr(CONST_UpperEndLowerCase$, sChar$)
                If iRc% > 0 Then
                    sSourceString$ = SafeStuff(sSourceString$, lPtr, 1, Mid(CONST_UpperEndUpperCase$, iRc%, 1))
                End If
#End If
#End If
            End If
        Next ' lptr
        SafeUCase = sSourceString$
        Exit Function
    End If
    
    ' if we get here, we're expecting UTF-8
    
    lEnd = Len(sSourceString$)
    If lEnd = 0 Then
        SafeUCase = ""
        Exit Function
    End If
    
    lPtr = 1
    Do
        MyMarcCharacter.Utf8Char = Mid(sSourceString$, lPtr)
        sOut$ = sOut$ + MyMarcCharacter.Utf8CharUCase
        lPtr = lPtr + MyMarcCharacter.Utf8CharOctets
        If lPtr > lEnd Then
            Exit Do
        End If
    Loop
    
    SafeUCase = sOut$

End Function

Public Function UCaseFirstWord(ByVal sString$, Optional ByVal bUppercaseAtHyphens As Boolean = False) As String

    ' UTF-8 safe: separate handling provided
    
    Dim lPtr As Long, lLen As Long
    
    Dim iOctets%, iRc%
    
    Dim sChar$, sLeft$, sRight$
    
    Dim bDidOne As Boolean
    
    
    lLen = Len(sString$)
    If lLen = 0 Then
        UCaseFirstWord = ""
        Exit Function
    End If
    
    ' default value: same as initial value
    UCaseFirstWord = sString$
    
    
    If Mid(sString$, 1, 1) = MyMarcCharacter.MarcDelimiter Then
        sLeft$ = Mid(sString$, 1, 2)
        sString$ = Mid(sString$, 3)
        ' 20070731: skip subfield $6
        If Right(sLeft$, 1) = "6" Then
            iRc% = InStr(sString$, MyMarcCharacter.MarcDelimiter)
            If iRc% > 0 Then
                sLeft$ = sLeft$ + Mid(sString$, 1, iRc% + 1)
                sString$ = Mid(sString$, iRc% + 2)
            End If
        End If
    End If
    
    If m_bUtf8 Then
    
        lPtr = 1
        Do
            iOctets% = MyMarcCharacter.Utf8CharOctets(Mid(sString$, lPtr, 1))
            MyMarcCharacter.Utf8Char = Mid(sString, lPtr, iOctets%)
            Select Case MyMarcCharacter.Utf8CharCategory
                Case Utf8_LetterLowercase$ ' "Ll"
#If True Then
                    If lPtr > 1 Then
                        sString$ = Mid(sString$, 1, lPtr - 1) + MyMarcCharacter.Utf8CharUCase + Mid(sString$, lPtr + iOctets%)
                    Else
                        sString$ = MyMarcCharacter.Utf8CharUCase + Mid(sString$, lPtr + iOctets%)
                    End If
#Else
                    If lPtr > 1 Then
                        UCaseFirstWord = sLeft$ + Mid(sString$, 1, lPtr - 1) + MyMarcCharacter.Utf8CharUCase + Mid(sString$, lPtr + iOctets%)
                    Else
                        UCaseFirstWord = sLeft$ + MyMarcCharacter.Utf8CharUCase + Mid(sString$, lPtr + iOctets%)
                    End If
#End If
                    Exit Do
                Case Utf8_LetterUppercase$ ' "Lu"
                    Exit Do
                Case Utf8_LetterTitlecase$ ' "Lt"
                    Exit Do
                Case Utf8_NumberDecimal$ ' "Nd"
                    Exit Do
                Case Utf8_NumberLetter$ ' "Nl"
                    Exit Do
                Case Utf8_NumberOther$ ' "No"
                    Exit Do
                Case Utf8_SymbolCurrency$ ' "Sc"
                    Exit Do
                Case Utf8_SymbolMath$ ' "Sm"
                    Exit Do
            End Select
            lPtr = lPtr + iOctets%
            If lPtr > lLen Then
                Exit Do
            End If
        Loop

        ' regardless of what we did with the first letter, we may wish to
        '   uppercase at hyphens as well
        ' for example, the conversion of text in this TOC: 2002004791.html
        If bUppercaseAtHyphens Then
            'Debug.Print "Did one? " + str(bDidOne) + " >" + sString$ + "< " + str(bUppercaseAtHyphens)
            lPtr = InStr(sString$, MyMarcCharacter.MarcDelimiter)
            If lPtr > 0 Then
                sRight$ = Mid(sString$, lPtr)
                sString$ = Mid(sString$, 1, lPtr - 1)
            End If
            For lPtr = Len(sString$) To 1 Step -1
                MyMarcCharacter.Utf8Char = Mid(sString$, lPtr, 1)
                If Mid(sString$, lPtr, 1) = "-" Then
                    MyMarcCharacter.Utf8Char = Mid(sString$, lPtr + 1)
                    If MyMarcCharacter.Utf8CharCategory = Utf8_LetterLowercase$ Then
                        sString$ = SafeStuff(sString$, lPtr + 1, MyMarcCharacter.Utf8CharOctets, MyMarcCharacter.Utf8CharUCase)
                    End If
                End If
            Next ' lptr
        End If
        UCaseFirstWord = sLeft$ + sString$ + sRight$
        
    Else ' not UTF-8
    
        For lPtr = 1 To Len(sString$)
            sChar$ = Mid(sString$, lPtr, 1)
            If InStr(CONST_UpperCaseAlpha$, sChar$) Then
                ' first character already lowercased
                Exit For
            ElseIf InStr(CONST_LowerCaseAlpha$, sChar$) > 0 Then
                ' lowercase the alpha character
                UCaseFirstWord = sLeft$ + SafeStuff(sString$, lPtr, 1, UCase(sChar$))
                Exit For
            ElseIf InStr(Const_NumString$, sChar$) > 0 Then
                Exit For
            ElseIf InStr(CONST_Currency$, sChar$) > 0 Then
                Exit For
            ElseIf InStr(CONST_Math$, sChar$) > 0 Then
                Exit For
            Else
                iRc% = InStr(sChar$, CONST_UpperEndLowerCase$)
                If iRc% > 0 Then
                    UCaseFirstWord = sLeft$ + SafeStuff(sString$, lPtr, 1, Mid(CONST_UpperEndUpperCase, iRc%, 1))
                    Exit For
                End If
                iRc% = InStr(sChar$, CONST_UpperEndUpperCase$)
                If iRc% > 0 Then
                    Exit For
                End If
            End If
        Next ' lptr
    End If
    
End Function

Public Function LengthInCharacters(sString$) As Long

    ' UTF-8 safe: separate handling provided
    
    ' this returns the number of characters in a string, not the
    '   number of octets. for non-UTF-8 strings, the two are of course
    '   identical
    
    Dim lPtr As Long, lEnd As Long, lCount As Long

    Dim iOctets%
   
    lEnd = Len(sString$)
    If Not m_bUtf8 Then
        LengthInCharacters = lEnd
        Exit Function
    End If
    
    ' if we get here, we've got UTF-8
    
    If lEnd = 0 Then
        LengthInCharacters = 0
        Exit Function
    End If
    
    ' to get here, the thing contains at least one octet; which we're going to assume
    '   is a legal UTF-8 character
    
    lPtr = 1
    Do
        lCount = lCount + 1
        MyMarcCharacter.Utf8Char = Mid(sString$, lPtr, 1)
        lPtr = lPtr + MyMarcCharacter.Utf8CharOctets(Mid(sString$, lPtr, 1))
        If lPtr > lEnd Then
            Exit Do
        End If
    Loop
    
    LengthInCharacters = lCount

End Function

Public Function NormString(ByVal sCharacterString$, Optional bTrim As Boolean = True) As String

    ' UTF-8: separate handling provided
    
    Dim lCurrentOctet As Long, lLength As Long
    
    Dim sOut$, sRetVal$, sPrevChar$, sTestChar$
    
    Dim iLength%, iStrLen%, iWorking%, iCtr%, iCtr2%
    
    Dim bDebug As Boolean
    
    
#If NormStringDebug = -1 Then
    Debug.Print "Norm string entry: >" + sCharacterString$ + "< " + str(m_bUtf8)
#End If

    If m_bUtf8 Then
        ' we manipulate the pointer to the current octet ourselves, as
        '   the increment for the next character (i.e., the next first
        '   octet) varies from one 'character' to the next
        lCurrentOctet = 1
        ' the main normalization loop
        lLength = Len(sCharacterString$)
        If lLength > 0 Then
            Do
                ' determine the length of this UTF character
                iLength% = MyMarcCharacter.Utf8CharOctets(Mid(sCharacterString$, lCurrentOctet, 1))
#If NormStringDebugFull = -1 Then
                Debug.Print "Values: >" + sOut$ + "< >" + Mid(sCharacterString$, lCurrentOctet, iLength%) + "<"
#End If
                MyMarcCharacter.Utf8Char = Mid(sCharacterString$, lCurrentOctet, iLength%)
                sOut$ = sOut$ + MyMarcCharacter.Utf8CharNorm
                lCurrentOctet = lCurrentOctet + iLength% ' skip over the character, however long it may be
                If lCurrentOctet > lLength Then
                    Exit Do
                End If
            Loop
        End If
    
    Else ' NOT unicode
    
        iStrLen% = Len(sCharacterString$)
        sPrevChar$ = " "
        
        Select Case m_sCharacterSetOut$
            Case "V" ' Voyager
                ' convert the Voyager string into the generic intermediate form
                For iCtr% = 1 To iStrLen%
                    sTestChar$ = Mid(sCharacterString$, iCtr%, 1)
#If NormStringDebug = -1 Then
                    Debug.Print "Values: >" + sTestChar$ + "< " + str(Asc(sTestChar$))
#End If
                    Select Case Asc(sTestChar$)
                        Case 27 ' should not be occurring!
                            ' handle just like USMARC
                            GoTo NormStringMHandleEscape
                        Case 31 ' delimiter!
                            ' insert a space
                            sRetVal$ = sRetVal$ + " "
                            ' skip delimiter and subfield code
                            iCtr% = iCtr% + 1
                        Case 160
                            sRetVal$ = sRetVal$ + GenericScriptL$
                        Case Else
                            sRetVal$ = sRetVal$ + NormCharV(sTestChar$)
                            'Debug.Print "Ret val so far: >" + sRetVal$ + "<"
                    End Select
                Next ' ictr%
            Case "M", "O"  ' USMARC and OCLC
                ' convert the USMARC string into the generic intermediate form
                For iCtr% = 1 To iStrLen%
                    sTestChar$ = Mid(sCharacterString$, iCtr%, 1)
                    Select Case Asc(sTestChar$)
                        Case 27
NormStringMHandleEscape:
                            If Mid(sCharacterString$, iCtr% + 1, 1) = "g" Then
                                ' the greek set
                                For iCtr2% = iCtr% + 2 To iStrLen%
                                    sTestChar$ = Mid(sCharacterString$, iCtr2%, 1)
                                    Select Case sTestChar$
                                        Case MarcEscape
                                            ' the end of the string
                                            iCtr% = iCtr2% + 1
                                            GoTo NormStringMNextChar
                                        Case MyMarcCharacter.MarcDelimiter
                                            iCtr% = iCtr2% - 1
                                            GoTo NormStringMNextChar
                                        Case "a"
                                            sRetVal$ = sRetVal$ + GenericAlpha$
                                        Case "b"
                                            sRetVal$ = sRetVal$ + GenericBeta$
                                        Case "c"
                                            sRetVal$ = sRetVal$ + GenericGamma$
                                        Case Else ' what is this mess?
                                            ' we'll just continue
                                    End Select
                                Next ' ictr2%
                                ' the only way we can get here is if we hit
                                '   the end of the field altogether
                                Exit For
                            Else
                                ' normal set, superscripts or subscripts
                                ' skip 2 characters and continue
                                iCtr% = iCtr% + 1
                            End If
                        Case 31 ' delimiter!
                            sRetVal$ = sRetVal$ + " "
                            ' we will skip 2 characters
                            iCtr% = iCtr% + 1
                        Case 193, 190 ' script-l for USMARC and OCLC, respectively
                            ' todo: not really sure what we should do with this
                            sRetVal$ = sRetVal$ + GenericScriptL$
                        Case Else
                            ' appears to be a normal character
                            sRetVal$ = sRetVal$ + NormCharM(sTestChar$)
NormStringMNextChar:
                    End Select
                Next ' ictr%
        End Select
        
#If NormStringDebugFull = -1 Then
        Debug.Print "after loop before final: >" + sOut$ + "< >" + sRetVal$ + "<"
#End If
        sOut$ = ""
        For iCtr% = 1 To Len(sRetVal$)
            sOut$ = sOut$ + NormCharFinalV(Mid(sRetVal$, iCtr%, 1))
        Next ' ictr%
    
    End If
    
    ' endgame: various cleanups (all are independent of character-encoding)
    
    'remove surrounding spaces
    'remove multiple internal spaces
    If bTrim Then
        NormString = Trim(RemoveRepeatedCharacters(sOut$, " "))
    Else
        NormString = RemoveRepeatedCharacters(sOut$, " ")
    End If

End Function
Private Function NormCharV(sIn$) As String

    ' USED FOR NON-UTF-8 ONLY!!
    
    ' this does pre-normalization on a single Voyager character
    
    ' preserve all normal punctuation for the present
    If InStr(CONST_PunctuationToKeepForAWhile$, sIn$) > 0 Then
        NormCharV = sIn$
    Else
        Select Case Asc(sIn$)
            Case 32
                NormCharV = " "
            Case Is < 48 ' shouldn't be happening!
                NormCharV = sIn$
            Case Is < 58 ' numerals
                NormCharV = sIn$
            Case Is < 65 ' shouldn't be happening!
                NormCharV = ""
            Case Is < 91 ' upper-case letters
                NormCharV = sIn$
            Case Is < 97 ' shouldn't be happening!
                NormCharV = ""
            Case Is < 123
                NormCharV = UCase(sIn$)
            Case 123, 135
                NormCharV = GenericCurly$
            Case 144
                NormCharV = GenericDegree$
            Case 146
                NormCharV = GenericPressing
            Case 147
                NormCharV = GenericCopyright
            Case 148
                NormCharV = GenericSharp
            Case 149
                NormCharV = GenericInvertedQuestionMark
            Case 150
                NormCharV = GenericInvertedExclamationMark
            Case Is < 160 ' shouldn't be happening!
                NormCharV = ""
            Case 160 ' Voyager script-l
                NormCharV = GenericScriptL$
            Case 161, 177
                NormCharV = GenericSlashL$
            Case 162, 178
                NormCharV = GenericSlashO$
            Case 163, 179
                NormCharV = GenericSlashD$
            Case 164, 180
                NormCharV = GenericThorn$
            Case 165, 181
                'Debug.Print "Generic AE >" + GenericAE$ + "<"
                NormCharV = GenericAE$
            Case 166, 182
                NormCharV = GenericOE$
            Case 169, 170, 171, 174, 176, 185, 186
                ' flat, registered, plus/minus, alif, ayin
                ' pound, eth
                NormCharV = sIn$
            Case 172, 188
                NormCharV = GenericHookO$
            Case 173, 189
                NormCharV = genericHookU$
            Case 175
                NormCharV = GenericAlpha$
            Case 184 ' turkish dotless I: only one possibility foreseen
                NormCharV = "I"
            Case 190
                NormCharV = GenericBeta$
            Case 191
                NormCharV = GenericGamma$
            Case 192 To 201
                NormCharV = Chr(Asc(sIn$) - 144)
            Case Is > 223 ' normal diacritics--put this here for slight efficiency gain
                NormCharV = ""
            Case 202, 218
                NormCharV = GenericSuperSubPlus$
            Case 203, 219
                NormCharV = GenericSuperSubMinus$
            Case 204, 220
                NormCharV = GenericSuperSubParensL$
            Case 205, 221
                NormCharV = GenericSuperSubParensR$
            Case 208 To 217
                NormCharV = Chr(Asc(sIn$) - 160)
            Case Else
                ' leftover and unrecognized junk
                NormCharV = ""
        End Select
    End If

End Function


Private Function NormCharM(sIn$) As String

    ' USED FOR NON-UTF-8 ONLY!!
    
    ' this does pre-normalization on a single non-Voyager (OCLC or pure MARC) character
    
    ' preserve all normal punctuation for the present
    If InStr(CONST_PunctuationToKeepForAWhile$, sIn$) > 0 Then
        NormCharM = sIn$
    Else
        Select Case Asc(sIn$)
            Case 32
                NormCharM = " "
            Case Is < 48 ' shouldn't be happening!
                NormCharM = ""
            Case Is < 58 ' numerals
                NormCharM = sIn$
            Case Is < 65 ' shouldn't be happening!
                NormCharM = ""
            Case Is < 91 ' upper-case letters
                NormCharM = sIn$
            Case Is < 97 ' shouldn't be happening!
                NormCharM = ""
            Case Is < 123
                NormCharM = UCase(sIn$)
            Case 123, 125
                NormCharM = GenericCurly$
            Case Is < 161 ' shouldn't be happening!
                NormCharM = ""
            Case 161, 177
                NormCharM = GenericSlashL$
            Case 162, 178
                NormCharM = GenericSlashO$
            Case 163, 179
                NormCharM = GenericSlashD$
            Case 164, 180
                NormCharM = "TH"
            Case 165, 181
                NormCharM = "AE"
            Case 166, 182
                NormCharM = "OE"
            Case 169, 170, 174, 176, 185, 186, 194, 195, 196, 197, 198
                ' flat, registered, alif, ayin
                ' pound, eth, produced, copyright, sharp
                ' inverted question, inverted exclamation
                NormCharM = sIn$
            Case 172, 188
                NormCharM = GenericHookO$
            Case 173, 189
                NormCharM = genericHookU$
            Case 184 ' turkish dotless I: only one possibility foreseen
                NormCharM = "I"
            Case 192
                NormCharM = GenericScriptL$
            Case Else
                ' diacritics, and unrecognized junk
                NormCharM = ""
        End Select
    End If

End Function


Private Function NormCharFinalV(sIn$) As String

    ' USE FOR NON-UTF-8 ONLY!
    
    ' this does the last-stage normalization of a heading--converting
    '   a single "generically-normalized" character
    
    
    Select Case sIn$
        Case "A" To "Z"
            NormCharFinalV = sIn$
        Case "0" To "9"
            NormCharFinalV = sIn$
        Case " "
            NormCharFinalV = sIn$
        Case GenericSlashL$
            NormCharFinalV = "L"
        Case GenericSlashO$
            NormCharFinalV = "O"
        Case GenericSlashD$
            NormCharFinalV = "D"
        Case GenericThorn$
            NormCharFinalV = "TH"
        Case GenericAE$
            NormCharFinalV$ = "AE"
        Case GenericOE$
            NormCharFinalV$ = "OE"
        Case GenericHookO$
            NormCharFinalV$ = "O"
        Case genericHookU$
            NormCharFinalV$ = "U"
        Case GenericScriptL$
            NormCharFinalV$ = "L"
        Case MARC_BritishPound$, GenericCurly$
            NormCharFinalV$ = " "
        Case MARC_Eth$
            NormCharFinalV$ = "D"
        Case GenericAlpha$
            NormCharFinalV = "A"
        Case GenericBeta$
            NormCharFinalV = "B"
        Case GenericGamma$
            NormCharFinalV = "G"
        Case MARC_Flat$
            NormCharFinalV$ = Chr(169) ' as of 20020204
        Case GenericSuperSubPlus$
            NormCharFinalV = " "
        Case GenericSuperSubMinus$
            NormCharFinalV = " "
        Case GenericSuperSubParensL$
            NormCharFinalV = " "
        Case GenericSuperSubParensR$
            NormCharFinalV = " "
        Case Else
            ' punctuation, odd characters of all kinds, diacritics
            Select Case Asc(sIn$)
                Case 35, 38, 43 ' pound, ampersand, plus
                    NormCharFinalV$ = sIn$
                Case 39, 91, 93, 94, 95, 96, 124, 126, AscGenericDegree%, AscGenericPressing%, AscGenericCopyright%, AscGenericSharp%, AscGenericInvertedQuestionMark%, AscGenericInvertedExclamationMark%, 167, 168, 174, 176, 183, 187, 224 To 255
                    ' apostrophe, L/R brackets, spacing circumflex and underscore
                    ' spacing grave, vertical bar, tilde
                    ' degree sign, pressing, copyright, inverted question, inverted exclamation
                    ' m.znak, centered dot, alif, ayn, t.znak, unknown, diacritics
                    NormCharFinalV = ""
                Case Else
                    NormCharFinalV = " "
            End Select
    End Select
    
End Function



Public Function SafeLCase(ByVal sSourceString$) As String

    ' UTF-8 safe: separate handling provided
    
    Dim lPtr As Long, lEnd As Long

    Dim iOctets%, iRc%
    
    Dim sOut$, sChar$
    
    'If Mid(sSourceString$, 1, 1) = "v" Then
    '    Debug.Print "SLC >" + sSourceString$ + "< " + str(m_bUtf8)
    'End If
    
    If Not m_bUtf8 Then
        For lPtr = 1 To Len(sSourceString$)
            sChar$ = Mid(sSourceString$, lPtr, 1)
            iRc% = InStr(CONST_UpperCaseAlpha$, sChar$)
            If iRc% > 0 Then
                sSourceString$ = SafeStuff(sSourceString$, lPtr, 1, Mid(CONST_LowerCaseAlpha$, iRc%, 1))
            Else
                iRc% = InStr(CONST_UpperEndUpperCase$, sChar$)
                If iRc% > 0 Then
                    sSourceString$ = SafeStuff(sSourceString$, lPtr, 1, Mid(CONST_UpperEndLowerCase$, iRc%, 1))
                End If
            End If
        Next ' lptr
        SafeLCase = sSourceString$
        Exit Function
    End If
    
    lEnd = Len(sSourceString$)
    If lEnd = 0 Then
        SafeLCase = ""
        Exit Function
    End If
    
    lPtr = 1
    Do
        MyMarcCharacter.Utf8Char = Mid(sSourceString$, lPtr)
        sOut$ = sOut$ + MyMarcCharacter.Utf8CharLCase
        lPtr = lPtr + MyMarcCharacter.Utf8CharOctets
        If lPtr > lEnd Then
            Exit Do
        End If
    Loop
    
    SafeLCase = sOut$

End Function
Public Function IsTrue(ByVal sInput$) As Boolean

    ' UTF-8 safe because none of the constants includes
    '   any multi-octet characters; if the input string is a
    '   non-UTF-8 string, then the comparisons will fail, as they should
    
    Select Case NormString(sInput$)
        Case "TRUE", "YES", "Y", "T", "1"
            IsTrue = True
        Case Else ' we hope it's FALSE, NO, F or N
            IsTrue = False
    End Select

End Function

Public Function IsTheFullStopAtTheEndProbablyIntegral(ByVal sHeading$) As Integer

    ' identify a number of cases in which the full stop at the end of a heading is
    '   likely to be "integral" with the heading--i.e., it's part of the basic
    '   heading itself, and not simply a full stop that happens to have been added
    '   to the end of a heading
    
    ' if the return value is False, it means only that this function can't decide
    '   that the full stop is integral;
    '   it's the calling routine's job to ask the operator what to
    '   do with the terminal full stop
    
    ' UTF-8 safe, because the container program must tell us if the
    '   text is UTF-8 or not and we have separate handling each way
    ' watch out if you must add any text constants involving
    '   diacritics; see comments below
    
    Dim iRc%
    
    Dim sTest5$, sTest4$, sTerminalPunctuation$
    
    Dim lPtr As Long
    
    
    ' if we got here accidentally, pretend everything is OK (this instruction
    '   tells the container program to leave the heading alone)
    If Right(sHeading$, 1) <> "." Then
        If InStr(Chr(34) + "'", Right(sHeading$, 1)) > 0 Then
            If Mid(sHeading$, Len(sHeading$) - 1, 1) = "." Then
                sTerminalPunctuation$ = Right(sHeading$, 1)
                sHeading$ = Mid(sHeading$, 1, Len(sHeading$) - 1)
                GoTo ITFSATEPI_FullStopAfterAll
            End If
        End If
YesTheFullStopAtTheEndIsIntegral:
        IsTheFullStopAtTheEndProbablyIntegral = FULLSTOP_Integral%
        Exit Function
    End If
    
ITFSATEPI_FullStopAfterAll:
    ' 20050504: only interested in the terminal subfield, aren't we?
    iRc% = Rat(sHeading$, MarcDelimiter)
    If iRc% > 0 Then
        sHeading$ = Trim(Mid(sHeading$, iRc% + 2))
    End If
    
    ' set the default value: we can't tell about this full stop
    IsTheFullStopAtTheEndProbablyIntegral = FULLSTOP_Unknown%
    
    iRc% = Len(sHeading$)
    If iRc% > 2 Then
        If m_bUtf8 Then
            ' find the start of the character that precedes the full stop
            lPtr = MyMarcCharacter.Utf8CharFindFirstOctet(sHeading$, Len(sHeading$) - 1)
            ' the Utf8Char will automatically trim off things following the
            '   character itself--i.e., the full stop; so we don't have
            '   to worry ourselves with the number of octets in the character
            MyMarcCharacter.Utf8Char = Mid(sHeading$, lPtr)
            ' terminal full stops folloing numerals can be dropped safely
            Select Case MyMarcCharacter.Utf8CharCategory
                Case Utf8_NumberDecimal$
YesWeMayRemoveTheFullStop:
                    IsTheFullStopAtTheEndProbablyIntegral = FULLSTOP_Remove%
                    Exit Function
                Case Utf8_LetterUppercase$, Utf8_LetterTitlecase$
                    ' if the preceding character is uppercase and the character before
                    '   that is a space or another full stop, we have an initialisim--
                    '   retain the full stop
                    ' take the heading minus the uppercase letter and see if the now-final
                    '   character is space or full stop
                    If InStr(" .", SafeRight(Mid(sHeading$, 1, lPtr - 1), 1)) > 0 Then
                        GoTo YesTheFullStopAtTheEndIsIntegral
                    End If
            End Select
            
            ' many of the following tests involve a 5-character string ...
            sTest5$ = SafeRight("     " + SafeUCase(SafeRight(sHeading$, 5)), 5)
            sTest4$ = SafeMid(sTest5$, 2) '* * * * NOTE that this builds on sTest5, not sHeading$
            
            ' UTF-8: these tests as given here are all UTF-8 safe because they
            '   involve only low-end charcters; but we may eventually need to add
            '   tests that involve diacritics and similar things
            ' these are always OK, retaining their full stops
            ' * * * * WHEN ADDING TO THIS LIST, remember to do it in both places
            '   (see below for parallel section)
            ' 20041124: added Dept. and Jr.
            ' 20050405: ESQ and DR added
            ' 20060110: added Ref.
            If sTest5$ = " A.D." Or sTest5$ = "CENT." Or sTest5$ = "DEPT." Then
                GoTo YesTheFullStopAtTheEndIsIntegral
            ElseIf sTest5$ = " B.C." Then
                GoTo YesTheFullStopAtTheEndIsIntegral
            ElseIf sTest5$ = " ETC." Or sTest5$ = " ESQ." Then
                GoTo YesTheFullStopAtTheEndIsIntegral
            ElseIf sTest5$ = " INC." Or sTest5$ = " REV." Then
                GoTo YesTheFullStopAtTheEndIsIntegral
            ElseIf sTest5$ = " LTD." Then
                GoTo YesTheFullStopAtTheEndIsIntegral
            ElseIf sTest5$ = " ARR." Then
                GoTo YesTheFullStopAtTheEndIsIntegral
            ElseIf sTest4$ = " CO." Or sTest4$ = " DR." Or sTest4$ = " JR." Then
                GoTo YesTheFullStopAtTheEndIsIntegral
            End If
        Else ' NOT utf-8: we can do this more simply
            ' terminal full stops folloing numerals can be dropped safely
            If InStr(Const_NumString$, Mid(sHeading$, iRc% - 1, 1)) > 0 Then
                GoTo YesWeMayRemoveTheFullStop
            End If
            ' if the preceding character is uppercase and the character before
            '   that is a space or another full stop, we have an initialisim--
            '   retain the full stop
            If InStr(CONST_UpperCaseAlpha$, Mid(sHeading$, iRc% - 1, 1)) > 0 Then
                If InStr(" .", Mid(sHeading$, iRc% - 2, 1)) > 0 Then
                    GoTo YesTheFullStopAtTheEndIsIntegral
                End If
            End If
            
            ' many of the following tests involve a 5-character string ...
            sTest5$ = UCase(Right(sHeading$, 5))
            sTest4$ = Right("    " + UCase(Right(sHeading$, 4)), 4)
            
            ' these are always OK, retaining their full stops
            ' 20050405: ESQ and DR added
            If sTest5$ = " A.D." Or sTest5$ = "CENT." Or sTest5$ = "DEPT." Then
                GoTo YesTheFullStopAtTheEndIsIntegral
            ElseIf sTest5$ = " B.C." Then
                GoTo YesTheFullStopAtTheEndIsIntegral
            ElseIf sTest5$ = " ETC." Or sTest5$ = " ESQ." Then
                GoTo YesTheFullStopAtTheEndIsIntegral
            ElseIf sTest5$ = " INC." Then
                GoTo YesTheFullStopAtTheEndIsIntegral
            ElseIf sTest5$ = " LTD." Then
                GoTo YesTheFullStopAtTheEndIsIntegral
            ElseIf sTest5$ = " ARR." Or UCase(Right(sHeading$, 6)) = MyMarcCharacter.MarcDelimiter + "OARR." Then
                GoTo YesTheFullStopAtTheEndIsIntegral
            ElseIf sTest4$ = " CO." Or sTest4$ = " DR." Or sTest4$ = " JR." Then
                GoTo YesTheFullStopAtTheEndIsIntegral
            End If
        End If
    End If

    ' if we get here, we'll return with the default value of Unknown;
    '   some other code is going to have to ask the operator what to do

End Function




Public Sub DumpArray(Optional sTagList$ = "", Optional bIncludeSubfieldDetails As Boolean = True)

    ' this is ONLY used for debugging purposes!
    
    Dim iCtr%, iCtr2%
    
    Dim sText$
    
    For iCtr% = 0 To m_iMarcCtr% - 1
        With MarcArray(iCtr%)
#If WithDebug = -1 Then
            PushWith "DumpArray with on"
#End If
            On Error GoTo DumpArrayRecovery
            If Len(sTagList$) > 0 Then
                If InStr(sTagList$, .Tag) = 0 Then
                    GoTo DumpArrayNextField
                End If
            End If
            ' LEAVE THIS DEBUG ALONE
            Debug.Print Trim(str(iCtr%)) + " " + str(.Deleted) + "  " + .Tag + ":" + .Ind + " prev " + str(.PrevField) + " next " + str(.NextField) + " first " + str(.FirstSubfield) + " last " + str(.LastSubfield) + " sort >" + .SortInstruction + "< ext >"; .SortInstructionExtension + "<"
            If bIncludeSubfieldDetails Then
                For iCtr2% = 0 To .SubfieldLast
                    With MarcArray(iCtr%).Subfield(iCtr2%)
                        ' LEAVE THIS DEBUG ALONE
                        Debug.Print "     " + Trim(str(iCtr2%)) + " " + .Code + ":" + .Text + "< prev " + str(.PrevSubfield) + " next " + str(.NextSubfield) + " sortgp " + str(.SortGroup) + " sortinstr " + str(.SortInstruction) + " sortstr >" + .SortString + "<"
                    End With
                Next
            End If
DumpArrayNextField:
            On Error GoTo 0
#If WithDebug = -1 Then
            PopWith "DumpArray with off"
#End If
        End With
    Next
    
    Exit Sub
    
DumpArrayRecovery:
    Debug.Print Error(Err)
    Resume DumpArrayNextField
    
End Sub

Private Sub ReadValidationConfiguration()

    ' set up the field-order definitions
    
    ' at one time, we read the field-order information from the ValidIt configuration
    '   files.  but we changed our mind.
    
    ' now, we're going to force things into what we think of as 'generic' order here.
    '   (this is somewhat more refined than the MARC-defined generic order.) if container
    '   programs want to enforce some other or finer order, they must pass the
    '   finished record prepared by this module to ValidIt; or enforce their field order
    '   in some other way
    
    ' the field order enforced here is that which we follow at
    '   Northwestern: references are by type and then in alphabetical order;
    '   and local series tractices come before other people's series
    '   practices
    
    SetDefaultFldOrderAuth
    SetDefaultSfdOrderAuth
    
    SetDefaultFldOrderBib
    SetDefaultSfdOrderBib
    
    SetDefaultFldOrderHold
    SetDefaultSfdOrderHold
    
    SetDefaultFldOrderOther
    SetDefaultSfdOrderOther
    
#If False Then
    ' this is now dead; replaced by the above
    ReDim gblaSubfieldOrderAuth(0 To 1)
    gbliSubfieldOrderAuthLast% = 1
    gbliSubfieldOrderAuthMax% = 1
    With gblaSubfieldOrderAuth(1)
        .Last = 1
        ReDim .Order(0 To 1)
        .Order(1).Type = SFDORDER_SegmentRandom%
    End With
    
    ReDim gblaSubfieldOrderOther(0 To 1)
    gbliSubfieldOrderOtherLast% = 1
    gbliSubfieldOrderOtherMax% = 1
    With gblaSubfieldOrderOther(1)
        .Last = 1
        ReDim .Order(0 To 1)
        .Order(1).Type = SFDORDER_SegmentRandom%
    End With
    
    ReDim gblaSubfieldOrderBib(0 To 1)
    gbliSubfieldOrderBibLast% = 1
    gbliSubfieldOrderBibMax% = 1
    With gblaSubfieldOrderBib(1)
        .Last = 1
        ReDim .Order(0 To 1)
        .Order(1).Type = SFDORDER_SegmentRandom%
    End With
    
    ReDim gblaSubfieldOrderHold(0 To 1)
    gbliSubfieldOrderHoldLast% = 1
    gbliSubfieldOrderHoldMax% = 1
    With gblaSubfieldOrderHold(1)
        .Last = 1
        ReDim .Order(0 To 1)
        .Order(1).Type = SFDORDER_SegmentRandom%
    End With
#End If

End Sub

Private Sub DigestSubfieldText(ByVal lArrayPointer As Long, ByVal sField$)

    ' 20081024: change first parameter from the array element itself, to
    '   the array pointer; and below we'll deal with the fallout
    ' former first parameter: ByRef aArrayElement As MarcField
    
    Dim sSfc$, sSfd$, sNextSfc$
    
    Dim iRc%, iSubfieldOrder%
    
    Dim b010 As Boolean, bDebug As Boolean
    
    
#If DigestSfdTextDebug = -1 Then
    If MarcArray(lArrayPointer).Tag = "411" Then
        Debug.Print "DIGEST SUBFIELD TEXT ENTRY >" + sField$
        Debug.Print vbTab + CharToHex(sField$)
    End If
    If InStr("245 440", MarcArray(lArrayPointer).Tag) > 0 Then
        bDebug = True
    End If
#End If

    ' make sure there aren't any subfields in here already
    MarcArray(lArrayPointer).FirstSubfield = -1
    MarcArray(lArrayPointer).LastSubfield = -1
    MarcArray(lArrayPointer).SubfieldLast = -1
    
    ' 20050218: for all variable fields higher than 010, we're going to
    '   trim spaces fore and aft
    If FldTag < "011" Then
        b010 = True
    End If
#If DigestSfdTextDebug = -1 Then
    Debug.Print "010? " + str(b010)
#End If
    
    ' if this is a control field, then add the text as the
    '   first "subfield" and leave it at that
    If MarcArray(lArrayPointer).IsControl Then
        gblbInternalSfdAdd = True
        SfdAdd "", sField$
        gblbInternalSfdAdd = False
        Exit Sub
    End If
    
    'find the first subfield code
    iRc% = InStr(sField$, MyMarcCharacter.MarcDelimiter)
    If iRc% > 0 Then
        sSfc$ = Mid(sField$, iRc% + 1, 1)
        ' 20040615: DO NOT trim spaces from the field text
        ' 20050218: actually, it's OK except in case of the 010
        If b010 Then
            sField$ = Mid(sField$, iRc% + 2)
        Else
            sField$ = Trim(Mid(sField$, iRc% + 2))
        End If
        Do ' for each subfield in the field
            iRc% = InStr(sField$, MyMarcCharacter.MarcDelimiter)
            If iRc% > 0 Then
                If b010 Then
                    sNextSfc$ = Mid(sField$, iRc% + 1, 1)
                    sSfd$ = Mid(sField$, 1, iRc% - 1)
                    sField$ = Mid(sField$, iRc% + 2)
                Else
                    sNextSfc$ = Trim(Mid(sField$, iRc% + 1, 1))
                    sSfd$ = Trim(Mid(sField$, 1, iRc% - 1))
                    sField$ = Trim(Mid(sField$, iRc% + 2))
                End If
            Else
                sSfd$ = sField$
                sField$ = ""
            End If
#If ResetCurrentFieldDebug = -1 Then
            Debug.Print "Adding one sfd: >" + sSfc$ + "< >" + sSfd$ + "< " + CharToHex(sSfd$)
#ElseIf DigestSfdTextDebug = -1 Then
            Debug.Print "Adding one sfd: >" + sSfc$ + "< >" + sSfd$ + "< " + CharToHex(sSfd$)
#End If
            gblbInternalSfdAdd = True
            SfdAdd sSfc$, sSfd$
            gblbInternalSfdAdd = False
            If Len(sField$) = 0 Then
                Exit Do
            End If
            sSfc$ = sNextSfc$
        Loop
    End If
    
End Sub

Public Sub SfdAdd(ByVal sSubfieldCode$, ByVal sSubfieldText$)

    ' add a new subfield to the current field
    
    Dim iNextSubfield%, iPrevSubfield%, iCurrent%, iFormerSfdLast%
    Dim iCtr%, iCtr2%, iSortGroup%, iSortInstruction%, iRc%, iMatchesFound%, iGroup%
    Dim iPtr%, iPtr2%
    
    Dim sSfdCodeString$, sScheme$, sPreviousSfc$, sT$, sI$, sF$, s5$, sSfd$, sJunk$, sIndicators$
    Dim sHPunct$, sSortingExtension$
    
    Dim bTPresent As Boolean, bDebug As Boolean, bLocal As Boolean, bTPresentBefore As Boolean
    
    Static bBusy As Boolean
    
    
    ' 20081023: if we're adding 245 $h, use the special routine instead
    ' 20081101: but don't do this if we have anything that even vaguely
    '   resembles proper punctuation already
    ' 20081101: the very best thing would be for us to "know" that we're
    '   arriving here via the outside world, or via an internal call
    '   (from FldAdd or ResetCurrentField or whatever)
    ' 20081101: on third thought, we're going to take this out
    '   altogether
    'If FldTag = "245" Then
        'If sSubfieldCode$ = "h" Then
            'If SfdFindFirst("b") Or SfdFindFirst("c") Then
            'If InStr(sSubfieldText$, "[") = 0 And InStr(sSubfieldText$, "]") = 0 Then
                'If Len(NormString(Right(Trim(sSubfieldText$), 1))) > 0 Then
                    ' ends in some alphabetic or numeric character: must be text, rather
                    '   than punctuation; so add the $h using our "smart" routine
                    'FldInsertSubfieldH sSubfieldText$
                    'Exit Sub
                'End If
            'End If
        'End If
    'End If
    
    If sSubfieldCode$ = "6" And Not bBusy And Not gblbInternalSfdAdd Then
        ' 20100207: existing logic does not work
        ' we want to add the subfield and change the sorting extension without
        '   doing anything else--especially without changing the order of fields
#If True Then
        With MarcArray(FldPointer)
            sSortingExtension$ = SetFieldSortGroupFromTag(.Tag, .Ind, FldText)
            iRc% = InStr(sSortingExtension$, prvsSortExtensionMarker$)
            If iRc% > 0 Then ' it better be!
                MarcArray(FldPointer).SortInstructionExtension = Mid(sSortingExtension$, iRc%)
            End If
        End With
#Else
        bBusy = True
        FldDelete
        FldAdd FldTag, FldInd, MarcDelimiter + sSubfieldCode$ + sSubfieldText$ + FldText
        bBusy = False
#End If
        Exit Sub
    End If
    
#If SfdAddDebug = -1 Then
    If InStr("245 440 410 411", FldTag) > 0 Then
        Debug.Print "SFD ADD ENTRY with " + sSubfieldText$
        Debug.Print vbTab + CharToHex(sSubfieldText$)
        bDebug = True
    End If
#End If

    ' 20050923: if the subfield code is 'blank' then
    '   force to a "legal" value
    If sSubfieldCode$ = " " Or Len(sSubfieldCode$) <> 1 Then
        sSubfieldCode$ = "9"
        If Mid(FldTag, 1, 2) <> "00" Then
#If MarcRecordModifiedDebug = -1 Then
            Debug.Print "MRM sfd add >" + sSubfieldCode$ + ":" + sSubfieldText$ + "<"
#End If
            m_bMarcRecordModified = True
        End If
    End If
    
#If SfdAddDebug = -1 Then
    If bDebug Then
        Debug.Print "SfdAdd: " + FldTag + ":" + FldInd + " >" + sSubfieldCode$ + "< >" + sSubfieldText$ + "< " + str(MarcArray(FldPointer).IsControl)
        iRc% = Val(Mid(MarcArray(FldPointer).SortInstruction, 1, 3))
        Debug.Print "Field sort group: " + str(iRc%) + " full instruction: >" + MarcArray(FldPointer).SortInstruction + "< >" + MarcArray(FldPointer).SortInstructionExtension + "<"
        If MarcRecordFormat = "A" Then
            Debug.Print "Instruction: " + str(gblaFieldOrderAuth(iRc%).SortInstruction)
        End If
    End If
#End If

    ' 20051102: if the outside world is asking us to add subfield $5 to an
    '   existing field, then remember this for just a bit later on
    If MarcRecordFormat = "A" And sSubfieldCode$ = "5" Then
        iRc% = Val(Mid(MarcArray(FldPointer).SortInstruction, 1, 3))
        If gblaFieldOrderAuth(iRc%).SortInstruction = 4 Then
            bLocal = True
        End If
    End If

    ' if this is a control field (for which there are no
    '   subfields) we are obviously replacing the entire
    '   field text
    If MarcArray(FldPointer).IsControl Then
        If MarcArray(FldPointer).SubfieldLast > -1 Then
            MarcArray(FldPointer).Changed = True
            MarcArray(FldPointer).Subfield(1).Text = sSubfieldText$
            MarcArray(FldPointer).Subfield(1).NormNaco = NormString(sSubfieldText$, True)
            MarcArray(FldPointer).Subfield(1).Norm = NormString(sSubfieldText$, True)
            Exit Sub
        End If
    End If

#If SfdAddDebug = -1 Then
    If bDebug Then
        Debug.Print "Sfd last: " + str(MarcArray(FldPointer).SubfieldLast)
    End If
#End If
    ' to simplify matters, we're going to handle in this routine ONLY the cases in which
    '   we don't have any subfields at all yet
    ' if we do have a subfield already, we're going to move
    '   to the last subfield and use the "insert after" routine
    '   for the new subfield
    If MarcArray(FldPointer).SubfieldLast > -1 Then
        MarcArray(FldPointer).Changed = True
        SfdMoveLast
        SfdInsertAfter sSubfieldCode$, sSubfieldText$
        ' 20051102: if the outside world has asked us to add
        '   subfield $5 to an existing field that is ordered
        '   by a rule that considers local $5 to be important ...
        If bLocal And Not gblbInternalSfdAdd Then
            ' see if the new subfield is a local subfield
            If Len(m_sNuc$) > 0 Then
                s5$ = sSubfieldText$
                sSfd$ = "(" + s5$ + ")"
                iRc% = InStr(s5$, MarcDelimiter)
                If iRc% > 0 Then
                    s5$ = Trim(Mid(s5$, 1, iRc% - 1))
                End If
                If iRc% > 0 Then
                    s5$ = Mid(s5$, 1, iRc% - 1)
                End If
                If InStr(m_sNuc$, "(" + s5$) > 0 Then
                    ' the outside world is adding $5 with a local code to a field
                    '   sorted by local $5; the easy way to force this field into
                    '   the correct position (which may or may not be the
                    '   current position) is to delete the existing field
                    '   and re-add it
SfdAdd_DeleteAndReAddForLocalSorting:
                    FldLoadInfo sT$, sI$, sF$
                    FldDelete
                    FldAdd sT$, sI$, sF$
                ElseIf InStr(m_sLocalNucString$, MarcDelimiter + "5" + s5$) > 0 Then
                    GoTo SfdAdd_DeleteAndReAddForLocalSorting
                End If
            End If
        End If
    
#If SfdAddDebug = -1 Then
        If FldTag = "049" And bDebug Then
            Debug.Print "Dump for 049 field"
            DumpArray
        End If
#End If
        Exit Sub
    End If
    
    
    ' if we get here, we're adding the first subfield in the field
    
    
    sScheme$ = NormalizationScheme
    
    With MarcArray(FldPointer)
#If WithDebug = -1 Then
        PushWith "SfdAdd 1"
#End If
        iFormerSfdLast% = .SubfieldLast
        
        ' add a new element to the array of subfields
        .SubfieldLast = .SubfieldLast + 1
        If .SubfieldLast > .SubfieldMax Or .SubfieldMax = 0 Then
            .SubfieldMax = .SubfieldMax + 5
            ReDim Preserve .Subfield(0 To .SubfieldMax)
        End If
        
#If WithDebug = -1 Then
        PopWith "SfdAdd 1"
#End If
    End With
    
    SetSfdSortGroupFromCode sSubfieldCode$, iSortGroup%, iSortInstruction%, sSfdCodeString$, iMatchesFound%, bTPresentBefore
        
    ' fill the new array element with your data
    With MarcArray(FldPointer).Subfield(MarcArray(FldPointer).SubfieldLast)
#If WithDebug = -1 Then
        PushWith "SfdAdd 2"
#End If
        .SortGroup = iSortGroup%
        .SortInstruction = iSortInstruction%
        .SortString = sSfdCodeString$
        .Deleted = False
        .Code = sSubfieldCode$
        If MarcArray(FldPointer).IsControl Then
            .Text = sSubfieldText$
        Else
            .Text = sSubfieldText$
        End If
#If SfdAddDebug = -1 Then
        If bDebug Then
            Debug.Print "Set .Text as : " + .Text
            Debug.Print vbTab + CharToHex(.Text)
        End If
#End If
        
        If .Code = "a" Then
            sIndicators$ = MarcArray(FldPointer).Ind
            If GetLeaderValue(6, 1) = "z" Then
                sSubfieldText$ = RemoveNonfilingCharacters("A", MarcArray(FldPointer).Tag, sIndicators$, sSubfieldText$)
            Else
                sSubfieldText$ = RemoveNonfilingCharacters("B", MarcArray(FldPointer).Tag, sIndicators$, sSubfieldText$)
            End If
        End If
        NormalizationScheme = NORMALIZATIONSCHEME_Voyager$
        .Norm = NormString(sSubfieldText$)
        
        NormalizationScheme = NORMALIZATIONSCHEME_Pcc$
        If sSubfieldCode$ = "a" Then
            iRc% = InStr(sSubfieldText$, ",")
            If iRc% = 0 Then
                .NormNaco = NormString(sSubfieldText$)
            ElseIf iRc% > 0 And iRc% = Len(sSubfieldText$) Then
                .NormNaco = NormString(sSubfieldText$)
            Else
                .NormNaco = NormString(Mid(sSubfieldText$, 1, iRc% - 1)) + ", " + NormString(Mid(sSubfieldText$, iRc% + 1))
            End If
        Else
            .NormNaco = NormString(.Text)
        End If
        
        ' use dummy values for these two (but see just below)
        .NextSubfield = -1
        .PrevSubfield = -1
#If WithDebug = -1 Then
        PopWith "SfdAdd 2"
#End If
    End With
    
        
    ' special test: if this is the first and only subfield
    '   in the array so far, then the setting of 'first' and 'last' is
    '   a simple matter
    ' recall that .SubfieldLast has already been incremented from its
    '   default of -1 above; so if it's zero, we have one element in
    '   the array
    ' 20040604: since we're only handling in this routine the case in which
    '   the new subfield is also the first subfield, then none of this
    '   other stuff is even necessary; let's comment it out
    If MarcArray(FldPointer).SubfieldLast = 0 Then ' this is the first subfield
        With MarcArray(FldPointer)
#If WithDebug = -1 Then
            PushWith "SfdAdd 3"
#End If
            .FirstSubfield = 0
            .LastSubfield = 0
#If WithDebug = -1 Then
            PopWith "SfdAdd 3"
#End If
        End With
        SfdPointer = 0
    Else ' new subfield is not the only subfield
    
        With MarcArray(FldPointer)
#If WithDebug = -1 Then
            PushWith "SfdAdd 4"
#End If
            ' save the code of the previous subfield in case you need it
            sPreviousSfc$ = .Subfield(.LastSubfield).Code
            ' assume that the current subfield is in the correct place, at
            '   the end of the field
            '.Subfield(.LastSubfield) is the previously-last subfield; its
            '   next subfield is the new subfield
            .Subfield(.LastSubfield).NextSubfield = .SubfieldLast
            '.Subfield(.SubfieldLast) is the newly-added
            '   subfield; its previous is the previously-last subfield
            .Subfield(.SubfieldLast).PrevSubfield = .LastSubfield
            ' ... it has no next subfield
            .Subfield(.SubfieldLast).NextSubfield = -1
            ' the newly-added subfield is now the last subfield
            '   in the field
            .LastSubfield = .SubfieldLast
#If WithDebug = -1 Then
            PopWith "SfdAdd 4"
#End If
        End With
        
        ' test this subfield location, and shift this subfield until
        '   it's in the right place
        Do
            Select Case TestSubfieldPosition(MarcArray(FldPointer).Subfield(), MarcArray(FldPointer).LastSubfield)
                Case SUBFIELDPOSITION_OK%
                    Exit Do
                Case SUBFIELDPOSITION_MoveUp%
                    If MarcArray(FldPointer).Subfield(MarcArray(FldPointer).LastSubfield).PrevSubfield < 0 Then
                        Exit Do
                    End If
                    If TestSubfieldOrder And Not MakeNoChange Then
                        SfdShiftLeft
                        ' 20080801: here and elsewhere: do not report any problem if we're
                        '   shifting the position of subfield $w
                        If SfdCode <> "w" Then
                            m_bSfdOrderChanged = True
                            If InStr(m_sFieldsWithSubfieldsOutOfOrder$, MarcArray(FldPointer).Tag) = 0 Then
                                m_sFieldsWithSubfieldsOutOfOrder$ = m_sFieldsWithSubfieldsOutOfOrder$ + " " + MarcArray(FldPointer).Tag
                            End If
                        End If
                    Else
                        If SfdCode <> "w" Then
                            m_bSubfieldsOutOfOrder = True
                            If InStr(m_sFieldsWithSubfieldsOutOfOrder$, MarcArray(FldPointer).Tag) = 0 Then
                                m_sFieldsWithSubfieldsOutOfOrder$ = m_sFieldsWithSubfieldsOutOfOrder$ + " " + MarcArray(FldPointer).Tag
                            End If
                        End If
                    End If
                Case SUBFIELDPOSITION_MoveDown%
                    If MarcArray(FldPointer).Subfield(MarcArray(FldPointer).LastSubfield).NextSubfield < 0 Then
                        Exit Do
                    End If
                    If TestSubfieldOrder And Not MakeNoChange Then
                        SfdShiftRight
                        If SfdCode <> "w" Then
                            m_bSfdOrderChanged = True
                            If InStr(m_sFieldsWithSubfieldsOutOfOrder$, MarcArray(FldPointer).Tag) = 0 Then
                                m_sFieldsWithSubfieldsOutOfOrder$ = m_sFieldsWithSubfieldsOutOfOrder$ + " " + MarcArray(FldPointer).Tag
                            End If
                        End If
                    Else
                        If SfdCode <> "w" Then
                            m_bSubfieldsOutOfOrder = True
                            If InStr(m_sFieldsWithSubfieldsOutOfOrder$, MarcArray(FldPointer).Tag) = 0 Then
                                m_sFieldsWithSubfieldsOutOfOrder$ = m_sFieldsWithSubfieldsOutOfOrder$ + " " + MarcArray(FldPointer).Tag
                            End If
                        End If
                    End If
                Case Else
#If SfdAddDebug = -1 Then
                    If bDebug Then
                        Debug.Print "SA Else"
                    End If
#End If
            End Select
        Loop
        
    End If ' is this the first subfield to be added, or some subfield other than the first one?
'#End If

    NormalizationScheme = sScheme$
    

#If SfdAddDebug = -1 Then
    If bDebug Then
        Debug.Print "SfdAdd exit: >" + MarcArray(FldPointer).Subfield(MarcArray(FldPointer).SubfieldLast).Text
        Debug.Print vbTab + CharToHex(MarcArray(FldPointer).Subfield(MarcArray(FldPointer).SubfieldLast).Text)
    End If
#End If

End Sub

Private Sub SetSfdSortGroupFromCode(ByVal sSubfieldCode$, ByRef iSortGroup%, ByRef iSortInstruction%, ByRef sSfdCodeString$, ByRef iMatchesFound%, ByRef bTPresentBefore As Boolean)

    ' return the subfield sorting group (pointer into the subfield-sorting array) and
    '   the sorting instruction code (the method to be appllied to that group in
    '   the array) for some supplied MARC subfield
    
    ' 20030707: we're going to drop this whole idea--if the container program wants to
    '   add subfields in the "wrong" order, then it can also pass the finished record
    '   to ValidIt
    ' in order to maintain existing code without change, we're going to supply
    '   return values that will cause new subfields to come at the end of
    '   fields and that's as fancy as we're going to get
    
    ' 20040728: added argument bTPresentBefore so we can find proper
    '   sorting point for certain subfields
    
    Dim iReturn%, iCtr%, iFirstFind%
    
    Dim bWorryAboutT As Boolean
    
    iSortGroup% = 1
    iSortInstruction% = SORTINSTRUCTION_Generic%
    iMatchesFound% = 0
    
    ' 20060526: ignore subfield order added; we return the generic
    '   default parameters set just above
    If IgnoreSfdOrder Then
        Exit Sub
    End If
    
    With gblaSfdOrder

        If InStr(.Duplicates, sSubfieldCode$) > 0 Then
            bWorryAboutT = True
        End If
        
        For iCtr% = 1 To .Last
            If InStr(.Order(iCtr%).Sfds, sSubfieldCode$) > 0 Then
                ' if this is a subfield that can appear either
                '   before or after $t ...
                If bWorryAboutT Then
                    ' if the field to which we're adding a new subfield
                    '   contains subfield $t to the left of the
                    '   current subfield ...
                    If bTPresentBefore Then
                        ' if this group does NOT contain $t, then it's the
                        '   first group in the string that contains the
                        '   ambiguous subfields, and it's not the group
                        '   we're looking for
                        If InStr(.Order(iCtr%).Sfds, "t") = 0 Then
                            iFirstFind% = iCtr%
                            GoTo SetSfdSortGroupFromCodeContinue
                        'Else
                            ' this is the group that contains $t; and since
                            '   we have $t to the left of the subfield in question,
                            '   this must be the right group for our subfield; continue
                            '   as below
                        End If
                    'Else
                        ' subfield $t does not appear in the heading to the left of
                        '   the new subfield: the group we've just found is the right one
                    End If
                'Else
                    ' the subfield we're dealing with is not an ambiguous subfield, so
                    '   we'll take the first match we find
                End If
                iMatchesFound% = iMatchesFound% + 1
                If iMatchesFound% = 1 Then
                    sSfdCodeString$ = .Order(iCtr%).Sfds
                    iSortGroup% = iCtr%
                    iSortInstruction% = .Order(iCtr%).Type
                End If
            End If
SetSfdSortGroupFromCodeContinue:
        Next
        If iMatchesFound% = 0 And iFirstFind% > 0 Then
            sSfdCodeString$ = .Order(iFirstFind%).Sfds
            iSortGroup% = iFirstFind%
            iSortInstruction% = .Order(iFirstFind%).Type
        End If
    End With
    
    
#If False Then
    Select Case m_sRecordFormat$
        Case "A"
            With gblaSubfieldOrderAuth(MarcArray(FldPointer).SubfieldOrderPointer)
                For iCtr% = 1 To .Last
                    If InStr(.Order(iCtr%).Sfds, sSubfieldCode$) > 0 Then
                        iMatchesFound% = iMatchesFound% + 1
                        If iMatchesFound% = 1 Then
                            sSfdCodeString$ = .Order(iCtr%).Sfds
                            iSortGroup% = iCtr%
                            iSortInstruction% = .Order(iCtr%).Type
                        End If
                    End If
                Next
            End With
        Case "H"
            With gblaSubfieldOrderHold(MarcArray(FldPointer).SubfieldOrderPointer)
                For iCtr% = 1 To .Last
                    If InStr(.Order(iCtr%).Sfds, sSubfieldCode$) > 0 Then
                        iMatchesFound% = iMatchesFound% + 1
                        If iMatchesFound% = 1 Then
                            sSfdCodeString$ = .Order(iCtr%).Sfds
                            iSortGroup% = iCtr%
                            iSortInstruction% = .Order(iCtr%).Type
                        End If
                    End If
                Next
            End With
        Case Else ' "B", "D", "F", "M", "P", "S", "U"
            With gblaSubfieldOrderBib(MarcArray(FldPointer).SubfieldOrderPointer)
                For iCtr% = 1 To .Last
                    'Debug.Print "Comparing >" + sSubfieldCode$ + "< >" + .Order(iCtr%).Sfds + "<"
                    If InStr(.Order(iCtr%).Sfds, sSubfieldCode$) > 0 Then
                        iMatchesFound% = iMatchesFound% + 1
                        If iMatchesFound% = 1 Then
                            sSfdCodeString$ = .Order(iCtr%).Sfds
                            iSortGroup% = iCtr%
                            iSortInstruction% = .Order(iCtr%).Type
                        End If
                    End If
                Next
            End With
    End Select
#End If

End Sub

Public Function SfdFindFirst(ByVal sSubfieldCode$, Optional ByVal sNormalizedSubfieldText$ = "") As Boolean

    ' 20040614: add optional ability to specify the normalized text of
    '   the subfield, too
    
    
    Dim bText As Boolean
    
    SfdFindFirst = False
    
    m_bSfdAtTop = False
    m_bSfdAtBottom = False
    
    m_sSubfieldTextWanted$ = NormString(sNormalizedSubfieldText$)
    If Len(m_sSubfieldTextWanted$) > 0 Then
        bText = True
    End If
    
    If Len(sSubfieldCode$) > 0 Then
        m_sSubfieldWanted$ = sSubfieldCode$ ' Mid(Trim(sSubfieldCode$), 1, 1)
    ElseIf Len(m_sSubfieldWanted$) = 0 Or Not FldWasFound Then
        Exit Function
    End If
    
    SfdMoveFirst
    While SfdWasFound
        If Not SfdDeleted Then
            If InStr(m_sSubfieldWanted$, SfdCode) > 0 Then
                If bText Then
                    If Mid(SfdNorm, 1, Len(m_sSubfieldTextWanted$)) = m_sSubfieldTextWanted$ Then
                        SfdFindFirst = True
                        Exit Function
                    End If
                Else
                    SfdFindFirst = True
                    Exit Function
                End If
            End If
        End If
        SfdMoveNext
    Wend
    
    SfdPointer = -1
    
End Function

Public Property Get SfdCode() As String

    If FldPointer > -1 And SfdPointer > -1 And Not m_bSfdAtTop Then
        SfdCode = MarcArray(FldPointer).Subfield(SfdPointer).Code
    Else
        SfdCode = ""
    End If

End Property

Public Property Let SfdCode(ByVal vNewValue As String)

    If FldPointer > -1 And SfdPointer > -1 Then
        SfdChange vNewValue, SfdText
    End If

End Property

Public Property Get SfdText() As String

    If FldPointer > -1 And SfdPointer > -1 And Not m_bSfdAtTop Then
        SfdText = MarcArray(FldPointer).Subfield(SfdPointer).Text
    Else
        SfdText = ""
    End If
    
End Property

Public Property Let SfdText(ByVal vNewValue As String)
    
#If ResetCurrentFieldDebug = -1 Then
    Debug.Print "SfdText: >" + vNewValue + "< " + str(FldPointer) + " " + str(SfdPointer) + " >" + SfdCode + "<"
#End If

    If FldPointer > -1 And SfdPointer > -1 Then
        If Mid(vNewValue, 1, 1) = MyMarcCharacter.MarcDelimiter Then
            SfdChange Mid(vNewValue, 2, 1), Mid(vNewValue, 3)
        Else
            SfdChange SfdCode, vNewValue
        End If
    End If

End Property

Public Property Get SfdNorm() As String

    If FldPointer > -1 And SfdPointer > -1 Then
        SfdNorm = MarcArray(FldPointer).Subfield(SfdPointer).Norm
    Else
        SfdNorm = ""
    End If

End Property


Public Property Get SfdNormNaco() As String

    If FldPointer > -1 And SfdPointer > -1 Then
        SfdNormNaco = MarcArray(FldPointer).Subfield(SfdPointer).NormNaco
    Else
        SfdNormNaco = ""
    End If

End Property


Private Property Get FldNext() As Integer

    If FldPointer > -1 Then
        On Error GoTo FldNextError
        FldNext = MarcArray(FldPointer).NextField
        On Error GoTo 0
    Else
        FldNext = -1
    End If

FldNextErrorResume:
    Exit Property
    
FldNextError:
    Debug.Print "Error 2!!! " + Error(Err)
    On Error GoTo 0
    DumpArray
    FldNext = -1
    Resume FldNextErrorResume
End Property


Public Sub SfdChange(ByVal sSubfieldCode$, ByVal sSubfieldText$)

    Dim iRc%
    
    Dim sField$
    
    If FldIsControl Then
        Exit Sub
    End If
    

    If FldPointer > -1 Then
        If SfdPointer > -1 Then
            With MarcArray(FldPointer)
#If WithDebug = -1 Then
                PushWith "SfdChange"
#End If
                ' assemble a fresh copy of the field's text: WITHOUT trimming anything!!!
                ' NOTE that we do not simply use FldText here
                .Subfield(SfdPointer).Code = sSubfieldCode$
                If .Tag <> "010" Then
                    .Subfield(SfdPointer).Text = Trim(sSubfieldText$)
                Else
                    .Subfield(SfdPointer).Text = sSubfieldText$
                End If
                iRc% = .FirstSubfield
                Do
                    If iRc% < 0 Then
                        Exit Do
                    End If
                    If Not .Subfield(iRc%).Deleted Then
                        sField$ = sField$ + MyMarcCharacter.MarcDelimiter + .Subfield(iRc%).Code + .Subfield(iRc%).Text
                    End If
                    iRc% = .Subfield(iRc%).NextSubfield
                Loop
#If WithDebug = -1 Then
                PopWith "SfdChange"
#End If
            End With
            ' and reset the whole field text, with all that this entails (including
            '   field-order stuff) being handled automatically
            ResetCurrentField MarcArray(FldPointer).Tag, MarcArray(FldPointer).Ind, sField$
        End If
    End If
    
End Sub

Public Function SfdFindNext(Optional ByVal sSubfieldCode$ = "", Optional ByVal sNormalizedSubfieldText$ = "") As Boolean

    ' 20040614: add optional ability to specify the normalized text of
    '   the subfield, too

    Dim sCode$

    Dim bText As Boolean
    
    
    SfdFindNext = False
    
    m_bSfdAtTop = False
    m_bSfdAtBottom = False
    
    If Len(sNormalizedSubfieldText$) > 0 Then
        m_sSubfieldTextWanted$ = NormString(sNormalizedSubfieldText$)
        If Len(m_sSubfieldTextWanted$) > 0 Then
            bText = True
        End If
    End If
    
    If Len(sSubfieldCode$) > 0 Then
        m_sSubfieldWanted$ = sSubfieldCode$ ' Mid(Trim(sSubfieldCode$), 1, 1)
        If Len(sSubfieldCode$) = 0 Then
            Exit Function
        End If
    ElseIf Len(m_sSubfieldWanted$) = 0 Or Not FldWasFound Then
        Exit Function
    End If
    
    While SfdMoveNext
        If Not SfdDeleted Then
            If InStr(m_sSubfieldWanted$, SfdCode) > 0 Then
                If bText Then
                    If Mid(SfdNorm, 1, Len(m_sSubfieldTextWanted$)) = m_sSubfieldTextWanted$ Then
                        SfdFindNext = True
                        Exit Function
                    End If
                Else
                    SfdFindNext = True
                    Exit Function
                End If
            End If
        End If
    Wend

    SfdPointer = -1
    
End Function

Public Function SfdMoveFirst() As Boolean

    If FldPointer > 0 Then
        SfdPointer = MarcArray(FldPointer).FirstSubfield
        SfdMoveFirst = True
    Else
        SfdPointer = -1
        SfdMoveFirst = False
    End If
    
    m_bSfdAtTop = False
    m_bSfdAtBottom = False
    
End Function

Public Function SfdMoveLast() As Boolean

    If FldPointer > -1 Then
        SfdPointer = MarcArray(FldPointer).LastSubfield
    Else
        SfdPointer = -1
    End If

    m_bSfdAtTop = False
    m_bSfdAtBottom = False

    SfdMoveLast = m_bSfdWasFound
    
End Function

Public Function SfdMoveNext() As Boolean

    If FldPointer > 0 And SfdPointer > -1 Then
        If m_bSfdAtTop Then
            SfdPointer = MarcArray(FldPointer).FirstSubfield
        Else
            'Debug.Print "SETTING SFDPOINTER TO " + str(SfdNext)
            SfdPointer = SfdNext
        End If
    Else
        SfdPointer = -1
    End If

    m_bSfdAtTop = False
    m_bSfdAtBottom = False

    SfdMoveNext = SfdWasFound

End Function

Public Function SfdMovePrev() As Boolean

    If FldPointer > 0 And SfdPointer > -1 Then
        If m_bSfdAtBottom Then
            SfdPointer = MarcArray(FldPointer).LastSubfield
        Else
            SfdPointer = SfdPrevious
        End If
    Else
        SfdPointer = -1
    End If

    m_bSfdAtTop = False
    m_bSfdAtBottom = False

    SfdMovePrev = SfdWasFound
    
End Function

Public Sub SfdDelete()
    
    Dim iSave%, iSavePrevious%
    
    Dim s245HPunctuation$
    
    Dim lSavedSubfieldPointer As Long
    
    If FldPointer < 0 Or SfdPointer < 0 Then
        Exit Sub
    End If
    
    ' 20081023: allowance made for deleting 245 $h: transfer
    '   punctuation to the preceding subfield (if any!)
    
    If MarcArray(FldPointer).Tag = "245" Then
        If MarcArray(FldPointer).Subfield(SfdPointer).Code = "h" Then
            ' before we delete the 245 $h, we need to save any
            '   punctuation that follows the $h text, so we can
            '   transfer it to the preceding subfield
            iSave% = Rat(MarcArray(FldPointer).Subfield(SfdPointer).Text, "]")
            If iSave% > 0 Then
                s245HPunctuation$ = Mid(MarcArray(FldPointer).Subfield(SfdPointer).Text, iSave% + 1)
            End If
        End If
    End If
    
    MarcArray(FldPointer).Subfield(SfdPointer).Deleted = True

    MarcArray(FldPointer).Changed = True

    If Len(s245HPunctuation$) > 0 Then
        lSavedSubfieldPointer = SfdPointer
        If SfdMovePrev Then
            SfdText = SfdText + s245HPunctuation$
        End If
        SfdPointer = lSavedSubfieldPointer
    End If

End Sub

Private Property Get SfdNext() As Integer

    If FldPointer > -1 And SfdPointer > -1 Then
        SfdNext = MarcArray(FldPointer).Subfield(SfdPointer).NextSubfield
    Else
        SfdNext = -1
    End If
    
End Property

Private Property Get SfdPrevious() As Integer

    If FldPointer > -1 And SfdPointer > -1 Then
        SfdPrevious = MarcArray(FldPointer).Subfield(SfdPointer).PrevSubfield
    Else
        SfdPrevious = -1
    End If


End Property


Public Sub FldShiftUp()

    Dim iCurrent%, iPrevious%, iCurrentsPrevioussNext%
    
    If FldPointer > -1 Then
        ' there must be some field before the current field
        If FldPrev < 0 Then
            Exit Sub
        End If
    Else
        Exit Sub
    End If
    
    iCurrent% = FldPointer
    iPrevious% = FldPrev
    
    ' the two fields must be part of the same group
    If MarcArray(iCurrent%).SortInstruction <> MarcArray(iPrevious%).SortInstruction Then
        Exit Sub
    End If
    
    ' they're part of the same group
    ' the subsidiary information must allow them to move, also
    Select Case MarcArray(iCurrent%).SortInstruction
        Case SORTINSTRUCTION_7XX%, SORTINSTRUCTION_Indicator2%, SORTINSTRUCTION_Local%, SORTINSTRUCTION_Reference%
            'If MarcArray(iCurrent%).SortInstructionSupplement <> MarcArray(iPrevious%).SortInstructionSupplement Then
            '    Exit Sub
            'End If
        Case SORTINSTRUCTION_Tag%
            If MarcArray(iCurrent%).Tag <> MarcArray(iPrevious%).Tag Then
                Exit Sub
            End If
        Case SORTINSTRUCTION_Generic%
            If Mid(MarcArray(iCurrent%).Tag, 1, 1) <> Mid(MarcArray(iPrevious%).Tag, 1, 1) Then
                Exit Sub
            End If
    End Select
    
    ' OK: if we get here then it's possible to move the field up one
    
    ' the 'next' pointer in the field previous to the previous field is now the current field
    MarcArray(MarcArray(iPrevious%).PrevField).NextField = iCurrent%
    ' the 'previous' pointer in the next field is now the previous field
    MarcArray(MarcArray(iCurrent%).NextField).PrevField = iPrevious%
    
    MarcArray(iPrevious%).NextField = MarcArray(iCurrent%).NextField
    MarcArray(iCurrent%).NextField = iPrevious%
    MarcArray(iCurrent%).PrevField = MarcArray(iPrevious%).PrevField
    MarcArray(iPrevious%).PrevField = iCurrent%

    ' we're leaving m_iFldPointer% still pointed at the field it was pointed at
    '   before
    
End Sub

Private Property Get FldPrev() As Long

    If FldPointer > -1 Then
        FldPrev = MarcArray(FldPointer).PrevField
    Else
        FldPrev = -1
    End If
    
End Property


Public Sub FldShiftDown()

    Dim iSave%
    
    If FldPointer > -1 Then
        ' there must be some field after the current field
        If FldNext < 0 Then
            Exit Sub
        End If
    Else
        Exit Sub
    End If
    
    ' move to the next field, and then move it up--same effect as moving
    '   the current field down, and we've already got the code ready to go
    iSave% = FldPointer
    FldMoveNext
    FldShiftUp
    FldPointer = iSave%
    
End Sub

Public Sub SfdShiftLeft()

    ' more-or-less equivalent to the FldShiftUp routine
    
    Dim iCurrent%, iPrevious%
    
    Dim bNext As Boolean, bPrevious As Boolean
    
    If FldPointer > -1 Then
        If SfdPointer < 0 Then
            Exit Sub
        End If
        iCurrent% = SfdPointer
        ' there must be some field before the current field
        If SfdPrevious < 0 Then
            Exit Sub
        End If
        iPrevious% = SfdPrevious
    Else
        Exit Sub
    End If
    
    ' OK: if we get here then it's possible to move the subfield one to the left
    
    With MarcArray(FldPointer)
#If WithDebug = -1 Then
        PushWith "SfdShiftLeft"
#End If
    
        If .Subfield(iCurrent%).NextSubfield > -1 Then
            .Subfield(.Subfield(iCurrent%).NextSubfield).PrevSubfield = iPrevious%
            If Not bPrevious Then
                If .Subfield(.Subfield(iCurrent%).NextSubfield).PrevSubfield = MarcArray(FldPointer).LastSubfield Then
                    MarcArray(FldPointer).LastSubfield = .Subfield(iCurrent%).NextSubfield
                End If
                bPrevious = True
            End If
        End If
        
        .Subfield(iCurrent%).PrevSubfield = .Subfield(iPrevious%).PrevSubfield
        If Not bPrevious Then
            If .Subfield(iCurrent%).PrevSubfield = MarcArray(FldPointer).LastSubfield Then
                MarcArray(FldPointer).LastSubfield = iCurrent%
                bPrevious = True
            End If
        End If
        
        If .Subfield(iPrevious%).PrevSubfield > -1 Then
            .Subfield(.Subfield(iPrevious%).PrevSubfield).NextSubfield = iCurrent%
            If Not bNext Then
                If .Subfield(.Subfield(iPrevious%).PrevSubfield).NextSubfield = MarcArray(FldPointer).FirstSubfield Then
                    MarcArray(FldPointer).FirstSubfield = .Subfield(iPrevious%).PrevSubfield
                    bNext = True
                End If
            End If
        End If
        
        .Subfield(iPrevious%).PrevSubfield = iCurrent%
        If Not bPrevious Then
            If .Subfield(iPrevious%).PrevSubfield = MarcArray(FldPointer).LastSubfield Then
                MarcArray(FldPointer).LastSubfield = iPrevious%
                bPrevious = True
            End If
        End If
        
        .Subfield(iPrevious%).NextSubfield = .Subfield(iCurrent%).NextSubfield
        If Not bNext Then
            If .Subfield(iPrevious%).NextSubfield = MarcArray(FldPointer).FirstSubfield Then
                MarcArray(FldPointer).FirstSubfield = iPrevious%
                bNext = True
            End If
        End If
        
        .Subfield(iCurrent%).NextSubfield = iPrevious%
        If Not bNext Then
            If .Subfield(iCurrent%).NextSubfield = MarcArray(FldPointer).FirstSubfield Then
                MarcArray(FldPointer).FirstSubfield = iCurrent%
                bNext = True
            End If
        End If
        
#If WithDebug = -1 Then
        PopWith "SfdShiftLeft"
#End If
    End With
        
    ' we're leaving m_iSfdPointer% still pointed at the subfield it was pointed at
    '   before
        
        
    If Not gblbSkipSubfieldOrderTest Then
        ' test this subfield location, and shift this subfield until
        '   it's in the right place
        Do
            Select Case TestSubfieldPosition(MarcArray(FldPointer).Subfield(), iCurrent%)
                Case SUBFIELDPOSITION_OK%
                    Exit Do
                Case SUBFIELDPOSITION_MoveUp%
                    If MarcArray(FldPointer).Subfield(MarcArray(FldPointer).LastSubfield).PrevSubfield < 0 Then
                        Exit Do
                    End If
                    gblbSkipSubfieldOrderTest = True
                    SfdShiftLeft
                Case SUBFIELDPOSITION_MoveDown%
                    If MarcArray(FldPointer).Subfield(MarcArray(FldPointer).LastSubfield).NextSubfield < 0 Then
                        Exit Do
                    End If
                    gblbSkipSubfieldOrderTest = True
                    ' in effect, we must undo the shift we just made
                    SfdShiftRight
                    Exit Do
            End Select
        Loop
    Else
        gblbSkipSubfieldOrderTest = False
    End If

End Sub

Public Sub SfdShiftRight()

    ' more-or-less equivalent to the FldShiftDown routine
    
    Dim iSave%, iCurrent%, iNext%
    
    Dim sCode$
    
    Dim bNext As Boolean, bPrevious As Boolean
    
    
    If FldPointer > -1 Then
        If SfdPointer < 0 Then
            Exit Sub
        End If
        iCurrent% = SfdPointer
        ' there must be some field after the current field
        If SfdNext < 0 Then
            Exit Sub
        End If
        iNext% = SfdNext
    Else
        Exit Sub
    End If
    
    ' OK: if we get here then it's possible to move the subfield one to the right (or one down)
    
    With MarcArray(FldPointer)
#If WithDebug = -1 Then
        PushWith "SfdShiftRight"
#End If
        If .Subfield(iCurrent%).PrevSubfield > -1 Then
            .Subfield(.Subfield(iCurrent%).PrevSubfield).NextSubfield = iNext%
            If Not bNext Then
                If .Subfield(.Subfield(iCurrent%).PrevSubfield).NextSubfield = MarcArray(FldPointer).FirstSubfield Then
                    MarcArray(FldPointer).FirstSubfield = .Subfield(iCurrent%).PrevSubfield
                    bNext = True
                End If
            End If
        End If
        
        .Subfield(iCurrent%).NextSubfield = .Subfield(iNext%).NextSubfield
        If Not bNext Then
            If .Subfield(iCurrent%).NextSubfield = MarcArray(FldPointer).FirstSubfield Then
                MarcArray(FldPointer).FirstSubfield = iCurrent%
                bNext = True
            End If
        End If
        
        If .Subfield(iNext%).NextSubfield > -1 Then
            .Subfield(.Subfield(iNext%).NextSubfield).PrevSubfield = iCurrent%
            If Not bPrevious Then
                If .Subfield(.Subfield(iNext%).NextSubfield).PrevSubfield = MarcArray(FldPointer).LastSubfield Then
                    MarcArray(FldPointer).LastSubfield = .Subfield(iNext%).NextSubfield
                    bPrevious = True
                End If
            End If
        End If
        
        .Subfield(iNext%).NextSubfield = iCurrent%
        If Not bNext Then
            If .Subfield(iNext%).NextSubfield = MarcArray(FldPointer).FirstSubfield Then
                MarcArray(FldPointer).FirstSubfield = iNext%
                bNext = True
            End If
        End If
        
        .Subfield(iNext%).PrevSubfield = .Subfield(iCurrent%).PrevSubfield
        If Not bPrevious Then
            If .Subfield(iNext%).PrevSubfield = MarcArray(FldPointer).LastSubfield Then
                MarcArray(FldPointer).LastSubfield = iNext%
                bPrevious = True
            End If
        End If
        
        
        .Subfield(iCurrent%).PrevSubfield = iNext%
        If Not bPrevious Then
            If .Subfield(iCurrent%).PrevSubfield = MarcArray(FldPointer).LastSubfield Then
                MarcArray(FldPointer).LastSubfield = iCurrent%
                bPrevious = True
            End If
        End If
    
#If WithDebug = -1 Then
        PopWith "SfdShiftRight"
#End If
    End With
    
    ' m_iSfdPointer continues to point to the same subfield as before
    
    If Not gblbSkipSubfieldOrderTest Then
        ' test this subfield location, and shift this subfield until
        '   it's in the right place
        Do
            Select Case TestSubfieldPosition(MarcArray(FldPointer).Subfield(), iCurrent%)
                Case SUBFIELDPOSITION_OK%
                    Exit Do
                Case SUBFIELDPOSITION_MoveUp%
                    If MarcArray(FldPointer).Subfield(MarcArray(FldPointer).LastSubfield).PrevSubfield < 0 Then
                        Exit Do
                    End If
                    gblbSkipSubfieldOrderTest = True
                    ' in effect, we must undo the shift we just did because it's bad
                    SfdShiftLeft
                    Exit Do
                Case SUBFIELDPOSITION_MoveDown%
                    If MarcArray(FldPointer).Subfield(MarcArray(FldPointer).LastSubfield).NextSubfield < 0 Then
                        Exit Do
                    End If
                    gblbSkipSubfieldOrderTest = True
                    SfdShiftRight
            End Select
        Loop
    Else
        gblbSkipSubfieldOrderTest = False
    End If
    
End Sub

Public Property Get FldIsControl() As Boolean

    If FldPointer > -1 Then
        FldIsControl = MarcArray(FldPointer).IsControl
    Else
        FldIsControl = False
    End If

End Property

Public Sub SfdInsertBefore(ByVal sSubfieldCode$, ByVal sSubfieldText$)

    ' insert a new subfield following the current subfield
    
    Dim iNextSubfield%, iPrevSubfield%, iCurrent%
    Dim iCtr%, iSortGroup%, iSortInstruction%, iRc%, iMatchesFound%, iGroup%
    
    Dim sSfdCodeString$, sLead$
    
    Dim bTPresentBefore As Boolean
    
    
    ' no subfields in control fields
    If FldIsControl Then
        Exit Sub
    End If
    ' can't add if we don't have appropriate information
    If Len(sSubfieldCode$) = 0 Or Len(sSubfieldText$) = 0 Then
        Exit Sub
    End If
    
    iCurrent% = SfdPointer
    
    MarcArray(FldPointer).Changed = True
    SfdMoveTop
    Do While SfdMoveNext
        If SfdPointer = iCurrent% Then
            Exit Do
        End If
        If SfdCode = "t" Then
            bTPresentBefore = True
            Exit Do
        End If
    Loop
    SfdPointer = iCurrent%
    
    SetSfdSortGroupFromCode sSubfieldCode$, iSortGroup%, iSortInstruction%, sSfdCodeString$, iMatchesFound%, bTPresentBefore
    
    ' add a new element to the array of subfields
    With MarcArray(FldPointer)
#If WithDebug = -1 Then
        PushWith "SfdInsertBefore 1"
#End If
        .SubfieldLast = .SubfieldLast + 1
        If .SubfieldLast > .SubfieldMax Or .SubfieldMax = 0 Then
            .SubfieldMax = .SubfieldMax + 5
            ReDim Preserve .Subfield(0 To .SubfieldMax)
        End If
        SfdPointer = .SubfieldLast
#If WithDebug = -1 Then
        PopWith "SfdInsertBefore 1"
#End If
    End With
    
    
    ' fill the new array element with your data
    With MarcArray(FldPointer).Subfield(MarcArray(FldPointer).SubfieldLast)
#If WithDebug = -1 Then
        PushWith "SfdInsertBefore 2"
#End If
        .Deleted = False
        .SortGroup = iSortGroup%
        .Code = sSubfieldCode$
        .Text = Trim(sSubfieldText$)
        .Norm = NormString(sSubfieldText$)
        .SortInstruction = iSortInstruction%
        .SortString = sSfdCodeString$
        
        If sSubfieldCode$ = "a" Then
            iRc% = InStr(.Text, ",")
            If iRc% = 0 Or (iRc% > 0 And iRc% = Len(.Text)) Then
                .NormNaco = .Norm
            Else
                .NormNaco = NormString(Mid(.Text, 1, iRc% - 1)) + ", " + NormString(Mid(.Text, iRc% + 1))
            End If
        Else
            .NormNaco = .Norm
        End If
        
        ' use dummy values for these two, temporarily
        .NextSubfield = -1
        .PrevSubfield = -1
#If WithDebug = -1 Then
        PopWith "SfdInsertBefore 2"
#End If
    End With
    
    ' special test: if this is the first and only subfield in the array so far, then we're already done
    '   (shouldn't happen unless the container deletes all of the subfields, and then inserts them one
    '   at a time)
    If MarcArray(FldPointer).SubfieldLast = 0 Then ' this is the first subfield
        With MarcArray(FldPointer)
#If WithDebug = -1 Then
            PushWith "SfdInsertBefore 3"
#End If
            .FirstSubfield = 0
            .LastSubfield = 0
#If WithDebug = -1 Then
            PopWith "SfdInsertBefore 3"
#End If
        End With
    Else
    
        With MarcArray(FldPointer)
#If WithDebug = -1 Then
            PushWith "SfdInsertBefore 4"
#End If
            ' this isn't the first subfield we've dealt with for this field
            ' put it where we're told to put it
            If .Subfield(iCurrent%).PrevSubfield > -1 Then
                ' if the current subfield isn't the first in the string, set the
                '   'next' for the subfield previous to the current subfield to
                '   point to the new subfield
                .Subfield(.Subfield(iCurrent%).PrevSubfield).NextSubfield = .SubfieldLast
            Else
                ' if the current subfield IS the first in the string, then the
                '   subfield we're adding ahead of it is the new first subfield
                .FirstSubfield = .SubfieldLast
            End If
            ' the new subfield's previous subfield is the current subfield
            .Subfield(.SubfieldLast).PrevSubfield = .Subfield(iCurrent%).PrevSubfield
            ' the new subfield's next subfield is the current subfield
            .Subfield(.SubfieldLast).NextSubfield = iCurrent%
            ' the current subfield's previous subfield is the new subfield
            .Subfield(iCurrent%).PrevSubfield = .SubfieldLast
#If WithDebug = -1 Then
            PopWith "SfdInsertBefore 4"
#End If
        End With
        
        ' test this subfield location, and shift this subfield until
        '   it's in the right place
        Do
            Select Case TestSubfieldPosition(MarcArray(FldPointer).Subfield(), SfdPointer)
                Case SUBFIELDPOSITION_OK%
                    Exit Do
                Case SUBFIELDPOSITION_MoveUp%
                    If MarcArray(FldPointer).Subfield(SfdPointer).PrevSubfield < 0 Then
                        Exit Do
                    End If
                    If TestSubfieldOrder And Not MakeNoChange Then
                        SfdShiftLeft
                        If SfdCode <> "w" Then
                            m_bSfdOrderChanged = True
                            If InStr(m_sFieldsWithSubfieldsOutOfOrder$, MarcArray(FldPointer).Tag) = 0 Then
                                m_sFieldsWithSubfieldsOutOfOrder$ = m_sFieldsWithSubfieldsOutOfOrder$ + " " + MarcArray(FldPointer).Tag
                            End If
                        End If
                    Else
                        If SfdCode <> "w" Then
                            m_bSubfieldsOutOfOrder = True
                            If InStr(m_sFieldsWithSubfieldsOutOfOrder$, MarcArray(FldPointer).Tag) = 0 Then
                                m_sFieldsWithSubfieldsOutOfOrder$ = m_sFieldsWithSubfieldsOutOfOrder$ + " " + MarcArray(FldPointer).Tag
                            End If
                        End If
                        Exit Do
                    End If
                Case SUBFIELDPOSITION_MoveDown%
                    If MarcArray(FldPointer).Subfield(SfdPointer).NextSubfield < 0 Then
                        Exit Do
                    End If
                    If TestSubfieldOrder And Not MakeNoChange Then
                        SfdShiftRight
                        If SfdCode <> "w" Then
                            m_bSfdOrderChanged = True
                            If InStr(m_sFieldsWithSubfieldsOutOfOrder$, MarcArray(FldPointer).Tag) = 0 Then
                                m_sFieldsWithSubfieldsOutOfOrder$ = m_sFieldsWithSubfieldsOutOfOrder$ + " " + MarcArray(FldPointer).Tag
                            End If
                        End If
                    Else
                        If SfdCode <> "w" Then
                            m_bSubfieldsOutOfOrder = True
                            If InStr(m_sFieldsWithSubfieldsOutOfOrder$, MarcArray(FldPointer).Tag) = 0 Then
                                m_sFieldsWithSubfieldsOutOfOrder$ = m_sFieldsWithSubfieldsOutOfOrder$ + " " + MarcArray(FldPointer).Tag
                            End If
                        End If
                        Exit Do
                    End If
            End Select
        Loop
    
    End If ' is this the only subfield in the field?
    
End Sub

Public Sub SfdInsertAfter(ByVal sSubfieldCode$, ByVal sSubfieldText$)

    ' insert a new subfield following of the current subfield
    
    Dim iNextSubfield%, iPrevSubfield%, iCurrent%, iSfd%
    Dim iCtr%, iSortGroup%, iSortInstruction%, iRc%, iMatchesFound%, iGroup%
    
    Dim sSfdCodeString$, sLead$
    
    Dim bTPresentBefore As Boolean, bDebug As Boolean
    
    
#If SfdInsertAfterDebug = -1 Then
    If sSubfieldCode$ = "h" Then
        bDebug = True
        Debug.Print "SIA: " + sSubfieldCode$ + ":" + sSubfieldText$ + "<"
    End If
#End If
    
    ' no subfields in control fields
    If FldIsControl Then
        Exit Sub
    End If
    ' can't add if we don't have appropriate information
    If Len(sSubfieldCode$) = 0 Or Len(sSubfieldText$) = 0 Then
        ' 20051219: retain empty 853 $a (this added specifically for
        '   Patricia Scott, University of Adelaide)
        If FldTag = "853" And sSubfieldCode$ = "a" Then
            ' do nothing: continue as below
        Else
            Exit Sub
        End If
    End If
    
    
    iCurrent% = SfdPointer
    
    MarcArray(FldPointer).Changed = True
    SfdMoveTop
    Do While SfdMoveNext
        If SfdCode = "t" Then
            bTPresentBefore = True
            Exit Do
        End If
        If SfdPointer = iCurrent% Then
            Exit Do
        End If
    Loop
    SfdPointer = iCurrent%
    
    SetSfdSortGroupFromCode sSubfieldCode$, iSortGroup%, iSortInstruction%, sSfdCodeString$, iMatchesFound%, bTPresentBefore
#If SfdInsertAfterDebug = -1 Then
    If bDebug Then
        Debug.Print "SortGroup: " + str(iSortGroup%) + " instruction " + str(iSortInstruction%) + " >" + sSfdCodeString$ + "<"
    End If
#End If
    'If gblaSfdOrder.Tag = "041" Then
        'bDebug = True
        'Debug.Print "Sfd " + sSubfieldCode$ + " order " + str(iSortGroup%)
    'End If
    
    ' add a new element to the array of subfields
    With MarcArray(FldPointer)
#If WithDebug = -1 Then
        PushWith "SfdInsertAfter 1"
#End If
        .SubfieldLast = .SubfieldLast + 1
        If .SubfieldLast > .SubfieldMax Or .SubfieldMax = 0 Then
            .SubfieldMax = .SubfieldMax + 5
            ReDim Preserve .Subfield(0 To .SubfieldMax)
        End If
        SfdPointer = .SubfieldLast
#If WithDebug = -1 Then
        PopWith "SfdInsertAfter 1"
#End If
    End With
    
    ' fill the new array element with your data
    With MarcArray(FldPointer).Subfield(MarcArray(FldPointer).SubfieldLast)
#If WithDebug = -1 Then
        PushWith "SfdInsertAfter 2"
#End If
        .Deleted = False
        .SortGroup = iSortGroup%
        .Code = sSubfieldCode$
        ' 20051005: DO NOT TRIM any subfields of the 010 field!
        If FldTag = "010" Then
            .Text = sSubfieldText$
        Else
            .Text = Trim(sSubfieldText$)
        End If
        .Norm = NormString(sSubfieldText$)
        .SortInstruction = iSortInstruction%
        .SortString = sSfdCodeString$
#If SfdInsertAfterDebug = -1 Then
        If bDebug Then
            Debug.Print "Text set: >" + .Text + "<"
        End If
#End If
        
        ' todo: this needs to take nonfiling into account too, doesn't it?
        If sSubfieldCode$ = "a" Then
            iRc% = InStr(.Text, ",")
            If iRc% = 0 Or (iRc% > 0 And iRc% = Len(.Text)) Then
                .NormNaco = .Norm
            Else
                .NormNaco = NormString(Mid(.Text, 1, iRc% - 1)) + ", " + NormString(Mid(.Text, iRc% + 1))
            End If
        Else
            .NormNaco = .Norm
        End If
        
        ' use dummy values for these two, temporarily
        .NextSubfield = -1
        .PrevSubfield = -1
        
#If WithDebug = -1 Then
        PopWith "SfdInsertAfter 2"
#End If
    End With
    
    ' special test: if this is the first and only subfield in the array so far, then we're already done
    '   (shouldn't happen unless the container deletes all of the subfields, and then inserts them one
    '   at a time)
    If MarcArray(FldPointer).SubfieldLast = 0 Then ' this is the first subfield
        With MarcArray(FldPointer)
#If WithDebug = -1 Then
            PushWith "SfdInsertAfter 3"
#End If
            .FirstSubfield = 0
            .LastSubfield = 0
#If WithDebug = -1 Then
            PopWith "SfdInsertAfter 3"
#End If
        End With
        SfdPointer = 1
    Else
        With MarcArray(FldPointer)
#If WithDebug = -1 Then
            PushWith "SfdInsertAfter 4"
#End If
            ' the new subfield's next subfield is the current subfield's next subfield (which
            '   may be minus 1)
            .Subfield(.SubfieldLast).NextSubfield = .Subfield(iCurrent%).NextSubfield
            ' the new subfield's previous subfield is the current subfield
            .Subfield(.SubfieldLast).PrevSubfield = iCurrent%
            If .Subfield(iCurrent%).NextSubfield > -1 Then
                ' if there is a subfield currently following the current subfield, that
                '   subfield's previous subfield becomes the new subfield
                .Subfield(.Subfield(iCurrent%).NextSubfield).PrevSubfield = .SubfieldLast
            Else
                ' there is no subfield currently following the current subfield; so
                '   the new subfield becomes the last subfield
                .LastSubfield = .SubfieldLast
            End If
            ' the current subfield's next subfield is the new subfield
            .Subfield(iCurrent%).NextSubfield = .SubfieldLast
#If WithDebug = -1 Then
            PopWith "SfdInsertAfter 4"
#End If
        End With
        
        ' test this subfield location, and shift this subfield until
        '   it's in the right place
        Do
            Select Case TestSubfieldPosition(MarcArray(FldPointer).Subfield(), MarcArray(FldPointer).LastSubfield)
                Case SUBFIELDPOSITION_OK%
                    Exit Do
                Case SUBFIELDPOSITION_MoveUp%
                    If MarcArray(FldPointer).Subfield(SfdPointer).PrevSubfield < 0 Then
                        Exit Do
                    End If
                    If TestSubfieldOrder And Not MakeNoChange Then
                        ' we're allowed to make changes and we're interested
                        '   in knowing about them
                        SfdShiftLeft
                        If SfdCode <> "w" Then
                            m_bSfdOrderChanged = True
                            ' 20080731: similar to just below, keep a list of
                            '   the tags whose subfields were rearranged
                            If InStr(m_sFieldsWithSubfieldsOutOfOrder$, MarcArray(FldPointer).Tag) = 0 Then
                                m_sFieldsWithSubfieldsOutOfOrder$ = Trim(m_sFieldsWithSubfieldsOutOfOrder$ + " " + MarcArray(FldPointer).Tag)
                            End If
                        End If
                    Else
                        If SfdCode <> "w" Then
                            m_bSubfieldsOutOfOrder = True
                            If InStr(m_sFieldsWithSubfieldsOutOfOrder$, MarcArray(FldPointer).Tag) = 0 Then
                                m_sFieldsWithSubfieldsOutOfOrder$ = Trim(m_sFieldsWithSubfieldsOutOfOrder$ + " " + MarcArray(FldPointer).Tag)
                            End If
                        End If
                        Exit Do
                    End If
                Case SUBFIELDPOSITION_MoveDown%
                    If MarcArray(FldPointer).Subfield(SfdPointer).NextSubfield < 0 Then
                        Exit Do
                    End If
                    If TestSubfieldOrder And Not MakeNoChange Then
                        If SfdCode <> "w" Then
                            m_bSfdOrderChanged = True
                            If InStr(m_sFieldsWithSubfieldsOutOfOrder$, MarcArray(FldPointer).Tag) = 0 Then
                                m_sFieldsWithSubfieldsOutOfOrder$ = m_sFieldsWithSubfieldsOutOfOrder$ + " " + MarcArray(FldPointer).Tag
                            End If
                        End If
                        SfdShiftRight
                    Else
                        If SfdCode <> "w" Then
                            m_bSubfieldsOutOfOrder = True
                            If InStr(m_sFieldsWithSubfieldsOutOfOrder$, MarcArray(FldPointer).Tag) = 0 Then
                                m_sFieldsWithSubfieldsOutOfOrder$ = m_sFieldsWithSubfieldsOutOfOrder$ + " " + MarcArray(FldPointer).Tag
                            End If
                        End If
                        Exit Do
                    End If
                Case Else
#If SfdInsertAfterDebug = -1 Then
                    If bDebug Then
                        Debug.Print "SIA Else"
                    End If
#End If
            End Select
        Loop
        
    End If ' is this the only subfield in the field?

End Sub

Public Function FldTestNext(sTag$) As Boolean

    Dim iSave%
    
    Dim sSave$
    
    Dim bSave As Boolean
    
    ' see if a given field is present in the current record at some point
    '   after the current field
    
    ' unlike the 'find' functions, this does NOT move the current field pointer
    
    iSave% = FldPointer
    sSave$ = m_sTagWanted$
    bSave = FldWasFound
    
    FldFindNext sTag$
    FldTestNext = FldWasFound
    
    FldPointer = iSave%
    m_sTagWanted$ = sSave$
    m_bFieldWasFound = bSave
    
End Function

Public Function FldTestFirst(sTag$) As Boolean

    Dim iSave%
    
    Dim sSave$
    
    Dim bSave As Boolean
    
    ' see if a given field is present in the current record at any point
    
    ' unlike the 'find' functions, this does NOT move the current field pointer
    
    iSave% = FldPointer
    sSave$ = m_sTagWanted$
    bSave = FldWasFound
    
    FldFindFirst sTag$
    FldTestFirst = FldWasFound
    
    FldPointer = iSave%
    m_sTagWanted$ = sSave$
    m_bFieldWasFound = bSave

End Function

Public Function SfdTestFirst(ByVal sSubfieldCode$) As Boolean

    Dim bSave As Boolean
    Dim iSave%
    Dim sSave$
    
    iSave% = SfdPointer
    bSave = SfdWasFound
    sSave$ = m_sSubfieldWanted$
    
    SfdFindFirst sSubfieldCode$
    SfdTestFirst = SfdWasFound
    
    SfdPointer = iSave%
    m_bSfdWasFound = bSave
    m_sSubfieldWanted$ = sSave$
    
End Function

Public Property Get SfdWasFound() As Boolean

    SfdWasFound = m_bSfdWasFound

End Property


Public Function SfdTestNext(ByVal sSubfieldCode$) As Boolean

    Dim bSave As Boolean
    Dim iSave%
    Dim sSave$
    
    iSave% = SfdPointer
    bSave = SfdWasFound
    sSave$ = m_sSubfieldWanted$
    
    SfdFindNext sSubfieldCode$
    SfdTestNext = SfdWasFound
    
    SfdPointer = iSave%
    m_bSfdWasFound = bSave
    m_sSubfieldWanted$ = sSave$

End Function

Private Sub NormCallNumberRemoveSuDocsAlphas(ByRef sWork$, ByRef sPiece$, ByRef bSlashHit As Boolean)

    bSlashHit = False
    sPiece$ = ""
    
    Do
        If Len(sWork$) = 0 Then
            Exit Do
        End If
        MyMarcCharacter.Utf8Char = sWork$
        sWork$ = Mid(sWork$, MyMarcCharacter.Utf8CharOctets + 1)
        Select Case MyMarcCharacter.Utf8Char
            Case "A" To "Z"
NormCallNoRemoveSudocsAlphasLetter:
                sPiece$ = sPiece$ + MyMarcCharacter.Utf8CharNorm
            Case "0" To "9"
                ' we're now at a numeral (the normal case, eventually): exit
                ' at a later point, you'll later strip off the numerals
                sWork$ = MyMarcCharacter.Utf8Char + sWork$
                Exit Do
            Case "."
                If Len(sWork$) > 0 Then
                    If InStr(Const_NumString$, Mid(sWork$, 1, 1)) > 0 Then ' safe
                        sPiece$ = sPiece$ + " "
                    End If
                Else
                    sPiece$ = sPiece$ + " "
                End If
                ' in all cases, you'll effectively discard the hyphen
                Exit Do
            Case " "
                ' if the space separates two alphabetic portions, then
                '   concatenate the aphabetic portions and continue gathering
                '   alphabetic characters; otherwise, it's time to quit this loop
                If Len(sWork$) > 0 Then
                    If InStr(CONST_UpperCaseAlpha$, Mid(sWork$, 1, 1)) = 0 Then
                        ' remove the space and get out of here
                        Exit Do
                    End If
                Else
                    ' should not happen!
                    Exit Do
                End If
            Case "/"
                If Len(sWork$) > 0 Then
                    If InStr(CONST_UpperCaseAlpha$, Mid(sWork$, 1, 1)) > 0 Then
                        sPiece$ = sPiece$ + "  "
                        ' do nothing with sWork right here
                    Else
                        If InStr(Const_NumString$, Mid(sWork$, 1, 1)) > 0 Then
                            bSlashHit = True
                        End If
                        Exit Do
                    End If
                Else
                    Exit Do
                End If
            Case Else
                If MyMarcCharacter.Utf8CharCategory = Utf8_LetterUppercase$ Then
                    ' this shouldn't happen, of course, but ...
                    GoTo NormCallNoRemoveSudocsAlphasLetter
                End If
                ' others: some bizarre mark of punctuation?
                Exit Do
        End Select
    Loop

End Sub

Private Sub NormCallNumberRemoveSuDocsNumerals(ByRef sWork$, ByRef sPiece$, ByVal bSlashHit As Boolean, ByRef bSlashHacked As Boolean, ByRef sElement$)

    Dim iPad%
    
    sPiece$ = ""
    sElement$ = ""
    
    If Not bSlashHit Then
        iPad% = 4
    Else
        iPad% = 5
    End If
    
    Do
        If Len(sWork$) = 0 Then
            If Len(sElement$) > 0 Then
                If Len(sPiece$) > 0 Then
                    sPiece$ = sPiece$ + " "
                End If
                sPiece$ = sPiece$ + Right("       " + sElement, iPad%)
                If bSlashHacked Then
                    sPiece$ = sPiece$ + " "
                End If
            End If
            Exit Do
        End If
        
        MyMarcCharacter.Utf8Char = sWork$
        sWork$ = Mid(sWork$, MyMarcCharacter.Utf8CharOctets + 1)
        Select Case MyMarcCharacter.Utf8Char
            Case "0" To "9"
                ' add this numeral to the accumulating numeric string,
                '   and continue
                sElement$ = sElement$ + MyMarcCharacter.Utf8Char
            Case "."
                ' we have hit the decimal point in the number
                ' right-justify the existing number, and continue with a new numeric block (if any)
                If Len(sPiece$) > 0 Then
                    sPiece$ = sPiece$ + " "
                End If
                sPiece$ = sPiece$ + Right("        " + sElement$, iPad%)
                iPad% = 5
                sElement$ = ""
                ' if the decimal point is followed by a space plus more numerals, then
                '   remove the space and pretend nothing is wrong
                If Len(sWork$) > 0 Then
                    If Mid(sWork$, 1, 1) = " " Then ' safe
                        If Len(sWork$) > 1 Then
                            If InStr(Const_NumString$, Mid(sWork$, 2, 1)) > 0 Then ' safe
                                ' remove the space, too
                                sWork$ = Mid(sWork$, 2)
                            Else
                                MyNextChar.Utf8Char = Mid(sWork$, 2)
                                If MyNextChar.Utf8CharCategory = Utf8_LetterUppercase$ Then
                                    If Len(sPiece$) > 0 Then
                                        sPiece$ = sPiece$ + " "
                                    End If
                                End If
                                Exit Do
                            End If
                        Else ' should never happen!
                            sWork$ = ""
                        End If
                    ElseIf MyMarcCharacter.Utf8CharCategory = Utf8_LetterUppercase$ Then '  InStr(CONST_UpperCaseAlpha$, Mid(sWork$, 1, 1)) > 0 Then
                        sPiece$ = sPiece$ + " "
                        Exit Do
                    End If
                End If
            Case "-"
                ' attach any accumulated numeric information
                '   (same as if we came to any other non-recognized
                '   piece in the input stream)
                If Len(sPiece$) > 0 Then
                    sPiece$ = sPiece$ + " "
                End If
                sPiece$ = sPiece$ + Right("       " + sElement, iPad%)
                iPad% = 5
                sElement$ = ""
                If Len(sWork$) > 0 Then ' it probably should be!
                    ' 20030705: obviously, this isn't doing anything; but we'be
                    '   best leave it alone for now
                    If InStr(Const_NumString$, Mid(sWork$, 1, 1)) > 0 Then
                        'sPiece$ = sPiece$ + " "
                    'else: if not a numeral, then we'll handle it under its
                    '   own merits elsewise
                    End If
                Else
                    ' we're obviously done!
                    Exit Do
                End If
            Case "/"
                ' we have hit a slash to the left of the colon
                ' insert a space
                ' right-justify the existing number @ 5, and continue with a new numeric block
                If Len(sPiece$) > 0 Then
                    sPiece$ = sPiece$ + " "
                End If
                sPiece$ = sPiece$ + Right("       " + sElement, iPad%)
                iPad% = 5
                sElement$ = ""
                If Len(sWork$) > 0 Then
                    If Mid(sWork$, 1, 1) = " " Then ' safe
                        If Len(sWork$) > 1 Then ' safe
                            MyNextChar.Utf8Char = Mid(sWork$, 2)
                            If MyNextChar.Utf8CharCategory = Utf8_LetterUppercase$ Then ' InStr(CONST_UpperCaseAlpha$, Mid(sWork$, 2, 1)) > 0 Then
                                sPiece$ = sPiece$ + " "
                                Exit Do
                            End If
                        End If
                    Else
                        If MyMarcCharacter.Utf8CharCategory = Utf8_LetterUppercase$ Then
                        'If InStr(CONST_UpperCaseAlpha$, Mid(sWork$, 1, 1)) > 0 Then
                            sPiece$ = sPiece$ + " "
                            Exit Do
                        End If
                    End If
                Else
                    ' nothing left, which means that the slash immediately precedes the colon
                    ' throw in an additional space
                    sPiece$ = sPiece$ + " "
                End If
            Case " "
                ' continue with the next character as if nothing were wrong
            Case Else ' includes uppercase letters of all sorts
                ' attach any accumulated numeric information
                If Len(sPiece$) > 0 Then
                    sPiece$ = sPiece$ + " "
                End If
                sPiece$ = sPiece$ + Right("       " + sElement, iPad%)
                ' put the current piece back on to the string
                sWork$ = MyMarcCharacter.Utf8Char + sWork$
                Exit Do
        End Select
    Loop

End Sub

Public Property Get TextRaw() As String

    TextRaw = TextFormatted(Raw)
    
#If False Then

    ' provides the current record in flattened "text" format, but not so pretty as
    '   the format provided by TextFormatted
    
    Dim sOutput$, sTag$, sIndicators$, sField$, s008$
    
    Dim iRc%, iPtr%
    
    ' save pointer to current field
    iPtr% = FldPointer
    
    sOutput$ = " 000" + "     " + m_sLeader$
    FldMoveTop
    Do While FldMoveNext
        'Debug.Print "TR " + str(FldPointer)
        If Not FldDeleted Then
            Select Case FldTag
                Case Is < "010"
                    sOutput$ = sOutput$ + vbCr + vbLf + " " + FldTag + "     " + FldText
                Case Else
                    sOutput$ = sOutput$ + vbCr + vbLf + " " + FldTag + ":" + FldInd + ": " + FldText
            End Select
        End If
    Loop

    TextRaw = sOutput$
    
    ' restore pointer to current field
    FldPointer = iPtr%

#End If

End Property


Public Function GetFixedField(ByVal iMarcStartingPosition%, ByVal iLength%) As String

    ' can't do this if we don't have a field
    If FldPointer < 0 Then
        GetFixedField = ""
        Exit Function
    End If
    
    ' can't do this if we don't have a control field
    If InStr("006 007 008", FldTag) = 0 Then
        GetFixedField = ""
        Exit Function
    End If
    
    ' return the desired value, bumping the starting position up by one
    GetFixedField = Mid(FldText, iMarcStartingPosition% + 1, iLength%)

End Function

Public Sub ChangeFixedField(ByVal iMarcStartingPosition%, ByVal iLength%, ByVal sNewValue$)

    ' can't do this if we don't have a field, or a valid starting position
    '   or a valid length
    If FldPointer < 0 Or iMarcStartingPosition% < 0 Or iLength% < 1 Then
        Exit Sub
    End If
    
    ' can't do this if we don't have a control field
    If InStr("006 007 008", FldTag) = 0 Then
        Exit Sub
    End If
    
    ' if we don't actually have anything yet, set some kind of default value for the field
    '   before we do anything else
    If (Len(MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text) = 0) Then
        Select Case FldTag
            Case "006"
                MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(18)
            Case "007"
                Select Case sNewValue$
                    Case "a" ' map
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(8)
                    Case "c" ' computer file
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(14)
                    Case "d" ' globe
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(6)
                    Case "f" ' tactile
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(10)
                    Case "g" ' projected graphic
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(9)
                    Case "h" ' microform
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(13)
                    Case "k" ' nonprojected graphic
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(6)
                    Case "m" ' motion picture
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(17) + String(6, MyMarcCharacter.MarcFill)
                    Case "o" ' kit
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(2)
                    Case "q" ' notated music
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(2)
                    Case "r" ' remote-sensing image
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(9) + String(6, MyMarcCharacter.MarcFill)
                    Case "s" ' sound recording
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(14)
                    Case "t" ' text
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(2)
                    Case "v" ' videorecording
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(9)
                    Case "z" ' unspecified
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(2)
                    Case Else ' goodness knows what this is!
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Space(14)
                End Select
            Case "008"
                Select Case m_sRecordFormat$
                    Case "H"
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Format(Now, "yymmdd") + Space(26)
                    Case "Q" ' community info
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Format(Now, "yymmdd") + Space(9)
                    Case "W" ' classification
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Format(Now, "yymmdd") + Space(8)
                    Case Else
                        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = Format(Now, "yymmdd") + Space(34)
                End Select
        End Select
    End If
    
    ' if the indicated element lies within this fixed field, then change its value
    If iMarcStartingPosition% + iLength <= Len(MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text) Then
        MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text = SafeStuff(MarcArray(FldPointer).Subfield(MarcArray(FldPointer).FirstSubfield).Text, iMarcStartingPosition% + 1, iLength%, sNewValue$)
    End If
    
End Sub

Public Function TagCompare(ByVal sTagWantedOrListOfTags$, ByVal sComparisonTag$, Optional ByVal iTagWantedLength%) As Boolean

    ' 20040607: made the now-not-used iTagWantedLength% optional so we don't
    '   break existing code
    
    Dim iCtr%, iEnd%
    
    Dim sTagPiece$
    
    Dim bTagOK As Boolean
    
    
    ' assume: match no found
    TagCompare = False
    
    Do
        GetNextPiece sTagWantedOrListOfTags$, sTagPiece$, " "
        sTagWantedOrListOfTags$ = Trim(sTagWantedOrListOfTags$)
        bTagOK = False
        iEnd% = Len(sTagPiece$)
        For iCtr% = 1 To iEnd% ' formerly:  iTagWantedLength%
            If Mid(sTagPiece$, iCtr%, 1) <> Mid(sComparisonTag$, iCtr%, 1) Then
                ' 20040616 (happy bloomsday!): allow for the 'X' to appear in either of
                '   the two tags
                If Mid(sTagPiece$, iCtr%, 1) <> "X" And Mid(sComparisonTag$, iCtr%, 1) <> "X" Then
                    ' non-match: this is not a match
                    'bTagOK = False
                    Exit For
                End If
            'Else
                ' they are the same: continue
            End If
            If iCtr% = iEnd% Then
                ' if we reach the end and we've not yet found
                '   a non-match, then we must have a match
                bTagOK = True
            End If
        Next ' ictr%
        If bTagOK Then
            TagCompare = True
            Exit Function ' with return value of true
        End If
        If Len(sTagWantedOrListOfTags$) = 0 Then
            Exit Do
        End If
    Loop
    
    ' if we get here, we have NOT found a match: neither an exact match on all
    '   supplied charcaters, nor a match, excepting where the tag wanted
    '   contains "X"
    
    TagCompare = False
    
End Function

Public Function ConvertISBN10To13(ByVal s10CharacterISBN$) As String

    ' given a 10(or 9)-characterr ISBN, convert it to the 13-character format
    '   to be used beginning in 2007
    
    ' see http://www.isbn.org/standards/home/isbn/transition.asp
    
    Dim iCtr%, iWeight%
    
    Dim lTotal As Long
    
    Dim sISBN$, sExtension$
    
    ' remove any hyphens
    Do
        iCtr% = InStr(s10CharacterISBN$, "-")
        If iCtr% = 0 Then
            Exit Do
        End If
        s10CharacterISBN$ = SafeStuff(s10CharacterISBN$, iCtr%, 1, "")
    Loop
    
    ' snap off any 'extension' that may be present
    For iCtr% = 1 To Len(s10CharacterISBN$)
        If InStr("0123456789X-", Mid(s10CharacterISBN$, iCtr%, 1)) = 0 Then
            sExtension$ = Mid(s10CharacterISBN$, iCtr%)
            s10CharacterISBN$ = Mid(s10CharacterISBN$, 1, iCtr% - 1)
            Exit For
        End If
    Next ' ictr%
    
    iCtr% = Len(s10CharacterISBN$)
    ' set the basic string, including the new '978' prefix--and
    '   discard the current check digit
    Select Case iCtr%
        Case 9
            sISBN$ = "9780" + Mid(s10CharacterISBN$, 1, 8)
        Case 10
            sISBN$ = "978" + Mid(s10CharacterISBN$, 1, 9)
        Case Else
            ConvertISBN10To13 = s10CharacterISBN$ + sExtension$
            Exit Function
    End Select

    iWeight% = 1
    ' get the value of the first 12 characters
    For iCtr% = 1 To 12
        lTotal = lTotal + (Val(Mid(sISBN$, iCtr%, 1)) * iWeight%)
        If iWeight% = 3 Then
            iWeight% = 1
        Else
            iWeight% = 3
        End If
    Next ' ictr%

    ' it is unclear why the standard calls for the 'outer' Mod here--we already know that the result
    '   will have to be 0-9 inclusive.  it's not harmful, but it's silly. however, we
    '   will do exactly what we're told!
    ConvertISBN10To13 = sISBN$ + Trim(str((10 - (lTotal Mod 10)) Mod 10)) + sExtension$
    
End Function

Private Sub NormalizeStandardNumberKeepOnlyCharacters(ByRef sCopy$, ByVal sKeepString$)

    Dim iRc%
    
    ' the effect of this on strings that contain Unicode is that all Unicode characters
    '   will be removed--one octet at a time. it is not yet clear whether this is
    '   the correct behavior
    
    For iRc% = Len(sCopy$) To 1 Step -1
        If InStr(sKeepString$, Mid(sCopy$, iRc%, 1)) = 0 Then
            If iRc% = 1 Then
                sCopy$ = Mid(sCopy$, 2)
            Else
                sCopy$ = Mid(sCopy$, 1, iRc% - 1) + Mid(sCopy$, iRc% + 1)
            End If
        End If
    Next ' irc%

End Sub

Public Function ListSubfieldsForNormalization(ByVal sFormat$, ByVal sTag$) As String

    Dim sSubfields$
    
    Select Case sFormat$
        Case "A"
            Select Case sTag$
                Case "100", "400", "500", "700"
                    sSubfields = SUBFIELDS_Personal$ + SUBFIELDS_SubjectSubdivisions$
                Case "110", "410", "510", "710"
                    sSubfields = SUBFIELDS_Corporate$ + SUBFIELDS_SubjectSubdivisions$
                Case "111", "411", "511", "711"
                    sSubfields = SUBFIELDS_Conference$ + SUBFIELDS_SubjectSubdivisions$
                Case "130", "430", "530", "730"
                    sSubfields = SUBFIELDS_UniformTitle$ + SUBFIELDS_SubjectSubdivisions$
                Case "150", "450", "550", "750"
                    sSubfields = SUBFIELDS_Topical$ + SUBFIELDS_SubjectSubdivisions$
                Case "151", "451", "551", "751"
                    sSubfields = SUBFIELDS_Geographic$ + SUBFIELDS_SubjectSubdivisions$
                Case "155", "455", "555", "755"
                    sSubfields = SUBFIELDS_Form$ + SUBFIELDS_SubjectSubdivisions$
                Case "180", "480", "580", "780"
                    sSubfields$ = SUBFIELDS_SubjectSubdivisions$
                Case "181", "481", "581", "781"
                    sSubfields$ = SUBFIELDS_SubjectSubdivisions$
                Case "182", "482", "582", "782"
                    sSubfields$ = SUBFIELDS_SubjectSubdivisions$
                Case "185", "485", "585", "785"
                    sSubfields$ = SUBFIELDS_SubjectSubdivisions$
                Case Else
                    sSubfields = SUBFIELDS_Other$
            End Select
        Case "B", "D", "F", "M", "P", "S", "U"
            Select Case sTag$
                Case "100", "400", "500", "600", "700", "800"
                    sSubfields = SUBFIELDS_Personal$
                Case "110", "410", "510", "610", "710", "810"
                    sSubfields = SUBFIELDS_Corporate$
                Case "111", "411", "511", "611", "711", "811"
                    sSubfields = SUBFIELDS_Conference$
                Case "130", "440", "490", "530", "630", "730", "830"
                    sSubfields = SUBFIELDS_UniformTitle$
                Case "210", "211", "245", "246", "740"
                    sSubfields$ = "abnp"
                Case "650"
                    sSubfields = SUBFIELDS_Topical$
                Case "651"
                    sSubfields = SUBFIELDS_Geographic$
                Case "655"
                    sSubfields = SUBFIELDS_Form$
                Case Else
                    sSubfields = SUBFIELDS_Other$
            End Select
            ' add $v, $x, $y and $z ONLY for subjects (so we don't accidentally
            '   include ISBN and numbering for series, among other things!)
            If Mid(sTag$, 1, 1) = "6" Then
                sSubfields = sSubfields + SUBFIELDS_SubjectSubdivisions$
            End If
        Case Else
            sSubfields = SUBFIELDS_Other$
    End Select
    
    ListSubfieldsForNormalization = sSubfields$
    
End Function

Public Function FldFindLast(ByVal sTagToFind$, Optional ByVal sNormalizedFieldText$ = "") As Boolean
    
    ' 20040614: tags to find may actually be a *list*
    
    
    Dim iDirPtr%, iTagLen%, iDirLen%
    
    Dim sTagWanted$, sTags$, sTag$
    
    Dim bText As Boolean
    
#If FldFindLastDebug = -1 Then
    Debug.Print "FieldFindLast entry for " + sTagToFind$
    DumpArray "", False
    'FldFindLast = False
    'Exit Function
#End If
    
    m_bFldAtTop = False
    m_bFldAtBottom = False
    m_bSfdAtTop = False
    m_bSfdAtBottom = False
    
    FldFindLast = False
    
    sTagToFind$ = UCase(RemoveRepeatedCharacters(sTagToFind$, " "))
    
    If Len(sNormalizedFieldText$) > 0 Then
        m_sFieldWanted$ = NormString(sNormalizedFieldText$)
        If Len(m_sFieldWanted$) > 0 Then
            bText = True
        End If
    End If
    
    If Len(sTagToFind$) > 0 Then
        m_sTagWanted$ = sTagToFind$
    End If
    
    ' need the length of the "desired tag"
    If Len(m_sTagWanted$) < 1 Then
        FldPointer = -1
#If FldFindLastDebug = -1 Then
        Debug.Print "FieldFindLast field NOT FOUND #1"
#End If
        Exit Function
    End If
    
    FldMoveLast
    While FldWasFound
#If FldFindLastDebug = -1 Then
        Debug.Print "FFL " + str(FldPointer) + " " + FldTag + ":" + FldInd + ":" + FldText
#End If
        If Not FldDeleted Then
            If TagCompare(m_sTagWanted$, FldTag) Then
                If bText Then
                    If Mid(FldNorm, 1, Len(m_sFieldWanted$)) = m_sFieldWanted$ Then
#If FldFindLastDebug = -1 Then
                        Debug.Print "FieldFindLast field FOUND #1"
#End If
                        FldFindLast = True
                        Exit Function
                    End If
                Else
#If FldFindLastDebug = -1 Then
                    Debug.Print "FieldFindLast field FOUND #2"
#End If
                    FldFindLast = True
                    Exit Function
                End If
            End If
        End If
        FldMovePrev
    Wend
    
    ' tag not found: set pointer to zero
    FldPointer = -1

#If FldFindLastDebug = -1 Then
    Debug.Print "FieldFindLast field NOT FOUND #2"
#End If

End Function

Public Function SfdDelim(ByVal sSubfieldCode$) As String

    SfdDelim = MyMarcCharacter.MarcDelimiter + Mid(sSubfieldCode$, 1, 1)
    
End Function

Public Sub FldAddGeneric(ByVal sNewTag$, ByVal sNewIndicators$, ByVal sNewFieldText$, Optional iForceTagLength% = -1)

    ' 20040921: this subroutine was created when we did not yet have the field-ordering
    '   business in place
    ' now that that business is in place, the need for this routine no longer exists, and
    '   is hereby removed; container programs can use the two FldInsert routines to control
    '   the position of a field, if they don't like the default positioning provided by
    '   FldAdd
    ' for compatibility, this subroutine's name is retained as an entry point, but all we
    '   do is pass information along to the FldAdd routine
    
    FldAdd sNewTag, sNewIndicators$, sNewFieldText
    
    
    ' here's the dead code, FYI
#If False Then

    ' add a new field at the most appropriate "generic" position--assuming
    '   that the new field's stated location is also permissible within the existing
    '   field-sorting definition
    
    Dim iPlace%, iGenericLength%
    
    Dim sGeneric$, sSortSignature$
    
    
    sSortSignature$ = SetFieldSortGroupFromTag(sNewTag$, sNewIndicators$, sNewFieldText$)
    
    If Mid(sNewTag$, 1, 1) = "0" Then
        If Mid(sNewTag$, 2, 1) = "0" Then
            ' 00X fields are in tag order no matter what the
            '   outside world says!
            iGenericLength% = 3
        Else
            Select Case iForceTagLength%
                Case Is < 1
                    iGenericLength% = 1
                Case Is > 3
                    iGenericLength% = 1
                Case Else
                    iGenericLength% = iForceTagLength%
            End Select
        End If
    Else
        ' not an 0XX field
        Select Case iForceTagLength%
            Case Is < 1
                iGenericLength% = 1
            Case Is > 3
                iGenericLength% = 1
            Case Else
                iGenericLength% = iForceTagLength%
        End Select
    End If
        
    
    sGeneric$ = Mid(sNewTag$, 1, iGenericLength%)
    
    iPlace% = -1
    ' find the first field in the record with a tag "higher" than
    '   our field
    FldMoveFirst
    While FldWasFound
        If Mid(FldTag, 1, iGenericLength%) > sGeneric$ Then
            ' we have hit a point that's "beyond" the proper point for
            '   the new field
            If MarcArray(FldPointer).PrevField > -1 Then
                ' there is a previous field
                If Mid(MarcArray(MarcArray(FldPointer).PrevField).Tag, 1, iGenericLength%) <= sGeneric$ Then
                    iPlace = FldPointer
                    GoTo FieldAddGenericDone
                End If
            Else
                ' there is no previous field
                iPlace = FldPointer
                GoTo FieldAddGenericDone
            End If
        End If
        FldMoveNext
    Wend
    
    
FieldAddGenericDone:

    If iPlace% > -1 Then
        FldPointer = iPlace%
        FldInsertBefore sNewTag$, sNewIndicators$, sNewFieldText$
    Else ' just add it at the bottom
        FldAdd sNewTag$, sNewIndicators$, sNewFieldText$
    End If
    
#End If

End Sub

Public Property Get FldDeleted() As Boolean

    'Debug.Print "FLD DEL " + str(FldPointer)
    FldDeleted = MarcArray(FldPointer).Deleted

End Property


Public Property Get SfdDeleted() As Boolean

    If FldPointer > -1 And SfdPointer > -1 Then
        SfdDeleted = MarcArray(FldPointer).Subfield(SfdPointer).Deleted
    Else
        SfdDeleted = True
    End If

End Property


Public Function SfdFindLast(ByVal sSubfieldCode$, Optional ByVal sNormalizedSubfieldText$ = "") As Boolean

    ' 20040614: add optional ability to specify the normalized text of
    '   the subfield, too
    
    Dim bText As Boolean
    
    SfdFindLast = False


    m_bSfdAtTop = False
    m_bSfdAtBottom = False

#If SfdFindLastDebug = -1 Then
    Debug.Print "Arrived at SfdFindLast: >" + sSubfieldCode$ + "< >" + sNormalizedSubfieldText$ + "< >" + m_sSubfieldWanted$ + "< " + str(FldWasFound)
#End If

    If Len(sSubfieldCode$) > 0 Then
        m_sSubfieldWanted$ = sSubfieldCode$ ' Mid(Trim(sSubfieldCode$), 1, 1)
    ElseIf Len(m_sSubfieldWanted$) = 0 Or Not FldWasFound Then
        Exit Function
    End If
    
    m_sSubfieldTextWanted$ = NormString(sNormalizedSubfieldText$)
    If Len(m_sSubfieldTextWanted$) > 0 Then
        bText = True
    End If
    
    SfdMoveLast
    While SfdWasFound
        ' 20050803: added the critical missing Not
        If Not SfdDeleted Then
            If InStr(m_sSubfieldWanted$, SfdCode) > 0 Then
                If bText Then
                    If Mid(SfdNorm, 1, Len(m_sSubfieldTextWanted$)) = m_sSubfieldTextWanted$ Then
                        SfdFindLast = True
                        Exit Function
                    End If
                Else
                    SfdFindLast = True
                    Exit Function
                End If
            End If
        End If
        SfdMovePrev
    Wend

    SfdPointer = -1
    
End Function

Public Function Sfdfindprev(Optional ByVal sSubfieldCode$ = "", Optional ByVal sNormalizedSubfieldText$ = "") As Boolean

    ' 20040614: add optional ability to specify the normalized text of
    '   the subfield, too

    Dim bText As Boolean
    
    Dim sCode$
    
    
    Sfdfindprev = False
    
    m_bSfdAtTop = False
    m_bSfdAtBottom = False
    
    If Len(sSubfieldCode$) > 0 Then
        m_sSubfieldWanted$ = sSubfieldCode$ ' Mid(Trim(sSubfieldCode$), 1, 1)
        If Len(sSubfieldCode$) = 0 Then
            Exit Function
        End If
    ElseIf Len(m_sSubfieldWanted$) = 0 Or Not FldWasFound Then
        Exit Function
    End If
    
    If Len(sNormalizedSubfieldText$) > 0 Then
        m_sSubfieldTextWanted$ = NormString(sNormalizedSubfieldText$)
        If Len(m_sSubfieldTextWanted$) > 0 Then
            bText = True
        End If
    End If
    
    
    While SfdMovePrev
        If Not SfdDeleted Then
            If InStr(m_sSubfieldWanted$, SfdCode) > 0 Then
                If bText Then
                    If Mid(SfdNorm, 1, Len(m_sSubfieldTextWanted$)) = m_sSubfieldTextWanted$ Then
                        Sfdfindprev = True
                        Exit Function
                    End If
                Else
                    Sfdfindprev = True
                    Exit Function
                End If
            End If
        End If
    Wend

    SfdPointer = -1
    
End Function

Public Function FldFindPrev(Optional sTagToFind$ = "", Optional ByVal sNormalizedFieldText$ = "") As Boolean

    ' find the occurrence of some tag preceding the current field
    ' to find the next occurrence of the tag used in fldfindfirst, supply no
    '   parameter here; we'll expose the next field with the same tag
    ' to find the first occurrence of *any* tag following the current
    '   field, supply the tag parameter (1 to 3 digits) here
    
    Dim iDirPtr%, iTagLen%, iDirLen%
    
    Dim sField$, sTags$, sTag$
    
    Dim bBottom As Boolean, bText As Boolean
    
    
    bBottom = m_bFldAtBottom
    
    FldFindPrev = False
    
    m_bFldAtTop = False
    m_bFldAtBottom = False
    m_bSfdAtTop = False
    m_bSfdAtBottom = False
    
    If Len(sNormalizedFieldText$) > 0 Then
        m_sFieldWanted$ = NormString(sNormalizedFieldText$)
        If Len(m_sFieldWanted$) > 0 Then
            bText = True
        End If
    Else
        If Len(m_sFieldWanted$) > 0 Then
            bText = True
        End If
    End If
    
    If Len(sTagToFind$) > 0 Then
        m_sTagWanted$ = UCase(RemoveRepeatedCharacters(sTagToFind$, " "))
    End If
    
    ' need the length of the "desired tag"
    If Len(m_sTagWanted$) < 1 Then
        Exit Function
    End If
    
    If Not FldWasFound Then
        If Not bBottom Then
            Exit Function
        End If
    End If
    
    If bBottom Then
        If TagCompare(m_sTagWanted$, FldTag, iTagLen%) Then
            ' found it!
            FldFindPrev = True
            Exit Function
        End If
    End If
    
    ' find the tag already
    While FldMovePrev
        'Debug.Print "FFP " + str(FldPointer)
        If Not FldDeleted Then
            If TagCompare(m_sTagWanted$, FldTag) Then
                If bText Then
                    If Mid(FldNorm, 1, Len(m_sFieldWanted$)) = m_sFieldWanted$ Then
                        FldFindPrev = True
                        Exit Function
                    End If
                Else
                    FldFindPrev = True
                    Exit Function
                End If
            End If
        End If
    Wend

    ' tag not found
    FldPointer = -1
    
End Function

Public Sub FldUndelete()

    ' 20050719: this is no longer available
    
#If False Then
    If FldPointer < 0 Then
        Exit Sub
    End If
    
    MarcArray(FldPointer).Deleted = False
#End If

End Sub

Public Sub SfdUndelete()
    
    If FldPointer < 0 Or SfdPointer < 0 Then
        Exit Sub
    End If
    
    MarcArray(FldPointer).Subfield(SfdPointer).Deleted = True

End Sub

Public Property Get FldNextTag() As String

    If FldNext > -1 Then
        FldNextTag = MarcArray(FldNext).Tag
    Else
        FldNextTag = ""
    End If

End Property


Public Property Get FldPrevTag() As String


    If FldPrev > -1 Then
        FldPrevTag = MarcArray(FldPrev).Tag
    Else
        FldPrevTag = ""
    End If


End Property

Public Function FldTestPrev(ByVal sTag$) As Boolean

    Dim iSave%
    
    Dim sSave$
    
    Dim bSave As Boolean
    
    ' see if a given field is present in the current record at some point
    '   after the current field
    
    ' unlike the 'find' functions, this does NOT move the current field pointer
    
    iSave% = FldPointer
    sSave$ = m_sTagWanted$
    bSave = FldWasFound
    
    FldFindPrev sTag$
    FldTestPrev = FldWasFound
    
    FldPointer = iSave%
    m_sTagWanted$ = sSave$
    m_bFieldWasFound = bSave

End Function

Public Function FldTestLast(sTag$) As Boolean

    Dim iSave%
    
    Dim sSave$
    
    Dim bSave As Boolean
    
    ' see if a given field is present in the current record at some point
    '   after the current field
    
    ' unlike the 'find' functions, this does NOT move the current field pointer
    
    iSave% = FldPointer
    sSave$ = m_sTagWanted$
    bSave = FldWasFound
    
    FldFindLast sTag$
    FldTestLast = FldWasFound
    
    FldPointer = iSave%
    m_sTagWanted$ = sSave$
    m_bFieldWasFound = bSave

End Function

Public Function SfdTestPrev(ByVal sSubfieldCode$) As Boolean

    Dim bSave As Boolean
    Dim iSave%
    Dim sSave$
    
    iSave% = SfdPointer
    bSave = SfdWasFound
    sSave$ = m_sSubfieldWanted$
    
    Sfdfindprev sSubfieldCode$
    SfdTestPrev = SfdWasFound
    
    SfdPointer = iSave%
    m_bSfdWasFound = bSave
    m_sSubfieldWanted$ = sSave$

End Function

Public Function Convert539To533Sfd7(ByVal sWhole539Field$) As String

    Dim sOutput$, sSfd$, sSfc$, sNextSfc$
    
    Dim iRc%, iStart%, iLength%
    
    
    ' 20040615: space substituted for fill: if a subfield is missing, that must
    '   represent code 'blank' (we could have coded a fill character if we had
    '   wanted one; but we can't code a blank in a subfield)
    'sOutput$ = String(15, MyMarcCharacter.MarcFill)
    sOutput$ = String(15, " ")
    
    sWhole539Field$ = sWhole539Field$
    If Mid(sWhole539Field$, 1, 1) <> MyMarcCharacter.MarcDelimiter Then
        sSfc$ = "a"
    Else
        sSfc$ = Mid(sWhole539Field$, 2, 1)
        sWhole539Field$ = Mid(sWhole539Field$, 3)
    End If
    
    Do
        iRc% = InStr(sWhole539Field$, MyMarcCharacter.MarcDelimiter)
        If iRc% = 0 Then
            sSfd$ = sWhole539Field$
            sWhole539Field$ = ""
            sNextSfc$ = " "
        Else
            sSfd$ = Mid(sWhole539Field$, 1, iRc% - 1)
            sNextSfc$ = Mid(sWhole539Field$, iRc% + 1, 1)
            sWhole539Field$ = Mid(sWhole539Field$, iRc% + 2)
        End If
        
        Select Case sSfc$
            Case "a" ' date type: byte 00
                iStart% = 1
                iLength% = 1
            Case "b" ' date 1: bytes 01-04
                iStart% = 2
                iLength% = 4
            Case "c" ' date 2: bytes 05-08
                iStart% = 6
                iLength% = 4
            Case "d" ' place of publication: bytes 09-11
                iStart% = 10
                iLength% = 2
            Case "e" ' frequency: byte 12
                iStart% = 13
                iLength% = 1
            Case "f" ' regularity:byte 13
                iStart% = 14
                iLength% = 1
            Case "g" ' form of item: byte 14
                iStart% = 15
                iLength% = 1
            Case Else
                iStart% = 0
        End Select
        If iStart% > 0 Then
            sOutput$ = SafeStuff(sOutput$, iStart%, iLength%, Mid(RTrim(sSfd$) + String(iLength%, MyMarcCharacter.MarcFill), 1, iLength%))
        End If
        
        If Len(sWhole539Field$) = 0 Then
            Exit Do
        End If
        sSfc$ = sNextSfc$
    Loop
    
    ' 20040615: note lack of trim--would be inappropriate
    Convert539To533Sfd7 = sOutput$
    
End Function

Public Function SfdMake(sSubfieldCode$, sSubfieldText$) As String

    sSubfieldCode$ = Trim(sSubfieldCode$) ' TRIM ok for the subfield code itself
    Select Case Len(sSubfieldCode$)
        Case 0
            SfdMake = ""
            Exit Function
        Case 1 ' these are OK
        Case Else
            If Mid(sSubfieldCode$, 1, 1) = MyMarcCharacter.MarcDelimiter Then
                sSubfieldCode$ = Mid(sSubfieldCode$, 2, 1)
            Else
                sSubfieldCode$ = Mid(sSubfieldCode$, 1, 1)
            End If
    End Select
    
    If Len(sSubfieldText$) = 0 Then
        SfdMake = ""
        Exit Function
    Else
        SfdMake = MyMarcCharacter.MarcDelimiter + sSubfieldCode$ + sSubfieldText$
    End If
    
End Function

Public Property Get FldPointer() As Integer

    FldPointer = m_iFldPointer%

End Property

Public Property Let FldPointer(ByVal vNewValue As Integer)

    Dim iPtr%
    
    m_iFldPointer% = vNewValue
        
    ' 20040526: m_iMarcCtr is always 1 more than the
    '   total number of fields in the record (the actual
    '   last field is given by m_iLastField%, which we probably should
    '   have used here instead but why change it if this works?)
    If m_iFldPointer% > -1 And m_iFldPointer% < m_iMarcCtr% Then
        SfdPointer = MarcArray(m_iFldPointer%).FirstSubfield
        m_bFieldWasFound = True
        SetSubfieldSortGroupFromTag FldTag
    Else
        m_iFldPointer% = -1
        m_bFieldWasFound = False
    End If

End Property

Public Property Get SfdPointer() As Integer

    SfdPointer = m_iSfdPointer%
    
End Property

Public Property Let SfdPointer(ByVal vNewValue As Integer)

    'Debug.Print "Setting SfdPointer to " + str(vNewValue) + " limit " + str(MarcArray(FldPointer).SubfieldLast)
    
    If FldPointer > -1 Then
        If vNewValue > -1 And vNewValue <= MarcArray(FldPointer).SubfieldLast Then
            m_iSfdPointer% = vNewValue
            m_bSfdWasFound = True
        Else
            m_iSfdPointer% = -1
            m_bSfdWasFound = False
        End If
    Else
        m_iSfdPointer% = -1
        m_bSfdWasFound = False
    End If
    
    'If m_bSfdWasFound Then
        'Debug.Print "New SFD POINTER " + FldTag + " " + " " + Str(vNewValue) + " " + Str(FldPointer) + " " + Str(MarcArray(FldPointer).SubfieldLast)
    'End If
    
    'Debug.Print "Found " + str(m_bSfdWasFound)
    
End Property

Public Function FldMoveTop() As Boolean

    If FldMoveFirst() Then
        FldMoveTop = True
        m_bFldAtTop = True
        m_bFldAtBottom = False
        m_bSfdAtTop = False
        m_bSfdAtBottom = False
    Else
        FldMoveTop = False
        m_bFldAtTop = False
        m_bFldAtBottom = False
        m_bSfdAtTop = False
        m_bSfdAtBottom = False
    End If

End Function

Public Function FldMoveBottom() As Boolean

    If FldMoveLast() Then
        FldMoveBottom = True
        m_bFldAtTop = False
        m_bFldAtBottom = True
        m_bSfdAtTop = False
        m_bSfdAtBottom = False
    Else
        FldMoveBottom = False
        m_bFldAtTop = False
        m_bFldAtBottom = False
        m_bSfdAtTop = False
        m_bSfdAtBottom = False
    End If

End Function

Public Function SfdMoveTop() As Boolean

    ' todo: there seem to be some unresolved issues with the
    '   move top and move bottom variables: we should NOT allow
    '   for output of sfdcode or sfdtext for example if we're at top or bottom
    If SfdMoveFirst() Then
        SfdMoveTop = True
        m_bSfdAtTop = True
        m_bSfdAtBottom = False
    Else
        SfdMoveTop = False
        m_bSfdAtTop = False
        m_bSfdAtBottom = False
    End If

End Function

Public Function SfdMoveBottom() As Boolean

    If SfdMoveLast() Then
        SfdMoveBottom = True
        m_bSfdAtTop = False
        m_bSfdAtBottom = True
    Else
        SfdMoveBottom = False
        m_bSfdAtTop = False
        m_bSfdAtBottom = False
    End If

End Function

Public Property Get FldDirectory() As String

    If FldPointer > -1 Then
        FldDirectory = MarcArray(FldPointer).Directory
    Else
        FldDirectory = ""
    End If
    
End Property



Public Function HexDisplay2Marc(ByVal sField$) As String

    ' convert a piece of text in 'displayable' form as created by
    '   the function Marc2HexDisplay into
    '   its original format
    ' high-end charcters which are in the form "\&H" plus a numeric code become
    '   the original characters again

    ' this is the reverse of the Marc2HexDisplay function
    
    Dim lPtr As Long, lLen As Long
    
    Dim iCharLen%, iVal%, iLoop%
    
    Dim sOutput$, sChar$

    sOutput$ = sField$
    
    Do
        lPtr = InStr(sOutput$, "\&H")
        If lPtr = 0 Then
            Exit Do
        End If
        sOutput$ = SafeStuff(sOutput$, lPtr, 5, MyMarcCharacter.Hex2Char(Mid(sOutput$, lPtr + 3, 2)))
    Loop
    
    
    Do
        lPtr = InStr(sOutput$, "|")
        If lPtr = 0 Then
            Exit Do
        End If
        sOutput$ = SafeStuff(sOutput$, lPtr, 1, MyMarcCharacter.MarcDelimiter)
    Loop
    
    HexDisplay2Marc = sOutput$

End Function

Public Function LastNondiacriticCharacter(sMarcString$) As String

    ' returns the last character in a given MARC string (MARC-8 or UTF-8) that
    '   is not a diacritic
    
    ' 20040119: added for UTF-8 conversion
    
    
    Dim lPtr As Long
    
    If m_bUtf8 Then
        lPtr = Len(sMarcString$)
        Do
            lPtr = MyMarcCharacter.Utf8CharFindFirstOctet(sMarcString$, lPtr)
            If lPtr > 0 Then
                MyMarcCharacter.Utf8Char = Mid(sMarcString$, lPtr)
                If MyMarcCharacter.Utf8CharCategory <> "Mn" Then ' todo: check this code
                    LastNondiacriticCharacter = MyMarcCharacter.Utf8Char
                    Exit Do
                End If
                lPtr = lPtr - 1
            Else
                Exit Do
            End If
        Loop
    Else ' diacritics always come BEFORE the character
        LastNondiacriticCharacter = Right(sMarcString$, 1)
    End If

End Function

Public Function CharIsNumeric(ByVal sInChar$, Optional ByRef iReturnValue% = -99) As Boolean

    ' entry point for characters in either MARC-8 (any flavor) or UTF-8
    
    ' decides whether a character is numeric or not, and if so, what its value might be
    
    
    Dim sChar$
    
    Dim iRc%
    
    
    CharIsNumeric = False
    
    If Not m_bUtf8 Then
        sChar$ = Mid(sInChar$, 1, 1) ' all are one byte long
CharIsNumericRetrySubSuper:
        If Len(sChar$) = 0 Then ' nothing supplied!
            Exit Function
        End If
        iRc% = InStr(Const_NumString$, sChar$) ' plain numeral?
        If iRc% = 0 Then
            iRc% = InStr(Voyager_Superscripts$, iRc%)
            If iRc% = 0 Then
                iRc% = InStr(Voyager_Subscripts$, sChar$)
            End If
        End If
        If iRc% > 0 And iRc% < 11 Then ' exclude super/sub punctuation: numeral of some kind
            CharIsNumeric = True
            If iReturnValue% <> -99 Then
                iReturnValue% = iRc%
            End If
            Exit Function
        End If
        ' one more possibility: an escape sequence
        ' this MAY be too fancy
        If sChar$ = MarcEscape And Len(sInChar$) > 2 Then
            sChar$ = Mid(sInChar$, 3)
            GoTo CharIsNumericRetrySubSuper
        End If
    Else ' UTF-8
         ' use built-in function
         MyMarcCharacter.Utf8Char = sInChar$
         If MyMarcCharacter.Utf8CharCategory = "Nd" Then
            CharIsNumeric = True
            ' hope for the best here!
            If iReturnValue% <> -99 Then
                iReturnValue% = MyMarcCharacter.Utf8CharVal
            End If
         End If
    End If
    
End Function

Public Sub FldLoadInfo(ByRef sTag$, ByRef sIndicators$, ByRef sField$)

    ' return in one move the three field pieces
    
    sTag$ = FldTag
    sIndicators$ = FldInd
    sField$ = FldText
    
End Sub

Public Function CharIsAlpha(ByVal sInChar$) As Boolean

    ' entry point for characters in either MARC-8 (any flavor) or UTF-8
    
    ' decides whether a character is alphabetic or not
    
    
    Dim sChar$
    
    
    CharIsAlpha = False
    
    If Not m_bUtf8 Then
        sChar$ = Mid(sInChar$, 1, 1)
        If Len(sChar$) = 0 Then ' nothing supplied!
            Exit Function ' with default return value False
        End If
        If InStr(CONST_UpperCaseAlpha$, sChar$) > 0 Or InStr(CONST_LowerCaseAlpha$, sChar$) > 0 Or InStr(CONST_UpperEndUpperCase$, sChar$) > 0 Or InStr(CONST_UpperEndLowerCase$, sChar$) > 0 Then
            CharIsAlpha = True
        End If
    Else ' UTF-8
         MyMarcCharacter.Utf8Char = sInChar$
         If Mid(MyMarcCharacter.Utf8CharCategory, 1, 1) = "L" Then
            CharIsAlpha = True
         End If
    End If

End Function

Public Function CharIsUpper(ByVal sInChar$) As Boolean

    ' entry point for characters in either MARC-8 (any flavor) or UTF-8
    
    ' decides whether a character is uppercase or not
    
    
    Dim sChar$
    
    
    CharIsUpper = False
    
    If Not m_bUtf8 Then
        sChar$ = Mid(sInChar$, 1, 1)
        If Len(sChar$) = 0 Then ' nothing supplied!
            Exit Function
        End If
        If InStr(CONST_UpperCaseAlpha$, sChar$) > 0 Or InStr(CONST_UpperEndUpperCase$, sChar$) > 0 Then
            CharIsUpper = True
        End If
    Else ' UTF-8
        MyMarcCharacter.Utf8Char = sInChar$
        If InStr("Lu Lt", MyMarcCharacter.Utf8CharCategory) > 0 Then
           CharIsUpper = True
        End If
    End If
        

End Function

Public Function CharIsLower(sInChar$) As Boolean

    ' entry point for characters in either MARC-8 (any flavor) or UTF-8
    
    ' decides whether a character is uppercase or not
    
    
    Dim sChar$
    
    
    CharIsLower = False
    
    If Not m_bUtf8 Then
        sChar$ = Mid(sInChar$, 1, 1)
        If Len(sChar$) = 0 Then ' nothing supplied!
            Exit Function
        End If
        If InStr(CONST_LowerCaseAlpha$, sChar$) > 0 Or InStr(CONST_UpperEndLowerCase$, sChar$) > 0 Then
            CharIsLower = True
        End If
    Else ' UTF-8
        MyMarcCharacter.Utf8Char = sInChar$
        If MyMarcCharacter.Utf8CharCategory = "Ll" Then
           CharIsLower = True
        End If
    End If

End Function
Public Property Get MarcUmlaut() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcUmlaut = MyMarcCharacter.Utf8Umlaut
    Else
        MarcUmlaut = MyMarcCharacter.Marc8Umlaut
    End If
    
End Property


Public Property Get AustralianSubdivisionPractice() As Boolean

    AustralianSubdivisionPractice = m_bAustralianSubdivisionPractice

End Property

Public Property Let AustralianSubdivisionPractice(ByVal vNewValue As Boolean)

    m_bAustralianSubdivisionPractice = vNewValue
    
End Property

Public Function Marc2MsoftAscii(ByVal sIn$, Optional sFlavor As Marc2MsoftAsciiType = Latin1Text) As String

    ' this function is used for DISPLAY PURPOSES ONLY. the result
    '   of this function is not reversible
    
    Dim sJunk$, sFiller$
    
    Dim iLen%
    
    Dim lPtr As Long
    
    Dim lChr As Currency
    
    
#If Marc2MsoftAsciiDebug = -1 Then
    Debug.Print "M2MSoftA >" + sIn$ + "< " + str(m_bUtf8)
#End If

    ' if we're asked for the "extended Latin 1" display, we're going to
    '   represent non-displayable characters with an arbitrary
    '   symbol
    ' chr(149) appears as a fat medial dot
    If sFlavor = latin1textextended Or sFlavor = Latin1TextWithDots Then
        sFiller$ = Chr(149)
    End If
    
    
    If Not m_bUtf8 Then
    
        For lPtr = Len(sIn$) To 1 Step -1
            lChr = Asc(Mid(sIn$, lPtr, 1))
            Select Case lChr
                Case 31 ' delimiter
                    sIn$ = SafeStuff(sIn$, lPtr, 1, "|")
                    ' add spaces around the delimiter, too
                    If lPtr > 1 Then
                        If Mid(sIn$, lPtr - 1, 1) <> " " Then
                            sIn$ = SafeStuff(sIn$, lPtr, 0, " ")
                        End If
                    End If
                    If Mid(sIn$, lPtr + 2, 1) <> " " Then
                        sIn$ = SafeStuff(sIn$, lPtr + 2, 0, " ")
                    End If
                Case Is < 128
                    ' keep all of these as is
                Case Is < 160
                    Select Case lChr
                        Case 144 ' degree sign
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(176))
                        Case 145 ' script l
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "l")
                        Case 146 ' pressing
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "(p)")
                        Case 147 ' copyright
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(169))
                        Case 148 ' sharp
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "#")
                        Case 149 ' inverted question mark
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(191))
                        Case 150 ' inverted bang
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(161))
                        Case Else
                            sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                    End Select
                Case Is < 176
                    Select Case lChr
                        Case 160
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "l")
                        Case 161
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "L")
                        Case 162
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(216))
                        Case 163 ' slash-D
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(208))
                        Case 164 ' thorn
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(222))
                        Case 165 ' AE
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(198))
                        Case 166 ' OE
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(140))
                        Case 167 ' miag. znak
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(146))
                        ' 168: medial dot
                        Case 169
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "flat")
                        Case 170 ' registered
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(174))
                        Case 171 ' plus/minus
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(177))
                        Case 172 ' hook-O
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "O")
                        Case 173 'hook-U
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "U")
                        Case 174 ' ayin
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "'")
                        Case 175 ' alpha
                            sIn$ = SafeStuff(sIn$, lPtr, 1, " alpha")
                        Case Else
                            sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                    End Select
                Case Is < 192
                    Select Case lChr
                        Case 176 ' alif
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "'")
                        Case 177 ' slash-l
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "l")
                        Case 178 ' slash-o
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(248))
                        Case 179 ' lower-case slash-d
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "d")
                        Case 180 ' lowercase eth
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(254))
                        Case 181 'ae
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(230))
                        Case 182 ' oe
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(156))
                        Case 183 'tverd. znak
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(148))
                        Case 184 ' turkish dotless i
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "i")
                        Case 185 ' pound sign
                            sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(163))
                        Case 186 ' eth
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(240))
                        Case 188 ' hook o
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "o")
                        Case 189 ' hook u
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "u")
                        Case 190 ' beta
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(223))
                        Case 191 ' gamma
                            sIn$ = SafeStuff(sIn$, lPtr, 1, " gamma ")
                        Case Else
                            sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                    End Select
                Case Is < 208
                    Select Case lChr
                        Case 192
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "0")
                        Case 193
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "1")
                        Case 194
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "2")
                        Case 195
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "3")
                        Case 196
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "4")
                        Case 197
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "5")
                        Case 198
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "6")
                        Case 199
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "7")
                        Case 200
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "8")
                        Case 201
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "9")
                        Case 202
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "+")
                        Case 203
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "-")
                        Case 204
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "(")
                        Case 205
                            sIn$ = SafeStuff(sIn$, lPtr, 1, ")")
                        Case Else
                            sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                    End Select
                Case Is < 224
                    Select Case lChr
                        Case 208
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "0")
                        Case 209
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "1")
                        Case 210
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "2")
                        Case 211
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "3")
                        Case 212
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "4")
                        Case 213
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "5")
                        Case 214
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "6")
                        Case 215
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "7")
                        Case 216
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "8")
                        Case 217
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "9")
                        Case 218
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "+")
                        Case 219
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "-")
                        Case 220
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "(")
                        Case 221
                            sIn$ = SafeStuff(sIn$, lPtr, 1, ")")
                        Case Else
                            sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                    End Select
                Case Else ' two columns at once!
                    Select Case lChr
                        Case 225 ' grave
                            Select Case Mid(sIn$, lPtr + 1, 1)
                                Case "A"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(192))
                                Case "E"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(200))
                                Case "I"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(204))
                                Case "O"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(210))
                                Case "U"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(217))
                                Case "a"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(224))
                                Case "e"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(232))
                                Case "i"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(236))
                                Case "o"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(242))
                                Case "u"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(249))
                                Case Else
                                    sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                            End Select
                        Case 226 ' acute
                            'Debug.Print "Acute >" + Mid(sIn$, lPtr) + "<"
                            Select Case Mid(sIn$, lPtr + 1, 1)
                                Case "A"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(193))
                                Case "E"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(201))
                                Case "I"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(205))
                                Case "O"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(211))
                                Case "U"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(218))
                                Case "Y"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(221))
                                Case "a"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(225))
                                Case "e"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(233))
                                Case "i"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(237))
                                Case "o"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(243))
                                Case "u"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(250))
                                Case "y"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(253))
                                Case Else
                                    sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                            End Select
                        Case 227 ' circumflex
                            Select Case Mid(sIn$, lPtr + 1, 1)
                                Case "A"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(194))
                                Case "E"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(202))
                                Case "I"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(206))
                                Case "O"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(212))
                                Case "U"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(219))
                                Case "a"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(226))
                                Case "e"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(234))
                                Case "i"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(238))
                                Case "o"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(244))
                                Case "u"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(251))
                                Case Else
                                    sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                            End Select
                        Case 228 ' tilde
                            Select Case Mid(sIn$, lPtr + 1, 1)
                                Case "A"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(195))
                                Case "N"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(209))
                                Case "O"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(213))
                                Case "a"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(227))
                                Case "n"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(241))
                                Case "o"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(245))
                                Case Else
                                    sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                            End Select
                        Case 232 ' umlaut
                            Select Case Mid(sIn$, lPtr + 1, 1)
                                Case "A"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(196))
                                Case "E"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(203))
                                Case "I"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(207))
                                Case "O"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(214))
                                Case "U"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(220))
                                Case "Y"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(159))
                                Case "a"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(228))
                                Case "e"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(235))
                                Case "i"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(239))
                                Case "o"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(246))
                                Case "u"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(252))
                                Case "y"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(255))
                                Case Else
                                    sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                            End Select
                        Case 234 ' angstrom
                            Select Case Mid(sIn$, lPtr + 1, 1)
                                Case "A"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(197))
                                Case "a"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(229))
                                Case Else
                                    sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                            End Select
                        Case 233 ' hacek
                            Select Case Mid(sIn$, lPtr + 1, 1)
                                Case "S"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(138))
                                Case "Z"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(142))
                                Case "s"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(154))
                                Case "z"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(158))
                                Case Else
                                    sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                            End Select
                        Case 240 ' cedilla
                            Select Case Mid(sIn$, lPtr + 1, 1)
                                Case "C"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(199))
                                Case "c"
                                    sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(231))
                                Case Else
                                    sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                            End Select
                        Case 246 ' wrong underscore
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(95))
                        Case Else
                            sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                    End Select
            End Select ' the main groups
        Next ' lPtr
    
    Else ' UTF-8 character representation
    
        ' we're going to progress from right to left
        lPtr = Len(sIn$) - 1
        Do
            lPtr = MyMarcCharacter.Utf8CharFindFirstOctet(sIn$, lPtr)
            If lPtr < 1 Then
                Exit Do
            End If
#If Marc2MsoftAsciiDebug = -1 Then
            DoEvents
#End If
            MyMarcCharacter.Utf8Char = Mid(sIn$, lPtr)
            iLen% = MyMarcCharacter.Utf8CharOctets
#If Marc2MsoftAsciiDebug = -1 Then
            Debug.Print str(lPtr) + " " + str(iLen%) + " >" + sIn$ + "<"
#End If
            
            lChr = MyMarcCharacter.Utf8CharAsc
            Select Case lChr
                Case 31 ' delimiter
                    sIn$ = SafeStuff(sIn$, lPtr, 1, "|")
                    ' add spaces around the delimiter, too
                    If Mid(sIn$, lPtr + 2, 1) <> " " Then
                        sIn$ = SafeStuff(sIn$, lPtr + 2, 0, " ")
                    End If
                    If lPtr > 1 Then
                        If Mid(sIn$, lPtr - 1, 1) <> " " Then
                            sIn$ = SafeStuff(sIn$, lPtr, 0, " ")
                        End If
                    End If
                Case Is < 128
                    ' keep all of these as is
                Case Else ' these are all multiple-byte characters in Utf-8
                    ' 20050815: in the past we used the single-byte characters to
                    '   represent base-plus-diacritic combinations; but if we're working
                    '   in UTF-8 then we should really use the UTF-8 versions, shouldn't we?
                    If sFlavor = Latin1TextWithDots Then
#If Marc2MsoftAsciiDebug = -1 Then
                        Debug.Print str(lPtr) + " " + str(iLen%) + " >" + sIn$ + "< substituting dot"
#End If
                        Select Case MyMarcCharacter.Utf8Char
                            Case MyMarcCharacter.Utf8AELower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(230))
                            Case MyMarcCharacter.Utf8AEUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(198))
                            Case MyMarcCharacter.Utf8Alif, MyMarcCharacter.Utf8Ayn
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "'")
                            Case MyMarcCharacter.Utf8Alpha
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "alpha")
                            Case MyMarcCharacter.Utf8Beta
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(223))
                            Case MyMarcCharacter.Utf8BritishPound
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(163))
                            Case MyMarcCharacter.Utf8Copyright
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(169))
                            Case MyMarcCharacter.Utf8DSlashUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(208))
                            Case MyMarcCharacter.Utf8DSlashLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(240))
                            Case MyMarcCharacter.Utf8Degree
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(176))
                            Case MyMarcCharacter.Utf8ExclamationInverted
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(161))
                            Case MyMarcCharacter.Utf8Flat
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "flat")
                            Case MyMarcCharacter.Utf8Gamma
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "gamma")
                            Case MyMarcCharacter.Utf8IDotless
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "i")
                            Case MyMarcCharacter.Utf8LScript
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "l")
                            Case MyMarcCharacter.Utf8LSlashLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "l")
                            Case MyMarcCharacter.Utf8LSlashUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "L")
                            Case MyMarcCharacter.Utf8MiagkiiZnak
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(146))
                            Case MyMarcCharacter.Utf8OEUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(140))
                            Case MyMarcCharacter.Utf8OELower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(156))
                            Case MyMarcCharacter.Utf8OHookLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "o")
                            Case MyMarcCharacter.Utf8OHookUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "O")
                            Case MyMarcCharacter.Utf8PlusMinus
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(177))
                            Case MyMarcCharacter.Utf8Pressing
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "(p)")
                            Case MyMarcCharacter.Utf8QuestionInverted
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(191))
                            Case MyMarcCharacter.Utf8Registered
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(174))
                            Case MyMarcCharacter.Utf8Sharp
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "#")
                            Case MyMarcCharacter.Utf8OSlashLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(248))
                            Case MyMarcCharacter.Utf8OSlashUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(216))
                            Case MyMarcCharacter.Utf8Subscript0
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "0")
                            Case MyMarcCharacter.Utf8Subscript1
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "1")
                            Case MyMarcCharacter.Utf8Subscript2
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "2")
                            Case MyMarcCharacter.Utf8Subscript3
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "3")
                            Case MyMarcCharacter.Utf8Subscript4
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "4")
                            Case MyMarcCharacter.Utf8Subscript5
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "5")
                            Case MyMarcCharacter.Utf8Subscript6
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "6")
                            Case MyMarcCharacter.Utf8Subscript7
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "7")
                            Case MyMarcCharacter.Utf8Subscript8
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "8")
                            Case MyMarcCharacter.Utf8Subscript9
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "9")
                            Case MyMarcCharacter.Utf8SubscriptParensLeft
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "(")
                            Case MyMarcCharacter.Utf8SubscriptParensRight
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, ")")
                            Case MyMarcCharacter.Utf8SubscriptPlus
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "+")
                            Case MyMarcCharacter.Utf8SubscriptMinus
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "-")
                            Case MyMarcCharacter.Utf8Superscript0
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(186))
                            Case MyMarcCharacter.Utf8Superscript1
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(185))
                            Case MyMarcCharacter.Utf8Superscript2
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(178))
                            Case MyMarcCharacter.Utf8Superscript3
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(179))
                            Case MyMarcCharacter.Utf8Superscript4
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "4")
                            Case MyMarcCharacter.Utf8Superscript5
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "5")
                            Case MyMarcCharacter.Utf8Superscript6
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "6")
                            Case MyMarcCharacter.Utf8Superscript7
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "7")
                            Case MyMarcCharacter.Utf8Superscript8
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "8")
                            Case MyMarcCharacter.Utf8Superscript9
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "9")
                            Case MyMarcCharacter.Utf8SuperscriptParensLeft
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "(")
                            Case MyMarcCharacter.Utf8SuperscriptParensRight
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, ")")
                            Case MyMarcCharacter.Utf8SuperscriptPlus
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "+")
                            Case MyMarcCharacter.Utf8SuperscriptMinus
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "-")
                            Case MyMarcCharacter.Utf8ThornLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(222))
                            Case MyMarcCharacter.Utf8ThornUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(254))
                            Case MyMarcCharacter.Utf8TvyerdiZnak
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(148))
                            Case MyMarcCharacter.Utf8UHookLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "u")
                            Case MyMarcCharacter.Utf8UHookUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "U")
                            Case Else ' diacritic; other unrecognized character of any type
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                        End Select
                    ElseIf sFlavor = Latin1Text Then
                        Select Case MyMarcCharacter.Utf8Char
                            Case MyMarcCharacter.Utf8Acute
                                If lPtr > 1 Then
                                    Select Case Mid(sIn$, lPtr - 1, 1)
                                        Case "a"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(225))
                                            lPtr = lPtr - 1
                                        Case "A"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(193))
                                            lPtr = lPtr - 1
                                        Case "e"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(233))
                                            lPtr = lPtr - 1
                                        Case "E"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(201))
                                            lPtr = lPtr - 1
                                        Case "i"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(237))
                                            lPtr = lPtr - 1
                                        Case "I"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(205))
                                            lPtr = lPtr - 1
                                        Case "o"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(243))
                                            lPtr = lPtr - 1
                                        Case "O"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(211))
                                            lPtr = lPtr - 1
                                        Case "u"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(250))
                                            lPtr = lPtr - 1
                                        Case "U"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(218))
                                            lPtr = lPtr - 1
                                        Case "y"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(253))
                                            lPtr = lPtr - 1
                                        Case "Y"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(221))
                                            lPtr = lPtr - 1
                                        Case Else
                                            sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                    End Select
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                End If
                            Case MyMarcCharacter.Utf8AELower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(230))
                            Case MyMarcCharacter.Utf8AEUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(198))
                            Case MyMarcCharacter.Utf8Angstrom
                                If lPtr > 1 Then
                                    Select Case Mid(sIn$, lPtr - 1, 1)
                                        Case "a"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(229))
                                            lPtr = lPtr - 1
                                        Case "A"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(197))
                                            lPtr = lPtr - 1
                                        Case Else
                                            sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                    End Select
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                End If
                            Case MyMarcCharacter.Utf8Alif, MyMarcCharacter.Utf8Ayn
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "'")
                            Case MyMarcCharacter.Utf8Alpha
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "alpha")
                            Case MyMarcCharacter.Utf8Beta
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(223))
                            Case MyMarcCharacter.Utf8BritishPound
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(163))
                            Case MyMarcCharacter.Utf8Cedilla
                                If lPtr > 1 Then
                                    Select Case Mid(sIn$, lPtr - 1, 1)
                                        Case "c"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(231))
                                            lPtr = lPtr - 1
                                        Case "C"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(199))
                                            lPtr = lPtr - 1
                                        Case Else
                                            sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                    End Select
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                End If
                            Case MyMarcCharacter.Utf8Circumflex
                                If lPtr > 1 Then
                                    Select Case Mid(sIn$, lPtr - 1, 1)
                                        Case "a"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(226))
                                            lPtr = lPtr - 1
                                        Case "A"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(194))
                                            lPtr = lPtr - 1
                                        Case "e"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(234))
                                            lPtr = lPtr - 1
                                        Case "E"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(202))
                                            lPtr = lPtr - 1
                                        Case "i"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(238))
                                            lPtr = lPtr - 1
                                        Case "I"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(206))
                                            lPtr = lPtr - 1
                                        Case "o"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(244))
                                            lPtr = lPtr - 1
                                        Case "O"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(212))
                                            lPtr = lPtr - 1
                                        Case "u"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(251))
                                            lPtr = lPtr - 1
                                        Case "U"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(219))
                                            lPtr = lPtr - 1
                                        Case Else
                                            sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                    End Select
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                End If
                            Case MyMarcCharacter.Utf8Copyright
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(169))
                            Case MyMarcCharacter.Utf8DSlashUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(208))
                            Case MyMarcCharacter.Utf8DSlashLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(240))
                            Case MyMarcCharacter.Utf8Degree
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(176))
                            Case MyMarcCharacter.Utf8ExclamationInverted
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(161))
                            Case MyMarcCharacter.Utf8Flat
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "flat")
                            Case MyMarcCharacter.Utf8Gamma
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "gamma")
                            Case MyMarcCharacter.Utf8Grave
                                If lPtr > 1 Then
                                    Select Case Mid(sIn$, lPtr - 1, 1)
                                        Case "a"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(224))
                                            lPtr = lPtr - 1
                                        Case "A"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(192))
                                            lPtr = lPtr - 1
                                        Case "e"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(232))
                                            lPtr = lPtr - 1
                                        Case "E"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(200))
                                            lPtr = lPtr - 1
                                        Case "i"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(236))
                                            lPtr = lPtr - 1
                                        Case "I"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(204))
                                            lPtr = lPtr - 1
                                        Case "o"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(242))
                                            lPtr = lPtr - 1
                                        Case "O"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(210))
                                            lPtr = lPtr - 1
                                        Case "u"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(249))
                                            lPtr = lPtr - 1
                                        Case "U"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(217))
                                            lPtr = lPtr - 1
                                        Case Else
                                            sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                    End Select
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                End If
                            Case MyMarcCharacter.Utf8Hacek
                                If lPtr > 1 Then
                                    Select Case Mid(sIn$, lPtr - 1, 1)
                                        Case "s"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(154))
                                            lPtr = lPtr - 1
                                        Case "S"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(138))
                                            lPtr = lPtr - 1
                                        Case "z"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(158))
                                            lPtr = lPtr - 1
                                        Case "Z"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(142))
                                            lPtr = lPtr - 1
                                        Case Else
                                            sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                    End Select
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                End If
                            Case MyMarcCharacter.Utf8IDotless
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "i")
                            Case MyMarcCharacter.Utf8LScript
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "l")
                            Case MyMarcCharacter.Utf8LSlashLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "l")
                            Case MyMarcCharacter.Utf8LSlashUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "L")
                            Case MyMarcCharacter.Utf8MiagkiiZnak
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(146))
                            Case MyMarcCharacter.Utf8OEUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(140))
                            Case MyMarcCharacter.Utf8OELower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(156))
                            Case MyMarcCharacter.Utf8OHookLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "o")
                            Case MyMarcCharacter.Utf8OHookUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "O")
                            Case MyMarcCharacter.Utf8PlusMinus
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(177))
                            Case MyMarcCharacter.Utf8Pressing
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "(p)")
                            Case MyMarcCharacter.Utf8QuestionInverted
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(191))
                            Case MyMarcCharacter.Utf8Registered
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(174))
                            Case MyMarcCharacter.Utf8Sharp
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "#")
                            Case MyMarcCharacter.Utf8OSlashLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(248))
                            Case MyMarcCharacter.Utf8OSlashUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(216))
                            Case MyMarcCharacter.Utf8Subscript0
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "0")
                            Case MyMarcCharacter.Utf8Subscript1
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "1")
                            Case MyMarcCharacter.Utf8Subscript2
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "2")
                            Case MyMarcCharacter.Utf8Subscript3
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "3")
                            Case MyMarcCharacter.Utf8Subscript4
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "4")
                            Case MyMarcCharacter.Utf8Subscript5
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "5")
                            Case MyMarcCharacter.Utf8Subscript6
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "6")
                            Case MyMarcCharacter.Utf8Subscript7
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "7")
                            Case MyMarcCharacter.Utf8Subscript8
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "8")
                            Case MyMarcCharacter.Utf8Subscript9
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "9")
                            Case MyMarcCharacter.Utf8SubscriptParensLeft
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "(")
                            Case MyMarcCharacter.Utf8SubscriptParensRight
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, ")")
                            Case MyMarcCharacter.Utf8SubscriptPlus
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "+")
                            Case MyMarcCharacter.Utf8SubscriptMinus
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "-")
                            Case MyMarcCharacter.Utf8Superscript0
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(186))
                            Case MyMarcCharacter.Utf8Superscript1
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(185))
                            Case MyMarcCharacter.Utf8Superscript2
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(178))
                            Case MyMarcCharacter.Utf8Superscript3
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(179))
                            Case MyMarcCharacter.Utf8Superscript4
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "4")
                            Case MyMarcCharacter.Utf8Superscript5
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "5")
                            Case MyMarcCharacter.Utf8Superscript6
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "6")
                            Case MyMarcCharacter.Utf8Superscript7
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "7")
                            Case MyMarcCharacter.Utf8Superscript8
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "8")
                            Case MyMarcCharacter.Utf8Superscript9
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "9")
                            Case MyMarcCharacter.Utf8SuperscriptParensLeft
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "(")
                            Case MyMarcCharacter.Utf8SuperscriptParensRight
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, ")")
                            Case MyMarcCharacter.Utf8SuperscriptPlus
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "+")
                            Case MyMarcCharacter.Utf8SuperscriptMinus
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "-")
                            Case MyMarcCharacter.Utf8ThornLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(222))
                            Case MyMarcCharacter.Utf8ThornUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(254))
                            Case MyMarcCharacter.Utf8Tilde
                                If lPtr > 1 Then
                                    Select Case Mid(sIn$, lPtr - 1, 1)
                                        Case "a"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(227))
                                            lPtr = lPtr - 1
                                        Case "A"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(195))
                                            lPtr = lPtr - 1
                                        Case "n"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(241))
                                            lPtr = lPtr - 1
                                        Case "N"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(209))
                                            lPtr = lPtr - 1
                                        Case "o"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(245))
                                            lPtr = lPtr - 1
                                        Case "O"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(213))
                                            lPtr = lPtr - 1
                                        Case Else
                                            sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                    End Select
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                End If
                            Case MyMarcCharacter.Utf8TvyerdiZnak
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(148))
                            Case MyMarcCharacter.Utf8UHookLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "u")
                            Case MyMarcCharacter.Utf8UHookUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "U")
                            Case MyMarcCharacter.Utf8Umlaut
                                If lPtr > 1 Then
                                    Select Case Mid(sIn$, lPtr - 1, 1)
                                        Case "a"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(228))
                                            lPtr = lPtr - 1
                                        Case "A"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(196))
                                            lPtr = lPtr - 1
                                        Case "e"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(235))
                                            lPtr = lPtr - 1
                                        Case "E"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(203))
                                            lPtr = lPtr - 1
                                        Case "i"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(239))
                                            lPtr = lPtr - 1
                                        Case "I"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(207))
                                            lPtr = lPtr - 1
                                        Case "o"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(246))
                                            lPtr = lPtr - 1
                                        Case "O"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(214))
                                            lPtr = lPtr - 1
                                        Case "u"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(252))
                                            lPtr = lPtr - 1
                                        Case "U"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(220))
                                            lPtr = lPtr - 1
                                        Case "y"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(255))
                                            lPtr = lPtr - 1
                                        Case "Y"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, Chr(159))
                                            lPtr = lPtr - 1
                                        Case Else
                                            sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                    End Select
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                End If
                            Case Else ' unrecognized character of any type
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                        End Select
                    Else ' we must want output using UTF-8 equivalents
                        Select Case MyMarcCharacter.Utf8Char
                            Case MyMarcCharacter.Utf8Acute
                                If lPtr > 1 Then
                                    Select Case Mid(sIn$, lPtr - 1, 1)
                                        Case "a"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00E1"))
                                            lPtr = lPtr - 1
                                        Case "A"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00C1"))
                                            lPtr = lPtr - 1
                                        Case "e"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00E9"))
                                            lPtr = lPtr - 1
                                        Case "E"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00C9"))
                                            lPtr = lPtr - 1
                                        Case "i"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00ED"))
                                            lPtr = lPtr - 1
                                        Case "I"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00CD"))
                                            lPtr = lPtr - 1
                                        Case "o"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00F3"))
                                            lPtr = lPtr - 1
                                        Case "O"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00D3"))
                                            lPtr = lPtr - 1
                                        Case "u"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00FA"))
                                            lPtr = lPtr - 1
                                        Case "U"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00DA"))
                                            lPtr = lPtr - 1
                                        Case "y"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00FD"))
                                            lPtr = lPtr - 1
                                        Case "Y"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00DD"))
                                            lPtr = lPtr - 1
                                        Case Else
#If Marc2MsoftAsciiDebug = -1 Then
                                            Debug.Print "Using filler >" + sFiller$ + "< at " + str(lPtr) + " for " + str(iLen%) + " >" + sIn$ + "<"
#End If
                                            sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                    End Select
                                Else ' first character in string
                                    sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                End If
                            Case MyMarcCharacter.Utf8AELower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00E6"))
                            Case MyMarcCharacter.Utf8AEUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00C6"))
                            Case MyMarcCharacter.Utf8Angstrom
                                If lPtr > 1 Then
                                    Select Case Mid(sIn$, lPtr - 1, 1)
                                        Case "a"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00E5"))
                                            lPtr = lPtr - 1
                                        Case "A"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00C5"))
                                            lPtr = lPtr - 1
                                        Case Else
                                            sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                    End Select
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                End If
                            Case MyMarcCharacter.Utf8Alif, MyMarcCharacter.Utf8Ayn
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "'")
                            Case MyMarcCharacter.Utf8Alpha
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "alpha")
                            Case MyMarcCharacter.Utf8Beta
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "beta")
                            Case MyMarcCharacter.Utf8BritishPound
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00AE"))
                            Case MyMarcCharacter.Utf8Cedilla
                                If lPtr > 1 Then
                                    Select Case Mid(sIn$, lPtr - 1, 1)
                                        Case "c"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00E7"))
                                            lPtr = lPtr - 1
                                        Case "C"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00C7"))
                                            lPtr = lPtr - 1
                                        Case Else
                                            sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                    End Select
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                End If
                            Case MyMarcCharacter.Utf8Circumflex
                                If lPtr > 1 Then
                                    Select Case Mid(sIn$, lPtr - 1, 1)
                                        Case "a"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00E2"))
                                            lPtr = lPtr - 1
                                        Case "A"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00C2"))
                                            lPtr = lPtr - 1
                                        Case "e"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00EA"))
                                            lPtr = lPtr - 1
                                        Case "E"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00CA"))
                                            lPtr = lPtr - 1
                                        Case "i"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00EE"))
                                            lPtr = lPtr - 1
                                        Case "I"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00CE"))
                                            lPtr = lPtr - 1
                                        Case "o"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00F4"))
                                            lPtr = lPtr - 1
                                        Case "O"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00D4"))
                                            lPtr = lPtr - 1
                                        Case "u"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00FB"))
                                            lPtr = lPtr - 1
                                        Case "U"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00DB"))
                                            lPtr = lPtr - 1
                                        Case Else
                                            sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                    End Select
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                End If
                            Case MyMarcCharacter.Utf8Copyright
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00A9"))
                            Case MyMarcCharacter.Utf8DSlashUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00D0"))
                            Case MyMarcCharacter.Utf8DSlashLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00F0"))
                            Case MyMarcCharacter.Utf8Degree
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00B0"))
                            Case MyMarcCharacter.Utf8ExclamationInverted
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00A1"))
                            Case MyMarcCharacter.Utf8Flat
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "flat")
                            Case MyMarcCharacter.Utf8Gamma
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "gamma")
                            Case MyMarcCharacter.Utf8Grave
                                If lPtr > 1 Then
                                    Select Case Mid(sIn$, lPtr - 1, 1)
                                        Case "a"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00E0"))
                                            lPtr = lPtr - 1
                                        Case "A"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00C0"))
                                            lPtr = lPtr - 1
                                        Case "e"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00E8"))
                                            lPtr = lPtr - 1
                                        Case "E"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00C8"))
                                            lPtr = lPtr - 1
                                        Case "i"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00EC"))
                                            lPtr = lPtr - 1
                                        Case "I"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00CC"))
                                            lPtr = lPtr - 1
                                        Case "o"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00F2"))
                                            lPtr = lPtr - 1
                                        Case "O"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00D2"))
                                            lPtr = lPtr - 1
                                        Case "u"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00F9"))
                                            lPtr = lPtr - 1
                                        Case "U"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00D9"))
                                            lPtr = lPtr - 1
                                        Case Else
                                            sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                    End Select
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                End If
                            Case MyMarcCharacter.Utf8Hacek
                                If lPtr > 1 Then
                                    Select Case Mid(sIn$, lPtr - 1, 1)
                                        Case "s"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, "s")
                                            lPtr = lPtr - 1
                                        Case "S"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, "S")
                                            lPtr = lPtr - 1
                                        Case "z"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, "z")
                                            lPtr = lPtr - 1
                                        Case "Z"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, "Z")
                                            lPtr = lPtr - 1
                                        Case Else
                                            sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                    End Select
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                End If
                            Case MyMarcCharacter.Utf8IDotless
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "i")
                            Case MyMarcCharacter.Utf8LScript
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "l")
                            Case MyMarcCharacter.Utf8LSlashLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "l")
                            Case MyMarcCharacter.Utf8LSlashUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "L")
                            Case MyMarcCharacter.Utf8MiagkiiZnak
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "'")
                            Case MyMarcCharacter.Utf8OEUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "OE")
                            Case MyMarcCharacter.Utf8OELower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "oe")
                            Case MyMarcCharacter.Utf8OHookLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "o")
                            Case MyMarcCharacter.Utf8OHookUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "O")
                            Case MyMarcCharacter.Utf8PlusMinus
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00B1"))
                            Case MyMarcCharacter.Utf8Pressing
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "(p)")
                            Case MyMarcCharacter.Utf8QuestionInverted
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00BF"))
                            Case MyMarcCharacter.Utf8Registered
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00AE"))
                            Case MyMarcCharacter.Utf8Sharp
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "#")
                            Case MyMarcCharacter.Utf8OSlashLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00F8"))
                            Case MyMarcCharacter.Utf8OSlashUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00D8"))
                            Case MyMarcCharacter.Utf8Subscript0
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "0")
                            Case MyMarcCharacter.Utf8Subscript1
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "1")
                            Case MyMarcCharacter.Utf8Subscript2
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "2")
                            Case MyMarcCharacter.Utf8Subscript3
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "3")
                            Case MyMarcCharacter.Utf8Subscript4
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "4")
                            Case MyMarcCharacter.Utf8Subscript5
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "5")
                            Case MyMarcCharacter.Utf8Subscript6
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "6")
                            Case MyMarcCharacter.Utf8Subscript7
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "7")
                            Case MyMarcCharacter.Utf8Subscript8
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "8")
                            Case MyMarcCharacter.Utf8Subscript9
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "9")
                            Case MyMarcCharacter.Utf8SubscriptParensLeft
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "(")
                            Case MyMarcCharacter.Utf8SubscriptParensRight
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, ")")
                            Case MyMarcCharacter.Utf8SubscriptPlus
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "+")
                            Case MyMarcCharacter.Utf8SubscriptMinus
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "-")
                            Case MyMarcCharacter.Utf8Superscript0
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "0")
                            Case MyMarcCharacter.Utf8Superscript1
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00B9"))
                            Case MyMarcCharacter.Utf8Superscript2
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00B2"))
                            Case MyMarcCharacter.Utf8Superscript3
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00B3"))
                            Case MyMarcCharacter.Utf8Superscript4
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "4")
                            Case MyMarcCharacter.Utf8Superscript5
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "5")
                            Case MyMarcCharacter.Utf8Superscript6
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "6")
                            Case MyMarcCharacter.Utf8Superscript7
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "7")
                            Case MyMarcCharacter.Utf8Superscript8
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "8")
                            Case MyMarcCharacter.Utf8Superscript9
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "9")
                            Case MyMarcCharacter.Utf8SuperscriptParensLeft
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "(")
                            Case MyMarcCharacter.Utf8SuperscriptParensRight
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, ")")
                            Case MyMarcCharacter.Utf8SuperscriptPlus
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "+")
                            Case MyMarcCharacter.Utf8SuperscriptMinus
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "-")
                            Case MyMarcCharacter.Utf8ThornLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00FE"))
                            Case MyMarcCharacter.Utf8ThornUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, MyMarcCharacter.UcsHex2Utf8("00DE"))
                            Case MyMarcCharacter.Utf8Tilde
                                If lPtr > 1 Then
                                    Select Case Mid(sIn$, lPtr - 1, 1)
                                        Case "a"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00E3"))
                                            lPtr = lPtr - 1
                                        Case "A"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("C3"))
                                            lPtr = lPtr - 1
                                        Case "n"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00F1"))
                                            lPtr = lPtr - 1
                                        Case "N"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00D1"))
                                            lPtr = lPtr - 1
                                        Case "o"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00F5"))
                                            lPtr = lPtr - 1
                                        Case "O"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("D5"))
                                            lPtr = lPtr - 1
                                        Case Else
                                            sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                    End Select
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                End If
                            Case MyMarcCharacter.Utf8TvyerdiZnak
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, Chr(34))
                            Case MyMarcCharacter.Utf8UHookLower
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "u")
                            Case MyMarcCharacter.Utf8UHookUpper
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, "U")
                            Case MyMarcCharacter.Utf8Umlaut
                                If lPtr > 1 Then
                                    Select Case Mid(sIn$, lPtr - 1, 1)
                                        Case "a"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00E4"))
                                            lPtr = lPtr - 1
                                        Case "A"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00C4"))
                                            lPtr = lPtr - 1
                                        Case "e"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00EB"))
                                            lPtr = lPtr - 1
                                        Case "E"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00CB"))
                                            lPtr = lPtr - 1
                                        Case "i"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00EF"))
                                            lPtr = lPtr - 1
                                        Case "I"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00CF"))
                                            lPtr = lPtr - 1
                                        Case "o"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00F6"))
                                            lPtr = lPtr - 1
                                        Case "O"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00D6"))
                                            lPtr = lPtr - 1
                                        Case "u"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00FC"))
                                            lPtr = lPtr - 1
                                        Case "U"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00DC"))
                                            lPtr = lPtr - 1
                                        Case "y"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, MyMarcCharacter.UcsHex2Utf8("00FF"))
                                            lPtr = lPtr - 1
                                        Case "Y"
                                            sIn$ = SafeStuff(sIn$, lPtr - 1, iLen% + 1, "Y")
                                            lPtr = lPtr - 1
                                        Case Else
                                            sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                    End Select
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                                End If
                            Case Else ' unrecognized character of any type
                                sIn$ = SafeStuff(sIn$, lPtr, iLen%, sFiller$)
                        End Select
                    End If
            End Select ' the main groups
            
            ' lPtr at present is on the first octet of the current character
            ' back it up to the last octet of the previous character
            lPtr = lPtr - 1
            If lPtr < 1 Then
                Exit Do
            End If
        Loop
    
    End If
    
    'Debug.Print "M2MA out: >" + sIn$ + "<"
    Marc2MsoftAscii = sIn$
    
End Function

Public Function StringIsNumeric(ByVal sInString$, Optional ByVal sAdditionalAllowedCharacters$ = "") As Boolean

    ' entry point for characters in either MARC-8 (any flavor) or UTF-8
    
    ' decides whether a a string is all-numeric or not
    
    
    Dim sChar$
    
    Dim iRc%, iLen%
    
    
    StringIsNumeric = False
    
    If Not m_bUtf8 Then
        For iRc% = 1 To Len(sInString$)
            If Not CharIsNumeric(Mid(sInString$, iRc%, 1)) And InStr(sAdditionalAllowedCharacters$, Mid(sInString$, iRc%, 1)) = 0 Then
                Exit Function ' with False
            End If
        Next
        StringIsNumeric = True
    Else ' UTF-8
        iRc% = 1
        iLen% = Len(sInString$)
        Do
            MyMarcCharacter.Utf8Char = Mid(sInString$, iRc%)
            If MyMarcCharacter.Utf8CharCategory <> "Nd" Then
                If InStr(sAdditionalAllowedCharacters$, MyMarcCharacter.Utf8Char) = 0 Then
                    Exit Function ' with False
                End If
            End If
            iRc% = iRc% + MyMarcCharacter.Utf8CharOctets
            If iRc% > iLen% Then
                StringIsNumeric = True
                Exit Function
            End If
        Loop
    End If

End Function

Public Property Get MarcCircumflex() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcCircumflex = MyMarcCharacter.Utf8Circumflex
    Else
        MarcCircumflex = MyMarcCharacter.Marc8Circumflex
    End If

End Property

Public Property Get MarcHacek() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcHacek = MyMarcCharacter.Utf8Hacek
    Else
        MarcHacek = MyMarcCharacter.Marc8Hacek
    End If

End Property

Public Property Get MarcOEUpper() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcOEUpper = MyMarcCharacter.Utf8OEUpper
    Else
        MarcOEUpper = MyMarcCharacter.Marc8OEUpper
    End If

End Property

Public Property Get MarcAEUpper() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcAEUpper = MyMarcCharacter.Utf8AEUpper
    Else
        MarcAEUpper = MyMarcCharacter.Marc8AEUpper
    End If

End Property

Public Property Get MarcGrave() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcGrave = MyMarcCharacter.Utf8Grave
    Else
        MarcGrave = MyMarcCharacter.Marc8Grave
    End If

End Property

Public Property Get MarcMiagkiiZnak() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcMiagkiiZnak = MyMarcCharacter.Utf8MiagkiiZnak
    Else
        MarcMiagkiiZnak = MyMarcCharacter.Marc8MiagkiiZnak
    End If

End Property

Public Property Get MarcTverdiiZnak() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcTverdiiZnak = MyMarcCharacter.Utf8TvyerdiZnak
    Else
        MarcTverdiiZnak = MyMarcCharacter.Marc8TvyerdiZnak
    End If

End Property

Public Property Get MarcTilde() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcTilde = MyMarcCharacter.Utf8Tilde
    Else
        MarcTilde = MyMarcCharacter.Marc8Tilde
    End If

End Property

Public Property Get MarcOELower() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcOELower = MyMarcCharacter.Utf8OELower
    Else
        MarcOELower = MyMarcCharacter.Marc8OELower
    End If

End Property

Public Property Get MarcAELower() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcAELower = MyMarcCharacter.Utf8AELower
    Else
        MarcAELower = MyMarcCharacter.Marc8AELower
    End If

End Property

Public Property Get MarcExclamationInverted() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcExclamationInverted = MyMarcCharacter.Utf8ExclamationInverted
    Else
        MarcExclamationInverted = MyMarcCharacter.Marc8ExclamationInverted(m_sCharacterSetOut$)
    End If

End Property

Public Property Get MarcQuestionInverted() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcQuestionInverted = MyMarcCharacter.Utf8QuestionInverted
    Else
        MarcQuestionInverted = MyMarcCharacter.Marc8QuestionInverted(m_sCharacterSetOut$)
    End If

End Property

Public Property Get MarcBritishPound() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcBritishPound = MyMarcCharacter.Utf8BritishPound
    Else
        MarcBritishPound = MyMarcCharacter.Marc8BritishPound
    End If

End Property

Public Property Get MarcDSlashUpper() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcDSlashUpper = MyMarcCharacter.Utf8DSlashUpper
    Else
        MarcDSlashUpper = MyMarcCharacter.Marc8DSlashUpper
    End If

End Property

Public Property Get MarcThornUpper() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcThornUpper = MyMarcCharacter.Utf8ThornUpper
    Else
        MarcThornUpper = MyMarcCharacter.Marc8ThornUpper
    End If

End Property

Public Property Get MarcCopyright() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcCopyright = MyMarcCharacter.Utf8Copyright
    Else
        MarcCopyright = MyMarcCharacter.Marc8Copyright(m_sCharacterSetOut$)
    End If

End Property

Public Property Get MarcRegistered() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcRegistered = MyMarcCharacter.Utf8Registered
    Else
        MarcRegistered = MyMarcCharacter.Marc8Registered
    End If

End Property

Public Property Get MarcOSlashUpper() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcOSlashUpper = MyMarcCharacter.Utf8OSlashUpper
    Else
        MarcOSlashUpper = MyMarcCharacter.Marc8OSlashUpper
    End If

End Property

Public Property Get MarcBeta() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcBeta = MyMarcCharacter.Utf8Beta
    Else
        MarcBeta = MyMarcCharacter.Marc8Beta(m_sCharacterSetOut$)
    End If

End Property

Public Property Get MarcEth() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcEth = MyMarcCharacter.Utf8Eth
    Else
        MarcEth = MyMarcCharacter.Marc8Eth
    End If

End Property

Public Property Get MarcOSlashLower() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcOSlashLower = MyMarcCharacter.Utf8OSlashLower
    Else
        MarcOSlashLower = MyMarcCharacter.Marc8OSlashLower
    End If

End Property


Public Property Get MarcThornLower() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcThornLower = MyMarcCharacter.Utf8ThornLower
    Else
        MarcThornLower = MyMarcCharacter.Marc8ThornLower
    End If

End Property

Public Property Get MarcDegree() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcDegree = MyMarcCharacter.Utf8Degree
    Else
        MarcDegree = MyMarcCharacter.Marc8Degree(m_sCharacterSetOut$)
    End If

End Property

Public Property Get MarcPlusMinus() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcPlusMinus = MyMarcCharacter.Utf8PlusMinus
    Else
        MarcPlusMinus = MyMarcCharacter.Marc8PlusMinus
    End If

End Property

Public Property Get MarcSuperscript2() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSuperscript2 = MyMarcCharacter.Utf8Superscript2
    Else
        MarcSuperscript2 = MyMarcCharacter.Marc8Superscript2(m_sCharacterSetOut$)
    End If

End Property

Public Property Get MarcSuperscript1() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSuperscript1 = MyMarcCharacter.Utf8Superscript1
    Else
        MarcSuperscript1 = MyMarcCharacter.Marc8Superscript1(m_sCharacterSetOut$)
    End If

End Property

Public Property Get MarcSuperscript3() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSuperscript3 = MyMarcCharacter.Utf8Superscript3
    Else
        MarcSuperscript3 = MyMarcCharacter.Marc8Superscript3(m_sCharacterSetOut$)
    End If

End Property

Public Property Get MarcSuperscript0() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    
    'Debug.Print "Superscript0 " + str(m_bUtf8)
    If m_bUtf8 Then
        MarcSuperscript0 = MyMarcCharacter.Utf8Superscript0
    Else
        MarcSuperscript0 = MyMarcCharacter.Marc8Superscript0(m_sCharacterSetOut$)
    End If

End Property

Public Property Get MarcAcute() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcAcute = MyMarcCharacter.Utf8Acute
    Else
        MarcAcute = MyMarcCharacter.Marc8Acute
    End If

End Property

Public Property Get MarcAngstrom() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcAngstrom = MyMarcCharacter.Utf8Angstrom
    Else
        MarcAngstrom = MyMarcCharacter.Marc8Angstrom
    End If

End Property

Public Property Get MarcCedilla() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcCedilla = MyMarcCharacter.Utf8Cedilla
    Else
        MarcCedilla = MyMarcCharacter.Marc8Cedilla
    End If

End Property


Public Property Get MarcLSlashUpper() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcLSlashUpper = MyMarcCharacter.Utf8LSlashUpper
    Else
        MarcLSlashUpper = MyMarcCharacter.Marc8LSlashUpper
    End If

End Property

Public Property Get MarcLSlashLower() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcLSlashLower = MyMarcCharacter.Utf8LSlashLower
    Else
        MarcLSlashLower = MyMarcCharacter.Marc8LSlashLower
    End If

End Property


Public Property Get MarcFlat() As String

    If m_bUtf8 Then
        MarcFlat = MyMarcCharacter.Utf8Flat
    Else
        MarcFlat = MyMarcCharacter.Marc8Flat
    End If

End Property


Public Property Get MarcDotMiddle() As String

    If m_bUtf8 Then
        MarcDotMiddle = MyMarcCharacter.Utf8DotMiddle
    Else
        MarcDotMiddle = MyMarcCharacter.Marc8DotMiddle
    End If

End Property

Public Property Get MarcOHookUpper() As String

    If m_bUtf8 Then
        MarcOHookUpper = MyMarcCharacter.Utf8OHookUpper
    Else
        MarcOHookUpper = MyMarcCharacter.Marc8OHookUpper
    End If

End Property


Public Property Get MarcUHookUpper() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcUHookUpper = MyMarcCharacter.Utf8UHookUpper
    Else
        MarcUHookUpper = MyMarcCharacter.Marc8UHookUpper
    End If

End Property

Public Property Get MarcUHookLower() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcUHookLower = MyMarcCharacter.Utf8UHookLower
    Else
        MarcUHookLower = MyMarcCharacter.Marc8UHookLower
    End If

End Property

Public Property Get MarcOHookLower() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcOHookLower = MyMarcCharacter.Utf8OHookLower
    Else
        MarcOHookLower = MyMarcCharacter.Marc8OHookLower
    End If

End Property

Public Property Get MarcAlif() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcAlif = MyMarcCharacter.Utf8Alif
    Else
        MarcAlif = MyMarcCharacter.Marc8Alif
    End If

End Property

Public Property Get MarcAyn() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcAyn = MyMarcCharacter.Utf8Ayn
    Else
        MarcAyn = MyMarcCharacter.Marc8Ayn
    End If

End Property


Public Property Get MarcIDotless() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcIDotless = MyMarcCharacter.Utf8IDotless
    Else
        MarcIDotless = MyMarcCharacter.Marc8IDotless
    End If

End Property

Public Property Get MarcLScript() As String

    If m_bUtf8 Then
        MarcLScript = MyMarcCharacter.Utf8LScript
    Else
        MarcLScript = MyMarcCharacter.Marc8LScript(m_sCharacterSetOut$)
    End If

End Property


Public Property Get MarcPressing() As String

    If m_bUtf8 Then
        MarcPressing = MyMarcCharacter.Utf8Pressing
    Else
        MarcPressing = MyMarcCharacter.Marc8Pressing(m_sCharacterSetOut$)
    End If

End Property

Public Property Get MarcSharp() As String

    If m_bUtf8 Then
        MarcSharp = MyMarcCharacter.Utf8Sharp
    Else
        MarcSharp = MyMarcCharacter.Marc8Sharp(m_sCharacterSetOut$)
    End If

End Property

Public Property Get MarcQuestionPseudo() As String

    If m_bUtf8 Then
        MarcQuestionPseudo = MyMarcCharacter.Utf8QuestionPseudo
    Else
        MarcQuestionPseudo = MyMarcCharacter.Marc8QuestionPseudo
    End If

End Property
Public Property Get MarcMacron() As String

    If m_bUtf8 Then
        MarcMacron = MyMarcCharacter.Utf8Macron
    Else
        MarcMacron = MyMarcCharacter.Marc8Macron
    End If

End Property
Public Property Get MarcBreve() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcBreve = MyMarcCharacter.Utf8Breve
    Else
        MarcBreve = MyMarcCharacter.Marc8Breve
    End If

End Property
Public Property Get MarcDotAbove() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcDotAbove = MyMarcCharacter.Utf8DotAbove
    Else
        MarcDotAbove = MyMarcCharacter.Marc8DotAbove
    End If

End Property
Public Property Get MarcLigatureLeft() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcLigatureLeft = MyMarcCharacter.Utf8LigatureLeft
    Else
        MarcLigatureLeft = MyMarcCharacter.Marc8LigatureLeft
    End If

End Property
Public Property Get MarcLigatureRight() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcLigatureRight = MyMarcCharacter.Utf8LigatureRight
    Else
        MarcLigatureRight = MyMarcCharacter.Marc8LigatureRight
    End If

End Property
Public Property Get MarcCommaHighOffCenter() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcCommaHighOffCenter = MyMarcCharacter.Utf8CommaHighOffCenter
    Else
        MarcCommaHighOffCenter = MyMarcCharacter.Marc8CommaHighOffCenter
    End If

End Property
Public Property Get MarcAcuteDouble() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcAcuteDouble = MyMarcCharacter.Utf8AcuteDouble
    Else
        MarcAcuteDouble = MyMarcCharacter.Marc8AcuteDouble
    End If

End Property
Public Property Get MarcCandrabindu() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcCandrabindu = MyMarcCharacter.Utf8Candrabindu
    Else
        MarcCandrabindu = MyMarcCharacter.Marc8Candrabindu
    End If

End Property
Public Property Get MarcHookRight() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcHookRight = MyMarcCharacter.Utf8HookRight
    Else
        MarcHookRight = MyMarcCharacter.Marc8HookRight
    End If

End Property
Public Property Get MarcDotBelow() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcDotBelow = MyMarcCharacter.Utf8DotBelow
    Else
        MarcDotBelow = MyMarcCharacter.Marc8DotBelow
    End If

End Property
Public Property Get MarcDotBelowDouble() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcDotBelowDouble = MyMarcCharacter.Utf8DotBelowDouble
    Else
        MarcDotBelowDouble = MyMarcCharacter.Marc8DotBelowDouble
    End If

End Property
Public Property Get MarcCircleBelow() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcCircleBelow = MyMarcCharacter.Utf8CircleBelow
    Else
        MarcCircleBelow = MyMarcCharacter.Marc8CircleBelow
    End If

End Property
Public Property Get MarcUnderscoreDouble() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcUnderscoreDouble = MyMarcCharacter.Utf8UnderscoreDouble
    Else
        MarcUnderscoreDouble = MyMarcCharacter.Marc8UnderscoreDouble
    End If

End Property
Public Property Get MarcUnderscore() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcUnderscore = MyMarcCharacter.Utf8Underscore
    Else
        MarcUnderscore = MyMarcCharacter.Marc8Underscore
    End If

End Property
Public Property Get MarcHookLeft() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcHookLeft = MyMarcCharacter.Utf8HookLeft
    Else
        MarcHookLeft = MyMarcCharacter.Marc8HookLeft
    End If

End Property
Public Property Get MarcCedillaRight() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcCedillaRight = MyMarcCharacter.Utf8CedillaRight
    Else
        MarcCedillaRight = MyMarcCharacter.Marc8CedillaRight
    End If

End Property

Public Property Get MarcUpadhmaniya() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcUpadhmaniya = MyMarcCharacter.Utf8Upadhmaniya
    Else
        MarcUpadhmaniya = MyMarcCharacter.Marc8Upadhmaniya
    End If

End Property
Public Property Get MarcTildeDoubleLeft() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcTildeDoubleLeft = MyMarcCharacter.Utf8TildeDoubleLeft
    Else
        MarcTildeDoubleLeft = MyMarcCharacter.Marc8TildeDoubleLeft
    End If

End Property
Public Property Get MarcTildeDoubleRight() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcTildeDoubleRight = MyMarcCharacter.Utf8TildeDoubleRight
    Else
        MarcTildeDoubleRight = MyMarcCharacter.Marc8TildeDoubleRight
    End If

End Property
Public Property Get MarcCommaHighCentered() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcCommaHighCentered = MyMarcCharacter.Utf8CommaHighCentered
    Else
        MarcCommaHighCentered = MyMarcCharacter.Marc8CommaHighCentered
    End If

End Property
Public Property Get MarcSuperscript4() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSuperscript4 = MyMarcCharacter.Utf8Superscript4
    Else
        MarcSuperscript4 = MyMarcCharacter.Marc8Superscript4(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSuperscript5() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSuperscript5 = MyMarcCharacter.Utf8Superscript5
    Else
        MarcSuperscript5 = MyMarcCharacter.Marc8Superscript5(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSuperscript6() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSuperscript6 = MyMarcCharacter.Utf8Superscript6
    Else
        MarcSuperscript6 = MyMarcCharacter.Marc8Superscript6(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSuperscript7() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSuperscript7 = MyMarcCharacter.Utf8Superscript7
    Else
        MarcSuperscript7 = MyMarcCharacter.Marc8Superscript7(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSuperscript8() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSuperscript8 = MyMarcCharacter.Utf8Superscript8
    Else
        MarcSuperscript8 = MyMarcCharacter.Marc8Superscript8(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSuperscript9() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSuperscript9 = MyMarcCharacter.Utf8Superscript9
    Else
        MarcSuperscript9 = MyMarcCharacter.Marc8Superscript9(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSuperscriptPlus() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSuperscriptPlus = MyMarcCharacter.Utf8SuperscriptPlus
    Else
        MarcSuperscriptPlus = MyMarcCharacter.Marc8SuperscriptPlus(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSuperscriptMinus() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSuperscriptMinus = MyMarcCharacter.Utf8SuperscriptMinus
    Else
        MarcSuperscriptMinus = MyMarcCharacter.Marc8SuperscriptMinus(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSuperscriptParensLeft() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSuperscriptParensLeft = MyMarcCharacter.Utf8SuperscriptParensLeft
    Else
        MarcSuperscriptParensLeft = MyMarcCharacter.Marc8SuperscriptParensLeft(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSuperscriptParensRight() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSuperscriptParensRight = MyMarcCharacter.Utf8SuperscriptParensRight
    Else
        MarcSuperscriptParensRight = MyMarcCharacter.Marc8SuperscriptParensRight(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSubscript0() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSubscript0 = MyMarcCharacter.Utf8Subscript0
    Else
        MarcSubscript0 = MyMarcCharacter.Marc8Subscript0(m_sCharacterSetOut$)
    End If

End Property

Public Property Get MarcSubscript1() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSubscript1 = MyMarcCharacter.Utf8Subscript1
    Else
        MarcSubscript1 = MyMarcCharacter.Marc8Subscript1(m_sCharacterSetOut$)
    End If

End Property

Public Property Get MarcSubscript2() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSubscript2 = MyMarcCharacter.Utf8Subscript2
    Else
        MarcSubscript2 = MyMarcCharacter.Marc8Subscript2(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSubscript3() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSubscript3 = MyMarcCharacter.Utf8Subscript3
    Else
        MarcSubscript3 = MyMarcCharacter.Marc8Subscript3(m_sCharacterSetOut$)
    End If

End Property

Public Property Get MarcSubscript4() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSubscript4 = MyMarcCharacter.Utf8Subscript4
    Else
        MarcSubscript4 = MyMarcCharacter.Marc8Subscript4(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSubscript5() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSubscript5 = MyMarcCharacter.Utf8Subscript5
    Else
        MarcSubscript5 = MyMarcCharacter.Marc8Subscript5(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSubscript6() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSubscript6 = MyMarcCharacter.Utf8Subscript6
    Else
        MarcSubscript6 = MyMarcCharacter.Marc8Subscript6(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSubscript7() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSubscript7 = MyMarcCharacter.Utf8Subscript7
    Else
        MarcSubscript7 = MyMarcCharacter.Marc8Subscript7(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSubscript8() As String

    ' 20040210: this is the pattern we should use in the future for individual
    '   characters: depending on the value of m_bUtf8, we retrieve the
    '   proper value from the character object
    If m_bUtf8 Then
        MarcSubscript8 = MyMarcCharacter.Utf8Subscript8
    Else
        MarcSubscript8 = MyMarcCharacter.Marc8Subscript8(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSubscript9() As String

    If m_bUtf8 Then
        MarcSubscript9 = MyMarcCharacter.Utf8Subscript9
    Else
        MarcSubscript9 = MyMarcCharacter.Marc8Subscript9(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSubscriptPlus() As String

    If m_bUtf8 Then
        MarcSubscriptPlus = MyMarcCharacter.Utf8SubscriptPlus
    Else
        MarcSubscriptPlus = MyMarcCharacter.Marc8SubscriptPlus(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSubscriptMinus() As String

    If m_bUtf8 Then
        MarcSubscriptMinus = MyMarcCharacter.Utf8SubscriptMinus
    Else
        MarcSubscriptMinus = MyMarcCharacter.Marc8SubscriptMinus(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSubscriptParensLeft() As String

    If m_bUtf8 Then
        MarcSubscriptParensLeft = MyMarcCharacter.Utf8SubscriptParensLeft
    Else
        MarcSubscriptParensLeft = MyMarcCharacter.Marc8SubscriptParensLeft(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcSubscriptParensRight() As String

    If m_bUtf8 Then
        MarcSubscriptParensRight = MyMarcCharacter.Utf8SubscriptParensRight
    Else
        MarcSubscriptParensRight = MyMarcCharacter.Marc8SubscriptParensRight(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcNonSortBegin() As String

    MarcNonSortBegin = MyMarcCharacter.MarcNonSortBegin

End Property
Public Property Get MarcNonSortEnd() As String

    MarcNonSortEnd = MyMarcCharacter.MarcNonSortEnd

End Property
Public Property Get MarcJoinerZeroWidth() As String

    If m_bUtf8 Then
        MarcJoinerZeroWidth = MyMarcCharacter.Utf8JoinerZeroWidth
    Else
        MarcJoinerZeroWidth = MyMarcCharacter.Marc8JoinerZeroWidth
    End If

End Property
Public Property Get MarcNonJoinerZeroWidth() As String

    If m_bUtf8 Then
        MarcNonJoinerZeroWidth = MyMarcCharacter.Utf8NonJoinerZeroWidth
    Else
        MarcNonJoinerZeroWidth = MyMarcCharacter.Marc8NonJoinerZeroWidth
    End If

End Property

Public Property Get MarcDSlashLower() As String

    If m_bUtf8 Then
        MarcDSlashLower = MyMarcCharacter.Utf8DSlashLower
    Else
        MarcDSlashLower = MyMarcCharacter.Marc8DSlashLower
    End If

End Property
Public Property Get MarcAlpha() As String

    If m_bUtf8 Then
        MarcAlpha = MyMarcCharacter.Utf8Alpha
    Else
        MarcAlpha = MyMarcCharacter.Marc8Alpha(m_sCharacterSetOut$)
    End If

End Property

Public Property Get MarcGamma() As String

    If m_bUtf8 Then
        MarcGamma = MyMarcCharacter.Utf8Gamma
    Else
        MarcGamma = MyMarcCharacter.Marc8Gamma(m_sCharacterSetOut$)
    End If

End Property
Public Property Get MarcEscape() As String

    MarcEscape = Chr(27)

End Property
Public Property Get MarcDelimiter() As String

    MarcDelimiter = MyMarcCharacter.MarcDelimiter

End Property

Public Property Get MarcEndOfField() As String

    MarcEndOfField = MyMarcCharacter.MarcEndOfField

End Property
Public Property Get MarcEndOfRecord() As String

    MarcEndOfRecord = MyMarcCharacter.MarcEndOfRecord

End Property
Public Property Get MarcFill() As String

    MarcFill = MyMarcCharacter.MarcFill

End Property



Public Function Hex2CharString(ByVal sIn$) As String

    Dim sOut$
    
    Dim iRc%
    
    Select Case Len(sIn$)
        Case 0
            Hex2CharString = ""
            Exit Function
        Case 1
            sIn$ = "0" + sIn$
        Case Else
            If Len(sIn$) Mod 2 <> 0 Then
                sIn$ = "0" + sIn$
            End If
    End Select
    
    For iRc% = Len(sIn$) - 1 To 1 Step -2
        sOut$ = MyMarcCharacter.Hex2Char(Mid(sIn$, iRc%, 2)) + sOut$
    Next
    
    Hex2CharString = sOut$
    
End Function

Public Sub TranslateMarc2Utf8OneField(ByVal sMarcRecordFormat$, ByVal sTag$, ByRef sIndicators$, ByRef sField$, ByRef bChanged As Boolean, ByRef bError As Boolean)

    ' translate one entire variable field in some MARC-8 representation into its UTF-8 representation
    
    Dim sWork$, sPiece$, sNonfiling$, sChar$, sLeft$, sOut$
    Dim sCharacterSet0$, sCharacterSet1$, sNextCharacterSet0$, sNextCharacterSet1$
    
    Dim iIndicator%, iNonfiling%, iCtr%, iEscape%
    
    Dim bLocalChanged As Boolean
    
    
#If TranslateMarc2Utf8Debug = -1 Then
    Debug.Print "TM2U8OFFB entry; error? " + str(bError)
#End If
    
    ' todo: theoretically, we should also translate the indicators, like this: anything that's
    '   above char #127 becomes the fill character (and the reverse in the utf-to-marc routine)
    
    ' maybe the nonfiling indicator points to a diacritic?
    ' if so, move any diacritics out of the nonfiling zone and
    '   reset the nonfiling indicator appropriately
    ' figure out of this field has a nonfiling characters delimiter
    Select Case sMarcRecordFormat$
        Case "A"
            Select Case sTag$
                Case "130", "430", "530"
                    iIndicator% = 2
                Case Else
                    iIndicator% = 0
            End Select
        Case "H"
            iIndicator% = 0
        Case Else ' must be a bibliographic format
            Select Case sTag$
                Case "130", "430", "630", "730"
                    iIndicator% = 1
                Case "222", "240", "242", "243", "245", "440", "830"
                    iIndicator% = 2
                Case Else
                    iIndicator% = 0
            End Select
    End Select
    
    ' if there is a nonfiling indicator, find out its value
    If iIndicator% > 0 Then
        iNonfiling% = Val(Mid(sIndicators$, iIndicator%, 1))
        ' if there are nonfiling characters present, move any diacritics
        '   out of the nonfiling zone
        If iNonfiling% > 0 Then
            sPiece$ = Mid(sField$, 1, 2) ' remove sfd code
            sField$ = Mid(sField$, 3)
            sNonfiling$ = Mid(sField$, 1, iNonfiling%)
            sField$ = Mid(sField$, iNonfiling% + 1)
            Do
                sChar$ = Right(sNonfiling$, 1) ' remember: currently single-byte characters
                If Asc(sChar$) > 223 Then ' diacritics start at character 224
                    sField$ = sChar$ + sField$
                    sNonfiling$ = Mid(sNonfiling$, 1, Len(sNonfiling$) - 1)
                    If Len(sNonfiling$) = 0 Then
                        ' nothing left in the nonfiling zone
                        Exit Do
                    End If
                Else ' terminal character not a diacritic: all done
                    Exit Do
                End If
            Loop
            iCtr% = Len(sNonfiling$)
            ' only bother to reset the indicator if there's a change
            If iCtr% <> iNonfiling% Then
                sIndicators$ = SafeStuff(sIndicators$, iIndicator%, 1, Trim(str(iCtr%)))
                bChanged = True
            End If
            ' no matter what, reset the field to its original full contents
            sWork$ = sPiece$ + sNonfiling$ + sField$
        Else
            sWork$ = sField$
        End If ' nonfiling indicator is non-zero?
    Else
        sWork$ = sField$
    End If ' nonfiling indicator defined for this field?
        
        
    ' each field is assumed to start with the standard character set
    sCharacterSet0$ = "s"
    sCharacterSet1$ = "s"
    ' 20061116: also assume that the 'next' character set is standard as well
    sNextCharacterSet0$ = "s"
    sNextCharacterSet1$ = "s"
    
    'Private Const CHARACTERSET_CODES_FOR_880_BasicAsG0$ = "(B"
    'Private Const CHARACTERSET_CODES_FOR_880_HebrewAsG0$ = "(2"
    'Private Const CHARACTERSET_CODES_FOR_880_BasicCyrillicAsG0$ = "(N"
    'Private Const CHARACTERSET_CODES_FOR_880_BasicArabicAsG0$ = "(3"
    'Private Const CHARACTERSET_CODES_FOR_880_GreekAsG0$ = "(S"
    'Private Const CHARACTERSET_CODES_FOR_880_CJKAsG0$ = "$1"
    'Private Const CHARACTERSET_CODES_FOR_880_ExtendedCyrillicAsG1$ = ")Q"
    'Private Const CHARACTERSET_CODES_FOR_880_ExtendedArabicAsG1$ = ")4"
    'Private Const CHARACTERSET_CODES_FOR_880_ExtendedLatinAsG1$ = ")!E"
    
    
    ' find the first escape-marked break, if any; or (most common case) move the entire string from
    '   sWork to sPiece and set sWork to null
    TranslateMarc2Utf8OneFieldFindBreak sWork$, sPiece$, sCharacterSet0$, sCharacterSet1$, sNextCharacterSet0$, sNextCharacterSet1$
#If TranslateMarc2Utf8Debug = -1 Then
    Debug.Print "Broke off first piece >" + sPiece$ + "< from work >" + sWork$ + "< 0 >" + sCharacterSet0$ + "< 1 >" + sCharacterSet1$ + "< next 0 >" + sNextCharacterSet0$ + "< next 1 >" + sNextCharacterSet1$ + "<"
#End If

    ' we've broken off the first piece, and we know what character set
    '   is used to represent it (the 'standard' set in all cases)
    ' do each escape-delimited piece, starting with the
    '   first one that we've already broken off
    Do
    
        ' here's where the work of translation occurs; we don't appear to do anything
        '   with bLocalChanged (at the bottom of this routine, we do a plain ol'
        '   string compare to see if anything's different)
        TranslateMarc2Utf8Text sCharacterSet0$, sCharacterSet1$, sTag$, sPiece$, bLocalChanged, bError
#If TranslateMarc2Utf8Debug = -1 Then
        Debug.Print "Translated text: >" + sPiece$ + "< hex >" + CharToHex(sPiece$) + " " + str(bLocalChanged) + " " + str(bError)
#End If
        
        ' add the just-translated bit to the growing output string
        sOut$ = sOut$ + sPiece$
        
        ' all fields that do not contain
        '   an escape will exit here after the first piece--which is
        '   the whole thing--is handled by the above translation; and
        '   of course pieces that do contain an escape will exit here when
        '   we're done
        If Len(sWork$) = 0 Then
            Exit Do
        End If
        ' we've previously isolated the marker for the
        '   next character set; the character set that
        '   begins the next piece is now the current
        '   character set
        sCharacterSet0$ = sNextCharacterSet0$
        sCharacterSet1$ = sNextCharacterSet1$
        
        TranslateMarc2Utf8OneFieldFindBreak sWork$, sPiece$, sCharacterSet0$, sCharacterSet1$, sNextCharacterSet0$, sNextCharacterSet1$
#If TranslateMarc2Utf8Debug = -1 Then
        Debug.Print "Broke off next piece >" + sPiece$ + "< from work >" + sWork$ + "< 0 >" + sCharacterSet0$ + "< 1 >" + sCharacterSet1$ + "< next 0 >" + sNextCharacterSet0$ + "< next 1 >" + sNextCharacterSet1$ + "<"
#End If
        
    Loop

    ' 20060801: accommodate "&#x...;" notation
    If InStr(sOut$, "&#") > 0 Then
        TranslateMarc2Utf8HexNotation sOut$
    End If
    
    ' 20070303: added to insert RTL markers at subfield boundaries for LC use
    '   (not yet clear if this is good for anyone else)
    If m_bUtf8LcPattern Then
        sOut$ = TranslateMarc2Utf8OneFieldLcPattern(sTag$, sOut$)
    End If
    
    If sField$ <> sOut$ Then
        bChanged = True
        sField$ = sOut$
    End If
    
End Sub

Public Sub TranslateMarc2Utf8Text(ByRef sMarc8CharacterSetCode0$, ByRef sMarc8CharacterSetCode1$, ByVal sTag$, ByRef sText$, ByRef bChanged As Boolean, ByRef bError As Boolean)

    Dim lPtr As Long, lLen As Long, lCtr As Long, lPtr2 As Long
    
    Dim iLen%, iOdd%
    
    Dim sField$, sDiacriticsAbove$, sDiacriticsOther$, sUtf8Character$, sOdd$, sChar$
    Dim sHexValue$, sLeft$, sRight$
    
    Dim bCharacterError As Boolean, bCharacterChanged As Boolean, bG0 As Boolean, bMultiByte As Boolean
    
    
#If TranslateMarc2Utf8TextDebug = -1 Or TranslateMarc2Utf8TextErrorOnlyDebug = -1 Then
    Debug.Print "TM2U8T entry: >" + sMarc8CharacterSetCode0$ + ":" + sMarc8CharacterSetCode1$ + " " + sTag$ + "< >" + sText$ + "<"
#End If

    m_iDiacriticLast% = 0
    
    
    lLen = Len(sText$)
    
    ' 20061012: added because otherwise the test for Asc(sChar$) in the revised
    '   loop below bombs when we're handed a null string
    If lLen = 0 Then
        bChanged = False
        Exit Sub
    End If
    
    bG0 = True
    
    If Mid(sMarc8CharacterSetCode0$, 1, 1) = "$" Then
        If sMarc8CharacterSetCode0$ = "$,1" Or sMarc8CharacterSetCode0$ = "$1" Then
            iLen% = 3 ' the only recognized multi-byte set: EACC given as G0
            bMultiByte = True
            ' 20040830: we discover that sometimes, we're not getting multiples
            '   of 3 bytes in these segments (because of bad data, not because
            '   our coding up to this point is bad); we're going to attempt to
            '   translate as much as we can, and then we're going to just dump the remainder
            ' we determine this, of course, by doing a Mod on the length
            '   of the supplied 3-bytes-per-character string
            iOdd% = lLen Mod 3
            If iOdd% <> 0 Then
                lLen = lLen - iOdd%
                sOdd$ = Mid(sText$, lLen + 1)
                sText$ = Mid(sText$, 1, lLen)
            End If
        Else
            ' unrecognized EACC code--this will come back as "[MARC+...]" equivalents
            '   or whatever
            ' we'll use a length of 1 for these, because we want each bad
            '   character to be translated individually
            iLen% = 1
        End If
    Else
        ' single-byte character set
        iLen% = 1
    End If
    
    
    ' handle each single- or multi-byte character one at a time
    ' 20061012: changed from For to Do so that we could
    '   manipulate the counter ourselves when we run into
    '   "&#x" notation
    'For lPtr = 1 To lLen Step iLen%
    'Next
    lPtr = 1
    Do
        sChar$ = Mid(sText$, lPtr, 1)
        If sChar$ = "&" Then
            If Mid(sText$, lPtr + 1, 2) = "#x" Then
                sHexValue$ = Mid(sText$, lPtr + 3)
                lPtr2 = InStr(sHexValue$, ";")
                If lPtr2 > 0 Then
                    sLeft$ = Mid(sText$, 1, lPtr - 1)
                    sRight$ = Mid(sHexValue$, lPtr2 + 1)
                    sHexValue$ = UCase(Mid(sHexValue$, 1, lPtr2 - 1))
                    If Len(sHexValue$) Mod 2 <> 0 Then
                        sHexValue$ = "0" + sHexValue$
                    End If
                    ' sHexValue now [theoretically!] contains characters that can
                    '   be interpreted as the code point for a single Unicode character
                    ' reconstruct the "original" field, replacing this bogus notation
                    '   with a bogus charcater which we'll proceed to skip over in just
                    '   a moment, and recalculate the length of this working string
                    sText$ = sLeft$ + "X" + sRight$
                    lLen = Len(sText$)
                    ' find the UTF8 equivalent for this character and add it to
                    '   the string we're constructing
                    sField$ = sField$ + TranslateSortAndReturnDiacriticArray() + MyMarcCharacter.UcsHex2Utf8(sHexValue$)
                    bChanged = True
                    ' advance over the bogus character we just inserted, and then pretend
                    '   nothing is wrong
                    lPtr = lPtr + 1
                    GoTo TM2U8T_CheckForEnd
                End If
            End If
        End If
    
        If Not bMultiByte Then
            If Asc(sChar$) > 127 Then
                MyMarcCharacter.TranslateMarc2Utf8OneCharacter m_sCharacterSetIn$, sMarc8CharacterSetCode1$, Mid(sText$, lPtr, iLen%), sUtf8Character$, bCharacterChanged, bCharacterError
#If TranslateMarc2Utf8TextDebug = -1 Or TranslateMarc2Utf8TextErrorOnlyDebug = -1 Then
                If bCharacterError Then
                    Debug.Print "CE1: >" + m_sCharacterSetIn$ + "+< >" + sMarc8CharacterSetCode1$ + "< >" + Mid(sText$, lPtr, iLen%) + "<"
                End If
#End If
                bG0 = False
            Else
                MyMarcCharacter.TranslateMarc2Utf8OneCharacter m_sCharacterSetIn$, sMarc8CharacterSetCode0$, Mid(sText$, lPtr, iLen%), sUtf8Character$, bCharacterChanged, bCharacterError
#If TranslateMarc2Utf8TextDebug = -1 Or TranslateMarc2Utf8TextErrorOnlyDebug = -1 Then
                If bCharacterError Then
                    Debug.Print "CE2: >" + m_sCharacterSetIn$ + "+< >" + sMarc8CharacterSetCode1$ + "< >" + Mid(sText$, lPtr, iLen%) + "<"
                End If
#End If
                bG0 = True
            End If
        Else ' it IS multi-byte
            MyMarcCharacter.TranslateMarc2Utf8OneCharacter m_sCharacterSetIn$, sMarc8CharacterSetCode0$, Mid(sText$, lPtr, iLen%), sUtf8Character$, bCharacterChanged, bCharacterError
#If TranslateMarc2Utf8TextDebug = -1 Or TranslateMarc2Utf8TextErrorOnlyDebug = -1 Then
            If bCharacterError Then
                Debug.Print "CE3: >" + m_sCharacterSetIn$ + "+< >" + sMarc8CharacterSetCode1$ + "< >" + Mid(sText$, lPtr, iLen%) + "<"
            End If
#End If
        End If
        
        bChanged = bChanged Or bCharacterChanged
#If TranslateMarc2Utf8TextDebug = -1 Then
        Debug.Print str(lPtr) + " >" + sChar$ + "< character error " + str(bCharacterError)
#End If
        If bCharacterError Then
            ' no translation has taken place
TranslateMarc2Utf8TextError:
            bError = True
            'Debug.Print "MARC 1 Character error"
            sField$ = sField$ + "[MARC+"
            For lCtr = lPtr To (lPtr + iLen%) - 1 ' may be multi-byte character
                sField$ = sField$ + MyMarcCharacter.Char2Hex(Mid(sText$, lCtr, 1))
            Next
            sField$ = sField$ + "]"
        Else
            ' no error: character is defined no problem
            ' 20040802: if the just-translated character is the delimiter, dump out
            '   everything you may be holding and get ready for the next thing
            If sUtf8Character$ = MarcDelimiter Then ' same in UTF8 and MARC8
                sField$ = sField$ + TranslateSortAndReturnDiacriticArray() + MarcDelimiter
            Else ' the just-translated character was not a delimiter
                ' we reverse the order of diacritics that come above the letter,
                '   and accumulate the other diacritics
                If bMultiByte Then
                    GoTo TranslateMarc2Utf8TextOK
                ElseIf bG0 Then
                    If sTag$ = "880" Or InStr(CHARACTERSET_Non880$, sMarc8CharacterSetCode0$) > 0 Then
TranslateMarc2Utf8TextOK:
                        If InStr(UTF8DiacriticsAbove$, sUtf8Character$) > 0 Then
                            TranslateAddOneDiacriticToArray sUtf8Character$, Utf8Diacritics$
                            bChanged = True
                        ElseIf InStr(Utf8DiacriticsOther$, sUtf8Character$) > 0 Then
                            Debug.Print "DIACRITIC OTHER"
                            TranslateAddOneDiacriticToArray sUtf8Character$, Utf8Diacritics$
                            bChanged = True
                        Else
                            ' normal chacter; paste after it any accumulated diacritics
                            sField$ = sField$ + sUtf8Character$ + TranslateSortAndReturnDiacriticArray()
                        End If
                    ElseIf InStr(CHARACTERSET_GreekCodes$, sMarc8CharacterSetCode0$) > 0 Then
                        If sUtf8Character$ = MarcAlpha Or sUtf8Character$ = MarcBeta Or sUtf8Character$ = MarcGamma Then
                            ' these three are allowed in non-880 fields
                            GoTo TranslateMarc2Utf8TextOK
                        Else
                            ' 20080828: at least in authority records--and therefore
                            '   probably anywhere else--escape sequences can appear anywhere
                            ' normal chacter; paste after it any accumulated diacritics
                            sField$ = sField$ + sUtf8Character$ + TranslateSortAndReturnDiacriticArray()
                            'GoTo TranslateMarc2Utf8TextError
                        End If
                    Else
                        ' 20080828: at least in authority records--and therefore
                        '   probably anywhere else--escape sequences can appear anywhere
                        ' normal chacter; paste after it any accumulated diacritics
                        sField$ = sField$ + sUtf8Character$ + TranslateSortAndReturnDiacriticArray()
                        'GoTo TranslateMarc2Utf8TextError
                    End If
                Else ' must be G1
                    If sTag$ = "880" Or InStr(CHARACTERSET_Non880$, sMarc8CharacterSetCode1$) > 0 Then
TranslateMarc2Utf8TextOK2:
                        If InStr(UTF8DiacriticsAbove$, sUtf8Character$) > 0 Then
                            TranslateAddOneDiacriticToArray sUtf8Character$, Utf8Diacritics$
                            bChanged = True
                        ElseIf InStr(Utf8DiacriticsOther$, sUtf8Character$) > 0 Then
                            TranslateAddOneDiacriticToArray sUtf8Character$, Utf8Diacritics$
                            bChanged = True
                        Else
                            ' normal chacter; paste after it any accumulated diacritics
                            sField$ = sField$ + sUtf8Character$ + TranslateSortAndReturnDiacriticArray()
                        End If
                    ElseIf InStr(CHARACTERSET_GreekCodes$, sMarc8CharacterSetCode1$) > 0 Then
                        If sUtf8Character$ = MarcAlpha Or sUtf8Character$ = MarcBeta Or sUtf8Character$ = MarcGamma Then
                            ' these three are allowed in non-880 fields
                            GoTo TranslateMarc2Utf8TextOK2
                        Else
                            ' 20080828: at least in authority records--and therefore
                            '   probably anywhere else--escape sequences can appear anywhere
                            sField$ = sField$ + sUtf8Character$ + TranslateSortAndReturnDiacriticArray()
                            'GoTo TranslateMarc2Utf8TextError
                        End If
                    Else
                        ' 20080828: at least in authority records--and therefore
                        '   probably anywhere else--escape sequences can appear anywhere
                        sField$ = sField$ + sUtf8Character$ + TranslateSortAndReturnDiacriticArray()
                        'GoTo TranslateMarc2Utf8TextError
                    End If
                End If
            End If
        End If
        lPtr = lPtr + iLen%
TM2U8T_CheckForEnd:
        If lPtr > lLen Then
            Exit Do
        End If
    Loop
    
    ' put any accumulated diacritics not yet accounted for at the end of the finished
    '   string
    sText$ = sField$ + TranslateSortAndReturnDiacriticArray()
    
    
    ' for multi-byte character sets for which we've been supplied an inappropriate number
    '   of characters, translate the leftover into dummy codes
    If Len(sOdd$) > 0 Then
        'Debug.Print "MARC 2"
        sText$ = sText$ + "[MARC+"
        For lCtr = 1 To Len(sOdd$)
            sText$ = sText$ + MyMarcCharacter.Char2Hex(Mid(sOdd$, lCtr, 1))
        Next
        sText$ = sText$ + "]"
    End If
    
#If TranslateMarc2Utf8TextDebug = -1 Or TranslateMarc2Utf8TextErrorOnlyDebug = -1 Then
    Debug.Print "TM2U8T exit: >" + CharToHex(sText$) + "<"
#End If
    
End Sub

Public Sub TranslateUtf8Text2Marc(X, Y)

End Sub

Public Sub TranslateUtf82MarcOneField(ByRef sMarc8CharacterSetCodes$, ByVal sTag$, ByRef sText$, ByRef bChanged As Boolean, ByRef bError As Boolean)

    ' we receive in sText the complete variable field text, including
    '   delimiters and subfield codes, all in one big ol' string
    
    Dim lPtr As Long, lLen As Long, lCtr As Long
    
    Dim iLen%, iAsc%
    
    Dim sField$, sDiacriticsAbove$, sDiacriticsOther$, sMarc8Character$, sMarc8CharacterSetCode$
    Dim sCurrentCharacterSetCode$, sScrap$, sOriginalSubfield$, sOutputSubfield$, sSfc$
    Dim sTest$, sCurrentEscapeCode$, sPreviousEscapeCode$, sLeftEnd$, sCore$, sRightEnd$, sChar$
    Dim sLocalCharacterSetCodes$
    
    Dim bCharacterError As Boolean, bDiacritics As Boolean, bCharacterChanged As Boolean
    Dim b202FPresent As Boolean, b303FPresent As Boolean, bOtherCharactersPresent As Boolean
    Dim bAltered As Boolean
    
    m_iDiacriticLast% = 0
    
    
#If TranslateUtf82MarcOneFieldDebug = -1 Then
    Debug.Print "TU2MOF entry"
#End If
    ' assume the normal character set: ASCII as G0 and
    '   ANSEL as G1
    
    Do
    
        ' we're dealing with one subfield at a time, from left to right; we
        '   take the thing apart ourselves
        ' here, we isolate the next subfield and its code
        If Mid(sText$, 1, 1) = MyMarcCharacter.MarcDelimiter Then
Tu82MOFNextSubfield:
            sSfc$ = Mid(sText$, 1, 2)
            sText$ = Mid(sText$, 3)
        Else
            sSfc$ = ""
        End If
        lPtr = InStr(sText$, MyMarcCharacter.MarcDelimiter)
        Select Case lPtr
            Case 1
                ' an empty subfield: we won't translate anything
                If Len(sText$) = 0 Then
                    Exit Do
                End If
                GoTo Tu82MOFNextSubfield
            Case Is > 0
                ' current subfield is not the last subfield
                sOriginalSubfield$ = sSfc$ + Mid(sText$, 1, lPtr - 1)
                sSfc$ = ""
                sText$ = Mid(sText$, lPtr)
            Case Else
                ' zero: current subfield must also be the last subfield (which
                '   of course may also be the only subfield)
                sOriginalSubfield$ = sSfc$ + sText$
                sSfc$ = ""
                sText$ = ""
        End Select
        
        sCurrentCharacterSetCode$ = ""
        sOutputSubfield$ = ""

#If TranslateUtf82MarcOneFieldDebug = -1 Then
        Debug.Print "Sfd before conversion: >" + sOriginalSubfield$ + "< >" + CharToHex(sOriginalSubfield$)
#End If
        
        ' go through the extracted subfield one character at a time, from RIGHT to LEFT
        '   (so that we hit UTF-8 diacritics before we hit the base characters)
        ' we ourselves point lptr to the octet preceding the start of the previously-examined
        '   charcater, and let the character object back it up further if we're dealing with
        '   a multi-octet character
        ' we start out pointed to the last octet in the whole string, which may or may not
        '   be an octet in a multi-byte character
        lPtr = Len(sOriginalSubfield$)
        
        Do While lPtr > 0
        
            ' find the first octet of this character
            lPtr = MyMarcCharacter.Utf8CharFindFirstOctet(sOriginalSubfield$, lPtr)
            
            ' translate this one character
            MyMarcCharacter.TranslateUtf82MarcOneCharacter m_sCharacterSetOut$, sMarc8CharacterSetCode$, Mid(sOriginalSubfield$, lPtr, MyMarcCharacter.Utf8CharOctets(Mid(sOriginalSubfield$, lPtr, 1))), sMarc8Character$, bCharacterChanged, bCharacterError

            bChanged = bChanged Or bCharacterChanged
            
            If bCharacterError Then
TranslateUtf82MarcTextError:
                bError = True
                iLen% = MyMarcCharacter.Utf8CharOctets(Mid(sOriginalSubfield, lPtr, 1))
                sChar$ = Mid(sOriginalSubfield, lPtr, iLen%)
                sChar$ = MyMarcCharacter.Utf82Ucs(sChar$)
                MyMarcCharacter.UcsChar = sChar$
                sChar$ = LCase(MyMarcCharacter.UcsHex)
                sOutputSubfield$ = "&#x" + sChar$ + ";" + sOutputSubfield$
                bCharacterError = False
            ElseIf sTag$ = "880" Then
TMU2MOF_EverythingNowOK:
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                Debug.Print "TMU2MOFENOK codes: >" + sCurrentCharacterSetCode$ + "< >" + sMarc8CharacterSetCode$ + "<"
#End If
                ' if we don't have a "current" code yet, then set it equal to the
                '   code for the current character (this will typically
                '   happen for the rightmost character in the first subfield)
                If Len(sCurrentCharacterSetCode$) = 0 Then
                    sCurrentCharacterSetCode$ = sMarc8CharacterSetCode$
                End If
                If sTag$ = "880" Then ' 20080829: seemingly-redundant test added, because we can now branch here
                    ' we'll accept any character sets defined for MARC in the 880, without further testing
                    If InStr(sMarc8CharacterSetCodes$, " " + sMarc8CharacterSetCode$ + " ") = 0 Then
                        sMarc8CharacterSetCodes$ = sMarc8CharacterSetCodes$ + " " + sMarc8CharacterSetCode$ + " "
                    End If
                    ' 20070425: accumulate also codes just for this one field, separate from the
                    '   overall list for the record
                    If InStr(sLocalCharacterSetCodes$, " " + sMarc8CharacterSetCode$ + " ") = 0 Then
                        sLocalCharacterSetCodes$ = sLocalCharacterSetCodes$ + " " + sMarc8CharacterSetCode$ + " "
                    End If
                End If
                If sCurrentCharacterSetCode$ <> sMarc8CharacterSetCode$ Then
                    sOutputSubfield$ = MarcEscape + TranslateUtf82MarcShortCodeToLong(sCurrentCharacterSetCode$) + sOutputSubfield$
                    ' we've just dealt with the stuff to the right of the current
                    '   character; so the current character's code is now
                    '   the current code
                    sCurrentCharacterSetCode$ = sMarc8CharacterSetCode$
                End If ' did we just change character sets?
                ' deal with diacritics: if the current character *is*
                '   a diacritic, accumulate it; if it is not a diacritic,
                '   any accumulated diacritics go to its left
                If InStr(Marc8DiacriticsAbove$, sMarc8Character$) > 0 Then
                    TranslateAddOneDiacriticToArray sMarc8Character$, Marc8Diacritics$
                    bDiacritics = True
                ElseIf InStr(Marc8DiacriticsAbove$, sMarc8Character$) > 0 Then
                    TranslateAddOneDiacriticToArray sMarc8Character$, Marc8Diacritics$
                    bDiacritics = True
                Else
                    ' normal character; stick it on to the growing string
                    sOutputSubfield$ = sMarc8Character$ + sOutputSubfield$
                    ' any accumulated diacritics come before this letter
                    If bDiacritics Then
                        If sCurrentCharacterSetCode$ <> "1" Then
                            sOutputSubfield$ = MarcEscape + sCurrentCharacterSetCode$ + sOutputSubfield$
                            sCurrentCharacterSetCode$ = "1"
                        End If
                        sOutputSubfield$ = TranslateSortAndReturnDiacriticArray() + sOutputSubfield$
                        bDiacritics = False
                    End If
                End If
            Else ' not 880, and no errors
                If Len(sCurrentCharacterSetCode$) = 0 Then
                    sCurrentCharacterSetCode$ = sMarc8CharacterSetCode$
                End If
                If InStr(CHARACTERSET_Non880$, sMarc8CharacterSetCode$) > 0 Then
TranslateUtf82MarcTextOK:
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                    Debug.Print "MarcTextOK fall-through: >" + sCurrentCharacterSetCode$ + "< >" + sMarc8CharacterSetCode$ + "<"
#End If
                    If sCurrentCharacterSetCode$ <> sMarc8CharacterSetCode$ Then
                        sOutputSubfield$ = MarcEscape + TranslateUtf82MarcShortCodeToLong(sCurrentCharacterSetCode$) + sOutputSubfield$
                        sCurrentCharacterSetCode$ = sMarc8CharacterSetCode$
                    End If
                    If InStr(Marc8DiacriticsAbove$, sMarc8Character$) > 0 Then
                        TranslateAddOneDiacriticToArray sMarc8Character$, Marc8Diacritics$
                        'sDiacriticsAbove$ = sDiacriticsAbove$ + sMarc8Character$
                        bDiacritics = True
                    ElseIf InStr(Marc8DiacriticsOther$, sMarc8Character$) > 0 Then
                        TranslateAddOneDiacriticToArray sMarc8Character$, Marc8Diacritics$
                        'sDiacriticsOther$ = sMarc8Character$ + sDiacriticsOther$
                        bDiacritics = True
                    Else
                        ' non-diacritic character; stick it on to the growing string
                        sOutputSubfield$ = sMarc8Character$ + sOutputSubfield$
                        ' any accumulated diacritics come before this letter
                        If bDiacritics Then
                            If sCurrentCharacterSetCode$ <> "1" Then
                                sOutputSubfield$ = MarcEscape + sCurrentCharacterSetCode$ + sOutputSubfield$
                                sCurrentCharacterSetCode$ = "1"
                            End If
                            sOutputSubfield$ = TranslateSortAndReturnDiacriticArray() + sOutputSubfield$
                            bDiacritics = False
                        End If
                    End If
                ElseIf InStr(CHARACTERSET_GreekCodes$, sMarc8CharacterSetCode$) > 0 Then
                    If sMarc8Character$ = MarcAlpha Or sMarc8Character$ = MarcBeta Or sMarc8Character$ = MarcGamma Then
                        ' these three are allowed in non-880 fields
                        GoTo TranslateUtf82MarcTextOK
                    Else
                        GoTo TMU2MOF_EverythingNowOK
                        'GoTo TranslateUtf82MarcTextError
                    End If
                Else
                    GoTo TMU2MOF_EverythingNowOK
                    'GoTo TranslateUtf82MarcTextError
                End If
             End If ' error? 880? non-880?
            
            ' lptr is currently on the forst octet of the utf8 character; back up into the previous
            '   character and continue
            lPtr = lPtr - 1
        Loop
        
        If bDiacritics Then
            If sCurrentCharacterSetCode$ <> "1" Then
                sOutputSubfield$ = MarcEscape + sCurrentCharacterSetCode$ + sOutputSubfield$
                sCurrentCharacterSetCode$ = "1"
            End If
            sOutputSubfield$ = TranslateSortAndReturnDiacriticArray() + sOutputSubfield$
            bDiacritics = False
        End If
        
        lPtr = Rat(sOutputSubfield$, MarcEscape)
        If lPtr > 0 Then
            If sTag$ <> "880" Then
                If InStr(sOutputSubfield$, MarcEscape$ + "(") = 0 And InStr(sOutputSubfield$, MarcEscape$ + "$") = 0 Then
                    If Mid(sOutputSubfield$, lPtr + 1, 1) <> "s" Then
                        sOutputSubfield$ = sOutputSubfield$ + MarcEscape + "s"
                    End If
                Else
                    If Mid(sOutputSubfield$, lPtr + 1, 2) <> "(B" Then
                        sOutputSubfield$ = sOutputSubfield$ + MarcEscape + "(B"
                    End If
                End If
            Else
                If Mid(sOutputSubfield$, lPtr + 1, 2) <> "(B" Then
                    sOutputSubfield$ = sOutputSubfield$ + MarcEscape + "(B"
                End If
            End If
        End If
        
        
        ' 20050722: now some additional fun
        ' THIS ONLY APPLIES TO 880 SUBFIELDS that contain an escape
        ' the "exceptional characters" we're dealing with here are the
        '   "normal" punctuation characters (hex 20-2F) in cyrillic, greek and
        '   hebrew; and numerals and more punctuation (hex 30-3F) in hebrew an
        '   cyrillic (but not greek)
        ' if an-escape delimited string of "standard set" characters is composed
        '   entirely of these exceptional characters AND IF the character sets to
        '   the left and to the right of this string are both of one of the
        '   accepted types, then we remove the escape switches that delimit this
        '   string of exceptional characters, so that they participate in the
        '   character set of their context
        ' similarly, if a subfield ends with a sequence of only exceptional characters
        '   and the previous character set allows all of these characters, then put
        '   these characters within the previous character set, retaining the
        '   "switch back to normal" at the end of the subfield
        ' (no such similar treatment for text that comes at the beginning of the
        '   subfield, before the first "escape" sequence)
        If sTag$ = "880" Then
            If InStr(sOutputSubfield$, MarcEscape) > 0 Then
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                Debug.Print "Sfd Converted with excape: >" + sOutputSubfield$ + "<"
#End If
                If InStr(sOutputSubfield$, MarcEscape$ + CHARACTERSET_CODES_FOR_880_HebrewAsG0$) > 0 Or InStr(sOutputSubfield$, MarcEscape$ + CHARACTERSET_CODES_FOR_880_BasicCyrillicAsG0$) > 0 Or InStr(sOutputSubfield$, MarcEscape$ + CHARACTERSET_CODES_FOR_880_BasicArabicAsG0$) > 0 Then
                    ' if we get here, then this subfield does actually
                    '   require the elaborate attention called for by this
                    '   exceptional condition
                    sOriginalSubfield$ = sOutputSubfield$
                    sOutputSubfield$ = ""
                    sPreviousEscapeCode$ = ""
                    ' break off each escape-delimited piece
                    Do
                        lPtr = InStr(sOriginalSubfield$, MarcEscape)
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                        Debug.Print str(lPtr) + " >" + sOriginalSubfield$ + "< >" + sOutputSubfield$ + "<"
#End If
                        bAltered = False
                        Select Case lPtr
                            Case 0
                                sTest$ = sOriginalSubfield$
                                sOriginalSubfield$ = ""
                                ' todo: test this last piece for criteria as described above
                            Case 1
                                ' either the subfield begins with an escape-marker, or
                                '   we're somewhere within the subfield
                                'sCurrentEscapeCode$, sPreviousEscapeCode$
                                ' all of the codes that we generate are 2-byte codes
                                sCurrentEscapeCode$ = Mid(sOriginalSubfield$, lPtr + 1, 2)
                                sOriginalSubfield$ = Mid(sOriginalSubfield$, lPtr + 3)
                                lPtr = InStr(sOriginalSubfield$, MarcEscape)
                                If lPtr = 0 Then
                                    ' the string of interest occurs at the end of the subfield
                                    sTest$ = sOriginalSubfield$
                                    sOriginalSubfield$ = ""
                                    If sCurrentEscapeCode = CHARACTERSET_CODES_FOR_880_BasicAsG0$ Then
                                        TranslateUtf82MarcOneFieldExceptionalCharacters sTest$, b202FPresent, b303FPresent, bOtherCharactersPresent
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                                        Debug.Print "Result from exceptional test: >" + sTest$ + "< >" + str(b202FPresent) + " " + str(b303FPresent) + " " + str(bOtherCharactersPresent)
#End If
                                        'CHARACTERSET_CODES_FOR_880_BasicArabicAsG0$
                                        If Not bOtherCharactersPresent Then
                                            Select Case sPreviousEscapeCode$
                                                Case CHARACTERSET_CODES_FOR_880_HebrewAsG0$
                                                    If b202FPresent Or b303FPresent Then
TU82MOFAlterEscapeCoding2:                              ' NOTE label in left margin
                                                        sOutputSubfield$ = sOutputSubfield$ + sTest$ + MarcEscape + CHARACTERSET_CODES_FOR_880_BasicAsG0$
                                                        bAltered = True
                                                    End If
                                                Case CHARACTERSET_CODES_FOR_880_BasicCyrillicAsG0$
                                                    If b202FPresent Or b303FPresent Then
                                                        GoTo TU82MOFAlterEscapeCoding2
                                                    End If
                                                Case CHARACTERSET_CODES_FOR_880_BasicArabicAsG0$
                                                    If Len(sTest$) = 1 And InStr(",;?%", sTest$) > 0 Then
                                                        ' do nothing with these--leave 'em alone
                                                    Else
                                                        If b202FPresent And Not b303FPresent Then
                                                            GoTo TU82MOFAlterEscapeCoding2
                                                        ElseIf b202FPresent And b303FPresent Then
                                                            ' 303F is OK as long as it's not
                                                            '   30 through 39 ...
                                                            If InStr(sTest$, "0") = 0 And InStr(sTest$, "1") = 0 And InStr(sTest$, "2") = 0 And InStr(sTest$, "3") = 0 And InStr(sTest$, "4") = 0 And InStr(sTest$, "5") = 0 And InStr(sTest$, "6") = 0 And InStr(sTest$, "7") = 0 And InStr(sTest$, "8") = 0 And InStr(sTest$, "9") = 0 Then
                                                                GoTo TU82MOFAlterEscapeCoding2
                                                            End If
                                                            ' if we get here, then the string contains a mixture of
                                                            '   characters 20-2F plus one or more numerals
                                                            ' we're going to split the thing into 2 pieces:
                                                            '   1) the left end, containing non-numerals
                                                            '   2) the central core, beginning with the first numeral, plus
                                                            '   any other stuff on the right (we don't care what follows
                                                            '   the first numeral)
                                                            sCore$ = sTest$
                                                            sLeftEnd$ = ""
                                                            sRightEnd$ = ""
                                                            Do While Len(sCore$) > 0
                                                                If InStr("0123456789", Mid(sCore$, 1, 1)) > 0 Then
                                                                    Exit Do
                                                                End If
                                                                sLeftEnd$ = sLeftEnd$ + Mid(sCore$, 1, 1)
                                                                sCore$ = Mid(sCore$, 2)
                                                            Loop
                                                            ' if we removed any characters from the left end,
                                                            '   place them inside the preceding character
                                                            '   sequence
                                                            sOutputSubfield$ = sOutputSubfield$ + sLeftEnd$
                                                            sOriginalSubfield$ = SafeStuff(sOriginalSubfield$, 4, 0, sRightEnd$)
                                                            ' if we have any characters left in the core (we ought
                                                            '   to, by definition), then leave this escape
                                                            '   sequence between the other two
                                                            ' but all we want in the middle now, is the numeral-bounded string
                                                            sTest$ = sCore$
                                                            ' and we'll pretend we haven't changed anything ...
                                                            bAltered = False
                                                        End If
                                                    End If
                                            End Select
                                        End If
                                    End If
                                    If Not bAltered Then
                                        sOutputSubfield$ = sOutputSubfield$ + MarcEscape + sCurrentEscapeCode$ + sTest$
                                    End If
                                Else
                                    ' the current escape sequence is followed by yet another in
                                    '   the same subfield
                                    sTest$ = Mid(sOriginalSubfield$, 1, lPtr - 1)
                                    sOriginalSubfield$ = Mid(sOriginalSubfield$, lPtr)
                                    If Len(sPreviousEscapeCode$) > 0 Then
                                        If sCurrentEscapeCode$ = CHARACTERSET_CODES_FOR_880_BasicAsG0$ Then
                                            If sPreviousEscapeCode$ = Mid(sOriginalSubfield$, 2, 2) Then
                                                ' we have a string of "normal" characters in between
                                                '   two other strings of the same type
                                                ' what kind of characters do we have?
                                                TranslateUtf82MarcOneFieldExceptionalCharacters sTest$, b202FPresent, b303FPresent, bOtherCharactersPresent
                                                If Not bOtherCharactersPresent Then
                                                    Select Case sPreviousEscapeCode$
                                                        Case CHARACTERSET_CODES_FOR_880_HebrewAsG0$
                                                            If b202FPresent Or b303FPresent Then
TU82MOFAlterEscapeCoding:                                       ' NOTE label in left margin
                                                                sOutputSubfield$ = sOutputSubfield$ + sTest$
                                                                sOriginalSubfield$ = Mid(sOriginalSubfield$, 4)
                                                                lPtr = InStr(sOriginalSubfield$, MarcEscape)
                                                                If lPtr > 0 Then ' it better be!
                                                                    sOutputSubfield$ = sOutputSubfield$ + Mid(sOriginalSubfield$, 1, lPtr - 1)
                                                                    sOriginalSubfield$ = Mid(sOriginalSubfield$, lPtr)
                                                                End If
                                                                bAltered = True
                                                                sCurrentEscapeCode$ = sPreviousEscapeCode$
                                                            End If
                                                        Case CHARACTERSET_CODES_FOR_880_BasicCyrillicAsG0$
                                                            If b202FPresent Or b303FPresent Then
                                                                GoTo TU82MOFAlterEscapeCoding
                                                            End If
                                                        Case CHARACTERSET_CODES_FOR_880_BasicArabicAsG0$
                                                            If Len(sTest$) = 1 And InStr(",;?%", sTest$) > 0 Then
                                                                ' do nothing with these--leave 'em alone
                                                            Else
                                                                If b202FPresent And Not b303FPresent Then
                                                                    GoTo TU82MOFAlterEscapeCoding
                                                                ElseIf b202FPresent And b303FPresent Then
                                                                    ' the string contains a mixture of characters in the
                                                                    '   ranges 20-2F and 30-3F
                                                                    ' 30-3F is OK as long as it's not
                                                                    '   30 through 39 ...
                                                                    If InStr(sTest$, "0") = 0 And InStr(sTest$, "1") = 0 And InStr(sTest$, "2") = 0 And InStr(sTest$, "3") = 0 And InStr(sTest$, "4") = 0 And InStr(sTest$, "5") = 0 And InStr(sTest$, "6") = 0 And InStr(sTest$, "7") = 0 And InStr(sTest$, "8") = 0 And InStr(sTest$, "9") = 0 Then
                                                                        GoTo TU82MOFAlterEscapeCoding
                                                                    End If
                                                                    ' if we get here, then the string contains a mixture of
                                                                    '   characters 20-2F plus one or more numerals
                                                                    ' we're going to split the thing into up to 3 pieces:
                                                                    '   1) the left end, containing non-numerals
                                                                    '   2) the central core, beginning and ending with numerals
                                                                    '   3) the right end, containing non-numerals
                                                                    sCore$ = sTest$
                                                                    sLeftEnd$ = ""
                                                                    sRightEnd$ = ""
                                                                    Do While Len(sCore$) > 0
                                                                        If InStr("0123456789", Mid(sCore$, 1, 1)) > 0 Then
                                                                            Exit Do
                                                                        End If
                                                                        sLeftEnd$ = sLeftEnd$ + Mid(sCore$, 1, 1)
                                                                        sCore$ = Mid(sCore$, 2)
                                                                    Loop
                                                                    Do While Len(sCore$) > 0
                                                                        If InStr("0123456789", Right(sCore$, 1)) > 0 Then
                                                                            Exit Do
                                                                        End If
                                                                        sRightEnd$ = Right(sCore$, 1) + sRightEnd$
                                                                        sCore$ = Mid(sCore$, 1, Len(sCore$) - 1)
                                                                    Loop
                                                                    ' if we removed any characters from the left end,
                                                                    '   place them inside the preceding character
                                                                    '   sequence
                                                                    sOutputSubfield$ = sLeftEnd$
                                                                    ' if we removed any characters from the right end, place
                                                                    '   them inside the following character sequence
                                                                    sOriginalSubfield$ = SafeStuff(sOriginalSubfield$, 4, 0, sRightEnd$)
                                                                    ' if we have any characters left in the core (we ought
                                                                    '   to, by definition), then leave this escape
                                                                    '   sequence between the other two
                                                                    ' but all we want in the middle now, is the numeral-bounded string
                                                                    sTest$ = sCore$
                                                                    ' and we'll pretend we haven't changed anything ...
                                                                    bAltered = False
                                                                End If
                                                            End If
                                                    End Select
                                                'Else
                                                    ' the string contains characters other than those in the
                                                    '   range 20-3F; we're going to leave it alone (for now ...)
                                                    ' todo: eventually, we could see if anything at either the
                                                    '   left or right end (such as a space) could go with the previous
                                                    '   or following string ...
                                                End If
                                            End If
                                        End If
                                    End If
                                    If Not bAltered Then
                                        sOutputSubfield$ = sOutputSubfield$ + MarcEscape + sCurrentEscapeCode$ + sTest$
                                    End If
                                    sPreviousEscapeCode$ = sCurrentEscapeCode$
                                End If
                            Case Else
                                ' must be that we're at the beginning of the field,
                                '   and there's a "normal" string before the first
                                '   escape code
                                sOutputSubfield$ = sOutputSubfield$ + Mid(sOriginalSubfield$, 1, lPtr - 1)
                                sOriginalSubfield$ = Mid(sOriginalSubfield$, lPtr)
                        End Select
                        If Len(sOriginalSubfield$) = 0 Then
                            Exit Do
                        End If
                    Loop
                End If
            End If
        End If
        
#If TranslateUtf82MarcOneFieldDebug = -1 Then
        Debug.Print "Sfd after conversion: >" + sSfc$ + sOutputSubfield$ + "< >" + CharToHex(sSfc$ + sOutputSubfield$)
#End If
        
        sField$ = sField$ + sSfc$ + sOutputSubfield$
        
        If Len(sText$) = 0 Then
            Exit Do
        End If
    Loop
        
    ' 20070425: add character set code to end of $6 if missing
    sLocalCharacterSetCodes$ = TranslateUtf82MarcCharacterSetString(sLocalCharacterSetCodes$, "/")
    If Len(sLocalCharacterSetCodes$) > 0 Then ' this can only happen if the tag is 880
        iLen% = InStr(sField$, MyMarcCharacter.MarcDelimiter + "6")
        If iLen% > 0 Then
            sChar$ = Mid(sField$, 1, iLen% + 2) ' contains the field through the $6 marker
            sField$ = Mid(sField$, iLen% + 3) ' contains the field starting with first char of $6 text
            iLen% = InStr(sField$, MyMarcCharacter.MarcDelimiter)
            If iLen% > 0 Then
                sSfc$ = Mid(sField$, 1, iLen% - 1) ' contains the text of $6 itself
                sField$ = Mid(sField$, iLen%) ' remaining field, starting with $
            Else
                sSfc$ = sField$
                sField$ = ""
            End If
            ' we only use the very first code in $6
            If Mid(sLocalCharacterSetCodes$, 1, 1) = "/" Then
                sLocalCharacterSetCodes$ = Mid(sLocalCharacterSetCodes$, 2)
            End If
            iLen% = InStr(sLocalCharacterSetCodes$, "/")
            If iLen% > 0 Then
                sLocalCharacterSetCodes$ = Mid(sLocalCharacterSetCodes$, 1, iLen% - 1)
            End If
            ' re-add the separating slash, and if necessary a right-to-left marker
            Select Case sLocalCharacterSetCodes$
                ' 20070531: replace literal references (incorrect in one case) with constants
                'Case "(3", "(2)"
                Case CHARACTERSET_CODES_FOR_880_BasicArabicAsG0$, CHARACTERSET_CODES_FOR_880_HebrewAsG0$
                    sLocalCharacterSetCodes$ = "/" + sLocalCharacterSetCodes$ + "/r"
                Case Else
                    sLocalCharacterSetCodes$ = "/" + sLocalCharacterSetCodes$
            End Select
            ' remove any code that may currently exist in the $6
            iLen% = InStr(sSfc$, "/")
            If iLen% > 0 Then
                sSfc$ = Mid(sSfc$, 1, iLen% - 1)
            End If
            ' at this point:
            '   sChar$ contains the field up to and including $6
            '   sSfc$ contains the text of $6
            '   sField$ contains everything following $6, starting with its delimiter code
            '   sLocalCharacterSetCodes contains the business to add to $6
            sField$ = sChar$ + sSfc$ + sLocalCharacterSetCodes$ + sField$
        End If
    End If
    
    ' return the modified field
    sText$ = sField$

    ' todo: do we not need a "return to normal character set" not only at the end of the
    '   field, if the last subfield in the field does not already end with a
    '   normal character?
    
End Sub

Public Sub Translate880FieldTranslateThePiece(ByRef sPiece$, ByRef bChanged As Boolean)

    Dim iCtr%
    
    If sCharacterSetup$ = "L2M" Then
        TranslateRemainder sPiece$, bChanged
        Exit Sub
    End If
    
    For iCtr% = 1 To iCharacterLast%
        TranslateOneCharacter sPiece$, aCharacter(iCtr%).From, aCharacter(iCtr%).To, bChanged
    Next ' ictr%
    TranslateRemainder sPiece$, bChanged

End Sub

Public Property Get FldInd1() As String

    If FldPointer > -1 Then
        If MarcArray(FldPointer).IsControl Then
            FldInd1 = ""
        Else
            FldInd1 = Mid(MarcArray(FldPointer).Ind, 1, 1)
        End If
    Else
        FldInd1 = ""
    End If

End Property

Public Property Let FldInd1(ByVal vNewValue As String)

    If FldPointer > -1 Then
        If Not MarcArray(FldPointer).IsControl Then
#If ResetCurrentFieldDebug = -1 Then
            Debug.Print "RCF from fldind1 1"
#End If
            ResetCurrentField FldTag, Mid(vNewValue + " ", 1, 1) + Mid(FldInd, 2, 1), FldText
        Else
#If ResetCurrentFieldDebug = -1 Then
            Debug.Print "RCF from fldind1 2"
#End If
            ResetCurrentField FldTag, "", FldText
        End If
    End If

End Property

Public Property Get FldInd2() As String

    If FldPointer > -1 Then
        If MarcArray(FldPointer).IsControl Then
            FldInd2 = ""
        Else
            FldInd2 = Mid(MarcArray(FldPointer).Ind, 2, 1)
        End If
    Else
        FldInd2 = ""
    End If

End Property

Public Property Let FldInd2(ByVal vNewValue As String)

    If FldPointer > -1 Then
        If Not MarcArray(FldPointer).IsControl Then
#If ResetCurrentFieldDebug = -1 Then
            Debug.Print "RCF from fldind2 1"
#End If
            ResetCurrentField FldTag, Mid(FldInd, 1, 1) + Mid(vNewValue + " ", 1, 1), FldText
        Else
#If ResetCurrentFieldDebug = -1 Then
            Debug.Print "RCF from fldind2 2"
#End If
            ResetCurrentField FldTag, "", FldText
        End If
    End If

End Property

Public Sub FldGetInfo(ByRef sTag$, ByRef sIndicators$, ByRef sField$)

    sTag$ = FldTag
    sIndicators$ = FldInd
    sField$ = FldText
    
End Sub


Public Function CharCategory(ByVal sChar$) As String

    'Debug.Print "Char cat >" + sChar$ + "<"
    If Len(sChar$) = 0 Then
        CharCategory = "Cc"
        Exit Function
    End If
    If m_bUtf8 Then
        MyMarcCharacter.Utf8Char = sChar$
        CharCategory = MyMarcCharacter.Utf8CharCategory
    Else
        ' simulate this for non-Unicode characters
        Select Case Asc(Mid(sChar$, 1, 1))
            Case 27, 29, 30, 31
                CharCategory = "Cc"
            Case 32
                CharCategory = "Zs"
            Case 34, 39
                CharCategory = "Pi"
            Case 40, 60, 91, 123
                CharCategory = "Ps"
            Case 41, 62, 93, 125
                CharCategory = "Pe"
            Case 45
                CharCategory = "Pd"
            Case 48 To 59, 208 To 227 ' including subcripts for voyager
                CharCategory = "Nd"
            Case 65 To 90, 161 To 166, 172, 173
                CharCategory = "Lu"
            Case 97 To 122, 145, 160, 175, 177 To 182, 186, 188, 189, 190, 191 ' including voyager 3 greeks, script-l for MARC and Voyager, script-l for OCLC
                CharCategory = "Ll"
            Case 192 To 198
                If CharacterSetIn = "V" Then
                    CharCategory = "Nd"
                Else
                    CharCategory = "Po"
                End If
            Case 199 To 201
                CharCategory = "Nd"
            Case 224 To 255
                CharCategory = "Mn"
            Case Else
                CharCategory = "Po"
        End Select
    End If
    
End Function

Public Function SafeLen(sString$) As Long

    Dim lTotal As Long, lPtr As Long, lEnd As Long
    
    Dim iOctets%
    
    
    If m_bUtf8 Then
        lPtr = 1
        lEnd = Len(sString$)
        If lEnd > 0 Then
            Do
                MyMarcCharacter.Utf8Char = Mid(sString$, lPtr)
                iOctets% = MyMarcCharacter.Utf8CharOctets
                lTotal = lTotal + 1
                lPtr = lPtr + iOctets%
                If lPtr > lEnd Then
                    Exit Do
                End If
            Loop
        End If
        SafeLen = lTotal
    Else
        SafeLen = Len(sString$)
    End If

End Function

Public Property Get FldOrderFolder() As String

    FldOrderFolder = m_sFieldOrderFolder$

End Property

Public Property Let FldOrderFolder(ByVal vNewValue As String)

    Dim sTestValue$
    
    If m_iMarcCtr% <> 0 Then
        Exit Property
    End If

    
    sTestValue$ = vNewValue
    If Right(sTestValue$, 1) <> "\" Then
        sTestValue$ = sTestValue$ + "\"
    End If
    ' 20050803: if same as the current value, then it didn't really
    '   change, did it?
    If m_sFieldOrderFolder$ = sTestValue$ Then
        Exit Property
    End If
    ' 20080923: if there is no field order folder, then there's
    '   not any reading to do; reset (back?) to the default
    '   value, and make like a tree
    If Len(sTestValue$) = 0 Then
        m_sFieldOrderFolder$ = ""
        ClearFldOrder "A"
        ClearFldOrder "B"
        ClearFldOrder "H"
        SetDefaultFldOrderAuth
        SetDefaultFldOrderBib
        SetDefaultFldOrderHold
        Exit Property
    End If
    
    gblbTestOrderStuff = True
    m_sFieldOrderFolder$ = sTestValue$
    
    ClearFldOrder "B"
    SetFieldOrderFromFile "B", m_sFieldOrderFolder$ + "bibsup.cfg", gblaFieldOrderBib(), gbliFieldOrderBibLast%, gbliFieldOrderBibMax%
    ClearSfdOrder "B"
    SetSfdOrderFromFile "B", m_sFieldOrderFolder$ + "bibsup.cfg", gblaSubfieldOrderBib(), gbliSubfieldOrderBibLast%, gbliSubfieldOrderBibMax%
    
    ClearFldOrder "H"
    SetFieldOrderFromFile "H", m_sFieldOrderFolder$ + "holdsup.cfg", gblaFieldOrderHold(), gbliFieldOrderHoldLast%, gbliFieldOrderHoldMax%
    ClearSfdOrder "H"
    SetSfdOrderFromFile "H", m_sFieldOrderFolder$ + "holdsup.cfg", gblaSubfieldOrderHold(), gbliSubfieldOrderHoldLast%, gbliSubfieldOrderHoldMax%
    
    ClearFldOrder "A"
    SetFieldOrderFromFile "A", m_sFieldOrderFolder$ + "authsup.cfg", gblaFieldOrderAuth(), gbliFieldOrderAuthLast%, gbliFieldOrderAuthMax%
    ClearSfdOrder "A"
    SetSfdOrderFromFile "A", m_sFieldOrderFolder$ + "authsup.cfg", gblaSubfieldOrderAuth(), gbliSubfieldOrderAuthLast%, gbliSubfieldOrderAuthMax%
    
End Property

Private Sub SetFieldOrderFromFile(ByVal sType$, ByVal sFile$, ByRef aFieldOrder() As FieldOrderType, ByRef iFieldOrderLast%, ByRef iFieldOrderMax%)

    Dim sSection$, sLine$, sStart$, sEnd$, sDefault$
    Dim sSectionName$
    
    Dim iEquals%
    
    Dim lLength As Long, lReturn As Long, lRc As Long
    
    
    'Debug.Print "SFOFF: >" + sType$ + "< >" + sFile$ + "<"
    ClearFldOrder sType$
    iFieldOrderLast% = 0
    
    ' we're going to include here code that actually duplicates code in
    '   the INI.BAS module (tailored for this particular case), so that projects aren't
    '   required to include INI.BAS whenever they include this object
    sSectionName$ = "ExtendedFieldOrder"
    sDefault$ = ""
    sSection$ = Space(32000) + Chr(0)
    lLength = 32001
    
    lReturn = GetPrivateProfileSection(sSectionName$, sSection$, lLength, sFile$)

    ' remove the trailing double-null that marks the end of the list
    lReturn = InStr(sSection$, Chr(0) + Chr(0))
    If lReturn > 0 Then
        sSection$ = Mid(sSection$, 1, lReturn - 1)
    End If
    
    ' convert any internal nulls to the replacement separator character
    ' 20051011: somehow or other the following loop went infinite while
    '   processing a file of records that had been processed twice
    '   before
    ' we'll substitute one possible equivalent and
    '   see if it does any better ...
    Do
        lRc = InStr(sSection$, Chr(0))
        If lRc = 0 Then
            Exit Do
        Else
            sSection$ = SafeStuff(sSection$, lRc, 1, vbTab)
        End If
    Loop

    sSection$ = Trim(sSection$)
    
    
    ' if the string consists only of the separator character, it doesn't
    '   exist at all
    If sSection$ = vbTab Then
        sSection$ = ""
    End If
    
    If Len(sSection$) > 0 Then
        Do
            GetNextPiece sSection$, sLine$, vbTab
            If IsGoodIniLine(sLine$, iEquals%) Then
                sLine$ = Mid(sLine$, iEquals% + 1)
                GetNextPiece sLine$, sStart$, " "
                iEquals% = InStr(sStart$, "-")
                If iEquals% > 0 Then
                    sEnd$ = Mid(sStart$, iEquals% + 1)
                    sStart$ = Mid(sStart$, 1, iEquals% - 1)
                Else
                    sEnd$ = sStart$
                End If
                SetFldOrder sType$, sStart$, sEnd$, SetFieldOrderMethodFromText(sLine$)
            End If
            If Len(sSection$) = 0 Then
                Exit Do
            End If
        Loop
    Else
        sSectionName$ = "FieldOrder"
        sDefault$ = ""
        sSection$ = Space(32000) + Chr(0)
        lLength = 32001
        
        lReturn = GetPrivateProfileSection(sSectionName$, sSection$, lLength, sFile$)
    
        ' remove the trailing double-null that marks the end of the list
        lReturn = InStr(sSection$, Chr(0) + Chr(0))
        If lReturn > 0 Then
            sSection$ = Mid(sSection$, 1, lReturn - 1)
        End If
        
        ' convert any internal nulls to our replacement separator character
#If True Then
        Do
            lRc = InStr(sSection$, Chr(0))
            If lRc = 0 Then
                Exit Do
            Else
                sSection$ = SafeStuff(sSection$, lRc, 1, vbTab)
            End If
        Loop
#Else
        Do
            lRc = InStr(sSection$, Chr(0))
            ' the following allows us to avoid reference to
            '   the 'stuff' function
            Select Case lRc
                Case 0
                    Exit Do
                Case 1
                    sSection$ = vbTab + Mid(sSection$, 2)
                Case Else
                    sSection$ = Mid(sSection$, 1, lRc - 1) + vbTab + Mid(sSection$, lRc + 1)
            End Select
        Loop
#End If

        sSection$ = Trim(sSection$)
        
        ' if the string consists only of the separator character, it doesn't
        '   exist at all
        If sSection$ = vbTab Then
            sSection$ = ""
        End If
        
        Do
            GetNextPiece sSection$, sLine$, vbTab
            If IsGoodIniLine(sLine$, iEquals%) Then
                sStart$ = Mid(sLine$, 1, 1)
                sLine$ = Mid(sLine$, iEquals% + 1)
                If sStart$ = "0" Then
                    SetFldOrder sType$, "001", "009", SetFieldOrderMethodFromText("Tag")
                    sStart$ = "010"
                    sEnd$ = "099"
                Else
                    sEnd$ = sStart$ + "99"
                    sStart$ = sStart$ + "00"
                End If
                SetFldOrder sType$, sStart$, sEnd$, SetFieldOrderMethodFromText(sLine$)
            End If
            If Len(sSection$) = 0 Then
                Exit Do
            End If
        Loop
    End If
    
    ' one final catch-all entry just in case everything is bad
    SetFldOrder sType$, "001", "999", SetFieldOrderMethodFromText("Generic")
    
End Sub

Private Function SetFieldOrderMethodFromText(sFieldOrderDescription$) As Integer

    Select Case UCase(sFieldOrderDescription$)
        Case "TAG", "T"
            SetFieldOrderMethodFromText = SORTINSTRUCTION_Tag%
        Case "7"
            SetFieldOrderMethodFromText = SORTINSTRUCTION_7XX%
        Case "INDICATOR2", "2", "IND2", "INDIC2"
            SetFieldOrderMethodFromText = SORTINSTRUCTION_Indicator2%
        Case "LOCAL", "5", "NUC"
            SetFieldOrderMethodFromText = SORTINSTRUCTION_Local%
        Case "SFD8"
            SetFieldOrderMethodFromText = SORTINSTRUCTION_Sfd8PlusTag%
        Case "REFERENCE", "REF"
            SetFieldOrderMethodFromText = SORTINSTRUCTION_Reference%
        Case "PAIRED", "P", "PAIR"
            SetFieldOrderMethodFromText = SORTINSTRUCTION_Paired880s%
        Case "PAIRED LC", "PAIREDLC", "PLC", "P LC", "PAIRLC", "PAIR LC"
            SetFieldOrderMethodFromText = SORTINSTRUCTION_Paired880sLC%
        Case Else ' includes GENERIC, natcherly
            SetFieldOrderMethodFromText = SORTINSTRUCTION_Generic%
    End Select

End Function

Private Sub SetDefaultFldOrderAuth()

    ClearFldOrder "A"
    SetFldOrder "A", "001", "399", SORTINSTRUCTION_Tag%
    SetFldOrder "A", "400", "499", SORTINSTRUCTION_Reference%
    SetFldOrder "A", "500", "599", SORTINSTRUCTION_Reference%
    SetFldOrder "A", "600", "641", SORTINSTRUCTION_Tag%
    SetFldOrder "A", "642", "642", SORTINSTRUCTION_Local%
    SetFldOrder "A", "643", "643", SORTINSTRUCTION_Tag%
    SetFldOrder "A", "644", "644", SORTINSTRUCTION_Local%
    SetFldOrder "A", "645", "645", SORTINSTRUCTION_Local%
    SetFldOrder "A", "646", "646", SORTINSTRUCTION_Local%
    SetFldOrder "A", "647", "699", SORTINSTRUCTION_Tag%
    SetFldOrder "A", "700", "799", SORTINSTRUCTION_Indicator2%
    SetFldOrder "A", "800", "999", SORTINSTRUCTION_Tag%
    SetFldOrder "A", "880", "880", SORTINSTRUCTION_Paired880s%

End Sub

Private Sub SetDefaultFldOrderBib()

#If SetFldOrderDebug = -1 Then
    Debug.Print "Setting default field order bib"
#End If

    ClearFldOrder "B"
    SetFldOrder "B", "001", "399", SORTINSTRUCTION_Tag%
    SetFldOrder "B", "400", "599", SORTINSTRUCTION_Generic%
    SetFldOrder "B", "600", "655", SORTINSTRUCTION_Indicator2%
    SetFldOrder "B", "652", "699", SORTINSTRUCTION_Tag%
    SetFldOrder "B", "700", "700", SORTINSTRUCTION_7XX%
    SetFldOrder "B", "710", "711", SORTINSTRUCTION_7XX%
    SetFldOrder "B", "730", "740", SORTINSTRUCTION_Tag%
    SetFldOrder "B", "741", "799", SORTINSTRUCTION_Generic%
    ' 20050103: break the 800 group into two batches, so the
    '   access points come before the holdings-related fields
    SetFldOrder "B", "800", "840", SORTINSTRUCTION_Generic%
    SetFldOrder "B", "850", "999", SORTINSTRUCTION_Generic%
    SetFldOrder "B", "880", "880", SORTINSTRUCTION_Paired880s%

End Sub

Private Sub SetDefaultFldOrderHold()

    ClearFldOrder "H"
    SetFldOrder "H", "001", "852", SORTINSTRUCTION_Tag%
    SetFldOrder "H", "853", "869", SORTINSTRUCTION_Sfd8PlusTag%
    SetFldOrder "H", "870", "999", SORTINSTRUCTION_Tag%
    SetFldOrder "H", "880", "880", SORTINSTRUCTION_Paired880s%

End Sub

Private Sub SetDefaultFldOrderOther()
    
    ClearFldOrder "O"
    SetFldOrder "O", "001", "009", SORTINSTRUCTION_Tag%
    SetFldOrder "O", "010", "999", SORTINSTRUCTION_Generic%
    SetFldOrder "H", "880", "880", SORTINSTRUCTION_Paired880s%

End Sub

Private Sub TestLastFieldOrderRule(ByRef aArray() As FieldOrderType, ByRef iLast%, ByRef iMax%)

    ' make sure that one of the field-order arrays ends with a catch-all entry
    
    If aArray(iLast%).Begin <> "001" Or aArray(iLast%).End <> "999" Then
        iLast% = iLast% + 1
        If iLast% > iMax% Then
            iMax% = iLast%
            ReDim Preserve aArray(0 To iMax%)
        End If
        aArray(iLast%).Begin = "001"
        aArray(iLast%).End = "999" ' corrected 20040921
        aArray(iLast%).SortInstruction = SetFieldOrderMethodFromText("Generic")
    End If

End Sub

Private Sub SetFieldSortGroupFromTagEndgame(ByRef sLabel$, ByVal iCtr%, ByVal iSortInstruction%, ByVal sTag$, ByVal sIndicators$, ByVal sField$)

    Dim sSfd$, s5$
    
    Dim iRc%
    
    ' the primary sorting element for any field
    '   is the field group number into which
    '   that field fits
    sLabel$ = Right("000" + Trim(str(iCtr%)), 3)
#If SetFieldSortGroupFromTagEndgameDebug = -1 Then
    Debug.Print "Endgame basic: >" + sLabel$ + "< instruction: " + str(iSortInstruction%)
#End If

    Select Case iSortInstruction%
        Case SORTINSTRUCTION_LeaveOrderAlone% ' added 20061117
            ' we're going to return a generic code, and that's all we get!
            sLabel$ = "*"
        Case SORTINSTRUCTION_7XX%
            If InStr(sField$, MarcDelimiter + "t") > 0 Then
                sLabel$ = sLabel$ + "7T"
            Else
                sLabel$ = sLabel$ + "7 "
            End If
        Case SORTINSTRUCTION_Generic%
            sLabel$ = sLabel$ + Mid(sTag$, 1, 1)
        Case SORTINSTRUCTION_Sfd8PlusTag%
            ' 20040920: technique added
            ' extract subfield $a from the field
            iCtr% = InStr(sField$, MarcDelimiter + "8")
            If iCtr% > 0 Then
                sSfd$ = Trim(Mid(sField$, iCtr% + 2))
                iCtr% = InStr(sSfd$, MarcDelimiter)
                If iCtr% > 0 Then
                    sSfd$ = Trim(Mid(sSfd$, 1, iCtr% - 1))
                End If
            Else
                ' no $a: use default
                sSfd$ = "0"
            End If
            iCtr% = InStr(sSfd$, ".")
            Select Case iCtr%
                Case 0
                    If Len(sSfd$) < 3 Then
                        sLabel$ = sLabel$ + Mid("000", 1, 3 - Len(sSfd$)) + sSfd$
                    Else
                        ' hope for the best
                        sLabel$ = sLabel$ + sSfd$
                    End If
                Case 1 ' probably illegally-formatted subfield!
                    ' set zero prefix plus decimals
                    sLabel$ = sLabel$ + "000" + sSfd$ + sTag$
                Case 2
                    ' including zero
                    sLabel$ = sLabel$ + "00" + sSfd$ + sTag$
                Case 3
                    ' including zero
                    sLabel$ = sLabel$ + "0" + sSfd$ + sTag$
                Case Else ' hope for the best!
                    sLabel$ = sLabel$ + sSfd$ + sTag$
            End Select
        Case SORTINSTRUCTION_Indicator2%
            ' 20040617: blank indicators form a group that comes after *all*
            '   non-blank indicators
            If Mid(sIndicators$, 2, 1) = " " Then
                ' 20041206: although the 653 field has a blank indicator, people may
                '   wish it to be somewhere other than at the end
                ' because our previous value of chr(255) already produced
                '   the same result as the new value of "9" in nearly every case,
                '   this may be regarded as having no material effect; the only
                '   time this will have an effect is when people decide to have this
                '   somewhere other than at the end; or when a record contains both a
                '   653 field *and also* other 600-655 fields with blank second
                '   indicators (we hope these aren't allowed!)
                If sTag$ = "653" Then
                    sLabel$ = sLabel$ + SortingIndicatorFor653Field
                Else
                    sLabel$ = sLabel$ + Chr(255)
                End If
            Else
                sLabel$ = sLabel$ + Mid(sIndicators$, 2, 1)
            End If
            ' 20041206: added specification for 654 field here: doesn't
            '   have a second indicator
            If Mid(sIndicators$, 2, 1) = "7" Or sTag$ = "654" Then
                iCtr% = InStr(sField$, MarcDelimiter + "2")
                If iCtr% > 0 Then
                    ' 20041206: translate certain $2 codes into their
                    '   indicator equivalents
                    sSfd$ = Mid(sField$, iCtr% + 2)
                    iCtr% = InStr(sSfd$, MarcDelimiter)
                    If iCtr% > 0 Then
                        sSfd$ = Mid(sSfd$, 1, iCtr% - 1)
                    End If
                    Select Case sSfd$
                        Case "lcsh"
                            sLabel$ = sLabel$ + "0"
                        Case "lcshac"
                            sLabel$ = sLabel$ + "1"
                        Case "mesh"
                            sLabel$ = sLabel$ + "2"
                        Case "nal"
                            sLabel$ = sLabel$ + "3"
                        Case "cash"
                            sLabel$ = sLabel$ + "5"
                        Case "rvm"
                            sLabel$ = sLabel$ + "6"
                        Case Else
                            sLabel$ = sLabel$ + sSfd$
                    End Select
                End If
            End If
        Case SORTINSTRUCTION_Local%
            sLabel$ = sLabel$ + sTag$
            If Len(m_sNuc$) > 0 Then
                ' 20050909: fancier logic, to allow use of "NUC code roots"
                '   instead of only one exact NUC code
                iRc% = Rat(sField$, MarcDelimiter + "5")
                If iRc% > 0 Then
                    s5$ = Trim(Mid(sField$, iRc% + 2))
                    iRc% = InStr(s5$, MarcDelimiter)
                    If iRc% > 0 Then
                        s5$ = Trim(Mid(s5$, 1, iRc% - 1))
                    End If
                    sSfd$ = "(" + s5$ + ")"
                    iRc% = InStr(s5$, "-")
                    If iRc% > 0 Then
                        s5$ = Mid(s5$, 1, iRc% - 1)
                    End If
                    ' 20051007: allow for exact match on NUC
                    '   code to take precedence over match on
                    '   root alone
                    If InStr(m_sNuc$, sSfd$) > 0 Then
                        sLabel$ = sLabel$ + "5"
                    ElseIf InStr(m_sLocalNucString$, MarcDelimiter + "5" + s5$) > 0 Then
                        sLabel$ = sLabel$ + "6"
                    Else
                        sLabel$ = sLabel$ + "9"
                    End If
                Else
                    sLabel$ = sLabel$ + "9"
                End If
            End If
        Case SORTINSTRUCTION_Reference%
            ' sorted generically (first character of tag)
            sLabel$ = sLabel$ + Mid(sTag$, 1, 1)
            ' add the $w code
            iCtr% = InStr(sField$, MarcDelimiter + "w")
            If iCtr% > 0 Then
                sLabel$ = sLabel$ + Mid(sField$, iCtr% + 2, 1)
            Else
                sLabel$ = sLabel$ + "n"
            End If
            ' add the normalized reference text (forces references of the same
            '   "type" to appear in alphabetical order)
            ' 20050719: remove subfield $w if it appears at the beginning
            '   of the field (as it should)
            ' 20080725: remove subfield $w at the end as well
            iRc% = InStr(sField$, MyMarcCharacter.MarcDelimiter + "w")
            Select Case iRc%
                Case 0
                    ' do nothing
                Case 1
                    sField$ = Mid(sField$, 3)
                    iRc% = InStr(sField$, MyMarcCharacter.MarcDelimiter)
                    If iRc% > 0 Then
                        sField$ = Mid(sField$, iRc%)
                    End If
                Case Else ' Is > 1 ' must be at the right end
                    sField$ = Mid(sField$, 1, iRc% - 1)
            End Select
            ' 20080725: also remove $5 at the right end (if it's at the left end,
            '   we have no hope!)
            iRc% = InStr(sField$, MyMarcCharacter.MarcDelimiter + "5")
            If iRc% > 1 Then
                sField$ = Mid(sField$, 1, iRc% - 1)
            End If
            sLabel$ = sLabel$ + NormString(RemoveDelimiters(sField$))
        Case SORTINSTRUCTION_Tag%
            sLabel$ = sLabel$ + sTag$
    End Select

End Sub

Public Sub ClearSfdOrder(ByVal sMarcFormat$)

    gblbTestOrderStuff = True
    
    
    Select Case sMarcFormat$
        Case "A"
            gbliSubfieldOrderAuthLast% = 0
        Case "H"
            gbliSubfieldOrderHoldLast% = 0
        Case "B", "D", "F", "M", "P", "S", "U"
            gbliSubfieldOrderBibLast% = 0
        Case Else
            gbliSubfieldOrderOtherLast% = 0
    End Select
    
End Sub

Private Sub SetDefaultSfdOrderAuth()

    ClearSfdOrder "A"
    
    SetSfdOrder "A", "010", "az"
    SetSfdOrder "A", "014", "6a"
    SetSfdOrder "A", "016", "az2"
    SetSfdOrder "A", "017", "6ab"
    SetSfdOrder "A", "020", "6{#acz}"
    SetSfdOrder "A", "022", "6{#ayz}"
    SetSfdOrder "A", "035", "6az"
    SetSfdOrder "A", "040", "6abcdef"
    SetSfdOrder "A", "045", "abc"
    SetSfdOrder "A", "050", "6{#abd}5"
    SetSfdOrder "A", "052", "ab"
    SetSfdOrder "A", "053", "abcd"
    SetSfdOrder "A", "055", "6abd5"
    SetSfdOrder "A", "060", "6{#abd}5"
    SetSfdOrder "A", "066", "{abc}"
    SetSfdOrder "A", "070", "6{#abd}"
    SetSfdOrder "A", "072", "6ax2"
    SetSfdOrder "A", "073", "6az"
    SetSfdOrder "A", "082", "6{#abd}25"
    SetSfdOrder "A", "083", "6{#abcz}25"
    SetSfdOrder "A", "086", "6{#adz}25"
    SetSfdOrder "A", "087", "6{abc}"
    SetSfdOrder "A", "100", "6a{#qbcdek}{u4}{!tkfghlmnoprs}{#vxyz}"
    SetSfdOrder "A", "110", "6a{#bcdgkn}{eu4}{!tfhldgknmoprs}{#vxyz}"
    SetSfdOrder "A", "111", "6a{#bqdceng}{u4}{!tnfhklps}{#vxyz}"
    SetSfdOrder "A", "130", "6a{#nplfksdhmorgt}{#vxyz}"
    SetSfdOrder "A", "150", "6a{#vxyz)"
    SetSfdOrder "A", "151", "6a{#vxyz}"
    SetSfdOrder "A", "155", "6a{#vxyz}"
    SetSfdOrder "A", "180", "6{^xvyz}"
    SetSfdOrder "A", "181", "6{^zvxy}"
    SetSfdOrder "A", "182", "6{^yvxz}"
    SetSfdOrder "A", "183", "6{^vxyz}"
    SetSfdOrder "A", "400", "6wa{#qbcdek}{u4}{!tkfghlmnoprs}{#vxyz}"
    SetSfdOrder "A", "410", "{6}{w}{a}{#bcdgkn}{eu4}{!tfhldgknmoprs}{#vxyz}"
    SetSfdOrder "A", "411", "6wa{#bqdceng}{u4}{!tnfhklps}{#vxyz}"
    SetSfdOrder "A", "430", "6wa{#nplfksdhmorgt}{#vxyz}"
    SetSfdOrder "A", "450", "6wa{#vxyz)"
    SetSfdOrder "A", "451", "6wa{#vxyz}"
    SetSfdOrder "A", "455", "6wa{#vxyz}"
    SetSfdOrder "A", "480", "6w{^xvyz}"
    SetSfdOrder "A", "481", "6w{^zvxy}"
    SetSfdOrder "A", "482", "6w{^yvxz}"
    SetSfdOrder "A", "483", "6w{^vxyz}"
    SetSfdOrder "A", "500", "6wa{#qbcdek}{u4}{!tkfghlmnoprs}{#vxyz}"
    SetSfdOrder "A", "510", "6wa{#bcdgkn}{eu4}{!tfhldgknmoprs}{#vxyz}"
    SetSfdOrder "A", "511", "6wa{#bqdceng}{u4}{!tnfhklps}{#vxyz}"
    SetSfdOrder "A", "530", "6wa{#nplfksdhmorgt}{#vxyz}"
    SetSfdOrder "A", "550", "6wa{#vxyz)"
    SetSfdOrder "A", "551", "6wa{#vxyz}"
    SetSfdOrder "A", "555", "6wa{#vxyz}"
    SetSfdOrder "A", "580", "6w{^xvyz}"
    SetSfdOrder "A", "581", "6w{^zvxy}"
    SetSfdOrder "A", "582", "6w{^yvxz}"
    SetSfdOrder "A", "583", "6w{^vxyz}"
    SetSfdOrder "A", "700", "68wa{#qbcdek}{u4}{!tkfghlmnoprs}{#vxyz}205"
    SetSfdOrder "A", "710", "68wa{#bcdgkn}{eu4}{!tfhldgknmoprs}{#vxyz}205"
    SetSfdOrder "A", "711", "68wa{#bqdceng}{u4}{!tnfhklps}{#vxyz}205"
    SetSfdOrder "A", "730", "68wa{#nplfksdhmorgt}{#vxyz}205"
    SetSfdOrder "A", "750", "68wa{#vxyz)205"
    SetSfdOrder "A", "751", "68wa{#vxyz}205"
    SetSfdOrder "A", "755", "68wa{#vxyz}205"
    SetSfdOrder "A", "780", "68w{^xvyz}205"
    SetSfdOrder "A", "781", "68w{^zvxy}205"
    SetSfdOrder "A", "782", "68w{^yvxz}205"
    SetSfdOrder "A", "783", "68w{^vxyz}205"
    SetSfdOrder "A", "788", "6{#ai}25"

End Sub

Private Sub SetDefaultSfdOrderBib()

    ClearSfdOrder "B"
    SetSfdOrder "B", "010", "abz"
    SetSfdOrder "B", "013", "6a{#bcdef}"
    SetSfdOrder "B", "015", "6a"
    SetSfdOrder "B", "016", "az2"
    SetSfdOrder "B", "017", "6ab"
    SetSfdOrder "B", "020", "6{^abcz}"
    SetSfdOrder "B", "022", "6{^ayz}"
    SetSfdOrder "B", "024", "6{^acdz}2"
    SetSfdOrder "B", "027", "6az"
    SetSfdOrder "B", "028", "6ab"
    SetSfdOrder "B", "030", "6az"
    SetSfdOrder "B", "032", "6ab"
    SetSfdOrder "B", "033", "63{^abc}"
    SetSfdOrder "B", "034", "6a{#bcdefghjkmnpst}"
    SetSfdOrder "B", "035", "6az"
    SetSfdOrder "B", "036", "6ab"
    SetSfdOrder "B", "037", "6a{#bcfgn}"
    SetSfdOrder "B", "040", "6abc{#de}"
    SetSfdOrder "B", "041", "6a{#bcdefgh}"
    SetSfdOrder "B", "043", "6ab2"
    SetSfdOrder "B", "044", "6abc2"
    SetSfdOrder "B", "045", "6abc"
    SetSfdOrder "B", "046", "6abcde"
    SetSfdOrder "B", "048", "ab"
    SetSfdOrder "B", "050", "3{#ab}"
    SetSfdOrder "B", "051", "abc"
    SetSfdOrder "B", "052", "6abd2"
    SetSfdOrder "B", "055", "ab2"
    SetSfdOrder "B", "060", "{#ab}"
    SetSfdOrder "B", "061", "{#abc}"
    SetSfdOrder "B", "066", "{abc}"
    SetSfdOrder "B", "070", "{#ab}"
    SetSfdOrder "B", "071", "{#abc}"
    SetSfdOrder "B", "072", "6ax2"
    SetSfdOrder "B", "074", "az"
    SetSfdOrder "B", "080", "6abx2"
    SetSfdOrder "B", "082", "{^ab}2"
    SetSfdOrder "B", "084", "6ab2"
    SetSfdOrder "B", "086", "6az2"
    SetSfdOrder "B", "088", "6az"
    SetSfdOrder "B", "100", "6a{#bcdgq}{eu4}{!tfgklnp}"
    SetSfdOrder "B", "110", "6a{#bcdgkn}{eu4}{!tdfghlkmnoprs}"
    SetSfdOrder "B", "111", "6a{#bcdegnq}{u4}{!tfhklnps}"
    SetSfdOrder "B", "130", "6a{#dfghklmnoprst}"
    SetSfdOrder "B", "210", "6ab2"
    SetSfdOrder "B", "222", "6ab"
    SetSfdOrder "B", "240", "6a{#dfghklmnoprs}"
    SetSfdOrder "B", "242", "6a{#bchnpy}"
    SetSfdOrder "B", "243", "6a{#dfghklmnoprs}"
    SetSfdOrder "B", "245", "6a{#bcfghknps}"
    SetSfdOrder "B", "246", "6{i}{!abfghnp}5"
    SetSfdOrder "B", "247", "6a{#bfghnpx}"
    SetSfdOrder "B", "250", "6ab"
    SetSfdOrder "B", "254", "6a"
    SetSfdOrder "B", "255", "6abcdefg"
    SetSfdOrder "B", "256", "6a"
    SetSfdOrder "B", "257", "6a"
    SetSfdOrder "B", "260", "6{#abcdefg}"
    SetSfdOrder "B", "261", "6{#abdef}"
    SetSfdOrder "B", "262", "6{#abckl}"
    SetSfdOrder "B", "270", "6{#abcdefghijklmnpqrz}4"
    SetSfdOrder "B", "300", "63{#abcefg}"
    SetSfdOrder "B", "306", "6a"
    SetSfdOrder "B", "307", "6ab"
    SetSfdOrder "B", "310", "6ab"
    SetSfdOrder "B", "321", "6ab"
    SetSfdOrder "B", "340", "63{#abcdefhi}"
    SetSfdOrder "B", "342", "6{#abcdefghijklmnopqrstuvw}2"
    SetSfdOrder "B", "343", "6{#abcdefghi}"
    SetSfdOrder "B", "351", "63{#abc}"
    SetSfdOrder "B", "352", "6{#abcdefgi}"
    SetSfdOrder "B", "355", "6{#abcdefghj}"
    SetSfdOrder "B", "357", "6{#abcg}"
    SetSfdOrder "B", "362", "6az"
    SetSfdOrder "B", "400", "6a{#qbcdek}{u4}{!tkfghlmnoprs}{#vx}"
    SetSfdOrder "B", "410", "6a{#bcdgkn}{eu4}{!tfhldgknmoprs}{#vx}"
    SetSfdOrder "B", "411", "6a{#bqdceng}{u4}{!tnfhklps}{#vx}"
    SetSfdOrder "B", "440", "6a{#np}{#xv}"
    SetSfdOrder "B", "490", "6{^alvx}"
    SetSfdOrder "B", "500", "63a5"
    SetSfdOrder "B", "501", "6a5"
    SetSfdOrder "B", "502", "6a"
    SetSfdOrder "B", "504", "6ab"
    SetSfdOrder "B", "505", "6{#agrt}"
    SetSfdOrder "B", "506", "63a{#bcde}5"
    SetSfdOrder "B", "507", "6ab"
    SetSfdOrder "B", "508", "6a"
    SetSfdOrder "B", "510", "63a{#bcx}"
    SetSfdOrder "B", "511", "6a"
    SetSfdOrder "B", "513", "6ab"
    SetSfdOrder "B", "514", "6a{#bcdefghijkm}"
    SetSfdOrder "B", "515", "6a"
    SetSfdOrder "B", "516", "6a"
    SetSfdOrder "B", "518", "63a"
    SetSfdOrder "B", "520", "63ab"
    SetSfdOrder "B", "521", "63ab"
    SetSfdOrder "B", "522", "6a"
    SetSfdOrder "B", "524", "63a2"
    SetSfdOrder "B", "525", "6a"
    SetSfdOrder "B", "526", "6{i}{#abcdxz}5"
    SetSfdOrder "B", "530", "63abcd"
    SetSfdOrder "B", "533", "63a{#bcdefmn}7"
    SetSfdOrder "B", "534", "63p{#atbmceflnzxk}"
    SetSfdOrder "B", "535", "63a{#bcdg}"
    SetSfdOrder "B", "536", "6a{#bcdefgh}"
    SetSfdOrder "B", "538", "6a"
    SetSfdOrder "B", "540", "63abcd5"
    SetSfdOrder "B", "541", "63{#abcdefhno}5"
    SetSfdOrder "B", "544", "63{#abcden}"
    SetSfdOrder "B", "545", "6ab"
    SetSfdOrder "B", "546", "63ab"
    SetSfdOrder "B", "547", "6a"
    SetSfdOrder "B", "550", "6a"
    SetSfdOrder "B", "551", "6a{#bcdefghijklmnop}"
    SetSfdOrder "B", "555", "63a{#bcd}"
    SetSfdOrder "B", "556", "6az"
    SetSfdOrder "B", "561", "63a5"
    SetSfdOrder "B", "562", "63{#abcde}5"
    SetSfdOrder "B", "565", "63a{#bcde}"
    SetSfdOrder "B", "567", "6a"
    SetSfdOrder "B", "580", "6a"
    SetSfdOrder "B", "581", "63az"
    SetSfdOrder "B", "583", "63a{#bcdefhijklnoxz}5"
    SetSfdOrder "B", "584", "63ab5"
    SetSfdOrder "B", "585", "63a5"
    SetSfdOrder "B", "586", "63a"
    SetSfdOrder "B", "600", "63a{#bcdgq}{eu4}{!tfgklnp}{#vxyz}2"
    SetSfdOrder "B", "610", "63a{#bcdgkn}{eu4}{!tfhldgknmoprs}{#vxyz}2"
    SetSfdOrder "B", "611", "63a{#bqdceng}{u4}{!tnfhklps}{#vxyz}2"
    SetSfdOrder "B", "630", "63a{#nplfksdhmorgt}{#vxyz}2"
    SetSfdOrder "B", "650", "63a{#bcde}{#vxyz}2"
    SetSfdOrder "B", "651", "63a{#vxyz}2"
    SetSfdOrder "B", "653", "6a"
    SetSfdOrder "B", "654", "{#abcvyz}23"
    SetSfdOrder "B", "655", "63a{#bc}{#vxyz}25"
    SetSfdOrder "B", "656", "63ak{#vxyz}2"
    SetSfdOrder "B", "657", "63a{#vxyz}2"
    SetSfdOrder "B", "658", "6a{#bcd}2"
    SetSfdOrder "B", "700", "63a{#qbcdek}{u4}{!tkfghlmnoprsx}5"
    SetSfdOrder "B", "710", "63a{#bcdgkn}{eu4}{!tfhldgknmoprsx}5"
    SetSfdOrder "B", "711", "63a{#bqdceng}{u4}{!tnfhklpsx}5"
    SetSfdOrder "B", "720", "6a{e4}"
    SetSfdOrder "B", "730", "63a{#nplfksdhmorgtx}5"
    SetSfdOrder "B", "740", "6a{#hnp}5"
    SetSfdOrder "B", "752", "6abcd"
    SetSfdOrder "B", "753", "6abc"
    SetSfdOrder "B", "754", "6a2"
    SetSfdOrder "B", "760", "67{#abcdghimnostwxy}"
    SetSfdOrder "B", "762", "67{#abcdghimnostwxy}"
    SetSfdOrder "B", "765", "67{#abcdghikmnorstuwxyz}"
    SetSfdOrder "B", "767", "67{#abcdghikmnorstuwxyz}"
    SetSfdOrder "B", "770", "67{#abcdghikmnorstuwxyz}"
    SetSfdOrder "B", "772", "67{#abcdghikmnorstuwxyz}"
    SetSfdOrder "B", "773", "673{#abdghikmnoprstuwxyz}"
    SetSfdOrder "B", "774", "67{#abcdghikmnorstuwxyz}"
    SetSfdOrder "B", "775", "67{#abcdefghikmnorstuwxyz}"
    SetSfdOrder "B", "776", "67{#abcdghikmnorstuwxyz}"
    SetSfdOrder "B", "777", "67{#abcdghikmnostwxy}"
    SetSfdOrder "B", "780", "67{#abcdghikmnorstuwxyz}"
    SetSfdOrder "B", "785", "67{#abcdghikmnorstuwxyz}"
    SetSfdOrder "B", "786", "67{#abcdghijkmnorstuvwxyz}"
    SetSfdOrder "B", "787", "67{#abcdghikmnorstuwxyz}"
    SetSfdOrder "B", "800", "6a{#qbcdek}{u4}{!tkfghlmnoprs}v"
    SetSfdOrder "B", "810", "6a{#bcdgkn}{eu4}{!tfhldgknmoprs}v"
    SetSfdOrder "B", "811", "6a{#bqdceng}{u4}{!tnfhklps}v"
    SetSfdOrder "B", "830", "6a{#nplfksdhmorgt}v"
    SetSfdOrder "B", "891", "9{638}{abcdefghijklmnouvwxyz]"

    'Debug.Print "Sfd order bib info: " + str(gbliSubfieldOrderBibLast%) + " " + str(gbliSubfieldOrderBibMax%)
    
    
End Sub

Private Sub SetDefaultSfdOrderHold()

    ' nothing defined: we'll take the default of "whatever" for now
    ClearSfdOrder "H"
    SetSfdOrder "H", "999", "{#abcdefghijklmnopqrstuvwxyz0123456789}"
    
End Sub

Private Sub SetDefaultSfdOrderOther()

    ' nothing defined: we'll take the default of "whatever" for now
    ClearSfdOrder "O"
    SetSfdOrder "O", "999", "{#abcdefghijklmnopqrstuvwxyz0123456789}"
    
End Sub

Public Sub SetSfdOrder(ByVal sMarcFormat$, ByVal sTag$, ByVal sInstruction$)

    Dim iCtr%
    
    'Debug.Print "SSO: >" + sMarcFormat$ + "< >" + sTag$ + "< >" + sInstruction$ + "<"
    ' can only do this if we're not holding a record
    If m_iMarcCtr% <> 0 Then
        Exit Sub
    End If

    Select Case sMarcFormat$
        Case "A"
            SetSfdOrderForFormat gblaSubfieldOrderAuth(), gbliSubfieldOrderAuthLast%, gbliSubfieldOrderAuthMax%, sTag$, sInstruction$
        Case "B", "D", "F", "M", "P", "S", "U"
            SetSfdOrderForFormat gblaSubfieldOrderBib(), gbliSubfieldOrderBibLast%, gbliSubfieldOrderBibMax%, sTag$, sInstruction$
        Case "H"
            SetSfdOrderForFormat gblaSubfieldOrderHold(), gbliSubfieldOrderHoldLast%, gbliSubfieldOrderHoldMax%, sTag$, sInstruction$
        Case Else
            SetSfdOrderForFormat gblaSubfieldOrderOther(), gbliSubfieldOrderOtherLast%, gbliSubfieldOrderOtherMax%, sTag$, sInstruction$
    End Select

End Sub


Private Sub SetSfdOrderForFormat(ByRef aArray() As SFDORDERTYPE, ByRef iLast%, ByRef iMax%, ByVal sTag$, ByVal sList$)

    ' digest a full subfield-order string for a single
    '   variable field tag into its components and
    '   add corresponding elements to the subfield-order array
    '   for that tag
    
    Dim sChar$, sCurrent$, sLeads$, sAts$, sTotal$, sDuplicates$
    
    Dim iType%, iCtr%, iPtr%
    
    Dim bFound As Boolean, bDebug As Boolean, bBracesInEffect As Boolean
    
    
    ' if we've already got an element in our array
    '   for this tag, we're going to replace it with
    '   a new definition
    bFound = False
    For iPtr% = 1 To iLast%
        If aArray(iPtr%).Tag = sTag$ Then
            bFound = True
            Exit For
        End If
    Next ' ictr%
    ' tag not already found, so add a new element to the array
    If Not bFound Then
        iLast% = iLast% + 1
        If iLast% > iMax% Or iMax% = 0 Then
            iMax% = iMax% + 5
            ReDim Preserve aArray(0 To iMax%)
        End If
        iPtr% = iLast%
    End If
    
    With aArray(iPtr%)
        .Last = -1
        .Max = 0
        .Tag = sTag$
        .Duplicates = ""
    End With
    
    Do
        sChar$ = Mid(sList$, 1, 1)
        sList$ = Mid(sList$, 2)
        Select Case sChar$
            Case "{"
                ' beginning of a new group of subfields
                bBracesInEffect = True
                If Len(sCurrent$) > 0 Then ' will be null first time through
                    ' the new group isn't the first group: get rid of the
                    '   previous one
                    ' create one entry for the current information; and
                    '   clear out variables ready for the next group
                    SetSfdOrderForFormatClearSegment aArray(iPtr%), iType%, sCurrent$
                End If
                Select Case Mid(sList$, 1, 1)
                    Case "#"
                        sList$ = Mid(sList$, 2)
                        iType% = SFDORDER_SegmentRandom%
                    Case "!"
                        sList$ = Mid(sList$, 2)
                        iType% = SFDORDER_SegmentWithLead%
                        sLeads$ = sLeads$ + Mid(sList$, 1, 1)
                    Case "^" ' appears not to be used; meaning is unclear
                        sList$ = Mid(sList$, 2)
                        iType% = SFDORDER_SegmentWithSingleLead%
                        sLeads$ = sLeads$ + Mid(sList$, 1, 1)
                    Case "@" ' appears not to be used; meaning is unclear
                        sList$ = Mid(sList$, 2)
                        iType% = SFDORDER_OccursInMultipleSegments%
                        If InStr(sAts$, Mid(sList$, 1, 1)) = 0 Then
                            sAts$ = sAts$ + Mid(sList$, 1, 1)
                        End If
                        ' unsure whether or not we want to do this for this; I think
                        '   we do *not* want this
                        'sLeads$ = sLeads$ + Mid(sList$, 1, 1)
                    Case Else
                        ' 20040526: this ostensibly-missing clause added
                        ' list of codes that *must* appear in this order only
                        sCurrent$ = sCurrent$ + sChar$
                        If InStr(sTotal$, sChar$) > 0 Then
                            sDuplicates$ = sDuplicates$ = sChar$
                        Else
                            sTotal$ = sTotal$ + sChar$
                        End If
                End Select
            Case "}"
                If Len(sCurrent$) > 0 Then
                    SetSfdOrderForFormatClearSegment aArray(iPtr%), iType%, sCurrent$
                End If
                bBracesInEffect = False
            Case Else
                ' some normal subfield
                If bBracesInEffect Then
                    sCurrent$ = sCurrent$ + sChar$
                    If InStr(sTotal$, sChar$) > 0 Then
                        sDuplicates$ = sDuplicates$ + sChar$
                    Else
                        sTotal$ = sTotal$ + sChar$
                    End If
                Else
                    ' 20050927: it turns out that we're not properly handling a string
                    '   of subfield codes that appear outside of braces--a list of subfield
                    '   codes that *must* appear in a specified order; so instead of making
                    '   one group out of the whole string, we'll make a separate group out
                    '   of each code
                    ' if the rule is constructed correctly, sCurrent will already be
                    '   clear; so we do not need to clear it first; and obviously we don't
                    '   need to accumulate anything in it
                    SetSfdOrderForFormatClearSegment aArray(iPtr%), iType%, sChar$
                End If
        End Select
            
RTTVVSONextCharacter:
        If Len(sList$) = 0 Then
            If Len(sCurrent$) > 0 Then
                SetSfdOrderForFormatClearSegment aArray(iPtr%), iType%, sCurrent$
            End If
            Exit Do
        End If
    Loop
    
    ' subfield codes that appear in more than one group
    aArray(iPtr%).Duplicates = sDuplicates$
    ' subfield codes that must be the first code in their group
    aArray(iPtr%).SfdSegments = sLeads$
    
    
    ' 20040526: since sAts$ appears only to be used in
    '   cases involving instructions that are no longer used it
    '   should always be null; so the following code (whose
    '   purpose remains more than a little obscure) will never
    '   be exercised
    ' mark the last occurrence of each "only" group
    If Len(sAts$) > 0 Then
        Do
            sChar$ = Mid(sAts$, 1, 1)
            sAts$ = Mid(sAts$, 2)
            For iCtr% = aArray(iPtr%).Last To 1 Step -1
                If aArray(iPtr%).Order(iCtr%).Type = SFDORDER_OccursInMultipleSegments% Then
                    If InStr(aArray(iPtr%).Order(iCtr%).Sfds, sChar$) > 0 Then
                        aArray(iPtr%).Order(iCtr%).Type = SFDORDER_OccursInMultipleSegmentsLast%
                        Exit For
                    End If
                End If
            Next ' ictr%
            If Len(sAts$) = 0 Then
                Exit Do
            End If
        Loop
    End If
    
End Sub

Private Sub SetSfdOrderForFormatClearSegment(ByRef aArray As SFDORDERTYPE, ByRef iType%, ByRef sCurrent$)

    ' add one element to the current tag definition
    '   in the subfield order array, using
    '   supplied list of subfields and supplied
    '   subfield-order-type definition
    
    aArray.Last = aArray.Last + 1
    If aArray.Last > aArray.Max Or aArray.Max = 0 Then
        aArray.Max = aArray.Max + 2
        ReDim Preserve aArray.Order(0 To aArray.Max)
    End If
    
    With aArray.Order(aArray.Last)
        .Type = iType%
        .Sfds = sCurrent$
    End With
    
    ' ready for the next segment
    sCurrent$ = ""
    iType% = SFDORDER_NoSegmentInThisOrder

End Sub

Private Sub SetSfdOrderFromFile(ByVal sType$, ByVal sFile$, ByRef aArray() As SFDORDERTYPE, ByRef iLast%, ByRef iMax%)

    Dim sSection$, sLine$, sStart$, sEnd$, sDefault$, sTag$
    Dim sSectionName$
    
    Dim iEquals%
    
    Dim lLength As Long, lReturn As Long, lRc As Long
    
    iLast% = 0
    
    'Debug.Print "SFOFF: " + sType$ + "< >" + sFile$ + "<"
    
    ' we're going to include here code that actually duplicates code in
    '   the INI.BAS module (tailored for this particular case), so that projects aren't
    '   required to include INI.BAS whenever they include this object
    sSectionName$ = "SubfieldOrder"
    sDefault$ = ""
    sSection$ = Space(32000) + Chr(0)
    lLength = 32001
    
    lReturn = GetPrivateProfileSection(sSectionName$, sSection$, lLength, sFile$)

    ' remove the trailing double-null that marks the end of the list
    lReturn = InStr(sSection$, Chr(0) + Chr(0))
    If lReturn > 0 Then
        sSection$ = Mid(sSection$, 1, lReturn - 1)
    End If
    
    ' convert any internal nulls to the desired separator character
    Do
        lRc = InStr(sSection$, Chr(0))
        If lRc = 0 Then
            Exit Do
        Else
            sSection$ = SafeStuff(sSection$, lRc, 1, vbTab)
        End If
    Loop
    
    sSection$ = Trim(sSection$)
    
    ' if the string consists only of the separator character, it doesn't
    '   exist at all
    If sSection$ = vbTab Then
        sSection$ = ""
    End If
    
    Do While Len(sSection$) > 0
        GetNextPiece sSection$, sLine$, vbTab
        'If Len(sLine$) > 0 Then
            'Debug.Print sLine$
        'End If
        If IsGoodIniLine(sLine$, iEquals%) Then
            'Debug.Print str(iEquals%) + " >" + sLine$ + "<"
            If iEquals% = 4 Then
                sTag$ = Mid(sLine$, 1, 3)
                sLine$ = Mid(sLine$, iEquals% + 1)
                SetSfdOrder sType$, sTag$, sLine$
            End If
        End If
        If Len(sSection$) = 0 Then
            Exit Do
        End If
    Loop
    
End Sub

Private Sub TestLastSfdOrderRule(ByRef aArray() As SFDORDERTYPE, ByRef iLast%, ByRef iMax%)

    ' we're going to create a default entry in the table as the last tag
    ' what'll happen is this:
    ' when we're looking at the subfield order table for a matching tag, we'll use a loop
    '   from 1 through iLast%-1
    ' if we find a matching tag we'll exit the loop with the pointer, and use
    '   the definition we find attached to that tag
    ' if we don't find anything we'll exit the loop with the pointer at the
    '   entry following the "last" entry, the dummy entry we create here; this
    '   will allow any fields that aren't defined to be sorted with subfields in "any order"

    ' todo: we want to do this ONCE per time that the subfield order
    '   stuff is reset; we do NOT want to do this once per incoming bib record
    
    Dim iCtr%

    Const sSfds$ = "abcdefghijklmnopqrstuvwxyz0123456789"
    
    'Debug.Print "TLSOR " + str(iLast%) + " " + str(iMax%)
    
    If iLast% = 0 Then
        iLast% = 1
        iMax% = 5
        ReDim Preserve aArray(0 To iMax%)
TestLastSfdOrderRuleDefault:
        ' the tag doesn't matter; we'll use a dummy value
        aArray(iLast%).Tag = "XXX"
        aArray(iLast%).Last = 1
        aArray(iLast%).Max = 5
        ReDim Preserve aArray(iLast%).Order(0 To aArray(iLast%).Max)
        aArray(iLast%).Order(aArray(iLast%).Last).Sfds = sSfds$
        aArray(iLast%).Order(aArray(iLast%).Last).Type = SFDORDER_SegmentRandom%
        Exit Sub
    End If
    
    If aArray(iLast%).Tag = "XXX" Then
        Exit Sub
    End If
    
    For iCtr% = 1 To iLast%
        'Debug.Print "Tag " + aArray(iCtr%).Tag
         If aArray(iCtr%).Order(aArray(iCtr%).Last).Sfds <> sSfds$ Then
            aArray(iCtr%).Last = aArray(iCtr%).Last + 1
            If aArray(iCtr%).Last > aArray(iCtr%).Max Then
                aArray(iCtr%).Max = aArray(iCtr%).Last
                ReDim Preserve aArray(iCtr%).Order(0 To aArray(iCtr%).Max)
            End If
            aArray(iCtr%).Order(aArray(iCtr%).Last).Sfds = sSfds$
            aArray(iCtr%).Order(aArray(iCtr%).Last).Type = SFDORDER_SegmentRandom%
        End If
    Next ' ictr%
    
#If False Then
    iLast% = iLast% + 1
    If iLast% > iMax% Then
        iMax% = iLast%
        ReDim Preserve aArray(0 To iLast%)
    End If
#End If

    GoTo TestLastSfdOrderRuleDefault
    
End Sub

Private Sub SetSubfieldSortGroupFromTag(ByRef sTag$)

    Dim iPtr%
    
   ''Debug.Print "SSGFT for " + sTag$
    ' 20040526: find the line in the 'subfield order' table that describes this
    '   field, and copy the entire array element to a central location
    ' this way, we don't have to do a "case" statement each time we do something
    '   to a subdivision to figure out which format we need to check
    Select Case MarcRecordFormat
        Case "A"
            For iPtr% = 0 To gbliSubfieldOrderAuthLast% - 1
                If gblaSubfieldOrderAuth(iPtr%).Tag = sTag Then
                    Exit For
                End If
            Next ' gbliFieldOrderPtr%
            gblaSfdOrder = gblaSubfieldOrderAuth(iPtr%)
        Case "B", "D", "F", "M", "P", "S", "U"
            For iPtr% = 0 To gbliSubfieldOrderBibLast% - 1
                If gblaSubfieldOrderBib(iPtr%).Tag = sTag Then
                    Exit For
                End If
            Next ' gbliFieldOrderPtr%
            gblaSfdOrder = gblaSubfieldOrderBib(iPtr%)
        Case "H"
            For iPtr% = 0 To gbliSubfieldOrderHoldLast% - 1
                'Debug.Print "iptr " + str(iPtr%) + " last " + str(gbliSubfieldOrderHoldLast%)
                If gblaSubfieldOrderHold(iPtr%).Tag = sTag Then
                    Exit For
                End If
            Next ' gbliFieldOrderPtr%
            'Debug.Print "iptr " + str(iPtr%) + " last " + str(gbliSubfieldOrderHoldLast%)
            gblaSfdOrder = gblaSubfieldOrderHold(iPtr%)
        Case Else
            For iPtr% = 0 To gbliSubfieldOrderOtherLast% - 1
                If gblaSubfieldOrderOther(iPtr%).Tag = sTag Then
                    Exit For
                End If
            Next ' gbliFieldOrderPtr%
            gblaSfdOrder = gblaSubfieldOrderOther(iPtr%)
    End Select

End Sub

Public Property Get SfdMax() As Integer

    SfdMax = gbliSubfieldOrderBibLast%
    
End Property


Private Function TestSubfieldPosition(ByRef aArray() As MarcSubfield, ByVal iCurrentSfdInArray%) As Integer

    ' test the location of a given subfield in the current field,
    '   given the definition of subfield order provided elsewhere
    ' return one of these values:
    '   Private Const SUBFIELDPOSITION_OK% = 0
    '   Private Const SUBFIELDPOSITION_MoveLeft% = -1
    '   Private Const SUBFIELDPOSITION_MoveUp% = SUBFIELDPOSITION_MoveLeft%
    '   Private Const SUBFIELDPOSITION_MoveRight% = 1
    '   Private Const SUBFIELDPOSITION_MoveDown% = SUBFIELDPOSITION_MoveRight%


    Dim sCurrentSfc$, sPreviousSfc$, sNextSfc$
    
    Dim iSfdOrderForCurrent%, iSfdOrderForPrevious%, iSfdOrderForNext%, iPtr%, iPtr2%
    Dim iSaveSfdPtr%
    
    Dim bAmbiguous As Boolean, bTToLeft As Boolean
    
    
    ' 20060526: ignore subfield order added
    If IgnoreSfdOrder Then
        TestSubfieldPosition = SUBFIELDPOSITION_OK%
        Exit Function
    End If
    
    ' NOTE that we haven't yet determined for sure that it matters whether
    '   or not a subfield--or any of its neighbors--participates in more than
    '   one group
    ' until we determine this, we're not going to factor it in here
    ' because we're doing the position-validation for all subfields in this one
    '   central place, should we later need to factor in multiple-group-ness, we
    '   can do it here and everything else can stay the same
    
    ' default value: subfield is OK
    TestSubfieldPosition = SUBFIELDPOSITION_OK%
    
    If InStr(gblaSfdOrder.Duplicates, aArray(iCurrentSfdInArray%).Code) > 0 Then
        bAmbiguous = True
        iSaveSfdPtr% = SfdPointer
        SfdMoveTop
        Do While SfdMoveNext
            If SfdPointer = iSaveSfdPtr Then
                Exit Do
            End If
            If SfdCode = "t" Then
                bTToLeft = True
                Exit Do
            End If
        Loop
        SfdPointer = iSaveSfdPtr%
    End If
    
    iSfdOrderForPrevious% = 0
    iSfdOrderForNext% = gblaSfdOrder.Last
    
    ' extract the subfield code for the current
    '   subfield and those of its neighbors
    sCurrentSfc$ = aArray(iCurrentSfdInArray%).Code
    If aArray(iCurrentSfdInArray%).PrevSubfield > -1 Then
        sPreviousSfc$ = aArray(aArray(iCurrentSfdInArray%).PrevSubfield).Code
        ' find the subfield-order array element that describes the
        '   previous subfield
        For iSfdOrderForPrevious% = 0 To gblaSfdOrder.Last - 1
            If InStr(gblaSfdOrder.Order(iSfdOrderForPrevious%).Sfds, sPreviousSfc$) > 0 Then
                ' if the previous subfield is ambiguous, and if it appears
                '   after $t (which must be the case if it precedes the current sfd, and the
                '   current subfield appears after $t), then wait for the $t group
                If InStr(gblaSfdOrder.Duplicates, sPreviousSfc$) > 0 And bTToLeft Then
                    If InStr(gblaSfdOrder.Order(iSfdOrderForPrevious%).Sfds, "t") > 0 Then
                        Exit For
                    End If
                Else
                    Exit For
                End If
            End If
        Next ' iSfdOrderForPrevions%
    End If
    If aArray(iCurrentSfdInArray%).NextSubfield > -1 Then
        sNextSfc$ = aArray(aArray(iCurrentSfdInArray%).NextSubfield).Code
        ' find the subfield-order array element that describes the
        '   next subfield
        For iSfdOrderForNext% = 0 To gblaSfdOrder.Last - 1
            If InStr(gblaSfdOrder.Order(iSfdOrderForNext%).Sfds, sNextSfc$) > 0 Then
                ' if the next subfield is ambiguous, and if it appears
                '   after $t (which must be the case if it follows the current sfd, and the
                '   current subfield appears after $t), then wait for the $t group
                If InStr(gblaSfdOrder.Duplicates, sPreviousSfc$) > 0 And bTToLeft Then
                    If InStr(gblaSfdOrder.Order(iSfdOrderForPrevious%).Sfds, "t") > 0 Then
                        Exit For
                    End If
                Else
                    Exit For
                End If
            End If
        Next ' iSfdOrderForNext%
    ElseIf Len(sPreviousSfc$) = 0 Then
        ' there is no next subfield, and there is no previous subfield
        ' the current subfield is the only subfield in the field, which
        '   means that its location is by that fact OK
        Exit Function ' with 'OK' return value
    End If
    
    ' find the definition of the group to which the current sfd belongs
    For iSfdOrderForCurrent% = 0 To gblaSfdOrder.Last - 1
        If InStr(gblaSfdOrder.Order(iSfdOrderForCurrent%).Sfds, sCurrentSfc$) > 0 Then
            If bTToLeft Then
                ' we can only get here if the current subfield
                '   is one of the ambiguous ones, and if
                '   $t appeaers to the left of this
                '   subfield
                If InStr(gblaSfdOrder.Order(iSfdOrderForCurrent%).Sfds, "t") > 0 Then
                    Exit For
                End If
            Else
                Exit For
            End If
        End If
    Next ' iSfdOrderForCurrent%
    
#If TestSfdPositionDebug = -1 Then
    Debug.Print "TestSfdPosition After loop: " + str(iSfdOrderForCurrent%) + " " + str(gblaSfdOrder.Last - 1)
    Debug.Print "Prev: " + str(iSfdOrderForPrevious%) + " >" + sPreviousSfc$ + "<"
    Debug.Print "Curr: " + str(iSfdOrderForCurrent%) + " >" + sCurrentSfc$ + "<"
    Debug.Print "Next: " + str(iSfdOrderForNext%) + " >" + sNextSfc$ + "<"
#End If
    
    ' test the relationship of the current subfield to the subfield (if any)
    '   that immediately precedes it in the field
    If Len(sPreviousSfc$) > 0 Then
        'Debug.Print "Previous"
        ' 20040721: new hard-coded test: if current subfield is $l and previous
        '   subfield is $k they're out of order
        If sPreviousSfc$ = "k" And sCurrentSfc$ = "l" Then
            If Mid(MarcArray(FldPointer).Tag, 2, 2) = "30" Then
                ' 20060228: test for tag (including record format) added so we
                '   don't accidentally move things like $k and $l in 049 fields
                '   that should be controlled by the usual rules
                ' bibliographic 1,6,7,8XX fields; authority 1,4,5XX fields
                Select Case MarcRecordFormat
                    Case "A"
                        If InStr("145", Mid(MarcArray(FldPointer).Tag, 1, 1)) > 0 Then
                            TestSubfieldPosition = SUBFIELDPOSITION_MoveUp%
                            Exit Function
                        End If
                    Case "B", "D", "F", "M", "P", "S", "U"
                        If InStr("1678", Mid(MarcArray(FldPointer).Tag, 1, 1)) > 0 Then
                            TestSubfieldPosition = SUBFIELDPOSITION_MoveUp%
                            Exit Function
                        End If
                End Select
            ElseIf bTToLeft Then
                If InStr("00 10 11", Right(MarcArray(FldPointer).Tag, 2)) > 0 Then
                    ' 20060228: test for tag (including record format) added so we
                    '   don't accidentally move things like $k and $l in 049 fields
                    '   that should be controlled by the usual rules
                    ' bibliographic 1,6,7,8XX fields; authority 1,4,5XX fields
                    Select Case MarcRecordFormat
                        Case "A"
                            If InStr("145", Mid(MarcArray(FldPointer).Tag, 1, 1)) > 0 Then
                                TestSubfieldPosition = SUBFIELDPOSITION_MoveUp%
                                Exit Function
                            End If
                        Case "B", "D", "F", "M", "P", "S", "U"
                            If InStr("1678", Mid(MarcArray(FldPointer).Tag, 1, 1)) > 0 Then
                                TestSubfieldPosition = SUBFIELDPOSITION_MoveUp%
                                Exit Function
                            End If
                    End Select
                End If
            End If
        End If
        If iSfdOrderForCurrent% > iSfdOrderForPrevious% Then
            ' current subfield's group is higher than the previous subfield's group:
            '   these two are in order already
            ' on to any next subfield
            ' todo: we'll leave the question of multiple groups open until we've
            '   also considered the next subfield
        ElseIf iSfdOrderForCurrent% = iSfdOrderForPrevious% Then
            ' 20050623: if same but zero (minus 1?): there's nothing to do
            If iSfdOrderForCurrent% > 0 Then
                ' the two subfields are in the same group: so we need to
                '   worry about the sort order for this group
                Select Case gblaSfdOrder.Order(iSfdOrderForCurrent%).Type
                    Case SFDORDER_NoSegmentInThisOrder%
                        ' subfields must be in the specified order
                        iPtr% = InStr(gblaSfdOrder.Order(iSfdOrderForCurrent%).Sfds, sPreviousSfc$)
                        iPtr2% = InStr(gblaSfdOrder.Order(iSfdOrderForCurrent%).Sfds, sCurrentSfc$)
                        If iPtr2% < iPtr% Then
                            TestSubfieldPosition = SUBFIELDPOSITION_MoveUp%
                            Exit Function
                        'Else
                            ' the two subfields are in order
                            ' on to any next subfield
                        End If
                    Case SFDORDER_SegmentRandom%
                        'Debug.Print "Random"
                        ' we don't care what order these are in, so they must
                        '   already be in the right order
                        ' on to any next subfield
                    Case SFDORDER_SegmentWithLead%
                        'Debug.Print "Lead"
                        ' if the current subfield is the 'lead' subfield in this segment and the
                        '   previous one is not the 'lead' subfield, then move the current subfield up one
                        If Mid(gblaSfdOrder.Order(iSfdOrderForCurrent%).Sfds, 1, 1) = sCurrentSfc$ And sCurrentSfc$ <> sPreviousSfc$ Then
                            TestSubfieldPosition = SUBFIELDPOSITION_MoveUp%
                            Exit Function
                        'Else
                            ' the current subfield isn't the lead subfield, or it *is* the lead subfield
                            '   but the previous subfield code is the same as the current one; so we're considering
                            '   these 2 subfields to be in order
                            ' on to any next subfield
                        End If
                    Case SFDORDER_SegmentWithSingleLead%, SFDORDER_OccursInMultipleSegments%, SFDORDER_OccursInMultipleSegmentsLast%
                        'Debug.Print "Others"
                        ' these are at present all not used, so they don't count
                        ' on to any next subfield
                End Select
            End If
        Else
            'Debug.Print "Current lower than previous"
            ' the current subfield's group is lower than the previous
            '   subfield's group: the current subfield needs to be
            '   moved up one
            TestSubfieldPosition = SUBFIELDPOSITION_MoveUp%
            Exit Function
        End If
    End If
    
    ' if we get here, either there is no previous subfield, or
    '   the current subfield is (at least provisionally) in order
    '   in relation to the previous subfield
    'Debug.Print "No previous used"
    
    ' test the relationship of the current subfield to the subfield (if any)
    '   that immediately precedes it in the field
    If Len(sNextSfc$) > 0 Then
        If iSfdOrderForCurrent% < iSfdOrderForNext% Then
            ' current subfield's group is less than the next subfield's group:
            '   these two are in order already
        ElseIf iSfdOrderForCurrent% = iSfdOrderForNext% Then
            ' 20050620: the pointers must be greater than zero (they're zero if
            '   there is in fact no subfield-order definition for this field
            ' if the pointers are zero we'll simply add subfields in the order we
            '   receive them
            If iSfdOrderForCurrent% > 0 Then
                ' the two subfields are in the same group: so we need to
                '   worry about the sort order for this group
                Select Case gblaSfdOrder.Order(iSfdOrderForCurrent%).Type
                    Case SFDORDER_NoSegmentInThisOrder%
                        ' subfields must be in the specified order
                        iPtr% = InStr(gblaSfdOrder.Order(iSfdOrderForCurrent%).Sfds, sNextSfc$)
                        iPtr2% = InStr(gblaSfdOrder.Order(iSfdOrderForCurrent%).Sfds, sCurrentSfc$)
                        If iPtr2% > iPtr% Then
                            TestSubfieldPosition = SUBFIELDPOSITION_MoveDown%
                            Exit Function
                        'Else
                            ' the two subfields are in order
                        End If
                    Case SFDORDER_SegmentRandom%
                        ' we don't care what order these are in, so they must
                        '   already be in the right order
                    Case SFDORDER_SegmentWithLead%
                        ' if the next subfield is the 'lead' subfield in this segment and the
                        '   current one is not the 'lead' subfield, then move the current subfield down one
                        If Mid(gblaSfdOrder.Order(iSfdOrderForCurrent%).Sfds, 1, 1) = sNextSfc$ And sCurrentSfc$ <> sNextSfc$ Then
                            TestSubfieldPosition = SUBFIELDPOSITION_MoveDown%
                            Exit Function
                        'Else
                            ' the next subfield isn't the lead subfield, or it *is* the lead subfield
                            '   but the next subfield code is the same as the current one; so we're considering
                            '   these 2 subfields to be in order
                        End If
                    Case SFDORDER_SegmentWithSingleLead%, SFDORDER_OccursInMultipleSegments%, SFDORDER_OccursInMultipleSegmentsLast%
                        ' these are at present all not used, so they don't count
                End Select
            End If
        Else
            ' the current subfield's group is higher than the next
            '   subfield's group: the current subfield needs to be
            '   moved down one
            TestSubfieldPosition = SUBFIELDPOSITION_MoveDown%
            Exit Function
        End If
    End If

End Function

Public Sub FldReset(ByVal sTag$, ByVal sIndicators$, ByVal sField$)

    ' we've relented, and we're going to make this 'reset the whole thing' capability
    '   avilable to the outside; but we'll do it using a 'standard' name, and
    '   simply leap to the internal routine with the non-standard name
    
#If ResetCurrentFieldDebug = -1 Then
    Debug.Print "RCF from fldReset"
#End If
    ResetCurrentField sTag$, sIndicators$, sField$
    
End Sub

Public Function SummarizeFieldOrderInstructions(sType$) As String

    Select Case sType$
        Case "A"
            SummarizeFieldOrderInstructions = SummarizeFieldOrderInstructions2(gblaFieldOrderAuth(), gbliFieldOrderAuthLast%)
        Case "B"
            SummarizeFieldOrderInstructions = SummarizeFieldOrderInstructions2(gblaFieldOrderBib(), gbliFieldOrderBibLast%)
        Case "H"
            SummarizeFieldOrderInstructions = SummarizeFieldOrderInstructions2(gblaFieldOrderHold(), gbliFieldOrderHoldLast%)
    End Select
    
    

End Function

Private Function SummarizeFieldOrderInstructions2(ByRef aArray() As FieldOrderType, ByVal iLast%) As String

    Dim sOutput$
    
    Dim iCtr%
    
    For iCtr% = 1 To iLast%
        If Len(sOutput$) > 0 Then
            sOutput$ = sOutput$ + vbCrLf
        End If
        sOutput$ = sOutput$ + aArray(iCtr%).Begin + "-" + aArray(iCtr%).End
        
        Select Case aArray(iCtr%).SortInstruction
            Case SORTINSTRUCTION_Tag%
                sOutput$ = sOutput$ + " by tag"
            Case SORTINSTRUCTION_7XX%
                sOutput$ = sOutput$ + " by LCRI 21.30J"
            Case SORTINSTRUCTION_Indicator2%
                sOutput$ = sOutput$ + " by second indicator"
            Case SORTINSTRUCTION_Local%
                sOutput$ = sOutput$ + " local $5 comes first"
            Case SORTINSTRUCTION_Reference%
                sOutput$ = sOutput$ + " in reference order"
            Case Else ' includes GENERIC, natcherly
                sOutput$ = sOutput$ + " in generic order"
        End Select
    Next ' ictr
    
    SummarizeFieldOrderInstructions2 = sOutput$
    
End Function

Public Property Get TestFieldOrder() As Boolean

    TestFieldOrder = Not m_bOmitFieldOrderTest
    
End Property

Public Property Let TestFieldOrder(ByVal vNewValue As Boolean)

    m_bOmitFieldOrderTest = Not vNewValue
    
End Property

Public Property Get TestSubfieldOrder() As Boolean

    TestSubfieldOrder = Not m_bOmitSubfieldOrderTest
    
End Property

Public Property Let TestSubfieldOrder(ByVal vNewValue As Boolean)

    m_bOmitSubfieldOrderTest = Not vNewValue
    
End Property

Public Property Get FldsOutOfOrder() As Boolean

    FldsOutOfOrder = m_bFieldsOutOfOrder

End Property


Public Property Get SubfieldsOutOfOrder() As Boolean
        
    SubfieldsOutOfOrder = m_bSubfieldsOutOfOrder

End Property

Public Property Get FldsWithSfdsOutOfOrder() As String

    FldsWithSfdsOutOfOrder = m_sFieldsWithSubfieldsOutOfOrder$

End Property


Public Property Get MarcRecordModified() As Boolean

    ' NOTE that this property reflects changes to the order of
    '   fields or subfields made AUTOMATICALLY by program; it does
    '   not reflect changes instituted by the outside world (unless
    '   those changes instituted by the outside world cause the program
    '   automatically to override them ...)
    
    MarcRecordModified = m_bMarcRecordModified
    
End Property

Public Property Get MakeNoChange() As Boolean

    'Debug.Print "Getting MNC: " + str(m_bMakeNoChange)
    MakeNoChange = m_bMakeNoChange

End Property

Public Property Let MakeNoChange(ByVal vNewValue As Boolean)

    'Debug.Print "SETTING MNC TO: " + str(vNewValue)
    m_bMakeNoChange = vNewValue
    'Debug.Print "MNC is now: " + str(m_bMakeNoChange)
    'Debug.Print "MNC is now: " + str(MakeNoChange)
    
End Property

Private Sub TranslateWholeRecordAtOnce()
    
    Dim bChanged As Boolean
    
    Dim sField$
    
    Dim iCtr%, iPtr%, iLast%
    
    
    ' 20041021: added use of FldPointer to avoid an infinite loop that appeared *only*
    '   if we performed this sequence of steps:
    ' with CharacterSetIn and Out set to M and V respectively, read in a record in the
    '   MARC character set (no problem at this stage; translation is fine); this
    '   record contains the degree symbol
    ' put that record somewhere for safekeeping
    ' with CharacterSetIn and Out still set to M and V, read in the already-translated
    '   record (with the degree symbol already translated to hex 90, which is not a
    '   valid MARC value)
    
    FldMoveTop
    iLast% = m_iMarcCtr%
    Do While FldMoveNext
        iPtr% = FldPointer
        If iPtr% <= iLast% Then
            If Not FldIsControl And Not FldDeleted Then
                sField$ = FldText
                bChanged = False
                If InStr(sField$, MarcEscape) > 0 Then
                    If FldTag = "880" Then
                        Translate880Field sField$, bChanged
                    Else ' this is NOT an 880 field
                        TranslateRemainder sField$, bChanged
                    End If
                Else ' field contains no escape: use the standard setup
                    TranslateRemainder sField$, bChanged
                    'For iCtr% = 1 To iCharacterLast%
                    '    TranslateOneCharacter sField$, aCharacter(iCtr%).From, aCharacter(iCtr%).To, bChanged
                    'Next ' ictr%
                End If
                If bChanged Then
#If ResetCurrentFieldDebug = -1 Then
                    Debug.Print "TWRAO"
#End If
                    ResetCurrentField FldTag, FldInd, sField$
                    m_bMarcRecordTranslated = True
                End If
            End If
        End If
        FldPointer = iPtr%
    Loop

End Sub

Public Property Get FldOrderChanged() As Boolean

    FldOrderChanged = m_bFldOrderChanged
    
End Property


Public Property Get SfdOrderChanged() As Boolean

    SfdOrderChanged = m_bSfdOrderChanged

End Property


Private Sub TranslateLatin12Marc8()

    ' 20040721: new routine
    
    
    Dim sField$, sTag$
    Dim iPtr%, iChanged%, iRc%
    Dim sLead$, sRest$, sLow$, sHigh$
    
    
    If sCharacterSetup$ <> "L2M" Then
        sCharacterSetup$ = "L2M"
        ' this doesn't actually do anything, as
        '   we do all of the translation via the MscoftAscii2Marc function
        iCharacterLast% = 255
        ReDim aCharacter(0 To 255)
    End If
    
    TranslateWholeRecordAtOnce
    Exit Sub

End Sub

Private Sub TranslateLatin12Utf8()

    ' 20040721: new routine


    Dim iCtr%, iNonfiling%, iIndicator%, iPtr%, iEscape%
    
    Dim bChanged As Boolean, bError As Boolean, m_bUtf8Save As Boolean
    
    Dim sField$, sNonfiling$, sChar$, sPiece$, sRemainder$, sSave$
    Dim sCharacterSet$, sNextCharacterSet$, sTag$, sIndicators$
    
    
    m_bUtf8Save = m_bUtf8
    m_bUtf8 = True
    
    iPtr% = FldPointer
    
    
    FldMoveTop
    Do While FldMoveNext
        ' NOTE that we're not skipping deleted fields ...
        Select Case FldTag
            Case "005", "006", "007", "008"
                ' these fixed-length fields remain untouched (other 00X fields shouldn't contain any
                '   high-end characters, but we're going on the assumption of bad data,
                '   and we'll translate 'em. if we ever translate such a record back again, we'll catch it then
                ' todo: translate these fields too; but convert any character not in set 1 into
                '   a fill character
            Case Else
                ' including 001, 003: we'll translate these and hope for the best
                FldLoadInfo sTag$, sIndicators$, sField$
                sSave$ = sField$
                sField$ = MsoftAscii2Marc(sField$)
                If sField$ <> sSave$ Then
#If FldChangeDebug = -1 Then
                    Debug.Print "FldChange from TL12UTF8"
#End If
                    FldChange sTag$, sIndicators$, sField$
                    m_bMarcRecordTranslated = True
                End If
        End Select
TranslateMarc2Utf8NextField:
    Loop
               
    ' Unicode records don't need the 066 field
    Do While FldFindFirst("066")
        FldDelete
    Loop

    ' set leader/09 to 'utf-8' to signal this change
    m_sLeader$ = SafeStuff(m_sLeader$, 10, 1, "a")
    
    FldPointer = iPtr%
    
    m_bUtf8 = m_bUtf8Save
    
    Exit Sub

End Sub

Public Function XMLRecordOut(sForm As XmlExportType) As String

    ' 20040802: translate the current MARC-like array into an XML
    '   output record, using the MARCXML schema
    
    ' NOTE that this property provides one record in XML format (i.e.,
    '   the contents of the <record> tag); any stuff needed outside
    '   the individual record must be supplied in another manner--perhaps
    '   by the container program

    Dim sOut$, sField$, sSfdString$, sSfdStopAtNext$, sType$, sRole$, sRelationship$
    Dim sDisplayLabel$, sDisplayLabel2$
    Dim sAuthority$, sAuthority2$, sElement$, sPart$, sWhole$, sAllSfds$, sExtent$, sV$, sTitle$
    Dim sCharacterSetOut$, sCrlfTabTab$, sStopAt$, sTabTab$, sTabTabTab$, sCrLfTabTabTab$, s001$
    Dim sPiece$, sHostUrl$, sSfc$, s020$
    
    Dim lPtr As Long
    
    Dim iFieldPtr%, iFieldPtr2%, iSfdPointer%, iNonfiling%, iRc%, iRc2%, iTAt%, iCtr%
    
    Dim bQualified As Boolean, bChanged As Boolean, bHave260DateAlready As Boolean
    Dim bModsAquifer As Boolean, bKeyDate As Boolean, bFirstUrl As Boolean, bGHandled As Boolean
    
    On Error GoTo 0
    
    sTabTab$ = vbTab + vbTab
    sCrlfTabTab$ = vbCrLf + sTabTab$
    sTabTabTab$ = sTabTab$ + vbTab
    sCrLfTabTabTab$ = sCrlfTabTab + vbTab
    
    ' save the current setting for CharacterSetOut (if this isn't UTF-8 we're going to
    '   force it to UTF-8, and change it back later on)
    sCharacterSetOut$ = CharacterSetOut
    
    ' save our current location, because we're going to be going through the record, maybe
    '   multiple times
    iFieldPtr% = FldPointer
    iSfdPointer% = SfdPointer
    
    
    Select Case sForm
    
        Case XmlExportType_MarcXML%
        
            ' this is possible in all formats, including authority
            
            ' we're going to translate the entire record into UTF-8 if it's not already
            '   in UTF-8, to avoid problems with the 880 fields
            If CharacterSetOut <> "U" Then
                CharacterSetOut = "U"
            End If
            
            ' the XML header
            sOut$ = "<?xml version=" + AddQuotes("1.0") + " encoding=" + AddQuotes("UTF-8") + " ?> "
            ' the MARC header
            sOut$ = sOut$ + vbCrLf + "<marc:collection xmlns:marc=" + AddQuotes("http://www.loc.gov/MARC21/slim")
            sOut$ = sOut$ + vbCrLf + "     xmlns:xsi=" + AddQuotes("http://www.w3.org/2001/XMLSchema-instance")
            sOut$ = sOut$ + vbCrLf + "     xsi:schemaLocation=" + AddQuotes("http://www.loc.gov/MARC21/slim http://www.loc.gov/standards/marcxml/schema/MARC21slim.xsd") + ">"
            
            sOut$ = sOut$ + vbCrLf + vbTab + "<marc:record>"
        
            ' the record leader
            ' 20051107: get rid of the stupid OCLC hijacking of part of the tail of the leader
            '   by forcing the tail to be a constant value
            sOut$ = sOut$ + sCrlfTabTab + XmlTags("marc:leader", Mid(Leader, 1, 20 + "4500"))
            
            ' this is the easiest one: direct translation
            ' todo: isn't there some kind of header to write on this???
            FldMoveTop
            Do While FldMoveNext
                If Not FldDeleted Then
                    If Mid(FldTag, 1, 2) = "00" Then
                        sOut$ = sOut$ + sCrlfTabTab + XmlTags("marc:controlfield tag=" + AddQuotes(FldTag), XmlConditionText(FldText))
                    Else
                        SfdMoveTop
                        sField$ = ""
                        Do While SfdMoveNext
                            If Not SfdDeleted Then
                                ' 20060527: do not translate ampersand in URLs
                                'If FldTag = "856" And SfdCode = "u" Then
                                '    sField$ = sField$ + sCrLfTabTab + vbTab + XmlTags("marc:subfield code=" + AddQuotes(SfdCode), SfdText)
                                'Else
                                    sField$ = sField$ + sCrlfTabTab + vbTab + XmlTags("marc:subfield code=" + AddQuotes(SfdCode), XmlConditionText(SfdText))
                                'End If
                            End If
                        Loop
                        sField$ = XmlTags("marc:datafield tag=" + AddQuotes(XmlConditionText(FldTag)) + " ind1=" + AddQuotes(Mid(FldInd, 1, 1)) + " ind2=" + AddQuotes(Mid(FldInd, 2, 1)), sField$)
                        If InStr(sField$, "<marc:subfield") > 0 Then
                            sOut$ = sOut$ + sCrlfTabTab + sField$
                        End If
                    End If
                End If
            Loop
            
            sOut$ = sOut$ + vbCrLf + vbTab + "</marc:record>" + vbCrLf + "</marc:collection>"
            
            If CharacterSetOut <> sCharacterSetOut Then
                CharacterSetOut = sCharacterSetOut$
            End If
            
        Case XmlExportType_MODSAquifer%
        
            bModsAquifer = True
            GoTo XMLRO_NormalModsOutput
            
        Case XmlExportType_MODS%, XmlExportType_MODSAquifer%
            
XMLRO_NormalModsOutput:

            ' 20050707: we have now defined a separate section for MADS
            Select Case MarcRecordFormat
                Case "A"
                    GoTo XmlRecordOutUseMadsInstead
                Case "B", "D", "F", "M", "P", "S", "U"
                    ' these are OK
                Case Else
                    XMLRecordOut = ""
                    Exit Function
            End Select
            
XmlRecordOutUseModsInstead:

            ' the XML header
            sOut$ = "<?xml version=" + AddQuotes("1.0") + " encoding=" + AddQuotes("UTF-8") + " ?> "
            ' the MODS header
            ' 20050531: omit the version number (for ongoing compatability?)
            sOut$ = sOut$ + vbCrLf + "<modsCollection xmlns:xlink=" + AddQuotes("http://www.w3.org/1999/xlink") ' + " version=" + AddQuotes("3.0")
            sOut$ = sOut$ + vbCrLf + "     xmlns:xsi=" + AddQuotes("http://www.w3.org/2001/XMLSchema-instance")
            sOut$ = sOut$ + vbCrLf + "     xmlns=" + AddQuotes("http://www.loc.gov/mods/v3")
            ' 20071004: changed from version 3.0 to 3.2
            sOut$ = sOut$ + vbCrLf + "     xsi:schemaLocation=" + AddQuotes("http://www.loc.gov/mods/v3 http://www.loc.gov/standards/mods/v3/mods-3-2.xsd") + ">"
            sOut$ = sOut$ + vbCrLf + vbTab + "<mods>"
            
            ' *********************************************
            ' the titleinfo section: one repeat of titleInfo for
            '   each included title
            ' *********************************************
            FldMoveTop
            Do While FldMoveNext
                sDisplayLabel$ = ""
                Select Case FldTag
                    Case "130"
XlmRecordOutUniformTitle:
                        iNonfiling% = 0
                        sType$ = "uniform"
                        GoTo XmlRecordOutStandardTitle
                    Case "210"
                        sType$ = "abbreviated"
                        iNonfiling% = 0
                        GoTo XmlRecordOutStandardTitle
                    Case "240"
                        sType$ = "uniform"
                        GoTo XlmRecordOutUniformTitle
                    Case "242"
                        iNonfiling% = 0
                        sType$ = "translated"
                        GoTo XmlRecordOutStandardTitle
                    Case "245"
                        sType$ = ""
                        iNonfiling% = Val(Mid(FldInd, 2, 1))
XmlRecordOutStandardTitle:
                        sDisplayLabel$ = ""
                        sField$ = ""
                        ' 20080529: per K. Miller, 245 $f and 245 $g don't go
                        '   into the title business at all
                        If SfdFindFirst("a") Then
                            sField$ = sField$ + XmlRecordOutOneLump("title", iNonfiling%, "adhklmor", "np", " ", bModsAquifer, True)
                            'sField$ = sField$ + XmlRecordOutOneLump("title", iNonfiling%, "adfhgklmor", "np", " ", bModsAquifer)
                            ' 20080530: any display label in $a doesn't go into the "title" element,
                            '   it goes into the titleInfo element
                            SfdFindFirst "a"
                            lPtr = InStr(SfdText, vbTab)
                            If lPtr > 0 Then
                                sDisplayLabel$ = " displayLabel=" + AddQuotes(Mid(SfdText, lPtr + 1))
                                If Mid(sDisplayLabel$, 1, 1) = vbTab Then
                                    sDisplayLabel$ = Mid(sDisplayLabel$, 2)
                                End If
                                SfdText$ = Mid(SfdText$, 1, lPtr - 1)
                            End If
                        End If
                        If SfdFindFirst("b") Then
                            sField$ = sField$ + XmlRecordOutOneLump("subTitle", 0, "bhk", "", " ", bModsAquifer)
                        End If
                        If SfdFindFirst("i") Then ' 242 only, not 245
                            sDisplayLabel$ = " displayLabel=" + AddQuotes(XmlConditionText(SfdText))
                            'Debug.Print "DL picked up >" + FldTextFormatted(HexEquivalents)
                        End If
                        SfdMoveTop
                        Do While SfdMoveNext
                            Select Case SfdCode
                                Case "n"
                                    sField$ = sField$ + XmlRecordOutOneLump("partNumber", 0, "ndhklmor", "np", " ", bModsAquifer)
                                Case "p"
                                    sField$ = sField$ + XmlRecordOutOneLump("partName", 0, "pdhklmor", "np", " ", bModsAquifer)
                            End Select
                        Loop
                        If Len(sField$) > 0 Then
                            If Len(sType$) > 0 Then
                                sOut$ = sOut$ + sCrlfTabTab$ + XmlTags("titleInfo type=" + AddQuotes(sType$) + sDisplayLabel$, sField$)
                            Else
                                sOut$ = sOut$ + sCrlfTabTab$ + XmlTags("titleInfo" + sDisplayLabel$, sField$)
                            End If
                        End If
                    Case "246"
                        iNonfiling% = 0
                        If Mid(FldInd, 2, 1) = "1" Then
                            sType$ = "translated" ' parallel title, really
                        Else
                            sType$ = "alternative"
                        End If
                        GoTo XmlRecordOutStandardTitle
                    Case "730"
                        ' ind2=2 handled as relatedItem
                        If Mid(FldInd, 2, 1) <> "2" Then
                            sType$ = "uniform"
                            GoTo XlmRecordOutUniformTitle
                        End If
                    Case "740"
                        ' ind2=2 handled as relatedItem
                        If Mid(FldInd, 2, 1) <> "2" Then
                            sType$ = "alternative"
                            GoTo XmlRecordOutStandardTitle
                        End If
                End Select
            Loop
        
            ' *********************************************
            ' the name section: one <name> tag for each included name
            ' *********************************************
            FldMoveTop
            If bModsAquifer Then
                sAuthority$ = "naf"
            Else
                sAuthority$ = ""
            End If
            Do While FldMoveNext
                Select Case FldTag
                    Case "100"
                        If SfdFindFirst("8") Then
                            sRole$ = SfdText
                        Else
                            sRole$ = "Creator"
                        End If
XmlRecordOutPersonalName:
                        sType$ = "personal"
XmlRecordOutGeneralName:
                        XmlModsAssembleNamePersonal sOut$, sRole$, sType$, sCrlfTabTab$, sAuthority$
                    Case "110"
                        If SfdFindFirst("8") Then
                            sRole$ = SfdText
                        Else
                            sRole$ = "Creator"
                        End If
XmlRecordOutCorporateName:
                        sType$ = "corporate"
                        XmlModsAssembleNameCorporate sOut$, sRole$, sType$, sCrlfTabTab$, sAuthority$
                        
                    Case "111"
                        If SfdFindFirst("8") Then
                            sRole$ = SfdText
                        Else
                            sRole$ = "Creator"
                        End If
XMLRecordOutConferenceName:
                        sType$ = "conference"
                        XmlModsAssembleNameConference sOut$, sRole$, sType$, sCrlfTabTab$, sAuthority$
                        
                    Case "700"
                        ' 700 with $t handled as relatedItem
                        If Not SfdFindFirst("t") Then
                            If SfdFindFirst("8") Then
                                sRole$ = SfdText
                            ElseIf bModsAquifer Then
                                sRole$ = "Contributor"
                            Else
                                sRole$ = ""
                            End If
                            GoTo XmlRecordOutPersonalName
                        End If
                    Case "710"
                        ' 710 with $t handled as relatedItem: see below
                        If Not SfdFindFirst("t") Then
                            If SfdFindFirst("8") Then
                                sRole$ = SfdText
                            ElseIf bModsAquifer Then
                                sRole$ = "Contributor"
                            Else
                                sRole$ = ""
                            End If
                            GoTo XmlRecordOutCorporateName
                        End If
                    Case "711"
                        ' 711 with $t handled as relatedItem
                        If Not SfdFindFirst("t") Then
                            If SfdFindFirst("8") Then
                                sRole$ = SfdText
                            ElseIf bModsAquifer Then
                                sRole$ = "Contributor"
                            Else
                                sRole$ = ""
                            End If
                            GoTo XmlRecordOutCorporateName
                        End If
                    Case "720"
                        If Mid(FldInd, 1, 1) = "1" Then
                            sType$ = "personal"
                        Else
                            sType$ = ""
                        End If
                        If SfdFindFirst("8") Then
                            sRole$ = SfdText
                        ElseIf bModsAquifer Then
                            sRole$ = "Contributor"
                        Else
                            sRole$ = ""
                        End If
                        GoTo XmlRecordOutGeneralName
                End Select
            Loop
            
            
            ' *********************************************
            ' the type-of-resource section
            ' *********************************************
            ' hard-coded; only one value possible per record
            sType$ = ""
            If GetLeaderValue(7, 1) = "c" Then
                sType$ = " collection=" + AddQuotes("yes")
            End If
            If InStr("dfpt", GetLeaderValue(6, 1)) > 0 Then
                sType$ = sType$ + " manuscript=" + AddQuotes("yes")
            End If
            Select Case GetLeaderValue(6, 1)
                Case "a", "t"
                    sRole$ = "text"
XmlRecordOutModsTypeOfResource:
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("typeOfResource" + sType$, sRole$)
                Case "c", "d"
                    sRole$ = "notated music"
                    GoTo XmlRecordOutModsTypeOfResource
                Case "e", "f"
                    sRole$ = "cartographic"
                    GoTo XmlRecordOutModsTypeOfResource
                Case "g"
                    sRole$ = "moving image"
                    GoTo XmlRecordOutModsTypeOfResource
                Case "i"
                    sRole$ = "sound recording - nonmusical"
                    GoTo XmlRecordOutModsTypeOfResource
                Case "j"
                    sRole$ = "sound recording - musical"
                    GoTo XmlRecordOutModsTypeOfResource
                Case "k"
                    sRole$ = "still image"
                    GoTo XmlRecordOutModsTypeOfResource
                Case "m"
                    sRole$ = "software, multimedia"
                    GoTo XmlRecordOutModsTypeOfResource
                Case "p"
                    sRole$ = "mixed material"
                    GoTo XmlRecordOutModsTypeOfResource
                Case "r"
                    sRole$ = "three dimensional object"
                    GoTo XmlRecordOutModsTypeOfResource
            End Select
        
                    
            ' we cut this out to a separate routine because this basic routine
            '   is now too large!
            sOut$ = XmlRecordOutGenreSection(sOut$, sCrlfTabTab$)
        
            ' *********************************************
            ' next lump: non-fixed-fields
            ' *********************************************
            FldMoveTop
            Do While FldFindNext("655")
                'Debug.Print "655: " + sField$
                Select Case Mid(FldInd, 2, 1)
                    Case "0"
                        sRole$ = " authority=" + AddQuotes("lcsh")
                    Case "1"
                        sRole$ = " authority=" + AddQuotes("lcshac")
                    Case "2"
                        sRole$ = " authority=" + AddQuotes("mesh")
                    Case "3"
                        sRole$ = " authority=" + AddQuotes("nal")
                    Case "5"
                        sRole$ = " authority=" + AddQuotes("csh")
                    Case "6"
                        sRole$ = " authority=" + AddQuotes("rvm")
                    Case "7"
                        If SfdFindFirst("2") Then
                            sRole$ = " authority=" + AddQuotes(SfdText)
                        Else
                            sRole$ = ""
                        End If
                    Case Else
                        sRole$ = ""
                End Select
                sField$ = XmlRecordOutOneLump("genre" + sRole + sDisplayLabel$, 0, "abvxyz", "", " - ")
                If Len(sField$) > 0 Then
                    sOut$ = sOut$ + sCrlfTabTab + sField$
                End If
            Loop
        
        
            ' *********************************************
            ' the origininfo section
            ' *********************************************
            ' all the bits of this go into one big ol' originInfo tag
            sField$ = ""
            If InStr(Get008Value(15, 3), MarcFill) = 0 And Get008Value(15, 3) <> "   " Then
                sField$ = sTabTabTab$ + XmlTags("place", XmlTags("placeTerm type=" + AddQuotes("code") + " authority=" + AddQuotes("marccountry"), Get008Value(15, 3)))
            End If
            If FldFindFirst("044") Then
                If SfdFindFirst("a") Then
                    If Len(sField$) > 0 Then
                        sField$ = sField$ + vbCrLf
                    End If
                    sField$ = sTabTabTab$ + XmlTags("place", XmlTags("placeTerm type=" + AddQuotes("text") + sDisplayLabel$ + " authority=" + AddQuotes("marccountry"), XmlConditionText(SfdText)))
                End If
            End If
            FldMoveTop
            If FldFindFirst("245") Then
                If SfdFindFirst("f") Then
                    sPiece$ = SfdText
XRO_Handle245FOrG:  ' NOTE label in left margin
                    ' remove any embedded label
                    lPtr = InStr(sPiece$, vbTab)
                    If lPtr > 0 Then
                        sPiece$ = Mid(sPiece$, 1, lPtr - 1)
                    End If
                    
                    sField$ = sTabTabTab$ + XmlTags("dateIssued", XmlConditionText(sPiece$))
                    
                ElseIf SfdFindFirst("g") Then
                    sPiece$ = SfdText
                    GoTo XRO_Handle245FOrG
                End If
            End If
            Do While FldFindNext("260")
                If SfdFindFirst("a") Then
                    If Len(sField$) > 0 Then
                        sField$ = sField$ + vbCrLf
                    End If
                    sField$ = sField$ + sTabTabTab + XmlTags("place", XmlTags("placeTerm type=" + AddQuotes("text") + " authority=" + AddQuotes("marccountry"), XmlConditionText(SfdText)))
                End If
                If SfdFindFirst("b") Then
                    If Len(sField$) > 0 Then
                        sField$ = sField$ + vbCrLf
                    End If
                    sField$ = sField$ + sTabTabTab + XmlTags("publisher", XmlConditionText(SfdText))
                End If
                ' 20091130: per K. miller, add an element for 260 $c even
                '   if 008/07-10 is available
                'If Get008Value(7, 4) = "    " Then
                    If SfdFindFirst("c") Then
                        If Len(sField$) > 0 Then
                            sField$ = sField$ + vbCrLf
                        End If
                        sField$ = sField$ + sTabTabTab$ + XmlTags("dateIssued", XmlConditionText(SfdText))
                    End If
                'End If
                If SfdFindFirst("g") Then
                    If Len(sField$) > 0 Then
                        sField$ = sField$ + vbCrLf
                    End If
                    sField$ = sField$ + sTabTabTab$ + XmlTags("dateCreated", XmlConditionText(SfdText))
                End If
            Loop
            Select Case Get008Value(6, 1)
                Case "e", "p", "r", "s" ' t is separate, below
                    If Get008Value(7, 4) <> "    " Then
                        If Len(sField$) > 0 Then
                            sField$ = sField$ + vbCrLf
                        End If
                        If bModsAquifer Then
                            sField$ = sField$ + sTabTabTab + XmlTags("dateIssued keyDate=" + AddQuotes("yes") + " encoding=" + AddQuotes("marc"), Get008Value(7, 4))
                            bKeyDate = True
                        Else
                            sField$ = sField$ + sTabTabTab + XmlTags("dateIssued encoding=" + AddQuotes("marc"), Get008Value(7, 4))
                        End If
                    End If
                Case "c", "d", "i", "k", "m", "u"
                    If Get008Value(7, 4) <> "    " Then
                        If Len(sField$) > 0 Then
                            sField$ = sField$ + vbCrLf
                        End If
                        If bModsAquifer Then
                            bKeyDate = True
                            sField$ = sField$ + sTabTabTab + XmlTags("dateIssued keyDate=" + AddQuotes("yes") + " encoding=" + AddQuotes("marc") + " point=" + AddQuotes("start"), Get008Value(7, 4))
                        Else
                            sField$ = sField$ + sTabTabTab + XmlTags("dateIssued encoding=" + AddQuotes("marc") + " point=" + AddQuotes("start"), Get008Value(7, 4))
                        End If
                    End If
                    If Get008Value(11, 4) <> "    " Then
                        If Len(sField$) > 0 Then
                            sField$ = sField$ + vbCrLf
                        End If
                        If bModsAquifer Then
                            If Not bKeyDate Then
                                sField$ = sField$ + sTabTabTab + XmlTags("dateIssued keyDate=" + AddQuotes("yes") + " encoding=" + AddQuotes("marc") + " point=" + AddQuotes("end"), Get008Value(11, 4))
                                bKeyDate = True
                            Else
                                sField$ = sField$ + sTabTabTab + XmlTags("dateIssued encoding=" + AddQuotes("marc") + " point=" + AddQuotes("end"), Get008Value(11, 4))
                            End If
                        Else
                            sField$ = sField$ + sTabTabTab + XmlTags("dateIssued encoding=" + AddQuotes("marc") + " point=" + AddQuotes("end"), Get008Value(11, 4))
                        End If
                    End If
                Case "q"
                    If Get008Value(7, 4) <> "    " Then
                        If Len(sField$) > 0 Then
                            sField$ = sField$ + vbCrLf
                        End If
                        If bModsAquifer Then
                            sField$ = sField$ + sTabTabTab + XmlTags("dateIssued keyDate=" + AddQuotes("yes") + " qualifier=" + AddQuotes("questionable") + " encoding=" + AddQuotes("marc") + " point=" + AddQuotes("start"), Get008Value(7, 4))
                            bKeyDate = True
                        Else
                            sField$ = sField$ + sTabTabTab + XmlTags("dateIssued qualifier=" + AddQuotes("questionable") + " encoding=" + AddQuotes("marc") + " point=" + AddQuotes("start"), Get008Value(7, 4))
                        End If
                    End If
                    If Get008Value(11, 4) <> "    " Then
                        If Len(sField$) > 0 Then
                            sField$ = sField$ + vbCrLf
                        End If
                        If bModsAquifer Then
                            If Not bKeyDate Then
                                sField$ = sField$ + sTabTabTab + XmlTags("dateIssued keyDate=" + AddQuotes("yes") + " qualifier=" + AddQuotes("questionable") + " encoding=" + AddQuotes("marc") + " point=" + AddQuotes("end"), Get008Value(11, 4))
                                bKeyDate = True
                            Else
                                sField$ = sField$ + sTabTabTab + XmlTags("dateIssued qualifier=" + AddQuotes("questionable") + " encoding=" + AddQuotes("marc") + " point=" + AddQuotes("end"), Get008Value(11, 4))
                            End If
                        Else
                            sField$ = sField$ + sTabTabTab + XmlTags("dateIssued qualifier=" + AddQuotes("questionable") + " encoding=" + AddQuotes("marc") + " point=" + AddQuotes("end"), Get008Value(11, 4))
                        End If
                    End If
                Case "t"
                    If Get008Value(7, 4) <> "    " Then
                        If Len(sField$) > 0 Then
                            sField$ = sField$ + vbCrLf
                        End If
                        If bModsAquifer Then
                            sField$ = sField$ + sTabTabTab + XmlTags("dateIssued keyDate=" + AddQuotes("yes") + " encoding=" + AddQuotes("marc"), Get008Value(7, 4))
                            bKeyDate = True
                        Else
                            sField$ = sField$ + sTabTabTab + XmlTags("dateIssued encoding=" + AddQuotes("marc"), Get008Value(7, 4))
                        End If
                    End If
                    If Get008Value(11, 4) <> "    " Then
                        If Len(sField$) > 0 Then
                            sField$ = sField$ + vbCrLf
                        End If
                        If bModsAquifer Then
                            If Not bKeyDate Then
                                sField$ = sField$ + sTabTabTab + XmlTags("copyrightDate keyDate=" + AddQuotes("yes"), Get008Value(11, 4))
                                bKeyDate = True
                            Else
                                sField$ = sField$ + sTabTabTab + XmlTags("copyrightDate", Get008Value(11, 4))
                            End If
                        Else
                            sField$ = sField$ + sTabTabTab + XmlTags("copyrightDate", Get008Value(11, 4))
                        End If
                    End If
            End Select
            FldMoveTop
            Do While FldFindNext("033")
                If SfdFindFirst("a") Then
                    Select Case Mid(FldInd, 1, 1)
                        Case "0", "1"
                            If Len(sField$) > 0 Then
                                sField$ = sField$ + vbCrLf
                            End If
                            sField$ = sField$ + sTabTabTab + XmlTags("dateCaptured encoding=" + AddQuotes("iso8601") + " point=" + AddQuotes("start"), XmlConditionText(SfdText))
                        Case "2"
                            If Len(sField$) > 0 Then
                                sField$ = sField$ + vbCrLf
                            End If
                            sField$ = sField$ + sTabTabTab + XmlTags("dateCaptured point=" + AddQuotes("start") + " encoding=" + AddQuotes("iso8601") + " point=" + AddQuotes("start"), XmlConditionText(SfdText))
                            If SfdFindNext("a") Then
                                sField$ = sField$ + sCrlfTabTab + XmlTags("dateCaptured point=" + AddQuotes("start") + " encoding=" + AddQuotes("iso8601") + " point=" + AddQuotes("end"), XmlConditionText(SfdText))
                            End If
                    End Select
                End If
            Loop
            FldMoveTop
            Do While FldFindNext("046")
                If SfdFindFirst("b") Then
                    If Len(sField$) > 0 Then
                        sField$ = sField$ + vbCrLf
                    End If
                    sField$ = sField$ + sTabTabTab + XmlTags("dateIssued encoding=" + AddQuotes("marc") + " point=" + AddQuotes("start"), XmlConditionText(SfdText))
                End If
                If SfdFindFirst("d") Then
                    If Len(sField$) > 0 Then
                        sField$ = sField$ + vbCrLf
                    End If
                    sField$ = sField$ + sTabTabTab + XmlTags("dateIssued encoding=" + AddQuotes("marc") + " point=" + AddQuotes("end"), XmlConditionText(SfdText))
                End If
                If SfdFindFirst("j") Then
                    If Len(sField$) > 0 Then
                        sField$ = sField$ + vbCrLf
                    End If
                    sField$ = sField$ + sTabTabTab + XmlTags("dateModified", XmlConditionText(SfdText))
                End If
                If SfdFindFirst("k") Then
                    If Len(sField$) > 0 Then
                        sField$ = sField$ + vbCrLf
                    End If
                    sField$ = sField$ + sTabTabTab + XmlTags("dateCreated point=" + AddQuotes("start"), XmlConditionText(SfdText))
                End If
                If SfdFindFirst("l") Then
                    If Len(sField$) > 0 Then
                        sField$ = sField$ + vbCrLf
                    End If
                    sField$ = sField$ + sTabTabTab + XmlTags("dateCreated point=" + AddQuotes("end"), XmlConditionText(SfdText))
                End If
                If SfdFindFirst("m") Then
                    If Len(sField$) > 0 Then
                        sField$ = sField$ + vbCrLf
                    End If
                    sField$ = sField$ + sTabTabTab + XmlTags("dateValid point=" + AddQuotes("start"), XmlConditionText(SfdText))
                End If
                If SfdFindFirst("n") Then
                    If Len(sField$) > 0 Then
                        sField$ = sField$ + vbCrLf
                    End If
                    sField$ = sField$ + sTabTabTab + XmlTags("dateValid point=" + AddQuotes("end"), XmlConditionText(SfdText))
                End If
            Loop
            If FldFindFirst("250") Then
                If SfdFindFirst("a") Then
                    If Len(sField$) > 0 Then
                        sField$ = sField$ + vbCrLf
                    End If
                    sField$ = sField$ + sTabTabTab + XmlTags("edition", XmlConditionText(SfdText))
                End If
            End If
            Select Case GetLeaderValue(7, 1)
                Case "b", "i", "s"
                    If Len(sField$) > 0 Then
                        sField$ = sField$ + vbCrLf
                    End If
                    sField$ = sField$ + sTabTabTab + XmlTags("issuance", "continuing")
                Case Else
                    If Len(sField$) > 0 Then
                        sField$ = sField$ + vbCrLf
                    End If
                    sField$ = sField$ + sTabTabTab + XmlTags("issuance", "monographic")
            End Select
            If FldFindFirst("310") Then
                If SfdFindFirst("a") Then
XmlRecordOut310a:   ' NOTE label in left margin
                    If Len(sField$) > 0 Then
                        sField$ = sField$ + vbCrLf
                    End If
                    sField$ = sField$ + sTabTabTab + XmlRecordOutOneLump("frequency", 0, "ab", "", " ")
                ElseIf SfdFindFirst("b") Then
                    GoTo XmlRecordOut310a
                End If
            End If
            FldMoveTop
            Do While FldFindNext("321")
                If SfdFindFirst("a") Then
XmlRecordOut321a:   ' NOTE label in left margin
                    If Len(sField$) > 0 Then
                        sField$ = sField$ + vbCrLf
                    End If
                    sField$ = sField$ + sTabTabTab + XmlRecordOutOneLump("frequency", 0, "ab", "", " ")
                ElseIf SfdFindFirst("b") Then
                    GoTo XmlRecordOut321a
                End If
            Loop
            ' end of the origin info section
            If Len(sField$) > 0 Then
                ' note that we add explicit whitespace because of the peculiar
                '   nature of this one particular lump
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("originInfo", vbCrLf + sField$ + sCrlfTabTab)
            End If
            
            'If bModsAquifer Then
            '    If InStr(sOut$, "keyDate") = 0 Then
            '        MsgBox "Record with no keyDate"
            '    End If
            'End If
            
            ' *********************************************
            ' language section
            ' *********************************************
            ' todo: it is NOT at all clear whether there should be one
            '   <language> tag with repeated <languageTerm> tags inside it,
            '   or repeated <language> tags; perhaps the schema indicates this?
            ' for now, we're going with highly redundant coding
            sAuthority$ = ""
            If Not FldFindFirst("041") Then
                If Get008Value(35, 3) <> "   " And InStr(Get008Value(35, 3), MarcFill) = 0 Then
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("language", XmlTags("languageTerm type=" + AddQuotes("code") + " authority=" + AddQuotes("iso639-2b"), Get008Value(35, 3)))
                End If
            Else
                FldMoveTop
                Do While FldFindNext("041")
                    If SfdFindFirst("2") Then
                        If SfdText <> "rfc3066" Then
                            GoTo XmlRecordOutNext041Field
                        End If
                        sAuthority$ = " authority=" + AddQuotes(SfdText)
                    Else
                        sAuthority$ = " authority=" + AddQuotes("iso639-2b")
                    End If
                    SfdMoveTop
                    Do While SfdMoveNext
                        Select Case SfdCode
                            Case "a", "d", "e"
                                sField$ = XmlConditionText(SfdText)
                                Do
                                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("language", XmlTags("languageTerm type=" + AddQuotes("code") + sAuthority$, Mid(sField$, 1, 3)))
                                    sField$ = Mid(sField$, 4)
                                    If Len(sField$) < 3 Then
                                        Exit Do
                                    End If
                                Loop
                        End Select
                    Loop
XmlRecordOutNext041Field:
                Loop
            End If
            
            
            ' *********************************************
            ' the physical description section
            ' *********************************************
            ' this *appears* all to fit into one tag
            sField$ = ""
            sAuthority$ = " authority=" + AddQuotes("marcform")
            Select Case MarcRecordFormat
                Case "B"
                    Select Case Get008Value(23, 1)
                        Case " ", "r"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "print")
                        Case "a"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "microfilm")
                        Case "b"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "microfiche")
                        Case "f"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "braille")
                        Case "s"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "electronic")
                    End Select
                Case "D"
                    ' born digital, or not?
                    FldMoveTop
                    Do While FldFindNext("007")
                        If Mid(FldText, 1, 1) = "m" And InStr("ab", Mid(FldText, 12, 1)) > 0 Then
                            sField$ = sCrLfTabTabTab + XmlTags("digitalOrigin", "reformatted digital")
                            Exit Do
                        End If
                    Loop
                    Select Case Get008Value(23, 1)
                        Case " ", "r"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "print")
                        Case "a"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "microfilm")
                        Case "b"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "microfiche")
                        Case "f"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "braille")
                        Case "s"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "electronic")
                    End Select
                    sField$ = sTabTabTab + XmlTags("form" + sAuthority, "electronic")
                Case "F"
                    Select Case Get008Value(29, 1)
                        Case " ", "r"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "print")
                        Case "a"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "microfilm")
                        Case "b"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "microfiche")
                        Case "f"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "braille")
                        Case "s"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "electronic")
                    End Select
                Case "M"
                    Select Case Get008Value(23, 1)
                        Case " ", "r"
                            If InStr("cd", GetLeaderValue(6, 1)) > 0 Then
                                sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "print")
                            End If
                        Case "a"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "microfilm")
                        Case "b"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "microfiche")
                        Case "f"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "brialle")
                        Case "s"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "electronic")
                    End Select
                Case "P"
                    Select Case Get008Value(29, 1)
                        Case " ", "r"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "print")
                        Case "a"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "microfilm")
                        Case "b"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "microfiche")
                        Case "f"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "braille")
                        Case "s"
                            sField$ = sCrLfTabTabTab + XmlTags("form" + sAuthority, "electronic")
                    End Select
            End Select
            FldMoveTop
            Do While FldFindNext("24")
                If InStr("242 245 246", FldTag) > 0 Then
                    If SfdFindFirst("h") Then
                        sField$ = sField$ + sCrLfTabTabTab + XmlTags("form authority=" + AddQuotes("gmd"), XmlConditionText(SfdText))
                    End If
                End If
            Loop
            If bModsAquifer Then
                sField$ = sField$ + sCrLfTabTabTab + XmlTags("internetMediaType", "image")
                sField$ = sField$ + sCrLfTabTabTab + XmlTags("digitalOrigin", "reformatted digital")
            End If
            If FldFindFirst("256") Then
                If SfdFindFirst("a") Then
                    sField$ = sField$ + sCrLfTabTabTab + XmlTags("form", XmlConditionText(SfdText))
                End If
            End If
            FldMoveTop
            Do While FldFindNext("300")
                'Debug.Print "300 field: >" + FldTextFormatted(HexEquivalents)
                If SfdFindFirst("a") Then
                    sField$ = sField$ + sCrLfTabTabTab + XmlRecordOutOneLump("extent", 0, "abce", "", " ", False, True)
                ElseIf SfdFindFirst("b") Then
                    sField$ = sField$ + sCrLfTabTabTab + XmlRecordOutOneLump("extent", 0, "abce", "", " ", False, True)
                ElseIf SfdFindFirst("c") Then
                    sField$ = sField$ + sCrLfTabTabTab + XmlRecordOutOneLump("extent", 0, "abce", "", " ", False, True)
                ElseIf SfdFindFirst("e") Then
                    sField$ = sField$ + sCrLfTabTabTab + XmlRecordOutOneLump("extent", 0, "abce", "", " ", False, True)
                End If
            Loop
            FldMoveTop
            Do While FldFindNext("856")
                If SfdFindFirst("q") Then
                    sField$ = sField$ + sCrLfTabTabTab + XmlTags("internetMediaType", XmlConditionText(SfdText))
                End If
            Loop
            FldMoveTop
            Do While FldFindNext("007")
                If Mid(FldText, 1, 1) = "c" Then
                    Select Case Mid(FldText, 14, 1)
                        Case "a"
                            sField$ = sField$ + sCrLfTabTabTab + XmlTags("reformattingQuality", "access")
                        Case "p"
                            sField$ = sField$ + sCrLfTabTabTab + XmlTags("reformattingQuality", "preservation")
                        Case "r"
                            sField$ = sField$ + sCrLfTabTabTab + XmlTags("reformattingQuality", "replacement")
                    End Select
                End If
            Loop
            
            ' the undefined 300 $n is inserted into some MARC records during EAD conversion
            '   so we can create a "physical description note"
            FldMoveTop
            If FldFindFirst("300") Then
                If SfdFindFirst("n") Then
                    sPiece$ = SfdText
                    GetNextPiece sPiece$, sType$, "//"
                    If Len(sType$) > 0 And Len(sPiece$) > 0 Then
                        sField$ = sField$ + sCrLfTabTabTab + XmlTags("note type=" + AddQuotes(sType$), sPiece$)
                    End If
                End If
                If SfdFindFirst("d") Then
                    sPiece$ = SfdText
                    sField$ = sField$ + sCrLfTabTabTab + XmlTags("note displayLabel=" + AddQuotes("Physical facets"), sPiece$)
                End If
            End If
            
            If Len(sField$) > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("physicalDescription", sField$ + sCrlfTabTab)
            End If
            
            
            ' *********************************************
            ' abstract
            ' *********************************************
            FldMoveTop
            Do While FldFindNext("520")
                If SfdFindFirst("u") Then
                    sAuthority$ = " xlink:simplelink=" + AddQuotes(SfdText$)
                Else
                    sAuthority$ = ""
                End If
                SfdMoveTop
                sOut$ = sOut$ + sCrlfTabTab + XmlRecordOutOneLump("abstract" + sAuthority$, 0, "ab", "", " ")
            Loop
            
            ' *********************************************
            ' TOC
            ' *********************************************
            FldMoveTop
            Do While FldFindNext("505")
                If SfdFindFirst("u") Then
                    sAuthority$ = " xlink:simplelink=" + AddQuotes(SfdText$)
                Else
                    sAuthority$ = ""
                End If
                SfdMoveTop
                sOut$ = sOut$ + sCrlfTabTab + XmlRecordOutOneLump("tableOfContents" + sAuthority$, 0, "agrt", "", " ")
            Loop
            
            ' *********************************************
            ' target audience part 1
            ' *********************************************
            FldMoveTop
            Do While FldFindNext("521")
                sOut$ = sOut$ + sCrlfTabTab + XmlRecordOutOneLump("targetAudience", 0, "ab", "", " ")
            Loop
            ' target audience part 2
            If InStr("BDFM", MarcRecordFormat) > 0 Then
                Select Case Get008Value(22, 1)
                    Case "d"
                        sOut$ = sOut$ + sCrlfTabTab + XmlTags("targetAudience authority=" + AddQuotes("marctarget"), "adolescent")
                    Case "e"
                        sOut$ = sOut$ + sCrlfTabTab + XmlTags("targetAudience authority=" + AddQuotes("marctarget"), "adult")
                    Case "g"
                        sOut$ = sOut$ + sCrlfTabTab + XmlTags("targetAudience authority=" + AddQuotes("marctarget"), "general")
                    Case "b", "c", "j"
                        sOut$ = sOut$ + sCrlfTabTab + XmlTags("targetAudience authority=" + AddQuotes("marctarget"), "juvenile")
                    Case "a"
                        sOut$ = sOut$ + sCrlfTabTab + XmlTags("targetAudience authority=" + AddQuotes("marctarget"), "preschool")
                    Case "f"
                        sOut$ = sOut$ + sCrlfTabTab + XmlTags("targetAudience authority=" + AddQuotes("marctarget"), "specialized")
                End Select
            End If
            
            ' *********************************************
            ' notes
            ' *********************************************
            FldMoveTop
            Do While FldFindNext("5")
                ' include in this exception all of the 5XX tags whose texts
                '   are accounted for elsewhere; this is not entirely clear from
                '   the documentation
                If InStr("505 506 510 540 520 521 539", FldTag) = 0 Then
                    'Debug.Print "Note " + FldTag + " " + str(bModsAquifer) + " " + FldNorm
                    If bModsAquifer Then
                        If Mid(FldNorm, 1, 17) = "ALSO AVAILABLE AS" Then
                            GoTo XRO_AquiferNextNotField
                        End If
                    End If
                    If FldTag = "500" Then
                        sDisplayLabel$ = ""
                        lPtr = InStr(SfdText, vbTab)
                        If lPtr > 0 Then
                            sDisplayLabel$ = " displayLabel=" + AddQuotes(Mid(SfdText, lPtr + 1))
                            If Mid(sDisplayLabel$, 1, 1) = vbTab Then
                                sDisplayLabel$ = Mid(sDisplayLabel$, 2)
                            End If
                        End If
                        sOut$ = sOut$ + sCrlfTabTab$ + XmlRecordOutOneLump("note" + sDisplayLabel$, 0, "a", "", " ", bModsAquifer, True)
                    Else
                        If SfdFindFirst("u") Then
                            sAuthority$ = " xlink:simpleLink=" + AddQuotes(SfdText$)
                        Else
                            sAuthority$ = ""
                        End If
                        SfdMoveTop
                        ' todo: NOTE that the documentation only lists
                        '   these two as "e.g.", suggesting that there are yet other
                        '   types that may be defined
                        Select Case FldTag
                            Case "511"
                                sType$ = "performers"
                            Case "518"
                                sType$ = "venue"
                            Case Else
                                sType$ = ""
                        End Select
                        sOut$ = sOut$ + sCrlfTabTab$ + XmlRecordOutOneLump("note" + sAuthority$ + sType$, 0, "abcdefghijklmnopqrstvwxyz01234579", "", " ")
                    End If
                End If
XRO_AquiferNextNotField:
            Loop
            If FldFindFirst("245") Then
                If SfdFindFirst("c") Then
                    lPtr = InStr(SfdText, vbTab)
                    If lPtr > 0 Then
                        sDisplayLabel$ = " displayLabel=" + AddQuotes(Mid(SfdText, lPtr + 1))
                        If Mid(sDisplayLabel$, 1, 1) = vbTab Then
                            sDisplayLabel$ = Mid(sDisplayLabel$, 2)
                        End If
                        SfdText$ = Mid(SfdText$, 1, lPtr - 1)
                    Else
                        sDisplayLabel$ = ""
                    End If
                    sOut$ = sOut$ + sCrlfTabTab + "<note type=" + AddQuotes("statement of responsibility") + sDisplayLabel$ + ">" + XmlConditionText(SfdText) + "</note>"
                End If
            End If
            
            
            ' *********************************************
            ' the subject block
            ' *********************************************
            FldMoveTop
            Do While FldFindNext("6")
                sField$ = ""
                Select Case FldTag
                    Case "600", "610", "611", "630", "650", "651"
                        'Debug.Print "Sub Out: >" + FldTextFormatted(HexEquivalents) + "<"
                        Select Case Mid(FldInd, 2, 1)
                            Case "0"
                                sAuthority$ = "lcsh"
                            Case "1"
                                sAuthority$ = "lcshac"
                            Case "2"
                                sAuthority$ = "mesh"
                            Case "3"
                                sAuthority$ = "nal"
                            Case "5"
                                sAuthority$ = "csh"
                            Case "6"
                                sAuthority$ = "rvm"
                            Case "7"
                                If SfdFindFirst("2") Then
                                    sAuthority$ = XmlConditionText(SfdText)
                                Else
                                    sAuthority$ = ""
                                End If
                                SfdMoveTop
                            Case Else
                                sAuthority$ = ""
                        End Select
                    Case "653"
                        sAuthority = ""
                    Case Else
                        sAuthority$ = ""
                End Select
                If Len(sAuthority$) > 0 Then
                    sAuthority$ = " authority=" + AddQuotes(sAuthority$)
                End If
                sField$ = ""
                Select Case FldTag
                    Case "600"
                        sField$ = XmlRecordOutOneLump("namePart", 0, "aq", "", " ")
                        SfdMoveTop
                        If SfdFindFirst("b") Then
XmlRecordOut600b:           ' NOTE label in left margin
                            sField$ = sField$ + XmlRecordOutOneLump("namePart type=" + AddQuotes("termsOfAddress"), 0, "bc", "")
                        ElseIf SfdFindFirst("c") Then
                            GoTo XmlRecordOut600b
                        End If
                        'sField$ = sField$ + XmlRecordOutOneLump("termsOfAddress", 0, "bc", "", " ")
                        If SfdFindFirst("d") Then
                            sField$ = sField$ + XmlRecordOutOneLump("namePart type=" + AddQuotes("date"), 0, "d", "", " ")
                        End If
                        If SfdFindFirst("e") Then
                            sField$ = sField$ + XmlRecordOutOneLump("role type=" + AddQuotes("text"), 0, "e", "", " ")
                        End If
                        If SfdFindFirst("4") Then
                            sField$ = sField$ + XmlRecordOutOneLump("role type=" + AddQuotes("code"), 0, "4", "", " ")
                        End If
                        If SfdFindFirst("u") Then
                            sField$ = sField$ + XmlRecordOutOneLump("affiliation", 0, "u", "", " ")
                        End If
                        If Len(sField$) > 0 Then
                            sField$ = "<name type=" + AddQuotes("personal") + ">" + sField$ + "</name>"
                        End If
                        SfdMoveTop
                        Do While SfdMoveNext
                            Select Case SfdCode
                                Case "v"
                                    sField$ = sField$ + XmlRecordOutOneLump("genre", 0, SfdCode, "vxyz", " ")
                                Case "x"
                                    sField$ = sField$ + XmlRecordOutOneLump("topic", 0, SfdCode, "vxyz", " ")
                                Case "y"
                                    sField$ = sField$ + XmlRecordOutOneLump("temporal", 0, SfdCode, "vxyz", " ")
                                Case "z"
                                    sField$ = sField$ + XmlRecordOutOneLump("geographic", 0, SfdCode, "vxyz", " ")
                            End Select
                        Loop
                        
                    Case "610"
                        sField$ = XmlRecordOutOneLump("namePart", 0, "a", "", " ")
                        SfdMoveTop
                        Do While SfdFindNext("b")
                            sField$ = sField$ + XmlRecordOutOneLump("namePart", 0, "b", "b", " ")
                        Loop
                        SfdMoveTop
                        sField$ = sField$ + XmlRecordOutOneLump("namePart", 0, "cdnp", "", " ")
                        If SfdFindFirst("e") Then
                            sField$ = sField$ + XmlRecordOutOneLump("role type=" + AddQuotes("text"), 0, "e", "", " ")
                        End If
                        If SfdFindFirst("4") Then
                            sField$ = sField$ + XmlRecordOutOneLump("role type=" + AddQuotes("code"), 0, "4", "", " ")
                        End If
                        If Len(sField$) > 0 Then
                            sField$ = "<name type=" + AddQuotes("corporate") + ">" + sField$ + "</name>"
                        End If
                        SfdMoveTop
                        Do While SfdMoveNext
                            Select Case SfdCode
                                Case "v"
                                    sField$ = sField$ + XmlRecordOutOneLump("genre", 0, SfdCode, "vxyz", " ")
                                Case "x"
                                    sField$ = sField$ + XmlRecordOutOneLump("topic", 0, SfdCode, "vxyz", " ")
                                Case "y"
                                    sField$ = sField$ + XmlRecordOutOneLump("temporal", 0, SfdCode, "vxyz", " ")
                                Case "z"
                                    sField$ = sField$ + XmlRecordOutOneLump("geographic", 0, SfdCode, "vxyz", " ")
                            End Select
                        Loop
                    Case "611"
                        sField$ = XmlRecordOutOneLump("namePart", 0, "ancdeqp", "", " ")
                        If SfdFindFirst("4") Then
                            sField$ = sField$ + XmlRecordOutOneLump("role type=" + AddQuotes("code"), 0, "4", "", " ")
                        End If
                        If Len(sField$) > 0 Then
                            sField$ = "<name type=" + AddQuotes("conference") + ">" + sField$ + "</name>"
                        End If
                        SfdMoveTop
                        Do While SfdMoveNext
                            Select Case SfdCode
                                Case "v"
                                    sField$ = sField$ + XmlRecordOutOneLump("genre", 0, SfdCode, "vxyz", " ")
                                Case "x"
                                    sField$ = sField$ + XmlRecordOutOneLump("topic", 0, SfdCode, "vxyz", " ")
                                Case "y"
                                    sField$ = sField$ + XmlRecordOutOneLump("temporal", 0, SfdCode, "vxyz", " ")
                                Case "z"
                                    sField$ = sField$ + XmlRecordOutOneLump("geographic", 0, SfdCode, "vxyz", " ")
                            End Select
                        Loop
                    Case "630"
                        sField$ = "<titleInfo>" + XmlRecordOutOneLump("title", 0, "adfhklor", "np", " ") + "</titleInfo>"
                        SfdMoveTop
                        Do While SfdMoveNext
                            Select Case SfdCode
                                Case "n"
                                    sField$ = sField$ + XmlRecordOutOneLump("partNumber", 0, "ndfhklmor", "np")
                                Case "p"
                                    sField$ = sField$ + XmlRecordOutOneLump("partName", 0, "pdfhklmor", "np")
                            End Select
                        Loop
                        If SfdFindFirst("4") Then
                            sField$ = sField$ + XmlRecordOutOneLump("role type=" + AddQuotes("code"), 0, "4", "", " ")
                        End If
                        SfdMoveTop
                        Do While SfdMoveNext
                            Select Case SfdCode
                                Case "v"
                                    sField$ = sField$ + XmlRecordOutOneLump("genre", 0, SfdCode, "vxyz", " ")
                                Case "x"
                                    sField$ = sField$ + XmlRecordOutOneLump("topic", 0, SfdCode, "vxyz", " ")
                                Case "y"
                                    sField$ = sField$ + XmlRecordOutOneLump("temporal", 0, SfdCode, "vxyz", " ")
                                Case "z"
                                    sField$ = sField$ + XmlRecordOutOneLump("geographic", 0, SfdCode, "vxyz", " ")
                            End Select
                        Loop
                    Case "650"
                        sField$ = XmlRecordOutOneLump("topic", 0, "abcd", "", " ")
                        SfdMoveTop
                        Do While SfdMoveNext
                            sSfc$ = SfdCode
                            Select Case SfdCode
                                Case "v"
                                    sField$ = sField$ + XmlRecordOutOneLump("genre", 0, SfdCode, "vxyz", " ")
                                Case "x"
                                    sField$ = sField$ + XmlRecordOutOneLump("topic", 0, SfdCode, "vxyz", " ")
                                Case "y"
                                    sField$ = sField$ + XmlRecordOutOneLump("temporal", 0, SfdCode, "vxyz", " ")
                                Case "z"
                                    sField$ = sField$ + XmlRecordOutOneLump("geographic", 0, SfdCode, "vxyz", " ")
                            End Select
                        Loop
                    Case "651"
                        If SfdFindFirst("a") Then
                            sField$ = sField$ + "<geographic>" + XmlConditionText(SfdText) + "</geographic>"
                        End If
                        SfdMoveTop
                        Do While SfdMoveNext
                            Select Case SfdCode
                                Case "v"
                                    sField$ = sField$ + XmlRecordOutOneLump("genre", 0, SfdCode, "vxyz", " ")
                                Case "x"
                                    sField$ = sField$ + XmlRecordOutOneLump("topic", 0, SfdCode, "vxyz", " ")
                                Case "y"
                                    sField$ = sField$ + XmlRecordOutOneLump("temporal", 0, SfdCode, "vxyz", " ")
                                Case "z"
                                    sField$ = sField$ + XmlRecordOutOneLump("geographic", 0, SfdCode, "vxyz", " ")
                            End Select
                        Loop
                    Case "653"
                        SfdMoveTop
                        Do While SfdFindNext("a")
                            sField$ = sField$ + "<topic>" + XmlConditionText(SfdText) + "</topic>"
                        Loop
                End Select
                If Len(sField$) > 0 Then
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("subject" + sAuthority$, sField$)
                End If
            Loop
            ' other "subject" fields
            If FldFindFirst("045") Then
                Select Case Mid(FldInd, 1, 1)
                    Case "0", "1"
                        SfdMoveTop
                        Do While SfdFindNext("b")
                            sOut$ = sOut$ + sCrlfTabTab$ + XmlTags("subject", XmlTags("temporal encoding=" + AddQuotes("iso8601"), XmlConditionText(SfdText)))
                            If Mid(FldInd, 1, 1) = "0" Then ' redundant with test for multiple $b, but what-the-heck
                                Exit Do
                            End If
                        Loop
                    Case "2"
                        If SfdFindFirst("b") Then
                            sOut$ = sOut$ + sCrlfTabTab$ + XmlTags("subject", XmlTags("temporal encoding=" + AddQuotes("iso8601") + " point=" + AddQuotes("start"), XmlConditionText(SfdText)))
                            If SfdFindNext("b") Then
                                sOut$ = sOut$ + sCrlfTabTab$ + XmlTags("subject", XmlTags("temporal encoding=" + AddQuotes("iso8601") + " point=" + AddQuotes("end"), XmlConditionText(SfdText)))
                            End If
                        End If
                End Select
            End If
            If FldFindFirst("043") Then
                SfdMoveTop
                Do While SfdMoveNext
                    Select Case SfdCode
                        Case "a"
                            sOut$ = sOut$ + sCrlfTabTab + XmlTags("subject", XmlTags("geographicCode authority=" + AddQuotes("marcgac"), XmlConditionText(SfdText)))
                        Case "c"
                            sOut$ = sOut$ + sCrlfTabTab + XmlTags("subject", XmlTags("geographicCode authority=" + AddQuotes("iso3166"), XmlConditionText(SfdText)))
                    End Select
                Loop
            End If
            FldMoveTop
            Do While FldFindNext("752")
                SfdMoveTop
                sField$ = ""
                Do While SfdMoveNext
                    Select Case SfdCode
                        Case "a"
                            sField$ = sField$ + XmlTags("country", XmlConditionText(SfdText))
                        Case "b"
                            sField$ = sField$ + XmlTags("state", XmlConditionText(SfdText))
                        Case "c"
                            sField$ = sField$ + XmlTags("county", XmlConditionText(SfdText))
                        Case "d"
                            sField$ = sField$ + XmlTags("city", XmlConditionText(SfdText))
                    End Select
                Loop
                If Len(sField$) > 0 Then
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("subject", XmlTags("hierarchicalGeographic", sField$))
                End If
            Loop
            sField$ = ""
            FldMoveTop
            Do While FldFindNext("034")
                sField$ = XmlRecordOutOneLump("coordinates", 0, "defg", "", " ")
                If Len(sField$) > 0 Then
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("subject", XmlTags("cartographics", sField$))
                End If
            Loop
            FldMoveTop
            Do While FldFindNext("255")
                SfdMoveTop
                Do While SfdMoveNext
                    Select Case SfdCode
                        Case "a"
                            sOut$ = sOut$ + sCrlfTabTab + XmlTags("subject", XmlTags("cartographics", XmlTags("scale", XmlConditionText(SfdText)) + XmlTags("coordinates", "")))
                        Case "b"
                            sOut$ = sOut$ + sCrlfTabTab + XmlTags("subject", XmlTags("cartographics", XmlTags("projection>", XmlConditionText(SfdText))))
                        Case "c"
                            sOut$ = sOut$ + sCrlfTabTab + XmlTags("subject", XmlTags("cartographics", XmlTags("coordinates", XmlConditionText(SfdText))))
                    End Select
                Loop
            Loop
            FldMoveTop
            Do While FldFindNext("656")
                If FldFindFirst("a") Then
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("subject", XmlTags("occupation", XmlConditionText(SfdText)))
                End If
            Loop
            
            
            ' *********************************************
            ' the classification group
            ' *********************************************
            FldMoveTop
            Do While FldFindNext("0")
                sField$ = ""
                Select Case FldTag
                    Case "050"
                        sField$ = XmlRecordOutOneLump("classification authority=" + AddQuotes("lcc"), 0, "ab", "", " ")
                    Case "082"
                        If SfdFindFirst("2") Then
                            sAuthority$ = " edition=" + AddQuotes(SfdText$)
                        Else
                            sAuthority$ = ""
                        End If
                        SfdMoveTop
                        sField$ = XmlRecordOutOneLump("classification authority=" + AddQuotes("ddc") + sAuthority$, 0, "ab", "", " ")
                    Case "080"
                        sField$ = XmlRecordOutOneLump("classification authority=" + AddQuotes("udc"), 0, "abx", "", " ")
                    Case "060"
                        sField$ = XmlRecordOutOneLump("classification authority=" + AddQuotes("nlm"), 0, "ab", "", " ")
                    Case "086"
                        Select Case Mid(FldInd, 1, 1)
                            Case "0"
                                sField$ = XmlRecordOutOneLump("classification authority=" + AddQuotes("sudocs"), 0, "ab", "", " ")
                            Case "1"
                                sField$ = XmlRecordOutOneLump("classification authority=" + AddQuotes("candocs"), 0, "ab", "", " ")
                            Case Else
                                If SfdFindFirst("2") Then
                                    sAuthority$ = XmlConditionText(SfdText)
                                    SfdMoveTop
                                    sField$ = XmlRecordOutOneLump("classification authority=" + AddQuotes(sAuthority$), 0, "a", "", " ")
                                End If
                        End Select
                    Case "084"
                        If SfdFindFirst("2") Then
                            sAuthority$ = XmlConditionText(SfdText)
                            SfdMoveTop
                            sField$ = XmlRecordOutOneLump("classification authority=" + AddQuotes(sAuthority$), 0, "ab", "", " ")
                        End If
                End Select
                If Len(sField$) > 0 Then
                    sOut$ = sOut$ + sCrlfTabTab + sField$
                End If
            Loop
            
            
            ' *********************************************
            ' the related item group (relatedItem)
            ' *********************************************
            FldMoveTop
            sField$ = ""
            Do While FldMoveNext
                
                iFieldPtr2% = FldPointer
                
                sType$ = ""
                sDisplayLabel$ = ""
                sDisplayLabel2$ = ""
                iTAt% = 0
                sAuthority$ = ""
                
                ' initial selection by tag; and assign the type attribute
                Select Case FldTag
                    Case "510"
                        sType$ = " type=" + AddQuotes("isReferencedBy")
                    Case "440"
                        sType$ = " type=" + AddQuotes("series")
                    Case "490"
                        If Mid(FldInd, 1, 1) <> "0" Then
                            GoTo XmlRecordOutNextRelatedItemField
                        End If
                        sType$ = " type=" + AddQuotes("series")
                    Case "534"
                        sType$ = " type=" + AddQuotes("original")
                    Case "700", "710", "711"
                        If Not SfdFindFirst("t") Then
                            GoTo XmlRecordOutNextRelatedItemField
                        End If
                        iTAt% = SfdPointer
                        sType$ = " type=" + AddQuotes("constituent")
                        sAuthority$ = "naf"
                    Case "730"
                        If Mid(FldInd, 2, 1) <> "2" Then
                            GoTo XmlRecordOutNextRelatedItemField
                        End If
                        sAuthority$ = "naf"
                        sType$ = " type=" + AddQuotes("constituent")
                    Case "740"
                        If Mid(FldInd, 2, 1) <> "2" Then
                            GoTo XmlRecordOutNextRelatedItemField
                        End If
                        sType$ = " type=" + AddQuotes("constituent")
                    Case "760" To "787"
                        Select Case FldTag
                            Case "760", "762"
                                sType$ = " type=" + AddQuotes("series")
                            Case "770"
                                sType$ = " type=" + AddQuotes("constituent")
                            Case "772", "773"
                                sType$ = " type=" + AddQuotes("host")
                            Case "774"
                                sType$ = " type=" + AddQuotes("constituent")
                            Case "775"
                                ' reference to ind2 in documentation unclear
                                sType$ = " type=" + AddQuotes("otherVersion")
                            Case "776"
                                sType$ = " type=" + AddQuotes("otherFormat")
                            Case "780"
                                sType$ = " type=" + AddQuotes("preceding")
                            Case "785"
                                sType$ = " type=" + AddQuotes("succeeding")
                            Case "786"
                                sType$ = " type=" + AddQuotes("original")
                        End Select
                    Case "800" To "830"
                        sType$ = " type=" + AddQuotes("series")
                        If FldTag <> "830" Then
                            SfdFindFirst ("t")
                            iTAt% = SfdPointer
                        End If
                        sAuthority$ = "naf"
                    Case "856"
                        ' it's not entirely certain what this is doing in this group!
                        If Mid(FldInd, 2, 1) = "2" Then
                            If SfdFindFirst("q") Then
                                sField$ = "<internetMediaType>" + XmlConditionText(SfdText) + "</internetMediaType>"
                                GoTo XmlRecordOutOneRelatedItemFieldAssembled
                            End If
                        End If
                        GoTo XmlRecordOutNextRelatedItemField
                    Case Else
                        GoTo XmlRecordOutNextRelatedItemField
                End Select
                
                ' assign any displayLabel attribute
                Select Case FldTag
                    Case "773"
                        If SfdFindFirst("3") Then
XmlRecordOut_773:           ' NOTE label in left margin
                            sDisplayLabel = " displayLabel=" + AddQuotes(SfdText)
                        ElseIf SfdFindFirst("i") Then
                            GoTo XmlRecordOut_773
                        ElseIf SfdFindFirst("t") Then
                            iRc% = InStr(SfdText, vbTab)
                            If iRc% > 0 Then
                                SfdText = Mid(SfdText, 1, iRc% - 1)
                            End If
                        End If
                    Case "760", "762", "765", "767", "770", "772", "774", "775", "776", "777", "780", "785", "786", "787"
                        If SfdFindFirst("i") Then
                            sDisplayLabel = " displayLabel=" + AddQuotes(SfdText)
                        End If
                End Select
                
                'Debug.Print "Display label for " + FldTag + "? >" + sDisplayLabel$ + "<"
                ' now assemble the actual contents
                Select Case FldTag
                    Case "440"
                        ' handling of nonfiling is not clear
                        If SfdFindFirst("v") Then
                            sV$ = XmlRecordOutOneLump("partNumber", 0, "v", "avx", " ")
                        Else
                            sV$ = ""
                        End If
                        SfdMoveFirst
                        sOut$ = sOut$ + sCrlfTabTab + "<relatedItem " + sType$ + "><titleInfo>" + XmlRecordOutOneLump("title", 0, "a", "avx", " ") + sV$ + "</titleInfo></relatedItem>"
                    Case "490"
                        SfdMoveTop
                        sField$ = ""
                        Do While SfdMoveNext
                            ' output each $a as a separate unit
                            Select Case SfdCode
                                Case "a"
                                    If Len(sField$) > 0 Then
                                        sOut$ = sOut$ + sCrlfTabTab + "<relatedItem>" + sField$ + "</relatedItem>"
                                        sField$ = ""
                                    End If
                                    sField$ = XmlRecordOutOneLump("title", 0, "a", "av", " ")
                                Case "v"
                                    sV$ = XmlRecordOutOneLump("partNumber", 0, "v", "a", " ")
                                    If Len(sField$) > 0 Then
                                        sOut$ = sOut$ + sCrlfTabTab + "<relatedItem><titleInfo>" + sField$ + sV$ + "</titleInfo></relatedItem>"
                                        sField$ = ""
                                    End If
                            End Select
                        Loop
                        If Len(sField$) > 0 Then
                            sOut$ = sOut$ + sCrlfTabTab + "<relatedItem " + sType$ + "><titleInfo>" + sField$ + "</titleInfo></relatedItem>"
                            sField$ = ""
                        End If
                    Case "534"
                        If SfdFindFirst("t") Then
                            sField$ = XmlRecordOutOneLump("title", 0, "t", "", " ")
                            If SfdFindNext("v") Then
                                sField$ = sField$ + XmlRecordOutOneLump("partNumber", 0, "v", "", " ")
                            End If
                        End If
                        If SfdFindFirst("a") Then
                            sField$ = sField$ + XmlRecordOutOneLump("name", 0, "a", "", " ")
                        End If
                        If SfdFindFirst("c") Then
                            sElement$ = XmlRecordOutOneLump("publisher", 0, "c", "", " ")
                        Else
                            sElement$ = ""
                        End If
                        If SfdFindFirst("b") Then
                            sElement$ = sElement$ + XmlRecordOutOneLump("edition", 0, "b", "", " ")
                        End If
                        If Len(sElement$) > 0 Then
                            sField$ = sField$ + "<originInfo>" + sElement$ + "</originInfo>"
                            sElement$ = ""
                        End If
                        If SfdFindFirst("x") Then
                            sField$ = sField$ + XmlRecordOutOneLump("identifier type=" + AddQuotes("issn"), 0, "v", "", " ")
                        End If
                        If SfdFindFirst("z") Then
                            sField$ = sField$ + XmlRecordOutOneLump("identifier type=" + AddQuotes("isbn"), 0, "z", "", " ")
                        End If
                    Case "700", "800"
                        ' we already know that it contains $t
                        If FldTag = "800" Then
                            If SfdFindFirst("v") Then
                                sV$ = XmlRecordOutOneLump("partNumber", 0, "v", "abcdefghijklmnopqrstuvwxyz", " ")
                            End If
                            SfdMoveTop
                        Else
                            sV$ = ""
                        End If
                        
                        
                        SfdFindFirst "t"
                        sTitle$ = XmlRecordOutOneLump("title", 0, "tgfklmors", "", " ") + sV$
                        SfdFindFirst "t"
                        Do While SfdMoveNext
                            Select Case SfdCode
                                Case "n"
                                    sTitle$ = sTitle$ + XmlRecordOutOneLump("partNumber", 0, "n", "abcdefghijklmnopqrstuvwxyz", " ")
                                Case "p"
                                    sTitle$ = sTitle$ + XmlRecordOutOneLump("partNumber", 0, "p", "abcdefghijklmnopqrstuvwxyz", " ")
                            End Select
                        Loop
                        If Len(sTitle$) > 0 Then
                            sTitle$ = "<titleInfo>" + sTitle$ + "</titleInfo>"
                        End If
                        
                        If SfdFindFirst("e") Then
                            sRole$ = SfdText$
                        Else
                            sRole$ = "Contributor"
                        End If
                        
                        sField$ = ""
                        SfdMoveTop
                        XmlModsAssembleNamePersonal sField$, sRole$, "personal", sCrlfTabTab$, sAuthority$
                        
                        sField$ = sTitle$ + sField$
                    
                    Case "710", "810"
                        ' we already know that it contains $t
                        'If Len(sAuthority$) > 0 Then
                        '    Debug.Print "7XX authority B: >" + sAuthority$ + "<"
                        'End If
                        If FldTag = "810" Then
                            If SfdFindFirst("v") Then
                                sV$ = XmlRecordOutOneLump("partNumber", 0, "v", "abcdefghijklmnopqrstuvwxyz", " ")
                            End If
                        Else
                            sV$ = ""
                        End If
                        
                        SfdFindFirst "t"
                        sTitle$ = XmlRecordOutOneLump("title", 0, "tgfklmors", "", " ") + sV$
                        SfdFindFirst "t"
                        Do While SfdMoveNext
                            Select Case SfdCode
                                Case "n"
                                    sTitle$ = sTitle$ + XmlRecordOutOneLump("partNumber", 0, "n", "abcdefghijklmnopqrstuvwxyz", " ")
                                Case "p"
                                    sTitle$ = sTitle$ + XmlRecordOutOneLump("partNumber", 0, "p", "abcdefghijklmnopqrstuvwxyz", " ")
                            End Select
                        Loop
                        If Len(sTitle$) > 0 Then
                            sTitle$ = "<titleInfo>" + sTitle$ + "</titleInfo>"
                        End If
                        
                        sRole$ = ""
                        If SfdFindFirst("e") Then
                            sRole$ = SfdText$
                        End If
                        If SfdFindFirst("4") Then
                            sRole$ = SfdText$
                        End If
                        
                        sField$ = ""
                        SfdMoveTop
                        XmlModsAssembleNameCorporate sField$, sRole$, "corporate", sCrlfTabTab$, sAuthority$
                        
                        sField$ = sTitle$ + sField$
                        
                        'If Len(sAuthority$) > 0 Then
                        '    Debug.Print "7XX authority D: >" + sAuthority$ + "<"
                        'End If
                        
                    Case "711", "811"
                        ' we already know that it contains $t
                        If FldTag = "811" Then
                            If SfdFindFirst("v") Then
                                sV$ = XmlRecordOutOneLump("partNumber", 0, "v", "abcdefghijklmnopqrstuvwxyz", " ")
                            End If
                        Else
                            sV$ = ""
                        End If
                        
                        SfdFindFirst ("t")
                        sTitle$ = XmlRecordOutOneLump("title", 0, "tgfklsv", "", " ") + sV$
                        SfdFindFirst "t"
                        Do While SfdMoveNext
                            Select Case SfdCode
                                Case "n"
                                    sTitle$ = sTitle$ + XmlRecordOutOneLump("partNumber", 0, "n", "abcdefghijklmnopqrstuvwxyz", " ")
                                Case "p"
                                    sTitle$ = sTitle$ + XmlRecordOutOneLump("partNumber", 0, "p", "abcdefghijklmnopqrstuvwxyz", " ")
                            End Select
                        Loop
                    
                        If SfdFindFirst("4") Then
                            sRole$ = SfdText
                        End If
                        
                        SfdMoveTop
                        sField$ = ""
                        XmlModsAssembleNameConference sField$, sRole$, "conference", sCrlfTabTab$, sAuthority$
                        
                        sField$ = sTitle$ + sField$
                    
                    Case "730"
                        ' handling of nonfiling is not clear
                        sV$ = ""
                        sField$ = XmlRecordOutOneLump("title", 0, "adfgklmors", "", " ") + sV$
                        SfdFindFirst "a"
                        Do While SfdMoveNext
                            Select Case SfdCode
                                Case "n"
                                    sField$ = sField$ + XmlRecordOutOneLump("partNumber", 0, "n", "abcdefghijklmnopqrstuvwxyz", " ")
                                Case "p"
                                    sField$ = sField$ + XmlRecordOutOneLump("partNumber", 0, "p", "abcdefghijklmnopqrstuvwxyz", " ")
                            End Select
                        Loop
                        If SfdFindFirst("h") Then
                            sField$ = sField$ + "<physicalDescription><form>" + XmlConditionText(SfdText) + "</form></physicalDescription>"
                        End If
                        If SfdFindFirst("x") Then
                            sField$ = sField$ + XmlRecordOutOneLump("identifier type=" + AddQuotes("issn"), 0, "v", "", " ")
                        End If
                    
                    Case "830"
                        ' handling of nonfiling is not clear
                        ' 20080418: created from a clause that combined with 730 so we could
                        '   do the related item stuff
                        ' isolate the series numbering
                        If SfdFindFirst("v") Then
                            sV$ = XmlRecordOutOneLump("partNumber", 0, "v", "abcdefghijklmnopqrstuvwxyz", " ")
                        End If
                        SfdMoveTop
                        sField$ = XmlRecordOutOneLump("title", 0, "adfgklmors", "", " ") + sV$
                        SfdFindFirst "a"
                        Do While SfdMoveNext
                            Select Case SfdCode
                                Case "n"
                                    sField$ = sField$ + XmlRecordOutOneLump("partNumber", 0, "n", "abcdefghijklmnopqrstuvwxyz", " ")
                                Case "p"
                                    sField$ = sField$ + XmlRecordOutOneLump("partNumber", 0, "p", "abcdefghijklmnopqrstuvwxyz", " ")
                            End Select
                        Loop
                        If SfdFindFirst("h") Then
                            sField$ = sField$ + "<physicalDescription><form>" + XmlConditionText(SfdText) + "</form></physicalDescription>"
                        End If
                        If SfdFindFirst("x") Then
                            sField$ = sField$ + XmlRecordOutOneLump("identifier type=" + AddQuotes("issn"), 0, "v", "", " ")
                        End If
                        ' here's the part that's really different for the 830: it's titleinfo within relateditem
                        If Len(sField$) > 0 Then
                            sOut$ = sOut$ + sCrlfTabTab + "<relatedItem " + sType$ + "><titleInfo>" + sField$ + "</titleInfo></relatedItem>"
                            sField$ = ""
                        End If
                        
                    Case "740"
                    
#If False Then
                        ' handling of nonfiling is not clear
                        sField$ = XmlRecordOutOneLump("title", 0, "a", "", " ")
                        SfdFindFirst "a"
                        Do While SfdMoveNext
                            Select Case SfdCode
                                Case "n"
                                    sField$ = sField$ + XmlRecordOutOneLump("partNumber", 0, "n", "abcdefghijklmnopqrstuvwxyz", " ")
                                Case "p"
                                    sField$ = sField$ + XmlRecordOutOneLump("partNumber", 0, "p", "abcdefghijklmnopqrstuvwxyz", " ")
                            End Select
                        Loop
                        If SfdFindFirst("h") Then
                            sField$ = sField$ + "<physicalDescription><form>" + XmlConditionText(SfdText) + "</form></physicalDescription>"
                        End If
#End If
                        
                        sTitle$ = XmlRecordOutOneLump("title", 0, "a", "", " ")
                        SfdFindFirst "a"
                        Do While SfdMoveNext
                            Select Case SfdCode
                                Case "n"
                                    sTitle$ = sTitle$ + XmlRecordOutOneLump("partNumber", 0, "n", "abcdefghijklmnopqrstuvwxyz", " ")
                                Case "p"
                                    sTitle$ = sTitle$ + XmlRecordOutOneLump("partNumber", 0, "p", "abcdefghijklmnopqrstuvwxyz", " ")
                            End Select
                        Loop
                        If SfdFindFirst("h") Then
                            sTitle$ = sTitle$ + "<physicalDescription><form>" + XmlConditionText(SfdText) + "</form></physicalDescription>"
                        End If
                        If Len(sTitle$) > 0 Then
                            sField$ = sField$ + "<titleInfo>" + sTitle$ + "</titleInfo>"
                        End If
                        
                    Case "760", "762", "765", "767", "770", "772", "773", "774", "775", "776", "777", "780", "785", "786", "787"
                    
                        ' all kinds of related thingies
                        
                        'Debug.Print "Raw rel field: " + FldTextFormatted(HexEquivalents)
                        If SfdFindFirst("a") Then
                            sField$ = "<name>" + XmlRecordOutOneLump("namePart", 0, "a", "", " ") + "<role><roleTerm type=" + AddQuotes("text") + ">creator</roleTerm>" + "</role></name>"
                        Else
                            sField$ = ""
                        End If
                        
                        bGHandled = False
                        sTitle$ = ""
                        If SfdFindFirst("t") Then
                            sTitle$ = XmlRecordOutOneLump("title", 0, "t", "", " ")
                        End If
                        
                        If SfdFindNext("v") Then
                            sTitle$ = sTitle$ + XmlRecordOutOneLump("partNumber", 0, "v", "", " ")
                        End If
                        If SfdFindFirst("p") Then
                            sTitle$ = sTitle$ + XmlRecordOutOneLump("title" + AddQuotes("abbreviated"), 0, "p", "", " ")
                            If SfdFindNext("g") Then
                                bGHandled = True
                                sTitle$ = sTitle$ + XmlRecordOutOneLump("partNumber", 0, "g", "", " ")
                            End If
                            sTitle$ = "<titleInfo type=" + AddQuotes("abbreviated") + ">" + sTitle$ + "</titleInfo>"
                        End If
                        If SfdFindFirst("s") Then
                            sTitle$ = sTitle$ + XmlRecordOutOneLump("title", 0, "s", "", " ")
                            If SfdFindNext("g") Then
                                bGHandled = True
                                sTitle$ = sTitle$ + XmlRecordOutOneLump("partNumber", 0, "g", "", " ")
                            End If
                            sTitle$ = "<titleInfo type=" + AddQuotes("abbreviated") + ">" + sTitle$ + "</titleInfo>"
                        End If
                        If Not bGHandled Then
                            'Debug.Print "Not g yet"
                            If SfdFindFirst("g") Then
                                'Debug.Print "$g present"
                                sTitle$ = sTitle$ + XmlRecordOutOneLump("partNumber", 0, "g", "", " ")
                            End If
                        End If
                        
                        
                        sField$ = sField$ + "<titleInfo " + sDisplayLabel2$ + ">" + sTitle$ + "</titleInfo>"
                        
                        ' the originInfo embedded element
                        sElement$ = ""
                        Select Case FldTag
                            Case "775"
                                If SfdFindFirst("f") Then
                                    sElement$ = XmlRecordOutOneLump("place><placeTerm type=" + AddQuotes("code"), 0, "f", "", " ")
                                End If
                        End Select
                        If SfdFindFirst("d") Then
                            sElement$ = sElement$ + XmlRecordOutOneLump("publisher", 0, "d", "", " ")
                        End If
                        If SfdFindFirst("b") Then
                            sElement$ = sElement$ + XmlRecordOutOneLump("edition", 0, "b", "", " ")
                        End If
                        If Len(sElement$) > 0 Then
                            sField$ = sField$ + "<originInfo>" + sElement$ + "</originInfo>"
                            sElement$ = ""
                        End If
                        
                        ' the language subelement
                        If FldTag = "775" Then
                            If SfdFindFirst("e") Then
                                sField$ = sField$ + "<language><languageTerm type=" + AddQuotes("code") + " authority=" + AddQuotes("iso639-2b") + ">" + XmlConditionText(SfdText) + "</languageTerm></language>"
                            End If
                        End If
                        
                        ' the physical description subelement
                        If SfdFindFirst("h") Then
                            sField$ = sField$ + "<physicalDescription><extent>" + XmlConditionText(SfdText) + "</extent></physicalDescription>"
                        End If
                        
                        If FldTag = "786" And SfdFindFirst("j") Then
                            sField$ = sField$ + "<subject><temporal encoding=" + AddQuotes("iso8601") + ">" + XmlConditionText(SfdText) + "</temporal></subject>"
                        End If
                        
                        If SfdFindFirst("n") Then
                            sField$ = sField$ + "<note>" + XmlConditionText(SfdText) + "</note>"
                        End If
                        
                        If FldTag = "760" And SfdFindFirst("o") Then
                            sField$ = sField$ + XmlRecordOutOneLump("identifier", 0, "o", "", " ")
                        End If
                        
                        If SfdFindFirst("x") Then
                            sField$ = sField$ + XmlRecordOutOneLump("identifier type=" + AddQuotes("issn"), 0, "v", "", " ")
                        End If
                        
                        If SfdFindFirst("z") Then
                            sField$ = sField$ + XmlRecordOutOneLump("identifier type=" + AddQuotes("isbn"), 0, "z", "", " ")
                        End If
                        If SfdFindFirst("w") Then
                            If Len(Nuc) > 0 Then
                                If InStr(SfdText, Nuc) > 0 Then
                                    sField$ = sField$ + XmlRecordOutOneLump("identifier type=" + AddQuotes("local"), 0, "w", "", " ")
                                End If
                            End If
                        End If
                        
                        If FldTag = "773" Then
                        
                            If SfdFindFirst("9") Then ' URL of the host item
                                sHostUrl$ = SfdText
                                If Mid(SfdText, 1, 3) = "doi" Then
                                    sField$ = sField$ + sCrlfTabTab + "<identifier type=" + AddQuotes("doi") + ">" + Mid(SfdText, 4) + "</identifier>"
                                ElseIf Mid(SfdText, 1, 3) = "hdl" Then
                                    sField$ = sField$ + "<identifier type=" + AddQuotes("hdl") + ">" + Mid(SfdText, 4) + "</identifier>"
                                ElseIf Mid(SfdText, 1, 7) = "urn:doi" Then
                                    sField$ = sField$ + "<identifier type=" + AddQuotes("doi") + ">" + Mid(SfdText, 8) + "</identifier>"
                                ElseIf Mid(SfdText, 1, 7) = "urn:hdl" Then
                                    sField$ = sField$ + "<identifier type=" + AddQuotes("hdl") + ">" + Mid(SfdText, 8) + "</identifier>"
                                Else
                                    sField$ = sField$ + "<identifier type=" + AddQuotes("unknown") + ">" + SfdText + "</identifier>"
                                End If
                            End If
                            If SfdFindFirst("g") Then
                                sField$ = sField$ + XmlRecordOutOneLump("part><text", 0, "g", "", " ")
                            End If
                            If SfdFindFirst("q") Then
                                sElement$ = ""
                                sWhole$ = XmlConditionText(SfdText)
                                iCtr% = 1
                                Do
                                    iRc% = InStr(sWhole$, ":")
                                    If iRc% = 0 Or iCtr% = 4 Then
                                        sPart$ = sWhole$
                                        sWhole$ = ""
                                    Else
                                        sPart$ = Mid(sWhole$, 1, iRc% - 1)
                                        sWhole$ = Mid(sWhole$, iRc% + 1)
                                    End If
                                    If iCtr% = 4 Then
                                        sElement$ = sElement$ + "<extent><start>" + sPart$ + "</start></extent>"
                                    Else
                                        sElement$ = sElement$ + "<detail level=" + AddQuotes(Trim(str(iCtr%))) + "><number>" + sPart$ + "</number></detail>"
                                    End If
                                    If Len(sWhole$) = 0 Then
                                        Exit Do
                                    End If
                                    iCtr% = iCtr% + 1
                                Loop
                                If Len(sElement$) > 0 Then
                                    sField$ = sField$ + "<part>" + sField$ + "</part>"
                                End If
                            End If
                        End If
                        
                End Select
                
XmlRecordOutOneRelatedItemFieldAssembled:
                If Len(sField$) > 0 Then
                    sOut$ = sOut$ + sCrlfTabTab + "<relatedItem" + sType$ + sDisplayLabel$ + ">" + sField$ + "</relatedItem>"
                    sField$ = ""
                End If
XmlRecordOutNextRelatedItemField:

                FldPointer = iFieldPtr2%
            Loop
            
            
            
            ' the identifier group
            FldMoveTop
            Do While FldFindNext("856")
                If SfdFindFirst("u") Then
                    If Mid(SfdText, 1, 3) = "doi" Then
                        sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("doi") + ">" + Mid(SfdText, 4) + "</identifier>"
                    ElseIf Mid(SfdText, 1, 3) = "hdl" Then
                        sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("hdl") + ">" + Mid(SfdText, 4) + "</identifier>"
                    ElseIf Mid(SfdText, 1, 7) = "urn:doi" Then
                        sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("doi") + ">" + Mid(SfdText, 8) + "</identifier>"
                    ElseIf Mid(SfdText, 1, 7) = "urn:hdl" Then
                        sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("hdl") + ">" + Mid(SfdText, 8) + "</identifier>"
                    End If
                ElseIf SfdFindFirst("9") Then ' a winterton convention
                    sOut$ = sOut$ + sCrlfTabTab + "<identifier displayLabel=" + AddQuotes("Object ID") + " type=" + AddQuotes("local") + ">" + SfdText + "</identifier>"
                    sOut$ = sOut$ + sCrlfTabTab + "<identifier displayLabel=" + AddQuotes("Handle") + " type=" + AddQuotes("hdl") + ">http://hdl.handle.net/2166.DL/inu-wint-" + SfdText + "</identifier>"
                End If
            Loop
            FldMoveTop
            Do While FldFindNext("0")
                sField$ = ""
                Select Case FldTag
                    Case "020"
                        If SfdFindFirst("a") Then
                            sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("isbn") + ">" + XmlConditionText(SfdText) + "</identifier>"
                        End If
                        If SfdFindFirst("z") Then
                            sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("isbn") + " invalid=" + AddQuotes("yes") + ">" + XmlConditionText(SfdText) + "</identifier>"
                        End If
                    Case "024"
                        If SfdFindFirst("a") Then
                            Select Case Mid(FldInd, 1, 1)
                                Case "0"
                                    sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("isrc") + ">" + XmlConditionText(SfdText) + "</identifier>"
                                Case "2"
                                    sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("ismn") + ">" + XmlConditionText(SfdText) + "</identifier>"
                            End Select
                        End If
                    Case "022"
                        If SfdFindFirst("a") Then
                            sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("issn") + ">" + XmlConditionText(SfdText) + "</identifier>"
                        End If
                        If SfdFindFirst("z") Then
                            sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("issn") + " invalid=" + AddQuotes("yes") + ">" + XmlConditionText(SfdText) + "</identifier>"
                        End If
                    Case "024"
                        If SfdFindFirst("a") Then
XmlREcordOut024a:           ' NOTE label in left margin
                            Select Case Mid(FldInd, 1, 1)
                                Case "1"
                                    sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("upd") + ">" + XmlRecordOutOneLump("", 0, "a", "", " ") + "</identifier>"
                                Case "4"
                                    sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("sici") + ">" + XmlRecordOutOneLump("", 0, "ab", "", " ") + "</identifier>"
                            End Select
                        ElseIf SfdFindFirst("b") Then
                            GoTo XmlREcordOut024a
                        End If
                        If SfdFindFirst("z") Then
                            Select Case Mid(FldInd, 1, 1)
                                Case "1"
                                    sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("upd") + " invalid=" + AddQuotes("yes") + ">" + XmlRecordOutOneLump("", 0, "a", "", " ") + "</identifier>"
                                Case "4"
                                    sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("sici") + " invalid=" + AddQuotes("yes") + ">" + XmlRecordOutOneLump("", 0, "a", "", " ") + "</identifier>"
                            End Select
                        End If
                    Case "028"
                        If SfdFindFirst("a") Then
XmlRecordOut028a:           ' NOTE label in left margin
                            Select Case Mid(FldInd, 1, 1)
                                Case "0"
                                    sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("issue number") + ">" + XmlRecordOutOneLump("", 0, "ab", "", " ") + "</identifier>"
                                Case "1"
                                    sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("matrix number") + ">" + XmlRecordOutOneLump("", 0, "ab", "", " ") + "</identifier>"
                                Case "2"
                                    sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("music publisher") + ">" + XmlRecordOutOneLump("", 0, "ab", "", " ") + "</identifier>"
                                Case "3"
                                    sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("music plate") + ">" + XmlRecordOutOneLump("", 0, "ab", "", " ") + "</identifier>"
                                Case "4"
                                    sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("videorecording identifier") + ">" + XmlRecordOutOneLump("", 0, "ab", "", " ") + "</identifier>"
                            End Select
                        ElseIf SfdFindFirst("b") Then
                            GoTo XmlRecordOut028a
                        End If
                    Case "010"
                        If SfdFindFirst("a") Then
                            sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("lccn") + ">" + XmlConditionText(SfdText) + "</identifier>"
                        End If
                        If SfdFindFirst("z") Then
                            sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("lccn") + " invalid=" + AddQuotes("yes") + ">" + XmlConditionText(SfdText) + "</identifier>"
                        End If
                    Case "037"
                        If SfdFindFirst("a") Then
XmlREcordOut037a:           ' NOTE label in left margin
                            sOut$ = sOut$ + sCrlfTabTab + "<identifier type=" + AddQuotes("stock number") + ">" + XmlRecordOutOneLump("", 0, "ab", "", " ") + "</identifier>"
                        ElseIf SfdFindFirst("b") Then
                            GoTo XmlREcordOut037a
                        End If
                End Select
                If Len(sField$) > 0 Then
                    sOut$ = sOut$ + sCrlfTabTab + sField$
                End If
            Loop
            
            
            ' the location group
            If FldFindFirst("852") Then
                If SfdFindFirst("3") Then
                    sAuthority$ = " displayLabel=" + AddQuotes(SfdText)
                Else
                    sAuthority$ = ""
                End If
                SfdMoveTop
                sOut$ = sOut$ + sCrlfTabTab + XmlRecordOutOneLump("location><physicalLocation" + sAuthority$ + ">", 0, "abje", "", " ")
            End If
            FldMoveTop
            If bModsAquifer Then
                bFirstUrl = True
            End If
            Do While FldFindNext("856")
                sAuthority$ = XmlRecordOutOneLump("", 0, "y3", "", " ")
                If Len(sAuthority$) > 0 Then
                    sAuthority$ = " displayLabel=" + AddQuotes(sAuthority$)
                End If
                If bFirstUrl Then
                    bFirstUrl = False
                    sAuthority$ = " " + Trim(sAuthority$ + " usage=" + AddQuotes("primary display"))
                End If
                If SfdFindFirst("u") Then
                    sOut$ = sOut$ + sCrlfTabTab + "<location><url" + sAuthority$ + ">" + XmlConditionText(SfdText) + "</url></location>"
                End If
            Loop
            
            
            ' the access condition group
            FldMoveTop
            Do While FldFindNext("506")
                sOut$ = sOut$ + sCrlfTabTab + XmlRecordOutOneLump("accessCondition type=" + AddQuotes("restrictionOnAccess") + ">", 0, "abcd35", "", " ")
            Loop
            FldMoveTop
            Do While FldFindNext("540")
                sOut$ = sOut$ + sCrlfTabTab + XmlRecordOutOneLump("accessCondition type=" + AddQuotes("useAndReproduction") + ">", 0, "abcd35", "", " ")
            Loop
            
            ' the extension group: contains nothing???
            ' see below for the extension group in aquifer records
            
            ' the record information group
            sField$ = ""
            If FldFindFirst("040") Then
                If SfdFindFirst("a") Then
                    sField$ = sTabTabTab$ + "<recordContentSource authority=" + AddQuotes("marcorg") + ">" + XmlConditionText(SfdText) + "</recordContentSource>"
                End If
            End If
            If Len(sField$) > 0 Then
                sField$ = sField$ + sCrLfTabTabTab + "<recordCreationDate encoding=" + AddQuotes("marc") + ">" + Get008Value(0, 6) + "</recordCreationDate>"
            Else
                sField$ = "<recordCreationDate encoding=" + AddQuotes("marc") + ">" + Get008Value(0, 6) + "</recordCreationDate>"
            End If
            If FldFindFirst("005") Then
                sField$ = sField$ + sCrLfTabTabTab + "<recordChangeDate encoding=" + AddQuotes("iso8601") + ">" + FldText + "</recordChangeDate>"
            End If
            If FldFindFirst("003") Then
                sAuthority$ = " source=" + AddQuotes(FldText)
            Else
                sAuthority$ = ""
            End If
            If FldFindFirst("001") Then
                s001$ = FldText
                sField$ = sField$ + sCrLfTabTabTab + "<recordIdentifier" + sAuthority$ + ">" + FldText + "</recordIdentifier>"
            End If
            If FldFindFirst("040") Then
                If SfdFindFirst("b") Then
                    sField$ = sCrLfTabTabTab$ + "<languageOfCataloging><languageTerm authority=" + AddQuotes("iso639-2b") + ">" + XmlConditionText(SfdText) + "</languageTerm></languageOfCataloging>"
                End If
            End If
            If bModsAquifer And InStr(sField$, "languageOfCataloging") = 0 Then
                sField$ = sField$ + sCrLfTabTabTab$ + "<languageOfCataloging><languageTerm authority=" + AddQuotes("iso639-2b") + ">eng</languageTerm></languageOfCataloging>"
            End If
            If Len(sField$) > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + "<recordInfo>" + vbCrLf + sField$ + sCrlfTabTab + "</recordInfo>"
                'sOut$ = sOut$ + sCrLfTabTab + "<recordInformation>" + vbCrLf + sField$ + sCrLfTabTab + "</recordInformation>"
            End If
            
#If False Then
            ' 20091130: according to K. Miller, this was used for a project
            '   several years ago, but is no longer relevant
            If bModsAquifer Then
                sOut$ = sOut$ + sCrlfTabTab$ + "<extension>"
                sOut$ = sOut$ + sCrlfTabTab$ + vbTab + "<location xmlns=" + Chr(34) + "info:dlf/Aquifer/AssetActions/MODS3.2-extension/" + Chr(34) + " xmlns:xsi=" + Chr(34) + "http://www.w3.org/2001/XMLSchema-instance" + Chr(34) + " xsi:schemaLocation=" + Chr(34) + "info:dlf/Aquifer/AssetActions/MODS3.2-extension/ http://purl.org/DLF/Aquifer/AssetActions/MODS3.2-extension/Declarations.xsd" + Chr(34) + "><url access=" + Chr(34) + "asset action set" + Chr(34) + ">http://digital.library.northwestern.edu/oai/asset-actions/wwii/B" + s001$ + ".AssetAction.xml</url></location>"
                sOut$ = sOut$ + sCrlfTabTab$ + "</extension>"
            End If
#End If

            ' the MODS trailer
            sOut$ = sOut$ + vbCrLf + vbTab + "</mods>"
            sOut$ = sOut$ + vbCrLf + "</modsCollection>"
            
            
        Case XmlExportType_MADS%
        
XmlRecordOutUseMadsInstead:

            ' 20050707: MADS is now stable enough to attempt
            
            Select Case MarcRecordFormat
                Case "A"
                    ' you're properly here
                Case "B", "D", "F", "M", "P", "S", "U"
                    GoTo XmlRecordOutUseModsInstead
                Case Else
                    XMLRecordOut = ""
                    Exit Function
            End Select
            
            ' the XML header
            sOut$ = "<?xml version=" + AddQuotes("1.0") + " encoding=" + AddQuotes("UTF-8") + " ?> "
            ' the MADS header
            ' 20050531: omit the version number (for ongoing compatability?)
            sOut$ = sOut$ + vbCrLf + "<madsCollection xmlns:xlink=" + AddQuotes("http://www.w3.org/1999/xlink") ' + " version=" + AddQuotes("3.0")
            sOut$ = sOut$ + vbCrLf + "     xmlns=" + AddQuotes("http://www.loc.gov/mods/v3")
            sOut$ = sOut$ + vbCrLf + "     xmlns:xsi=" + AddQuotes("http://www.w3.org/2001/XMLSchema-instance")
            sOut$ = sOut$ + vbCrLf + "     xsi:schemaLocation=" + AddQuotes("http://www.loc.gov/mads.xsd") + ">"
            sOut$ = sOut$ + vbCrLf + vbTab + "<mads>"
            
            ' get the "authority" for the heading itself
            If Not SfdFindFirst("v") And Not SfdFindFirst("x") And Not SfdFindFirst("y") And Not Not SfdFindFirst("z") And Not FldFindFirst("150") And Not FldFindFirst("155") And Not FldFindFirst("550") Then
                sAuthority$ = "naf" ' LC/NACO authority file
            Else
                Select Case Get008Value(11, 1)
                    Case "a"
                        sAuthority$ = "lcsh"
                    Case "b"
                        sAuthority$ = "lcshac"
                    Case "c"
                        sAuthority$ = "mesh"
                    Case "d"
                        sAuthority$ = "nal"
                    Case "k"
                        sAuthority$ = "csh"
                    Case "s"
                        sAuthority$ = "sears"
                    Case "v"
                        sAuthority$ = "rvm"
                    Case Else
                        If FldFindFirst("040") Then
                            If SfdFindFirst("f") Then
                                sAuthority$ = SfdText$
                            Else
                                sAuthority$ = ""
                            End If
                        Else
                            sAuthority$ = ""
                        End If
                End Select
            End If
            
            ' "authority" tag: the established heading
            FldFindFirst "1"
            sField$ = XmlRecordOutMadsField(sAuthority$)
            If Len(sField$) > 0 Then ' it better be!
                sOut$ = sOut$ + sCrlfTabTab + "<authority>" + vbCrLf + sField$ + sCrlfTabTab + "</authority>"
            End If
            
            ' "related" tags: 5XX fields
            FldMoveTop
            Do While FldFindNext("5")
                sRelationship$ = "other"
                If SfdFindFirst("w") Then
                    ' cannot do "parentOrg", of course
                    Select Case Mid(SfdText + "nnnn", 1, 1)
                        Case "a"
                            sRelationship$ = "earlier"
                        Case "b"
                            sRelationship$ = "later"
                        Case "g"
                            sRelationship$ = "broader"
                        Case "h"
                            sRelationship$ = "narrower"
                        Case "n"
                            sRelationship$ = "equivalent"
                    End Select
                    'Debug.Print "Relationship: " + sRelationship$
                End If
                SfdMoveTop
                sField$ = XmlRecordOutMadsField("")
                If Len(sField$) > 0 Then ' it better be!
                    sOut$ = sOut$ + sCrlfTabTab + "<related type=" + AddQuotes(sRelationship$) + ">" + vbCrLf + sField$ + sCrlfTabTab + "</related>"
                End If
            Loop
            
            ' additional "related" tags: 7XX fields
            FldMoveTop
            Do While FldFindNext("7")
                Select Case FldTag
                    Case "700", "710", "711", "730", "750", "751", "755"
                        Select Case Mid(FldInd, 2, 1)
                            Case "0"
                                sAuthority2$ = "lcsh"
                            Case "1"
                                sAuthority2$ = "lcshac"
                            Case "2"
                                sAuthority2$ = "mesh"
                            Case "3"
                                sAuthority2$ = "nal"
                            Case "5"
                                sAuthority2$ = "csh"
                            Case "6"
                                sAuthority2$ = "rvm"
                            Case "7"
                                If SfdFindFirst("2") Then
                                    sAuthority2$ = XmlConditionText(SfdText)
                                Else
                                    sAuthority2$ = ""
                                End If
                                SfdMoveTop
                            Case Else
                                sAuthority2$ = ""
                        End Select
                End Select
                
                If Len(sAuthority2$) > 0 Then
                    sField$ = XmlRecordOutMadsField(sAuthority2$, True)
                    If Len(sField$) > 0 Then ' it better be!
                        sOut$ = sOut$ + sCrlfTabTab + "<related >" + vbCrLf + sField$ + sCrlfTabTab + "</related>"
                    End If
                End If
            Loop
            
            ' "variant" tags: 4XX fields
            FldMoveTop
            Do While FldFindNext("4")
                sRelationship$ = "other"
                If SfdFindFirst("w") Then
                    ' cannot do: abbreviation, translation, expansion
                    Select Case Mid(SfdText + "nnnn", 1, 1)
                        Case "d"
                            sRelationship$ = "acronym"
                    End Select
                End If
                SfdMoveTop
                sField$ = XmlRecordOutMadsField("")
                If Len(sField$) > 0 Then ' it better be!
                    sOut$ = sOut$ + sCrlfTabTab + "<variant type=" + AddQuotes(sRelationship$) + ">" + vbCrLf + sField$ + sCrlfTabTab + "</variant>"
                End If
            Loop
            
            ' "note" tags--waiting on information regarding "type" attribute
            
            ' "url" tags: 856 fields
            FldMoveTop
            Do While FldFindNext("856")
                If SfdFindFirst("z") Then ' public note
                    sField$ = SfdText
                ElseIf SfdFindFirst("3") Then ' materials specified
                    sField$ = SfdText
                Else
                    sField$ = ""
                End If
                If SfdFindFirst("u") Then
                    If Len(sField$) > 0 Then
                        sField$ = sTabTabTab$ + "<url displayLabel=" + AddQuotes(XmlConditionText(sField$)) + ">" + XmlConditionText(SfdText) + "</url"
                    Else
                        sField$ = sTabTabTab$ + "<url>" + XmlConditionText(SfdText) + "</url"
                    End If
                End If
            Loop
            
            ' "identifier" tags? see mods:identifierType
            If FldFindFirst("010") Then
                'Debug.Print "010 found"
                If SfdFindFirst("a") Then
                    'Debug.Print "$a found"
                    sOut$ = sOut$ + sCrLfTabTabTab + "<identifier type=" + AddQuotes("lccn") + ">" + XmlConditionText(SfdText) + "</identifier>"
                End If
            ElseIf FldFindFirst("035") Then
                Do
                    iRc% = InStr(SfdText, "(DNLM)")
                    If iRc% > 0 Then
                        sOut$ = sOut$ + sCrLfTabTabTab + "<identifier type=" + AddQuotes("dnlm") + ">" + XmlConditionText(SfdText) + "</identifier>"
                        Exit Do
                    End If
                    If Not FldFindNext("035") Then
                        Exit Do
                    End If
                Loop
            End If
            ' other standard numbers we can use as identifiers
            FldMoveTop
            Do While FldFindNext("02")
                Select Case FldTag
                    Case "020"
                        If SfdFindFirst("a") Then
                            sOut$ = sOut$ + sCrLfTabTabTab + "<identifier type=" + AddQuotes("isbn") + ">" + XmlConditionText(SfdText) + "</identifier>"
                        End If
                    Case "022"
                        If SfdFindFirst("a") Then
                            sOut$ = sOut$ + sCrLfTabTabTab + "<identifier type=" + AddQuotes("issn") + ">" + XmlConditionText(SfdText) + "</identifier>"
                        End If
                End Select
            Loop
            
            ' "extension" tags: we will not be using this one ...  (seems to be some kind of "local use" area)
            
            ' we will not for the present be using the "affiliation" or "occupation" or "fieldOfActivity" tags
            
            ' recordInfo tag
            ' the record information group
            sField$ = ""
            If FldFindFirst("040") Then
                If SfdFindFirst("a") Then
                    sField$ = sTabTabTab$ + "<recordContentSource authority=" + AddQuotes("marcorg") + ">" + XmlConditionText(SfdText) + "</recordContentSource>"
                End If
            End If
            If Len(sField$) > 0 Then
                sField$ = sField$ + sCrLfTabTabTab + "<recordCreationDate encoding=" + AddQuotes("marc") + ">" + Get008Value(0, 6) + "</recordCreationDate>"
            Else
                sField$ = "<recordCreationDate encoding=" + AddQuotes("marc") + ">" + Get008Value(0, 6) + "</recordCreationDate>"
            End If
            If FldFindFirst("005") Then
                sField$ = sField$ + sCrLfTabTabTab + "<recordChangeDate encoding=" + AddQuotes("iso8601") + ">" + FldText + "</recordChangeDate>"
            End If
            ' todo: given what Voyager does (or rather doesn't) with the 003, it might be better
            '   to use the authorityNUC (or even the plain NUC) in all cases ...
            If FldFindFirst("003") Then
                sAuthority$ = " source=" + AddQuotes(FldText)
            Else
                sAuthority$ = "" ' gblsAuthorityNUC$
            End If
            If FldFindFirst("001") Then
                sField$ = sField$ + sCrLfTabTabTab + "<recordIdentifier source=" + AddQuotes(sAuthority$) + ">" + FldText + "</recordIdentifier>"
            End If
            FldMoveTop
            If FldFindFirst("040") Then
                If SfdFindFirst("b") Then
                    sField$ = sField$ + sCrLfTabTabTab$ + "<languageOfCataloging><languageTerm authority=" + AddQuotes("iso639-2b") + ">" + XmlConditionText(SfdText) + "</languageTerm></languageOfCataloging>"
                End If
            End If
            If Len(sField$) > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + "<recordInfo>" + vbCrLf + sField$ + sCrlfTabTab + "</recordInfo>"
            End If
            
            ' the MADS trailer
            sOut$ = sOut$ + vbCrLf + vbTab + "</mads>"
            sOut$ = sOut$ + vbCrLf + "</madsCollection>"

        Case XmlExportType_DublinCoreOAI%
            
            ' 20051107: added
            If InStr("BDFMPSU", MarcRecordFormat) = 0 Then
                XMLRecordOut = ""
                Exit Function
            End If
            
            sAllSfds$ = "abcdefghijklmnopqrstuvwxyz"
            
            ' todo: this "example.org" stuff is obviously faked; but should there be something else?
            
            ' the XML header
            sOut$ = "<?xml version=" + AddQuotes("1.0") + " encoding=" + AddQuotes("UTF-8") + " ?> "
            ' the OAI header
            sOut$ = sOut$ + vbCrLf + "<oai_dc:dc xmlns:dc=" + Chr(34) + "http://purl.org/dc/elements/1.1/" + Chr(34)
            sOut$ = sOut$ + vbCrLf + "     xmlns:oai_dc=" + Chr(34) + "http://www.openarchives.org/OAI/2.0/oai_dc/" + Chr(34)
            sOut$ = sOut$ + vbCrLf + "     xmlns:xsi=" + Chr(34) + "http://www.w3.org/2001/XMLSchema-instance" + Chr(34)
            sOut$ = sOut$ + vbCrLf + "     xsi:schemaLocation=" + Chr(34) + "http://www.openarchives.org/OAI/2.0/oai_dc/ http://www.openarchives.org/OAI/2.0/oai_dc.xsd" + Chr(34) + ">"
            
            
            If FldFindFirst("245") Then
                sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:title", 0, sAllSfds$, "", " ")
            End If
            FldMoveTop
            Do While FldMoveNext
                If InStr("130 210 240 242 246 730 740", FldTag) > 0 Then
                    sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:title", 0, sAllSfds$, "", " ")
                End If
            Loop
            FldMoveTop
            Do While FldMoveNext
                If InStr("100 110 111", FldTag) > 0 Then
                    sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:creator", 0, sAllSfds$, "", " ")
                End If
            Loop
            FldMoveTop
            Do While FldMoveNext
                If InStr("700 710 711 720", FldTag) > 0 Then
                    sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:contributor", 0, sAllSfds$, "", " ")
                End If
            Loop
            
            FldMoveTop
            Do While FldFindNext("0")
                Select Case FldTag
                    Case "020" ' added 20091130 per K. Miller
                        If SfdFindFirst("a") Then
                            s020$ = SfdNorm
                            'Debug.Print "020 $a: >" + s020$ + "<"
                            Select Case Len(s020$)
                                Case 10, 13
                                    ' these are OK already
                                Case Else
                                    iRc% = InStr(s020$, " ")
                                    'Debug.Print "IRC: " + str(iRc%)
                                    Select Case iRc%
                                        Case 11, 14
                                            s020$ = Mid(s020$, 1, iRc% - 1)
                                        Case Else
                                            s020$ = ""
                                    End Select
                            End Select
                            ' because we've already got the meat of
                            '   the element, we do this output directly, instead of via
                            '   XmlRecordOutOneLump
                            If Len(s020$) > 0 Then
                                sOut$ = sOut$ + vbCrLf + "<dc:identifier>" + "URN:ISBN:" + s020$ + "</dc:identifier>"
                            End If
                        End If
                    Case "050"
                        sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:subject", 0, sAllSfds$, "", " ")
                    Case "082"
                        sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:subject", 0, sAllSfds$, "", " ")
                    Case "080"
                        sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:subject", 0, sAllSfds$, "", " ")
                End Select
            Loop
            
            
            FldMoveTop
            Do While FldFindNext("6")
                Select Case FldTag
                    Case "600"
                        sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:subject", 0, sAllSfds$, "", "v -- x -- y -- z -- ")
                    Case "610"
                        sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:subject", 0, sAllSfds$, "", "v -- x -- y -- z -- ")
                    Case "611"
                        sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:subject", 0, sAllSfds$, "", "v -- x -- y -- z -- ")
                    Case "630"
                        sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:subject", 0, sAllSfds$, "", "v -- x -- y -- z-- ")
                    Case "650"
                        sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:subject", 0, sAllSfds$, "", "v -- x -- y -- z -- ")
                    Case "651"
                        sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:subject", 0, sAllSfds$, "", "v -- x -- y -- z -- ")
                End Select
            Loop
            
            ' 20071012: created per K. Miller
            FldMoveTop
            Do While FldFindNext("540")
                sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:rights", 0, sAllSfds$, "", " ")
            Loop
            
            
            ' 20071012: 540 moved from here to dc:rights (above) per K. Miller
            FldMoveTop
            Do While FldFindNext("5")
                If InStr("506 530 546", FldTag) = 0 Then
                'If InStr("506 530 540 546", FldTag) = 0 Then
                    sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:description", 0, sAllSfds$, "", " ")
                End If
            Loop
            
            If FldFindFirst("260") Then
                sField$ = XmlRecordOutOneLump("dc:publisher", 0, "a", "", " ")
                If Len(sField$) > 0 Then
                    sOut$ = sOut$ + vbCrLf + sField$
                End If
                If SfdFindFirst("b") Then
                    sField$ = XmlRecordOutOneLump("dc:publisher", 0, "b", "", " ")
                    If Len(sField$) > 0 Then
                        sOut$ = sOut$ + vbCrLf + sField$
                    End If
                End If
                If SfdFindFirst("g") Then
                    sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:date", 0, "g", "", " ")
                End If
                If SfdFindFirst("c") Then
                    sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:date", 0, "c", "", " ")
                    bHave260DateAlready = True
                End If
            End If
            
            If FldFindFirst("533") Then
                If SfdFindFirst("d") Then
                    sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:date", 0, "d", "", " ")
                End If
                If SfdFindFirst("e") Then
                    sExtent$ = XmlConditionText(SfdText)
                End If
            End If
            
            If Not bHave260DateAlready Then
                sOut$ = sOut$ + vbCrLf + XmlTags("dc:date", Get008Value(7, 4))
            End If
            
            
            ' todo: there seems to be a more recent list of these ...
            Select Case GetLeaderValue(6, 1)
                Case "a", "c", "d", "t"
                    sOut$ = sOut$ + vbCrLf + XmlTags("dc:type", "Text data")
                Case "e", "f", "g", "k"
                    sOut$ = sOut$ + vbCrLf + "<dc:type>image</dc:type>"
                Case "i", "j"
                    sOut$ = sOut$ + vbCrLf + "<dc:type>sound</dc:type>"
                Case "m", "o", "p", "r"
                    ' there's no Type for these
            End Select
            If InStr("csp", GetLeaderValue(7, 1)) > 0 Then
                sOut$ = sOut$ + vbCrLf + XmlTags("dc:type", "collection")
            End If
            
            FldMoveTop
            Do While FldFindNext("856")
                If SfdFindFirst("q") Then
                    sOut$ = sOut$ + vbCrLf + XmlTags("dc:format", XmlConditionText(SfdText))
                End If
                If SfdFindFirst("u") Then
                    sOut$ = sOut$ + vbCrLf + XmlTags("dc:identifier", XmlConditionText(SfdText))
                End If
            Loop
            
            If Len(sExtent$) > 0 Then
                sOut$ = sOut$ + vbCrLf + XmlTags("dc:format", sExtent$)
            ElseIf FldFindFirst("300") Then
                If SfdFindFirst("a") Then
                    sOut$ = sOut$ + vbCrLf + XmlTags("dc:format", XmlConditionText(SfdText))
                End If
            End If
            
            FldMoveTop
            Do While FldFindNext("340")
                If SfdFindFirst("a") Then
                    sOut$ = sOut$ + vbCrLf + XmlTags("dc:format", XmlConditionText(SfdText))
                End If
            Loop
            
            FldMoveTop
            Do While FldFindNext("786")
                sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:source", 0, "ot", "", " ")
            Loop
            
            FldMoveTop
            Do While FldFindNext("546")
                If SfdFindFirst("a") Then
XmlRecordOut546aOai:
                    sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:language", 0, "ab", "", " ")
                ElseIf SfdFindFirst("b") Then
                    GoTo XmlRecordOut546aOai
                End If
            Loop
            
            If FldFindFirst("041") Then
                SfdMoveTop
                Do While SfdMoveNext
                    sField$ = XmlConditionText(SfdText)
                    Do
                        sOut$ = sOut$ + vbCrLf + XmlTags("dc:language", Mid(sField$, 1, 3))
                        sField$ = Mid(sField$, 4)
                        If Len(sField$) < 3 Then
                            Exit Do
                        End If
                    Loop
                Loop
            End If
            
            sOut$ = sOut$ + vbCrLf + XmlTags("dc:language", Get008Value(35, 3))
            
            
            ' todo:
            ' NOTE that we'ere not bothering with the 530 field, or the 760 to 787 fields:
            '   the 'relation' tag
            ' we may get around to this eventually ...
            
            sOut$ = sOut$ + vbCrLf + "</oai_dc:dc>"
        
        Case XmlExportType_DublinCoreRdf%
            
            If InStr("BDFMPSU", MarcRecordFormat) = 0 Then
                XMLRecordOut = ""
                Exit Function
            End If
            
            sAllSfds$ = "abcdefghijklmnopqrstuvwxyz"
            
            ' todo: this "example.org" stuff is obviously faked; but should there be something else?
            
            ' the XML header
            sOut$ = "<?xml version=" + AddQuotes("1.0") + " encoding=" + AddQuotes("UTF-8") + " ?> "
            ' the DC RDF header
            sOut$ = sOut$ + vbCrLf + "<!DOCTYPE rdf:RDF PUBLIC " + Chr(34) + "-//DUBLIN CORE//DCMES DTD 2001 11 28//EN" + Chr(34) + " " + Chr(34) + "http://dublincore.org/documents/2001/11/28/dcmes-xml-cdmes-xml-dtd.dtd" + Chr(34) + ">"
            sOut$ = sOut$ + vbCrLf + "<rdf:RDF xmlns:rdf=" + AddQuotes("http://www.w3.org/1999/02/22-rdf-syntax-ns#")
            sOut$ = sOut$ + vbCrLf + "     xmlns:dc=" + AddQuotes("http://purl.org/dc/elements/1.1/")
            sOut$ = sOut$ + vbCrLf + "     xmlns:dcq=" + AddQuotes("http://purl.org/dc/qualifiers/1.0/") + ">"
            'sOut$ = sOut$ + vbCrLf + "<rdf:Description about=" + AddQuotes("http://www.achrnews.com") + "/>"
            
            If FldFindFirst("245") Then
                sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:title", 0, sAllSfds$, "", " ")
            End If
            FldMoveTop
            Do While FldMoveNext
                If InStr("130 210 240 242 246 730 740", FldTag) > 0 Then
                    sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:title", 0, sAllSfds$, "", " ")
                End If
            Loop
            FldMoveTop
            Do While FldMoveNext
                If InStr("100 110 111", FldTag) > 0 Then
                    sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:creator", 0, sAllSfds$, "", " ")
                End If
            Loop
            FldMoveTop
            Do While FldMoveNext
                If InStr("700 710 711 720", FldTag) > 0 Then
                    sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:contributor", 0, sAllSfds$, "", " ")
                End If
            Loop
            
            FldMoveTop
            Do While FldFindNext("0")
                Select Case FldTag
                    Case "050"
                        sOut$ = sOut$ + vbCrLf + XmlTags("dc:subject", XmlTags("rdf:Description", XmlTags("dcq:subjectQualifier", "class") + XmlRecordOutOneLump("rdf:value", 0, sAllSfds$, "", " ")))
                    Case "082"
                        sOut$ = sOut$ + vbCrLf + XmlTags("dc:subject", XmlTags("rdf:Description", XmlTags("dcq:subjectQualifier", "class") + XmlRecordOutOneLump("rdf:value", 0, sAllSfds$, "", " ")))
                    Case "080"
                        sOut$ = sOut$ + vbCrLf + XmlTags("dc:subject", XmlTags("rdf:Description", XmlTags("dcq:subjectQualifier", "class") + XmlRecordOutOneLump("rdf:value", 0, sAllSfds$, "", " ")))
                End Select
            Loop
            
            FldMoveTop
            Do While FldFindNext("6")
                Select Case FldTag
                    Case "600"
                        sOut$ = sOut$ + vbCrLf + XmlTags("dc:subject", XmlTags("rdf:Description", XmlTags("dcq:subjectQualifier", "namePersonal") + XmlRecordOutOneLump("rdf:value", 0, sAllSfds$, "", "v -- x -- y -- z -- ")))
                    Case "610"
                        sOut$ = sOut$ + vbCrLf + XmlTags("dc:subject", XmlTags("rdf:Description", XmlTags("dcq:subjectQualifier", "nameCorporate") + XmlRecordOutOneLump("rdf:value", 0, sAllSfds$, "", "v -- x -- y -- z -- ")))
                    Case "611"
                        sOut$ = sOut$ + vbCrLf + XmlTags("dc:subject", XmlTags("rdf:Description", XmlTags("dcq:subjectQualifier", "nameConference") + XmlRecordOutOneLump("rdf:value", 0, sAllSfds$, "", "v -- x -- y -- z -- ")))
                    Case "630"
                        sOut$ = sOut$ + vbCrLf + XmlTags("dc:subject", XmlTags("rdf:Description", XmlTags("dcq:subjectQualifier", "titleUniform") + XmlRecordOutOneLump("rdf:value", 0, sAllSfds$, "", "v -- x -- y -- z-- ")))
                    Case "650"
                        sOut$ = sOut$ + vbCrLf + XmlTags("dc:subject", XmlTags("rdf:Description", XmlTags("dcq:subjectQualifier", "topical") + XmlRecordOutOneLump("rdf:value", 0, sAllSfds$, "", "v -- x -- y -- z -- ")))
                    Case "651"
                        sOut$ = sOut$ + vbCrLf + XmlTags("dc:subject", XmlTags("rdf:Description", XmlTags("dcq:subjectQualifier", "geographic") + XmlRecordOutOneLump("rdf:value", 0, sAllSfds$, "", "v -- x -- y -- z -- ")))
                End Select
            Loop
            
            
            FldMoveTop
            Do While FldFindNext("5")
                If InStr("506 530 540 546", FldTag) = 0 Then
                    sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:description", 0, sAllSfds$, "", " ")
                End If
            Loop
            
            If FldFindFirst("260") Then
                sField$ = XmlRecordOutOneLump("dc:publisher", 0, "a", "", " ")
                If Len(sField$) > 0 Then
                    sOut$ = sOut$ + vbCrLf + sField$
                End If
                sField$ = XmlRecordOutOneLump("dc:publisher", 0, "b", "", " ")
                If Len(sField$) > 0 Then
                    sOut$ = sOut$ + vbCrLf + sField$
                End If
                If SfdFindFirst("g") Then
                    sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:date", 0, "g", "", " ")
                End If
                If SfdFindFirst("c") Then
                    sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:date", 0, "c", "", " ")
                End If
            End If
            
            If FldFindFirst("533") Then
                If SfdFindFirst("d") Then
                    sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:date", 0, "d", "", " ")
                End If
                If SfdFindFirst("e") Then
                    sExtent$ = XmlConditionText(SfdText)
                End If
            End If
            
            sOut$ = sOut$ + vbCrLf + XmlTags("dc:date", Get008Value(7, 4))
            
            ' todo: there seems to be a more recent list of these ...
            Select Case GetLeaderValue(6, 1)
                Case "a", "c", "d", "t"
                    sOut$ = sOut$ + vbCrLf + XmlTags("dc:type", "Text data")
                Case "e", "f", "g", "k"
                    sOut$ = sOut$ + vbCrLf + "<dc:type>image</dc:type>"
                Case "i", "j"
                    sOut$ = sOut$ + vbCrLf + "<dc:type>sound</dc:type>"
                Case "m", "o", "p", "r"
                    ' there's no Type for these
            End Select
            If InStr("csp", GetLeaderValue(7, 1)) > 0 Then
                sOut$ = sOut$ + vbCrLf + XmlTags("dc:type", "collection")
            End If
            
            FldMoveTop
            Do While FldFindNext("856")
                If SfdFindFirst("q") Then
                    sOut$ = sOut$ + vbCrLf + XmlTags("dc:format", XmlConditionText(SfdText))
                End If
                If SfdFindFirst("u") Then
                    sOut$ = sOut$ + vbCrLf + XmlTags("dc:identifier", XmlConditionText(SfdText))
                End If
            Loop
            
            If Len(sExtent$) > 0 Then
                sOut$ = sOut$ + vbCrLf + XmlTags("dc:format", sExtent$)
            ElseIf FldFindFirst("300") Then
                If SfdFindFirst("a") Then
                    sOut$ = sOut$ + vbCrLf + XmlTags("dc:format", XmlConditionText(SfdText))
                End If
            End If
            
            FldMoveTop
            Do While FldFindNext("340")
                If SfdFindFirst("a") Then
                    sOut$ = sOut$ + vbCrLf + XmlTags("dc:format", XmlConditionText(SfdText))
                End If
            Loop
            
            FldMoveTop
            Do While FldFindNext("786")
                sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:source", 0, "ot", "", " ")
            Loop
            
            FldMoveTop
            Do While FldFindNext("546")
                If SfdFindFirst("a") Then
XmlRecordOut546a:
                    sOut$ = sOut$ + vbCrLf + XmlRecordOutOneLump("dc:language", 0, "ab", "", " ")
                ElseIf SfdFindFirst("b") Then
                    GoTo XmlRecordOut546a
                End If
            Loop
            
            If FldFindFirst("041") Then
                SfdMoveTop
                Do While SfdMoveNext
                    sField$ = XmlConditionText(SfdText)
                    Do
                        sOut$ = sOut$ + vbCrLf + XmlTags("dc:language", Mid(sField$, 1, 3))
                        sField$ = Mid(sField$, 4)
                        If Len(sField$) < 3 Then
                            Exit Do
                        End If
                    Loop
                Loop
            End If
            
            sOut$ = sOut$ + vbCrLf + XmlTags("dc:language", Get008Value(35, 3))
            
            
            ' todo:
            ' NOTE that we'ere not bothering with the 530 field, or the 760 to 787 fields:
            '   the 'relation' tag
            ' we may get around to this eventually ...
            
            sOut$ = sOut$ + vbCrLf + "</rdf:RDF>"
            
    End Select
    
            
    FldPointer = iFieldPtr%
    SfdPointer = iSfdPointer%
    
    
    If Len(sOut$) > 0 Then
        ' because we earlier force the value of CharacterSetOut to
        '   "U", the following clause can never possibly have any effect ...
        If CharacterSetOut <> "U" Then
            ' the bChanged here is of course to be ignored
            TranslateMarcText2Utf8 sOut$, bChanged
        End If
    End If
    
    ' restore the setting of CharacterSetOut if you changed it earlier
    If sCharacterSetOut$ = CharacterSetOut Then
        CharacterSetOut = sCharacterSetOut$
    End If
    
    ' 20060915: FireFox can display the superscript zero fine, no problem; but IE cannot; so
    '  we're going to make a substitution
    XMLRecordOut = ReplaceCharacters(sOut$, MyMarcCharacter.Utf8Superscript0, MyMarcCharacter.Utf8Degree)
        
    
End Function


Private Function XmlRecordOutOneLump(ByVal sTag$, ByVal iNonfiling%, ByVal sIncluded$, ByVal sStopAt$, Optional ByVal sSeparator$ = " ", Optional ByVal bModsAquifer As Boolean = False, Optional ByVal bCutLabel As Boolean = False) As String

    ' we enter here with, putatively, SfdPointer already
    '   pointed at the first sfd of interest; or otherwise
    '   where it's supposed to be
    
    Dim sCopy$, sReturn$, sNonSort$, sSfd$, sPiece$, sEndTag$
    Dim sThisSeparator$, sDisplayLabel$
    
    Dim iCtr%, iLen%, iPtr%
    
    Dim lPtr As Long
    
    Dim bFancySeparator As Boolean
    
    
    
    For iCtr% = 1 To Len(sSeparator$)
        If InStr("abcdefghijklmnopqrstuvwxyz", Mid(sSeparator$, iCtr%, 1)) > 0 Then
            bFancySeparator = True
            Exit For
        End If
    Next
    
    ' we want to be able to assume that the tag has no angle brackets
    If Mid(sTag$, 1, 1) = "<" Then
        sTag$ = Mid(sTag$, 2)
    End If
    If Right(sTag$, 1) = ">" Then
        sTag$ = Mid(sTag$, 1, Len(sTag$) - 1)
    End If
    
    ' create the closing tag by breaking the opening tag into
    '   its components, and reverse their order
    sCopy$ = sTag$
    Do
        iPtr% = InStr(sCopy$, "><")
        If iPtr% = 0 Then
            sPiece$ = sCopy$
            sCopy$ = ""
        Else
            sPiece$ = Mid(sCopy$, 1, iPtr% - 1)
            sCopy$ = Mid(sCopy$, iPtr% + 2)
        End If
        iPtr% = InStr(sPiece$, " ")
        If iPtr% > 0 Then
            sPiece$ = Mid(sPiece$, 1, iPtr% - 1)
        End If
        sEndTag$ = "</" + sPiece$ + ">" + sEndTag$
        If Len(sCopy$) = 0 Then
            Exit Do
        End If
    Loop
    
    Do
        If InStr(sIncluded$, SfdCode) > 0 And Len(SfdCode) > 0 Then
            sSfd$ = SfdText
            iPtr% = InStr(sSfd$, vbTab)
            If iPtr% > 0 Then
                If bCutLabel Then
                    sDisplayLabel$ = ""
                Else
                    sDisplayLabel$ = Mid(sSfd$, iPtr%)
                    If Mid(sDisplayLabel$, 1, 1) = vbTab Then
                        sDisplayLabel$ = Mid(sDisplayLabel$, 2)
                    End If
                    sDisplayLabel$ = " displayLabel=" + AddQuotes(sDisplayLabel$)
                End If
                sSfd$ = Mid(sSfd$, 1, iPtr% - 1)
            Else
                sDisplayLabel$ = ""
            End If
            iPtr% = InStr(sSeparator$, SfdCode)
            If iPtr = 0 Then
                If bFancySeparator Then
                    sThisSeparator$ = " "
                Else
                    sThisSeparator$ = sSeparator$
                End If
            Else
                sThisSeparator$ = Mid(sSeparator$, iPtr% + 1)
                For iPtr% = 1 To Len(sThisSeparator$)
                    If InStr("abcdefghijklmnopqrstuvwxyz", Mid(sThisSeparator$, iPtr%, 1)) > 0 Then
                        sThisSeparator$ = Mid(sThisSeparator$, 1, iPtr% - 1)
                        Exit For
                    End If
                Next ' iptr%
            End If
            If iNonfiling% > 0 Then
                If CharacterSetOut = "U" Then
                    iPtr% = 1
                    For iCtr% = 1 To iNonfiling%
                        MyMarcCharacter.Utf8Char = Mid(sSfd$, iPtr%)
                        iLen% = MyMarcCharacter.Utf8CharOctets
                        sNonSort$ = sNonSort$ + MyMarcCharacter.Utf8Char
                        iPtr% = iPtr% + iLen%
                    Next ' ictr%
                    sSfd$ = Mid(sSfd$, iPtr%)
                Else ' take the easy way out
                    sNonSort$ = Mid(sSfd$, 1, iNonfiling%)
                    sSfd$ = Mid(sSfd$, iNonfiling% + 1)
                End If
                iNonfiling% = 0
            End If
            If Len(sReturn$) = 0 Then
                sReturn$ = sSfd$
            Else
                sReturn$ = sReturn$ + sThisSeparator$ + sSfd$
            End If
        End If
        If Not SfdMoveNext Then
            Exit Do
        End If
        If InStr(sStopAt$, SfdCode) > 0 Then
            SfdMovePrev
            Exit Do
        End If
    Loop
    
    If Len(sReturn$) > 0 Then
        If bModsAquifer Then
            Select Case sTag$
                Case "title", "subTitle"
                    If InStr(":/", Right(sReturn$, 1)) > 0 Then
                        sReturn$ = Trim(Mid(sReturn$, 1, Len(sReturn$) - 1))
                    End If
            End Select
        End If
        sReturn$ = XmlConditionText(sReturn$)
        If Len(sTag$) > 0 Then
            ' todo: not clear just where this goes ...
            ' we know that sTag has no opening and closing brackets; and we've supplied
            '   them already for the closing tag
            If Len(sNonSort$) > 0 Then
                sReturn$ = "<nonSort>" + XmlConditionText(sNonSort$) + "</nonSort><" + sTag$ + sDisplayLabel$ + ">" + sReturn$ + sEndTag$
            Else
                sReturn$ = "<" + sTag$ + sDisplayLabel$ + ">" + sReturn$ + sEndTag$
            End If
        End If
    End If
    
    XmlRecordOutOneLump = sReturn$
    
End Function

Public Function AddQuotes(sInputString$) As String

    AddQuotes = m_sQuote$ + sInputString$ + m_sQuote$
    
End Function

Public Function XmlTags(ByVal sTag$, ByVal sText$) As String

    Dim iRc%
    
    
    iRc% = InStr(sTag$, " ")
    If iRc% > 0 Then
        XmlTags = "<" + sTag$ + ">" + sText$ + "</" + Mid(sTag$, 1, iRc% - 1) + ">"
    Else
        XmlTags = "<" + sTag$ + ">" + sText$ + "</" + sTag$ + ">"
    End If
    
    
End Function

Public Sub SetUpTranslation(Translation As MarcTranslateType)
    
    ' 20040901: we're centralizing this on the off chance that we may need to flip this stuff around
    '   from the outside to translate a single piece of text w/o translating an entire record
    
    Select Case Translation
        Case TranslateType_O2M% '"O2M"
            If sCharacterSetup$ = TranslateCode_O2M$ Then
                Exit Sub
            End If
            sCharacterSetup$ = TranslateCode_O2M$
            iCharacterLast% = 255
            ReDim aCharacter(0 To 255)
            aCharacter(193).From = True
            aCharacter(193).To = MarcLScript
        Case TranslateType_O2V% '"O2V"
            If sCharacterSetup$ = TranslateCode_O2V$ Then
                Exit Sub
            End If
            sCharacterSetup$ = TranslateCode_O2V$
            iCharacterLast% = 255
            ReDim aCharacter(0 To 255)
            aCharacter(190).From = True
            aCharacter(190).To = Chr(160)
            aCharacter(192).From = True
            aCharacter(192).To = Chr(144)
            aCharacter(194).From = True
            aCharacter(194).To = Chr(146)
            aCharacter(195).From = True
            aCharacter(195).To = Chr(147)
            aCharacter(196).From = True
            aCharacter(196).To = Chr(148)
            aCharacter(198).From = True
            aCharacter(197).To = Chr(149)
            aCharacter(198).From = True
            aCharacter(198).To = Chr(150)
            ' NOTE that the superscripts and subscripts are taken care of
            '   separately
        Case TranslateType_M2O% '"M2O"
            If sCharacterSetup$ = TranslateCode_M2O$ Then
                Exit Sub
            End If
            sCharacterSetup$ = TranslateCode_M2O$
            iCharacterLast% = 255
            ReDim aCharacter(0 To 255)
            aCharacter(193).From = True
            aCharacter(193).To = Chr(190) ' OCLC script-l
        Case TranslateType_M2V% '"M2V"
            If sCharacterSetup$ = TranslateCode_M2V$ Then
                Exit Sub
            End If
            sCharacterSetup$ = TranslateCode_M2V$
            iCharacterLast% = 255
            ReDim aCharacter(0 To 255)
            aCharacter(192).From = True
            aCharacter(192).To = Chr(144)
            aCharacter(193).From = True
            aCharacter(193).To = Chr(160)
            aCharacter(194).From = True
            aCharacter(194).To = Chr(146)
            aCharacter(195).From = True
            aCharacter(195).To = Chr(147)
            aCharacter(196).From = True
            aCharacter(196).To = Chr(148)
            aCharacter(198).From = True
            aCharacter(197).To = Chr(149)
            aCharacter(198).From = True
            aCharacter(198).To = Chr(150)
            ' NOTE that the superscripts and subscripts are taken care of
            '   separately
        Case TranslateType_V2M% '"V2M"
            If sCharacterSetup$ = TranslateCode_V2M$ Then
                Exit Sub
            End If
            sCharacterSetup$ = TranslateCode_V2M$
            iCharacterLast% = 255
            ReDim aCharacter(0 To 255)
            aCharacter(144).From = True
            aCharacter(144).To = MARC_Degree
            aCharacter(160).From = True
            aCharacter(160).To = MARC_ScriptL
            aCharacter(146).From = True
            aCharacter(146).To = MARC_Pressing
            aCharacter(147).From = True
            aCharacter(147).To = MARC_Copyright
            aCharacter(148).From = True
            aCharacter(148).To = MARC_Sharp
            aCharacter(149).From = True
            aCharacter(149).To = MARC_InvertedQuestion
            aCharacter(150).From = True
            aCharacter(150).To = MARC_InvertedExclamation
            aCharacter(175).From = True
            aCharacter(175).To = MarcEscape + "ga" + MarcEscape + "s"
            aCharacter(190).From = True
            aCharacter(190).To = MarcEscape + "gb" + MarcEscape + "s"
            aCharacter(191).From = True
            aCharacter(191).To = MarcEscape + "gb" + MarcEscape + "s"
            aCharacter(192).From = True
            aCharacter(192).To = MarcEscape + "p0" + MarcEscape + "s"
            aCharacter(193).From = True
            aCharacter(193).To = MarcEscape + "p1" + MarcEscape + "s"
            aCharacter(194).From = True
            aCharacter(194).To = MarcEscape + "p2" + MarcEscape + "s"
            aCharacter(195).From = True
            aCharacter(195).To = MarcEscape + "p3" + MarcEscape + "s"
            aCharacter(196).From = True
            aCharacter(196).To = MarcEscape + "p4" + MarcEscape + "s"
            aCharacter(197).From = True
            aCharacter(197).To = MarcEscape + "p5" + MarcEscape + "s"
            aCharacter(198).From = True
            aCharacter(198).To = MarcEscape + "p6" + MarcEscape + "s"
            aCharacter(199).From = True
            aCharacter(199).To = MarcEscape + "p7" + MarcEscape + "s"
            aCharacter(200).From = True
            aCharacter(200).To = MarcEscape + "p8" + MarcEscape + "s"
            aCharacter(201).From = True
            aCharacter(201).To = MarcEscape + "p9" + MarcEscape + "s"
            aCharacter(202).From = True
            aCharacter(202).To = MarcEscape + "p+" + MarcEscape + "s"
            aCharacter(203).From = True
            aCharacter(203).To = MarcEscape + "p-" + MarcEscape + "s"
            aCharacter(204).From = True
            aCharacter(204).To = MarcEscape + "p(" + MarcEscape + "s"
            aCharacter(205).From = True
            aCharacter(205).To = MarcEscape + "p)" + MarcEscape + "s"
            aCharacter(208).From = True
            aCharacter(208).To = MarcEscape + "b0" + MarcEscape + "s"
            aCharacter(209).From = True
            aCharacter(209).To = MarcEscape + "b1" + MarcEscape + "s"
            aCharacter(210).From = True
            aCharacter(210).To = MarcEscape + "b2" + MarcEscape + "s"
            aCharacter(211).From = True
            aCharacter(211).To = MarcEscape + "b3" + MarcEscape + "s"
            aCharacter(212).From = True
            aCharacter(212).To = MarcEscape + "b4" + MarcEscape + "s"
            aCharacter(213).From = True
            aCharacter(213).To = MarcEscape + "b5" + MarcEscape + "s"
            aCharacter(214).From = True
            aCharacter(214).To = MarcEscape + "b6" + MarcEscape + "s"
            aCharacter(215).From = True
            aCharacter(215).To = MarcEscape + "b7" + MarcEscape + "s"
            aCharacter(216).From = True
            aCharacter(216).To = MarcEscape + "b8" + MarcEscape + "s"
            aCharacter(217).From = True
            aCharacter(217).To = MarcEscape + "b9" + MarcEscape + "s"
            aCharacter(218).From = True
            aCharacter(218).To = MarcEscape + "b+" + MarcEscape + "s"
            aCharacter(219).From = True
            aCharacter(219).To = MarcEscape + "b-" + MarcEscape + "s"
            aCharacter(220).From = True
            aCharacter(220).To = MarcEscape + "b(" + MarcEscape + "s"
            aCharacter(221).From = True
            aCharacter(221).To = MarcEscape + "b)" + MarcEscape + "s"
        Case TranslateType_V2O% '"V2O"
            If sCharacterSetup$ = TranslateCode_V2O$ Then
                Exit Sub
            End If
            sCharacterSetup$ = TranslateCode_V2O$
            iCharacterLast% = 255
            ReDim aCharacter(0 To 255)
            aCharacter(144).From = True
            aCharacter(144).To = MARC_Degree
            aCharacter(160).From = True
            aCharacter(160).To = OCLC_ScriptL
            aCharacter(146).From = True
            aCharacter(146).To = MARC_Pressing
            aCharacter(147).From = True
            aCharacter(147).To = MARC_Copyright
            aCharacter(148).From = True
            aCharacter(148).To = MARC_Sharp
            aCharacter(149).From = True
            aCharacter(149).To = MARC_InvertedQuestion
            aCharacter(150).From = True
            aCharacter(150).To = MARC_InvertedExclamation
            aCharacter(175).From = True
            aCharacter(175).To = MarcEscape + "ga" + MarcEscape + "s"
            aCharacter(190).From = True
            aCharacter(190).To = MarcEscape + "gb" + MarcEscape + "s"
            aCharacter(191).From = True
            aCharacter(191).To = MarcEscape + "gb" + MarcEscape + "s"
            aCharacter(192).From = True
            aCharacter(192).To = MarcEscape + "p0" + MarcEscape + "s"
            aCharacter(193).From = True
            aCharacter(193).To = MarcEscape + "p1" + MarcEscape + "s"
            aCharacter(194).From = True
            aCharacter(194).To = MarcEscape + "p2" + MarcEscape + "s"
            aCharacter(195).From = True
            aCharacter(195).To = MarcEscape + "p3" + MarcEscape + "s"
            aCharacter(196).From = True
            aCharacter(196).To = MarcEscape + "p4" + MarcEscape + "s"
            aCharacter(197).From = True
            aCharacter(197).To = MarcEscape + "p5" + MarcEscape + "s"
            aCharacter(198).From = True
            aCharacter(198).To = MarcEscape + "p6" + MarcEscape + "s"
            aCharacter(199).From = True
            aCharacter(199).To = MarcEscape + "p7" + MarcEscape + "s"
            aCharacter(200).From = True
            aCharacter(200).To = MarcEscape + "p8" + MarcEscape + "s"
            aCharacter(201).From = True
            aCharacter(201).To = MarcEscape + "p9" + MarcEscape + "s"
            aCharacter(202).From = True
            aCharacter(202).To = MarcEscape + "p+" + MarcEscape + "s"
            aCharacter(203).From = True
            aCharacter(203).To = MarcEscape + "p-" + MarcEscape + "s"
            aCharacter(204).From = True
            aCharacter(204).To = MarcEscape + "p(" + MarcEscape + "s"
            aCharacter(205).From = True
            aCharacter(205).To = MarcEscape + "p)" + MarcEscape + "s"
            aCharacter(208).From = True
            aCharacter(208).To = MarcEscape + "b0" + MarcEscape + "s"
            aCharacter(209).From = True
            aCharacter(209).To = MarcEscape + "b1" + MarcEscape + "s"
            aCharacter(210).From = True
            aCharacter(210).To = MarcEscape + "b2" + MarcEscape + "s"
            aCharacter(211).From = True
            aCharacter(211).To = MarcEscape + "b3" + MarcEscape + "s"
            aCharacter(212).From = True
            aCharacter(212).To = MarcEscape + "b4" + MarcEscape + "s"
            aCharacter(213).From = True
            aCharacter(213).To = MarcEscape + "b5" + MarcEscape + "s"
            aCharacter(214).From = True
            aCharacter(214).To = MarcEscape + "b6" + MarcEscape + "s"
            aCharacter(215).From = True
            aCharacter(215).To = MarcEscape + "b7" + MarcEscape + "s"
            aCharacter(216).From = True
            aCharacter(216).To = MarcEscape + "b8" + MarcEscape + "s"
            aCharacter(217).From = True
            aCharacter(217).To = MarcEscape + "b9" + MarcEscape + "s"
            aCharacter(218).From = True
            aCharacter(218).To = MarcEscape + "b+" + MarcEscape + "s"
            aCharacter(219).From = True
            aCharacter(219).To = MarcEscape + "b-" + MarcEscape + "s"
            aCharacter(220).From = True
            aCharacter(220).To = MarcEscape + "b(" + MarcEscape + "s"
            aCharacter(221).From = True
            aCharacter(221).To = MarcEscape + "b)" + MarcEscape + "s"
    End Select
    
End Sub

Public Function XmlConditionText(ByVal sText$) As String

    Dim iRc%
    
    ' in 'plain' text, replace any reserved symbols with special codes
    
    'If InStr(sText$, "&amp") > 0 Then
    '    Debug.Print "AMP >" + sText$ + "<"
    'End If
    
    For iRc% = Len(sText$) To 1 Step -1
        Select Case Mid(sText$, iRc%, 1)
            Case "<"
                sText$ = SafeStuff(sText, iRc%, 1, "&lt;")
            Case ">"
                sText$ = SafeStuff(sText, iRc%, 1, "&gt;")
            Case "&"
                ' todo: we should actually be sensitive here to
                '   ampersands that appear as part of pre-existing special
                '   codes
                sText$ = SafeStuff(sText, iRc%, 1, "&amp;")
            Case m_sQuote$
                sText$ = SafeStuff(sText, iRc%, 1, "&quot;")
            Case "'"
                sText$ = SafeStuff(sText, iRc%, 1, "&apos;")
        End Select
    Next ' irc%
    
    XmlConditionText = sText$
    
End Function

Public Property Get FldTextFormatted(Optional ByVal iOutput As TextFormattedType = TextFormattedDefault, Optional ByVal bIncludeRtfWrapper As Boolean = False, Optional ByVal iRtfFontSizeInPoints% = 10, Optional ByVal sSubfieldsToInclude$ = "0123456789abcdefghijklmnopqrstuvwxyz", Optional ByVal sSubfieldsToExclude$ = "") As String

    ' provide a displayable version of the current field's text
    
    Dim sOut$, sFontTbl$, sColorTbl$, sText$
    
    Dim bRtfNaco As Boolean, bAuthority As Boolean
    
    
    If FldPointer > -1 Then
        Select Case iOutput
            Case TextFormatted_HexEquivalents%
                FldTextFormatted = Marc2HexDisplay(RemoveDelimiters(AddSpacesAroundDelimiters(FldTextWithOnlyCertainSubfields(sSubfieldsToInclude$, sSubfieldsToExclude$)), "|"))
            Case TextFormatted_Latin1NoDelimiters%
                FldTextFormatted = Trim(Marc2MsoftAscii(RemoveRepeatedCharacters(RemoveDelimiters(AddSpacesAroundDelimiters(FldTextWithOnlyCertainSubfields(sSubfieldsToInclude$, sSubfieldsToExclude$)), ""), " "), latin1))
            Case TextFormatted_Latin1%
                FldTextFormatted = Trim(Marc2MsoftAscii(RemoveRepeatedCharacters(RemoveDelimiters(AddSpacesAroundDelimiters(FldTextWithOnlyCertainSubfields(sSubfieldsToInclude$, sSubfieldsToExclude$)), "|"), " "), latin1))
            Case TextFormatted_PlainText%
                ' 20061215: turns out we had NOTHING for plain text; we'll use this for now ...
                FldTextFormatted = Marc2MsoftAscii(RemoveRepeatedCharacters(RemoveDelimiters(AddSpacesAroundDelimiters(FldTextWithOnlyCertainSubfields(sSubfieldsToInclude$, sSubfieldsToExclude$)), ""), " "), latin1)
            Case TextFormatted_Raw
                FldTextFormatted = ReplaceCharacters(AddSpacesAroundDelimiters(FldTextWithOnlyCertainSubfields(sSubfieldsToInclude$, sSubfieldsToExclude$)), MarcDelimiter, "|")
            Case TextFormatted_Latin1WithDots%
                FldTextFormatted = Marc2MsoftAscii(RemoveDelimiters(AddSpacesAroundDelimiters(FldTextWithOnlyCertainSubfields(sSubfieldsToInclude$, sSubfieldsToExclude$)), "|"), Latin1TextWithDots)
            Case TextFormatted_Latin1Extended%
                FldTextFormatted = Marc2MsoftAscii(RemoveDelimiters(AddSpacesAroundDelimiters(FldTextWithOnlyCertainSubfields(sSubfieldsToInclude$, sSubfieldsToExclude$)), "|"), Latin1extended)
            Case TextFormatted_RtfText%
                'If prvbPair880sWithRomanizedFieldsHold And FldTag = "880" Then
                '    sSubfieldsToExclude$ = sSubfieldsToExclude$ + "6"
                'End If
                sOut$ = TranslateMarc2RTF(AddSpacesAroundDelimiters(FldTextWithOnlyCertainSubfields(sSubfieldsToInclude$, sSubfieldsToExclude$)), False)
                ' 20070111: need to include the wrapper for RTF, if requested
                If bIncludeRtfWrapper Then
                    sFontTbl$ = "{\fonttbl"
                    sFontTbl$ = sFontTbl$ + "{\f0\fswiss\fprq2\fcharset0 Arial Unicode MS;}"
                    sFontTbl$ = sFontTbl$ + "}"
                    sOut$ = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033" + sFontTbl$ + sColorTbl$ + "\viewkind4\uc1\pard\f0\fs" + Trim(str(iRtfFontSizeInPoints% * 2)) + " " & sOut$ & "\par}"
                End If
                FldTextFormatted = sOut$
            Case TextFormatted_RtfTextNormalizedNaco%
                bRtfNaco = True
FTF_RtfNormalizedOfSomeKind:
                ' we're going to do this one subfield at a time
                SfdMoveFirst
                Do
                    If InStr(sSubfieldsToInclude$, SfdCode) > 0 And InStr(sSubfieldsToExclude$, SfdCode) = 0 Then
                        If bRtfNaco Then
                            sOut$ = sOut$ + " " + MarcDelimiter + SfdCode + " " + SfdNormNaco
                        Else
                            sOut$ = sOut$ + " " + MarcDelimiter + SfdCode + " " + SfdNorm
                        End If
                    End If
                    If Not SfdMoveNext Then
                        Exit Do
                    End If
                Loop
                sOut$ = TranslateMarc2RTF(Trim(sOut$), False)
                ' 20070111: need to include the wrapper for RTF, if requested
                If bIncludeRtfWrapper Then
                    sFontTbl$ = "{\fonttbl"
                    sFontTbl$ = sFontTbl$ + "{\f0\fswiss\fprq2\fcharset0 Arial Unicode MS;}"
                    sFontTbl$ = sFontTbl$ + "}"
                    sOut$ = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033" + sFontTbl$ + sColorTbl$ + "\viewkind4\uc1\pard\f0\fs" + Trim(str(iRtfFontSizeInPoints% * 2)) + " " & sOut$ & "\par}"
                End If
                FldTextFormatted = sOut$
            Case TextFormatted_RtfTextNormalizedPlain%
                'bRtfNaco retains its default value of False
                GoTo FTF_RtfNormalizedOfSomeKind
            Case TextFormatted_RtfTextNoDelimiters%
                sOut$ = Trim(TranslateMarc2RTF(RemoveRepeatedCharacters(RemoveDelimiters(AddSpacesAroundDelimiters(FldTextWithOnlyCertainSubfields(sSubfieldsToInclude$, sSubfieldsToExclude$))), " "), False))
                ' 20070111: need to include the wrapper for RTF, if requested
                If bIncludeRtfWrapper Then
                    sFontTbl$ = "{\fonttbl"
                    sFontTbl$ = sFontTbl$ + "{\f0\fswiss\fprq2\fcharset0 Arial Unicode MS;}"
                    sFontTbl$ = sFontTbl$ + "}"
                    sOut$ = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033" + sFontTbl$ + sColorTbl$ + "\viewkind4\uc1\pard\f0\fs" + Trim(str(iRtfFontSizeInPoints% * 2)) + " " & sOut$ & "\par}"
                End If
                FldTextFormatted = sOut$
            Case TextFormatted_RtfTextWithLabels%
                sOut$ = TranslateMarc2RTF(TranslateDiacriticsIntoLabels(AddSpacesAroundDelimiters(FldTextWithOnlyCertainSubfields(sSubfieldsToInclude$, sSubfieldsToExclude$))), False)
                ' 20070111: need to include the wrapper for RTF, if requested
                If bIncludeRtfWrapper Then
                    sFontTbl$ = "{\fonttbl"
                    sFontTbl$ = sFontTbl$ + "{\f0\fswiss\fprq2\fcharset0 Arial Unicode MS;}"
                    sFontTbl$ = sFontTbl$ + "}"
                    sOut$ = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033" + sFontTbl$ + sColorTbl$ + "\viewkind4\uc1\pard\f0\fs" + Trim(str(iRtfFontSizeInPoints% * 2)) + " " & sOut$ & "\par}"
                End If
                FldTextFormatted = sOut$
            Case TextFormatted_SacoProposal%
                ' 20050712: do not include subfield $w (or other unlikely things)
                SfdMoveFirst
                Do
                    If InStr("0123456789w", SfdCode) = 0 Then
                        sOut$ = sOut$ + MarcDelimiter + SfdCode + SfdText
                    End If
                    If Not SfdMoveNext Then
                        Exit Do
                    End If
                Loop
                FldTextFormatted = ReplaceCharacters(ReplaceCharacters(Marc2SacoProposal(sOut$), "{(}", "("), "{)}", ")")
            Case TextFormatted_HexEquivalentsExcept880Raw%
                If FldTag = "880" Then
                    FldTextFormatted = ReplaceCharacters(AddSpacesAroundDelimiters(FldTextWithOnlyCertainSubfields(sSubfieldsToInclude$, sSubfieldsToExclude$)), MarcDelimiter, "|")
                Else
                    FldTextFormatted = Marc2HexDisplay(RemoveDelimiters(AddSpacesAroundDelimiters(FldTextWithOnlyCertainSubfields(sSubfieldsToInclude$, sSubfieldsToExclude$)), "|"))
                End If
        End Select
    Else ' are we pointed at a legitimated field?
        FldTextFormatted = ""
    End If
    
End Property


Public Property Get SfdTextFormatted(Optional iOutput As TextFormattedType = TextFormattedDefault) As String

    ' provide a displayable version of the current field's text
    
    Dim sOut$
    
    
#If SfdTextFormattedDebug = -1 Then
    Debug.Print "STF " + str(iOutput) + " fld " + str(FldPointer) + " sfd " + str(SfdPointer) + " at top " + str(m_bSfdAtTop)
#End If
    If FldPointer > -1 And SfdPointer > -1 And Not m_bSfdAtTop Then
        Select Case iOutput
            Case TextFormatted_HexEquivalents%
                SfdTextFormatted = Marc2HexDisplay(RemoveDelimiters(AddSpacesAroundDelimiters(SfdText), "|"))
            Case TextFormatted_Latin1NoDelimiters%
                SfdTextFormatted = Marc2MsoftAscii(RemoveDelimiters(AddSpacesAroundDelimiters(SfdText), ""), latin1)
            Case TextFormatted_Latin1%
                SfdTextFormatted = Marc2MsoftAscii(RemoveDelimiters(AddSpacesAroundDelimiters(SfdText), "|"), latin1)
            Case TextFormatted_Raw
                SfdTextFormatted = ReplaceCharacters(AddSpacesAroundDelimiters(SfdText), MarcDelimiter, "|")
            Case TextFormatted_Latin1WithDots%
                SfdTextFormatted = Marc2MsoftAscii(RemoveDelimiters(AddSpacesAroundDelimiters(SfdText), "|"), Latin1TextWithDots)
            Case TextFormatted_PlainText%
                SfdTextFormatted = Marc2PlainText(SfdText)
            Case TextFormatted_Latin1Extended%
                SfdTextFormatted = Marc2MsoftAscii(RemoveDelimiters(AddSpacesAroundDelimiters(SfdText), "|"), Latin1extended)
            Case TextFormatted_SacoProposal%
                ' 20050712: do not include subfield $w (or other unlikely things)
                SfdMoveFirst
                Do
                    If InStr("0123456789w", SfdCode) = 0 Then
                        sOut$ = sOut$ + MarcDelimiter + SfdCode + SfdText
                    End If
                    If Not SfdMoveNext Then
                        Exit Do
                    End If
                Loop
                SfdTextFormatted = ReplaceCharacters(ReplaceCharacters(Marc2SacoProposal(sOut$), "{(}", "("), "{)}", ")")
            Case TextFormatted_HexEquivalentsExcept880Raw%
                If FldTag = "880" Then
                    SfdTextFormatted = ReplaceCharacters(AddSpacesAroundDelimiters(SfdText), MarcDelimiter, "|")
                Else
                    SfdTextFormatted = Marc2HexDisplay(RemoveDelimiters(AddSpacesAroundDelimiters(SfdText), "|"))
                End If
        End Select
    Else
        SfdTextFormatted = ""
    End If
    
End Property

Public Function Marc2SacoProposal(ByVal sIn$) As String

    ' 20041129 added
    ' theoretically, this is a reversible bit; but we're not going to write the reverse
    '   unless someone actually needs it
    
    
    Dim sJunk$, sFiller$, sOut$, sMarc8CharacterSetCode$, sMarc8Character$, sCurrentCharacterSetCode$
    
    Dim iLen%
    
    Dim lPtr As Long, lChr As Long, lLength As Long
    
    Dim bCharacterChanged As Boolean, bCharacterError As Boolean, bDiacritics As Boolean
    
    
#If Marc2SacoProposalDebug = -1 Then
    Debug.Print "M2SP: " + sIn$ + "<"
#End If

    If Len(sIn$) = 0 Then
        Marc2SacoProposal = ""
        Exit Function
    End If
    
    sIn$ = ReplaceCharacters(Trim(AddSpacesAroundDelimiters(sIn$)), MarcDelimiter$, "$")
#If Marc2SacoProposalDebug = -1 Then
    Debug.Print "After replacement: " + sIn$ + "<"
#End If
    
    If Not m_bUtf8 Then
Marc2SacoProposalReadyForTranslation:
        'NOT UNICODE
        For lPtr = Len(sIn$) To 1 Step -1
            lChr = Asc(Mid(sIn$, lPtr, 1))
            Select Case lChr
                'Case 31 ' delimiter
                '    sIn$ = SafeStuff(sIn$, lPtr, 1, "$")
                '    ' add spaces around the delimiter, too
                '    If Mid(sIn$, lPtr + 2, 1) <> " " Then
                '        sIn$ = SafeStuff(sIn$, lPtr + 2, 0, " ")
                '    End If
                '    If lPtr > 1 Then
                '        If Mid(sIn$, lPtr - 1, 1) <> " " Then
                '            sIn$ = SafeStuff(sIn$, lPtr, 0, " ")
                '        End If
                '    End If
                Case Is < 128
                    ' keep all of these as found except the parens
                    Select Case lChr
                        Case 40
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}")
                        Case 41
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{)}")
                    End Select
                Case Is < 160
                    Select Case lChr
                        Case 144 ' degree sign
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "deg. ")
                        Case 145 ' script l
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}l") ' not in SACO conventions
                        Case 146 ' pressing
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}p{)}") ' not in SACO conventions
                        Case 147 ' copyright
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(169)) ' not in SACO conventions
                        Case 148 ' sharp
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "#") ' not in SACO conventions
                        Case 149 ' inverted question mark
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(191)) ' not in SACO conventions
                        Case 150 ' inverted bang
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(161)) ' not in SACO conventions
                        Case Else
                            sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                    End Select
                Case Is < 176
                    Select Case lChr
                        Case 160
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "l") ' not in SACO conventions
                        Case 161
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}slash L{)}")
                        Case 162
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}slash O{)}")
                        Case 163 ' slash-D
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}slash D{)}")
                        Case 164 ' thorn
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}Thorn{)}")
                        Case 165 ' AE
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}AE{)}")
                        Case 166 ' OE
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}OE{)}")
                        Case 167 ' miag. znak
                            ' 20050210: attempt to replace those used in geographic
                            '   coordinates with an abbreviation
                            If lPtr > 1 Then
                                If InStr("0123456789", Mid(sIn$, lPtr - 1, 1)) > 0 Then
                                    sIn$ = SafeStuff(sIn$, lPtr, 1, "min. ")
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}miagkii znak{)}")
                                End If
                            Else
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}miagkii znak{)}")
                            End If
                        Case 168 ' dot centere
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}dot center{)}")
                        Case 169
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "flat") ' not in SACO conventions
                        Case 170 ' registered
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}r{)}") ' not in SACO conventions
                        Case 171 ' plus/minus
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(177)) ' not in SACO conventions
                        Case 172 ' hook-O
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}O hook{)}")
                        Case 173 'hook-U
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}U hook{)}")
                        Case 174 ' alif
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "alif")
                        Case 175 ' alpha
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "alpha ") ' not in SACO conventions
                        Case Else
                            sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                    End Select
                Case Is < 192
                    Select Case lChr
                        Case 176 ' ayn
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}ayn{)}")
                        Case 177 ' slash-l
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}slash l{)}")
                        Case 178 ' slash-o
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}slash o{)}")
                        Case 179 ' lower-case slash-d
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}slash d{)}")
                        Case 180 ' lowercase thorn
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}thorn{)}")
                        Case 181 'ae
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}ae{)}")
                        Case 182 ' oe
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}oe{)}")
                        Case 183 'tverd. znak
                            If lPtr > 1 Then
                                If InStr("0123456789", Mid(sIn$, lPtr - 1, 1)) > 0 Then
                                    sIn$ = SafeStuff(sIn$, lPtr, 1, "sec. ")
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}tvyerdi znak{)}")
                                End If
                            Else
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}tvyerdi znak{)}")
                            End If
                        Case 184 ' turkish dotless i
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}undotted i{)}")
                        'Case 185 ' pound sign
                            'sIn$ = SafeStuff(sIn$, lPtr, 2, Chr(163)) ' not in SACO conventions
                        Case 186 ' eth
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}eth{)}")
                        Case 188 ' hook o
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}o hook{)}")
                        Case 189 ' hook u
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}u hook{)}")
                        Case 190 ' beta
                            If m_sCharacterSetOut$ = "V" Then
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "beta ")
                            Else
                                ' should only occur in OCLC
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "l") ' not in SACO conventions
                            End If
                        Case 191 ' gamma
                            sIn$ = SafeStuff(sIn$, lPtr, 1, " gamma ")
                        Case Else
                            sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                    End Select
                Case Is < 208
                    If m_sCharacterSetOut$ = "V" Then
                        Select Case lChr
                            Case 192
                                ' 20050210: if it appears that we're doing coordinates, use
                                '   'deg' instead of making a simple substitution
                                If lPtr > 0 Then
                                    If InStr("0123456789", Mid(sIn$, lPtr - 1, 1)) > 0 Then
                                        sIn$ = SafeStuff(sIn$, lPtr, 1, "deg. ")
                                    Else
                                        sIn$ = SafeStuff(sIn$, lPtr, 1, "0") ' not in SACO conventions
                                    End If
                                Else
                                    sIn$ = SafeStuff(sIn$, lPtr, 1, "0") ' not in SACO conventions
                                End If
                            Case 193
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "1") ' not in SACO conventions
                            Case 194
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "2") ' not in SACO conventions
                            Case 195
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "3") ' not in SACO conventions
                            Case 196
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "4") ' not in SACO conventions
                            Case 197
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "5") ' not in SACO conventions
                            Case 198
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "6") ' not in SACO conventions
                            Case 199
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "7") ' not in SACO conventions
                            Case 200
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "8") ' not in SACO conventions
                            Case 201
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "9") ' not in SACO conventions
                            Case 202
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "+") ' not in SACO conventions
                            Case 203
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "-") ' not in SACO conventions
                            Case 204
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}") ' not in SACO conventions
                            Case 205
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "{)}") ' not in SACO conventions
                            Case Else
                                sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                        End Select
                    Else ' OCLC or MARC character sets
                        Select Case lChr
                            Case 192 ' degree sign
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "deg. ")
                            Case 193 ' script l
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}l") ' not in SACO conventions
                            Case 194 ' pressing
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}p{)}") ' not in SACO conventions
                            Case 195 ' copyright
                                sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(169)) ' not in SACO conventions
                            Case 196 ' sharp
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "#") ' not in SACO conventions
                            Case 197 ' inverted question mark
                                sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(191)) ' not in SACO conventions
                            Case 198 ' inverted bang
                                sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(161)) ' not in SACO conventions
                            Case Else
                                sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                        End Select
                    End If
                Case Is < 224
                    ' should not occur if OCLC or MARC
                    Select Case lChr
                        Case 208
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "0") ' not in SACO conventions
                        Case 209
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "1") ' not in SACO conventions
                        Case 210
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "2") ' not in SACO conventions
                        Case 211
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "3") ' not in SACO conventions
                        Case 212
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "4") ' not in SACO conventions
                        Case 213
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "5") ' not in SACO conventions
                        Case 214
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "6") ' not in SACO conventions
                        Case 215
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "7") ' not in SACO conventions
                        Case 216
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "8") ' not in SACO conventions
                        Case 217
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "9") ' not in SACO conventions
                        Case 218
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "+") ' not in SACO conventions
                        Case 219
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "-") ' not in SACO conventions
                        Case 220
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}") ' not in SACO conventions
                        Case 221
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{)}") ' not in SACO conventions
                        Case Else
                            sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                    End Select
                Case Else ' two columns at once!
                    Select Case lChr
                        Case 225 ' grave
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}grave{)}")
                        Case 226 ' acute
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}acute{)}")
                        Case 227 ' circumflex
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}circumflex{)}")
                        Case 228 ' tilde
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}tilde{)}")
                        Case 229
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}macron{)}")
                        Case 230
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}breve{)}")
                        Case 231
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}dot above{)}")
                        Case 232 ' umlaut
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}umlaut{)}")
                        Case 233 ' hacek
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}hacek{)}")
                        Case 234 ' angstrom
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "deg") ' unclear in SACO conventions
                        Case 235
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}left ligature{)}")
                        Case 236
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}right ligature{)}")
                        Case 237
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}comma off{)}")
                        Case 238
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}double acute{)}")
                        Case 239 ' candrabindu
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "") ' not in SACO conventions
                        Case 240 ' cedilla
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}cedilla{)}")
                        Case 241
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}right hook{)}")
                        Case 242
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}dot below{)}")
                        Case 243
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}double dot below{)}")
                        Case 244 ' circle below
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "") ' not in SACO conventions
                        Case 245 ' double underscore
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "") ' not in SACO conventions
                        Case 246 ' wrong underscore
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "_") ' not in SACO conventions
                        Case 247
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}left hook{)}")
                        Case 248
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}right cedilla{)}")
                        Case 249 ' upad ...
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "") ' not in SACO conventions
                        Case 250
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}double tilde 1{)}")
                        Case 251
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "{(}double tilde 2{)}")
                        Case Else
                            sIn$ = SafeStuff(sIn$, lPtr, 1, sFiller$)
                    End Select
            End Select ' the main groups
        Next ' lPtr
    
    Else ' UTF-8 character representation
    
        lPtr = Len(sIn$)
        Do
            ' starting from the right, find the first octet of this character
            lPtr = MyMarcCharacter.Utf8CharFindFirstOctet(sIn$, lPtr)
            ' translate this one character
            MyMarcCharacter.TranslateUtf82MarcOneCharacter "V", sMarc8CharacterSetCode$, Mid(sIn$, lPtr, MyMarcCharacter.Utf8CharOctets(Mid(sIn$, lPtr, 1))), sMarc8Character$, bCharacterChanged, bCharacterError
            
            If InStr(CHARACTERSET_Non880$, sMarc8CharacterSetCode$) > 0 Then
Marc2SacoProposalTextOK:
                If sCurrentCharacterSetCode$ <> sMarc8CharacterSetCode$ Then
                    Select Case sCurrentCharacterSetCode$
                        Case "1"
                            sOut$ = MarcEscape + "s" + sOut$
                        Case "2"
                            sOut$ = MarcEscape + "g" + sOut$
                        Case "3"
                            sOut$ = MarcEscape + "b" + sOut$
                        Case "4"
                            sOut$ = MarcEscape + "p" + sOut$
                    End Select
                    sCurrentCharacterSetCode$ = sMarc8CharacterSetCode$
                End If
                If InStr(Marc8DiacriticsAbove$, sMarc8Character$) > 0 Then
                    TranslateAddOneDiacriticToArray sMarc8Character$, Marc8Diacritics$
                    bDiacritics = True
                ElseIf InStr(Marc8DiacriticsOther$, sMarc8Character$) > 0 Then
                    TranslateAddOneDiacriticToArray sMarc8Character$, Marc8Diacritics$
                    bDiacritics = True
                Else
                    ' normal character; stick it on to the growing string
                    sOut$ = sMarc8Character$ + sOut$
                    ' any accumulated diacritics come before this letter
                    If bDiacritics Then
                        If sCurrentCharacterSetCode$ <> "1" Then
                            sOut$ = MarcEscape + sCurrentCharacterSetCode$ + sOut$
                            sCurrentCharacterSetCode$ = "1"
                        End If
                        sOut$ = TranslateSortAndReturnDiacriticArray() + sOut$
                        bDiacritics = False
                    End If
                End If
            ElseIf InStr(CHARACTERSET_GreekCodes$, sMarc8CharacterSetCode$) > 0 Then
                If sMarc8Character$ = MarcAlpha Or sMarc8Character$ = MarcBeta Or sMarc8Character$ = MarcGamma Then
                    ' these three are allowed in non-880 fields
                    GoTo Marc2SacoProposalTextOK
                End If
            End If
        
            ' lptr is currently on the forst octet of the utf8 character; back up into the previous
            '   character and continue
            lPtr = lPtr - 1
            
            If lPtr < 1 Then
                Exit Do
            End If
        Loop
    
        sIn$ = sOut$
        GoTo Marc2SacoProposalReadyForTranslation
        
    End If
    
    sIn$ = RemoveRepeatedCharacters(Trim(sIn$), " ")
    If Mid(sIn$, 1, 2) = "$a" Then
        sIn$ = Trim(Mid(sIn$, 3))
    End If
    
    Marc2SacoProposal$ = sIn$
    

End Function

Public Property Get SortingIndicatorFor653Field() As String

    SortingIndicatorFor653Field = gblsSortingIndicatorFor653Field$

End Property

Public Property Let SortingIndicatorFor653Field(ByVal vNewValue As String)

    gblsSortingIndicatorFor653Field$ = Trim(vNewValue)
    Select Case Len(gblsSortingIndicatorFor653Field$)
        Case 0
            gblsSortingIndicatorFor653Field$ = DefaultSortingIndicatorFor653Field$
        Case 1
            ' these are temporarily OK
        Case Else
            gblsSortingIndicatorFor653Field$ = Mid(gblsSortingIndicatorFor653Field$, 1, 1)
    End Select
    If InStr("0123456789", gblsSortingIndicatorFor653Field$) = 0 Then
        gblsSortingIndicatorFor653Field$ = DefaultSortingIndicatorFor653Field$
    End If
    
End Property

Private Sub DecomposeUnicodeCharacters()

    ' 20050204: we've been handed a record that's allegedly Unicode UTF-8 as defined
    '   for MARC
    ' scan through the record, and replace any pre-composed characters with their
    '   legal decomposed MARC equivalents
    ' we're going to allow *anything* in 880 fields, at least for now!
    
    Dim bChanged As Boolean
    
    Dim sField$
    
    Static bVoyagerTested As Boolean
    Static bSkipTranslation As Boolean
    
    
    ' 20080122: if the operator has selected "no decomposition" for the Voyager
    '   cataloging client, then we'll behave the same way here
    If bSkipTranslation Then
        Exit Sub
    End If
    If Not bVoyagerTested Then
        bVoyagerTested = True
        sField$ = RegGetValue(MAIN_KEY_CURRENTUSER, "Software\VB and VBA Program Settings\VoyagerCat\Preferences", "BypassAutoDecompose")
        If UCase(sField$) = "TRUE" Then
            bSkipTranslation = True
            Exit Sub
        End If
    End If
    
    FldMoveTop
    
#If DecomposeUnicodeCharactersDebug = -1 Then
    Debug.Print "DUC entry"
#End If
    
    Do While FldMoveNext
        bChanged = False
        Select Case FldTag
            Case "000" To "009"
                ' do nothing with these--should not contain any funny characters
            Case Else ' including the 880
#If DecomposeUnicodeCharactersDebug = -1 Then
                Debug.Print "Decomposing " + FldTag + " " + CharToHex(FldText)
#End If
                sField$ = DecomposeUnicodeCharactersInString(FldText, bChanged)
#If DecomposeUnicodeCharactersDebug = -1 Then
                Debug.Print "                " + CharToHex(sField$)
#End If
        End Select
        ' if we made any substitutions, replace the field's text
        If bChanged Then
            FldText = sField$
        End If
    Loop
    
End Sub

Public Function Marc2OclcScreenFont(ByVal sField$) As String
    
    ' convert the supplied string in the current character set into
    '   the character set used for OCLC screen display
    
    ' this is a public function, so we can call it externally
    ' NOTE however that behavior is still conditioned on the
    '   value given for CharacterSetOut: we assume that the
    '   character set of the input string uses
    '   to that convention

    ' NOTE that this won't work properly for 880 fields, of course; and
    '   it'll be bad to use this on Unicode strings until we've got Unicode
    '   working properly
    
    Dim sDiacriticsAbove$, sDiacriticsOther$, sChar$
    
    Dim bDiacritics As Boolean, bChanged As Boolean
    
    Dim iPtr%
    
    Dim lPtr As Long
    
    
    On Error Resume Next
    
    Select Case CharacterSetOut
        Case CHARACTERSET_Voyager$
M2osfNormal:
           For lPtr = Len(sField$) To 1 Step -1
              DoEvents
              sChar$ = Mid(sField$, lPtr, 1)
              Select Case Asc(sChar$)
                 Case Is < 128
                    If sChar$ = MarcDelimiter Then
                       sField$ = SafeStuff(sField$, lPtr, 1, m_sOclcScreenDelim$)
                    End If
                    If bDiacritics Then
                       sField$ = SafeStuff(sField$, lPtr + 2, 0, sDiacriticsAbove$ + sDiacriticsOther$)
                       bDiacritics = False
                       sDiacriticsAbove$ = ""
                       sDiacriticsOther$ = ""
                    End If
                 Case Is > 223
                    sField$ = SafeStuff(sField$, lPtr, 1, "")
                    If InStr(Marc8DiacriticsAbove$, sChar$) > 0 Then
                       sDiacriticsAbove$ = sDiacriticsAbove$ + sChar$
                    Else
                       sDiacriticsOther$ = sDiacriticsOther$ + sChar$
                    End If
                    bDiacritics = True
                 Case Else ' above Ascii maximum and not a diacritic--must be a special character
                    'Debug.Print str(lPtr) + " special? " + sChar$ + " " + str(bDiacritics)
                    If bDiacritics Then
                       sField$ = SafeStuff(sField$, lPtr + 2, 0, sDiacriticsAbove$ + sDiacriticsOther$)
                       bDiacritics = False
                       sDiacriticsAbove$ = ""
                       sDiacriticsOther$ = ""
                    End If
                    iPtr% = InStr(m_sVoyagerAllowsOclcDoesNot$, sChar$)
                    If iPtr% > 0 Then
                        sChar$ = Mid(m_sVoyagerAllowsOclcDoesNot$, iPtr% + 1)
                        iPtr% = InStr(sChar$, " ")
                        If iPtr% > 0 Then
                            sChar$ = Mid(sChar$, 1, iPtr% - 1)
                        End If
                        sField$ = SafeStuff(sField$, lPtr, 1, sChar$)
                    Else
                        iPtr% = InStr(m_sVoyagerGreeksEtc$, sChar$)
                        If iPtr% > 0 Then
                            sField$ = SafeStuff(sField$, lPtr, 1, Mid(m_sOclcGreeksEtc$, iPtr%, 1))
                        End If
                    End If
              End Select
           Next
        
           If bDiacritics Then
              sField$ = sField$ + sDiacriticsAbove$ + sDiacriticsOther$
           End If
                
        Case CHARACTERSET_OCLC$
        
            SetUpTranslation OclcToVoyager
            TranslateRemainder sField$, bChanged
            GoTo M2osfNormal
            
        Case CHARACTERSET_MARC$
        
            SetUpTranslation MarcToVoyager
            TranslateRemainder sField$, bChanged
            GoTo M2osfNormal
            
        Case CHARACTERSET_Utf8$
        
            ' todo: back-translate, then loop up as above
            
    End Select
    
    'Debug.Print "Out >" + sField$ + "<"
    
    Marc2OclcScreenFont = sField$
    
    'Print #iDebug%, "M2OSF exit"
    'Close #iDebug%
    
End Function

Public Function OclcScreenFont2Marc(ByVal sField$) As String

    ' this is a public function, so we can call it externally
    ' NOTE however that behavior is still conditioned on the
    '   value given for CharacterSetOut: we assume that the
    '   character set of the output string uses
    '   that convention
    
    ' translate characters in the OCLC on-screen display into
    '   MARC equivalents
    ' because the OCLC screen display closely follows MARC, we only
    '   have to worry about certain other characters
    ' changes will no doubt be needed when OCLC moves to Unicode
       
    ' NOTE that because all diacritics and special characters have the same
    '   on-screen and USMARC values, we only have to worry about the
    '   oddities: delimiter, and the 'escape' characters
    ' ALSO (added 980204): the fill character!
   
    ' for ease of translation (one-for-one exchange), we're converting strings in all cases to the
    '   Voyager character set
    ' at the end, we push this into whatever else might be needed


    Dim iCtr%, iCtr2%
    Dim sTest$, sDiacriticsAbove$, sDiacriticsOther$
   
    Dim bDiacritics As Boolean, bChanged As Boolean
    
    
    For iCtr% = Len(sField$) To 1 Step -1
        sTest$ = Mid(sField$, iCtr%, 1)
        Select Case Asc(sTest$)
            Case 2
                sField$ = SafeStuff(sField$, iCtr%, 1, MyMarcCharacter.Marc8Alif)
            Case Is < 128 ' "normal" stuff
                ' leave the character alone; but insert any diacritics just ahead of
                '   it (then we'll loop up and move one to the left, so we don't
                '   need to worry about double-inspection or anything silly like that)
                If bDiacritics Then
                    sField$ = SafeStuff(sField$, iCtr%, 0, sDiacriticsOther$ + sDiacriticsAbove$)
                    bDiacritics = False
                    sDiacriticsAbove$ = ""
                    sDiacriticsOther$ = ""
                End If
            Case Is > 223 ' diacritics etc
                If InStr(Marc8DiacriticsAbove$, sTest$) > 0 Then
                    sDiacriticsAbove$ = sTest$ + sDiacriticsAbove$
                Else
                    sDiacriticsOther$ = sTest$ + sDiacriticsOther$
                End If
                bDiacritics = True
                sField$ = SafeStuff(sField$, iCtr%, 1, "")
            Case Else ' high-end; maybe a problem
                iCtr2% = InStr(m_sOclcGreeksEtc$, sTest$)
                If iCtr2% > 0 Then
                    sField$ = SafeStuff(sField$, iCtr%, 1, Mid(m_sVoyagerGreeksEtc$, iCtr2%, 1))
                End If
                If bDiacritics Then
                    sField$ = SafeStuff(sField$, iCtr%, 0, sDiacriticsAbove$ + sDiacriticsOther$)
                    bDiacritics = False
                    sDiacriticsAbove$ = ""
                    sDiacriticsOther$ = ""
                End If
        End Select
    Next

    Select Case CharacterSetOut
        Case CHARACTERSET_Voyager$
            ' do nothing: already in this set
        Case CHARACTERSET_OCLC$
            SetUpTranslation VoyagerToOclc
            TranslateRemainder sField$, bChanged
        Case CHARACTERSET_MARC$
            SetUpTranslation VoyagerToMarc
            TranslateRemainder sField$, bChanged
        Case CHARACTERSET_Utf8$
            ' todo
    End Select
    
    OclcScreenFont2Marc = sField$

End Function

Public Property Get IsMarcErrorText() As String

    IsMarcErrorText = m_sIsMarcErrorText$
    
End Property


Private Sub TranslateAddOneDiacriticToArray(ByVal sChar$, ByVal sTable$)

    ' 20050314: added
    ' this receives one diacritic (which may be either MARC8 or UTF8) and
    '   adds it to an array; later on we'll sort the array by
    '   combining class (and maybe also the sequential number) and
    '   add the resulting string to a string that's a-building
    
    
    Dim iRc%
    
    
    iRc% = InStr(sTable$, sChar$)
    If iRc% = 0 Then
        Exit Sub
    End If
    
    m_iDiacriticLast% = m_iDiacriticLast% + 1
    If m_iDiacriticLast% > m_iDiacriticMax% Then
        m_iDiacriticMax% = m_iDiacriticMax% + 5
        ReDim Preserve m_aDiacritic(0 To m_iDiacriticMax%)
    End If
    With m_aDiacritic(m_iDiacriticLast%)
        .Diacritic = sChar$
        .Order = m_iDiacriticLast%
        .CombiningClass = Val(Mid(sTable$, iRc% + Len(sChar$), 3))
    End With
    
End Sub

Private Function TranslateSortAndReturnDiacriticArray() As String

    Dim iCtr%, iLast%
    
    Dim bChanged As Boolean

    Dim sOutput$
    
    Dim Flip As DIACRITICARRAYTYPE
    
    
    ' default value: nothing
    TranslateSortAndReturnDiacriticArray = ""
    
    Select Case m_iDiacriticLast%
        Case 0
            ' return nothing
            TranslateSortAndReturnDiacriticArray = ""
        Case 1
            ' most common case: return the one diacritic
            TranslateSortAndReturnDiacriticArray = m_aDiacritic(1).Diacritic
        Case Else
            ' more than one diacritic
            ' sort the array by combining class, reversing the
            '   order of things in class 230
            iLast% = m_iDiacriticLast% - 1
            Do
                bChanged = False
                For iCtr% = 1 To iLast%
                    If m_aDiacritic(iCtr%).CombiningClass > m_aDiacritic(iCtr%).CombiningClass Then
TranslateSortAndReturnDiacriticArrayFlip:
                        Flip = m_aDiacritic(iCtr%)
                        m_aDiacritic(iCtr%) = m_aDiacritic(iCtr% + 1)
                        m_aDiacritic(iCtr% + 1) = Flip
                        bChanged = True
                    ElseIf m_aDiacritic(iCtr%).CombiningClass = 230 Then
                        If m_aDiacritic(iCtr% + 1).CombiningClass = 230 Then
                            ' the two categories are the same and they're both
                            '   class #230: diacritics above the letter; reverse the order
                            If m_aDiacritic(iCtr%).Order < m_aDiacritic(iCtr% + 1).Order Then
                                GoTo TranslateSortAndReturnDiacriticArrayFlip
                            End If
                        End If
                    End If
                Next
                If Not bChanged Then
                    Exit Do
                End If
                iLast% = iLast% - 1
                If iLast% < 1 Then
                    Exit Do
                End If
            Loop
            
            ' generate the final output string
            For iCtr% = 1 To m_iDiacriticLast%
                sOutput$ = sOutput$ + m_aDiacritic(iCtr%).Diacritic
            Next ' ictr%
            
            TranslateSortAndReturnDiacriticArray = sOutput$
            
    End Select

    m_iDiacriticLast% = 0

End Function

Public Property Get Directory() As String

    Directory = m_sDirectory$

End Property


Private Sub SeeIfSortOrderChanged()

    ' you've just read in a brand-new MARC record supplied
    '   by the outside
    ' read through the array of fields and subfields, and
    '   see if the fields and subfields are in the order they were
    '   in the source record, or if they've been changed due to
    '   field or subfield sort rules
    
    Dim iCtr%, iCtr2%
    
    'Debug.Print "SISOC"
    Dim bDebug As Boolean
    
    'If FldFindFirst("590") Then
    '    bDebug = True
    'End If
    
    For iCtr% = 0 To m_iMarcCtr% - 1
        'If bDebug Then
        '    Debug.Print str(iCtr%) + " " + MarcArray(iCtr%).Tag + " " + str(MarcArray(iCtr%).NextField)
        'End If
        If MarcArray(iCtr%).NextField <> iCtr% + 1 And MarcArray(iCtr%).NextField <> -1 Then
            'If bDebug Then
            '    Debug.Print "FLD CHANGED"
            'End If
#If MarcRecordModifiedDebug = -1 Then
            Debug.Print "MRM see if sort order changed"
#End If
            m_bMarcRecordModified = True
            Exit For
        End If
        For iCtr2% = 0 To MarcArray(iCtr%).SubfieldLast - 1
            'If bDebug Then
            '    Debug.Print vbTab + str(iCtr2%) + " " + MarcArray(iCtr%).Subfield(iCtr2%).Code + " " + str(MarcArray(iCtr%).Subfield(iCtr2%).NextSubfield)
            'End If
            If MarcArray(iCtr%).Subfield(iCtr2%).NextSubfield <> iCtr2% + 1 And MarcArray(iCtr%).Subfield(iCtr2%).NextSubfield <> -1 Then
                'If bDebug Then
                '    Debug.Print "SFD CHANGED"
                'End If
#If MarcRecordModifiedDebug = -1 Then
                Debug.Print "MRM see if sort order changed 2"
#End If
                m_bMarcRecordModified = True
                GoTo SeeIfSortOrderChangedDone
            End If
            If MarcArray(iCtr%).Subfield(iCtr2%).NextSubfield = -1 Then
                Exit For
            End If
        Next ' ictr2%
        If MarcArray(iCtr%).NextField = -1 Then
            Exit For
        End If
    Next ' ictr%
SeeIfSortOrderChangedDone:
        
    
End Sub


Private Function XmlRecordOutMadsField(ByVal sAuthority$, Optional ByVal bForceAuthority As Boolean = False) As String

    ' we arrive here with FldPointer already set to the field of interest
    
    Dim sOut$, sName$, sTitle$, sType$
    
    Select Case Mid(FldTag, 2, 2)
        Case "00"
            sType$ = "personal"
            Select Case Mid(FldInd, 1, 1)
                Case "0"
                    sName$ = XmlRecordOutOneLump("namePart type=" + AddQuotes("given"), 0, "aq", "", " ")
                Case "3"
                    sName$ = XmlRecordOutOneLump("namePart type=" + AddQuotes("family"), 0, "aq", "", " ")
                Case Else ' normal surname/forename thing: no type attribute
                    sName$ = XmlRecordOutOneLump("namePart", 0, "aq", "", " ")
            End Select
            SfdMoveTop
            sName$ = sName$ + XmlRecordOutOneLump("namePart type=" + AddQuotes("termsOfAddress"), 0, "bc", "", " ")
            If SfdFindFirst("d") Then
                sName$ = sName$ + XmlRecordOutOneLump("namePart type=" + AddQuotes("date"), 0, "d", "", " ")
            End If
            ' we're going to ignore $e, $4 and $u
            'If SfdFindFirst("e") Then
            '    sName$ = sName$ + XmlRecordOutOneLump("role type=" + AddQuotes("text"), 0, "e", "", " ")
            'End If
            'If SfdFindFirst("4") Then
            '    sName$ = sName$ + XmlRecordOutOneLump("role type=" + AddQuotes("code"), 0, "4", "", " ")
            'End If
            'If SfdFindFirst("u") Then
            '    sName$ = sName$ + XmlRecordOutOneLump("affiliation", 0, "u", "", " ")
            'End If
XROMFAddNameTag:
            If Len(sAuthority$) > 0 Then
                sName$ = "<name type=" + AddQuotes(sType$) + " authority=" + AddQuotes(sAuthority$) + ">" + sName$ + "</name>"
            Else
                sName$ = "<name type=" + AddQuotes(sType$) + ">" + sName$ + "</name>"
            End If
XROMFAddTitlePortion:
            If SfdFindFirst("t") Then
                sTitle$ = XmlRecordOutOneLump("title", 0, "tfgklmors", "np", " ")
            End If
            ' tack on $n and $p if present
            GoTo XROMFAddTitleNAndP
        Case "10"
            sType$ = "corporate"
            sName$ = XmlRecordOutOneLump("namePart", 0, "a", "", " ")
            SfdMoveTop
            Do While SfdFindNext("b")
                sName$ = sName$ + XmlRecordOutOneLump("namePart", 0, "b", "b", " ")
            Loop
            SfdMoveTop
            sName$ = sName$ + XmlRecordOutOneLump("namePart", 0, "cdnp", "", " ")
            ' we're going to ignore $e, and $4
            'If SfdFindFirst("e") Then
            '    sName$ = sName$ + XmlRecordOutOneLump("role type=" + AddQuotes("text"), 0, "e", "", " ")
            'End If
            'If SfdFindFirst("4") Then
            '    sName$ = sName$ + XmlRecordOutOneLump("role type=" + AddQuotes("code"), 0, "4", "", " ")
            'End If
            GoTo XROMFAddNameTag ' and then any title portion
        Case "11"
            sType$ = "conference"
            sName$ = XmlRecordOutOneLump("namePart", 0, "ancdeqp", "", " ")
            ' we're going to ignore $4
            'If SfdFindFirst("4") Then
            '    sName$ = sName$ + XmlRecordOutOneLump("role type=" + AddQuotes("code"), 0, "4", "", " ")
            'End If
            GoTo XROMFAddNameTag ' and then any title portion
        Case "30"
            sType$ = "title"
            ' this doesn't actually have a "name" portion at all
            If Len(sAuthority$) > 0 Then
                sTitle$ = XmlRecordOutOneLump("title authority=" + AddQuotes(sAuthority$), 0, "adfhklor", "np", " ")
            Else
                sTitle$ = XmlRecordOutOneLump("title", 0, "adfhklor", "np", " ")
            End If
XROMFAddTitleNAndP:
            SfdMoveTop
            Do While SfdMoveNext
                Select Case SfdCode
                    Case "n"
                        sTitle$ = sTitle$ + XmlRecordOutOneLump("partNumber", 0, "ndfhklmor", "np")
                    Case "p"
                        sTitle$ = sTitle$ + XmlRecordOutOneLump("partName", 0, "pdfhklmor", "np")
                End Select
            Loop
        Case "48"
            sType$ = "temporal"
            If Len(sAuthority$) > 0 Then
                sName$ = XmlRecordOutOneLump("temporal authority=" + AddQuotes(sAuthority$), 0, "a", "", " ")
            Else
                sName$ = XmlRecordOutOneLump("temporal", 0, "a", "", " ")
            End If
        Case "50"
            sType$ = "topic"
            If Len(sAuthority$) > 0 Then
                sName$ = XmlRecordOutOneLump("topic authority=" + AddQuotes(sAuthority$), 0, "abcd", "", " ")
            Else
                sName$ = XmlRecordOutOneLump("topic", 0, "abcd", "", " ")
            End If
        Case "51"
            sType$ = "geographic"
            If SfdFindFirst("a") Then
                If Len(sAuthority$) > 0 Then
                    sName$ = XmlRecordOutOneLump("geographic authority=" + AddQuotes(sAuthority$), 0, "a", "", " ")
                Else
                    sName$ = "<geographic>" + XmlConditionText(SfdText) + "</geographic>"
                End If
            End If
        Case "55"
            sType$ = "genre"
            If SfdFindFirst("a") Then
                If Len(sAuthority$) > 0 Then
                    sName$ = XmlRecordOutOneLump("genre authority=" + AddQuotes(sAuthority$), 0, "a", "", " ")
                Else
                    sName$ = "<genre>" + XmlConditionText(SfdText) + "</genre>"
                End If
            End If
        Case Else ' including subdivision records
            XmlRecordOutMadsField = ""
            Exit Function
    End Select
        
    sOut$ = sName$ + sTitle$
    
    SfdMoveTop
    Do While SfdMoveNext
        If InStr("v", SfdCode) > 0 Then
            sOut$ = sOut$ + XmlRecordOutOneLump("genre", 0, SfdCode, "v", " ")
        End If
    Loop
    SfdMoveTop
    Do While SfdMoveNext
        If InStr("x", SfdCode) > 0 Then
            sOut$ = sOut$ + XmlRecordOutOneLump("topic", 0, SfdCode, "x", " ")
        End If
    Loop
    SfdMoveTop
    Do While SfdFindNext("y")
        sOut$ = sOut$ + XmlTags("temporal", XmlConditionText(SfdText))
    Loop
    SfdMoveTop
    Do While SfdFindNext("z")
        sOut$ = sOut$ + XmlTags("geographic", XmlConditionText(SfdText))
    Loop

    XmlRecordOutMadsField = sOut$
    
End Function

Private Sub TranslateMarc2Utf8OneFieldFindBreak(ByRef sWork$, ByRef sPiece$, ByVal sCharacterSet0$, ByVal sCharacterSet1$, ByRef sNextCharacterSet0$, ByRef sNextCharacterSet1$)

    Dim iEscape%, iCtr%
    
    Dim sLeft$, sIncomingNextSet0$, sIncomingNextSet1$
    
    Dim bDebug As Boolean
    
    
    sIncomingNextSet0$ = sNextCharacterSet0$
    sIncomingNextSet1$ = sNextCharacterSet1$
    
#If TranslateMarc2Utf8FindBreakDebug = -1 Then
    Debug.Print "TM2U8OFFB entry ('^' represents escape): >" + ReplaceCharacters(ReplaceCharacters(sWork$, MarcDelimiter, "$"), MarcEscape, "^") + "<"
#End If
    
    ' at least temporarily, set sPiece to the first escape-delimited piece
    iEscape% = InStr(sWork$, MyMarcCharacter.MarcEscape)
#If TranslateMarc2Utf8FindBreakDebug = -1 Then
    Debug.Print "TM2U8OFFB escape: " + str(iEscape%) + " incoming character set 0: " + sCharacterSet0$
#End If
    
    If iEscape% = 0 Then ' most common case: no character-set-switching code is present
        If sCharacterSet0$ = "s" Then
            ' the most common of the most common cases: no escapes, and we're
            '   starting with the standard character set
            ' this is also always the case for the first piece in the whole field (even
            '   if the piece consists solely of the delimiter and
            '   a subfield code)
            sPiece$ = sWork$
            sWork$ = ""
            sCharacterSet1$ = "s"
        Else ' current character set is no "s"
            ' we're going to break things at subfield codes, anyway
            If Mid(sWork$, 1, 1) = MyMarcCharacter.MarcDelimiter Then
                sLeft$ = Mid(sWork$, 1, 2)
                sPiece$ = Mid(sWork$, 3)
            Else
                sLeft$ = ""
                sPiece$ = sWork$
            End If
            iCtr% = InStr(sPiece$, MyMarcCharacter.MarcDelimiter)
            If iCtr% > 0 Then
                sPiece$ = sLeft$ + Mid(sPiece$, 1, iCtr% - 1)
                sWork$ = Mid(sWork$, Len(sPiece$) + 1)
                sNextCharacterSet0$ = "s"
                sNextCharacterSet1$ = "s"
            Else
                sPiece$ = sLeft$ + sPiece$
                sWork$ = ""
                ' we don't have to worry about sNextCharacterSet, because there are
                '   no characters to deal with after we've handled this piece
            End If
        End If
    Else ' text contains 'excape' character
        sPiece$ = Mid(sWork$, 1, iEscape% - 1)
        ' but we need to figure out whether the escape character occurs within
        '   the lead subfield or within some other subfield
        ' temporarily remove any leading delimiter/subfield code, so it doesn't
        '   interfere with the following operation
        If Mid(sPiece$, 1, 1) = MyMarcCharacter.MarcDelimiter Then ' should be!
            sLeft$ = Mid(sPiece$, 1, 2)
            sPiece$ = Mid(sPiece$, 3)
        End If
        ' look for the next subfield code in the supplied text
        iCtr% = InStr(sPiece$, MyMarcCharacter.MarcDelimiter)
        ' 20080828: not only must the delimiter appear somewhere, but
        '   it must appear TO THE LEFT of the escape character
        'If iCtr% > 0 And iCtr% < iEscape% Then
        If iCtr% > 0 And iCtr% < iEscape% Then
#If TranslateMarc2Utf8FindBreakDebug = -1 Then
            Debug.Print "TM2U8OFFB Default option a at " + str(iCtr%) + " vs. " + str(iEscape%) + " >" + ReplaceCharacters(ReplaceCharacters(sPiece$, MarcDelimiter, "$"), MarcEscape, "^") + "<"
#End If
            ' this piece contains an *internal* subfield code:
            '   pretend we're breaking at the subfield
            '   code, and assume we switch back to normal characters
            ' the escape-break is within some other subfield
            sPiece$ = sLeft$ + Mid(sPiece$, 1, iCtr% - 1)
            sWork$ = Mid(sWork$, Len(sPiece$) + 1)
            sNextCharacterSet0$ = "s"
            sNextCharacterSet1$ = "s"
        Else
            ' no internal subfield codes in this piece: the
            '   escape-break occurs within the lead subfield
            ' re-fetch the piece from the original field (we could,
            '   instead, re-attach the subfield code to achieve the
            '   same result)
            sPiece$ = Mid(sWork$, 1, iEscape% - 1)
#If TranslateMarc2Utf8FindBreakDebug = -1 Then
            Debug.Print "TM2U8OFFB mid(swork$,iEscape+1,1)>" + Mid(sWork$, iEscape% + 1, 1) + "<"
#End If
            Select Case Mid(sWork$, iEscape% + 1, 1)
                Case "s", "p", "b", "g"
                    sNextCharacterSet0$ = Mid(sWork$, iEscape% + 1, 1)
                    sWork$ = Mid(sWork$, iEscape% + 2)
                Case "!"
                    ' only recognized values are to indicate
                    '   extended Latin as G0 or G1: )!E and (!E
                    If Mid(sWork$, iEscape% + 1, 1) = "(" Then
                        sNextCharacterSet0$ = Mid(sWork$, iEscape% + 1, 3)
                    Else
                        sNextCharacterSet1$ = Mid(sWork$, iEscape% + 1, 3)
                    End If
                    sWork$ = Mid(sWork$, iEscape% + 4)
                Case "$"
                    ' forcing G0 and G1 to the same value
                    sNextCharacterSet0$ = Mid(sWork$, iEscape% + 1, 2)
                    sNextCharacterSet1$ = Mid(sWork$, iEscape% + 1, 2)
                    TranslateMarc2Utf8OneFieldFindBreakAdjustCode sNextCharacterSet1$, iEscape%, sWork$
                Case "("
                    sNextCharacterSet0$ = Mid(sWork$, iEscape% + 1, 2)
                    TranslateMarc2Utf8OneFieldFindBreakAdjustCode sNextCharacterSet0$, iEscape%, sWork$
#If TranslateMarc2Utf8FindBreakDebug = -1 Then
                    Debug.Print "Adjusted s0 code 1: >" + sNextCharacterSet0$ + "<"
#End If
                Case ")"
                    sNextCharacterSet1$ = Mid(sWork$, iEscape% + 1, 2)
                    TranslateMarc2Utf8OneFieldFindBreakAdjustCode sNextCharacterSet1$, iEscape%, sWork$
#If TranslateMarc2Utf8FindBreakDebug = -1 Then
                    Debug.Print "Adjusted s0 code 2: >" + sNextCharacterSet0$ + "<"
#End If
                Case Else
                    Select Case Mid(sWork$, iEscape% + 1, 1)
                        Case Else
                            sNextCharacterSet0$ = Mid(sWork$, iEscape% + 1, 2)
                            TranslateMarc2Utf8OneFieldFindBreakAdjustCode sNextCharacterSet0$, iEscape%, sWork$
#If TranslateMarc2Utf8FindBreakDebug = -1 Then
                            Debug.Print "Adjusted s0 code 3: >" + sNextCharacterSet0$ + "<"
#End If
                    End Select
            End Select
        End If
    End If

    ' if we've changed G0 but not changed G1, then set G1 to the corresponding "correct"
    '   value
    If sNextCharacterSet0$ <> sIncomingNextSet0$ Then
        ' we've changed G0
        If sNextCharacterSet1$ = sIncomingNextSet1$ Then
            ' we have NOT changed G1; change G1 to match G0
            Select Case sNextCharacterSet0$
                Case CHARACTERSET_CODES_FOR_880_BasicAsG0$
                    sNextCharacterSet1$ = CHARACTERSET_CODES_FOR_880_ExtendedLatinAsG1$
                Case CHARACTERSET_CODES_FOR_880_HebrewAsG0$
                    sNextCharacterSet1$ = CHARACTERSET_CODES_FOR_880_ExtendedLatinAsG1$
                Case CHARACTERSET_CODES_FOR_880_BasicCyrillicAsG0$
                    sNextCharacterSet1$ = CHARACTERSET_CODES_FOR_880_ExtendedCyrillicAsG1$
                Case CHARACTERSET_CODES_FOR_880_BasicArabicAsG0$
                    sNextCharacterSet1$ = CHARACTERSET_CODES_FOR_880_ExtendedArabicAsG1$
                Case CHARACTERSET_CODES_FOR_880_GreekAsG0$
                    sNextCharacterSet1$ = CHARACTERSET_CODES_FOR_880_ExtendedLatinAsG1$
                Case Else
                    sNextCharacterSet1$ = "s"
            End Select
        End If
    End If
#If TranslateMarc2Utf8FindBreakDebug = -1 Then
    Debug.Print "Codes at bottom: next s0 >" + sNextCharacterSet0$ + "< incoming next s0 >" + sIncomingNextSet0$ + "< next s1 >" + sNextCharacterSet1$ + "< incoming next s1 >" + sIncomingNextSet1$ + "<"
#End If
    
End Sub

Private Sub TranslateUtf82MarcOneFieldExceptionalCharacters(ByVal sTest$, ByRef b202FPresent As Boolean, ByRef b303FPresent As Boolean, ByRef bOtherCharactersPresent As Boolean)

    ' scan a supplied string to see if it contains any of the
    '   exceptional characters that might cause us to alter the
    '   escape coding of a piece of text (depending on the
    '   escape codes that surroud this piece of text in an
    '   880 field)
    ' characters 20-2F and 30-3F are of interest; because different
    '   scripts incorporate different combinations of these characters,
    '   we have to keep track of 'em separately
    
    
    Dim lCtr As Long
    
    
    b202FPresent = False
    b303FPresent = False
    bOtherCharactersPresent = False
    
    For lCtr = 1 To Len(sTest$)
        'Debug.Print "Exceptional? >" + Mid(sTest$, lCtr, 1) + "< " + str(Asc(Mid(sTest$, lCtr, 1)))
        Select Case Asc(Mid(sTest$, lCtr, 1))
            Case Is < 32 ' delimiter?
                bOtherCharactersPresent = True
            Case Is < 48 ' punctuation
                b202FPresent = True
            Case Is < 64 ' 0-9 and some more punctuation
                b303FPresent = True
            Case Else ' normal letters, mostly
                bOtherCharactersPresent = True
        End Select
    Next
    
End Sub

Public Function DecomposeUnicodeCharactersInString(ByVal sField$, Optional ByRef bChanged As Boolean) As String

    ' convert characters for a string that's supposed to be "normal" (ASCII)
    '   stuff
    ' NOTE that by calling this, the outside world has on its own decided that this is a
    '   good thing to do; the MARC record object itself only calls this routine if the
    '   registry entry for the Voyager cataloging client has decreed that this is an OK
    '   thing to do (via a call with proper parameters to RegGetValue)
    
    Dim sChar$, sHex$
    
    Dim lPtr As Long, iLength%, iPtr2%


#If DecomposeUnicodeCharactersDebug = -1 Then
    Debug.Print "DUCPT in:  >" + sField$ + "<"
#End If
    lPtr = Len(sField$) ' we'll start with last octet in the string, and we'll move to the leftg
    If lPtr = 0 Then
        DecomposeUnicodeCharactersInString = sField$
        Exit Function
    End If
    Do
        ' after this next function call, lptr points to the first octet in each character
        lPtr = MyMarcCharacter.Utf8CharFindFirstOctet(sField$, lPtr)
        iLength% = MyMarcCharacter.Utf8CharOctets(Mid(sField$, lPtr, 1))
        ' 20050726: new routine now centralizes all of the character-substitution
        '   logic
#If DecomposeUnicodeCharactersDebug = -1 Then
        Debug.Print "Posn " + str(lPtr) + " octets " + str(iLength%) + " char >" + Mid(sField$, lPtr, iLength%) + "<"
#End If
        If MyMarcCharacter.SubstituteUtf8Char(Mid(sField$, lPtr, iLength%), sChar$) Then
#If DecomposeUnicodeCharactersDebug = -1 Then
            Debug.Print "Changed"
#End If
            sField$ = SafeStuff(sField$, lPtr, iLength%, sChar$)
            bChanged = True
        End If
        lPtr = lPtr - 1 ' move to the last octet of the previous character
        If lPtr < 1 Then ' exit when all done
            Exit Do
        End If
    Loop
#If DecomposeUnicodeCharactersDebug = -1 Then
    Debug.Print "DUCPT out: >" + sField$ + "<"
#End If
    
    DecomposeUnicodeCharactersInString = sField$
    
End Function

Public Function Marc2PlainText(ByVal sIn$) As String

    Dim sMarc8CharacterSetCode$, sMarc8Character$, sCurrentCharacterSetCode$, sOut$
    
    Dim lPtr As Long, lChr As Long
    
    Dim bCharacterChanged As Boolean, bCharacterError As Boolean, bDiacritics As Boolean
    
    
#If Marc2PlainTextDebug = -1 Then
    Debug.Print "M2PT >" + sIn$ + "<"
#End If
    If Len(sIn$) = 0 Then
        Marc2PlainText = sIn$
        Exit Function
    End If
    If Not m_bUtf8 Then
Marc2PlainTextReadyForTranslation:
        'NOT UNICODE
        For lPtr = Len(sIn$) To 1 Step -1
            lChr = Asc(Mid(sIn$, lPtr, 1))
            Select Case lChr
                Case Is < 128
                    ' keep all of these as found
                Case Is < 160
                    Select Case lChr
                        Case 144 ' degree sign
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "deg. ")
                        Case 145 ' script l
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "l") ' not in SACO conventions
                        Case 146 ' pressing
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "(p)") ' not in SACO conventions
                        Case 147 ' copyright
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "(c)") ' not in SACO conventions
                        Case 148 ' sharp
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "#") ' not in SACO conventions
                        Case 149 ' inverted question mark
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "?") ' not in SACO conventions
                        Case 150 ' inverted bang
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "!") ' not in SACO conventions
                        Case Else
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "")
                    End Select
                Case Is < 176
                    Select Case lChr
                        Case 160
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "l") ' not in SACO conventions
                        Case 161
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "L")
                        Case 162
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "O")
                        Case 163 ' slash-D
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "D")
                        Case 164 ' thorn
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "Th")
                        Case 165 ' AE
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "Ae")
                        Case 166 ' OE
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "Oe")
                        Case 167 ' miag. znak
                            ' 20050210: attempt to replace those used in geographic
                            '   coordinates with an abbreviation
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "'")
                        Case 168 ' dot centere
                            sIn$ = SafeStuff(sIn$, lPtr, 1, ".")
                        Case 169
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "flat") ' not in SACO conventions
                        Case 170 ' registered
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "(r)") ' not in SACO conventions
                        Case 171 ' plus/minus
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "+/-") ' not in SACO conventions
                        Case 172 ' hook-O
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "O")
                        Case 173 'hook-U
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "U")
                        Case 174 ' alif
                            sIn$ = SafeStuff(sIn$, lPtr, 1, " alif ")
                        Case 175 ' alpha
                            sIn$ = SafeStuff(sIn$, lPtr, 1, " alpha ") ' not in SACO conventions
                        Case Else
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "")
                    End Select
                Case Is < 192
                    Select Case lChr
                        Case 176 ' ayn
                            sIn$ = SafeStuff(sIn$, lPtr, 1, " ayn ")
                        Case 177 ' slash-l
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "l")
                        Case 178 ' slash-o
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "o")
                        Case 179 ' lower-case slash-d
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "d")
                        Case 180 ' lowercase thorn
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "th")
                        Case 181 'ae
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "ae")
                        Case 182 ' oe
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "oe")
                        Case 183 'tverd. znak
                            sIn$ = SafeStuff(sIn$, lPtr, 1, Chr(34))
                        Case 184 ' turkish dotless i
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "i")
                        Case 186 ' eth
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "th")
                        Case 188 ' hook o
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "o")
                        Case 189 ' hook u
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "u")
                        Case 190 ' beta
                            If m_sCharacterSetOut$ = "V" Then
                                sIn$ = SafeStuff(sIn$, lPtr, 1, " beta ")
                            Else
                                ' should only occur in OCLC
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "l") ' not in SACO conventions
                            End If
                        Case 191 ' gamma
                            sIn$ = SafeStuff(sIn$, lPtr, 1, " gamma ")
                        Case Else
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "")
                    End Select
                Case Is < 208
                    If m_sCharacterSetOut$ = "V" Then
                        Select Case lChr
                            Case 192
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "0") ' not in SACO conventions
                            Case 193
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "1") ' not in SACO conventions
                            Case 194
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "2") ' not in SACO conventions
                            Case 195
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "3") ' not in SACO conventions
                            Case 196
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "4") ' not in SACO conventions
                            Case 197
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "5") ' not in SACO conventions
                            Case 198
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "6") ' not in SACO conventions
                            Case 199
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "7") ' not in SACO conventions
                            Case 200
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "8") ' not in SACO conventions
                            Case 201
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "9") ' not in SACO conventions
                            Case 202
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "+") ' not in SACO conventions
                            Case 203
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "-") ' not in SACO conventions
                            Case 204
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "(") ' not in SACO conventions
                            Case 205
                                sIn$ = SafeStuff(sIn$, lPtr, 1, ")") ' not in SACO conventions
                            Case Else
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "")
                        End Select
                    Else ' OCLC or MARC character sets
                        Select Case lChr
                            Case 192 ' degree sign
                                sIn$ = SafeStuff(sIn$, lPtr, 1, " deg. ")
                            Case 193 ' script l
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "l") ' not in SACO conventions
                            Case 194 ' pressing
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "(p)") ' not in SACO conventions
                            Case 195 ' copyright
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "(c)") ' not in SACO conventions
                            Case 196 ' sharp
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "#") ' not in SACO conventions
                            Case 197 ' inverted question mark
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "?") ' not in SACO conventions
                            Case 198 ' inverted bang
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "!") ' not in SACO conventions
                            Case Else
                                sIn$ = SafeStuff(sIn$, lPtr, 1, "")
                        End Select
                    End If
                Case Is < 224
                    ' should not occur if OCLC or MARC
                    Select Case lChr
                        Case 208
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "0") ' not in SACO conventions
                        Case 209
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "1") ' not in SACO conventions
                        Case 210
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "2") ' not in SACO conventions
                        Case 211
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "3") ' not in SACO conventions
                        Case 212
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "4") ' not in SACO conventions
                        Case 213
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "5") ' not in SACO conventions
                        Case 214
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "6") ' not in SACO conventions
                        Case 215
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "7") ' not in SACO conventions
                        Case 216
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "8") ' not in SACO conventions
                        Case 217
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "9") ' not in SACO conventions
                        Case 218
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "+") ' not in SACO conventions
                        Case 219
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "-") ' not in SACO conventions
                        Case 220
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "(") ' not in SACO conventions
                        Case 221
                            sIn$ = SafeStuff(sIn$, lPtr, 1, ")") ' not in SACO conventions
                        Case Else
                            sIn$ = SafeStuff(sIn$, lPtr, 1, "")
                    End Select
                Case Else ' two columns at once!
                    sIn$ = SafeStuff(sIn$, lPtr, 1, "")
            End Select ' the main groups
        Next ' lPtr
    
    Else ' UTF-8 character representation
    
        lPtr = Len(sIn$)
        Do
            ' starting from the right, find the first octet of this character
            lPtr = MyMarcCharacter.Utf8CharFindFirstOctet(sIn$, lPtr)
            ' translate this one character
            MyMarcCharacter.TranslateUtf82MarcOneCharacter "V", sMarc8CharacterSetCode$, Mid(sIn$, lPtr, MyMarcCharacter.Utf8CharOctets(Mid(sIn$, lPtr, 1))), sMarc8Character$, bCharacterChanged, bCharacterError
            
            If InStr(CHARACTERSET_Non880$, sMarc8CharacterSetCode$) > 0 Then
Marc2PlainTextTextOK:
                If sCurrentCharacterSetCode$ <> sMarc8CharacterSetCode$ Then
                    Select Case sCurrentCharacterSetCode$
                        Case "1"
                            sOut$ = MarcEscape + "s" + sOut$
                        Case "2"
                            sOut$ = MarcEscape + "g" + sOut$
                        Case "3"
                            sOut$ = MarcEscape + "b" + sOut$
                        Case "4"
                            sOut$ = MarcEscape + "p" + sOut$
                    End Select
                    sCurrentCharacterSetCode$ = sMarc8CharacterSetCode$
                End If
                If InStr(Marc8DiacriticsAbove$, sMarc8Character$) > 0 Then
                    TranslateAddOneDiacriticToArray sMarc8Character$, Marc8Diacritics$
                    bDiacritics = True
                ElseIf InStr(Marc8DiacriticsOther$, sMarc8Character$) > 0 Then
                    TranslateAddOneDiacriticToArray sMarc8Character$, Marc8Diacritics$
                    bDiacritics = True
                Else
                    ' normal character; stick it on to the growing string
                    sOut$ = sMarc8Character$ + sOut$
                    ' any accumulated diacritics come before this letter
                    If bDiacritics Then
                        If sCurrentCharacterSetCode$ <> "1" Then
                            sOut$ = MarcEscape + sCurrentCharacterSetCode$ + sOut$
                            sCurrentCharacterSetCode$ = "1"
                        End If
                        sOut$ = TranslateSortAndReturnDiacriticArray() + sOut$
                        bDiacritics = False
                    End If
                End If
            ElseIf InStr(CHARACTERSET_GreekCodes$, sMarc8CharacterSetCode$) > 0 Then
                If sMarc8Character$ = MarcAlpha Or sMarc8Character$ = MarcBeta Or sMarc8Character$ = MarcGamma Then
                    ' these three are allowed in non-880 fields
                    GoTo Marc2PlainTextTextOK
                End If
            End If
        
            ' lptr is currently on the forst octet of the utf8 character; back up into the previous
            '   character and continue
            lPtr = lPtr - 1
            
            If lPtr < 1 Then
                Exit Do
            End If
        Loop
    
        sIn$ = sOut$
        ' and having translated the string to "MARC", proceed as above
        GoTo Marc2PlainTextReadyForTranslation
        
    End If
    
    sIn$ = RemoveRepeatedCharacters(Trim(sIn$), " ")
    If Mid(sIn$, 1, 2) = "$a" Then
        sIn$ = Trim(Mid(sIn$, 3))
    End If
    
    Marc2PlainText = sIn$
    
End Function

Public Property Get FldTextNormalizable() As String

    ' return the text of a field containing only the subfields that
    '   participate in the normalized form of the field
    
    
    Dim iPtr%
    
    Dim sReturn$, sSubfieldsOfInterest$
    
    
    If FldPointer > -1 Then
        With MarcArray(FldPointer)
#If WithDebug = -1 Then
            PushWith "FldTextNormalizable"
#End If
            sSubfieldsOfInterest$ = ListSubfieldsForNormalization(m_sRecordFormat$, .Tag)
            iPtr% = .FirstSubfield
            If Mid(.Tag, 1, 2) = "00" Then
                If iPtr% > -1 Then
                    sReturn$ = .Subfield(iPtr%).Text
                End If
            Else
                While iPtr% > -1
                    If Not .Subfield(iPtr%).Deleted Then
                        ' 20040615: do not trim spaces from subfield text
                        If InStr(sSubfieldsOfInterest$, .Subfield(iPtr%).Code) > 0 Then
                            sReturn$ = sReturn$ + MyMarcCharacter.MarcDelimiter + .Subfield(iPtr%).Code + .Subfield(iPtr%).Text
                        End If
                    End If
                    iPtr% = .Subfield(iPtr%).NextSubfield
                Wend
            End If
            FldTextNormalizable = sReturn$
#If WithDebug = -1 Then
            PopWith "FldTextNormalizable"
#End If
        End With
    Else
        FldTextNormalizable = ""
    End If

End Property


Public Sub FldLoadInfoNormalizable(ByRef sTag$, ByRef sIndicators$, ByRef sField$)

    ' return in one move the three field pieces
    
    sTag$ = FldTag
    sIndicators$ = FldInd
    sField$ = FldTextNormalizable

End Sub

Public Function TestRecordForEmptySubfields(ByRef sReturnMessages$) As Boolean

    ' see if any of the fields in the current record normalize to nothing
    ' we can do this work with the digested form of the record, because normalization-to-nothing
    '   doesn't bother the digestion of a record
    
    Dim lFldPointer As Long, lSfdPointer As Long
    
    Dim sFieldsToTest$
    
    Dim bTestAll As Boolean
    
    
    sReturnMessages$ = ""
    
    lFldPointer = FldPointer
    lSfdPointer = SfdPointer
    
    Select Case MarcRecordFormat
        Case "A"
            sFieldsToTest$ = FieldsToTestForEmptySubfieldsAuth
        Case "H"
            sFieldsToTest$ = FieldsToTestForEmptySubfieldsHold
        Case Else
            sFieldsToTest$ = FieldsToTestForEmptySubfieldsBib
    End Select
    
    If Len(sFieldsToTest$) < 3 Then
        bTestAll = True
    End If
    
    FldMoveTop
    Do While FldMoveNext
        If Not FldDeleted Then
            If Mid(FldTag, 1, 2) <> "00" Then
                ' 20051005: only test fields we're asked to test
                If bTestAll Or InStr(sFieldsToTest$, FldTag) > 0 Then
                    Do
                        If Len(SfdNorm) = 0 Then
                            If Len(sReturnMessages$) > 0 Then
                                sReturnMessages$ = sReturnMessages$ + vbCrLf
                            End If
                            sReturnMessages$ = sReturnMessages$ + FldTag + " $" + SfdCode + " normalizes to nothing"
                        End If
                        If Not SfdMoveNext Then
                            Exit Do
                        End If
                    Loop
                End If
            End If
        End If
    Loop
    
    If Len(sReturnMessages$) > 0 Then
        TestRecordForEmptySubfields = True
    Else
        TestRecordForEmptySubfields = False
    End If
    
    FldPointer = lFldPointer
    SfdPointer = lSfdPointer
    
End Function

Public Function TestRecordForLeadingSubfield(ByRef sReturnMessages$) As Boolean

    ' see if any of the variable fields in the input record begin with an unexpected
    '   subfield
    ' note that we have to do this based on the raw form of the record as received, because
    '   once it's been digested the subfields have been moved around, and the test will
    '   be meaningless
    
    
    Dim sExpected$, sField$, sTag$
    Dim sLeader$, sDirectory$, sFields$, sAllowed$
    
    Dim lBad As Long, lDirPtr As Long, lLength As Long, lStart As Long
    
    
    sReturnMessages$ = ""
    
    If Len(MarcRecordIn) = 0 Then
        TestRecordForLeadingSubfield = False
        Exit Function
    End If
    If InStr("ABDFMPSU", MarcRecordFormat) = 0 Then
        TestRecordForLeadingSubfield = False
        Exit Function
    End If
        
    lBad = Val(Mid(MarcRecordIn, 13, 5)) ' mid ok
    ' omit field mark at end of directory
    sDirectory$ = Mid(MarcRecordIn, 1, lBad - 1) ' mid ok
    sLeader$ = Mid(sDirectory$, 1, 24)
    sDirectory$ = Mid(sDirectory, 25) ' mid ok
    ' skip over fieldmark here, too
    sFields$ = Mid(MarcRecordIn, lBad + 1) ' mid ok
    ' discard end-of-record doodad
    sFields$ = Mid(sFields$, 1, Len(sFields$) - 1) ' mid ok
    
    If MarcRecordFormat = "A" Then
        For lDirPtr = 1 To Len(sDirectory$) Step 12
            sTag$ = Mid(sDirectory$, lDirPtr, 3)
            lLength = Val(Mid(sDirectory$, lDirPtr + 3, 4)) - 1  ' note that we trim the EOF here
            lStart = Val(Mid(sDirectory$, lDirPtr + 7, 5)) + 1
            If lLength > 0 Then
                sField$ = Mid(sFields$, lStart + 2, lLength - 2) ' mid ok; discard indicators
                If InStr("145", Mid(sTag$, 1, 1)) > 0 Then
                    Select Case Mid(sTag$, 2, 2)
                        Case "80"
                            sExpected$ = "x"
                        Case "81"
                            sExpected$ = "z"
                        Case "82"
                            sExpected$ = "y"
                        Case "85"
                            sExpected$ = "v"
                        Case Else
                            sExpected$ = "a"
                    End Select
                    If Mid(sField$, 2, 1) <> sExpected$ Then
                        lBad = InStr(sField$, MarcDelimiter + sExpected$)
                        If lBad = 0 Then
TRFLS_UnexpectedAuthSubfieldFound:
                            If Len(sReturnMessages$) > 0 Then
                                sReturnMessages$ = sReturnMessages$ + vbCrLf
                            End If
                            sReturnMessages$ = sReturnMessages$ + sTag$ + " began with unexpected subfield $" + Mid(sField, 2, 1)
                            
                        Else
                            If Mid(sTag$, 1, 1) = "1" Then
                                sAllowed$ = "68"
                            Else
                                sAllowed$ = "w68"
                            End If
                            sField$ = Mid(sField$, 1, lBad - 1)
                            For lBad = 1 To Len(sField$)
                                If Mid(sField$, lBad, 1) = MarcDelimiter Then
                                    If InStr(sAllowed$, Mid(sField$, lBad + 1, 1)) = 0 Then
                                        GoTo TRFLS_UnexpectedAuthSubfieldFound
                                    End If
                                End If
                            Next ' lbad
                            ' if we get here naturally, there were no unexpected
                            '   subfields between the beginning subfield and the
                            '   expected subfield
                        End If
                    End If ' does the field *begin* with the expected subfield?
                End If ' is this an access field?
            End If ' does the field have a valid length?
        Next ' for each field listed in the directory
    Else ' bibliographic
        For lDirPtr = 1 To Len(sDirectory$) Step 12
            sTag$ = Mid(sDirectory$, lDirPtr, 3)
            If Mid(sTag$, 1, 2) <> "00" Then
                'Debug.Print Mid(sDirectory$, lDirPtr, 12)
                lLength = Val(Mid(sDirectory$, lDirPtr + 3, 4)) - 1  ' note that we trim the EOF here
                lStart = Val(Mid(sDirectory$, lDirPtr + 7, 5)) + 1
                If lLength > 0 Then
                    ' in the extraction, remove the indicators because they're boring for this test
                    'Debug.Print str(lStart) + " " + str(lLength) + " :" + sField$
                    sField$ = Mid(sFields$, lStart + 2, lLength - 2) ' mid ok
                    Select Case sTag$
                        ' 20051005: 246 and 247 removed from this list, because
                        '   they often properly begin with $i
                        Case "100" To "130", "222", "240", "245"
                        Case "400" To "440"
                        Case "600" To "651", "655"
                        Case "700" To "740"
                        Case "800" To "830"
                        Case Else
                            GoTo TRFLS_NextBibField
                    End Select
                    ' if we get here we've got a normal access field, and it
                    '   better begin with $6 or $a
                    sExpected$ = "a"
                    sAllowed$ = "68"
                    If Mid(sField$, 2, 1) <> sExpected$ Then
                        lBad = InStr(sField$, MarcDelimiter + sExpected$)
                        If lBad = 0 Then
TRFLS_UnexpectedBibSubfieldFound:
                            If Len(sReturnMessages$) > 0 Then
                                sReturnMessages$ = sReturnMessages$ + vbCrLf
                            End If
                            sReturnMessages$ = sReturnMessages$ + sTag$ + " began with unexpected subfield $" + Mid(sField, 2, 1)
                        Else
                            sField$ = Mid(sField$, 1, lBad - 1)
                            For lBad = 1 To Len(sField$)
                                If Mid(sField$, lBad, 1) = MarcDelimiter Then
                                    If InStr(sAllowed$, Mid(sField$, lBad + 1, 1)) = 0 Then
                                        GoTo TRFLS_UnexpectedBibSubfieldFound
                                    End If
                                End If
                            Next ' lbad
                            ' if we get here naturally, there were no unexpected
                            '   subfields between the beginning subfield and the
                            '   expected subfield
                        End If
                    End If ' does the field *begin* with the expected subfield?
                End If
            End If
TRFLS_NextBibField:
        Next ' lDirPtr
    End If
    
    If Len(sReturnMessages$) > 0 Then
        TestRecordForLeadingSubfield = True
    Else
        TestRecordForLeadingSubfield = False
    End If
    
End Function

Public Function TestRecordForBlankSubfieldCodes(ByRef sReturnMessages$) As Boolean

    ' see if any of the variable fields in the input record begin with an unexpected
    '   subfield
    ' note that we have to do this based on the raw form of the record as received, because
    '   once it's been digested the subfields have been moved around, and the test will
    '   be meaningless
    
    
    Dim sExpected$, sField$, sTag$
    Dim sLeader$, sDirectory$, sFields$, sAllowed$
    
    Dim lBad As Long, lDirPtr As Long, lLength As Long, lStart As Long
    
    
    sReturnMessages$ = ""
    
    If Len(MarcRecordIn) = 0 Then
        TestRecordForBlankSubfieldCodes = False
        Exit Function
    End If
        
    lBad = Val(Mid(MarcRecordIn, 13, 5)) ' mid ok
    ' omit field mark at end of directory
    sDirectory$ = Mid(MarcRecordIn, 1, lBad - 1) ' mid ok
    sLeader$ = Mid(sDirectory$, 1, 24)
    sDirectory$ = Mid(sDirectory, 25) ' mid ok
    ' skip over fieldmark here, too
    sFields$ = Mid(MarcRecordIn, lBad + 1) ' mid ok
    ' discard end-of-record doodad
    sFields$ = Mid(sFields$, 1, Len(sFields$) - 1) ' mid ok
    
    For lDirPtr = 1 To Len(sDirectory$) Step 12
        sTag$ = Mid(sDirectory$, lDirPtr, 3)
        lLength = Val(Mid(sDirectory$, lDirPtr + 3, 4)) - 1  ' note that we trim the EOF here
        lStart = Val(Mid(sDirectory$, lDirPtr + 7, 5)) + 1
        If lLength > 0 Then
            If Mid(sTag$, 1, 2) <> "00" Then
                sField$ = Mid(sFields$, lStart + 2, lLength - 2) ' mid ok; discard indicators
                For lBad = 1 To Len(sField$)
                    If Mid(sField$, lBad, 1) = MarcDelimiter Then
                        If Mid(sField$, lBad + 1, 1) = " " Then
                            If Len(sReturnMessages$) > 0 Then
                                sReturnMessages$ = sReturnMessages$ + vbCrLf
                            End If
                            sReturnMessages$ = sReturnMessages$ + sTag$ + " has 'blank' subfield"
                            Exit For
                        End If
                    End If
                Next ' lbad
            End If
        End If
    Next ' for each field listed in the directory
    
    If Len(sReturnMessages$) > 0 Then
        TestRecordForBlankSubfieldCodes = True
    Else
        TestRecordForBlankSubfieldCodes = False
    End If

End Function

Public Property Get FieldsToTestForEmptySubfieldsAuth() As String

    If Len(m_sFieldsToTestForEmptySubfieldsAuth$) = 0 Then
        FieldsToTestForEmptySubfieldsAuth = "*"
    Else
        FieldsToTestForEmptySubfieldsAuth = m_sFieldsToTestForEmptySubfieldsAuth$
    End If

End Property

Public Property Let FieldsToTestForEmptySubfieldsAuth(ByVal vNewValue As String)


    If vNewValue = "*" Then
        m_sFieldsToTestForEmptySubfieldsAuth$ = ""
    Else
        m_sFieldsToTestForEmptySubfieldsAuth$ = vNewValue
    End If

End Property

Public Property Get FieldsToTestForEmptySubfieldsBib() As String

    If Len(m_sFieldsToTestForEmptySubfieldsBib$) = 0 Then
        FieldsToTestForEmptySubfieldsBib = "*"
    Else
        FieldsToTestForEmptySubfieldsBib = m_sFieldsToTestForEmptySubfieldsBib$
    End If
    
End Property

Public Property Let FieldsToTestForEmptySubfieldsBib(ByVal vNewValue As String)

    If vNewValue = "*" Then
        m_sFieldsToTestForEmptySubfieldsBib$ = ""
    Else
        m_sFieldsToTestForEmptySubfieldsBib$ = vNewValue
    End If
        
End Property

Public Property Get FieldsToTestForEmptySubfieldsHold() As String

    If Len(m_sFieldsToTestForEmptySubfieldsHold$) = 0 Then
        FieldsToTestForEmptySubfieldsHold = "*"
    Else
        FieldsToTestForEmptySubfieldsHold = m_sFieldsToTestForEmptySubfieldsHold$
    End If
    
End Property

Public Property Let FieldsToTestForEmptySubfieldsHold(ByVal vNewValue As String)

    If vNewValue = "*" Then
        m_sFieldsToTestForEmptySubfieldsHold$ = ""
    Else
        m_sFieldsToTestForEmptySubfieldsHold$ = vNewValue
    End If
    
End Property

Public Property Get SeriesTracingPolicyDpcc(Optional ByRef lReturnFieldPointer As Long) As String

    Dim lPointer As Long, lSfdPointer As Long
    
    Dim sPolicy$, sA$
    Dim sNuc$
    
    Dim iRc%
    
    
    ' preserve pointers
    lPointer = FldPointer
    lSfdPointer = SfdPointer
    
    SeriesTracingPolicyDpcc = ""
    
    ' this is only a question for PCC/NACO series authority records: those
    '   that have 010 fields
    If InStr("abcz", Get008Value(12, 1)) = 0 Then
        GoTo SeriesTracingPolicyDpcc_Exit
    End If
    If Not FldFindFirst("010") Then
        GoTo SeriesTracingPolicyDpcc_Exit
    End If
    
    ' for series tracing, the PCC policy, narrowly so called, is
    '   1) an explicit statement of PCC tracing policy; or 2)
    '   lacking that explicit statement, ANY (non-local) 645
    '   that says "traced"
    ' here's part 1) of this
    FldMoveTop
    Do While FldFindNext("645")
        sA$ = Mid(SfdText, 1, 1)
        'Debug.Print "DPCC Found 645: " + FldText + " >" + sA$ + "<"
        Do While SfdFindNext("5")
            'Debug.Print "DPCC $5? " + SfdText
            If Mid(SfdText, 1, 4) = "DPCC" Then
                SeriesTracingPolicyDpcc = sA$
                lReturnFieldPointer = FldPointer
                GoTo SeriesTracingPolicyDpcc_Found
            End If
        Loop
    Loop
    
    ' 20060701: if this is a series-like phrase, then
    '   we'll say it's not traced
    If Get008Value(12, 1) = "c" Then
        SeriesTracingPolicyDpcc = "n"
        lReturnFieldPointer = 0
        GoTo SeriesTracingPolicyDpcc_Found
    End If
    
    ' if we get here, there is no explicit policy
    ' here's part 2) of the above-stated policy:
    '   is there any "traced" 645 field that has a $5 that's
    '   not a local $5?
    FldMoveTop
    Do While FldFindNext("645")
        sA$ = SfdText
        If Mid(sA$, 1, 1) = "t" Then
            Do While SfdFindNext("5")
                sNuc$ = Trim(SfdText)
                'Debug.Print "DPCC Found 645 2: " + FldText + " >" + sA$ + "<"
                ' note that we can't exclude DLC here: ANY NUC code (other
                '   than a local code) that's attached to a "traced" 645
                '   reflects PCC practice
                'If Mid(sNuc$, 1, 3) <> "DLC" Then
                    iRc% = InStr(sNuc$, "-")
                    If iRc% = 0 Then
                        iRc% = InStr(sNuc$, "/")
                    End If
                    If iRc% > 0 Then
                        sNuc$ = Mid(sNuc$, 1, iRc% - 1)
                    End If
                    If InStr(" " + Nuc, " " + sNuc$) = 0 Then
                        SeriesTracingPolicyDpcc = sA$
                        lReturnFieldPointer = FldPointer
                        GoTo SeriesTracingPolicyDpcc_Found
                    End If
                'End If
            Loop
        End If
    Loop
    
    sA$ = ""
    lReturnFieldPointer = 0
    
SeriesTracingPolicyDpcc_Found:

SeriesTracingPolicyDpcc_Exit:
    
    FldPointer = lPointer
    SfdPointer = lSfdPointer
    
End Property


Public Property Get SeriesAnalysisPolicyDpcc(Optional ByRef lReturnFieldPointer As Long) As String

    ' there is no such thing as PCC analysis policy
    SeriesAnalysisPolicyDpcc = ""
    lReturnFieldPointer = 0
    
End Property


Public Property Get SeriesClassificationPolicyDpcc(Optional ByRef lReturnFieldPointer As Long) As String

    ' there is no such thing as PCC classification policy
    SeriesClassificationPolicyDpcc = ""
    lReturnFieldPointer = 0

End Property


Public Property Get SeriesAnalysisPolicyLocal(Optional ByRef lReturnFieldPointer As Long) As String

    Dim lPointer As Long, lSfdPointer As Long
    
    Dim sPolicy$, sNucCopy$, sA$, sSfd$
    
    Dim iRc%
    

    ' preserve pointers
    lPointer = FldPointer
    lSfdPointer = SfdPointer
    
    SeriesAnalysisPolicyLocal = ""
    
    FldMoveTop
    Do While FldFindNext("644")
        sA$ = Mid(SfdText, 1, 1)
        Do While SfdFindNext("5")
            sSfd$ = "5" + SfdText
            iRc% = InStr(sSfd$, "-")
            If iRc% > 0 Then
                sSfd$ = Mid(sSfd$, 1, iRc% - 1)
            End If
            ' any $5 whose stem matches anything in the string of
            '   NUC code roots is a "local" code
            If InStr(m_sLocalNucString$, sSfd$) > 0 Then
                SeriesAnalysisPolicyLocal = sA$
                lReturnFieldPointer = FldPointer
                GoTo SeriesAnalysisPolicyLocal_Exit
            End If
        Loop
    Loop
    
SeriesAnalysisPolicyLocal_Exit:
    
    FldPointer = lPointer
    SfdPointer = lSfdPointer

End Property


Public Property Get SeriesClassificationPolicyLocal(Optional ByRef lReturnFieldPointer As Long) As String

    Dim lPointer As Long, lSfdPointer As Long
    
    Dim sPolicy$, sNucCopy$, sA$, sSfd$
    
    Dim iRc%
    
    
    ' preserve pointers
    lPointer = FldPointer
    lSfdPointer = SfdPointer
    
    SeriesClassificationPolicyLocal = ""
    
    FldMoveTop
    Do While FldFindNext("646")
        sA$ = Mid(SfdText, 1, 1)
        Do While SfdFindNext("5")
            sSfd$ = "5" + SfdText
            iRc% = InStr(sSfd$, "-")
            If iRc% > 0 Then
                sSfd$ = Mid(sSfd$, 1, iRc% - 1)
            End If
            ' any $5 whose stem matches anything in the string of
            '   NUC code roots is a "local" code
            If InStr(m_sLocalNucString$, sSfd$) > 0 Then
                SeriesClassificationPolicyLocal = sA$
                lReturnFieldPointer = FldPointer
                GoTo SeriesClassificationPolicyLocal_Exit
            End If
        Loop
    Loop
    
SeriesClassificationPolicyLocal_Exit:
    
    FldPointer = lPointer
    SfdPointer = lSfdPointer

End Property


Public Property Get SeriesTracingPolicyLocal(Optional ByRef lReturnFieldPointer As Long) As String


    Dim lPointer As Long, lSfdPointer As Long, lSavedPointer As Long
    
    Dim sPolicy$, sNucCopy$, sA$, sSfd$, sSavedPolicy$
    
    Dim iRc%
    
    
    ' preserve pointers
    lPointer = FldPointer
    lSfdPointer = SfdPointer
    
    SeriesTracingPolicyLocal = ""
    
    FldMoveTop
    Do While FldFindNext("645")
        sA$ = Mid(SfdText, 1, 1) ' copy $a
        SfdMoveFirst
        Do While SfdFindNext("5")
            sSfd$ = "5" + SfdText
            iRc% = InStr(sSfd$, "-")
            If iRc% > 0 Then
                sSfd$ = Mid(sSfd$, 1, iRc% - 1)
            End If
            ' any $5 whose stem matches anything in the string of
            '   NUC code roots is a "local" code
            iRc% = InStr(m_sLocalNucString$, sSfd$)
            ' 20060713: in the following we're assuming that the first code in the
            '   string is the most desirable one; so we're preferring a match on the
            '   first one and continuing if we have a match on a different one in hope of
            '   finding the "best" one later
            Select Case iRc%
                Case 2
                    ' sSfd doesn't have the delimiter character that m_sLNS
                    '   has; so match on the first is at 2
                    SeriesTracingPolicyLocal = sA$
                    lReturnFieldPointer = FldPointer
                    GoTo SeriesTracingPolicyLocal_Exit
                Case Is > 1
                    If Len(sSavedPolicy$) = 0 Then
                        sSavedPolicy$ = sA$
                        lSavedPointer = FldPointer
                    End If
            End Select
        Loop
    Loop
    
    If lSavedPointer > 0 Then
        SeriesTracingPolicyLocal = sSavedPolicy$
        lReturnFieldPointer = lSavedPointer
    End If
    
SeriesTracingPolicyLocal_Exit:
    
    FldPointer = lPointer
    SfdPointer = lSfdPointer

End Property

Public Property Get SeriesAnalysisPolicyDlc(Optional ByRef lReturnFieldPointer As Long) As String
    
    Dim lPointer As Long, lSfdPointer As Long
    
    Dim sPolicy$, sLcPolicy$, sA$
    
    
    ' preserve pointers
    lPointer = FldPointer
    lSfdPointer = SfdPointer
    
    SeriesAnalysisPolicyDlc = ""
    
    ' this is only a question for PCC/NACO series authority records
    If InStr("abcz", Get008Value(12, 1)) = 0 Then
        GoTo SeriesAnalysisPolicyDlc_Exit
    End If
    If Not FldFindFirst("010") Then
        GoTo SeriesAnalysisPolicyDlc_Exit
    End If
    
    FldMoveTop
    Do While FldFindNext("644")
        sA$ = Mid(SfdText, 1, 1)
        Do While SfdFindNext("5")
            If Mid(SfdText, 1, 3) = "DLC" Then
                lReturnFieldPointer = FldPointer
                SeriesAnalysisPolicyDlc = sA$
                GoTo SeriesAnalysisPolicyDlc_Exit
            End If
        Loop
    Loop
    
SeriesAnalysisPolicyDlc_Exit:
    
    FldPointer = lPointer
    SfdPointer = lSfdPointer

End Property


Public Property Get SeriesClassificationPolicyDlc(Optional ByRef lReturnFieldPointer As Long) As String

    Dim lPointer As Long, lSfdPointer As Long
    
    Dim sPolicy$, sLcPolicy$, sA$
    
    
    ' preserve pointers
    lPointer = FldPointer
    lSfdPointer = SfdPointer
    
    SeriesClassificationPolicyDlc = ""
    
    ' this is only a question for PCC/NACO series authority records
    If InStr("abcz", Get008Value(12, 1)) = 0 Then
        GoTo SeriesClassificationPolicyDlc_Exit
    End If
    If Not FldFindFirst("010") Then
        GoTo SeriesClassificationPolicyDlc_Exit
    End If
    
    FldMoveTop
    Do While FldFindNext("646")
        sA$ = Mid(SfdText, 1, 1)
        Do While SfdFindNext("5")
            If Mid(SfdText, 1, 3) = "DLC" Then
                SeriesClassificationPolicyDlc = sA$
                lReturnFieldPointer = FldPointer
                GoTo SeriesClassificationPolicyDlc_Exit
            End If
        Loop
    Loop
    
SeriesClassificationPolicyDlc_Exit:
    
    FldPointer = lPointer
    SfdPointer = lSfdPointer

End Property


Public Property Get SeriesTracingPolicyDlc(Optional ByRef lReturnFieldPointer As Long) As String

    Dim lPointer As Long, lSfdPointer As Long
    
    Dim sPolicy$, sLcPolicy$, sA$
    
    
    ' preserve pointers
    lPointer = FldPointer
    lSfdPointer = SfdPointer
    
    SeriesTracingPolicyDlc = ""
    
    ' this is only a question for PCC/NACO series authority records
    If InStr("abcz", Get008Value(12, 1)) = 0 Then
        GoTo SeriesTracingPolicyDlc_Exit
    End If
    If Not FldFindFirst("010") Then
        GoTo SeriesTracingPolicyDlc_Exit
    End If
    
    FldMoveTop
    Do While FldFindNext("645")
        sA$ = Mid(SfdText, 1, 1)
        'Debug.Print "Found DLC field? " + FldText + "< >" + sA$ + "<"
        Do While SfdFindNext("5")
            If Mid(SfdText, 1, 3) = "DLC" Then
                SeriesTracingPolicyDlc = sA$
                lReturnFieldPointer = FldPointer
                GoTo SeriesTracingPolicyDlc_Exit
            End If
        Loop
    Loop

SeriesTracingPolicyDlc_Exit:
    
    FldPointer = lPointer
    SfdPointer = lSfdPointer

End Property

Public Property Get SeriesNumberingPatternDlc(Optional ByRef lReturnFieldPointer As Long) As String
    
    Dim lPointer As Long, lSfdPointer As Long
    
    Dim sPolicy$, sLcPolicy$, sA$
    
    
    ' preserve pointers
    lPointer = FldPointer
    lSfdPointer = SfdPointer
    
    SeriesNumberingPatternDlc = ""
    
    ' this is only a question for PCC/NACO series authority records
    If InStr("abcz", Get008Value(12, 1)) = 0 Then
        GoTo SeriesNumberingPatternDlc_Exit
    End If
    If Not FldFindFirst("010") Then
        GoTo SeriesNumberingPatternDlc_Exit
    End If
    
    FldMoveTop
    Do While FldFindNext("642")
        SfdFindFirst "a"
        sA$ = SfdText
        Do While SfdFindNext("5")
            If Mid(SfdText, 1, 3) = "DLC" Then
                SeriesNumberingPatternDlc = sA$
                lReturnFieldPointer = FldPointer
                GoTo SeriesNumberingPatternDlc_Exit
            End If
        Loop
    Loop
    
SeriesNumberingPatternDlc_Exit:
    
    FldPointer = lPointer
    SfdPointer = lSfdPointer

End Property


Public Property Get SeriesNumberingPatternDpcc(Optional ByRef lReturnFieldPointer As Long) As String
    
    Dim lPointer As Long, lSfdPointer As Long
    
    Dim sPolicy$, sA$
    Dim sNuc$
    
    Dim iRc%
    
    
    ' preserve pointers
    lPointer = FldPointer
    lSfdPointer = SfdPointer
    
    SeriesNumberingPatternDpcc = ""
    
    ' this is only a question for PCC/NACO series authority records: those
    '   that have 010 fields
    If InStr("abcz", Get008Value(12, 1)) = 0 Then
        GoTo SeriesNumberingPatternDpcc_Exit
    End If
    If Not FldFindFirst("010") Then
        GoTo SeriesNumberingPatternDpcc_Exit
    End If
    
    ' for series tracing, the PCC policy, narrowly so called, is
    '   1) an explicit statement of PCC tracing policy; or 2)
    '   lacking that explicit statement, ANY (non-local) 645
    '   that says "traced"
    ' here's part 1) of this
    FldMoveTop
    Do While FldFindNext("642")
        SfdFindFirst "a"
        sA$ = SfdText
        Do While SfdFindNext("5")
            If Mid(SfdText, 1, 4) = "DPCC" Then
                SeriesNumberingPatternDpcc = sA$
                lReturnFieldPointer = FldPointer
                GoTo SeriesNumberingPatternDpcc_Found
            End If
        Loop
    Loop
    
    ' if we get here, there is no explicit policy
    ' here's part 2) of the above-stated policy:
    '   is there any 642 field that has a $5 that's
    '   not a local $5?
    FldMoveTop
    Do While FldFindNext("642")
        sA$ = SfdText
        Do While SfdFindNext("5")
            sNuc$ = Trim(SfdText)
            If Mid(sNuc$, 1, 3) <> "DLC" Then
                iRc% = InStr(sNuc$, "-")
                If iRc% = 0 Then
                    iRc% = InStr(sNuc$, "/")
                End If
                If iRc% > 0 Then
                    sNuc$ = Mid(sNuc$, 1, iRc% - 1)
                End If
                If InStr(" " + Nuc, " " + sNuc$) = 0 Then
                    SeriesNumberingPatternDpcc = sA$
                    lReturnFieldPointer = FldPointer
                    GoTo SeriesNumberingPatternDpcc_Found
                End If
            End If
        Loop
    Loop
    
    sA$ = ""
    lReturnFieldPointer = 0
    
SeriesNumberingPatternDpcc_Found:

SeriesNumberingPatternDpcc_Exit:
    
    FldPointer = lPointer
    SfdPointer = lSfdPointer

End Property


Public Property Get SeriesNumberingPatternLocal(Optional ByRef lReturnFieldPointer As Long) As String

    Dim lPointer As Long, lSfdPointer As Long
    
    Dim sPolicy$, sNucCopy$, sA$, sSfd$
    
    Dim iRc%
    
    
    ' preserve pointers
    lPointer = FldPointer
    lSfdPointer = SfdPointer
    
    SeriesNumberingPatternLocal = ""
    
    FldMoveTop
    Do While FldFindNext("642")
        SfdFindFirst "a"
        sA$ = SfdText
        Do While SfdFindNext("5")
            sSfd$ = "5" + SfdText
            iRc% = InStr(sSfd$, "-")
            If iRc% > 0 Then
                sSfd$ = Mid(sSfd$, 1, iRc% - 1)
            End If
            ' any $5 whose stem matches anything in the string of
            '   NUC code roots is a "local" code
            If InStr(m_sLocalNucString$, sSfd$) > 0 Then
                SeriesNumberingPatternLocal = sA$
                lReturnFieldPointer = FldPointer
                GoTo SeriesNumberingPatternLocal_Exit
            End If
        Loop
    Loop
    
SeriesNumberingPatternLocal_Exit:
    
    FldPointer = lPointer
    SfdPointer = lSfdPointer

End Property


Public Function RemoveNonfilingZone(ByRef sTextIn$) As Boolean

    ' 20060317: created
    
    
    Dim iNonfilingIndicator%, iNonfiling%, iA%, iOctets%, iLenNonSortBegin%, iLenNonSortEnd%
    
    Dim sTagString$, sPrefix$, sNonSortBegin$, sNonSortEnd$
    
    Dim lPtr As Long, lPtr2 As Long, lEnd As Long
    
    Dim bZone As Boolean, bChanged As Boolean
    
    
    ' assume that the output is the same as the input
    RemoveNonfilingZone = False
    
    ' deal first with the nonfiling zone
    
    If m_bUtf8 Then
        sNonSortBegin$ = MyMarcCharacter.Utf8NonSortBegin
        sNonSortEnd$ = MyMarcCharacter.Utf8NonSortEnd
    Else
        sNonSortBegin$ = MyMarcCharacter.MarcNonSortBegin
        sNonSortEnd$ = MyMarcCharacter.MarcNonSortEnd
    End If
    
    iLenNonSortBegin% = Len(sNonSortBegin$)
    iLenNonSortEnd% = Len(sNonSortEnd$)
    
    For lPtr = Len(sTextIn$) To 1 Step -1
        If Mid(sTextIn, lPtr, iLenNonSortBegin%) = sNonSortBegin$ Then
            ' if we encounter this character, we will be changing the text,
            '   one way or the other
            RemoveNonfilingZone = True
            For lPtr2 = lPtr + iLenNonSortBegin% To Len(sTextIn$)
                If Mid(sTextIn$, lPtr, 1) = MarcDelimiter Then
                    ' by definition, this is a badly-constructed field!
                    sTextIn$ = SafeStuff(sTextIn$, lPtr, lPtr2 - lPtr, "")
                    GoTo RNFZ_BeginStructureOK
                ElseIf Mid(sTextIn$, lPtr2, iLenNonSortEnd%) = sNonSortEnd$ Then
                    sTextIn$ = SafeStuff(sTextIn$, lPtr, (lPtr2 + iLenNonSortEnd%) - lPtr, "")
                    ' the character at lPtr is now the first character that follows the
                    '   nonfiling zone
                    ' if this is at the beginning of the text, uppercase it
                    Select Case lPtr
                        Case 1
                            sTextIn$ = UCaseFirstWord(sTextIn$)
                        Case 3
                            sTextIn$ = UCaseFirstWord(sTextIn$)
                        'Case Else
                            ' it's something internal, that we aren't going to trouble ourselves about
                    End Select
                    GoTo RNFZ_BeginStructureOK
                End If
            Next
            ' if we get here, we found a NonSortBegin within a piece of text that is not
            '   followed either by a NonSortClose or a subfield delimiter:
            '   discard everything from the open through the end
            '   of the text
            sTextIn$ = Mid(sTextIn$, 1, lPtr - 1)
RNFZ_BeginStructureOK:
        ElseIf Mid(sTextIn$, lPtr, iLenNonSortEnd%) = sNonSortEnd$ Then
            ' we're checking here for things that are badly formed; if
            '   the text is correctly formed, we'll meet this one again when
            '   we hit NonSortBegin
            ' if the text is badly formed, we'll deal with it here
            For lPtr2 = lPtr To 1 Step -1
                If Mid(sTextIn$, lPtr2, 1) = MarcDelimiter Then
                    ' this is badly formed: we have a close not preceded in the same subfield
                    '   by an open
                    ' remove everything in the subfield following the delimiter, up to
                    '   and including the close
                    sTextIn$ = UCaseFirstWord(SafeStuff(sTextIn$, lPtr2 + 2, (lPtr + iLenNonSortEnd%) - (lPtr2 + 2), ""))
                    GoTo RNFZ_EndStructureOK
                ElseIf Mid(sTextIn$, lPtr2, iLenNonSortBegin%) = sNonSortBegin$ Then
                    ' this is well-formed--OK for us
                    GoTo RNFZ_EndStructureOK
                End If
            Next ' lptr2
            ' if we get here, we found an ending character and exited the preceding
            '   loop without finding either a preceding delimiter or NonSortBegin:
            '   discard everything that precedes the close (it is entirely possible
            '   that this will throw away the entire text)
            sTextIn$ = UCaseFirstWord(Mid(sTextIn$, lPtr + iLenNonSortEnd%))
            RemoveNonfilingZone = True
RNFZ_EndStructureOK:
        End If
    Next ' lPtr

End Function

Public Property Get PreserveLeadingNumericSubfields() As Boolean

    PreserveLeadingNumericSubfields = m_bPreserveLeadingNumericSubfields
    
End Property

Public Property Let PreserveLeadingNumericSubfields(ByVal vNewValue As Boolean)

    m_bPreserveLeadingNumericSubfields = vNewValue
    
End Property


Public Property Get IgnoreSfdOrder() As Boolean

    IgnoreSfdOrder = m_bIgnoreSfdOrder

End Property

Public Property Let IgnoreSfdOrder(ByVal vNewValue As Boolean)
    
    m_bIgnoreSfdOrder = vNewValue
    
End Property

Public Function XmlUnconditionText(ByVal sText$, Optional ByVal bTranslateUnknownAmpsersandNotations As Boolean = True) As String
    
    ' convert reserved XML codes into things that play nicer in MARC records
    
    Dim lPtr As Long, lPtr2 As Long, lPtr3 As Long, lEnd As Long
    Dim lRemoveLength As Long
    
    Dim bOK As Boolean
    
    Dim sPiece$, sTrailingCharacter$
    
    ' 20080126: lRemoveLength instituted to provide for unambiguous declaration
    '   of the number of bytes to remove
    
    
    If m_bUtf8 Then
        For lPtr = Len(sText$) To 1 Step -1
            Select Case Mid(sText$, lPtr, 1)
                Case "" ' hex C2, or decimal 194
                    ' 20090730: added to deal with unfortunate character in
                    '   Springer TOC pages
                    If Asc(Mid(sText$, lPtr + 1, 1)) = 160 Then ' hex A0, or decimal 160
                        ' C2A0 is the non-breaking space, which we will
                        '   replace with the plain space
                        sText$ = SafeStuff(sText$, lPtr, 2, " ")
                    End If
                Case "&"
                    sPiece$ = Mid(sText$, lPtr)
                    lPtr2 = LesserNonZero(InStr(sPiece$, vbLf), LesserNonZero(InStr(sPiece$, ";"), InStr(sPiece$, " ")))
                    If lPtr2 > 0 Then
                        lEnd = lPtr2
                        Select Case Mid(sPiece$, lPtr2, 1)
                            Case " "
                                sTrailingCharacter$ = " "
                                lRemoveLength = lPtr2 - 1
                            Case ";"
                                sTrailingCharacter$ = ""
                                lRemoveLength = lPtr2
                            Case vbLf
                                sTrailingCharacter$ = ""
                                lRemoveLength = lPtr2 - 1
                            Case Else
                                sTrailingCharacter$ = ""
                                lRemoveLength = lPtr2
                        End Select
                    Else
                        lEnd = Len(Mid(sText$, lPtr)) + 1
                        sTrailingCharacter$ = ""
                    End If
                    If lEnd > 0 Then
                        sPiece$ = Mid(sText$, lPtr + 1, lEnd - 2) ' removing the "&" and the terminal character at the same time
                        'Debug.Print "XUT piece: >" + sPiece$ + "<"
                        Select Case sPiece$
                            'Case "#191" ' en-dash?
                            '    sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "-")
                            Case "Aacute", "#193"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "A" + MarcAcute + sTrailingCharacter$)
                            Case "aacute", "#225"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "a" + MarcAcute + sTrailingCharacter$)
                            Case "Acirc", "#194"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "A" + MarcCircumflex + sTrailingCharacter$)
                            Case "acirc", "#226"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "a" + MarcCircumflex + sTrailingCharacter$)
                            Case "acute", "#180"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcAcute + sTrailingCharacter$)
                            Case "AElig", "#198"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcAEUpper + sTrailingCharacter$)
                            Case "aelig", "#230"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcAELower + sTrailingCharacter$)
                            Case "Agrave", "#192"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "A" + MarcGrave + sTrailingCharacter$)
                            Case "agrave", "#224"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "a" + MarcGrave + sTrailingCharacter$)
                            Case "alefsym", "#8501"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8501) + sTrailingCharacter$)
                            Case "alpha", "#945"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(945) + sTrailingCharacter$)
                            Case "amp" ' character 38
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "&" + sTrailingCharacter$)
                            Case "and", "#8743"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8743) + sTrailingCharacter$)
                            Case "ang", "8736"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8736) + sTrailingCharacter$)
                            Case "apos"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "'" + sTrailingCharacter$)
                            Case "Aring", "#197"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "A" + MarcAngstrom + sTrailingCharacter$)
                            Case "aring", "#229"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "a" + MarcAngstrom + sTrailingCharacter$)
                            Case "asymp", "#8776"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8776) + sTrailingCharacter$)
                            Case "Atilde", "#195"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "A" + MarcTilde + sTrailingCharacter$)
                            Case "atilde", "#227"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "a" + MarcTilde + sTrailingCharacter$)
                            Case "Auml", "#196"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "A" + MarcUmlaut + sTrailingCharacter$)
                            Case "auml", "#228"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "a" + MarcUmlaut + sTrailingCharacter$)
                            Case "bdquo", "#8222"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, Chr(34) + sTrailingCharacter$)
                            Case "Beta", "#914"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(914) + sTrailingCharacter$)
                            Case "beta", "#946"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(946) + sTrailingCharacter$)
                            Case "brvbar"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsHex2Utf8("00A6") + sTrailingCharacter$)
                            Case "bull"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8230) + sTrailingCharacter$)
                            Case "cap", "#8745"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8745) + sTrailingCharacter$)
                            Case "Ccedil", "#199"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "C" + MarcCedilla + sTrailingCharacter$)
                            Case "ccedil", "#231"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "c" + MarcCedilla + sTrailingCharacter$)
                            Case "cedil", "#184"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcCedilla + sTrailingCharacter$)
                            Case "cent"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsHex2Utf8("00A2") + sTrailingCharacter$) ' or 162
                            Case "Chi", "#935"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(935) + sTrailingCharacter$)
                            Case "chi", "#967"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(967) + sTrailingCharacter$)
                            Case "clubs", "#9827"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(9827) + sTrailingCharacter$)
                            Case "cong", "#8773"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8773) + sTrailingCharacter$)
                            Case "copy", "#169"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcCopyright + sTrailingCharacter$)
                            Case "crarr", "#8629"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8629) + sTrailingCharacter$)
                            Case "cup", "#8746"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8746) + sTrailingCharacter$)
                            Case "curren"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsHex2Utf8("00A4") + sTrailingCharacter$)
                            Case "Dagger", "#8225"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8225) + sTrailingCharacter$)
                            Case "dagger", "#8224"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8224) + sTrailingCharacter$)
                            Case "dArr", "#8659"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8659) + sTrailingCharacter$)
                            Case "darr", "#8595"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8595) + sTrailingCharacter$)
                            Case "deg"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcDegree + sTrailingCharacter$)
                            Case "Delta", "#916"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(916) + sTrailingCharacter$)
                            Case "delta", "#948"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(948) + sTrailingCharacter$)
                            Case "diams", "#9830"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(9830) + sTrailingCharacter$)
                            Case "divide"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsHex2Utf8("00F7") + sTrailingCharacter$)
                            Case "Eacute", "#201"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "E" + MarcAcute + sTrailingCharacter$)
                            Case "eacute", "#233"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "e" + MarcAcute + sTrailingCharacter$)
                            Case "Ecirc", "#202"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "E" + MarcCircumflex + sTrailingCharacter$)
                            Case "ecirc", "#234"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "e" + MarcCircumflex + sTrailingCharacter$)
                            Case "Egrave", "#200"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "E" + MarcGrave + sTrailingCharacter$)
                            Case "egrave", "#232"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "e" + MarcGrave + sTrailingCharacter$)
                            Case "empty", "#8709"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8709) + sTrailingCharacter$)
                            Case "emsp", "#8195"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, " ") ' obviously, trailing character is then irrelevant
                            Case "ensp", "#8194"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, " ") ' obviously, trailing character is then irrelevant
                            Case "Epsilon", "#917"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(917) + sTrailingCharacter$)
                            Case "epsilon", "#949"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(949) + sTrailingCharacter$)
                            Case "equiv", "#8801"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8801) + sTrailingCharacter$)
                            Case "Eta", "#919"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(919) + sTrailingCharacter$)
                            Case "eta", "#951"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(951) + sTrailingCharacter$)
                            Case "ETH", "#208"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcDSlashUpper + sTrailingCharacter$)
                            Case "eth", "#240"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcEth + sTrailingCharacter$)
                            Case "Euml", "#203"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "E" + MarcUmlaut + sTrailingCharacter$)
                            Case "emul", "#235"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "e" + MarcUmlaut + sTrailingCharacter$)
                            Case "exist", "#8707"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8707) + sTrailingCharacter$)
                            Case "fnof", "#402"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(402) + sTrailingCharacter$)
                            Case "forall", "8704"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8704) + sTrailingCharacter$)
                            Case "frac12"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "1/2" + sTrailingCharacter$) ' todo ...
                            Case "frac14"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "1/4" + sTrailingCharacter$) ' todo ...
                            Case "frac34"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "3/4" + sTrailingCharacter$) ' todo ...
                            Case "frasl", "#8260"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "/" + sTrailingCharacter$)
                            Case "Gamma", "#915"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(915) + sTrailingCharacter$)
                            Case "gamma", "#947"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(947) + sTrailingCharacter$)
                            Case "ge" ', "#8211"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8805) + sTrailingCharacter$)
                            Case "gt"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, ">" + sTrailingCharacter$)
                            Case "harr", "#8596"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8596) + sTrailingCharacter$)
                            Case "hArr", "#8660"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8660) + sTrailingCharacter$)
                            Case "hearts", "#9829"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(9829) + sTrailingCharacter$)
                            Case "hellip"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8230) + sTrailingCharacter$)
                            Case "Iacute", "#205"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "I" + MarcAcute + sTrailingCharacter$)
                            Case "iacute", "#237"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "i" + MarcAcute + sTrailingCharacter$)
                            Case "Icirc", "#206"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "I" + MarcCircumflex + sTrailingCharacter$)
                            Case "icirc", "#238"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "i" + MarcCircumflex + sTrailingCharacter$)
                            Case "Igrave", "#204"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "i" + MarcGrave + sTrailingCharacter$)
                            Case "igrave", "#236"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "i" + MarcGrave + sTrailingCharacter$)
                            Case "iexcl"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcExclamationInverted + sTrailingCharacter$)
                            Case "image", "#8465"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8465) + sTrailingCharacter$)
                            Case "infin", "#8734"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8734) + sTrailingCharacter$)
                            Case "int", "#8747"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8747) + sTrailingCharacter$)
                            Case "Iota", "#921"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(921) + sTrailingCharacter$)
                            Case "iota", "#953"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(953) + sTrailingCharacter$)
                            Case "iquest"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcQuestionInverted + sTrailingCharacter$)
                            Case "isin", "#8712"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8712) + sTrailingCharacter$)
                            Case "Iuml", "#207"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "I" + MarcUmlaut + sTrailingCharacter$)
                            Case "iuml", "#239"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "i" + MarcUmlaut + sTrailingCharacter$)
                            Case "Kappa", "#922"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(922) + sTrailingCharacter$)
                            Case "kappa", "#954"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(954) + sTrailingCharacter$)
                            Case "Lambda", "#923"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(923) + sTrailingCharacter$)
                            Case "lambda", "#955"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(955) + sTrailingCharacter$)
                            Case "lang", "#9001"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(9001) + sTrailingCharacter$)
                            Case "laquo", "#171"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, Chr(34) + sTrailingCharacter$) ' 00AB
                            Case "larr", "#8592"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8592) + sTrailingCharacter$)
                            Case "lArr", "#8656"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8656) + sTrailingCharacter$)
                            Case "lceil", "#8968"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8968) + sTrailingCharacter$)
                            Case "ldquo", "#8220"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, Chr(34) + sTrailingCharacter$)
                            Case "le", "#8804"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8804) + sTrailingCharacter$)
                            Case "lfloor", "#8970"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8970) + sTrailingCharacter$)
                            Case "lowast", "#8727"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8727) + sTrailingCharacter$)
                            Case "loz", "#9674"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(9674) + sTrailingCharacter$)
                            Case "lrm", "#8206"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8206) + sTrailingCharacter$)
                            Case "lsaquo", "#8249"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "'" + sTrailingCharacter$)
                            Case "lsquo", "#8216"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, Chr(34) + sTrailingCharacter$)
                            Case "lt"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "<" + sTrailingCharacter$)
                            Case "macr"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcMacron + sTrailingCharacter$)
                            Case "mdash"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "--" + sTrailingCharacter$)
                            Case "micro"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsHex2Utf8("00B5") + sTrailingCharacter$)
                            Case "middot"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcDotMiddle + sTrailingCharacter$)
                            Case "minus", "#8722"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "-" + sTrailingCharacter$)
                            Case "Mu", "#924"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(924) + sTrailingCharacter$)
                            Case "mu", "#956"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(956) + sTrailingCharacter$)
                            Case "nabla", "#8711"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8711) + sTrailingCharacter$)
                            Case "nbsp"
                                ' in LC TOC, nbsp is known to be a bad translation for a+acute; until the need
                                '   arises, do not replace with the most likely thing, " " (or, most
                                '   literally, MyMarcCharacter.UcsHex2Utf8("00A0") or char 160
                                ' 20080208: sadly, this is ALSO known in LC TOC to be a representation
                                '   of the non-breaking space; cf 2007012264.html
                                ' until something else turns up to give us a reliable way to differentate
                                '   between the two possibilities, we're going to have to use the space
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, " ")
                                'sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "a" + MarcAcute + sTrailingCharacter$)
                            Case "ndash", "#8211"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "-" + sTrailingCharacter$)
                            Case "ne", "#8800"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8800) + sTrailingCharacter$)
                            Case "ni", "#8715"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8715) + sTrailingCharacter$)
                            Case "not", "#172"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsHex2Utf8("00AC") + sTrailingCharacter$)
                            Case "notin", "#8713"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8713) + sTrailingCharacter$)
                            Case "nsub", "#8836"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8836) + sTrailingCharacter$)
                            Case "Ntilde", "#209"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "N" + MarcTilde + sTrailingCharacter$)
                            Case "ntilde", "#241"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "n" + MarcTilde + sTrailingCharacter$)
                            Case "Nu", "#925"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(925) + sTrailingCharacter$)
                            Case "nu", "#957"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(957) + sTrailingCharacter$)
                            Case "Oacute", "#211"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "O" + MarcAcute + sTrailingCharacter$)
                            Case "oacute", "#243"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "o" + MarcAcute + sTrailingCharacter$)
                            Case "Ocirc", "#212"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "O" + MarcCircumflex + sTrailingCharacter$)
                            Case "ocirc", "#244"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "o" + MarcCircumflex + sTrailingCharacter$)
                            Case "OElig", "#338"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(338) + sTrailingCharacter$)
                            Case "oelig", "#339"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(339) + sTrailingCharacter$)
                            Case "Ograve", "#210"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "O" + MarcGrave + sTrailingCharacter$)
                            Case "ograve", "#242"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "o" + MarcGrave + sTrailingCharacter$)
                            Case "oline", "#8254"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8254) + sTrailingCharacter$)
                            Case "Omega", "#937"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(937) + sTrailingCharacter$)
                            Case "omega", "#969"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(969) + sTrailingCharacter$)
                            Case "Omicron", "#927"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(927) + sTrailingCharacter$)
                            Case "omicron", "#959"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(959) + sTrailingCharacter$)
                            Case "oplus", "#8853"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8853) + sTrailingCharacter$)
                            Case "or", "#8744"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8744) + sTrailingCharacter$)
                            Case "ordf", "#170"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsHex2Utf8("00AA") + sTrailingCharacter$) ' todo: or just "a"?
                            Case "ordm", "#186"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsHex2Utf8("00BA") + sTrailingCharacter$) ' todo: or just "o"?
                            Case "Oslash", "#216"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcOSlashUpper + sTrailingCharacter$)
                            Case "oslash", "#248"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcOSlashLower + sTrailingCharacter$)
                            Case "Otilde", "#213"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "O" + MarcTilde + sTrailingCharacter$)
                            Case "otilde", "#245"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "o" + MarcTilde + sTrailingCharacter$)
                            Case "otimes", "#8855"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8855) + sTrailingCharacter$)
                            Case "Ouml", "#214"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "O" + MarcUmlaut + sTrailingCharacter$)
                            Case "ouml", "#246"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "o" + MarcUmlaut + sTrailingCharacter$)
                            Case "para"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsHex2Utf8("00B6") + sTrailingCharacter$)
                            Case "part", "#8706"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8706) + sTrailingCharacter$)
                            Case "permil"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8240) + sTrailingCharacter$)
                            Case "perp", "#8869"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8869) + sTrailingCharacter$)
                            Case "Phi", "#934"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(934) + sTrailingCharacter$)
                            Case "phi", "#966"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(966) + sTrailingCharacter$)
                            Case "Pi", "#928"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(928) + sTrailingCharacter$)
                            Case "pi", "#960"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(960) + sTrailingCharacter$)
                            Case "piv", "#982"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(982) + sTrailingCharacter$)
                            Case "plusmn"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcPlusMinus + sTrailingCharacter$)
                            Case "pound"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcBritishPound + sTrailingCharacter$)
                            Case "prime"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8243) + sTrailingCharacter$)
                            Case "prod", "#8719"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8719) + sTrailingCharacter$)
                            Case "prop", "#8733"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8733) + sTrailingCharacter$)
                            Case "Psi", "#936"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(936) + sTrailingCharacter$)
                            Case "psi", "#968"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(968) + sTrailingCharacter$)
                            Case "quot" ' character 34
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, Chr(34) + sTrailingCharacter$)
                            Case "radic", "#8730"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8730) + sTrailingCharacter$)
                            Case "rang", "#9002"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(9002) + sTrailingCharacter$)
                            Case "raquo", "#187"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, Chr(34) + sTrailingCharacter$) ' 00BB
                            Case "rarr", "#8594"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8594) + sTrailingCharacter$)
                            Case "rArr", "#8658"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8658) + sTrailingCharacter$)
                            Case "rceil", "#8969"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8969) + sTrailingCharacter$)
                            Case "rdquo", "#8221"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, Chr(34) + sTrailingCharacter$)
                            Case "real", "#8476"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8476) + sTrailingCharacter$)
                            Case "rfloor", "#8971"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8971) + sTrailingCharacter$)
                            Case "Rho", "#929"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(929) + sTrailingCharacter$)
                            Case "rho", "#961"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(961) + sTrailingCharacter$)
                            Case "rlm", "#8207"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8207) + sTrailingCharacter$)
                            Case "rsaquo", "#8250"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "'" + sTrailingCharacter$)
                            Case "rsquo", "#8217"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, Chr(34) + sTrailingCharacter$)
                            Case "reg"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcRegistered + sTrailingCharacter$)
                            Case "sbquo", "#8218"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, Chr(34) + sTrailingCharacter$)
                            Case "sdot", "#8901"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8901) + sTrailingCharacter$)
                            Case "sect"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsHex2Utf8("00A7") + sTrailingCharacter$)
                            Case "shy", "#173"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "" + sTrailingCharacter$) ' 00AD: soft hyphen
                            Case "Sigma", "#931"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(931) + sTrailingCharacter$)
                            Case "sigma", "#963"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(963) + sTrailingCharacter$)
                            Case "sigmaf", "#962"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(962) + sTrailingCharacter$)
                            Case "sim", "#8773"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8764) + sTrailingCharacter$)
                            Case "spades", "#9824"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(9824) + sTrailingCharacter$)
                            Case "sub", "#8834"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8834) + sTrailingCharacter$)
                            Case "sube", "#8838"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8838) + sTrailingCharacter$)
                            Case "sum", "#8721"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8721) + sTrailingCharacter$)
                            Case "sup1"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcSuperscript1 + sTrailingCharacter$)
                            Case "sup2"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcSuperscript2 + sTrailingCharacter$)
                            Case "sup3"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcSuperscript3 + sTrailingCharacter$)
                            Case "sup", "#8835"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8835) + sTrailingCharacter$)
                            Case "supe", "#8839"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8839) + sTrailingCharacter$)
                            Case "szlig"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsHex2Utf8("00DF") + sTrailingCharacter$)
                            Case "Tau", "#932"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(932) + sTrailingCharacter$)
                            Case "tau", "#964"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(964) + sTrailingCharacter$)
                            Case "there4", "#8756"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8756) + sTrailingCharacter$)
                            Case "Theta", "#920"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(920) + sTrailingCharacter$)
                            Case "theta", "#952"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(952) + sTrailingCharacter$)
                            Case "thetasym", "977"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(977) + sTrailingCharacter$)
                            Case "thinsp", "#8201"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, " " + sTrailingCharacter$)
                            Case "THORN"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcThornUpper + sTrailingCharacter$)
                            Case "thorn", "254"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcThornLower + sTrailingCharacter$)
                            Case "times"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "x" + sTrailingCharacter$)
                            Case "trade"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8482) + sTrailingCharacter$)
                            Case "Uacute", "218"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "U" + MarcAcute + sTrailingCharacter$)
                            Case "uacute", "250"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "u" + MarcAcute + sTrailingCharacter$)
                            Case "uarr", "#8593"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8593) + sTrailingCharacter$)
                            Case "uArr", "#8657"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8657) + sTrailingCharacter$)
                            Case "Ucirc", "#219"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "U" + MarcCircumflex + sTrailingCharacter$)
                            Case "ucirc", "#251"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "u" + MarcCircumflex + sTrailingCharacter$)
                            Case "Ugrave", "#217"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "U" + MarcGrave + sTrailingCharacter$)
                            Case "ugrave", "#249"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "u" + MarcGrave + sTrailingCharacter$)
                            Case "uml"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MarcUmlaut + sTrailingCharacter$) ' 00A8
                            Case "upsih", "#978"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(978) + sTrailingCharacter$)
                            Case "Upsilon", "#933"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(933) + sTrailingCharacter$)
                            Case "upsilon", "#965"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(965) + sTrailingCharacter$)
                            Case "Uuml"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "U" + MarcUmlaut + sTrailingCharacter$)
                            Case "uuml", "#252"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "u" + MarcUmlaut + sTrailingCharacter$)
                            Case "Xi", "#926"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(926) + sTrailingCharacter$)
                            Case "xi", "#958"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(958) + sTrailingCharacter$)
                            Case "Yacute", "#221"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "Y" + MarcAcute + sTrailingCharacter$)
                            Case "yacute", "#253"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, "y" + MarcAcute + sTrailingCharacter$)
                            Case "yen"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsHex2Utf8("00A5") + sTrailingCharacter$)
                            Case "Zeta", "#918"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(918) + sTrailingCharacter$)
                            Case "zeta", "#950"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(950) + sTrailingCharacter$)
                            Case "zwj", "#8205"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8205) + sTrailingCharacter$)
                            Case "zwnj", "#8204"
                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(8204) + sTrailingCharacter$)
                            Case Else
                                'Debug.Print vbTab + "Unknown piece: >" + sPiece$ + "< " + str(bTranslateUnknownAmpsersandNotations)
                                If bTranslateUnknownAmpsersandNotations Then
                                    bOK = True
                                    Select Case Mid(sPiece$, 1, 1)
                                        Case "#"
                                            If InStr("Xx", Mid(sPiece$, 2, 1)) > 0 Then
                                                sPiece$ = UCase(sPiece$)
                                                For lPtr3 = 3 To Len(sPiece$)
                                                    If InStr("0123456789ABCDEF", Mid(sPiece$, lPtr3, 1)) = 0 Then
                                                        bOK = False
                                                        Exit For
                                                    End If
                                                Next ' lptr3
                                                If bOK Then
                                                    MyMarcCharacter.UcsHex = Mid(sPiece$, 3)
                                                    sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.Utf8Char) + sTrailingCharacter$
                                                End If
                                            Else
                                                For lPtr3 = 2 To Len(sPiece$)
                                                    If InStr("0123456789", Mid(sPiece$, lPtr3, 1)) = 0 Then
                                                        bOK = False
                                                        Exit For
                                                    End If
                                                Next ' lptr3
                                                If bOK Then
                                                    'Debug.Print "OK"
                                                    sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.UcsNumericToUtf8(Val(Mid(sPiece$, 2))) + sTrailingCharacter$)
                                                End If
                                            End If
                                        Case "X", "x"
                                            sPiece$ = UCase(sPiece$)
                                            For lPtr3 = 2 To Len(sPiece$)
                                                If InStr("0123456789ABCDEF", Mid(sPiece$, lPtr3, 1)) = 0 Then
                                                    bOK = False
                                                    Exit For
                                                End If
                                            Next ' lptr3
                                            If bOK Then
                                                MyMarcCharacter.UcsHex = Mid(sPiece$, 2)
                                                sText$ = SafeStuff(sText$, lPtr, lRemoveLength, MyMarcCharacter.Utf8Char) + sTrailingCharacter$
                                            End If
                                    End Select
                                End If
                       End Select
                    End If
                Case vbCr, vbLf
                    sText$ = SafeStuff(sText$, lPtr, 1, "")
            End Select
        Next ' lptr
    End If
    
    XmlUnconditionText = sText$

End Function

Public Function LesserNonZero(ByVal lNumeral1 As Long, ByVal lNumeral2 As Long) As Long

    If lNumeral1 = 0 Then
        LesserNonZero = lNumeral2 ' which may itself be zero
    ElseIf lNumeral2 = 0 Then
        LesserNonZero = lNumeral1
    ElseIf lNumeral1 < lNumeral2 Then
        LesserNonZero = lNumeral1
    Else
        LesserNonZero = lNumeral2
    End If
    
End Function


Private Sub TranslateMarc2Utf8HexNotation(ByRef sOut$)

    Dim iRc%, iRc2%, iRc3%
    
    Dim sRight$, sLeft$
    
    Dim bRetainCharacter As Boolean
    
    ' to get here we should have a string that contains "&#" but we're going
    '   to do another test here for insurance, and this time we'll include
    ' 20070125: include the "optional" starting position!
    If InStr(1, sOut$, "&#x", vbTextCompare) > 0 Then
        For iRc% = Len(sOut$) - 3 To 1 Step -1
            If UCase(Mid(sOut$, iRc%, 3)) = "&#X" Then
                sLeft$ = Mid(sOut$, 1, iRc% - 1)
                sRight$ = Mid(sOut$, iRc% + 3)
                iRc2% = InStr(sRight$, ";")
                If iRc2% = 0 Then
                    For iRc3% = iRc% + 3 To iRc% + 10
                        If InStr("0123456789abcdefABCDEF", Mid(sRight$, iRc3%, 1)) = 0 Then
                            bRetainCharacter = True
                            iRc2% = iRc3% ' otherwise, irc2 stays at zero
                            Exit For
                        End If
                    Next ' irc2%
                End If
                If iRc2% < 6 And iRc2% > 0 Then ' should really be exactly 5, but we'll allow for drop of leading zeroes
                    MyMarcCharacter.UcsHex = Right("0000" + Mid(sRight$, 1, iRc2% - 1), 4)
                    If Not bRetainCharacter Then
                        sOut$ = sLeft$ + MyMarcCharacter.Utf8Char + Mid(sRight$, iRc2% + 1)
                    Else
                        sOut$ = sLeft$ + MyMarcCharacter.Utf8Char + Mid(sRight$, iRc2%)
                    End If
                End If
            End If
        Next
    End If
    
End Sub

Public Sub XmlModsAssembleNamePersonal(ByRef sOut$, ByVal sRole$, ByVal sType$, ByVal sCrlfTabTab$, sAuthority$)

    Dim sField$
    
    If SfdFindFirst("a") Then
        sField$ = XmlRecordOutOneLump("namePart", 0, "aq", "")
        If SfdFindFirst("d") Then
            sField$ = sField$ + XmlRecordOutOneLump("namePart type=" + AddQuotes("date"), 0, "d", "")
        End If
        If SfdFindFirst("b") Then
XmlRecordOut100b:               ' NOTE label in left margin
            sField$ = sField$ + XmlRecordOutOneLump("namePart type=" + AddQuotes("termsOfAddress"), 0, "bc", "")
        ElseIf SfdFindFirst("c") Then
            GoTo XmlRecordOut100b
        End If
        If Len(sRole$) = 0 Then
            If SfdFindFirst("e") Then
                sRole$ = SfdText
            End If
        End If
        If SfdFindFirst("4") Then
            sField$ = sField$ + XmlRecordOutOneLump("namePart type=" + AddQuotes("code"), 0, "4", "")
        End If
        If SfdFindFirst("u") Then
            sField$ = sField$ + XmlRecordOutOneLump("namePart type=" + AddQuotes("affiliation"), 0, "u", "")
        End If
        If SfdFindFirst("9") Then
            sField$ = sField$ + XmlRecordOutOneLump("displayForm", 0, "9", "", " ", False)
        End If
        XmlModsAssembleNameGeneric sOut$, sField$, sType$, sRole$, sCrlfTabTab$, sAuthority$
    End If

End Sub

Public Sub XmlModsAssembleNameCorporate(ByRef sOut$, ByVal sRole$, ByVal sType$, ByVal sCrlfTabTab$, sAuthority$)

    Dim sField$
    
    If SfdFindFirst("a") Then
        sField$ = XmlRecordOutOneLump("namePart", 0, "a", "")
        If SfdFindFirst("b") Then
            ' output each $b separately
            Do
                sField$ = sField$ + XmlRecordOutOneLump("namePart", 0, "b", "b")
                If Not SfdFindNext("b") Then
                    Exit Do
                End If
            Loop
        End If
        If SfdFindFirst("c") Then
XmlRecordOut110c:               ' NOTE label in left margin
            sField$ = sField$ + XmlRecordOutOneLump("namePart", 0, "cdn", "")
        ElseIf SfdFindFirst("d") Then
            GoTo XmlRecordOut110c
        ElseIf SfdFindFirst("n") Then
            GoTo XmlRecordOut110c
        End If
        ' 20080527: per Karen Miller, $e doesn't have a type attribute
        If SfdFindFirst("e") Then
            sField$ = sField$ + XmlRecordOutOneLump("namePart", 0, "e", "")
        End If
        'If SfdFindFirst("e") Then
        '    sField$ = sField$ + XmlRecordOutOneLump("namePart type=" + AddQuotes("text"), 0, "e", "")
        'End If
        If SfdFindFirst("4") Then
            sField$ = sField$ + XmlRecordOutOneLump("namePart type=" + AddQuotes("code"), 0, "4", "")
        End If
        XmlModsAssembleNameGeneric sOut$, sField$, sType$, sRole$, sCrlfTabTab$, sAuthority$
    End If

End Sub

Public Sub XmlModsAssembleNameGeneric(ByRef sOut$, ByVal sField$, ByVal sType$, ByVal sRole$, sCrlfTabTab$, sAuthority$)


    Dim sQualifierString$
    
    If Len(sType$) > 0 Then
        sQualifierString$ = "type=" + AddQuotes(sType$)
    End If
    If Len(sAuthority$) > 0 Then
        If InStr(sAuthority$, Chr(34)) = 0 Then
            sQualifierString$ = sQualifierString$ + " authority=" + AddQuotes(sAuthority$)
        Else
            sQualifierString$ = sQualifierString$ + sAuthority$
        End If
    End If
    sQualifierString$ = Trim(sQualifierString$)
    If Len(sField$) > 0 Then
        If Len(sRole$) > 0 Then
            sOut$ = sOut$ + sCrlfTabTab$ + XmlTags("name " + sQualifierString$, XmlTags("role", XmlTags("roleTerm type=" + AddQuotes("text"), sRole$)) + sField$)
        Else
            sOut$ = sOut$ + sCrlfTabTab$ + XmlTags("name " + sQualifierString$, sField$)
        End If
    End If

End Sub


Public Sub XmlModsAssembleNameConference(ByRef sOut$, ByVal sRole$, ByVal sType$, ByVal sCrlfTabTab$, sAuthority$)

    Dim sField$
    
    If SfdFindFirst("a") Then
        sField$ = XmlRecordOutOneLump("namePart", 0, "acdenq", "")
        If SfdFindFirst("4") Then
            sField$ = sField$ + XmlRecordOutOneLump("namePart type=" + AddQuotes("code"), 0, "4", "")
        End If
        XmlModsAssembleNameGeneric sOut$, sField$, sType$, sRole$, sCrlfTabTab$, sAuthority$
    End If

End Sub

Public Sub TranslateMarc2Utf8OneField_Save(ByVal sMarcRecordFormat$, ByVal sTag$, ByRef sIndicators$, ByRef sField$, ByRef bChanged As Boolean, ByRef bError As Boolean)

#If False Then

    ' translate one entire variable field in some MARC-8 representation into its UTF-8 representation
    
    Dim sCharacterSet$, sWork$, sPiece$, sNonfiling$, sChar$, sNextCharacterSet$, sLeft$, sOut$
    
    Dim iIndicator%, iNonfiling%, iCtr%, iEscape%
    
    Dim bLocalChanged As Boolean
    
    
    ' todo: theoretically, we should also translate the indicators, like this: anything that's
    '   above char #127 becomes the fill character (and the reverse in the utf-to-marc routine)
    
    ' maybe the nonfiling indicator points to a diacritic?
    ' if so, move any diacritics out of the nonfiling zone and
    '   reset the nonfiling indicator appropriately
    ' figure out of this field has a nonfiling characters delimiter
    Select Case sMarcRecordFormat$
        Case "A"
            Select Case sTag$
                Case "130", "430", "530"
                    iIndicator% = 2
                Case Else
                    iIndicator% = 0
            End Select
        Case "H"
            iIndicator% = 0
        Case Else
            Select Case sTag$
                Case "130", "430", "630", "730"
                    iIndicator% = 1
                Case "222", "240", "242", "243", "245", "440", "830"
                    iIndicator% = 2
                Case Else
                    iIndicator% = 0
            End Select
    End Select
    
    ' if there is a nonfiling indicator, find out its value
    If iIndicator% > 0 Then
        iNonfiling% = Val(Mid(sIndicators$, iIndicator%, 1))
        ' if there are nonfiling characters present, move any diacritics
        '   out of the nonfiling zone
        If iNonfiling% > 0 Then
            sPiece$ = Mid(sField$, 1, 2) ' remove sfd code
            sField$ = Mid(sField$, 3)
            sNonfiling$ = Mid(sField$, 1, iNonfiling%)
            sField$ = Mid(sField$, iNonfiling% + 1)
            Do
                sChar$ = Right(sNonfiling$, 1) ' remember: currently single-byte characters
                If Asc(sChar$) > 223 Then ' diacritics start at character 224
                    sField$ = sChar$ + sField$
                    sNonfiling$ = Mid(sNonfiling$, 1, Len(sNonfiling$) - 1)
                    If Len(sNonfiling$) = 0 Then
                        ' nothing left in the nonfiling zone
                        Exit Do
                    End If
                Else ' terminal character not a diacritic: all done
                    Exit Do
                End If
            Loop
            iCtr% = Len(sNonfiling$)
            ' only bother to reset the indicator if there's a change
            If iCtr% <> iNonfiling% Then
                sIndicators$ = SafeStuff(sIndicators$, iIndicator%, 1, Trim(str(iCtr%)))
                bChanged = True
            End If
            ' no matter what, reset the field to its original full contents
            sWork$ = sPiece$ + sNonfiling$ + sField$
        Else
            sWork$ = sField$
        End If ' nonfiling indicator is non-zero?
    Else
        sWork$ = sField$
    End If ' nonfiling indicator defined for this field?
        
        
    ' each field is assumed to start with the standard character set
    sCharacterSet$ = "s"
    
    ' find the first escape-marked break, if any; or (most common case) move the entire string from
    '   sWork to sPiece and set sWork to null
    TranslateMarc2Utf8OneFieldFindBreak sWork$, sPiece$, sCharacterSet$, sNextCharacterSet$
    
    ' we've broken off the first piece, and we know what character set
    '   is used to represent it (the 'standard' set in all cases)
    ' do each escape-delimited piece, starting with the
    '   first one that we've already broken off
    Do
    
        ' here's where the work of translation occurs; we don't appear to do anything
        '   with bLocalChanged (at the bottom of this routine, we do a plain ol'
        '   string compare to see if anything's different)
        TranslateMarc2Utf8Text sCharacterSet$, sTag$, sPiece$, bLocalChanged, bError
        
        ' add the just-translated bit to the growing output string
        sOut$ = sOut$ + sPiece$
        
        ' all fields that do not contain
        '   an escape will exit here after the first piece--which is
        '   the whole thing--is handled by the above translation; and
        '   of course pieces that do contain an escape will exit here when
        '   we're done
        If Len(sWork$) = 0 Then
            Exit Do
        End If
        ' we've previously isolated the marker for the
        '   next character set; the character set that
        '   begins the next piece is now the current
        '   character set
        sCharacterSet$ = sNextCharacterSet$
        
        TranslateMarc2Utf8OneFieldFindBreak sWork$, sPiece$, sCharacterSet$, sNextCharacterSet$
        
#If False Then
        ' divide the remaining string at the next escape
        '   character, provided that the next escape occurs within
        '   the current subfield
        iEscape% = InStr(sWork$, MyMarcCharacter.MarcEscape)
        If iEscape% = 0 Then
            ' this is theoretically the last piece in the string
            If Mid(sWork$, 1, 1) = MyMarcCharacter.MarcDelimiter Then
                sLeft$ = Mid(sWork$, 1, 2)
                sPiece$ = Mid(sWork$, 3)
            Else
                sLeft$ = ""
                sPiece$ = sWork$
            End If
            If sCharacterSet$ <> "s" Then
                iCtr% = InStr(sPiece$, MyMarcCharacter.MarcDelimiter)
                If iCtr% > 0 Then
                    sPiece$ = sLeft$ + Mid(sPiece$, 1, iCtr% - 1)
                    sWork$ = Mid(sWork$, Len(sPiece$) + 1)
                    sNextCharacterSet$ = "s"
                Else
                    sPiece$ = sLeft$ + sPiece$
                    sWork$ = ""
                End If
            Else
                sPiece$ = sLeft$ + sPiece$
                sWork$ = ""
            End If
        Else
            ' there is at least one more escape-delimited piece in the string
            sPiece$ = Mid(sWork$, 1, iEscape% - 1)
            iCtr% = InStr(sPiece$, MarcDelimiter)
            If iCtr% > 0 And (sCharacterSet$ <> "s" And sCharacterSet$ <> "(B") Then
                sPiece$ = Mid(sPiece$, 1, iCtr% - 1)
                sWork$ = Mid(sWork$, iCtr%)
                sNextCharacterSet$ = "s"
            Else
                Select Case Mid(sWork$, iEscape% + 1, 1)
                    Case "s", "p", "b", "g"
                        sNextCharacterSet$ = Mid(sWork$, iEscape% + 1, 1)
                        sWork$ = Mid(sWork$, iEscape% + 2)
                    Case Else ' better be a two-character char set marker!
                        sNextCharacterSet$ = Mid(sWork$, iEscape% + 1, 2)
                        sWork$ = Mid(sWork$, iEscape% + 3)
                        If sNextCharacterSet$ = "(B" Then
                            sNextCharacterSet$ = "s"
                        End If
                End Select
            End If
        End If
#End If

    Loop

    ' 20060801: accommodate "&#x...;" notation
    If InStr(sOut$, "&#") > 0 Then
        TranslateMarc2Utf8HexNotation sOut$
    End If
    
    If sField$ <> sOut$ Then
        bChanged = True
        sField$ = sOut$
    End If

#End If

End Sub

Public Sub TranslateMarc2Utf8OneFieldFindBreak_Save(ByRef sWork$, ByRef sPiece$, ByVal sCharacterSet$, ByRef sNextCharacterSet$)

#If False Then

    Dim iEscape%, iCtr%
    
    Dim sLeft$
    
    Dim bDebug As Boolean
    
#If TranslateMarc2Utf8FindBreakDebug = -1 Then
    Debug.Print "TM2U8OFFB >" + sWork$ + "< >" + sPiece$ + "< >" + sCharacterSet$ + "< >" + sNextCharacterSet$ + "<"
    If InStr(sWork$, "BGN") > 0 Then
        bDebug = True
    End If
#End If

    ' at least temporarily, set sPiece to the first escape-delimited piece
    iEscape% = InStr(sWork$, MyMarcCharacter.MarcEscape)
    If iEscape% = 0 Then ' most common case: no character-set-switching present
        If sCharacterSet$ = "s" Then
            ' the most common of the most common cases: no escapes, and we're
            '   starting with the standard character set
            ' this is also always the case for the first piece in the whole field (even
            '   if the piece consists solely of the delimiter and
            '   a subfield code)
            sPiece$ = sWork$
            sWork$ = ""
        Else
            ' we're going to break things at subfield codes, anyway
            If Mid(sWork$, 1, 1) = MyMarcCharacter.MarcDelimiter Then
                sLeft$ = Mid(sWork$, 1, 2)
                sPiece$ = Mid(sWork$, 3)
            Else
                sLeft$ = ""
                sPiece$ = sWork$
            End If
            iCtr% = InStr(sPiece$, MyMarcCharacter.MarcDelimiter)
            If iCtr% > 0 Then
                sPiece$ = sLeft$ + Mid(sPiece$, 1, iCtr% - 1)
                sWork$ = Mid(sWork$, Len(sPiece$) + 1)
                sNextCharacterSet$ = "s"
            Else
                sPiece$ = sLeft$ + sPiece$
                sWork$ = ""
            End If
        End If
        ' we don't have to worry about sNextCharacterSet, because there are
        '   no characters to deal with after we've handled this piece
    Else
        sPiece$ = Mid(sWork$, 1, iEscape% - 1)
        ' but we need to figure out whether the escape character occurs within
        '   the lead subfield or within some other subfield
        ' temporarily remove any leading delimiter/subfield code, so it doesn't
        '   interfere with the following operation
        If Mid(sPiece$, 1, 1) = MyMarcCharacter.MarcDelimiter Then ' should be!
            sLeft$ = Mid(sPiece$, 1, 2)
            sPiece$ = Mid(sPiece$, 3)
        End If
        iCtr% = InStr(sPiece$, MyMarcCharacter.MarcDelimiter)
        If iCtr% > 0 Then
            ' this piece contains an *internal* subfield code:
            '   pretend we're breaking at the subfield
            '   code, and assume we switch back to normal characters
            ' the escape-break is within some other subfield
            sPiece$ = sLeft$ + Mid(sPiece$, 1, iCtr% - 1)
            sWork$ = Mid(sWork$, Len(sPiece$) + 1)
            sNextCharacterSet$ = "s"
        Else
            ' no internal subfield codes in this piece: the
            '   escape-break occurs within the lead subfield
            ' re-fetch the piece from the original field (we could,
            '   instead, re-attach the subfield code to achieve the
            '   same result)
            sPiece$ = Mid(sWork$, 1, iEscape% - 1)
            Select Case Mid(sWork$, iEscape% + 1, 1)
                Case "s", "p", "b", "g"
                    sNextCharacterSet$ = Mid(sWork$, iEscape% + 1, 1)
                    sWork$ = Mid(sWork$, iEscape% + 2)
                Case "!"
                    ' only recognized values are to indicate
                    '   extended Latin as G0 or G1: )!E and (!E
                    sNextCharacterSet$ = Mid(sWork$, iEscape% + 1, 3)
                    sWork$ = Mid(sWork$, iEscape% + 4)
                Case Else ' some non-roman set, including multi-byte
                    ' preliminarily, we'll assume that the
                    '   character-set designation is two bytes (which
                    '   it is, mostly); and deal just below with the
                    '   exceptions
                    sNextCharacterSet$ = Mid(sWork$, iEscape% + 1, 2)
                    ' 20050722: exceptionally, multi-byte G0 and G1 sets
                    '   may be designated with additional characters (note
                    '   that multi-byte G1 sets don't actually make any
                    '   sense, but we won't be handling that question
                    '   here)
                    Select Case sNextCharacterSet$
                        'Case "$1"
                            ' the standard way to say multi-byte EACC set appears
                            '   as G0; this is taken care of by the default
                            '   handling, below
                        Case "$,"
                            ' alternate way to say multi-byte character set appears
                            '   as G0; convert into standard notation "$" plus
                            '   character-set character
                            sNextCharacterSet$ = "$" + Mid(sWork$, iEscape% + 3, 1)
                            sWork$ = Mid(sWork$, iEscape% + 4)
                        Case "$-"
                            ' alternate way to indicate multi-byte character set
                            '   appears as G1; convert into standard notation "$)"
                            '   plus character-set character
                            sNextCharacterSet$ = "$)" + Mid(sWork$, iEscape% + 3, 1)
                            sWork$ = Mid(sWork$, iEscape% + 4)
                        Case "$)"
                            ' standard way to indicate multi-byte character set
                            '   appears as G1; pick up the character-set character
                            '   as part of the notation
                            sNextCharacterSet$ = "$)" + Mid(sWork$, iEscape% + 3, 1)
                            sWork$ = Mid(sWork$, iEscape% + 4)
                        Case "$-"
                            ' alternate way to indicate multi-byte character set
                            '   appears as G1
                            sNextCharacterSet$ = "$)" + Mid(sWork$, iEscape% + 3, 1)
                            sWork$ = Mid(sWork$, iEscape% + 4)
                        Case ")B"
                            sNextCharacterSet$ = "s"
                            sWork$ = Mid(sWork$, iEscape% + 3)
                        Case Else
                            ' leave the code as is
                            sWork$ = Mid(sWork$, iEscape% + 3)
                    End Select
            End Select
        End If
    End If

#End If

End Sub

Public Sub TranslateMarc2Utf8OneFieldFindBreakAdjustCode(ByRef sNextCharacterSet$, ByVal iEscape%, ByRef sWork$)

    ' 20050722: exceptionally, multi-byte G0 and G1 sets
    '   may be designated with additional characters (note
    '   that multi-byte G1 sets don't actually make any
    '   sense, but we won't be handling that question
    '   here)
    Select Case sNextCharacterSet$
        'Case "$1"
            ' the standard way to say multi-byte EACC set appears
            '   as G0; this is taken care of by the default
            '   handling, below
        Case "$,"
            ' alternate way to say multi-byte character set appears
            '   as G0; convert into standard notation "$" plus
            '   character-set character
            sNextCharacterSet$ = "$" + Mid(sWork$, iEscape% + 3, 1)
            sWork$ = Mid(sWork$, iEscape% + 4)
        Case "$-"
            ' alternate way to indicate multi-byte character set
            '   appears as G1; convert into standard notation "$)"
            '   plus character-set character
            sNextCharacterSet$ = "$)" + Mid(sWork$, iEscape% + 3, 1)
            sWork$ = Mid(sWork$, iEscape% + 4)
        Case "$)"
            ' standard way to indicate multi-byte character set
            '   appears as G1; pick up the character-set character
            '   as part of the notation
            sNextCharacterSet$ = "$)" + Mid(sWork$, iEscape% + 3, 1)
            sWork$ = Mid(sWork$, iEscape% + 4)
        Case ")B", "(B"
            ' 20070605: code "(B" added to return the G0 character
            '   set to standard (this is probably a recovery of the
            '   original intent; the single code ")B" was probably an error)
            sNextCharacterSet$ = "s"
            sWork$ = Mid(sWork$, iEscape% + 3)
        Case Else
            ' leave the code as is
            sWork$ = Mid(sWork$, iEscape% + 3)
    End Select

End Sub

Public Function TranslateMarc2RTF(ByVal sIn$, Optional ByVal bIncludeRtfWrapper As Boolean = False, Optional ByVal iFontSizeForRtfInPoints% = 10) As String

    ' translate a random piece of MARC text (UTF-8 or not) into
    '   the RTF equivalent
    
    Dim lCtr As Long, lEnd As Long, lIncrement As Long, lTotal As Long
    
    Dim iLen%, iCtr2%

    Dim sOut$, sTag$, sIndicators$
    
    Dim bChanged As Boolean, bError As Boolean
    
    Const sDelimiterRepresentation$ = "\u8225?"
    
    
    ' 20070306: formerly didn't do anything if not UTF-8; now we temporarily
    '   translate the text into UTF-8, then we can hijack the existing code
    ' NOTE that this leaves us yet with one small problem, BUT ONLY if we decide
    '   at some future time to do a MARC record editor: the nonfiling characters indicator
    '   has not been adjusted, will in rare cases no longer represent the correct value; but,
    '   as I said, this only becomes important if we attempt to edit this record, or otherwise convert
    '   the RTF record back into a MARC record
    If Not m_bUtf8 Then
        sTag$ = FldTag
        sIndicators$ = FldInd
        TranslateMarc2Utf8OneField MarcRecordFormat, sTag$, sIndicators$, sIn$, bChanged, bError
    End If
    
    lCtr = 1
    lEnd = Len(sIn$)
    Do While lCtr <= lEnd
        MyMarcCharacter.Utf8Char = Mid(sIn$, lCtr)
        iLen% = MyMarcCharacter.Utf8CharOctets
        Select Case MyMarcCharacter.Utf8CharAsc
            Case 31 ' delimiter: supply a graphics character, plus spaces on either side
                sOut$ = sOut$ + sDelimiterRepresentation$ + Mid(sIn$, lCtr + 1, 1)
                iLen% = 2 ' skip the delimiter and its subfield code
            Case Is < 128
                sOut$ = sOut$ + Mid(sIn$, lCtr, 1)
            Case Else
                lTotal = 0
                lIncrement = 1
                For iCtr2% = Len(MyMarcCharacter.UcsHex) - 1 To 1 Step -2
                    lTotal = lTotal + (Asc(MyMarcCharacter.Hex2Char(Mid(MyMarcCharacter.UcsHex, iCtr2%, 2))) * lIncrement)
                    lIncrement = lIncrement * 256
                Next ' ictr2%
                sOut$ = sOut$ + "\u" + Trim(str(lTotal)) + "?"
        End Select
        lCtr = lCtr + iLen%
    Loop
    
    If bIncludeRtfWrapper Then
        sOut$ = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033" & "{\fonttbl{\f0\fswiss\fprq2\fcharset0 Arial Unicode MS;}}" & "\viewkind4\uc1\pard\f0\fs" + Trim(str(iFontSizeForRtfInPoints% * 2)) + " " & sOut$ & "\par}"
    End If
    TranslateMarc2RTF = sOut$
    
End Function

Public Function TranslateRTF2Marc(ByVal sIn$) As String

    ' translate a random piece of RTF text into
    '   the UTF-8 equivalent
    
    Dim lCtr As Long, lEnd As Long, lIncrement As Long, lTotal As Long
    
    Dim iLen%, iCtr2%

    Dim sOut$, sHex$
    
    ' strip off the RTF wrapper (NOTING that we only recognize the
    '   one that we supply ourselves ...)
    lCtr = InStr(sIn$, "\fs")
    If lCtr > 0 Then
        sIn$ = Mid(sIn$, lCtr + 1)
        lCtr = InStr(sIn$, " ")
        If lCtr > 0 Then
            sIn$ = Trim(Mid(sIn$, lCtr + 1))
        End If
    End If
    lCtr = InStr(sIn$, "\par")
    If lCtr > 0 Then
        sIn$ = Mid(sIn$, 1, lCtr - 1)
    End If
            
    If m_bUtf8 Then
    
        lCtr = InStr(sIn$, "\u")
        Do While lCtr > 0
            sHex$ = Mid(sIn$, lCtr, 20)
            iLen% = InStr(sHex$, "?")
            If iLen% > 0 Then ' it sure better be!
                ' we're going to assume a two-byte character for the output business
                lTotal = Val(Mid(sHex$, 3, iLen% - 3))
                If lTotal = 8225 Then ' our faked delimiter character
                    sIn$ = SafeStuff(sIn$, lCtr, iLen%, MarcDelimiter)
                Else
                    lEnd = lTotal Mod 256
                    MyMarcCharacter.UcsHex = MyMarcCharacter.Char2Hex(Chr((lTotal - lEnd) / 256)) + MyMarcCharacter.Char2Hex(Chr(lEnd))
                    sIn$ = SafeStuff(sIn$, lCtr, iLen%, MyMarcCharacter.Utf8Char)
                End If
            Else ' badly formatted? mask the "\u" and continue as best you can
                sIn$ = SafeStuff(sIn$, lCtr, 1, "?")
            End If
            lCtr = InStr(sIn$, "\u")
        Loop
    
    End If
    
    TranslateRTF2Marc = sIn$

End Function

Public Property Get FldTextWithOnlyCertainSubfields(Optional ByVal sSubfieldsToInclude$ = "0123456789abcdefghijklmnopqrstuvwxyz", Optional ByVal sSubfieldsToExclude$ = "") As String

    Dim iPtr%
    
    Dim sReturn$
    
    
    If FldPointer > -1 Then
        With MarcArray(FldPointer)
#If WithDebug = -1 Then
            PushWith "FTWOCS"
#End If
            iPtr% = .FirstSubfield
            If Mid(.Tag, 1, 2) = "00" Then
                If iPtr% > -1 Then
                    sReturn$ = .Subfield(iPtr%).Text
                End If
            Else
                If Len(sSubfieldsToInclude$) = 0 Then
                    sSubfieldsToInclude$ = "0123456789abcdefghijklmnopqrstuvwxyz"
                End If
                While iPtr% > -1
                    If Not .Subfield(iPtr%).Deleted Then
                        If InStr(sSubfieldsToInclude$, .Subfield(iPtr%).Code) > 0 And InStr(sSubfieldsToExclude$, .Subfield(iPtr%).Code) = 0 Then
                            ' 20040615: do not trim spaces from subfield text
                            sReturn$ = sReturn$ + MyMarcCharacter.MarcDelimiter + .Subfield(iPtr%).Code + .Subfield(iPtr%).Text
                        End If
                    End If
                    iPtr% = .Subfield(iPtr%).NextSubfield
                Wend
            End If
            FldTextWithOnlyCertainSubfields = sReturn$
#If WithDebug = -1 Then
            PopWith "FTWOCS"
#End If
        End With
    Else
        FldTextWithOnlyCertainSubfields = ""
    End If

    
End Property


Private Function TranslateUtf82MarcCharacterSetString(ByVal sCharacterSetsPresent$, ByVal sSeparator$) As String
    
    Dim s066$, sPiece$
    
    Dim iPtr%
    
    
    If Len(sCharacterSetsPresent$) > 0 Then
        
        ' convert each single-byte code into its corresponding 066 code
        Do
            DoEvents
            GetNextPiece sCharacterSetsPresent$, sPiece$, " "
            If InStr("1234sgbp", sPiece$) = 0 Then
                If InStr("56789", sPiece$) > 0 Then
                    'iPtr% = InStr(CharSetU2MTranslation$, sPiece$)
                    ' 20050722: the preceding statement should never have been used, because
                    '   it's not safe in all cases; the following is better--the
                    '   single-byte characters we get returned to us are assigned
                    '   in ascending order beginning with ASCII hex 31 (decimal 49)
                    ' the first code (decimal 49) needs to be converted into the
                    '   integer "7" (because the single-byte code that
                    '   corresponds to that character appears as the 8th byte
                    '   in the conversion constant) and the remaining codes are units of
                    '   7 above this first one; so:
                    '      decimal 49 becomes 7: ((49-49)*7)+7 = (0*7)+7 = 7
                    '      decimal 50 becomes 14: ((50-49)*7)+7 = (1*7)+7 = 14
                    '      decimal 51 becomes 21: ((51-49)*7)+7 = (2*7)+7 = 21
                    '      and so on
                    iPtr% = ((Asc(sPiece$) - 49) * 7) + 7
                    s066$ = s066$ + sSeparator$ + Mid(CharSetU2MTranslation$, iPtr% + 3, 2)
                ElseIf Len(sPiece$) = 2 Then
                    s066$ = s066$ + sSeparator$ + sPiece$
                End If
            End If
            If Len(sCharacterSetsPresent$) = 0 Then
                Exit Do
            End If
        Loop
    End If

    TranslateUtf82MarcCharacterSetString = s066$
    
End Function

Public Property Get MarcRightToLeftMarker() As String

    If m_bUtf8 Then
        MarcRightToLeftMarker = MyMarcCharacter.Utf8RightToLeftMarker
    Else
        MarcRightToLeftMarker = ""
    End If

End Property

Public Property Get MarcLeftToRightMarker() As String

    If m_bUtf8 Then
        MarcLeftToRightMarker = MyMarcCharacter.Utf8LeftToRightMarker
    Else
        MarcLeftToRightMarker = ""
    End If

End Property


Public Function TranslateMarc2Utf8OneFieldLcPattern(ByVal sTag$, ByVal sOut$) As String

#If True Then
    
    ' 20071031: replacement suggested by David Bucknum
    
    Dim sRight$
    
    Dim lPtr As Long, lLen As Long, lPtr2 As Long, lPtr3 As Long
    
    Dim bRTL As Boolean
    

    'MsgBox "Entry into Lc pattern"
    If sTag$ <> "880" Then
        TranslateMarc2Utf8OneFieldLcPattern = sOut$
        Exit Function
    End If
    
    lPtr = 1
    lLen = Len(sOut$)
    Do
        MyMarcCharacter.Utf8Char = Mid(sOut$, lPtr)
        Select Case MyMarcCharacter.UcsHex ' formerly (in error): .Utf8CharAsc
            Case "05D0" To "05F4"
                bRTL = True
                Exit Do
            Case "0600" To "06FF"
                bRTL = True
                Exit Do
        End Select
        lPtr = lPtr + Len(MyMarcCharacter.Utf8Char)
        If lPtr > lLen Then
            Exit Do
        End If
    Loop

    'MsgBox "RTL? " + str(bRTL)
    If bRTL Then
        ' add RTL markers at every subfield boundary
        For lPtr = Len(sOut$) - 1 To 1 Step -1
            If Mid(sOut$, lPtr, 1) = MarcDelimiter Then
                'Debug.Print "At: " + Mid(sOut$, 1, lPtr - 1) + "< $ >" + Mid(sOut$, lPtr + 1)
                lPtr2 = InStr(Mid(sOut$, lPtr + 1), MarcDelimiter)
                If lPtr2 <> 0 Then
                    If Mid(sOut$, lPtr + lPtr2 - 3, 3) <> MarcRightToLeftMarker Then
                        sOut$ = SafeStuff(sOut$, lPtr + lPtr2, 0, MarcRightToLeftMarker)
                    End If
                End If
                If Mid(sOut$, lPtr + 1, 1) <> "6" Then
                    If Mid(sOut$, lPtr + 2, 3) <> MarcRightToLeftMarker Then
                        sOut$ = SafeStuff(sOut$, lPtr + 2, 0, MarcRightToLeftMarker)
                    End If
                Else
                    ' 20070731: modified and made fancier per D. Bucknum
                    ' add RLE and PDF markers to the 880 $6 260-xx $c [dates]
                    '   after the $c RLM and at the end of the subfield
                    lPtr3 = InStr(sOut$, MarcDelimiter + "c")
                    ' (recall that lPtr points to a delimiter
                    If lPtr3 <> 0 And Mid(sOut$, lPtr + 1, 4) = "6260" Then ' $6 260
                        If Mid(sOut$, lPtr3 + 5, 3) <> MyMarcCharacter.Utf8LeftToRightEmbedding Then
                            sOut$ = SafeStuff(sOut$, lPtr3 + 5, 0, MyMarcCharacter.Utf8LeftToRightEmbedding)
                        End If
                        ' check the last two characters in 260 $c for period and PDF combinations
                        sRight$ = Mid(sOut$, lPtr3 + 2)
                        lPtr3 = InStr(sRight$, MarcDelimiter)
                        If lPtr3 > 0 Then
                            sRight$ = Mid(sRight$, 1, lPtr3 - 1)
                        End If
                        sRight$ = SafeRight(sRight$, 2)
                        If InStr(sRight$, MyMarcCharacter.Utf8PopDirectionalFormatting) > 0 Then
                            Select Case sRight$
                                Case "." + MyMarcCharacter.Utf8PopDirectionalFormatting
                                    ' we want these in the other order
                                    sOut$ = Mid(sOut$, 1, Len(sOut$) - Len(sRight$)) + MyMarcCharacter.Utf8PopDirectionalFormatting + "."
                                Case MyMarcCharacter.Utf8PopDirectionalFormatting + "."
                                    ' these are OK; leave these alone
                                Case Else
                                    ' this is not OK, but leave it alone anyway
                            End Select
                        Else
                            If Right(sOut$, 1) = "." Then
                                sOut$ = Mid(sOut$, 1, Len(sOut$) - 1) + MyMarcCharacter.Utf8PopDirectionalFormatting + "."
                            Else
                                sOut$ = sOut$ + MyMarcCharacter.Utf8PopDirectionalFormatting
                            End If
                        End If
                    End If
                End If
            End If
        Next ' lptr
    End If

    TranslateMarc2Utf8OneFieldLcPattern = sOut$
    
#Else
    Dim sRight$
    
    Dim lPtr As Long, lLen As Long, lPtr2 As Long, lPtr3 As Long
    
    Dim bRTL As Boolean
    
    
    If sTag$ <> "880" Then
        TranslateMarc2Utf8OneFieldLcPattern = sOut$
        Exit Function
    End If
    
    lPtr = 1
    lLen = Len(sOut$)
    Do
        MyMarcCharacter.Utf8Char = Mid(sOut$, lPtr)
        Select Case MyMarcCharacter.UcsHex ' formerly (in error): .Utf8CharAsc
            Case "05D0" To "05F4"
                bRTL = True
                Exit Do
            Case "0600" To "06FF"
                bRTL = True
                Exit Do
        End Select
        lPtr = lPtr + Len(MyMarcCharacter.Utf8Char)
        If lPtr > lLen Then
            Exit Do
        End If
    Loop
    If bRTL Then
        ' add RTL markers at every subfield boundary
        For lPtr = Len(sOut$) - 1 To 1 Step -1
            If Mid(sOut$, lPtr, 1) = MarcDelimiter Then
                lPtr2 = InStr(Mid(sOut$, lPtr + 1), MarcDelimiter)
                If lPtr2 <> 0 Then
                    If Mid(sOut$, lPtr + lPtr2, 3) <> MarcRightToLeftMarker Then
                        sOut$ = SafeStuff(sOut$, lPtr + lPtr2, 0, MarcRightToLeftMarker)
                    End If
                End If
                If Mid(sOut$, lPtr + 1, 1) <> "6" Then
                    If Mid(sOut$, lPtr + 2, 3) <> MarcRightToLeftMarker Then
                        sOut$ = SafeStuff(sOut$, lPtr + 2, 0, MarcRightToLeftMarker)
                    End If
                Else
                    ' 20070731: modified and made fancier per D. Bucknum
                    ' add RLE and PDF markers to the 880 $6 260-xx $c [dates]
                    '   after the $c RLM and at the end of the subfield
                    lPtr3 = InStr(sOut$, MarcDelimiter + "c")
                    ' (recall that lPtr points to a delimiter
                    If lPtr3 <> 0 And Mid(sOut$, lPtr + 1, 4) = "6260" Then ' $6 260
                        If Mid(sOut$, lPtr3 + 5, 3) <> MyMarcCharacter.Utf8LeftToRightEmbedding Then
                            sOut$ = SafeStuff(sOut$, lPtr3 + 5, 0, MyMarcCharacter.Utf8LeftToRightEmbedding)
                        End If
                        ' check the last two characters in 260 $c for period and PDF combinations
                        sRight$ = Mid(sOut$, lPtr3 + 2)
                        lPtr3 = InStr(sRight$, MarcDelimiter)
                        If lPtr3 > 0 Then
                            sRight$ = Mid(sRight$, 1, lPtr3 - 1)
                        End If
                        sRight$ = SafeRight(sRight$, 2)
                        If InStr(sRight$, MyMarcCharacter.Utf8PopDirectionalFormatting) > 0 Then
                            Select Case sRight$
                                Case "." + MyMarcCharacter.Utf8PopDirectionalFormatting
                                ' we want these in the other order
                                    sOut$ = Mid(sOut$, 1, Len(sOut$) - Len(sRight$)) + MyMarcCharacter.Utf8PopDirectionalFormatting + "."
                                Case MyMarcCharacter.Utf8PopDirectionalFormatting + "."
                                    ' these are OK; leave these alone
                                Case Else
                                    ' this is not OK, but leave it alone anyway
                            End Select
                        Else
                            If Right(sOut$, 1) = "." Then
                                sOut$ = Mid(sOut$, 1, Len(sOut$) - 1) + MyMarcCharacter.Utf8PopDirectionalFormatting + "."
                            Else
                                sOut$ = sOut$ + MyMarcCharacter.Utf8PopDirectionalFormatting
                            End If
                        End If
                    End If
                End If
            End If
        Next ' lptr
    End If

    TranslateMarc2Utf8OneFieldLcPattern = sOut$
    
#End If

End Function

Public Function Utf8TextContainsOnlyMarc8Characters(ByVal sIn$) As Boolean

    ' 20070830: run through the supplied string (assumed to be in UTF-8), and see if it contains anything that's
    '   not part of the MARC-8 character set
    
    Dim lPtr As Long, lLength As Long
    
    Dim iLen%
    
    Dim bNonMarc8Found As Boolean
    
    lPtr = 1
    lLength = Len(sIn$)
    Do
        MyMarcCharacter.Utf8Char = Mid(sIn$, lPtr)
        iLen% = MyMarcCharacter.Utf8CharOctets
        Select Case MyMarcCharacter.Utf8CharCategoryMarc8
            Case Marc8Category_Basic$, Marc8Category_SuperscriptSubscript$
            Case Else
                Utf8TextContainsOnlyMarc8Characters = False
                Exit Function
        End Select
        lPtr = lPtr + MyMarcCharacter.Utf8CharOctets
        If lPtr > lLength Then
            Exit Do
        End If
    Loop

    Utf8TextContainsOnlyMarc8Characters = True

End Function

Public Property Get MarcLeftToRightEmbedding() As String
    
    If m_bUtf8 Then
        MarcLeftToRightEmbedding = MyMarcCharacter.Utf8LeftToRightEmbedding
    Else
        MarcLeftToRightEmbedding = ""
    End If
    
End Property


Public Property Get MarcPopDirectionalFormatting() As String
    
    If m_bUtf8 Then
        MarcPopDirectionalFormatting = MyMarcCharacter.Utf8PopDirectionalFormatting
    Else
        MarcPopDirectionalFormatting = ""
    End If

End Property


Public Property Get FldSortingForm() As String
    
    ' derive a 'sorting form' for the current field
    ' there are actually several things going on here:
    '   1) determining which subfields belong in the sorting heading (here taken
    '      to be the same subfields as in the NACO normalized heading); this form
    '      may contain internal punctuation
    '   2) determining the normalized text of each desired subfield, which
    '      we do in the somewhat subordinate property SfdSortingForm
    '   3) assembling the bits into a string, with interspersed subfield codes
    '      and various tricks performed with spacing
    
    ' it was a matter of debate whether the subfield code should be added here, or
    '   in SfdSortingForm; we have decided at least for now to add it in FldSortingForm
    
    ' as you might expect, the sorting form achieved here is one tailored to a particular
    '   end, determined by a certain task performed by the authority loader. it is entirely
    '   possible to imagine other sorting forms designed for other purposes.  should it
    '   be necessary to provide for additional sorting forms, we can add a parameter to
    '   the invocation of this property--at base an enumeration--to tell us which kind
    '   of sorting form is wanted
    
    Dim iRc%
    
    Dim lSfdPointer As Long, lSfdPointer2 As Long
    
    Dim sSfd$, sSfd2$, sOutput$, sSubfieldsOfInterest$, sJunk2$, sRest$
    Dim sDate1$, sDate2$, sQualifier$
    
    Dim bSkipSubfieldC As Boolean, bPersonalName As Boolean, bOK As Boolean
    Dim bBCPresent As Boolean, bADPresent As Boolean
    
    
    ' we'll be moving the subfield pointer; which we'll restore
    '   at the bottom of this routine
    lSfdPointer = SfdPointer
        
    sSubfieldsOfInterest$ = ListSubfieldsForNormalization(MarcRecordFormat, FldTag)
    
    ' appearance of the finished sorting form depends in some cases on a knowledge
    '   of whether the source field represents a personal name, or not; so let's
    '   get that question out of the way at the beginning
    If Right(FldTag, 2) = "00" Then
        bPersonalName = True
    End If
    
    
    SfdMoveFirst
    Do ' for each subfield in the field
        If InStr(sSubfieldsOfInterest$, SfdCode) > 0 Then
            Select Case SfdCode
            
                ' $a and $d are exactly the same as "Case Else", but we've
                '   put them at the top for efficiency: they occur a lot
                
                Case "a"
                
                    sOutput$ = sOutput$ + " $a" + SfdSortingForm(bPersonalName)
                
                Case "d"
                
                    sOutput$ = sOutput$ + " $d" + SfdSortingForm(bPersonalName)
                    If Len(sQualifier$) > 0 Then
                        sOutput$ = sOutput$ + " $q" + sQualifier$
                        sQualifier$ = ""
                    End If
                ' the following cases (before Case Else) have exceptions pertaining to
                '   inclusion or spacing, and so on
                
                Case "q"
                
                    ' in personal names, include $q only if $d is not present
                    ' in personal names, if it IS present, precede it with 2 spaces
                    '   so it comes out ahead of headings with "more stuff"
                    If bPersonalName Then
                        lSfdPointer2 = SfdPointer
                        If SfdFindFirst("d") Then
                            ' return to the $q before you skip it
                            SfdPointer = lSfdPointer2
                            sQualifier$ = SfdSortingForm(bPersonalName)
                            GoTo FSF_NextSubfield
                        End If
                        ' $q but no $d: return to the $q so you can pick it up
                        SfdPointer = lSfdPointer2
                        ' insert 2 spaces before $q to make it
                        '   sort to the top
                        sOutput$ = sOutput$ + "  $q" + SfdSortingForm(bPersonalName)
                    Else
                        ' not clear at the moment what these are
                        sOutput$ = sOutput$ + " $q" + SfdSortingForm(bPersonalName)
                    End If
                    
                Case "k"
                
                    If InStr(sOutput$, "  ") = 0 And InStr(sOutput$, "$t") = 0 Then
                        ' if this is a $k but not a name-title heading, then we're going to
                        '   give this the same basic structure as a name-title heading, so the
                        '   $k doesn't get mixed up with subordinate bodies
                        sOutput$ = sOutput$ + "  $k" + SfdSortingForm(bPersonalName)
                    Else
                        ' we have $k after $t, so it's just a form subheading
                        sOutput$ = sOutput$ + " $k" + SfdSortingForm(bPersonalName)
                    End If
                    
                Case "c"
                
                    lSfdPointer2 = SfdPointer
                    
                    ' for personal names, skip $c if $d is also present
                    If bPersonalName Then
                        If SfdFindFirst("d") Then
                            SfdPointer = lSfdPointer2
                            GoTo FSF_NextSubfield
                        End If
                        ' $c but no $d: return to the $c
                        SfdPointer = lSfdPointer2
                    End If
                    ' insert 2 spaces before $c to make it
                    '   sort before headings with "more stuff" in the preceding subfield
                    sOutput$ = sOutput$ + "  $c" + SfdSortingForm(bPersonalName)
                
                Case "t"
                
                    ' insert 2 spaces before $t to make this sort before headings
                    '   with "more stuff" in the preceding subfield
                    sOutput$ = sOutput$ + "  $t" + SfdSortingForm(bPersonalName)
                
                Case Else
                
                    sOutput$ = sOutput$ + " $" + SfdCode + SfdSortingForm(bPersonalName)
                    
            End Select
            
        End If
        
FSF_NextSubfield:
    Loop While SfdMoveNext
    
    ' return to the same field pointed to at entry
    SfdPointer = lSfdPointer

    ' return the accumulated value
    FldSortingForm = Trim(sOutput$)
    
End Property


Public Property Get MarcRightToLeftEmbedding() As String

    If m_bUtf8 Then
        MarcRightToLeftEmbedding = MyMarcCharacter.Utf8RightToLeftEmbedding
    Else
        MarcRightToLeftEmbedding = ""
    End If

End Property

Public Property Get MarcLeftToRightOverride() As String

    If m_bUtf8 Then
        MarcLeftToRightOverride = MyMarcCharacter.Utf8LeftToRightOverride
    Else
        MarcLeftToRightOverride = ""
    End If

End Property

Public Property Get MarcRightToLeftOverride() As String

    If m_bUtf8 Then
        MarcRightToLeftOverride = MyMarcCharacter.Utf8RightToLeftOverride
    Else
        MarcRightToLeftOverride = ""
    End If

End Property

Public Function TranslateLabelsIntoDiacritics(ByVal sText$) As String

    Dim iLen%
    
    Dim lPtr As Long, lPtr2 As Long
    
    Dim sLabel$
    
    
    
    ' 20071101: added to reverse action of TranslateDiacriticsIntoLabels
    
    ' 20071101: changed literal text for label delimiters into constants
    'Private Const prvsBeginMarkerForDiacriticLabels$ = "<-"
    'Private Const prvsEndMarkerForDiacriticLabels$ = "->"
    
    ' I don't think we need to distinguish UTF-8 here ...
#If False Then
    If m_bUtf8 Then
#End If

        For lPtr = Len(sText$) To 1 Step -1
            If Mid(sText$, lPtr, 1) = prvsBeginMarkerForDiacriticLabels$ Then
                lPtr2 = InStr(Mid(sText$, lPtr), prvsEndMarkerForDiacriticLabels$)
                If lPtr2 > 0 Then
                    ' adjust for the variable number of characters in the
                    '   closing label (so we take out the whole thing
                    lPtr2 = lPtr2 + Len(prvsEndMarkerForDiacriticLabels$) - 1
                    Select Case Mid(sText$, lPtr, lPtr2)
                        Case prvsBeginMarkerForDiacriticLabels$ + "underscore (spacing)" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, "_")
                        Case prvsBeginMarkerForDiacriticLabels$ + "tilde (spacing)" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, "~")
                        Case prvsBeginMarkerForDiacriticLabels$ + "circumflex (spacing)" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, "^")
                        Case prvsBeginMarkerForDiacriticLabels$ + "alif" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcAlif)
                        Case prvsBeginMarkerForDiacriticLabels$ + "ayn" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcAyn)
                        Case prvsBeginMarkerForDiacriticLabels$ + "miagkii znak" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcMiagkiiZnak)
                        Case prvsBeginMarkerForDiacriticLabels$ + "tverdii znak" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcTverdiiZnak)
                        Case prvsBeginMarkerForDiacriticLabels$ + "dot middle" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcDotMiddle)
                        Case prvsBeginMarkerForDiacriticLabels$ + "flat" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcFlat)
                        Case prvsBeginMarkerForDiacriticLabels$ + "O hook" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcOHookUpper)
                        Case prvsBeginMarkerForDiacriticLabels$ + "U hook" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcUHookUpper)
                        Case prvsBeginMarkerForDiacriticLabels$ + "O slash" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcOSlashUpper)
                        Case prvsBeginMarkerForDiacriticLabels$ + "L slash" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcLSlashUpper)
                        Case prvsBeginMarkerForDiacriticLabels$ + "D slash" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcDSlashUpper)
                        Case prvsBeginMarkerForDiacriticLabels$ + "Thorn" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcThornUpper)
                        Case prvsBeginMarkerForDiacriticLabels$ + "AE ligature" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcAEUpper)
                        Case prvsBeginMarkerForDiacriticLabels$ + "OE ligature" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcOEUpper)
                        Case prvsBeginMarkerForDiacriticLabels$ + "l slash" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcLSlashLower)
                        Case prvsBeginMarkerForDiacriticLabels$ + "o slash" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcOSlashLower)
                        Case prvsBeginMarkerForDiacriticLabels$ + "d slash" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcDSlashLower)
                        Case prvsBeginMarkerForDiacriticLabels$ + "thorn" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcThornLower)
                        Case prvsBeginMarkerForDiacriticLabels$ + "ae ligature" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcAELower)
                        Case prvsBeginMarkerForDiacriticLabels$ + "oe ligature" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcOELower)
                        Case prvsBeginMarkerForDiacriticLabels$ + "i without dot" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcIDotless)
                        Case prvsBeginMarkerForDiacriticLabels$ + "pound sterling" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcBritishPound)
                        Case prvsBeginMarkerForDiacriticLabels$ + "eth" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcEth)
                        Case prvsBeginMarkerForDiacriticLabels$ + "o hook" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcOHookLower)
                        Case prvsBeginMarkerForDiacriticLabels$ + "u hook" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcUHookLower)
                        Case prvsBeginMarkerForDiacriticLabels$ + "degree" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcDegree)
                        Case prvsBeginMarkerForDiacriticLabels$ + "l script" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcLScript)
                        Case prvsBeginMarkerForDiacriticLabels$ + "sharp" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcSharp)
                        Case prvsBeginMarkerForDiacriticLabels$ + "? inverted" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcQuestionInverted)
                        Case prvsBeginMarkerForDiacriticLabels$ + "! inverted" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcExclamationInverted)
                        Case prvsBeginMarkerForDiacriticLabels$ + "pseudo question" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcQuestionPseudo)
                        Case prvsBeginMarkerForDiacriticLabels$ + "grave" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcGrave)
                        Case prvsBeginMarkerForDiacriticLabels$ + "acute" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcAcute)
                        Case prvsBeginMarkerForDiacriticLabels$ + "circumflex (non-spacing)" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcCircumflex)
                        Case prvsBeginMarkerForDiacriticLabels$ + "tilde (non-spacing)" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcTilde)
                        Case prvsBeginMarkerForDiacriticLabels$ + "macron" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcMacron)
                        Case prvsBeginMarkerForDiacriticLabels$ + "breve" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcBreve)
                        Case prvsBeginMarkerForDiacriticLabels$ + "dot above" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcDotAbove)
                        Case prvsBeginMarkerForDiacriticLabels$ + "umlaut" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcUmlaut)
                        Case prvsBeginMarkerForDiacriticLabels$ + "hacek" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcHacek)
                        Case prvsBeginMarkerForDiacriticLabels$ + "angstrom" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcAngstrom)
                        Case prvsBeginMarkerForDiacriticLabels$ + "ligature left half" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcLigatureLeft)
                        Case prvsBeginMarkerForDiacriticLabels$ + "ligature right half" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcLigatureRight)
                        Case prvsBeginMarkerForDiacriticLabels$ + "high comma off-center" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcCommaHighOffCenter)
                        Case prvsBeginMarkerForDiacriticLabels$ + "double acute" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcAcuteDouble)
                        Case prvsBeginMarkerForDiacriticLabels$ + "candrabindu" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcCandrabindu)
                        Case prvsBeginMarkerForDiacriticLabels$ + "cedilla" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcCedilla)
                        Case prvsBeginMarkerForDiacriticLabels$ + "right hook" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcHookRight)
                        Case prvsBeginMarkerForDiacriticLabels$ + "dot below" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcDotBelow)
                        Case prvsBeginMarkerForDiacriticLabels$ + "double dot below" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcDotBelowDouble)
                        Case prvsBeginMarkerForDiacriticLabels$ + "circle below" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcCircleBelow)
                        Case prvsBeginMarkerForDiacriticLabels$ + "double underscore" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcUnderscoreDouble)
                        Case prvsBeginMarkerForDiacriticLabels$ + "underscore (non-spacing)" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcUnderscore)
                        Case prvsBeginMarkerForDiacriticLabels$ + "left hook" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcHookLeft)
                        Case prvsBeginMarkerForDiacriticLabels$ + "inverted cedilla" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcCedillaRight)
                        Case prvsBeginMarkerForDiacriticLabels$ + "upadhmaniya" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcUpadhmaniya)
                        Case prvsBeginMarkerForDiacriticLabels$ + "double tilde left half" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcTildeDoubleLeft)
                        Case prvsBeginMarkerForDiacriticLabels$ + "double tilde right half" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcTildeDoubleRight)
                        Case prvsBeginMarkerForDiacriticLabels$ + "high comma centered" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcCommaHighCentered)
                        Case prvsBeginMarkerForDiacriticLabels$ + "RTL" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcRightToLeftMarker)
                        Case prvsBeginMarkerForDiacriticLabels$ + "LTR" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcLeftToRightMarker)
                        Case prvsBeginMarkerForDiacriticLabels$ + "LTRE" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcLeftToRightEmbedding)
                        Case prvsBeginMarkerForDiacriticLabels$ + "RTLE" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcRightToLeftEmbedding)
                        Case prvsBeginMarkerForDiacriticLabels$ + "PDF" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcPopDirectionalFormatting)
                        Case prvsBeginMarkerForDiacriticLabels$ + "LTRO" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcLeftToRightOverride)
                        Case prvsBeginMarkerForDiacriticLabels$ + "RTLO" + prvsEndMarkerForDiacriticLabels$
                            sText$ = SafeStuff(sText$, lPtr, lPtr2, MarcRightToLeftOverride)
                        'Case else
                            ' something else enclosed in braces--we don't care
                    End Select
                End If ' is there a closing brace?
            End If ' are we at a brace?
        Next ' for each character, from right to left
        
#If False Then
    Else
        ' NOTE that if it turns out we need a separate non-Unicode bit of business here,
        '   THIS WHOLE BIT NEEDS TO BE REWRITTEN IN PARALLEL WITH THE ABOVE
        ' what we have here is simply a copy of the corresponding section
        '   of TranslateDiacriticsIntoLabels
        For lPtr = Len(sText$) To 1 Step -1
            Select Case Mid(sText$, lPtr, 1)
                Case "_"
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;underscore (spacing)\u125;")
                Case "~"
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;tilde (spacing)\u125;")
                Case "^"
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;circumflex (spacing)\u125;")
                Case MarcAlif
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;alif\u125;")
                Case MarcAyn
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;ayn\u125;")
                Case MarcMiagkiiZnak
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;miagkii znak\u125;")
                Case MarcTverdiiZnak
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;tverdii znak\u125;")
                Case MarcDotMiddle
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;dot middle\u125;")
                Case MarcFlat
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;flat\u125;")
                Case MarcOHookUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;O hook\u125;")
                Case MarcUHookUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;U hook\u125;")
                Case MarcOSlashUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;O slash\u125;")
                Case MarcLSlashUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;L slash\u125;")
                Case MarcDSlashUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;D slash\u125;")
                Case MarcThornUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;Thorn\u125;")
                Case MarcAEUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;AE ligature\u125;")
                Case MarcOEUpper
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;OE ligature\u125;")
                Case MarcLSlashLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;l slash\u125;")
                Case MarcOSlashLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;o slash\u125;")
                Case MarcDSlashLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;d slash\u125;")
                Case MarcThornLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;thorn\u125;")
                Case MarcAELower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;ae ligature\u125;")
                Case MarcOELower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;oe ligature\u125;")
                Case MarcIDotless
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;i without dot\u125;")
                Case MarcBritishPound
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;pound sterling\u125;")
                Case MarcEth
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;eth\u125;")
                Case MarcOHookLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;o hook\u125;")
                Case MarcUHookLower
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;u hook\u125;")
                Case MarcDegree
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;degree\u125;")
                Case MarcLScript
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;l script\u125;")
                Case MarcSharp
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;sharp\u125;")
                Case MarcQuestionInverted
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;? inverted\u125;")
                Case MarcExclamationInverted
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;! inverted\u125;")
                Case MarcQuestionPseudo ' e0
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;pseudo question\u125;")
                Case MarcGrave
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;grave\u125;")
                Case MarcAcute
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;acute\u125;")
                Case MarcCircumflex
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;circumflex (non-spacing)\u125;")
                Case MarcTilde
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;tilde (non-spacing)\u125;")
                Case MarcMacron
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;macron\u125;")
                Case MarcBreve
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;breve\u125;")
                Case MarcDotAbove
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;dot above\u125;")
                Case MarcUmlaut
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;umlaut\u125;")
                Case MarcHacek
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;hacek\u125;")
                Case MarcAngstrom
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;angstrom\u125;")
                Case MarcLigatureLeft
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;ligature left half\u125;")
                Case MarcLigatureRight
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;ligature right half\u125;")
                Case MarcCommaHighOffCenter
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;high comma off-center\u125;")
                Case MarcAcuteDouble
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;double acute\u125;")
                Case MarcCandrabindu
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;candrabindu\u125;")
                Case MarcCedilla
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;cedilla\u125;")
                Case MarcHookRight
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;right hook\u125;")
                Case MarcDotBelow
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;dot below\u125;")
                Case MarcDotBelowDouble
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;double dot below\u125;")
                Case MarcCircleBelow
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;circle below\u125;")
                Case MarcUnderscoreDouble
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;double underscore\u125;")
                Case MarcUnderscore
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;underscore (non-spacing)\u125;")
                Case MarcHookLeft
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;left hook\u125;")
                Case MarcCedillaRight
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;inverted cedilla\u125;")
                Case MarcUpadhmaniya
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;upadhmaniya\u125;")
                Case MarcTildeDoubleLeft
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;double tilde left half\u125;")
                Case MarcTildeDoubleRight
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;double tilde right half\u125;")
                Case MarcCommaHighCentered
                    sText$ = SafeStuff(sText, lPtr, MyMarcCharacter.Utf8CharOctets, "\u123;high comma centered\u125;")
            End Select
        Next
    End If
#End If

    TranslateLabelsIntoDiacritics = sText$

End Function

Public Function NormalizeSeriesNumberForSorting(ByVal NormalizationMode As SeriesNumberingNormType, ByVal sOriginalHeading$, ByVal sHeading$, ByVal sSeriesSubfieldV$) As String

    Select Case NormalizationMode
        Case JustPcc
            ' no need for a separate routine just to do this!
            NormalizeSeriesNumberForSorting = NormString(sSeriesSubfieldV$)
        Case PadNumbers
            NormalizeSeriesNumberForSorting = NormalizeSeriesNumberLevel2(sSeriesSubfieldV$)
        Case PadNumbersRemoveCaption
            NormalizeSeriesNumberForSorting = NormalizeSeriesNumberLevel3(sSeriesSubfieldV$)
        Case Complete
            NormalizeSeriesNumberForSorting = NormalizeSeriesNumberLevel4(sOriginalHeading$, sHeading$, sSeriesSubfieldV$)
    End Select

End Function
Private Function NormalizeSeriesNumberLevel4(ByVal sOriginalHeading$, ByVal sHeading$, ByVal sSeriesSubfieldV$) As String

    Dim iIn%, iCtr%, iCaptions%
    Dim iSet1%, iRc%, iLen%, iPrevLength%
    
    Dim lLeftover As Long, lOut As Long, lRead As Long, lPattern1 As Long, lPattern1a As Long
    Dim lPattern2 As Long, lPattern2a As Long, lPattern1b As Long, lPattern2B As Long
    Dim lPattern3 As Long
        
    Dim bFound As Boolean, bPotentialPattern2 As Boolean, bNumeral As Boolean, bUnrecognized As Boolean
    Dim bContainsNumeral As Boolean, bSeriesRemoved As Boolean, bFirstAlphabetic As Boolean
    Dim bAddSeries As Boolean, bAsianLeapException As Boolean, bChanged As Boolean
    
    Dim sLine$, sChar$, sCharMinus1$, sLineSave$, sPrefix$, sYear$, sNorm$, sUcase$, sNo$
    Dim sVoyager$, sCaptions$, sJunk$, sString$, sOutput$, sIntermediate$, sCopy$, sInitials2$
    Dim sSegmentMarker$, sPreviousSegmentMarker$, sWords$, sInitials$, sRemainder$, sYear2$, sYear4$
    Dim sWordsWithSpaces$, sPiece$, sSaveInitials2$, sHighChar$
    
    Static iUnrecognized%
    Static iJunkHandle%
    
    
    NormalizeSeriesNumberLevel4 = ""
    
    sNorm$ = sSeriesSubfieldV$
    
    If Not prvbHaveSeriesNumberingPunctuation Then
        NormalizeSeriesNumberSetConstants
    End If
    
    If InStr(sNorm$, "1") > 0 Or InStr(sNorm$, "2") > 0 Or InStr(sNorm$, "3") > 0 Or InStr(sNorm$, "4") > 0 Or InStr(sNorm$, "5") > 0 Or InStr(sNorm$, "6") > 0 Or InStr(sNorm$, "7") > 0 Or InStr(sNorm$, "8") > 0 Or InStr(sNorm$, "9") > 0 Or InStr(sNorm$, "0") > 0 Then
        bContainsNumeral = True
    Else
        ' 5.5.2.2
        ' if no numerals are present, remove all punctuation that occurs before the first
        '   non-punctuation character
        Do While InStr(prvsSerNumRemoveTheseIfFirst$, Mid(sNorm$, 1, 1)) > 0
            sNorm$ = Trim(Mid(sNorm$, 2))
            If Len(sNorm$) = 0 Then
                Exit Do
            End If
        Loop
        sNorm$ = NormalizeSeriesNumberRemoveChapter(sNorm$)
    End If
    
    ' 5.5.2.3: replace unusual abbreviations for 'number'
    sNorm$ = NormalizeSeriesNumberConvertIfUsedInAbbrev(sNorm$, MarcSuperscript0)
    sNorm$ = NormalizeSeriesNumberConvertIfUsedInAbbrev(sNorm$, MarcMiagkiiZnak)
    sNorm$ = NormalizeSeriesNumberConvertIfUsedInAbbrev(sNorm$, MarcAngstrom)
    sNorm$ = NormalizeSeriesNumberConvertIfUsedInAbbrev(sNorm$, MarcDegree)

    ' 5.5.2.4: handle abbreviations with INTERNAL punctuation
    sUcase$ = UCase(sNorm$)
    ' n;o is a typo found in just a few records; but we have to allow for it
    If InStr(sUcase$, "N.O") > 0 Or InStr(sUcase, "N:O") > 0 Or InStr(sUcase$, "N:R") > 0 Or InStr(sUcase$, "N;O") > 0 Then
    
        sNo$ = "N.O"
        Do
            ' easy method: replace no matter what
            Do
                iRc% = InStr(sUcase$, sNo$)
                If iRc% = 0 Then
                    Exit Do
                End If
                sNorm = SafeStuff(sNorm$, iRc%, 3, prvsSerNumCaptionSubstitute$)
                sUcase$ = SafeStuff(sUcase$, iRc%, 3, prvsSerNumCaptionSubstitute$)
            Loop
            Select Case sNo$
                Case "N.O"
                    sNo$ = "N:O"
                Case "N:O"
                    sNo$ = "N:R"
                Case "N:R"
                    sNo$ = "N;O"
                Case Else
                    Exit Do
            End Select
        Loop
    End If
    
    On Error GoTo 0
    
    ' 5.5.2.5
    If bContainsNumeral Then
        
        sNorm$ = NormalizeSeriesNumberRemoveV(sNorm$, bFirstAlphabetic, True)
#If StandardSingleLetterAbbreviationHandling = False Then
        sNorm$ = NormalizeSeriesNumberOtherSingleLetterAbbrev("dfhjnprst", sNorm$, bFirstAlphabetic, True)
#End If
    End If
    
    
    iLen% = Len(sNorm$)
    For iRc% = Len(sNorm$) To 1 Step -1
        sChar$ = Mid(sNorm$, iRc%, 1)
        Select Case sChar$
            Case "[", "(", "<", "{", "="
                If iRc% = 1 Then
                    sNorm$ = SafeStuff(sNorm$, iRc%, 1, "")
                Else
                    sNorm$ = SafeStuff(sNorm$, iRc%, 1, "; ")
                End If
            Case "]", ")", ">", "}", ":", "."
                sNorm$ = SafeStuff(sNorm$, iRc%, 1, " ")
            Case "#", "+", "&"
                sNorm$ = SafeStuff(sNorm$, iRc%, 1, " ")
            Case "\"
                sNorm$ = SafeStuff(sNorm$, iRc%, 1, "/")
            'Case "=" ' marks a segment; we'll arbitrariy use this segment marker
                'sNorm$ = safestuff(sNorm$, iRc%, 1, "; ")
            Case "/", ",", ";", " ", MarcDelimiter
                ' keep these as they are
            Case "-"
                Select Case iRc%
                    Case 1
                        GoTo NSNL4_TreatPunctuationAsNormal
                    Case 2
                        GoTo NSNL4_HandleHyphenAsInternal
                    Case 3
                        If Mid(sNorm$, 1, 2) = "al" Then
                            sNorm$ = Trim(Mid(sNorm$, 4))
                            Exit For
                        End If
                        GoTo NSNL4_HandleHyphenAsInternal
                    Case Is = iLen%
                        GoTo NSNL4_TreatPunctuationAsNormal
                    Case Else ' must be >3, less than maximum
                        If Mid(sNorm$, iRc% - 3, 4) = " al-" Then
                            sNorm$ = SafeStuff(sNorm$, iRc% - 3, 4, " ")
                            GoTo Nsnl9LeaveTheThingAlone
                        End If
NSNL4_HandleHyphenAsInternal:  ' NOTE label in left margin
                        Select Case Mid(sNorm$, iRc% - 1, 1)
                            Case "0" To "9"
                                If InStr("ABCDEFGHIJKLMNOPQRSTUVWXYZ", Mid(sNorm$, iRc% + 1, 1)) = 0 Then
                                    GoTo NSNL4_TreatPunctuationAsNormal
                                'else (numeral to left, alpha to right)
                                    'retain hyphen for now
                                End If
                            Case "A" To "Z", "a" To "z"
                                If InStr("0123456789", Mid(sNorm$, iRc% + 1, 1)) = 0 Then
                                    If InStr("ABCDEFGHIJKLMNOPQRSTUVWXYZ", UCase(Mid(sNorm$, iRc% + 1, 1))) = 0 Then
                                        'Debug.Print "HYphen 2: >" + sNorm$ + "<"
                                        sNorm$ = SafeStuff(sNorm$, iRc%, 1, " ")
                                    End If
                                ElseIf InStr("ABCDEFGHIJKLMNOPQRSTUVWXYZ", UCase(Mid(sNorm$, iRc% + 1, 1))) = 0 Then
                                    GoTo NSNL4_TreatPunctuationAsNormal
                                End If
                            Case Else
                                GoTo NSNL4_TreatPunctuationAsNormal
                        End Select
                End Select
            Case "A" To "Z"
                ' keep these as they are
            Case "a" To "z"
                sNorm$ = SafeStuff(sNorm$, iRc%, 1, UCase(sChar$))
            Case "0" To "9"
                ' todo: unclear what all this means!
                If iRc% > 2 Then
                    If InStr(prvsSerNumStringOfSuperscripts$, Mid(sNorm$, iRc% - 2, 2)) > 0 Then
                        sNorm$ = SafeStuff(sNorm$, iRc%, 0, " ")
                    ElseIf InStr(prvsSerNumStringOfSubscripts$, Mid(sNorm$, iRc% - 2, 2)) > 0 Then
                        sNorm$ = SafeStuff(sNorm$, iRc%, 0, " ")
                    End If
                End If
            Case Is > sHighChar$
                sNorm$ = SafeStuff(sNorm$, iRc%, 1, NormString(sChar$))
            Case Else ' normal punctuation and other stuff
                If InStr(prvsSerNumStringOfSuperscripts$, Mid(sNorm$, iRc%, 2)) > 0 Or InStr(prvsSerNumStringOfSubscripts$, Mid(sNorm$, iRc%, 2)) > 0 Then
                    If iRc% > 1 Then
                        If InStr("0123456789", Mid(sNorm$, iRc% - 1, 1)) > 0 Then
                            sNorm$ = SafeStuff(sNorm$, iRc%, 2, " " + NormString(Mid(sNorm$, iRc%, 2)))
                        Else
                            sNorm$ = SafeStuff(sNorm$, iRc%, 2, NormString(Mid(sNorm$, iRc%, 2)))
                        End If
                    Else
                        sNorm$ = SafeStuff(sNorm$, iRc%, 2, NormString(Mid(sNorm$, iRc%, 2)))
                    End If
                Else
NSNL4_TreatPunctuationAsNormal:
                    If iRc% > 1 And iRc% < iLen% Then
                        If InStr("0123456789", Mid(Trim(Mid(sNorm$, iRc% + 1)), 1, 1)) > 0 Then
                            If InStr("0123456789", Right(Trim(NormString(Mid(sNorm$, 1, iRc% - 1))), 1)) > 0 Then
                                sNorm$ = SafeStuff(sNorm$, iRc%, 1, " ")
                            Else
                                sNorm$ = SafeStuff(sNorm$, iRc%, 1, "")
                            End If
                        Else
                            sNorm$ = SafeStuff(sNorm$, iRc%, 1, "")
                        End If
                    Else
                        sNorm$ = SafeStuff(sNorm$, iRc%, 1, "")
                    End If
                End If
        End Select
Nsnl9LeaveTheThingAlone:
    Next ' irc%
                
                
    sNorm$ = RemoveRepeatedCharacters(sNorm$, " ")
    
    ' remove external spaces
    sNorm$ = Trim(sNorm$)
    
    ' is there anything left?
    If Len(sNorm$) = 0 Then
        NormalizeSeriesNumberLevel4 = ""
        Exit Function
    End If
    
    bFound = False
    
    sOutput$ = ""
    sString$ = ""
    iLen% = Len(sNorm$)
    sIntermediate$ = sNorm$
    
    If Not bContainsNumeral Then
        NormalizeSeriesNumberLevel4 = NormalizeSeriesNumberNonNumericString(sNorm$, False)
        Exit Function
    End If
    
    
    ' break the thing into segments, and handle each segment appropriately
    sPreviousSegmentMarker$ = " "
    Do
        bFound = False
        For iCtr% = 1 To Len(sNorm$)
            If InStr(",;/", Mid(sNorm$, iCtr%, 1)) > 0 Then
                bFound = True
                Exit For
            End If
        Next ' ictr%
        If bFound Then
            sSegmentMarker$ = Mid(sNorm$, iCtr%, 1)
            sCopy$ = Mid(sNorm$, 1, iCtr% - 1)
            sNorm$ = Trim(Mid(sNorm$, iCtr% + 1))
            ' everything after the final numeral is part of the final segment, no matter what
            If Not NormalizeSeriesNumberIsNumeralPresent(sNorm$) Then
                sCopy$ = sCopy$ + " " + sNorm$
                sNorm$ = ""
            End If
        Else
            sSegmentMarker$ = " "
            sCopy$ = sNorm$
            sNorm$ = ""
        End If
        
        If Len(sNorm$) = 0 Then
            NormalizeSeriesNumberClause2b sOutput$, sCopy$, sIntermediate$, " ", " ", True, bFirstAlphabetic, bAsianLeapException
            Exit Do
        End If
        NormalizeSeriesNumberClause2b sOutput$, sCopy$, sIntermediate$, sSegmentMarker$, sPreviousSegmentMarker$, False, bFirstAlphabetic, bAsianLeapException
        sPreviousSegmentMarker$ = sSegmentMarker$
    Loop
    
    sOutput$ = RemoveRepeatedCharacters(sOutput$, " ")
    
    NormalizeSeriesNumberRemoveInitials sOriginalHeading$, sHeading$, sOutput$
     

    NormalizeSeriesNumberLevel4 = sOutput$

End Function



Private Sub NormalizeSeriesNumberRemoveInitials(ByVal sOriginalHeading$, ByVal sHeading$, ByRef sOutput$)

    Dim sCopy$, sInitials$, sInitials2$, sSaveInitials2$, sRemainder$, sWords$
    Dim sWordsWithSpaces$, sJunk$, sPiece$, sCopy2$, sOriginal$, sNormalizedHeading$
    Dim sInitials3$, sInitials4$, sCopySave$, sOriginalCopy$
    
    Dim iRc%, iRc2%, iPtr%, iPass%
    
    Dim bChanged As Boolean, bFound As Boolean, bRoman As Boolean, bInitialsCut As Boolean
    
    
    ' if the series numbering begins with a recognizable version of the
    '   initials of the series heading, or some other thing that
    '   can be recognized as 'title stuff', then remove the 'caption' too
    
    ' obviously, if we start with numerals, we don't/can't do any of this
    If InStr("0123456789", Mid(sOutput$, 1, 1)) > 0 Then
        Exit Sub
    End If
    
    ' first thing to try: 'regular' initials
    ' as in:
    '   CRS ISSUE BRIEF ; IB 87153
    '   COLLECTED STUDIES   CS578   CS 000578
    '   TWAYNES UNITED STATES AUTHORS SERIES ; TUSAS 259
  
    If InStr("*NEW *SER *SUP *", "*" + Mid(sOutput$, 1, 4) + "*") > 0 Or Mid(sOutput$, 1, 5) = "HORS " Then
        Exit Sub
    End If
    
    ' first word may NOT appear to be a roman numeral
    iRc% = InStr(sOutput$, " ")
    If iRc% > 0 Then ' it certainly should be!
        bFound = False
        ' do we find any letter here that is *not* part of a legal roman numeral?
        For iRc2% = 1 To iRc% - 1
            If InStr("IVXLCDM", Mid(sOutput$, iRc2%, 1)) = 0 Then
                bFound = True
                Exit For
            End If
        Next ' irc2%
        If Not bFound Then
            bRoman = True
        End If
    End If
    
    sCopy$ = sHeading$
    sOriginalCopy$ = sOriginalHeading$
    iPass% = 1 ' first time through this loop
    
    ' extract the "words" from the series numbering, up to the first numeric
    sRemainder$ = sOutput$
    sWords$ = ""
    Do
        GetNextPiece sRemainder$, sJunk$, " "
        sWords$ = sWords$ + sJunk$ + " "
        If InStr("0123456789", Mid(sRemainder$, 1, 1)) > 0 Then
            Exit Do
        End If
    Loop
    
    If InStr(sWords$, " ") > 0 Then
        sWordsWithSpaces$ = sWords$
        Do
            iRc% = InStr(sWords$, " ")
            If iRc% = 0 Then
                Exit Do
            End If
            sWords$ = SafeStuff(sWords$, iRc%, 1, "")
        Loop
    End If
        
    bChanged = False
    
    Do
        
        sCopySave$ = sCopy$
        ' extract the initials of the series heading
        sInitials$ = "" ' contains first letter of EACH word regardless of length
        sInitials2$ = "" ' first letter of each 'non-short' word
        sInitials3$ = ""
        sInitials4$ = ""
        Do
            GetNextPiece sCopy$, sJunk$, " "
            sInitials$ = sInitials$ + Mid(sJunk$, 1, 1)
            If InStr(prvsSeriesNumShortWordList$, " " + sJunk$ + " ") = 0 Then ' todo: expand this list?
                sInitials2$ = sInitials2$ + Mid(sJunk$, 1, 1)
            End If
            If Len(sCopy$) = 0 Then
                Exit Do
            End If
        Loop
        sSaveInitials2$ = sInitials2$
        If InStr(sOriginalCopy$, "-") > 0 Then
            sCopy$ = sOriginalCopy$
            Do
                iRc% = InStr(sCopy$, "-")
                If iRc% = 0 Then
                    Exit Do
                End If
                sCopy$ = SafeStuff(sCopy$, iRc%, 1, " ")
            Loop
            sCopy$ = Trim(NormString(sOriginalHeading$))
            Do
                GetNextPiece sCopy$, sJunk$, " "
                sInitials3$ = sInitials3$ + Mid(sJunk$, 1, 1)
                If InStr(prvsSeriesNumShortWordList$, " " + sJunk$ + " ") = 0 Then ' todo: expand this list?
                    sInitials4$ = sInitials4$ + Mid(sJunk$, 1, 1)
                End If
                If Len(sCopy$) = 0 Then
                    Exit Do
                End If
            Loop
        End If
        
        ' single letters would be dangerous!
        If Len(sWords$) > 1 Then
            ' there are a couple of unhappy places at which the 'series' replacement text
            '   accidentally happens to match the abbreviation of the heading, so we need
            '   to omit anything that has this word
            If sWords$ <> "SER" Then
                ' in the corpus of headings, the vast majority of matches were either on the beginning
                '   or the end of the extracted text string; but there were some cases in which
                '   the match was in the middle--and NONE of these was an improper match
                
                If InStr(sInitials$, sWords$) > 0 Or InStr(sInitials3$, sWords$) > 0 Then ' NOT: must equal 1? or either 1 or "at the right end"?
                    sOutput$ = sRemainder$
                    bChanged = True
                    Exit Do
                ElseIf InStr(sInitials2$, sWords$) > 0 Or InStr(sInitials4$, sWords$) > 0 Then
                    sOutput$ = sRemainder$
                    bChanged = True
                    Exit Do
                End If
            End If
        End If
        
NormSerNumRemInitNextPass:
        iPass% = iPass% + 1
        Select Case iPass%
            Case 2
                iRc% = InStr(sOriginalHeading$, "(")
                If iRc% = 0 Then
                    GoTo NormSerNumRemInitNextPass
                End If
                ' and, if the heading consists of term plus parenthesized qualifier, put the
                '   term at the end and try again
                ' examples:
                '   Disseration (Rand Graduate School) ; RGSD-103
                '   Ressearch report (Lesotho. Ministry of Agriculture and Marketing. Research Division) ; RD-R-81
                '   Report (University of Illinois at Urbana-Champaign. Dept of Computer Science) ; no. UIUCDCS-R-86-1316
                sOriginalCopy$ = RemoveDelimiters(Mid(sOriginalHeading$, iRc%) + " " + Mid(sOriginalHeading$, 1, iRc% - 1))
                sCopy$ = Trim(NormString(sOriginalCopy$))
            Case Else
                Exit Do
        End Select
    Loop
    
    
    ' second possibility, a: contains the whole thing
    '   NSRDS-NBS ; NSRDS-NBS 57.
    If InStr("0123456789", Mid(sOutput$, 1, 1)) = 0 Then
        ' part 2a: perhaps EVERYTHING to the left of the first digit?
        sJunk$ = sOutput$
        sCopy2$ = ""
        Do
            GetNextPiece sJunk$, sPiece$, " "
            If InStr("0123456789", Mid(sPiece$, 1, 1)) > 0 Then
                sJunk$ = Trim(sPiece$ + " " + sJunk$)
                Exit Do
            End If
            sCopy2$ = Trim(sCopy2$ + " " + sPiece$)
        Loop
        If InStr(sCopy2$, " ") > 0 Then
            If InStr(sCopy2$, sHeading$) > 0 Then
                sOutput$ = sJunk$
            End If
        End If
    End If
        
    ' second possibility b: overlaps on the first word of the heading
    ' as in:
    '   Capricorn books; CAP 28
    '   ALBAN INSTITUTE PUBLICATION ; AL126
    '   ATLA SERIALS PRESERVATION PROGRAM ; ATLA FILM 1996-S054
    ' possibility 2.25: overlaps on some other word of the heading
    ' as in:
    '   Grove evangelism series ; Ev 50
    If InStr("0123456789", Mid(sOutput$, 1, 1)) = 0 Then
        iRc% = InStr(sOutput$, " ")
        If iRc% > 2 Then ' avoiding single letters once again
            If Mid(sOutput$, 1, iRc% - 1) <> "SER" Then
                If InStr(sHeading$, Mid(sOutput$, 1, iRc% - 1)) = 1 Then
                    ' this is #2
                    sOutput$ = Trim(Mid(sOutput$, iRc% + 1))
                    bChanged = True
                ElseIf InStr(sHeading$, " " + Mid(sOutput$, 1, iRc% - 1)) > 0 And Not bRoman Then
                    ' this is #2.25
                    sOutput$ = Trim(Mid(sOutput$, iRc% + 1))
                    bChanged = True
                End If
            End If
        End If
    End If
    
    ' third possibility: the first word plus initials of the remainder ...
    '   ONR TOKYO SCIENTIFIC MONOGRAPH SERIES ; ONRT M2
    '   FJC STAFF PAPER ; FJCSP-77 3
    If InStr("0123456789", Mid(sOutput$, 1, 1)) = 0 Then
        iRc% = InStr(sHeading$, " ")
        If iRc% > 0 Then
            sWords$ = Mid(sHeading$, 1, iRc% - 1)
            sCopy$ = Trim(Mid(sHeading$, iRc% + 1))
            Do
                GetNextPiece sCopy$, sJunk$, " "
                sWords$ = sWords$ + Mid(sJunk$, 1, 1)
                If Len(sCopy$) = 0 Then
                    Exit Do
                End If
            Loop
            iRc% = InStr(sOutput$, " ")
            If iRc% > 2 Then
                If InStr(sWords$, Mid(sOutput$, 1, iRc% - 1)) = 1 Then
                    sOutput$ = Trim(Mid(sOutput$, iRc% + 1))
                    bChanged = True
                End If
            End If
        End If
    End If
    
    
    ' fourth possibility: same as the first, but omitting only articles
    ' as in:
    '   TOPICS IN THE NEUROSCIENCES ; TIN6
    If InStr("0123456789", Mid(sOutput$, 1, 1)) = 0 Then
        sRemainder$ = sOutput$
        sWords$ = ""
        Do
            GetNextPiece sRemainder$, sJunk$, " "
            sWords$ = sWords$ + sJunk$
            ' if the remaining words begin numeric, time to quit (this is kind of
            '   the reverse of our normal procedure, but it works, too)
            If InStr("0123456789", Mid(sRemainder$, 1, 1)) > 0 Then
                Exit Do
            End If
            If Len(sCopy$) = 0 Then
                Exit Do
            End If
        Loop
        ' extract the initials of the series heading
        sCopy$ = sHeading$
        sInitials$ = ""
        sInitials2$ = ""
        bInitialsCut = False
        Do
            GetNextPiece sCopy$, sJunk$, " "
            If InStr(prvsSeriesNumArticles$, " " + sJunk$ + " ") = 0 Then ' todo: expand this list?
                sInitials$ = sInitials$ + Mid(sJunk$, 1, 1)
            Else
                bInitialsCut = True
            End If
            If Len(sCopy$) = 0 Then
                Exit Do
            End If
        Loop
        ' single letters would be dangerous!
        If Len(sWords$) > 1 And bInitialsCut Then
            ' there are a couple of unhappy places at which the 'series' replacement text
            '   accidentally happens to match the abbreviation of the heading, so we need
            '   to omit anything that has this word
            If sWords$ <> "SER" Then
                ' in the corpus of headings, the vast majority of matches were either on the beginning
                '   or the end of the extracted text string; but there were some cases in which
                '   the match was in the middle--and NONE of these was an improper match
                If InStr(sInitials$, sWords$) > 0 Then ' perhaps: must equal 1? or either 1 or "at the right end"?
                    sOutput$ = sRemainder$
                    bChanged = True
                End If
            End If
        End If

    End If


    If Not bRoman Then
        ' if we have anything left over and there were multiple "words" in the
        '   caption stuff, then let's try one more time
        If InStr("0123456789", Mid(sOutput$, 1, 1)) = 0 And Len(sWordsWithSpaces$) > 0 Then
            ' extract the leading non-numeric thingies from the series numbering
            sRemainder$ = sOutput$
            sWords$ = ""
            sInitials2$ = sSaveInitials2$
            sNormalizedHeading$ = Trim(NormString(sOriginalHeading$))
            Do
                GetNextPiece sRemainder$, sJunk$, " "
                sWords$ = sWords$ + sJunk$ + " "
                If InStr("0123456789", Mid(sRemainder$, 1, 1)) > 0 Then
                    Exit Do
                End If
            Loop
            sWords$ = Trim(sWords$)
            Do
                GetNextPiece sWords$, sPiece$, " "
                ' exit if this 'word' appears to be a roman numeral
                bFound = False
                For iRc% = 1 To Len(sPiece$)
                    If InStr("IVXLCDM", Mid(sPiece$, iRc%, 1)) = 0 Then
                        bFound = True
                        Exit For
                    End If
                Next ' irc%
                If Not bFound Then
                    Exit Do
                End If
                If Len(sPiece$) = 1 Or sPiece$ = "SER" Or sPiece$ = "NEW" Or sPiece$ = "HORS" Then
                    If Len(sWords$) > 0 Then
                        sOutput$ = sPiece$ + " " + sWords$ + " " + sRemainder$
                    Else
                        sOutput$ = sPiece$ + " " + sRemainder$
                    End If
                    Exit Do
                End If
                If Len(sPiece$) > 1 And InStr(sNormalizedHeading$, sPiece$) = 1 Then
                    ' do nothing
                ElseIf InStr(sInitials$, sPiece$) = 0 And InStr(sInitials2$, sPiece$) = 0 Then
                    If Len(sWords$) > 0 Then
                        sOutput$ = sPiece$ + " " + sWords$ + " " + sRemainder$
                    Else
                        sOutput$ = sPiece$ + " " + sRemainder$
                    End If
                    Exit Do
                End If
                If Len(sWords$) = 0 Then
                    sOutput$ = sRemainder$
                    Exit Do
                End If
            Loop
        End If
    End If

End Sub


Private Function NormalizeSeriesNumberIsNumeralPresent(ByVal sIn$) As Boolean

    Dim iCtr%
    
    For iCtr% = 1 To Len(sIn$)
        If InStr("0123456789", Mid(sIn$, iCtr%, 1)) > 0 Then
            NormalizeSeriesNumberIsNumeralPresent = True
            Exit Function
        End If
    Next ' ictr%
    
    NormalizeSeriesNumberIsNumeralPresent = False
    
End Function


Private Function NormalizeSeriesNumberNonNumericString(ByVal sNorm$, ByVal bSegmentedAtSlash As Boolean) As String

    Dim sPiece$, sOut$, sTest$, sOtherString$
    
    Dim lAt As Long, lAt2 As Long
    
    Dim iRc%
        
    Static bInitialized As Boolean
    
    Static sReplacementString$
    
    
    sNorm$ = Trim(NormString(sNorm$))

    ' we're going to leave "chapter" out altogether
    If Not bInitialized Then
        bInitialized = True
        sReplacementString$ = " AASTAKAIK *AASTAK ABDR ABDRUCK *ABD ABHAND ABHANDLUNG ABHANDLUNGEN *ABH ABTEIL ABTEILUNG ABTH ABTHEIL ABTHEILUNG *ABT ADDENDUM *ADD AFDELING *AFD"
        sReplacementString$ = sReplacementString$ + " AFLEVERING *AFL ANEJO ANN ANNEE ANNO ANO *AN ANEXO *ANNEX ARGANG ARGGRAFFIAD *ARG ARTICLE *ART BAND BANDCHEN BANDE BDE BDCHEN BDCHN *BD"
        sReplacementString$ = sReplacementString$ + " BEIHEFT BEIHEFTE *BHFT BEILAGEN *BEILAG BILANGAN *BIL BOOK BOOKLET BOOKS *BK BULL BULLETIN *BUL CATALOG CATALOGUE *CAT CONGRESS *CONG"
        sReplacementString$ = sReplacementString$ + " DEEL DEL *D DOCUMENT DOCUMENTO DOKUMENT *DOC ERGANZUNGSBAND *ERGANZUNGSBD FASCICOLO FASCICLE FASCICULE FASZ FASZIKEL *FASC FICHES *FICHE"
        sReplacementString$ = sReplacementString$ + " FOLGE *F HAFT HEFT *HFT HALBBAND HALBBANDE HALBBDE *HALBBD ITEMS *ITEM JAARGANG JAHRESREIHE JAHRG JAHRGAG JAHRGANG JAHR *JHRG KNJ KNIGA KNIHA *KN LEVELS *LEVEL"
        sReplacementString$ = sReplacementString$ + " LIEFERUNG *LFG LIVRE LIVRAISON *LIVR MAPPE MAPS *MAP MONOGRAFIA MONOGRAFIE *MONOGRAPH NOMBOR NOMOR NOS NR NRS NUM NUMBER NUMERO NUMMER *NO PAGES *PAGE"
        sReplacementString$ = sReplacementString$ + " PAPERS *PAPER PARS PART PARTE PARTES PARTIE PARTIES PARTS PTS PTES *PT POSITION *POS PUBLICACI PUBLICACION PUBLICATION *PUB"
        sReplacementString$ = sReplacementString$ + " QUADERNI *QUADERNO RAEKKE REEKS *REEK REELS *REEL REIRE *REIHE REPORT RAPPORT REP RPT *REPT ROCNIK ROCZ ROCZNIK ROK *ROC SEC SECTION SECTIONS SECTS *SECT"
        sReplacementString$ = sReplacementString$ + " SERIE SERIES SERIIA *SER SESSION ZESZ *SESS SONDERBAND *SONDERBD ERGANZUNGSHEFT ERGANZUNGSHEFTE ERGANZUNGSHFT SUPLEMENTO SUPP SUPPL SUPPLEMENT SUPPLEMENTA SUPPLEMENTBAND SUPPLEMENTBD SUPPLEMENTO SUPPLEMENTARY SUPPLEMENTS SUPPLEMENTUM *SUP"
        sReplacementString$ = sReplacementString$ + " TEIL TEILBAND TEILBD THEIL TOM TOME TOMO TOMUS *T TEXTBAND TEXTS *TEXT VEROFFENTLICHUNGEN *VEROFFENTLICHUNG VOLS VOLUME VOLUMEN VOLUMES VOL *V"
    End If
    
    If bSegmentedAtSlash Then
        NormalizeSeriesNumberNonNumericString = sNorm$
        Exit Function
    End If
    
    Do
        GetNextPiece sNorm$, sPiece$, " "
        sPiece$ = " " + sPiece$ + " "
        sNorm$ = Trim(sNorm$) ' deal with multiple internal spaces this clumsy way
        ' look for varieties of "new series" and replace with standard text
        If InStr(prvsSeriesNumNewSeriesWords$, sPiece$) > 0 Then
            sOut$ = Trim(sOut$ + " " + prvsSeriesNumNewSeriesReplacement$)
        ElseIf InStr(prvsSeriesNumNewWords$, sPiece$) > 0 Then
            sOtherString$ = prvsSeriesNumSeriesWords$
NormalizeNonNumericStringTryForNewSeries:
            ' if previous or following word is the 'other' word then replace both
            If Len(sNorm$) > 0 Then
                ' what about the following word?
                iRc% = InStr(sNorm$, " ")
                If iRc% > 0 Then
                    sTest$ = " " + Mid(sNorm$, 1, iRc% - 1) + " "
                Else
                    sTest$ = " " + sNorm$ + " "
                End If
                If InStr(sOtherString$, sTest$) > 0 Then
                    ' replace the current word and the following word with the new series replacement
                    sOut$ = Trim(sOut$ + " " + prvsSeriesNumNewSeriesReplacement$)
                    If iRc% > 0 Then
                        sNorm$ = Mid(sNorm$, iRc% + 1)
                    Else
                        sNorm$ = ""
                    End If
                    GoTo NormalizeNonNumericStringNextWord
                End If
            End If
            ' following word (if any) isn't the 'other' word; what about the preceding word?
            If Len(sOut$) > 0 Then
                iRc% = Rat(sOut$, " ")
                If iRc% > 0 Then ' it should always be!
                    sTest$ = " " + Mid(sOut$, iRc% + 1, 1)
                Else
                    sTest$ = " " + sOut$ + " "
                End If
                If InStr(sOtherString$, sTest$) > 0 Then
                    ' replace the current and preceding words with the new series replacement
                    If iRc% > 0 Then
                        sOut$ = Trim(Mid(sOut$, 1, iRc% - 1) + " " + prvsSeriesNumNewSeriesReplacement$)
                    Else
                        sOut$ = prvsSeriesNumNewSeriesReplacement$
                    End If
                    GoTo NormalizeNonNumericStringNextWord
                End If
            End If
            ' if we get here, then this piece is a washout
            GoTo NnnsTryAsRegularWord
        ElseIf InStr(prvsSeriesNumSeriesWords$, sPiece$) > 0 Then
            ' if previous or following word = 'new' then replace both
            sOtherString$ = prvsSeriesNumNewWords$
            GoTo NormalizeNonNumericStringTryForNewSeries
        ElseIf InStr(" CHAPTER CHAP KAPITEL KAP ", sPiece$) > 0 Then
            GoTo NormalizeNonNumericStringNextWord
        Else
NnnsTryAsRegularWord:
            lAt = InStr(sReplacementString$, sPiece$)
            If lAt = 0 Then
                sOut$ = Trim(sOut$ + " " + sPiece$)
            Else
                lAt2 = InStr(Mid(sReplacementString$, lAt), "*")
                If lAt2 > 0 Then
                    sPiece$ = Mid(sReplacementString$, lAt + lAt2, 50)
                    lAt = InStr(sPiece, " ")
                    If lAt > 0 Then
                        sPiece$ = Mid(sPiece$, 1, lAt - 1)
                    End If
                End If
                sOut$ = Trim(sOut$ + " " + sPiece$)
            End If
        End If
NormalizeNonNumericStringNextWord:
        If Len(sNorm$) = 0 Then
            Exit Do
        End If
    Loop
        
    NormalizeSeriesNumberNonNumericString = RemoveRepeatedCharacters(Trim(sOut$), " ")
    
End Function


Private Function NormalizeSeriesNumberConvertIfUsedInAbbrev(ByVal sNorm$, ByVal sChar$) As String

    Dim iCtr%, iLenChar%
    
    Dim bAngstrom As Boolean, bSuperscriptZero As Boolean
    
    If sChar$ = MarcSuperscript0 Then
        bSuperscriptZero = True
    ElseIf sChar$ = MarcAngstrom Then
        bAngstrom = True
    End If
    
    ' get out of here if the character doesn't appear at all
    If InStr(sNorm$, sChar$) = 0 Then
        NormalizeSeriesNumberConvertIfUsedInAbbrev = sNorm$
        Exit Function
    End If
    
    iLenChar% = Len(sChar$)
    
    For iCtr% = Len(sNorm$) To 1 Step -1
        If Mid(sNorm$, iCtr%, iLenChar%) = sChar$ Then
            If iCtr% > 1 Then
                Select Case Mid(sNorm$, iCtr% - 1, 1)
                    Case "N", "n"
                        sNorm$ = SafeStuff(sNorm$, iCtr% - 1, iLenChar% + 1, prvsSerNumCaptionSubstitute$)
                    Case ".", ":"
                        If iCtr% > 2 Then
                            If InStr("nN", Mid(sNorm$, iCtr% - 2, 1)) > 0 Then
                                sNorm$ = SafeStuff(sNorm$, iCtr% - 2, iLenChar% + 2, prvsSerNumCaptionSubstitute$)
                            Else
                                sNorm$ = SafeStuff(sNorm$, iCtr%, iLenChar%, NormString(Mid(sNorm$, iCtr%, iLenChar%)))
                            End If
                        Else
                            sNorm$ = SafeStuff(sNorm$, iCtr%, iLenChar%, NormString(Mid(sNorm$, iCtr%, iLenChar%)))
                        End If
                    Case "8"
                        ' if abbreviation for octavo, then remove the zero altogether
                        If bSuperscriptZero Then
                            sNorm$ = SafeStuff(sNorm$, iCtr%, iLenChar%, "")
                        Else
                            GoTo CiuiafnNormalHandling
                        End If
                    Case Else
CiuiafnNormalHandling:
                        ' do NOT do this conversion for superscript zero--it'll be handled later
                        If Mid(sNorm$, iCtr%, iLenChar%) <> MarcSuperscript0 Then
                            sNorm$ = SafeStuff(sNorm$, iCtr%, iLenChar%, NormString(Mid(sNorm$, iCtr%, iLenChar%)))
                        End If
                End Select
            Else
                ' bogus character is first character in the string: replace with its normalized self
                sNorm$ = SafeStuff(sNorm$, iCtr%, iLenChar%, NormString(Mid(sNorm$, iCtr%, iLenChar%)))
            End If
        End If
    Next ' ictr%
    
    NormalizeSeriesNumberConvertIfUsedInAbbrev = sNorm$
    
End Function


Private Function NormalizeSeriesNumberOtherSingleLetterAbbrev(ByRef sLetters$, ByRef sVIn$, ByVal bFirstAlphabetic As Boolean, ByVal bTryAlsoAsUppercase As Boolean) As String

    ' scan series numbering for the word 'v' and decide whether it represents
    '   a caption word ('volume') or something else (roman numeral; just part of the
    '   number)
    
    Dim iRc%, iLenV%, iTab%, iCtr%, iPtr%
    
    Dim sLine$, sV$, gblsBlockString$, sJunk$, sHeading$, sVCharacters$, sOriginal$
    Dim sChar$, sTest$
    
    Dim lRead As Long, lWritten As Long, lRejected As Long, lNumber As Long, lDifference As Long
    Dim lWithV As Long
    
    Dim bHitNumeral As Boolean, bIsUppercase As Boolean, bColon As Boolean
    
    
    sV$ = sVIn$
    sOriginal$ = sVIn$
    
    gblsBlockString$ = "0123456890."
    
    ' note that we're not going to assume that the caller is being
    '   perfect in its protocol!
    If bTryAlsoAsUppercase Then
        sVCharacters$ = UCase(sLetters$)
        bIsUppercase = True
    Else
        sVCharacters$ = LCase(sLetters$)
    End If
        
        
    ' this 'Do' is for control purposes only. if we're interested in the abbreviation in both
    '   uppercase and lowercase, we'll to the same thing twice, once with uppercase once with lowercase; if
    '   we're only interested in lowercase we'll do this once with lowercase and then exit
    Do
    
        For iPtr% = 1 To Len(sV$)
        
            sTest$ = Mid(sV$, iPtr%, 1)
    
            If InStr(sVCharacters$, sTest$) > 0 Then
                ' for each occurrence of the character in the subfield: must be a separate word, or
                '   adjacent to other roman-numeral words
                iLenV% = Len(sV$)
        
                bHitNumeral = False
                
                Select Case iLenV%
                
                    Case 1 ' numbering subfield contains only the character in question
                        
                        ' retain the character in all cases
                        
                    Case 2 ' numbering subfield contains 2 characters
                    
                        If Mid(sV$, 2, 1) = "." Then
                            ' just the abbreviation
                            ' retain the letter as a likely thing to keep
                        Else
                            ' our letter plus something else: see what else
                            iCtr% = 1
                            GoTo NSNOSLA_StandardHandling
                        End If
                        
                    Case Else ' length of the numbering subfield is 3 or more
                    
                        ' scan the numbering backwards, looking for likely suspects
                        For iCtr% = iLenV% To 1 Step -1
                            sChar$ = Mid(sV$, iCtr%, 1)
                            If InStr("0123456789", sChar$) Then
                                ' mark that we've found a numeral, and
                                '   keep the character
                                bHitNumeral = True
                                GoTo NSNOSLA_NextCharacter
                            ElseIf Not bHitNumeral Then
                                ' this character--whatever it is--is to the right
                                '   of the rightmost numeral: retain it in all cases
                                GoTo NSNOSLA_NextCharacter
                            End If
                            ' if we get here, then we've hit a non-numeral preceding the final numeral
                            
                            If sChar$ = sTest$ Then
                                ' preliminary test: watch out for 'new series' in all its forms
                                ' if the single-letter word is part of a 'new series' sequence, then
                                '   retain the single letter for now--we'll handle the whole sequence
                                '   later on
                                Select Case sChar$
                                    Case "f", "F", "p", "P", "s", "S"
                                        ' potential 'series' word--is adjacent word 'new'?
                                        If NormalizeSeriesNumberIsWordNextToSingleLetter(iCtr%, sV$, prvsSeriesNumNewWords$, prvsSeriesNumSeriesWords$) Then
                                            GoTo NSNOSLA_NextCharacter
                                        End If
                                        If InStr("sS", sChar$) > 0 Then
                                            If NormalizeSeriesNumberIsWordNextToSingleLetter(iCtr%, sV$, prvsSeriesNumHorsWords$, prvsSeriesNumSeriesWords$) Then
                                                GoTo NSNOSLA_NextCharacter
                                            End If
                                        End If
                                    Case "h", "H"
                                        If NormalizeSeriesNumberIsWordNextToSingleLetter(iCtr%, sV$, prvsSeriesNumSeriesWords$, prvsSeriesNumHorsWords$) Then
                                            GoTo NSNOSLA_NextCharacter
                                        End If
                                    Case "n", "N"
                                        ' potential 'new' word--is adjacent word 'series'?
                                        If NormalizeSeriesNumberIsWordNextToSingleLetter(iCtr%, sV$, prvsSeriesNumSeriesWords$, prvsSeriesNumNewWords$) Then
                                            GoTo NSNOSLA_NextCharacter
                                        End If
                                End Select
                                
                                Select Case iCtr%
                                    Case 1 ' it's at the beginning
NSNOSLA_StandardHandling:                 ' NOTE label in left margin
                                        Select Case Mid(sV$, iCtr% + 1, 1)
                                            Case " "
                                                ' if the following character is an arabic numeral, then it's not
                                                '   something to keep
                                                If bIsUppercase Then
                                                    ' single uppercase letter followed by space--keep it
                                                    GoTo NSNOSLA_NextCharacter
                                                Else
                                                    GoTo NSNOSLA_MustBeVolume
                                                End If
                                                ' THIS IS DEAD CODE; this stuff never gets used for
                                                '   single character followed by space
                                                sJunk$ = Trim(NormString(Mid(sV$, iCtr% + 2)))
                                                If InStr("0123456789", Mid(sJunk$, 1, 1)) > 0 Then
                                                    GoTo NSNOSLA_MustBeVolume
                                                End If
                                                ' since we've just removed punctuation, the charcater of
                                                '   interest can't possibly be a full stop, can it?
                                                If InStr("0123456789.", Mid(sV$, iCtr% + 2, 1)) = 0 Then
                                                    ' isolate the following word
                                                    sJunk$ = Trim(NormString(Mid(sV$, iCtr% + 2)))
                                                    iRc% = InStr(sJunk$, " ")
                                                    If iRc% > 0 Then
                                                        sJunk$ = Mid(sJunk$, 1, iRc% - 1)
                                                    End If
                                                    sJunk$ = " " + sJunk$ + " "
                                                    ' exclude if the *next* word is a word that means "number"
                                                    If InStr(prvsSeriesNumIgnoredWords$, sJunk$) = 0 Then
RoslasFoundARomanNumeralMaybe:                          ' NOTE label in left margin
                                                        ' leave the thing alone
                                                    Else ' it's not something we want to keep: kill it
                                                        ' we're going to replace the ignorable single letter with something else,
                                                        '   so that we can remember that there USED to be something here, and we're going
                                                        '   carefully to retain the someothing else until we come to the "handle text" routine,
                                                        '   so we can know at that time that there was once a caption at a particular
                                                        '   point in the string; this is occasionally important, when we need to know what
                                                        '   the preceding and following "words" look like (distinction is usually between a
                                                        '   numeral, and "anything else"
                                                        sV$ = SafeStuff(sV$, iCtr%, 1, prvsSerNumCaptionSubstitute$)
                                                    End If
                                                Else ' followed by numeral or full stop
NSNOSLA_MustBeVolume:                               ' NOTE label in left margin
                                                    sV$ = SafeStuff(sV$, iCtr%, 1, prvsSerNumCaptionSubstitute$)
                                                    If Len(sV$) = 0 Then
                                                        Exit For
                                                    End If
                                                End If
                                            Case "a" To "z", "A" To "Z" ' clearly part of a word
                                                ' do nothing
                                            Case ":", ","
                                                If bIsUppercase Then
                                                    ' single uppercase letter followed by this punctuation--keep it
                                                    GoTo NSNOSLA_NextCharacter
                                                End If
                                                ' if the following character is a numeral, cut out the letter
                                                sJunk$ = Mid(Trim(NormString(Mid(sV$, iCtr% + 2))), 1, 1)
                                                If InStr("012346789", Mid(sJunk$, 1, 1)) > 0 Then
                                                    GoTo NSNOSLA_MustBeVolume
                                                End If
                                                GoTo NSNOSLA_TrySameAsFullStop
                                            Case "."
                                                ' if the following character is a numeral, cut out the letter
                                                sJunk$ = Trim(NormString(Mid(sV$, iCtr% + 2)))
                                                If InStr("012346789", Mid(sJunk$, 1, 1)) > 0 Then
                                                    ' it's a volume number ? UNLESS PRECEDED by another
                                                    '   initialism
                                                    If iCtr > 2 Then
                                                        sJunk$ = Trim(Mid(sV$, 1, iCtr% - 1))
                                                        If Len(sJunk$) > 1 Then
                                                            If Right(sJunk$, 1) = "." Then
                                                                sJunk$ = Mid(sJunk$, 1, Len(sJunk$) - 1)
                                                                If InStr("ABCDEDFGJIHKLMNOPQRSTUVWXYZ", Right(sJunk$, 1)) > 0 Then
                                                                    GoTo NSNOSLA_NextCharacter
                                                                End If
                                                            End If
                                                        End If
                                                    End If
                                                    GoTo NSNOSLA_MustBeVolume
                                                End If
                                                If bIsUppercase Then
                                                    If Mid(sV$, iCtr% + 1, 1) = "." Then
                                                        ' retain if part of an initialism: uppercase, full stop,
                                                        '   [intervening space], uppercase, full stop
                                                        sJunk$ = Trim(Mid(sV$, iCtr% + 2))
                                                        ' maybe followed by an initialism
                                                        If InStr("ABCDEDFGJIHKLMNOPQRSTUVWXYZ", Mid(sJunk$, 1, 1)) > 0 Then
                                                            If Mid(sJunk$, 2, 1) <> "." Then
                                                                GoTo NSNOSLA_MustBeVolume
                                                            Else
                                                                GoTo NSNOSLA_NextCharacter
                                                                ' it's an initialism
                                                            End If
                                                        ElseIf InStr("012346789", Mid(sJunk$, 1, 1)) > 0 And Mid(sJunk$, 2, 1) = "." And InStr("FPS", UCase(sChar$)) > 0 Then
                                                            sV$ = SafeStuff(sV$, iCtr%, 2, " " + prvsSeriesNumSeriesReplacement$ + " ")
                                                            ' ser. 3., for example
                                                            GoTo NSNOSLA_NextCharacter
                                                        Else
                                                            ' maybe preceded by an initialism?
                                                            If iCtr% > 1 Then
                                                                sJunk$ = Trim(Mid(sV$, 1, iCtr% - 1))
                                                                If Len(sJunk$) > 1 Then
                                                                    If Right$(sJunk$, 1) = "." Then
                                                                        If Len(sJunk$) > 1 Then
                                                                            If InStr("ABCDEDFGJIHKLMNOPQRSTUVWXYZ", Mid(sJunk$, Len(sJunk$) - 1, 1)) > 0 Then
                                                                                GoTo NSNOSLA_NextCharacter
                                                                            ElseIf InStr("012346789", Mid(sJunk$, Len(sJunk$) - 1, 1)) > 0 Then
                                                                                If InStr("FPS", UCase(sChar$)) > 0 Then
                                                                                    sV$ = SafeStuff(sV$, iCtr%, 2, " " + prvsSeriesNumSeriesReplacement$ + " ")
                                                                                    GoTo NSNOSLA_NextCharacter
                                                                                End If
                                                                            End If
                                                                        End If
                                                                    End If
                                                                End If
                                                            End If
                                                            'Debug.Print "NIA"
                                                        End If
                                                    End If
NSNOSLA_TrySameAsFullStop:                          ' NOTE label in left margin
                                                    ' if either the preceding or following word is a
                                                    '   "caption" word, retain the letter
                                                    sJunk$ = Trim(NormString(Mid(sV$, iCtr% + 2)))
                                                    iRc% = InStr(sJunk$, " ")
                                                    If iRc% > 0 Then
                                                        sJunk$ = Mid(sJunk$, 1, iRc% - 1)
                                                    End If
                                                    sJunk$ = " " + sJunk$ + " "
                                                    If InStr(prvsSeriesNumIgnoredWords$, sJunk$) = 0 And InStr(prvsSeriesNumSingleLetterCaptions$, sJunk$) = 0 Then
                                                        If iCtr% > 1 Then
RoslasTryPrecedingWord:                                     ' NOTE label in left margin
                                                            sJunk$ = Trim(NormString(Mid(sV$, 1, iCtr% - 1)))
                                                            iRc% = Rat(sJunk$, " ")
                                                            If iRc% > 0 Then
                                                                sJunk$ = Mid(sJunk$, iRc% + 1)
                                                            End If
                                                            sJunk$ = " " + sJunk$ + " "
                                                            ' exclude current word if the *preceding* word is a word that means "number"
                                                            If InStr(prvsSeriesNumIgnoredWords$, sJunk$) = 0 Then
                                                                GoTo NSNOSLA_MustBeVolume
                                                            End If
                                                        End If
                                                    Else
                                                        ' the following word DOES mean number
                                                        If iCtr% = 1 Then
                                                            GoTo NSNOSLA_MustBeVolume
                                                        End If
                                                        ' does the preceding word mean number:
                                                        GoTo RoslasTryPrecedingWord
                                                    End If
                                                Else ' some lower-case letter
                                                    ' throw the letter away
                                                    GoTo NSNOSLA_MustBeVolume
                                                End If
                                            'Case Else
                                        End Select
                                        ' we need this fakey exit so we can properly leave even if we
                                        '   got here improperly, via branch
                                        If iCtr% = 1 Then
                                            Exit For ' we were already at the beginning
                                        End If
                                    Case Else ' our letter is somewhere in between beginning and end
                                        If InStr("[({<", Mid(sV$, iCtr% - 1, 1)) > 0 Then
                                            If InStr(":,.])>", Mid(sV$, iCtr% + 1, 1)) > 0 Then
                                                ' it's a single letter captured by punctuation: examine it
                                                GoTo NSNOSLA_StandardHandling
                                            End If
                                            GoTo NSNOSLA_NextCharacter
                                        Else
                                            If InStr(".,: ", Mid(sV$, iCtr% - 1, 1)) > 0 Then
                                                GoTo NSNOSLA_StandardHandling
                                            End If
                                        End If
                                        ' else it's part of a word and we're keeping it
                                End Select
                            End If
NSNOSLA_NextCharacter:
                        Next ' irc%
                        
                End Select ' how long is this piece of text (subfield $v)?
                
            End If ' doesn't contains the character at all
        
        Next ' iPtr%
        
        If Not bTryAlsoAsUppercase Then
            Exit Do
        ElseIf sVCharacters$ = LCase(sLetters$) Then
            Exit Do
        End If
        sVCharacters$ = LCase(sLetters$)
        bIsUppercase = False
    Loop
    
    
    sV$ = Trim(sV$)
    
    ' if we've removed the entire first alphabetic business from the
    '   original string, set the "first alphabetic encountered already" marker
    '   so we'll handle "series" correctly later on
    If InStr("0123456789", Mid(Trim(NormString(sV$)), 1, 1)) > 0 Then
        If InStr("0123456789", Mid(Trim(NormString(sOriginal$)), 1, 1)) = 0 Then
            bFirstAlphabetic = True
        End If
    End If
    
    NormalizeSeriesNumberOtherSingleLetterAbbrev = sV$



End Function


Private Function NormalizeSeriesNumberIsWordNextToSingleLetter(ByVal iLocation%, ByVal sTestString$, ByVal sWordList$, ByVal sBlockingWordList$) As Boolean

    ' given a character string, a pointer to a sigle-letter word within that string, and a
    '   space-delimited list of interesting words, determine if the word adjacent to the
    '   pointed-at-word (either following or preceding word) is one of the words in the
    '   supplied list
    
    Dim sJunk$, sString$
    
    Dim iRc%
    
    Dim bFollowing As Boolean, bPreceding As Boolean
    
    
    ' extract and test the *following* word, if any
    sJunk$ = Trim(NormString(Mid(sTestString$, iLocation% + 2)))
    iRc% = InStr(sJunk$, " ")
    If iRc% > 0 Then
        sJunk$ = Mid(sJunk$, 1, iRc% - 1)
    End If
    If Len(sJunk$) > 0 Then
        sJunk$ = " " + sJunk$ + " "
        If InStr(sWordList$, sJunk$) > 0 Then
            ' the next word is in the list: we've found what we wanted to find
            bFollowing = True
        End If
    End If
    
    ' extract and test the *preceding* word, if any
    If iLocation% > 1 Then
        sString$ = Trim(Mid(sTestString$, 1, iLocation% - 1))
        If Right$(sString$, 1) <> "," Then ' it's in a SERIES and cannot be connected
            sString$ = Trim(NormString(sString$))
            iRc% = Rat(sString$, " ")
            If iRc% > 0 Then
                sJunk$ = Mid(sString$, iRc% + 1)
                sString$ = Mid(sString$, 1, iRc% - 1)
            Else
                sJunk$ = sString$
            End If
            If Len(sJunk$) > 0 Then
                sJunk$ = " " + sJunk$ + " "
                If InStr(sWordList$, sJunk$) > 0 Then
                    If Len(sString$) = 0 Then
                        ' the preceding word is in the list: we've found what we wanted to find
                        bPreceding = True
                    Else
                        ' is the word *before* this word in the same family as the
                        '   word we started with?
                        iRc% = Rat(sString$, " ")
                        If iRc% > 0 Then
                            sJunk$ = " " + sString$ + " "
                        Else
                            sJunk$ = " " + Mid(sString$, iRc% + 1) + " "
                        End If
                        If InStr(sBlockingWordList$, sJunk$) = 0 Then
                            bPreceding = True
                        End If
                    End If
                End If
            End If
        End If
    End If

    If (bFollowing And Not bPreceding) Or (Not bFollowing And bPreceding) Then
        NormalizeSeriesNumberIsWordNextToSingleLetter = True
    Else
        NormalizeSeriesNumberIsWordNextToSingleLetter = False
    End If
    
End Function


Private Function NormalizeSeriesNumberRemoveV(ByVal sVIn$, ByVal bFirstAlphabetic As Boolean, Optional ByVal bTryVAlsoAsUppercase As Boolean = False, Optional ByVal bMethod1 As Boolean = False) As String

    ' scan series numbering for the word 'v' and decide whether it represents
    '   a caption word ('volume') or something else (roman numeral; just part of the
    '   number)
    
    Dim iRc%, iLenV%, iTab%, iCtr%
    
    Dim sLine$, sV$, sJunk$, sHeading$, sVCharacter$, sOriginal$, sTrial$
    Dim sReplacementCharacter$, sJunk1$, sJunk2$
    
    Dim lRead As Long, lWritten As Long, lRejected As Long, lNumber As Long, lDifference As Long
    Dim lWithV As Long
    
    sV$ = sVIn$
    
    If bTryVAlsoAsUppercase Then
        sVCharacter$ = "V"
    Else
        sVCharacter$ = "v"
    End If
        
    sOriginal$ = sV$
    
    ' this 'Do' is for strange control purposes only. if we're interested in 'v' in both
    '   uppercase and lowercase, we'll to the same thing twice, once with 'V' once with 'v'; if
    '   we're only interested in lowercase we'll do this once with 'v' and then exit
    Do
        iRc% = InStr(sV$, sVCharacter$)
        If iRc% > 0 Then
            ' for each v in the subfield: must be a separate word, or
            '   adjacent to other roman-numeral words
            iLenV% = Len(sV$)
            Select Case iLenV%
                Case 1
                    ' retain the 'v' in nearly all cases
                Case 2
                    If Mid(sV$, 2, 1) = "." Then
                        ' retain the 'v.' as a likely roman numeral
                    Else
                        GoTo NSNRV_TreatAsLongerV
                    End If
                    
                Case Else
                    ' length is 3 or more
NSNRV_TreatAsLongerV:
                    ' scan the numbering backwards, looking for likely suspects
                    For iCtr% = iLenV% To 1 Step -1
                        If Mid(sV$, iCtr%, 1) = sVCharacter$ Then
                            
                            Select Case iCtr%
                            
                                Case 1 ' we're at the first character
                                
NSNRV_StandardHandling:             ' NOTE label in left margin
                                    
                                    ' 20020314: retention is clearly called for in cases where the "V" is followed
                                    '   by a colon: #1004834 (V:7) and #1025158 (V:4); as it turns out,
                                    '   the "V" is in fact a roman numeral, not a garbled volume caption
                                    ' remove if lower-case 'v' immediately followed by numeral (v58)
                                    ' 20020314: if 'v' immediately followed by numeral, cut it
                                    ' there were 16 records in the original corpus with 'v' immediately
                                    '   followed by a numeral; in every case, this turned out to be
                                    '   an inputter error for 'v.'; so this categorical change
                                    '   seems safe (all occurrences in database corrected manually)
                                    If sVCharacter$ = "v" Then
                                        If InStr("0123456789", Mid(sV$, iCtr% + 1, 1)) > 0 Then
                                            GoTo NSNRV_MustBeVolume
                                        End If
                                    End If
                                    
                                    Select Case Mid(sV$, iCtr% + 1, 1)
                                        Case " "
                                            If sVCharacter$ = "v" Then
                                                Select Case Mid(sV$, iCtr% + 2, 1)
                                                    Case "0" To "9"
                                                        ' as in: "v 5"
                                                        GoTo NSNRV_MustBeVolume
                                                    Case "."
                                                        Select Case Mid(sV$, iCtr% + 3, 1)
                                                            Case " "
                                                                ' as in: "v . 3"
                                                                If InStr("0123456789", Mid(sV$, iCtr% + 4, 1)) > 0 Then
                                                                    GoTo NSNRV_MustBeVolume
                                                                End If
                                                            Case "0" To "9"
                                                                ' as in: "v .3"
                                                                GoTo NSNRV_MustBeVolume
                                                        End Select
                                                End Select
                                            End If
                                            ' 'v' all by itself: it IS a roman numeral, we guess
                                            ' but if the following character is an arabic numeral, then it's not
                                            If InStr("0123456789.", Mid(sV$, iCtr% + 2, 1)) = 0 Then
                                                ' isolate the following word
                                                sJunk$ = Trim(NormString(Mid(sV$, iCtr% + 2)))
                                                iRc% = InStr(sJunk$, " ")
                                                If iRc% > 0 Then
                                                    sJunk$ = Mid(sJunk$, 1, iRc% - 1)
                                                End If
                                                sJunk$ = " " + sJunk$ + " "
                                                ' exclude if the *next* word is a word that means "number"
                                                If InStr(prvsSeriesNumIgnoredWords$, sJunk$) = 0 Then
NSNRV_FoundRomanNumeralMaybe:                        ' NOTE label in left margin
                                                    ' leave the thing alone
                                                Else ' it's not a roman numeral: kill it
                                                    sJunk$ = SafeStuff(sJunk$, iCtr%, 1, prvsSerNumCaptionSubstitute$)
                                                End If
                                            Else ' followed by numeral or full stop
NSNRV_MustBeVolume:                             ' NOTE label in left margin
                                                If NormalizeSeriesNumberNumeralInThisSegment(Mid(sV$, iCtr%)) Then
                                                    sV$ = SafeStuff(sV$, iCtr%, 1, prvsSerNumCaptionSubstitute$)
                                                    If Len(sV$) = 0 Then
                                                        Exit For
                                                    End If
                                                Else
                                                    Exit For
                                                End If
                                            End If
                                        'Case "a" To "z" ' clearly part of a word
                                        Case "."
                                            If sVCharacter$ = "V" Then
                                                ' this JUST MAY be a roman numeral V that JUST
                                                '   HAPPENS to have a full stop after it
                                                If Not NormalizeSeriesNumberRomanNumerals(sV$) Then
                                                    ' is the preceding character also a full stop?
                                                    If iCtr% > 1 Then
                                                        If Mid(sV$, iCtr% - 1, 1) = "." Then
                                                            GoTo NSNRV_Method2NextCharacter
                                                        End If
                                                    End If
                                                    ' maybe this "V." is the beginning of an
                                                    '   initialism? ...
                                                    If InStr("ABCDEFGHIJKLMNOPQRSTUVWXYZ", Mid(sV$, iCtr% + 2, 1)) > 0 Then
                                                        If Mid(sV$, iCtr% + 3, 1) <> "." Then
                                                            GoTo NSNRV_MustBeVolume
                                                        End If
                                                    End If
                                                    ' if either the preceding or following word is a
                                                    '   "caption" word, retain the "V"
                                                    sJunk2$ = Trim(Mid(sV$, iCtr% + 2))
                                                    sJunk$ = Trim(NormString(sJunk2$))
                                                    iRc% = InStr(sJunk$, " ")
                                                    If iRc% > 0 Then
                                                        sJunk$ = Mid(sJunk$, 1, iRc% - 1)
                                                    End If
                                                    sJunk$ = " " + sJunk$ + " "
                                                    ' exclude if either the *next* word or the preceding word mean "number" (we'll take
                                                    '   them out later, instead)
                                                    If InStr(prvsSeriesNumIgnoredWords$, sJunk$) = 0 Then
                                                        If iCtr% > 1 Then
RvwaTryPrecedingWord:                                           ' NOTE label in left margin
                                                            sJunk1$ = Trim(Mid(sV$, 1, iCtr% - 1))
                                                            sJunk$ = Trim(NormString(sJunk1$))
                                                            iRc% = Rat(sJunk$, " ")
                                                            If iRc% > 0 Then
                                                                sJunk$ = Mid(sJunk$, iRc% + 1)
                                                            End If
                                                            sJunk$ = " " + sJunk$ + " "
                                                            ' exclude if the *next* word is a word that means "number"
                                                            If InStr(prvsSeriesNumIgnoredWords$, sJunk$) = 0 Then
                                                                If Right(sJunk1$, 1) = "." Then
                                                                    If InStr("0123456789", Mid(sJunk1$, Len(sJunk1$) - 1, 1)) > 0 Then
                                                                        If InStr("0123456789", Mid(sJunk2$, 1, 1)) > 0 Then
                                                                            ' do nothing
                                                                        Else
                                                                            GoTo NSNRV_MustBeVolume
                                                                        End If
                                                                    Else
                                                                        GoTo NSNRV_MustBeVolume
                                                                    End If
                                                                Else
                                                                    GoTo NSNRV_MustBeVolume
                                                                End If
                                                            End If
                                                        End If
                                                    Else
                                                        ' the following word does NOT mean number
                                                        If iCtr% = 1 Then
                                                            GoTo NSNRV_MustBeVolume
                                                        End If
                                                        ' does the preceding word mean number:
                                                        GoTo RvwaTryPrecedingWord
                                                    End If
                                                'Else
                                                    ' Roman numerals are present--let's leave the "V." alone
                                                End If
                                            Else ' it's the lower-case form
                                                ' it's clearly a 'volume' abbreviation
                                                ' UNLESS it's preceded by the abbreviation "vol" in which
                                                '   case we're going to keep this 'v'
                                                ' cf: University of Iowa. Humanistic studies ; vol. v. no. 2
                                                sTrial$ = " " + Trim(NormString(Mid(sV$, 1, iCtr% - 1))) + " "
                                                If sTrial$ = " V " Or (Mid(sTrial$, 2, 1) = "V" And (InStr(prvsSeriesNumIgnoredWords1$, sTrial$) > 0 Or InStr(prvsSeriesNumIgnoredWords2$, sTrial$) > 0 Or InStr(prvsSeriesNumIgnoredWords3$, sTrial$) > 0 Or InStr(prvsSeriesNumIgnoredWords4$, sTrial$) > 0 Or InStr(prvsSeriesNumIgnoredWords5$, sTrial$) > 0)) Then
                                                    ' keep the V
                                                Else
                                                    GoTo NSNRV_MustBeVolume
                                                End If
                                            End If
                                        Case Else
                                            'bRejected = True
                                    End Select
                                Case iLenV% ' it's at the end
                                    If Mid(sV$, iLenV% - 1, 1) = " " Then
                                        GoTo NSNRV_FoundRomanNumeralMaybe
                                    'Else ' we're keeping the v
                                        'bRejected = True
                                    End If
                                Case Else ' somewhere in between
                                    If InStr(";.,({<[ ", Mid(sV$, iCtr% - 1, 1)) > 0 Then
                                        If sVCharacter$ = "V" Then
                                            If iCtr% > 2 Then
                                                If InStr("0123456789", Mid(sV$, iCtr% - 2, 1)) > 0 Then
                                                    If Mid(sV$, iCtr% + 1, 1) = " " Then
                                                        If InStr("0123456789", Mid(sV$, iCtr% + 2, 1)) > 0 Then
                                                            GoTo NSNRV_Method2NextCharacter
                                                        End If
                                                    End If
                                                End If
                                            End If
                                        End If
                                        GoTo NSNRV_StandardHandling
                                    ElseIf Mid(sV$, iCtr% - 1, 2) = "-v" Then
                                        ' remove also if hyphen plus lower-case 'v'
                                        GoTo NSNRV_StandardHandling
                                    End If
                                    ' else it's part of a word and we're keeping it
                            End Select
                        End If
NSNRV_Method2NextCharacter:
                    Next ' irc%
            End Select
            
        End If ' contains no 'v'
        
        If Not bTryVAlsoAsUppercase Then
            Exit Do
        ElseIf sVCharacter$ = "v" Then
            Exit Do
        End If
        sVCharacter$ = "v"
    Loop
    
    sV$ = Trim(sV$)
    
#If False Then
    ' 20071106: it's not clear that this is relevant any longer, so we'll
    '   comment it out until we understand it
    ' if we've removed the entire first alphabetic business from the
    '   original string, set the "first alphabetic encountered already" marker
    '   so we'll handle "series" correctly later on
    If InStr("0123456789", Mid(Trim(NormString(sV$)), 1, 1)) > 0 Then
        If InStr("0123456789", Mid(Trim(NormString(sOriginal$)), 1, 1)) = 0 Then
            bFirstAlphabetic = True
        End If
    End If
#End If

    NormalizeSeriesNumberRemoveV = sV$
    
End Function


Private Function NormalizeSeriesNumberRomanNumerals(ByVal sInV$) As Boolean

    ' perform a crude test for roman-numeral-ness
    ' NOTE that we do not test for the word 'v' by itself, because the
    '   appearance of this word is exactly why we're interested in
    '   knowing if there are any OTHER roman numerals here
        
    Dim sJunk$, sPiece$
    
    Dim iCtr%
        
    Dim bFound As Boolean
    
    Const sRomanString$ = "IVXLCDM"
    
    
    sJunk$ = Trim(NormString(sInV$))
    
    NormalizeSeriesNumberRomanNumerals = False
    
    Do
        GetNextPiece sJunk$, sPiece$, " "
        If sPiece$ <> "V" Then
            bFound = True
            For iCtr% = 1 To Len(sPiece$)
                If InStr(sRomanString$, Mid(sPiece$, iCtr%, 1)) = 0 Then
                    bFound = False
                    Exit Do
                End If
            Next ' ictr%
            If bFound Then
                NormalizeSeriesNumberRomanNumerals = True
                Exit Function
            End If
        End If
    Loop

End Function


Private Function NormalizeSeriesNumberNumeralInThisSegment(sString$) As Boolean

    Dim iRc%
    
    NormalizeSeriesNumberNumeralInThisSegment = False
    
    For iRc% = 1 To Len(sString$)
        If InStr("0123456789", Mid(sString$, iRc%, 1)) > 0 Then
            NormalizeSeriesNumberNumeralInThisSegment = True
            Exit Function
        End If
    Next ' irc%

    ' exiting with default value
    
End Function


Private Function NormalizeSeriesNumberAbbrevForNumber(ByVal sNorm$, ByVal sChar$) As String

    Dim iCtr%
    
    Dim bAngstrom As Boolean, bSuperscriptZero As Boolean
    
    
    If sChar$ = MarcSuperscript0 Then
        bSuperscriptZero = True
    ElseIf sChar$ = MarcAngstrom Then
        bAngstrom = True
    End If
    
    ' get out of here if the character doesn't appear at all
    If InStr(sNorm$, sChar$) = 0 Then
        NormalizeSeriesNumberAbbrevForNumber = sNorm$
        Exit Function
    End If
    
    For iCtr% = Len(sNorm$) To 1 Step -1
        If Mid(sNorm$, iCtr%, 1) = sChar$ Then
            If iCtr% > 1 Then
                Select Case Mid(sNorm$, iCtr% - 1, 1)
                    Case "N", "n"
                        sNorm$ = SafeStuff(sNorm$, iCtr% - 1, 2, prvsSerNumCaptionSubstitute$)
                    Case ".", ":"
                        If iCtr% > 2 Then
                            If InStr("nN", Mid(sNorm$, iCtr% - 2, 1)) > 0 Then
                                sNorm$ = SafeStuff(sNorm$, iCtr% - 2, 3, prvsSerNumCaptionSubstitute$)
                            Else
                                sNorm$ = SafeStuff(sNorm$, iCtr%, 1, NormString(Mid(sNorm$, iCtr%, 1)))
                            End If
                        Else
                            sNorm$ = SafeStuff(sNorm$, iCtr%, 1, NormString(Mid(sNorm$, iCtr%, 1)))
                        End If
                    Case "8"
                        ' if abbreviation for octavo, then remove the zero altogether
                        If bSuperscriptZero Then
                            sNorm$ = SafeStuff(sNorm$, iCtr%, 1, "")
                        Else
                            GoTo NSNAFN_NormalHandling
                        End If
                    Case Else
NSNAFN_NormalHandling:
                        ' do NOT do this conversion for superscript zero--it'll be handled later
                        If Mid(sNorm$, iCtr%, 1) <> MarcSuperscript0 Then
                            sNorm$ = SafeStuff(sNorm$, iCtr%, 1, NormString(Mid(sNorm$, iCtr%, 1)))
                        End If
                End Select
            Else
                ' bogus character is first character in the string: replace with its normalized self
                sNorm$ = SafeStuff(sNorm$, iCtr%, 1, NormString(Mid(sNorm$, iCtr%, 1)))
            End If
        End If
    Next ' ictr%
    
    NormalizeSeriesNumberAbbrevForNumber = sNorm$
    
End Function


Private Function NormalizeSeriesNumberLevel2(ByVal sSeriesSubfieldV$) As String

    ' simply replace each separate numeral group with a padded-out equivalent, and
    '   normalize the remainder without consideration
    
    Dim sOutput$, sChar$, sGroup$, sNorm$
    
    Dim iRc%
    
    
    sNorm$ = sSeriesSubfieldV$
    
    For iRc% = 1 To Len(sSeriesSubfieldV$)
        sChar$ = Mid(sSeriesSubfieldV$, iRc%, 1)
        If InStr("0123456789", sChar$) > 0 Then
            sGroup$ = sGroup$ + sChar$
        Else
            ' we've hit a non-numeral: deal with any previously-collected numerals
            If Len(sGroup$) > 0 Then
                Do While Mid(sGroup$, 1, 1) = "0"
                    sGroup$ = Mid(sGroup$, 2)
                    If Len(sGroup$) = 0 Then
                        Exit Do
                    End If
                Loop
                If Len(sGroup$) < prviSeriesNumMinimumInterestingLength% Then
                    sOutput$ = sOutput$ + " " + Right(String(prviSeriesNumMinimumInterestingLength%, "0") + sGroup$, prviSeriesNumMinimumInterestingLength%) + " "
                Else
                    sOutput$ = sOutput$ + " " + sGroup$
                End If
                sGroup$ = ""
            End If
            ' having done with any previously-collected numerals, add the
            '   non-numeral to the growing string
            sOutput$ = sOutput$ + sChar$
        End If
    Next ' irc%
    
    ' deal with any terminal set of numerals
    If Len(sGroup$) > 0 Then
        Do While Mid(sGroup$, 1, 1) = "0"
            sGroup$ = Mid(sGroup$, 2)
            If Len(sGroup$) = 0 Then
                Exit Do
            End If
        Loop
        If Len(sGroup$) < prviSeriesNumMinimumInterestingLength% Then
            sOutput$ = sOutput$ + " " + Right(String(prviSeriesNumMinimumInterestingLength%, "0") + sGroup$, prviSeriesNumMinimumInterestingLength%)
        Else
            sOutput$ = sOutput$ + " " + sGroup$
        End If
        sGroup$ = ""
    End If
    
    ' having adjusted the numerals to fixed lengths, normalize the alphabetic and
    '   other bits and return the result
    NormalizeSeriesNumberLevel2 = NormString(sOutput$)
    
End Function


Private Function NormalizeSeriesNumberLevel3(ByVal sSeriesSubfieldV$) As String

    ' level 2 normalization, but removing captions that precede the first
    '   numeral (if the $v contains numerics anywhere)
    
    Dim iRc%
    
    Dim bContainsNumeral As Boolean
    
    Dim sNorm$
    
    
    sNorm$ = sSeriesSubfieldV$
    
    
    If Not prvbHaveSeriesNumberingPunctuation Then
        NormalizeSeriesNumberSetConstants
    End If
        
    If InStr(sNorm$, "1") > 0 Or InStr(sNorm$, "2") > 0 Or InStr(sNorm$, "3") > 0 Or InStr(sNorm$, "4") > 0 Or InStr(sNorm$, "5") > 0 Or InStr(sNorm$, "6") > 0 Or InStr(sNorm$, "7") > 0 Or InStr(sNorm$, "8") > 0 Or InStr(sNorm$, "9") > 0 Or InStr(sNorm$, "0") > 0 Then
        bContainsNumeral = True
    Else
        sNorm$ = NormalizeSeriesNumberRemoveChapter(sNorm$)
    End If
    
    NormalizeSeriesNumberLevel3 = ""
    
    On Error GoTo 0

    ' perform level-2 normalization (stretch numerals to 8 [or whatever] places)
    sNorm$ = NormalizeSeriesNumberLevel2(sNorm$)
    
    If bContainsNumeral Then
        ' remove all leading non-numerics
        Do While InStr("0123456789", Mid(sNorm$, 1, 1)) = 0
            iRc% = InStr(sNorm$, " ")
            If iRc% = 0 Then
                Exit Do
            End If
            sNorm$ = Mid(sNorm$, iRc% + 1)
        Loop
    End If

    NormalizeSeriesNumberLevel3 = sNorm$

End Function


Private Sub NormalizeSeriesNumberSetConstants()

    prvsSerNumTheseBecomeSpacesFirst$ = "[](){}<>=:"
    prvsSerNumPunctuation$ = """" + "!#$%&'*+-.:;?@\^_`|~" + Chr(167) + Chr(168) + Chr(169) + Chr(197) + Chr(171) + Chr(174) + Chr(176) + Chr(183) + Chr(184) + Chr(185) + Chr(192) + Chr(194) + Chr(196) + Chr(197) + Chr(198)
    prvsSeriesNumIgnoredWords$ = prvsSeriesNumIgnoredWords1$ + prvsSeriesNumIgnoredWords2$ + prvsSeriesNumIgnoredWords3$ + prvsSeriesNumIgnoredWords4$ + prvsSeriesNumIgnoredWords5$
    prvsSeriesNumIgnoredWords$ = " V " + prvsSeriesNumIgnoredWords$ + prvsSeriesNumSingleLetterCaptions$
    prvsSerNumRemoveTheseIfFirst$ = prvsSerNumTheseBecomeSpacesFirst$ + prvsSerNumPunctuation$
    prvsSerNumCaptionSubstitute$ = " " + MarcDelimiter + " "
    prvsSerNumStringOfSuperscripts$ = MarcSuperscript0 + MarcSuperscript1 + MarcSuperscript2 + MarcSuperscript3 + MarcSuperscript4 + MarcSuperscript5 + MarcSuperscript6 + MarcSuperscript7 + MarcSuperscript8 + MarcSuperscript9
    prvsSerNumStringOfSubscripts$ = MarcSubscript0 + MarcSubscript1 + MarcSubscript2 + MarcSubscript3 + MarcSubscript4 + MarcSubscript5 + MarcSubscript6 + MarcSubscript7 + MarcSubscript8 + MarcSubscript9
    
    prvbHaveSeriesNumberingPunctuation = True

End Sub

Private Function NormalizeSeriesNumberRemoveChapter(ByVal sNorm$) As String

    Dim sJunk$
    
    ' remove abbreviations for 'Chapter' in
    '   the proper combination of case
    If UCase(Mid(sNorm$, 1, 3)) = "CH." Then
        sNorm$ = Trim(Mid(sNorm$, 4))
    ElseIf UCase(Mid(sNorm$, 1, 4)) = "KAP." Then
        sNorm$ = Trim(Mid(sNorm$, 5))
    Else
        ' remove words that mean 'chapter' in any mixture of case
        sJunk$ = UCase(sNorm$)
        If Mid(sJunk$, 1, 7) = "CHAPTER" Then
            sNorm$ = Trim(Mid(sNorm$, 8))
        ElseIf Mid(sJunk$, 1, 5) = "CHAP." Then
            sNorm$ = Trim(Mid(sNorm$, 6))
        ElseIf Mid(sJunk$, 1, 8) = "CHAPITRE" Then
            sNorm$ = Trim(Mid(sJunk$, 9))
        ElseIf Mid(sJunk$, 1, 7) = "KAPITEL" Then
            sNorm$ = Trim(Mid(sJunk$, 8))
        End If
    End If

    NormalizeSeriesNumberRemoveChapter = sNorm$
    
End Function
Private Function NormalizeSeriesNumberClause2b(ByRef sOutput$, ByVal sPiece$, ByVal sIntermediate$, ByVal sSegmentMarker$, ByVal sPreviousSegmentMarker$, ByVal bLastPiece As Boolean, ByVal bFirstAlphabetic As Boolean, ByVal bAsianLeapException As Boolean)

    Dim iCtr%, iLen%, iPrevLength%, iRc%
        
    Dim sChar$, sString$, sOriginalOutput$, sJunk$, sCopy$, sOutputCopy$
    
    Dim bNumeral As Boolean, bSeriesRemoved As Boolean
    Dim bUnrecognized As Boolean, bAddSeries As Boolean
    Dim bSegmented As Boolean, bSegmentedAtSlash As Boolean
    
    Static iUnrecognized%
    
    
    sOutputCopy$ = sOutput$
    
    iLen% = Len(sPiece$)
    
    iPrevLength% = Len(sOutput$)
    
    bFirstAlphabetic = False
    
    ' we know that the string contains at least one numeral somewhere; but
    '   before we enter the loop we need to know if the *first* character
    '   is a numeral, so we don't handle it inappropriately
    If InStr("0123456789", Mid(sPiece$, 1, 1)) > 0 Then
        bNumeral = True
    Else
        bNumeral = False
    End If
    
    If sSegmentMarker$ = "/" Or sPreviousSegmentMarker$ = "/" Then
        bSegmentedAtSlash = True
    End If
    
    ' attempt to handle ordinal numerals
    sPiece$ = NormalizeSeriesNumberSubstituteOrdinals(sPiece$, bLastPiece)
    
    ' divide the intermediately normalized string into alphabetic and numeric segments, and
    '   handle each segment
    For iCtr% = 1 To iLen%
        sChar$ = Mid(sPiece$, iCtr%, 1)
        If Len(sChar$) > 0 Then
            If sChar$ = " " Then
                If bNumeral Then
                    ' if we're in a numeric string, finish off the current one
                    '   and then we'll start a new one
                    bSegmented = True
                    NormalizeSeriesNumberHandleNumeral sOutput$, sString$
                    If iCtr% < iLen% Then
                        ' we have more to do: see what kind of thing follows the space
                        If InStr("0123456789", Mid(sPiece$, iCtr% + 1, 1)) > 0 Then
                            bNumeral = True
                        Else
                            bNumeral = False
                        End If
                    Else
                        ' we're all done: get outta town
                        Exit For
                    End If
                Else
                    ' the space is within an alphabeitic string: continue to accumulate
                    sString$ = sString$ + sChar$
                End If
                
            ElseIf bNumeral Then
            
                ' we've been working on a numeric string
                If InStr("0123456789", sChar$) > 0 Then
                    ' current character also numeral: contnue to accumulate
                    sString$ = sString$ + sChar$
                Else ' previous charcter is a numeral, current is a non-digit
                    ' handle the numeric string
                    bSegmented = True
                    NormalizeSeriesNumberHandleNumeral sOutput$, sString$
                    sString$ = sChar$
                    If iCtr% <= iLen% Then
                        If InStr("0123456789", sChar$) > 0 Then
                            bNumeral = True
                        Else
                            ' break was between numeral and following character: add blocking character
                            sString$ = "-" + sString$
                            bNumeral = False
                        End If
                    Else
                        If InStr("0123456789", sChar$) > 0 Then
                            sString$ = "-" + sString$
                        End If
                        Exit For
                    End If
                End If
            Else
                ' we've been working on an alphabetic string
                If InStr("0123456789", sChar$) = 0 Then
                    ' next character is also alphabetic
                    sString$ = sString$ + sChar$
                Else ' current char is numeral, previous wasn't
                    ' break between alphabetic and following numeral
                    bSegmented = True
                    If InStr("ABCDEFGHIJKLMNOPQRSTUVWXYZ", Right(sString$, 1)) > 0 Then
                        NormalizeSeriesNumberHandleText sOutput$, sString$ + "-", bUnrecognized, bSegmentedAtSlash, bSegmented, False, bSeriesRemoved, bAsianLeapException
                    Else
                        NormalizeSeriesNumberHandleText sOutput$, sString$, bUnrecognized, bSegmentedAtSlash, bSegmented, False, bSeriesRemoved, bAsianLeapException
                    End If
                    If bSeriesRemoved And Not bFirstAlphabetic Then
                        bAddSeries = True
                    End If
                    bFirstAlphabetic = True
                    sString$ = sChar$
                    If iCtr% <= iLen% Then
                        If InStr("0123456789", sChar$) > 0 Then
                            bNumeral = True
                        Else
                            ' break was between numeral and preceding character: add blocking char
                            sString$ = "-" + sString$
                            bNumeral = False
                        End If
                    Else
                        Exit For
                    End If
                End If
            End If
        End If
    Next ' ictr%
    
    ' handle the final 'word'
    If Len(sString$) > 0 Then
        If bNumeral Then
            NormalizeSeriesNumberHandleNumeral sOutput$, sString$
        Else
            If bLastPiece Then
                NormalizeSeriesNumberHandleText sOutput$, sString$, bUnrecognized, bSegmentedAtSlash, bSegmented, True, bSeriesRemoved, bAsianLeapException
            Else
                ' if the text came in the original business within slashes and we didn't divide it
                '   into pieces, then behave as if it's the last piece--normalize but keep everything
                If sSegmentMarker$ = "/" And sPreviousSegmentMarker$ = "/" And Not bSegmented Then ' And bLastPiece Then
                    ' this segment is an entire chunk, bounded in the origial series numbering
                    '   by slashes on both ends
                    NormalizeSeriesNumberHandleText sOutput$, sString$, bUnrecognized, bSegmentedAtSlash, bSegmented, True, bSeriesRemoved, bAsianLeapException
                Else
                    ' this segment does not come from a chunk bounded on both ends by slashes; or the source chunk contais
                    '   more than one segment
                    NormalizeSeriesNumberHandleText sOutput$, sString$, bUnrecognized, bSegmentedAtSlash, bSegmented, False, bSeriesRemoved, bAsianLeapException
                End If
            End If
            If bSeriesRemoved And Not bFirstAlphabetic Then
                bAddSeries = True
            End If
        End If
    End If
        
    
    If bAddSeries Then
        If InStr(Mid(sOutput$, iPrevLength% + 1), prvsSeriesNumSeriesReplacement$) = 0 Then
            If iPrevLength% = 0 Then
                sOutput$ = Trim(prvsSeriesNumSeriesReplacement$ + " " + sOutput$)
            Else
                If Len(sOutput$) > iPrevLength% Then
                    sOutput$ = SafeStuff(sOutput$, iPrevLength% + 2, 0, prvsSeriesNumSeriesReplacement$ + " ")
                Else
                    sOutput$ = sOutput$ + " " + prvsSeriesNumSeriesReplacement$
                End If
            End If
        End If
    End If

    ' if the segment ends with the standard series abbreviation and begins with a
    '   number and has in between a 'word' that usuall means "th" then
    '   put the 'ser' ahead of the number and remove the "th" word
    ' isolating again our numbering
    If Len(sOutputCopy$) = 0 Then ' the numbering up-to-the-segment-we-just-finished
        sCopy$ = sOutput$
    Else
        sCopy$ = Trim(Mid(sOutput$, Len(sOutputCopy$) + 1))
    End If
    iRc% = Rat(sCopy$, " ")
    If iRc% > 2 Then
        If InStr(prvsSeriesNumSeriesWords$, " " + Mid(sCopy$, iRc%) + " ") > 0 Then
            sCopy$ = Mid(sCopy$, 1, iRc%) + prvsSeriesNumSeriesReplacement$
            sJunk$ = Mid(sCopy$, 1, iRc% - 1)
            GoTo Nsn2bCheckForOthers
        End If
    End If
    If Right(sCopy$, 4) = " " + prvsSeriesNumSeriesReplacement$ Then
Nsn2bCheckForOthers:
        sJunk$ = Trim(Mid(sCopy$, 1, Len(sCopy$) - 4))
        iRc% = Rat(sJunk$, " ")
        If iRc% > 0 Then
            sCopy$ = Mid(sJunk$, iRc%) + " "
            sJunk$ = Mid(sJunk$, 1, iRc% - 1)
            If InStr(sJunk$, " ") = 0 Then
                If InStr("0123456789", Mid(sJunk$, 1, 1)) > 0 Then
                    If InStr(" A D E ", sCopy$) > 0 Then
                        If Mid(sJunk$, 3, 1) = "0" Then ' block this action if a year is involved!
                            sOutput$ = Trim(sOutputCopy$ + " " + Trim(prvsSeriesNumSeriesReplacement$) + " " + sJunk$)
                        End If
                    End If
                End If
            End If
        ElseIf InStr("0123456789", Mid(sJunk$, 1, 1)) > 0 Then
            If Mid(sJunk$, 3, 1) = "0" Then ' block this action if a year is involved!
                sOutput$ = Trim(sOutputCopy$ + " " + prvsSeriesNumSeriesReplacement$ + " " + sJunk$)
            End If
        'Else
            ' DON'T FLIP if NEW SER, for example
        End If
    End If

    
End Function


Private Sub NormalizeSeriesNumberHandleText(ByRef sOutputStringSoFar$, ByRef sWordOfInterest$, ByRef bUnrecognized As Boolean, bSegmentedAtSlash As Boolean, bSegmented As Boolean, bLastBit As Boolean, bSeriesRemoved As Boolean, bAsianLeapException As Boolean)

    ' we receive a potential series numbering caption (normalzied already)
    ' assume the prefix is bad
    
    ' todo this obviously needs to be more sophisticated: we'll have to throw away things that are
    '   recognizeably bad, and retain things that are recognizeably good, regardless of the
    '   way they are combined
    
    Dim sCopy$, sWord$, sNextWord$, sTest$, sOtherWords$, sReplacement$
    Dim sJunk$
    
    Dim iRc%
    
    Dim lAt As Long, lAt2 As Long
    
    Dim bSeries As Boolean, bHors As Boolean, bPreviousWordWasRemoved As Boolean
    
    sCopy$ = Trim(sWordOfInterest$)
    sWordOfInterest$ = ""
    
    If bLastBit Then
        ' this is the very last alphabetic string in the whole business: keep it (in a regular sort of way) no matter what
        sOutputStringSoFar$ = Trim(sOutputStringSoFar$ + " " + NormalizeSeriesNumberNonNumericString(sCopy$, bSegmentedAtSlash))
        Exit Sub
    Else
        ' a non-last bit
        If InStr(sCopy$, " ") = 0 And Not bSegmented Then
            ' the following business doesn't apply, however, to single-letter
            '   lumps that might be 'series': they're more likely just single letters
            If InStr(prvsSeriesNumSeriesWords$, " " + sCopy$ + " ") > 0 And Len(sCopy$) > 3 Then
                ' if the only thing in the segment is 'series' and it's not at the
                '   end of the string, then we're going to assume it's part of the
                '   PREVIOUS segment--which means we're going to insert the standard
                '   series replacement AHEAD of the last number in the string
                ' this is chiefly to fix things that have bad punctuation, such as:
                '   "2, ser., no. 8"
                iRc% = Rat(sOutputStringSoFar$, " ")
                If iRc% = 0 Then
                    sOutputStringSoFar$ = prvsSeriesNumSeriesReplacement$ + " " + sOutputStringSoFar$
                ElseIf InStr("0123456789", Mid(sOutputStringSoFar$, iRc% + 1, 1)) > 0 Then
                    sOutputStringSoFar$ = SafeStuff(sOutputStringSoFar$, iRc% + 1, 0, prvsSeriesNumSeriesReplacement$ + " ")
                Else
                    sOutputStringSoFar$ = sOutputStringSoFar$ + " " + prvsSeriesNumSeriesReplacement$
                End If
                bSeriesRemoved = False
                Exit Sub
            End If
        End If
    End If
    
    Do
        GetNextPiece sCopy$, sWord$, " "
        If sWord$ = MarcDelimiter Then
            ' see notes about this use of MyMarcRecord1.marcdelimiter in the remove-single-letter
            '   routines
            GoTo FsnsipgIgnoreTheWord
        Else
            bPreviousWordWasRemoved = False
        End If
        sTest$ = " " + sWord$ + " "
        ' the following will definitely NOT work--although the idea behind it--sometimes,
        '   we want to keep single letters--is a good one
        If InStr(prvsSeriesNumNewWords$, sTest$) > 0 Then
            sOtherWords$ = prvsSeriesNumSeriesWords$
            sReplacement$ = prvsSeriesNumNewSeriesReplacement$
NormalizeSeriesNumberingHandleTextNewSeries:
            If Len(sCopy$) = 0 Then
                ' this business of 'length=3' is needed to keep the 'N' in
                '   numberings such as: Bd. 2, Kapitel N, t.2 (bib 952695)
                ' and yet this causes a problem for "ser. n. 2", where we DO want
                '   to remove the 'N'
                If Len(sTest$) = 3 Then
                    'Debug.Print "Exiting because length of 3 "
                    ' single letter abbreviation: keep it after all (we've already removed the ones we want to remove)
                    GoTo FsnsipgKeepTheWord
                End If
                ' just N by itself: ignore it
                ' 20020607: the following MAY be what's wanted; the line after
                '   is the original text, which (because the test is backwards, and
                '   perhaps also because it uses the wrong variable) would ALWAYS
                '   be executed unless the word had one character
                ' NOTE that even when reversed in this manner, the test is going to
                '   continue to succeed (i.e., the result is going to be zero, which means
                '   that the left half will be true), because we haven't in the mean time
                '   changed the content of sTest, so it's still got the 'first'
                '   word in it, not the 'second' word
                If InStr(sOtherWords, sTest$) = 0 And Len(sTest$) <> 3 Then
                    If bSeries Then
                        bSeriesRemoved = True
                    End If
                    Exit Do
                End If
                ' 20020607: I think, however, that we need to get out of here now
                Exit Do
            End If ' above clause contains handling for LAST WORD IN THE SEGMENT
            
            ' this is handling for words that are NOT THE LAST word in the segment
            iRc% = InStr(sCopy$, " ")
            If iRc% = 0 Then
                sNextWord$ = " " + sCopy$ + " "
            Else
                sNextWord$ = " " + Mid(sCopy$, 1, iRc% - 1) + " "
            End If
            If InStr(sOtherWords$, sNextWord$) > 0 Then
FsnsipgHandleAsNewSeries:
                If iRc% > 0 Then
                    sCopy$ = Trim(Mid(sCopy$, iRc% + 1))
                Else
                    sCopy$ = ""
                End If
                sWord$ = sReplacement$
                GoTo FsnsipgKeepTheWord
            ' else we'll ignore the 'new' word and keep going
            End If
            If bSeries Then
                ' maybe the preceding word is 'hors' or its equivalent?
                bSeries = False
                sTest$ = Trim(sOutputStringSoFar$)
                iRc% = Rat(sTest$, " ")
                If iRc% > 0 Then
                    sTest$ = " " + Mid(sTest$, iRc% + 1) + " "
                Else
                    sTest$ = " " + sTest$ + " "
                End If
                If InStr(prvsSeriesNumHorsWords$, sTest$) > 0 Then
                    If iRc% > 0 Then
                        sOutputStringSoFar$ = Mid(sOutputStringSoFar$, 1, iRc% - 1)
                    Else
                        sOutputStringSoFar$ = ""
                    End If
                    sWord$ = prvsSeriesNumHorsSeriesReplacement$
                End If
                ' 20020313: if we remove the exception and go to KeepTheWord in all
                '   cases, we get "reihe" etc. included; if we replace the series word
                '   that's more than a single letter (3 characters, here) with a standard
                '   abbreviation, then we get "ser" either before or after the number,
                '   haphazardly.
                ' it seems best that we remove the 'series' word if it's not a single
                '   letter
                If Len(Trim(sWord$)) = 1 Then ' single-letter abbreviations
                    GoTo FsnsipgKeepTheWord
                End If
                ' otherwise, omit it
                bSeriesRemoved = True
            ElseIf bHors Then
                ' maybe the preceding word is 'hors' or its equivalent?
                bHors = False
                sTest$ = Trim(sOutputStringSoFar$)
                iRc% = Rat(sTest$, " ")
                If iRc% > 0 Then
                    sTest$ = " " + Mid(sTest$, iRc% + 1) + " "
                Else
                    sTest$ = " " + sTest$ + " "
                End If
                If InStr(prvsSeriesNumHorsWords$, sTest$) > 0 Then
                    If iRc% > 0 Then
                        sOutputStringSoFar$ = Mid(sOutputStringSoFar$, 1, iRc% - 1)
                    Else
                        sOutputStringSoFar$ = ""
                    End If
                    sWord$ = prvsSeriesNumHorsSeriesReplacement$
                End If
                ' moved 20020313 to OUTSIDE the preceding IF clause
                GoTo FsnsipgKeepTheWord
            Else ' must be 'New'
                GoTo FsnsipgKeepTheWord
            End If
        ElseIf InStr(prvsSeriesNumHorsWords$, sTest$) > 0 Then
            bHors = True
            sOtherWords$ = prvsSeriesNumSeriesWords$
            sReplacement$ = prvsSeriesNumHorsSeriesReplacement$
            GoTo NormalizeSeriesNumberingHandleTextNewSeries
        ElseIf InStr(prvsSeriesNumNewSeriesWords$, sTest$) > 0 Then
            sReplacement$ = prvsSeriesNumNewSeriesReplacement$
            iRc% = 0
            GoTo FsnsipgHandleAsNewSeries
        ElseIf InStr(prvsSeriesNumSeriesWords$, sTest$) > 0 Then
            bSeries = True
            sOtherWords$ = prvsSeriesNumNewWords$
            sReplacement$ = prvsSeriesNumNewSeriesReplacement$
            sJunk$ = Trim(sOutputStringSoFar$)
            If Len(sJunk$) > 0 Then
                ' if the rightmostword in the existing string is 'ganzen' or 'whole', then
                '   leave the word 'ser' where you found it
                lAt = Rat(sJunk$, " ")
                If lAt > 0 Then
                    sJunk$ = Mid(sJunk$, lAt + 1)
                End If
                ' we're using the stars here to prevent incorrect matches; I'm sure there
                '   are other ways to achieve the same kind of thing
                If InStr("*GANZ *WHOL", Mid("*" + Mid(sJunk$, 1, 4) + "****", 1, 5)) > 0 Then
                    GoTo FsnsipgKeepTheWord
                End If
                sJunk$ = Trim(sOutputStringSoFar$)
                ' if the 'series' word is otherwise between two alphas, then
                '   retain the standard abbreviation
                If InStr("0123456789", Right(sJunk$, 1)) = 0 Then
                    If Len(sCopy$) > 0 Then
                        ' alpha to the left
                        If InStr("0123456789", Mid(sCopy$, 1, 1)) = 0 Or bPreviousWordWasRemoved Then
                            ' alpha to the right, too
                            GoTo FsnsipgKeepTheWord
                        End If
                    End If
                End If
            End If
            
            GoTo NormalizeSeriesNumberingHandleTextNewSeries
        ElseIf InStr(prvsSeriesNumIgnoredWords$, sTest$) > 0 Then
            ' do nothing
            
            ' if the last word in the string is one of the two-part chinese, japanese or
            '   korean words that mean 'th', then set a flag so that the
            '   next time we come through here we can ignore the
            '   word immediately after the numbering, too
            If InStr(prvsSeriesNumCjkThWords$, sTest$) > 0 Then
                If Len(sCopy$) = 0 Then
                    bAsianLeapException = True
                End If
            End If
            
        Else
            If InStr(prvsSeriesNumCjkThWords$, sTest$) > 0 Then
                If Len(sCopy$) = 0 Then
                    bAsianLeapException = True
                    GoTo FsnsipgIgnoreTheWord
                End If
            End If
            If bAsianLeapException Then
                ' only do this for the *first* word in the string
                bAsianLeapException = False
                If InStr(prvsSeriesNumCjkIgnoredWords$, " " + NormString(sTest$) + " ") > 0 Then
                    GoTo FsnsipgIgnoreTheWord
                End If
            End If
            lAt = InStr(prvsSeriesNumSubstitutionString$, sTest$)
            If lAt > 0 And Not bSegmentedAtSlash Then
                lAt2 = InStr(Mid(prvsSeriesNumSubstitutionString$, lAt), "*")
                If lAt2 > 0 Then
                    sWord$ = Mid(prvsSeriesNumSubstitutionString$, lAt + lAt2, 50)
                    lAt = InStr(sWord$, " ")
                    If lAt > 0 Then
                        sWord$ = Mid(sWord$, 1, lAt - 1)
                    End If
                End If
            Else
                ' we're going to keep this word
                sWord$ = Trim(NormString(sWord$))
            End If
FsnsipgKeepTheWord:
            sOutputStringSoFar$ = Trim(sOutputStringSoFar$ + " " + sWord$)
        End If
        If False Then ' pseudo construction so we don't accidentally fall into this
FsnsipgIgnoreTheWord:
            bPreviousWordWasRemoved = True
        Else
            bPreviousWordWasRemoved = False
        End If
        If Len(sCopy$) = 0 Then
            Exit Do
        End If
    Loop
    
End Sub




Private Sub NormalizeSeriesNumberHandleNumeral(ByRef sOutputStringSoFar$, ByRef sWordOfInterest$)

    
    Select Case Len(sWordOfInterest$)
        Case Is < prviSeriesNumMinimumInterestingLength%
            sOutputStringSoFar$ = Trim(sOutputStringSoFar$ + " " + Right(String(prviSeriesNumMinimumInterestingLength%, "0") + sWordOfInterest$, prviSeriesNumMinimumInterestingLength%))
        Case Is = prviSeriesNumMinimumInterestingLength%
            sOutputStringSoFar$ = Trim(sOutputStringSoFar$ + " " + sWordOfInterest$)
        Case Else
            sOutputStringSoFar$ = Trim(sOutputStringSoFar$ + " " + sWordOfInterest$)
    End Select
    
    sWordOfInterest$ = ""
    
End Sub



Private Function NormalizeSeriesNumberSubstituteOrdinals(ByVal sIn$, Optional ByVal bLastPiece As Boolean = False) As String

    Dim sCopy$, sPiece$, sOut$, sRemainder$, sPieceSave$
    
    Dim iCtr%
    
    Dim bSingleLetterProblemPossible As Boolean, bChanged As Boolean
    
    
    sCopy$ = sIn$
    
    ' NOTE WELL that it is IMPOSSIBLE safely to extend the handling of ordinal numbers to
    '   those in non-English languages, notably Italian, French and Spanish. Here are
    '   some counter-examples:
    '   v. 28-28a
    '   reel 22, no. 14a
    ' however, we're going to attempt this in limited cases: where the previous or next word
    '   is a *series* word
    
    Do
        GetNextPiece sCopy$, sPiece$, " "
        If InStr("0123456789", Mid(sPiece$, 1, 1)) > 0 Then
            If Len(sCopy$) > 0 Then
                If Not NormalizeSeriesNumberIsNumeralPresent(sCopy$) And bLastPiece Then
                    bSingleLetterProblemPossible = True
                Else
                    bSingleLetterProblemPossible = False
                End If
            Else
                bSingleLetterProblemPossible = False
            End If
            ' is it a string of numerals followed by letters?
            If Len(sPiece$) > 1 Then
                ' find the dividing point between the numerals and the letters
                For iCtr% = 2 To Len(sPiece$)
                    If InStr("0123456789", Mid(sPiece$, iCtr%, 1)) = 0 Then
                        ' we're at the diving point
                        ' get the remaining text
                        sRemainder$ = " " + Trim(Mid(sPiece$, iCtr%)) + " "
                        ' the last numeral determines what the following
                        '   text may be
                        Select Case Mid(sPiece$, iCtr% - 1, 1)
                            Case "1"
                                If InStr(" ST TH ", sRemainder$) > 0 Then
                                    sPiece$ = Mid(sPiece$, 1, iCtr% - 1)
                                ElseIf sRemainder$ = " RE ERE " Then
                                    If NormalizeSeriesNumberSubstituteOrdinalsSeriesAdjacent(sOut$, sCopy$) Then
                                        sPiece$ = Mid(sPiece$, 1, iCtr% - 1)
                                    End If
                                ElseIf InStr(" A O E ", sRemainder$) > 0 Then
                                    If Not bSingleLetterProblemPossible Then
                                        If NormalizeSeriesNumberSubstituteOrdinalsSeriesAdjacent(sOut$, sCopy$) Then
                                            sPiece$ = Mid(sPiece$, 1, iCtr% - 1)
                                        End If
                                    End If
                                End If
                            Case "2"
                                'If InStr(" ND TH A O E ME D ", " " + sRemainder$ + " ") > 0 Then
                                If InStr(" ND TH ", sRemainder$) > 0 Then
                                    sPiece$ = Mid(sPiece$, 1, iCtr% - 1)
                                ElseIf InStr(" ME EME ", sRemainder$) > 0 Then
                                    If NormalizeSeriesNumberSubstituteOrdinalsSeriesAdjacent(sOut$, sCopy$) Then
                                        sPiece$ = Mid(sPiece$, 1, iCtr% - 1)
                                    End If
                                ElseIf sRemainder$ = " D " Then
                                    If NormalizeSeriesNumberSubstituteOrdinalsSeriesAdjacent(sOut$, sCopy$) Then
                                        sPiece$ = Mid(sPiece$, 1, iCtr% - 1)
                                    End If
                                ElseIf InStr(" A D E O ", sRemainder$) > 0 Then
                                    If Not bSingleLetterProblemPossible Then
                                        If NormalizeSeriesNumberSubstituteOrdinalsSeriesAdjacent(sOut$, sCopy$) Then
                                            sPiece$ = Mid(sPiece$, 1, iCtr% - 1)
                                        End If
                                    End If
                                End If
                            Case "3"
                                'If InStr(" RD TH D A O E ME ", " " + sRemainder$ + " ") > 0 Then
                                If InStr(" RD TH ", sRemainder$) > 0 Then
                                    sPiece$ = Mid(sPiece$, 1, iCtr% - 1)
                                ElseIf InStr(" ME EME ", sRemainder$) > 0 Then
                                    If NormalizeSeriesNumberSubstituteOrdinalsSeriesAdjacent(sOut$, sCopy$) Then
                                        sPiece$ = Mid(sPiece$, 1, iCtr% - 1)
                                    End If
                                ElseIf sRemainder$ = " D " Then
                                    If NormalizeSeriesNumberSubstituteOrdinalsSeriesAdjacent(sOut$, sCopy$) Then
                                        sPiece$ = Mid(sPiece$, 1, iCtr% - 1)
                                    End If
                                ElseIf InStr(" A E O ", sRemainder$) > 0 Then
                                    If Not bSingleLetterProblemPossible Then
                                        If NormalizeSeriesNumberSubstituteOrdinalsSeriesAdjacent(sOut$, sCopy$) Then
                                            sPiece$ = Mid(sPiece$, 1, iCtr% - 1)
                                        End If
                                    End If
                                End If
                            Case "4" To "9", "0"
                                'If InStr(" TH A O E ME ", " " + sRemainder$ + " ") > 0 Then
                                If InStr(" TH ", sRemainder$) > 0 Then
                                    sPiece$ = Mid(sPiece$, 1, iCtr% - 1)
                                ElseIf InStr(" ME EME ", sRemainder$) > 0 Then
                                    If NormalizeSeriesNumberSubstituteOrdinalsSeriesAdjacent(sOut$, sCopy$) Then
                                        sPiece$ = Mid(sPiece$, 1, iCtr% - 1)
                                    End If
                                ElseIf InStr(" A O E ", sRemainder$) > 0 Then
                                    If Not bSingleLetterProblemPossible Then
                                        If NormalizeSeriesNumberSubstituteOrdinalsSeriesAdjacent(sOut$, sCopy$) Then
                                            sPiece$ = Mid(sPiece$, 1, iCtr% - 1)
                                        End If
                                    End If
                                End If
                        End Select
                        Exit For
                    End If
                Next ' ictr%
            End If
        End If
SfoNextPiece:
        'If sPieceSave$ <> sPiece$ Then
            'bChanged = True
        'End If
        sOut$ = sOut$ + " " + sPiece$
        If Len(sCopy$) = 0 Then
            Exit Do
        End If
    Loop
    
    NormalizeSeriesNumberSubstituteOrdinals = Trim(sOut$)
    
End Function


Private Function NormalizeSeriesNumberSubstituteOrdinalsSeriesAdjacent(ByVal sLeft$, ByVal sRight$) As Boolean

    Dim iRc%
    
    Dim sWord$
    
    ' todo: additional 'session' and similar words could be added to the 2 lists here
    ' todo: same with 'congress' words and 'year' words; perhaps in fact we should just have another list of
    '   constants?
    
    NormalizeSeriesNumberSubstituteOrdinalsSeriesAdjacent = False
    
    If Len(sLeft$) > 0 Then
        sWord$ = Trim(sLeft$)
        iRc% = Rat(sWord$, " ")
        If iRc% > 0 Then
            sWord$ = Mid(sWord$, iRc% + 1)
        End If
        If Len(sWord$) > 1 Then
            If InStr(prvsSeriesNumSeriesWords$, " " + sWord$ + " ") > 0 Or sWord$ = "AN" Or sWord$ = "ANNEE" Or sWord$ = "SESSION" Or sWord$ = "SESS" Or sWord$ = "CONGRES" Or sWord$ = "CONGRESS" Or sWord$ = "CONG" Then
                NormalizeSeriesNumberSubstituteOrdinalsSeriesAdjacent = True
            End If
        End If
    End If
    
    If Len(sRight$) > 0 Then
        sWord$ = Trim(sRight$)
        iRc% = InStr(sWord$, " ")
        If iRc% > 0 Then
            sWord$ = Mid(sWord$, 1, iRc% - 1)
        End If
        If Len(sWord$) > 1 Then
            If InStr(prvsSeriesNumSeriesWords$, " " + sWord$ + " ") > 0 Or sWord$ = "AN" Or sWord$ = "ANNEE" Or sWord$ = "SESSION" Or sWord$ = "SESS" Or sWord$ = "CONGRES" Or sWord$ = "CONGRESS" Or sWord$ = "CONG" Then
                NormalizeSeriesNumberSubstituteOrdinalsSeriesAdjacent = True
            End If
        End If
    End If
    
End Function



Public Sub FldInsertSubfieldH(ByVal sSubfieldHText$)

    ' 20071217: created from routine in a loader program, to cover a situation
    '   that occurs with some regularity: need to add $h to an existing record,
    '   adjusting punctuation to suit
    
    Dim iRc%
    
    Dim sExistingSubfield$, sPunctuation$
    
    Dim bLastSfd As Boolean
    
    
    If Not SfdFindFirst("h") Then
        
        Select Case FldTag
            Case "245"
                If Not SfdFindFirst("b") Then
                    SfdFindFirst ("c")
                End If
                If SfdWasFound Then
                    ' we'll add $h after the subfield that precedes $b or $c
                    SfdMovePrev
                    bLastSfd = False
                Else
                    ' we'll add $h after the last subfield (probably $a, maybe $n or $p)
                    SfdMoveLast
                    bLastSfd = True
                End If
FISH_ContinueWithInsertion:
                ' we need to strip terminal punctuation from
                '   this field
                sExistingSubfield$ = SfdText
                Do While Len(sExistingSubfield$) > 0 ' this is Unicode-safe
                    If InStr("., /:;=", Right(sExistingSubfield$, 1)) > 0 Then
                        sPunctuation$ = Right(sExistingSubfield$, 1) + sPunctuation$
                        sExistingSubfield$ = Mid(sExistingSubfield$, 1, Len(sExistingSubfield$) - 1)
                    Else
                        Exit Do
                    End If
                Loop
                If bLastSfd And Len(sPunctuation$) = 0 Then
                    sPunctuation$ = "."
                End If
                SfdText = sExistingSubfield$
                If Mid(sSubfieldHText$, 1, 1) <> "[" Then
                    sSubfieldHText$ = "[" + sSubfieldHText$
                End If
                If InStr(sSubfieldHText$, "]") = 0 Then
                    sSubfieldHText$ = sSubfieldHText$ + "]"
                End If
                If Len(sPunctuation$) > 0 Then
                    iRc% = Rat(sSubfieldHText$, "]")
                    If iRc% > 0 Then ' it surely must be!
                        SfdInsertAfter "h", Mid(sSubfieldHText$, 1, iRc%) + sPunctuation$
                    Else
                        SfdInsertAfter "h", sSubfieldHText$ + sPunctuation$
                    End If
                Else
                    SfdInsertAfter "h", sSubfieldHText$
                End If
                
            Case Else
            
                ' unless specifically provided for above, we'll add the
                '   $h at the end of the field
                SfdMoveLast
                GoTo FISH_ContinueWithInsertion
                
        End Select ' by tag
        
    End If ' is $h already present?
    
End Sub

Public Function IsThisARomanNumeral(ByVal sPotentialRomanNumeral$) As Boolean

    Dim lPtr As Long, lCurrent As Long, lPrevious As Long, lValue As Long

    Dim sCopy$, sM$, sCAdd$, sCSub$, sXAdd$, sXSub$, sIAdd$, sISub$
    
    ' assume that what we have is NOT a roman numeral
    IsThisARomanNumeral = False
    
    ' here's the model: convert the putative roman numeral into its numeric
    '   equivalent, and then convert the numeric equivalent back into all
    '   possible roman equivalents
    ' if none of the roman equivalents matches the original string, then we don't
    '   have a roman numeral; else we do
    
    lValue = RomanNumberValue(NormString(sPotentialRomanNumeral$))
        
    ' most optimistic case: a "standard" roman numeral
    ' generate all of the "standard" equivalents
    sM$ = IsThisARomanNumeral1000(lValue)
    sCSub$ = IsThisARomanNumeral100Sub(lValue)
    sXSub$ = IsThisARomanNumeral10Sub(lValue)
    sISub$ = IsThisARomanNumeral1Sub(lValue)
    
    If sM$ + sCSub$ + sXSub$ + sISub$ = sPotentialRomanNumeral$ Then
        IsThisARomanNumeral = True
        Exit Function
    End If
        
    ' generate the remaining possibilities
    sCAdd$ = IsThisARomanNumeral100Add(lValue)
    sXAdd$ = IsThisARomanNumeral10Add(lValue)
    sIAdd$ = IsThisARomanNumeral1Add(lValue)
    
    ' test the remaining possibilities
    
    If sM$ + sCSub$ + sXSub$ + sIAdd$ = sPotentialRomanNumeral$ Then
        IsThisARomanNumeral = True
        Exit Function
    End If
    If sM$ + sCSub$ + sXAdd$ + sISub$ = sPotentialRomanNumeral$ Then
        IsThisARomanNumeral = True
        Exit Function
    End If
    If sM$ + sCSub$ + sXAdd$ + sIAdd$ = sPotentialRomanNumeral$ Then
        IsThisARomanNumeral = True
        Exit Function
    End If
    
    
    If sM$ + sCAdd$ + sXSub$ + sISub$ = sPotentialRomanNumeral$ Then
        IsThisARomanNumeral = True
        Exit Function
    End If
    If sM$ + sCAdd$ + sXSub$ + sIAdd$ = sPotentialRomanNumeral$ Then
        IsThisARomanNumeral = True
        Exit Function
    End If
    If sM$ + sCAdd$ + sXAdd$ + sISub$ = sPotentialRomanNumeral$ Then
        IsThisARomanNumeral = True
        Exit Function
    End If
    If sM$ + sCAdd$ + sXAdd$ + sIAdd$ = sPotentialRomanNumeral$ Then
        IsThisARomanNumeral = True
        Exit Function
    End If
    
End Function


Private Function IsThisARomanNumeral1000(ByVal lNumber As Long) As String

    IsThisARomanNumeral1000 = String(Int(lNumber / 1000), "M")
    
End Function

Private Function IsThisARomanNumeral100Sub(ByVal lNumber As Long) As String

    Dim iHundreds%
    
    iHundreds% = Int((lNumber Mod 1000) / 100)
    
    Select Case iHundreds%
        Case 9
            IsThisARomanNumeral100Sub = "CM"
        Case Is > 4
            IsThisARomanNumeral100Sub = Mid("DCCC", 1, iHundreds% - 4)
        Case 4
            IsThisARomanNumeral100Sub = "CD"
        Case Else
            IsThisARomanNumeral100Sub = Mid("CCC", 1, iHundreds%)
    End Select
    
End Function

Private Function IsThisARomanNumeral100Add(ByVal lNumber As Long) As String

    Dim iHundreds%
    
    iHundreds% = Int((lNumber Mod 1000) / 100)
    
    If iHundreds% > 4 Then
        IsThisARomanNumeral100Add = Mid("DCCCC", 1, iHundreds% - 4)
    Else
        IsThisARomanNumeral100Add = Mid("CCCC", 1, iHundreds%)
    End If
    
End Function

Private Function IsThisARomanNumeral10Sub(ByVal lNumber As Long) As String

    Dim iTens%
    
    iTens% = Int((lNumber Mod 100) / 10)
    
    Select Case iTens%
        Case 9
            IsThisARomanNumeral10Sub = "XC"
        Case Is > 4
            IsThisARomanNumeral10Sub = Mid("LXXX", 1, iTens% - 4)
        Case 4
            IsThisARomanNumeral10Sub = "XL"
        Case Else
            IsThisARomanNumeral10Sub = Mid("XXX", 1, iTens%)
    End Select
    
End Function

Private Function IsThisARomanNumeral10Add(ByVal lNumber As Long) As String

    Dim iTens%
    
    iTens% = Int((lNumber Mod 100) / 10)
    
    If iTens% > 4 Then
        IsThisARomanNumeral10Add = Mid("LXXXX", 1, iTens% - 4)
    Else
        IsThisARomanNumeral10Add = Mid("XXXX", 1, iTens%)
    End If
    
End Function

Private Function IsThisARomanNumeral1Sub(ByVal lNumber As Long) As String

    Dim iUnits%
    
    iUnits% = lNumber Mod 10
    
    Select Case iUnits%
        Case 9
            IsThisARomanNumeral1Sub = "IX"
        Case Is > 4
            IsThisARomanNumeral1Sub = Mid("VIII", 1, iUnits% - 4)
        Case 4
            IsThisARomanNumeral1Sub = "IV"
        Case Else
            IsThisARomanNumeral1Sub = Mid("III", 1, iUnits%)
    End Select
    
End Function

Private Function IsThisARomanNumeral1Add(ByVal lNumber As Long) As String

    Dim iUnits%
    
    iUnits% = lNumber Mod 10
    
    If iUnits% = 4 Then
        IsThisARomanNumeral1Add = Mid("VIIII", 1, iUnits% - 4)
    Else
        IsThisARomanNumeral1Add = Mid("IIII", 1, iUnits%)
    End If
    
End Function

Public Function RemoveLeadingCharacter(ByRef sOriginalString$, ByRef sCharacterToRemove$) As String

    Dim lPtr As Long, lTextLen As Long, lCharacterLen As Long, lTrimThroughHere As Long
    
    
    lTextLen = Len(sOriginalString$)
    lCharacterLen = Len(sCharacterToRemove$)
    
    lPtr = 1
    Do
        If Mid(sOriginalString$, lPtr, lCharacterLen) = sCharacterToRemove$ Then
            lTrimThroughHere = lPtr + lCharacterLen
        Else
            Exit Do
        End If
        lPtr = lPtr + lCharacterLen
        If lPtr > lTextLen Then
            Exit Do
        End If
    Loop
        
    If lTrimThroughHere > 0 Then
        RemoveLeadingCharacter = Mid(sOriginalString$, lTrimThroughHere)
    Else
        RemoveLeadingCharacter = sOriginalString$
    End If
    
End Function

Public Function RemoveTrailingCharacter(ByRef sOriginalString$, ByRef sCharacterToRemove$) As String


    Dim lPtr As Long, lTextLen As Long, lCharacterLen As Long, lTrimThroughHere As Long
    
    
    lCharacterLen = Len(sCharacterToRemove$)
    
    lPtr = (Len(sOriginalString$) - lCharacterLen) + 1
    
    If lPtr < 1 Then
        RemoveTrailingCharacter = sOriginalString$
        Exit Function
    End If
    
    Do
        If Mid(sOriginalString$, lPtr, lCharacterLen) = sCharacterToRemove$ Then
            lTrimThroughHere = lPtr
        Else
            Exit Do
        End If
        lPtr = lPtr - lCharacterLen
        If lPtr < 1 Then
            Exit Do
        End If
    Loop
        
    If lTrimThroughHere > 0 Then
        RemoveTrailingCharacter = Mid(sOriginalString$, 1, lTrimThroughHere - 1)
    Else
        RemoveTrailingCharacter = sOriginalString$
    End If

End Function

Public Function RomanNumberValue(ByVal sNormalizedPutativeRomanNumeral$) As Long

    Dim lPtr As Long, lCurrent As Long, lPrevious As Long, lValue As Long

    ' convert the roman numeral to a value using our standard model
    For lPtr = Len(sNormalizedPutativeRomanNumeral$) To 1 Step -1
        Select Case Mid(sNormalizedPutativeRomanNumeral$, lPtr, 1)
            Case " "
                GoTo CTNTV_NextRomanCharacter ' hope for the best!
            Case "I"
                lCurrent = 1
            Case "V"
                lCurrent = 5
            Case "X"
                lCurrent = 10
            Case "L"
                lCurrent = 50
            Case "C"
                lCurrent = 100
            Case "D"
                lCurrent = 500
            Case "M"
                lCurrent = 1000
            Case Else
                Exit Function ' with False return value
        End Select
        If lCurrent >= lPrevious Then
            lValue = lValue + lCurrent
            lPrevious = lCurrent
        Else
            lValue = lValue - lCurrent
        End If
CTNTV_NextRomanCharacter:
    Next ' lptr

    RomanNumberValue = lValue
    
    
End Function

Public Function XmlRecordOutGenreSection(ByRef sOut$, ByVal sCrlfTabTab$) As String

    ' genre section; repeat section for each relevant thingie
    ' biggest lump: based on fixed fields
    Select Case MarcRecordFormat
        Case "B"
            If InStr(Get008Value(24, 4), "a") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "abstract or summary")
            End If
            If InStr(Get008Value(24, 4), "b") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "bibliography")
            End If
            If InStr(Get008Value(24, 4), "c") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "catalog")
            End If
            If InStr(Get008Value(24, 4), "d") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "dictionary")
            End If
            If InStr(Get008Value(24, 4), "e") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "encyclopedia")
            End If
            If InStr(Get008Value(24, 4), "f") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "handbook")
            End If
            If InStr(Get008Value(24, 4), "g") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "legal article")
            End If
            If InStr(Get008Value(24, 4), "i") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "index")
            End If
            If InStr(Get008Value(24, 4), "j") > 0 Then ' not defined for serials (!)
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "patent")
            End If
            If InStr(Get008Value(24, 4), "k") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "discography")
            End If
            If InStr(Get008Value(24, 4), "l") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "legislation")
            End If
            If InStr(Get008Value(24, 4), "m") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "theses")
            End If
            If InStr(Get008Value(24, 4), "n") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "survey of literature")
            End If
            If InStr(Get008Value(24, 4), "o") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "review")
            End If
            If InStr(Get008Value(24, 4), "p") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "programmed text")
            End If
            If InStr(Get008Value(24, 4), "q") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "filmography")
            End If
            If InStr(Get008Value(24, 4), "r") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "directory")
            End If
            If InStr(Get008Value(24, 4), "s") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "statistics")
            End If
            If InStr(Get008Value(24, 4), "t") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "technical report")
            End If
            If InStr(Get008Value(24, 4), "v") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "legal case and case notes")
            End If
            If InStr(Get008Value(24, 4), "w") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "law report or digest")
            End If
            If InStr(Get008Value(24, 4), "z") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "treaty")
            End If
            If Get008Value(29, 1) = "1" Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "conference publication")
            End If
            If Get008Value(30, 1) = "1" Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "festschrift")
            End If
            Select Case Get008Value(33, 1)
                Case "1"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "fiction")
                Case "c"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "comic strip")
                Case "d"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "drama")
                Case "e"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "essay")
                Case "f"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "novel")
                Case "h"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "humor, satire")
                Case "i"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "letter")
                Case "j"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "short story")
                Case "p"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "poetry")
                Case "s"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "speech")
            End Select
            If InStr("abcd", Get008Value(34, 1)) > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "biography")
            End If
        Case "D"
            Select Case Get008Value(26, 1)
                Case "a"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "numeric data")
                Case "e"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "database")
                Case "f"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "font")
                Case "g"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "game")
                Case "h"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "sound")
            End Select
        Case "F"
            ' following is for VM expecially
            Select Case Get008Value(33, 1)
                Case "a"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "art original")
                Case "b"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "kit/graphic")
                Case "c"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "art reproduction")
                Case "d"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "diorama")
                Case "f"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "filmstrip")
                Case "i"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "picture")
                Case "k"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "graphic")
                Case "l"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "technical drawing")
                Case "m"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "motion picture")
                Case "n"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "chart")
                Case "o"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "flash card")
                Case "p"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "microscope slide")
                Case "q"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "model")
                Case "r"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "realia")
                Case "s"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "slide")
                Case "t"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "transparency")
                Case "v"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "videorecording")
                Case "w"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "toy")
            End Select
        Case "M"
            If InStr(Get008Value(30, 2), "a") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "autobiography")
            End If
            If InStr(Get008Value(30, 2), "b") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "biography")
            End If
            If InStr(Get008Value(30, 2), "c") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "conference publication")
            End If
            If InStr(Get008Value(30, 2), "d") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "drama")
            End If
            If InStr(Get008Value(30, 2), "e") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "essay")
            End If
            If InStr(Get008Value(30, 2), "f") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "fiction")
            End If
            If InStr(Get008Value(30, 2), "g") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "reporting")
            End If
            If InStr(Get008Value(30, 2), "h") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "history")
            End If
            If InStr(Get008Value(30, 2), "k") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "humor, satire")
            End If
            If InStr(Get008Value(30, 2), "i") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "instruction")
            End If
            If InStr(Get008Value(30, 2), "j") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "language instruction")
            End If
            If InStr(Get008Value(30, 2), "m") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "memoir")
            End If
            If InStr(Get008Value(30, 2), "o") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "folktale")
            End If
            If InStr(Get008Value(30, 2), "p") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "poetry")
            End If
            If InStr(Get008Value(30, 2), "r") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "rehearsal")
            End If
            If InStr(Get008Value(30, 2), "s") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "speech")
            End If
            If InStr(Get008Value(30, 2), "t") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "interview")
            End If
        Case "P"
            Select Case Get008Value(25, 1)
                Case "a", "b", "c"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "map")
                Case "d"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "globe")
                Case "e"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "atlas")
                Case Else
                    FldMoveTop
                    Do While FldFindNext("007")
                        Select Case Mid(FldText, 1, 2)
                            Case "ad"
                                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "atlas")
                            Case "aj"
                                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "map")
                            Case "aq"
                                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "model")
                            Case "ar"
                                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "remote sensing image")
                        End Select
                    Loop
            End Select
        Case "S"
            Select Case Get008Value(21, 1)
                Case "d"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "database")
                Case "l"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "looseleaf")
                Case "m"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "series")
                Case "n"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "newspaper")
                Case "p"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "periodical")
                Case "w"
                    sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "web site")
            End Select
            If InStr(Get008Value(24, 4), "a") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "abstract or summary")
            End If
            If InStr(Get008Value(24, 4), "b") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "bibliography")
            End If
            If InStr(Get008Value(24, 4), "c") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "catalog")
            End If
            If InStr(Get008Value(24, 4), "d") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "dictionary")
            End If
            If InStr(Get008Value(24, 4), "e") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "encyclopedia")
            End If
            If InStr(Get008Value(24, 4), "f") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "handbook")
            End If
            If InStr(Get008Value(24, 4), "g") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "legal article")
            End If
            If InStr(Get008Value(24, 4), "i") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "index")
            End If
            If InStr(Get008Value(24, 4), "k") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "discography")
            End If
            If InStr(Get008Value(24, 4), "l") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "legislation")
            End If
            If InStr(Get008Value(24, 4), "m") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "theses")
            End If
            If InStr(Get008Value(24, 4), "n") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "survey of literature")
            End If
            If InStr(Get008Value(24, 4), "o") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "review")
            End If
            If InStr(Get008Value(24, 4), "p") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "programmed text")
            End If
            If InStr(Get008Value(24, 4), "q") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "filmography")
            End If
            If InStr(Get008Value(24, 4), "r") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "directory")
            End If
            If InStr(Get008Value(24, 4), "s") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "statistics")
            End If
            If InStr(Get008Value(24, 4), "t") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "technical report")
            End If
            If InStr(Get008Value(24, 4), "v") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "legal case and case notes")
            End If
            If InStr(Get008Value(24, 4), "w") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "law report or digest")
            End If
            If InStr(Get008Value(24, 4), "z") > 0 Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "treaty")
            End If
            If Get008Value(29, 1) = "1" Then
                sOut$ = sOut$ + sCrlfTabTab + XmlTags("genre authority=" + AddQuotes("marcgt"), "conference publication")
            End If
        Case "U"
            ' none defined
    End Select

    XmlRecordOutGenreSection = sOut$
    
End Function

Public Function FindDateInString(ByVal sText$) As String

    Dim iCtr%, iLen%, iFirstNumeral%
    
    ' if the submitted string contains a year-like 4-digit numeric string, return that
    ' if not, return the string starting at the first numeral
    ' if not, return the string as given
    
    iLen% = Len(sText$) - 3
    If iLen% > 0 Then
        For iCtr% = 1 To iLen%
            If InStr("123456789", Mid(sText$, iCtr%, 1)) > 0 Then
                If iFirstNumeral% = 0 Then
                    iFirstNumeral% = iCtr%
                End If
                If InStr("0123456789", Mid(sText$, iCtr% + 1, 1)) > 0 Then
                    If InStr("0123456789", Mid(sText$, iCtr% + 2, 1)) > 0 Then
                        If InStr("0123456789", Mid(sText$, iCtr% + 3, 1)) > 0 Then
                            ' we are at the first numeral of a string of at least four numerals
                            ' given that we're being fed personal name subfield $d, we have almost
                            '   certainly pounced on the year portion; so return the string
                            '   beginning at this bit
                            FindDateInString = Mid(sText$, iCtr%)
                            Exit Function
                        End If
                    End If
                End If
            End If
        Next ' ictr%
        ' if we found any numeral, return with that much
        If iFirstNumeral% > 0 Then
            FindDateInString = Mid(sText$, iFirstNumeral%)
        End If
    End If
    
    FindDateInString = sText$
        
    
End Function

Public Function TranslateUtf82MarcShortCodeToLong(ByVal sShortCharacterSetCode$) As String

    Select Case sShortCharacterSetCode$
        Case CHARACTERTABLE_Basic$
            TranslateUtf82MarcShortCodeToLong = CHARACTERSET_CODES_FOR_880_BasicAsG0$
        Case CHARACTERTABLE_3Greeks$
            TranslateUtf82MarcShortCodeToLong = "s"
        Case CHARACTERTABLE_Subscript$
            TranslateUtf82MarcShortCodeToLong = "b"
        Case CHARACTERTABLE_Superscript$
            TranslateUtf82MarcShortCodeToLong = "p"
        Case CHARACTERTABLE_Hebrew$
            TranslateUtf82MarcShortCodeToLong = CHARACTERSET_CODES_FOR_880_HebrewAsG0$
        Case CHARACTERTABLE_BasicCyrillic$
            TranslateUtf82MarcShortCodeToLong = CHARACTERSET_CODES_FOR_880_BasicCyrillicAsG0$
        Case CHARACTERTABLE_BasicArabic$
            TranslateUtf82MarcShortCodeToLong = CHARACTERSET_CODES_FOR_880_BasicArabicAsG0$
        Case CHARACTERTABLE_Greek$
            TranslateUtf82MarcShortCodeToLong = CHARACTERSET_CODES_FOR_880_GreekAsG0$
        Case CHARACTERTABLE_CJK$
            TranslateUtf82MarcShortCodeToLong = CHARACTERSET_CODES_FOR_880_CJKAsG0$
        Case CHARACTERTABLE_ExtendedCyrillic$
            ' we always map this to G1, no matter what
            TranslateUtf82MarcShortCodeToLong = CHARACTERSET_CODES_FOR_880_ExtendedCyrillicAsG1$
        Case CHARACTERTABLE_ExtendedArabic$
            ' we always map this to G1, no matter what
            TranslateUtf82MarcShortCodeToLong = CHARACTERSET_CODES_FOR_880_ExtendedArabicAsG1$
        Case Else
            ' hope for the best!
            TranslateUtf82MarcShortCodeToLong = sShortCharacterSetCode$
    End Select

End Function

Public Sub TranslateUtf82MarcOneFieldOld(ByRef sMarc8CharacterSetCodes$, ByVal sTag$, ByRef sText$, ByRef bChanged As Boolean, ByRef bError As Boolean)

#If False Then

    ' we receive in sText the complete variable field text, including
    '   delimiters and subfield codes, all in one big ol' string
    
    Dim lPtr As Long, lLen As Long, lCtr As Long
    
    Dim iLen%, iAsc%
    
    Dim sField$, sDiacriticsAbove$, sDiacriticsOther$, sMarc8Character$, sMarc8CharacterSetCode$
    Dim sCurrentCharacterSetCode$, sScrap$, sOriginalSubfield$, sOutputSubfield$, sSfc$
    Dim sTest$, sCurrentEscapeCode$, sPreviousEscapeCode$, sLeftEnd$, sCore$, sRightEnd$, sChar$
    Dim sLocalCharacterSetCodes$
    
    Dim bCharacterError As Boolean, bDiacritics As Boolean, bCharacterChanged As Boolean
    Dim b202FPresent As Boolean, b303FPresent As Boolean, bOtherCharactersPresent As Boolean
    Dim bAltered As Boolean
    
    m_iDiacriticLast% = 0
    
    
#If TranslateUtf82MarcOneFieldDebug = -1 Then
    Debug.Print "TU2MOF entry"
#End If
    ' assume the normal character set: ASCII as G0 and
    '   ANSEL as G1
    
    Do
    
        ' we're dealing with one subfield at a time, from left to right; we
        '   take the thing apart ourselves
        ' here, we isolate the next subfield and its code
        If Mid(sText$, 1, 1) = MyMarcCharacter.MarcDelimiter Then
Tu82MOFNextSubfield:
            sSfc$ = Mid(sText$, 1, 2)
            sText$ = Mid(sText$, 3)
        Else
            sSfc$ = ""
        End If
        lPtr = InStr(sText$, MyMarcCharacter.MarcDelimiter)
        Select Case lPtr
            Case 1
                ' an empty subfield: we won't translate anything
                If Len(sText$) = 0 Then
                    Exit Do
                End If
                GoTo Tu82MOFNextSubfield
            Case Is > 0
                ' current subfield is not the last subfield
                sOriginalSubfield$ = sSfc$ + Mid(sText$, 1, lPtr - 1)
                sSfc$ = ""
                sText$ = Mid(sText$, lPtr)
            Case Else
                ' zero: current subfield must also be the last subfield (which
                '   of course may also be the only subfield)
                sOriginalSubfield$ = sSfc$ + sText$
                sSfc$ = ""
                sText$ = ""
        End Select
        
        sCurrentCharacterSetCode$ = ""
        sOutputSubfield$ = ""

#If TranslateUtf82MarcOneFieldDebug = -1 Then
        Debug.Print "Sfd before conversion: >" + sOriginalSubfield$ + "< >" + CharToHex(sOriginalSubfield$)
#End If
        
        ' go through the extracted subfield one character at a time, from RIGHT to LEFT
        '   (so that we hit UTF-8 diacritics before we hit the base characters)
        ' we ourselves point lptr to the octet preceding the start of the previously-examined
        '   charcater, and let the character object back it up further if we're dealing with
        '   a multi-octet character
        ' we start out pointed to the last octet in the whole string, which may or may not
        '   be an octet in a multi-byte character
        lPtr = Len(sOriginalSubfield$)
        
        Do While lPtr > 0
        
            ' find the first octet of this character
            lPtr = MyMarcCharacter.Utf8CharFindFirstOctet(sOriginalSubfield$, lPtr)
            
            ' translate this one character
            MyMarcCharacter.TranslateUtf82MarcOneCharacter m_sCharacterSetOut$, sMarc8CharacterSetCode$, Mid(sOriginalSubfield$, lPtr, MyMarcCharacter.Utf8CharOctets(Mid(sOriginalSubfield$, lPtr, 1))), sMarc8Character$, bCharacterChanged, bCharacterError

            bChanged = bChanged Or bCharacterChanged
            
            If bCharacterError Then
TranslateUtf82MarcTextError:
                bError = True
                iLen% = MyMarcCharacter.Utf8CharOctets(Mid(sOriginalSubfield, lPtr, 1))
                sChar$ = Mid(sOriginalSubfield, lPtr, iLen%)
                sChar$ = MyMarcCharacter.Utf82Ucs(sChar$)
                MyMarcCharacter.UcsChar = sChar$
                sChar$ = LCase(MyMarcCharacter.UcsHex)
                sOutputSubfield$ = "&#x" + sChar$ + ";" + sOutputSubfield$
                bCharacterError = False
            ElseIf sTag$ = "880" Then
TMU2MOF_EverythingNowOK:
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                Debug.Print "TMU2MOFENOK codes: >" + sCurrentCharacterSetCode$ + "< >" + sMarc8CharacterSetCode$ + "<"
#End If
                ' if we don't have a "current" code yet, then set it equal to the
                '   code for the current character (this will typically
                '   happen for the rightmost character in the first subfield)
                If Len(sCurrentCharacterSetCode$) = 0 Then
                    sCurrentCharacterSetCode$ = sMarc8CharacterSetCode$
                End If
                If sTag$ = "880" Then ' 20080829: seemingly-redundant test added, because we can now branch here
                    ' we'll accept any character sets defined for MARC in the 880, without further testing
                    If InStr(sMarc8CharacterSetCodes$, " " + sMarc8CharacterSetCode$ + " ") = 0 Then
                        sMarc8CharacterSetCodes$ = sMarc8CharacterSetCodes$ + " " + sMarc8CharacterSetCode$ + " "
                    End If
                    ' 20070425: accumulate also codes just for this one field, separate from the
                    '   overall list for the record
                    If InStr(sLocalCharacterSetCodes$, " " + sMarc8CharacterSetCode$ + " ") = 0 Then
                        sLocalCharacterSetCodes$ = sLocalCharacterSetCodes$ + " " + sMarc8CharacterSetCode$ + " "
                    End If
                End If
                If sCurrentCharacterSetCode$ <> sMarc8CharacterSetCode$ Then
                    If Len(sCurrentCharacterSetCode$) = 1 Then
                        Select Case sCurrentCharacterSetCode$
                            Case CHARACTERTABLE_Basic$
                                sOutputSubfield$ = MarcEscape + CHARACTERSET_CODES_FOR_880_BasicAsG0$ + sOutputSubfield$
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                                Debug.Print "Added basic code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
#End If
                            Case CHARACTERTABLE_3Greeks$
                                sOutputSubfield$ = MarcEscape + "s" + sOutputSubfield$
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                                Debug.Print "Added Greek code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
#End If
                            Case CHARACTERTABLE_Subscript$
                                sOutputSubfield$ = MarcEscape + "b" + sOutputSubfield$
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                                Debug.Print "Added subscript code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
#End If
                            Case CHARACTERTABLE_Superscript$
                                sOutputSubfield$ = MarcEscape + "p" + sOutputSubfield$
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                                Debug.Print "Added superscript code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
#End If
                            Case CHARACTERTABLE_Hebrew$
                                sOutputSubfield$ = MarcEscape + CHARACTERSET_CODES_FOR_880_HebrewAsG0$ + sOutputSubfield$
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                                Debug.Print "Added Hebrew code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
#End If
                            Case CHARACTERTABLE_BasicCyrillic$
                                sOutputSubfield$ = MarcEscape + CHARACTERSET_CODES_FOR_880_BasicCyrillicAsG0$ + sOutputSubfield$
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                                Debug.Print "Added Cyrillic basic code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
#End If
                            Case CHARACTERTABLE_BasicArabic$
                                sOutputSubfield$ = MarcEscape + CHARACTERSET_CODES_FOR_880_BasicArabicAsG0$ + sOutputSubfield$
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                                Debug.Print "Added Arabic basic code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
#End If
                            Case CHARACTERTABLE_Greek$
                                sOutputSubfield$ = MarcEscape + CHARACTERSET_CODES_FOR_880_GreekAsG0$ + sOutputSubfield$
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                                Debug.Print "Added Greek code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
#End If
                            Case CHARACTERTABLE_CJK$
                                sOutputSubfield$ = MarcEscape + CHARACTERSET_CODES_FOR_880_CJKAsG0$ + sOutputSubfield$
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                                Debug.Print "Added CJK code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
#End If
                            Case CHARACTERTABLE_ExtendedCyrillic$
                                ' we always map this to G1, no matter what
                                sOutputSubfield$ = MarcEscape + CHARACTERSET_CODES_FOR_880_ExtendedCyrillicAsG1$ + sOutputSubfield$
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                                Debug.Print "Added Cyrillic extended code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
#End If
                            Case CHARACTERTABLE_ExtendedArabic$
                                ' we always map this to G1, no matter what
                                sOutputSubfield$ = MarcEscape + CHARACTERSET_CODES_FOR_880_ExtendedArabicAsG1$ + sOutputSubfield$
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                                Debug.Print "Added Arabic extended code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
#End If
                            Case Else
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                                Debug.Print "TMU2MOFENOK: CASE ELSE"
#End If
                        End Select
                    Else ' multi-byte code: hope for the best
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                        Debug.Print "TMU2MOFENOK fall-through"
#End If
                        sOutputSubfield$ = MarcEscape + sCurrentCharacterSetCode$ + sOutputSubfield$
                    End If
                    ' we've just dealt with the stuff to the right of the current
                    '   character; so the current character's code is now
                    '   the current code
                    sCurrentCharacterSetCode$ = sMarc8CharacterSetCode$
                End If ' did we just change character sets?
                ' deal with diacritics: if the current character *is*
                '   a diacritic, accumulate it; if it is not a diacritic,
                '   any accumulated diacritics go to its left
                If InStr(Marc8DiacriticsAbove$, sMarc8Character$) > 0 Then
                    TranslateAddOneDiacriticToArray sMarc8Character$, Marc8Diacritics$
                    bDiacritics = True
                ElseIf InStr(Marc8DiacriticsAbove$, sMarc8Character$) > 0 Then
                    TranslateAddOneDiacriticToArray sMarc8Character$, Marc8Diacritics$
                    bDiacritics = True
                Else
                    ' normal character; stick it on to the growing string
                    sOutputSubfield$ = sMarc8Character$ + sOutputSubfield$
                    ' any accumulated diacritics come before this letter
                    If bDiacritics Then
                        If sCurrentCharacterSetCode$ <> "1" Then
                            sOutputSubfield$ = MarcEscape + sCurrentCharacterSetCode$ + sOutputSubfield$
                            sCurrentCharacterSetCode$ = "1"
                        End If
                        sOutputSubfield$ = TranslateSortAndReturnDiacriticArray() + sOutputSubfield$
                        bDiacritics = False
                    End If
                End If
            Else ' not 880, and no errors
                If Len(sCurrentCharacterSetCode$) = 0 Then
                    sCurrentCharacterSetCode$ = sMarc8CharacterSetCode$
                End If
                If InStr(CHARACTERSET_Non880$, sMarc8CharacterSetCode$) > 0 Then
TranslateUtf82MarcTextOK:
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                    Debug.Print "MarcTextOK fall-through: >" + sCurrentCharacterSetCode$ + "< >" + sMarc8CharacterSetCode$ + "<"
#End If
                    If sCurrentCharacterSetCode$ <> sMarc8CharacterSetCode$ Then
                    
                    
                    
                    
                    
                    
                    
                        Select Case sCurrentCharacterSetCode$
                            Case "1"
                                sOutputSubfield$ = MarcEscape + "s" + sOutputSubfield$
                            Case "2"
                                sOutputSubfield$ = MarcEscape + "g" + sOutputSubfield$
                            Case "3"
                                sOutputSubfield$ = MarcEscape + "b" + sOutputSubfield$
                            Case "4"
                                sOutputSubfield$ = MarcEscape + "p" + sOutputSubfield$
                            Case Else
                            
                            
                            
                                Select Case sCurrentCharacterSetCode$
                                    Case CHARACTERTABLE_Basic$
                                        sOutputSubfield$ = MarcEscape + CHARACTERSET_CODES_FOR_880_BasicAsG0$ + sOutputSubfield$
        #If TranslateUtf82MarcOneFieldDebug = -1 Then
                                        Debug.Print "Added basic code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
        #End If
                                    Case CHARACTERTABLE_3Greeks$
                                        sOutputSubfield$ = MarcEscape + "s" + sOutputSubfield$
        #If TranslateUtf82MarcOneFieldDebug = -1 Then
                                        Debug.Print "Added Greek code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
        #End If
                                    Case CHARACTERTABLE_Subscript$
                                        sOutputSubfield$ = MarcEscape + "b" + sOutputSubfield$
        #If TranslateUtf82MarcOneFieldDebug = -1 Then
                                        Debug.Print "Added subscript code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
        #End If
                                    Case CHARACTERTABLE_Superscript$
                                        sOutputSubfield$ = MarcEscape + "p" + sOutputSubfield$
        #If TranslateUtf82MarcOneFieldDebug = -1 Then
                                        Debug.Print "Added superscript code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
        #End If
                                    Case CHARACTERTABLE_Hebrew$
                                        sOutputSubfield$ = MarcEscape + CHARACTERSET_CODES_FOR_880_HebrewAsG0$ + sOutputSubfield$
        #If TranslateUtf82MarcOneFieldDebug = -1 Then
                                        Debug.Print "Added Hebrew code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
        #End If
                                    Case CHARACTERTABLE_BasicCyrillic$
                                        sOutputSubfield$ = MarcEscape + CHARACTERSET_CODES_FOR_880_BasicCyrillicAsG0$ + sOutputSubfield$
        #If TranslateUtf82MarcOneFieldDebug = -1 Then
                                        Debug.Print "Added Cyrillic basic code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
        #End If
                                    Case CHARACTERTABLE_BasicArabic$
                                        sOutputSubfield$ = MarcEscape + CHARACTERSET_CODES_FOR_880_BasicArabicAsG0$ + sOutputSubfield$
        #If TranslateUtf82MarcOneFieldDebug = -1 Then
                                        Debug.Print "Added Arabic basic code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
        #End If
                                    Case CHARACTERTABLE_Greek$
                                        sOutputSubfield$ = MarcEscape + CHARACTERSET_CODES_FOR_880_GreekAsG0$ + sOutputSubfield$
        #If TranslateUtf82MarcOneFieldDebug = -1 Then
                                        Debug.Print "Added Greek code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
        #End If
                                    Case CHARACTERTABLE_CJK$
                                        sOutputSubfield$ = MarcEscape + CHARACTERSET_CODES_FOR_880_CJKAsG0$ + sOutputSubfield$
        #If TranslateUtf82MarcOneFieldDebug = -1 Then
                                        Debug.Print "Added CJK code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
        #End If
                                    Case CHARACTERTABLE_ExtendedCyrillic$
                                        ' we always map this to G1, no matter what
                                        sOutputSubfield$ = MarcEscape + CHARACTERSET_CODES_FOR_880_ExtendedCyrillicAsG1$ + sOutputSubfield$
        #If TranslateUtf82MarcOneFieldDebug = -1 Then
                                        Debug.Print "Added Cyrillic extended code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
        #End If
                                    Case CHARACTERTABLE_ExtendedArabic$
                                        ' we always map this to G1, no matter what
                                        sOutputSubfield$ = MarcEscape + CHARACTERSET_CODES_FOR_880_ExtendedArabicAsG1$ + sOutputSubfield$
        #If TranslateUtf82MarcOneFieldDebug = -1 Then
                                        Debug.Print "Added Arabic extended code " + ReplaceCharacters(sOutputSubfield$, MarcEscape, "<E>")
        #End If
                                    Case Else
        #If TranslateUtf82MarcOneFieldDebug = -1 Then
                                        Debug.Print "TMU2MOFENOK: CASE ELSE"
        #End If
                                End Select
                                
                                sOutputSubfield$ = MarcEscape + sCurrentCharacterSetCode$ + sOutputSubfield$
                        End Select
                        sCurrentCharacterSetCode$ = sMarc8CharacterSetCode$
                    End If
                    If InStr(Marc8DiacriticsAbove$, sMarc8Character$) > 0 Then
                        TranslateAddOneDiacriticToArray sMarc8Character$, Marc8Diacritics$
                        'sDiacriticsAbove$ = sDiacriticsAbove$ + sMarc8Character$
                        bDiacritics = True
                    ElseIf InStr(Marc8DiacriticsOther$, sMarc8Character$) > 0 Then
                        TranslateAddOneDiacriticToArray sMarc8Character$, Marc8Diacritics$
                        'sDiacriticsOther$ = sMarc8Character$ + sDiacriticsOther$
                        bDiacritics = True
                    Else
                        ' non-diacritic character; stick it on to the growing string
                        sOutputSubfield$ = sMarc8Character$ + sOutputSubfield$
                        ' any accumulated diacritics come before this letter
                        If bDiacritics Then
                            If sCurrentCharacterSetCode$ <> "1" Then
                                sOutputSubfield$ = MarcEscape + sCurrentCharacterSetCode$ + sOutputSubfield$
                                sCurrentCharacterSetCode$ = "1"
                            End If
                            sOutputSubfield$ = TranslateSortAndReturnDiacriticArray() + sOutputSubfield$
                            bDiacritics = False
                        End If
                    End If
                ElseIf InStr(CHARACTERSET_GreekCodes$, sMarc8CharacterSetCode$) > 0 Then
                    If sMarc8Character$ = MarcAlpha Or sMarc8Character$ = MarcBeta Or sMarc8Character$ = MarcGamma Then
                        ' these three are allowed in non-880 fields
                        GoTo TranslateUtf82MarcTextOK
                    Else
                        GoTo TMU2MOF_EverythingNowOK
                        'GoTo TranslateUtf82MarcTextError
                    End If
                Else
                    GoTo TMU2MOF_EverythingNowOK
                    'GoTo TranslateUtf82MarcTextError
                End If
             End If ' error? 880? non-880?
            
            ' lptr is currently on the forst octet of the utf8 character; back up into the previous
            '   character and continue
            lPtr = lPtr - 1
        Loop
        
        If bDiacritics Then
            If sCurrentCharacterSetCode$ <> "1" Then
                sOutputSubfield$ = MarcEscape + sCurrentCharacterSetCode$ + sOutputSubfield$
                sCurrentCharacterSetCode$ = "1"
            End If
            sOutputSubfield$ = TranslateSortAndReturnDiacriticArray() + sOutputSubfield$
            bDiacritics = False
        End If
        
        lPtr = Rat(sOutputSubfield$, MarcEscape)
        If lPtr > 0 Then
            If sTag$ <> "880" Then
                If Mid(sOutputSubfield$, lPtr + 1, 1) <> "s" Then
                    sOutputSubfield$ = sOutputSubfield$ + MarcEscape + "s"
                End If
            Else
                If Mid(sOutputSubfield$, lPtr + 1, 2) <> "(B" Then
                    sOutputSubfield$ = sOutputSubfield$ + MarcEscape + "(B"
                End If
            End If
        End If
        
        
        ' 20050722: now some additional fun
        ' THIS ONLY APPLIES TO 880 SUBFIELDS that contain an escape
        ' the "exceptional characters" we're dealing with here are the
        '   "normal" punctuation characters (hex 20-2F) in cyrillic, greek and
        '   hebrew; and numerals and more punctuation (hex 30-3F) in hebrew an
        '   cyrillic (but not greek)
        ' if an-escape delimited string of "standard set" characters is composed
        '   entirely of these exceptional characters AND IF the character sets to
        '   the left and to the right of this string are both of one of the
        '   accepted types, then we remove the escape switches that delimit this
        '   string of exceptional characters, so that they participate in the
        '   character set of their context
        ' similarly, if a subfield ends with a sequence of only exceptional characters
        '   and the previous character set allows all of these characters, then put
        '   these characters within the previous character set, retaining the
        '   "switch back to normal" at the end of the subfield
        ' (no such similar treatment for text that comes at the beginning of the
        '   subfield, before the first "escape" sequence)
        If sTag$ = "880" Then
            If InStr(sOutputSubfield$, MarcEscape) > 0 Then
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                Debug.Print "Sfd Converted with excape: >" + sOutputSubfield$ + "<"
#End If
                If InStr(sOutputSubfield$, MarcEscape$ + CHARACTERSET_CODES_FOR_880_HebrewAsG0$) > 0 Or InStr(sOutputSubfield$, MarcEscape$ + CHARACTERSET_CODES_FOR_880_BasicCyrillicAsG0$) > 0 Or InStr(sOutputSubfield$, MarcEscape$ + CHARACTERSET_CODES_FOR_880_BasicArabicAsG0$) > 0 Then
                    ' if we get here, then this subfield does actually
                    '   require the elaborate attention called for by this
                    '   exceptional condition
                    sOriginalSubfield$ = sOutputSubfield$
                    sOutputSubfield$ = ""
                    sPreviousEscapeCode$ = ""
                    ' break off each escape-delimited piece
                    Do
                        lPtr = InStr(sOriginalSubfield$, MarcEscape)
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                        Debug.Print str(lPtr) + " >" + sOriginalSubfield$ + "< >" + sOutputSubfield$ + "<"
#End If
                        bAltered = False
                        Select Case lPtr
                            Case 0
                                sTest$ = sOriginalSubfield$
                                sOriginalSubfield$ = ""
                                ' todo: test this last piece for criteria as described above
                            Case 1
                                ' either the subfield begins with an escape-marker, or
                                '   we're somewhere within the subfield
                                'sCurrentEscapeCode$, sPreviousEscapeCode$
                                ' all of the codes that we generate are 2-byte codes
                                sCurrentEscapeCode$ = Mid(sOriginalSubfield$, lPtr + 1, 2)
                                sOriginalSubfield$ = Mid(sOriginalSubfield$, lPtr + 3)
                                lPtr = InStr(sOriginalSubfield$, MarcEscape)
                                If lPtr = 0 Then
                                    ' the string of interest occurs at the end of the subfield
                                    sTest$ = sOriginalSubfield$
                                    sOriginalSubfield$ = ""
                                    If sCurrentEscapeCode = CHARACTERSET_CODES_FOR_880_BasicAsG0$ Then
                                        TranslateUtf82MarcOneFieldExceptionalCharacters sTest$, b202FPresent, b303FPresent, bOtherCharactersPresent
#If TranslateUtf82MarcOneFieldDebug = -1 Then
                                        Debug.Print "Result from exceptional test: >" + sTest$ + "< >" + str(b202FPresent) + " " + str(b303FPresent) + " " + str(bOtherCharactersPresent)
#End If
                                        'CHARACTERSET_CODES_FOR_880_BasicArabicAsG0$
                                        If Not bOtherCharactersPresent Then
                                            Select Case sPreviousEscapeCode$
                                                Case CHARACTERSET_CODES_FOR_880_HebrewAsG0$
                                                    If b202FPresent Or b303FPresent Then
TU82MOFAlterEscapeCoding2:                              ' NOTE label in left margin
                                                        sOutputSubfield$ = sOutputSubfield$ + sTest$ + MarcEscape + CHARACTERSET_CODES_FOR_880_BasicAsG0$
                                                        bAltered = True
                                                    End If
                                                Case CHARACTERSET_CODES_FOR_880_BasicCyrillicAsG0$
                                                    If b202FPresent Or b303FPresent Then
                                                        GoTo TU82MOFAlterEscapeCoding2
                                                    End If
                                                Case CHARACTERSET_CODES_FOR_880_BasicArabicAsG0$
                                                    If Len(sTest$) = 1 And InStr(",;?%", sTest$) > 0 Then
                                                        ' do nothing with these--leave 'em alone
                                                    Else
                                                        If b202FPresent And Not b303FPresent Then
                                                            GoTo TU82MOFAlterEscapeCoding2
                                                        ElseIf b202FPresent And b303FPresent Then
                                                            ' 303F is OK as long as it's not
                                                            '   30 through 39 ...
                                                            If InStr(sTest$, "0") = 0 And InStr(sTest$, "1") = 0 And InStr(sTest$, "2") = 0 And InStr(sTest$, "3") = 0 And InStr(sTest$, "4") = 0 And InStr(sTest$, "5") = 0 And InStr(sTest$, "6") = 0 And InStr(sTest$, "7") = 0 And InStr(sTest$, "8") = 0 And InStr(sTest$, "9") = 0 Then
                                                                GoTo TU82MOFAlterEscapeCoding2
                                                            End If
                                                            ' if we get here, then the string contains a mixture of
                                                            '   characters 20-2F plus one or more numerals
                                                            ' we're going to split the thing into 2 pieces:
                                                            '   1) the left end, containing non-numerals
                                                            '   2) the central core, beginning with the first numeral, plus
                                                            '   any other stuff on the right (we don't care what follows
                                                            '   the first numeral)
                                                            sCore$ = sTest$
                                                            sLeftEnd$ = ""
                                                            sRightEnd$ = ""
                                                            Do While Len(sCore$) > 0
                                                                If InStr("0123456789", Mid(sCore$, 1, 1)) > 0 Then
                                                                    Exit Do
                                                                End If
                                                                sLeftEnd$ = sLeftEnd$ + Mid(sCore$, 1, 1)
                                                                sCore$ = Mid(sCore$, 2)
                                                            Loop
                                                            ' if we removed any characters from the left end,
                                                            '   place them inside the preceding character
                                                            '   sequence
                                                            sOutputSubfield$ = sOutputSubfield$ + sLeftEnd$
                                                            sOriginalSubfield$ = SafeStuff(sOriginalSubfield$, 4, 0, sRightEnd$)
                                                            ' if we have any characters left in the core (we ought
                                                            '   to, by definition), then leave this escape
                                                            '   sequence between the other two
                                                            ' but all we want in the middle now, is the numeral-bounded string
                                                            sTest$ = sCore$
                                                            ' and we'll pretend we haven't changed anything ...
                                                            bAltered = False
                                                        End If
                                                    End If
                                            End Select
                                        End If
                                    End If
                                    If Not bAltered Then
                                        sOutputSubfield$ = sOutputSubfield$ + MarcEscape + sCurrentEscapeCode$ + sTest$
                                    End If
                                Else
                                    ' the current escape sequence is followed by yet another in
                                    '   the same subfield
                                    sTest$ = Mid(sOriginalSubfield$, 1, lPtr - 1)
                                    sOriginalSubfield$ = Mid(sOriginalSubfield$, lPtr)
                                    If Len(sPreviousEscapeCode$) > 0 Then
                                        If sCurrentEscapeCode$ = CHARACTERSET_CODES_FOR_880_BasicAsG0$ Then
                                            If sPreviousEscapeCode$ = Mid(sOriginalSubfield$, 2, 2) Then
                                                ' we have a string of "normal" characters in between
                                                '   two other strings of the same type
                                                ' what kind of characters do we have?
                                                TranslateUtf82MarcOneFieldExceptionalCharacters sTest$, b202FPresent, b303FPresent, bOtherCharactersPresent
                                                If Not bOtherCharactersPresent Then
                                                    Select Case sPreviousEscapeCode$
                                                        Case CHARACTERSET_CODES_FOR_880_HebrewAsG0$
                                                            If b202FPresent Or b303FPresent Then
TU82MOFAlterEscapeCoding:                                       ' NOTE label in left margin
                                                                sOutputSubfield$ = sOutputSubfield$ + sTest$
                                                                sOriginalSubfield$ = Mid(sOriginalSubfield$, 4)
                                                                lPtr = InStr(sOriginalSubfield$, MarcEscape)
                                                                If lPtr > 0 Then ' it better be!
                                                                    sOutputSubfield$ = sOutputSubfield$ + Mid(sOriginalSubfield$, 1, lPtr - 1)
                                                                    sOriginalSubfield$ = Mid(sOriginalSubfield$, lPtr)
                                                                End If
                                                                bAltered = True
                                                                sCurrentEscapeCode$ = sPreviousEscapeCode$
                                                            End If
                                                        Case CHARACTERSET_CODES_FOR_880_BasicCyrillicAsG0$
                                                            If b202FPresent Or b303FPresent Then
                                                                GoTo TU82MOFAlterEscapeCoding
                                                            End If
                                                        Case CHARACTERSET_CODES_FOR_880_BasicArabicAsG0$
                                                            If Len(sTest$) = 1 And InStr(",;?%", sTest$) > 0 Then
                                                                ' do nothing with these--leave 'em alone
                                                            Else
                                                                If b202FPresent And Not b303FPresent Then
                                                                    GoTo TU82MOFAlterEscapeCoding
                                                                ElseIf b202FPresent And b303FPresent Then
                                                                    ' the string contains a mixture of characters in the
                                                                    '   ranges 20-2F and 30-3F
                                                                    ' 30-3F is OK as long as it's not
                                                                    '   30 through 39 ...
                                                                    If InStr(sTest$, "0") = 0 And InStr(sTest$, "1") = 0 And InStr(sTest$, "2") = 0 And InStr(sTest$, "3") = 0 And InStr(sTest$, "4") = 0 And InStr(sTest$, "5") = 0 And InStr(sTest$, "6") = 0 And InStr(sTest$, "7") = 0 And InStr(sTest$, "8") = 0 And InStr(sTest$, "9") = 0 Then
                                                                        GoTo TU82MOFAlterEscapeCoding
                                                                    End If
                                                                    ' if we get here, then the string contains a mixture of
                                                                    '   characters 20-2F plus one or more numerals
                                                                    ' we're going to split the thing into up to 3 pieces:
                                                                    '   1) the left end, containing non-numerals
                                                                    '   2) the central core, beginning and ending with numerals
                                                                    '   3) the right end, containing non-numerals
                                                                    sCore$ = sTest$
                                                                    sLeftEnd$ = ""
                                                                    sRightEnd$ = ""
                                                                    Do While Len(sCore$) > 0
                                                                        If InStr("0123456789", Mid(sCore$, 1, 1)) > 0 Then
                                                                            Exit Do
                                                                        End If
                                                                        sLeftEnd$ = sLeftEnd$ + Mid(sCore$, 1, 1)
                                                                        sCore$ = Mid(sCore$, 2)
                                                                    Loop
                                                                    Do While Len(sCore$) > 0
                                                                        If InStr("0123456789", Right(sCore$, 1)) > 0 Then
                                                                            Exit Do
                                                                        End If
                                                                        sRightEnd$ = Right(sCore$, 1) + sRightEnd$
                                                                        sCore$ = Mid(sCore$, 1, Len(sCore$) - 1)
                                                                    Loop
                                                                    ' if we removed any characters from the left end,
                                                                    '   place them inside the preceding character
                                                                    '   sequence
                                                                    sOutputSubfield$ = sLeftEnd$
                                                                    ' if we removed any characters from the right end, place
                                                                    '   them inside the following character sequence
                                                                    sOriginalSubfield$ = SafeStuff(sOriginalSubfield$, 4, 0, sRightEnd$)
                                                                    ' if we have any characters left in the core (we ought
                                                                    '   to, by definition), then leave this escape
                                                                    '   sequence between the other two
                                                                    ' but all we want in the middle now, is the numeral-bounded string
                                                                    sTest$ = sCore$
                                                                    ' and we'll pretend we haven't changed anything ...
                                                                    bAltered = False
                                                                End If
                                                            End If
                                                    End Select
                                                'Else
                                                    ' the string contains characters other than those in the
                                                    '   range 20-3F; we're going to leave it alone (for now ...)
                                                    ' todo: eventually, we could see if anything at either the
                                                    '   left or right end (such as a space) could go with the previous
                                                    '   or following string ...
                                                End If
                                            End If
                                        End If
                                    End If
                                    If Not bAltered Then
                                        sOutputSubfield$ = sOutputSubfield$ + MarcEscape + sCurrentEscapeCode$ + sTest$
                                    End If
                                    sPreviousEscapeCode$ = sCurrentEscapeCode$
                                End If
                            Case Else
                                ' must be that we're at the beginning of the field,
                                '   and there's a "normal" string before the first
                                '   escape code
                                sOutputSubfield$ = sOutputSubfield$ + Mid(sOriginalSubfield$, 1, lPtr - 1)
                                sOriginalSubfield$ = Mid(sOriginalSubfield$, lPtr)
                        End Select
                        If Len(sOriginalSubfield$) = 0 Then
                            Exit Do
                        End If
                    Loop
                End If
            End If
        End If
        
#If TranslateUtf82MarcOneFieldDebug = -1 Then
        Debug.Print "Sfd after conversion: >" + sSfc$ + sOutputSubfield$ + "< >" + CharToHex(sSfc$ + sOutputSubfield$)
#End If
        
        sField$ = sField$ + sSfc$ + sOutputSubfield$
        
        If Len(sText$) = 0 Then
            Exit Do
        End If
    Loop
        
    ' 20070425: add character set code to end of $6 if missing
    sLocalCharacterSetCodes$ = TranslateUtf82MarcCharacterSetString(sLocalCharacterSetCodes$, "/")
    If Len(sLocalCharacterSetCodes$) > 0 Then ' this can only happen if the tag is 880
        iLen% = InStr(sField$, MyMarcCharacter.MarcDelimiter + "6")
        If iLen% > 0 Then
            sChar$ = Mid(sField$, 1, iLen% + 2) ' contains the field through the $6 marker
            sField$ = Mid(sField$, iLen% + 3) ' contains the field starting with first char of $6 text
            iLen% = InStr(sField$, MyMarcCharacter.MarcDelimiter)
            If iLen% > 0 Then
                sSfc$ = Mid(sField$, 1, iLen% - 1) ' contains the text of $6 itself
                sField$ = Mid(sField$, iLen%) ' remaining field, starting with $
            Else
                sSfc$ = sField$
                sField$ = ""
            End If
            ' we only use the very first code in $6
            If Mid(sLocalCharacterSetCodes$, 1, 1) = "/" Then
                sLocalCharacterSetCodes$ = Mid(sLocalCharacterSetCodes$, 2)
            End If
            iLen% = InStr(sLocalCharacterSetCodes$, "/")
            If iLen% > 0 Then
                sLocalCharacterSetCodes$ = Mid(sLocalCharacterSetCodes$, 1, iLen% - 1)
            End If
            ' re-add the separating slash, and if necessary a right-to-left marker
            Select Case sLocalCharacterSetCodes$
                ' 20070531: replace literal references (incorrect in one case) with constants
                'Case "(3", "(2)"
                Case CHARACTERSET_CODES_FOR_880_BasicArabicAsG0$, CHARACTERSET_CODES_FOR_880_HebrewAsG0$
                    sLocalCharacterSetCodes$ = "/" + sLocalCharacterSetCodes$ + "/r"
                Case Else
                    sLocalCharacterSetCodes$ = "/" + sLocalCharacterSetCodes$
            End Select
            ' remove any code that may currently exist in the $6
            iLen% = InStr(sSfc$, "/")
            If iLen% > 0 Then
                sSfc$ = Mid(sSfc$, 1, iLen% - 1)
            End If
            ' at this point:
            '   sChar$ contains the field up to and including $6
            '   sSfc$ contains the text of $6
            '   sField$ contains everything following $6, starting with its delimiter code
            '   sLocalCharacterSetCodes contains the business to add to $6
            sField$ = sChar$ + sSfc$ + sLocalCharacterSetCodes$ + sField$
        End If
    End If
    
    ' return the modified field
    sText$ = sField$

    ' todo: do we not need a "return to normal character set" not only at the end of the
    '   field, if the last subfield in the field does not already end with a
    '   normal character?

#End If

End Sub

Public Sub FldChangedClearAll()

    ' 20080912: added
    
    Dim lFieldPointer As Long
    
    
    ' save the current field pointer!
    lFieldPointer = FldPointer
        
    FldMoveTop
    Do While FldMoveNext
        If Not FldDeleted Then
            If FldChanged Then
                FldChanged = False
            End If
        End If
        DoEvents
    Loop

End Sub

Public Property Get FldChanged() As Boolean

    If FldPointer > -1 Then
        FldChanged = MarcArray(FldPointer).Changed
    Else
        FldChanged = False
    End If

End Property

Public Property Let FldChanged(ByVal vNewValue As Boolean)

    If FldPointer > -1 Then
        MarcArray(FldPointer).Changed = vNewValue
    End If

End Property

Private Sub PushWith(ByVal sNewLabel$)

#If WithDebug = -1 Then
    prvlWithStackLast = prvlWithStackLast + 1
    If prvlWithStackLast > prvlWithStackMax Then
        prvlWithStackMax = prvlWithStackMax + 10
        ReDim Preserve prvaWithStack(0 To prvlWithStackMax)
    End If
    prvaWithStack(prvlWithStackLast) = sNewLabel
    
#End If

End Sub

Private Sub PopWith(ByVal sOldLabel$)

#If WithDebug = -1 Then
    If prvlWithStackLast = 0 Then
        Debug.Print "Popping With when zero"
        Exit Sub
    ElseIf prvaWithStack(prvlWithStackLast) <> sOldLabel$ Then
        Debug.Print "PopWith mismatch: >" + prvaWithStack(prvlWithStackLast) + "< >" + sOldLabel$ + "<"
        prvlWithStackLast = prvlWithStackLast - 1
    Else
        prvlWithStackLast = prvlWithStackLast - 1
    End If

#End If

End Sub

Public Sub DisplayWithStack()

#If WithDebug Then
    
    Dim lCtr As Long
    
    Debug.Print "Last in stack: " + str(prvlWithStackLast)
    For lCtr = 1 To prvlWithStackLast
        Debug.Print vbTab + Trim(str(lCtr)) + " >" + prvaWithStack(lCtr) + "<"
    Next ' lctr
    
#End If

End Sub

Public Function CountWithStack() As Long

    CountWithStack = prvlWithStackLast
    
End Function

Public Function SfdSortingFormD(ByVal sSfdText$) As String

    ' 20090221 added: if possible, come up with a sortable equivalent
    '   for the date subfield
    ' at inception, we only need this when we're generating the sorting form of an
    '   entire field; but we made it separate in case we want it elsewhere
    ' we arrive here with a subfield $d that we know contains a date that
    '   we want to retain in the heading
    ' this $d may come from a personal name or a corporate/conference name
    ' much of this is parallel to the treatment in SfdSortingFormY; in most cases
    '   this elaboration is not necessary, but we don't think it will actively
    '   hurt anything
    
    Dim bBCPresent As Boolean, bADPresent As Boolean
    
    Dim iRc%, iRc2%
    
    Dim sJunk2$, sDate1$, sDate2$, sDate1Extension$, sDate2Extension$
    Dim sSeparator$
    
    Dim lValue As Long
    
    
    sSfdText$ = SafeUCase(sSfdText$)
    
    SfdSortingFormDandYTestBcAdMarkers sSfdText$, bBCPresent, bADPresent
    
    
    ' render text as uppercase, and remove the BC and AD markers
    sJunk2$ = SfdSortingFormDandYPseudoNormalization(sSfdText$)
    
    
    ' let's get "century" headings out of the way first
    iRc% = Rat(sJunk2$, " ")
    If iRc% > 0 Then
        Select Case NormString(Mid(sJunk2$, iRc% + 1))
            Case "CENT", "CENTURY", "CENTURIES"
                ' this code should work with any single century or
                '   century grouping; this neatly
                '   provides for infinite expansion, without us having to hard-code
                '   anything
                ' at this point we're dealing with the text in absolute terms; later on we'll
                '   adjust for BC if needed
                sJunk2$ = Trim(Mid(sJunk2$, 1, iRc% - 1))
                'Debug.Print "Century 1: >" + sJunk2$ + "<"
                ' the rightmost word should now be where we'll find the
                '   number of interest
                ' this neatly gets us over any and all introductory labels
                iRc% = Rat(sJunk2$, " ")
                If iRc% > 0 Then
                    sJunk2$ = Mid(sJunk2$, iRc% + 1)
                End If
                'Debug.Print "Century 2: >" + sJunk2$ + "<"
                iRc% = InStr(sJunk2$, "-")
                If iRc% = 0 Then
                    ' single century: use same basic number for both dates
                    iRc% = Val(sJunk2$) - 1 ' 18th century becomes 17, becomes 1700-1799
                    'Debug.Print "Century value: " + str(iRc%)
                    sJunk2$ = Right("0000" + Trim(str(iRc%)) + "00", 4) + "-" + Right("0000" + Trim(str(iRc%)) + "99", 4)
                Else
                    ' century range: get two different base numbers
                    sDate1$ = Mid(sJunk2$, 1, iRc% - 1)
                    sDate2$ = Trim(Mid(sJunk2$, iRc% + 1))
                    iRc% = Val(sDate1$) - 1 ' 16th becomes 15 becomes 1500 for the opening date
                    iRc2% = Val(sDate2$) - 1 ' 18th becomes 17 becomes 1799 for the closing date
                    sJunk2$ = Right("0000" + Trim(str(iRc%)) + "00", 4) + "-" + Right("0000" + Trim(str(iRc2%)) + "99", 4)
                End If
                GoTo SYFD_AdjustLeadNumeric
            'Other Cases as discovered
            'Case Else
                ' the things we do for $y ("Early to ..." and so on) are irrelevant
                '   for personal names; they would probably not hurt anything,
                '   but they'd be in the way, and probably confusing in the end
        End Select
        
        ' if we get here we don't have any of the special cases
        '   outlined above
        ' there are additional fancy things that we do here for $y that
        '   are really not needed for $d in personal name corporate/conference
        '   headings
    End If ' is there a space anywhere in the subfield?
    
SYFD_AdjustLeadNumeric:

    ' the basic question at this point is: do we have a range of dates?
    
    iRc% = InStr(sJunk2$, "-")
    'Debug.Print "AYL: " + str(iRc%) + " >" + sJunk2$ + "<"
    If iRc% = 0 Then
        ' if we only have a single date, fake it into a span consisting of the
        '   same date for the beginning and the end; after "reversal" of the
        '   second year (see below), this means that the single years will file AFTER
        '   explicit ranges that begin with the same year, giving us the
        '   desired order of broader-before-narrower:
        '     --1918-1933
        '     --Revolution, 1918 <--only a single is present
        sDate1$ = NormString(sJunk2$)
        sDate2$ = sJunk2$
    Else
        sDate1$ = NormString(Mid(sJunk2$, 1, iRc% - 1))
        sDate2$ = NormString(Mid(sJunk2$, iRc% + 1))
    End If
    ' discard any remaining characters that come before
    '   the first numeral
    Do While InStr("0123456789", Mid(sDate1$, 1, 1)) = 0
        sDate1$ = Trim(Mid(sDate1$, 2))
        If Len(sDate1$) = 0 Then
            sDate1$ = "0000"
            Exit Do
        End If
    Loop
    Do While InStr("0123456789", Mid(sDate2$, 1, 1)) = 0
        sDate2$ = Trim(Mid(sDate2$, 2))
        If Len(sDate2$) = 0 Then
            sDate2$ = "0000"
            Exit Do
        End If
    Loop
    ' retain the extensions for date1 and 2; and then
    '   convert the extension into sortable numbers
    If Len(sDate1$) > 4 Then
        sDate1Extension$ = SfdSortingFormDExtension(Trim(Mid(sDate1$, 5)))
        ' 20090914: here and elsewhere: if there is no extension at all, use the
        '   month of "00", to place the monthless dates ahead of dates
        '   that have explicit months
        If Len(sDate1Extension$) = 0 Then
            sDate1Extension$ = "00"
        End If
        sDate1$ = Mid(sDate1$, 1, 4)
    Else
        sDate1Extension$ = "00" ' see note just above
    End If
    If Len(sDate2$) > 4 Then
        sDate2Extension$ = SfdSortingFormDExtension(Trim(Mid(sDate2$, 5)))
        If Len(sDate2Extension$) = 0 Then
            sDate2Extension$ = "00" ' see note just above
        End If
        sDate2$ = Mid(sDate2$, 1, 4)
    Else
        sDate2Extension$ = "00" ' see note just above
    End If
    ' remove all of the non-numeric information (including
    '   spaces and punctuation) from each of the dates
    For iRc% = Len(sDate1$) To 1 Step -1
        If InStr("0123456789", Mid(sDate1$, iRc%, 1)) = 0 Then
            sDate1$ = SafeStuff(sDate1$, iRc%, 1, "")
        End If
    Next ' irc%
    For iRc% = Len(sDate2$) To 1 Step -1
        If InStr("0123456789", Mid(sDate2$, iRc%, 1)) = 0 Then
            sDate2$ = SafeStuff(sDate2$, iRc%, 1, "")
        End If
    Next ' irc%
    ' the dates must each be at least 4 digits long
    If Len(sDate1$) < 4 Then
        sDate1$ = Right("0000" + sDate1$, 4)
    End If
    If Len(sDate2$) < 4 Then
        sDate2$ = Right("0000" + sDate2$, 4)
    End If
    'Debug.Print "Adjusted: >" + sDate1$ + "< >" + sDate2$ + "<"
    
    ' if the original subfield contains B.C., it applies always
    '   to the first date; we'll add leading zeroes to make sure this date
    '   comes before A.D. dates
    ' if the original subfield also contains
    '   A.D., that designation can apply only to the second date following
    '   a B.C. date; if it's not present, then they're
    '   BOTH B.C. dates
    If bBCPresent Then
        lValue = Val(sDate1$)
        If lValue = 0 Then
            sDate1$ = "000099998" ' 4 leading zeroes, plus opening year of 00001 reversed
        Else
            ' reverse the opening year into 5 characters
            ' NOTE that we do not reverse the month and/or day!!
            sDate1$ = "0000" + Right("00000" + Trim(str(99999 - lValue)), 5)
        End If
        If Not bADPresent Then
            ' the second date is a BC date as well, so put it as we have it into 8 characters
            '   with leading zeroes
            ' NOTE that when we have 2 BC dates we DO NOT "reverse" the second date by
            '   subtracting it from some arbitrary value; that's because the numeral
            '   as given will automatically create the "broader-before-narrower" order
            '   that we want (imaginary example):
            '       512 B.C.-142 B.C.  becomes 00000512-00000142
            '       512 B.C.-245 B.C.  becomes 00000512-00000245
            sDate2$ = Right("00000000" + sDate2$, 8)
            sSeparator$ = SPANCODE_SAME_ERA$
        Else
            ' the second date is an AD date, so reverse the year into 4 characters
            ' this allows broader headings to come before narrower ones (same principle as
            '   if the first date were an AD date; see below)
            ' NOTE that we do not reverse the month and/or day!!
            sDate2$ = Right("0000" + Trim(str(9999 - Val(sDate2$))), 4)
            sSeparator$ = SPANCODE_DIFFERENT_ERA$
        End If
    Else
        ' we have two AD dates
        ' leave the firtst date alone unless it's zero, in which
        '   case it's 1
        If sDate1$ = "0000" Then
            sDate1$ = "0001"
        End If
        ' the second date needs to be "reversed", so
        '   broader things come before narrower things
        ' example:
        '   1918-1933        becomes 1918-8066
        '   Revolution, 1918 becomes 1918-8081
        ' NOTE that we do not reverse the month and/or day!!
        sDate2$ = Right("0000" + Trim(str(9999 - Val(sDate2$))), 4)
        sSeparator$ = SPANCODE_SAME_ERA$
    End If
    
    ' reconstruct the sorting form for the two dates, adding on month and day
    '   if available
    SfdSortingFormD = sDate1$ + sDate1Extension$ + sSeparator$ + sDate2$ + sDate2Extension$

End Function

Public Function SfdSortingFormDExtension(ByVal sMonthAndDay$) As String

    Dim iRc%
    
    Dim sMonth$, sDay$
    
    
    If Len(sMonthAndDay$) = 0 Then
        SfdSortingFormDExtension = ""
        Exit Function
    End If
    
    iRc% = InStr(sMonthAndDay$, " ")
    If iRc% > 0 Then
        sMonth$ = Mid(sMonthAndDay$, 1, iRc% - 1)
        sDay$ = Mid(sMonthAndDay$, iRc% + 1)
    Else
        sMonth$ = sMonthAndDay$
        sDay$ = "00"
    End If
    
    Select Case Mid(NormString(sMonth$), 1, 3)
        Case "JAN"
            sMonth$ = "01" + Right("00" + Trim(str(Val(sDay$))), 2)
        Case "FEB"
            sMonth$ = "02" + Right("00" + Trim(str(Val(sDay$))), 2)
        Case "MAR"
            sMonth$ = "03" + Right("00" + Trim(str(Val(sDay$))), 2)
        Case "APR"
            sMonth$ = "04" + Right("00" + Trim(str(Val(sDay$))), 2)
        Case "MAY"
            sMonth$ = "05" + Right("00" + Trim(str(Val(sDay$))), 2)
        Case "JUN"
            sMonth$ = "06" + Right("00" + Trim(str(Val(sDay$))), 2)
        Case "JUL"
            sMonth$ = "07" + Right("00" + Trim(str(Val(sDay$))), 2)
        Case "AUG"
            sMonth$ = "08" + Right("00" + Trim(str(Val(sDay$))), 2)
        Case "SEP"
            sMonth$ = "09" + Right("00" + Trim(str(Val(sDay$))), 2)
        Case "OCT"
            sMonth$ = "10" + Right("00" + Trim(str(Val(sDay$))), 2)
        Case "NOV"
            sMonth$ = "11" + Right("00" + Trim(str(Val(sDay$))), 2)
        Case "DEC"
            sMonth$ = "12" + Right("00" + Trim(str(Val(sDay$))), 2)
        Case Else
            sMonth$ = "00" + Right("00" + Trim(str(Val(sDay$))), 2)
    End Select
    
    SfdSortingFormDExtension = sMonth$
    
End Function


Private Function SfdSortingFormYMonth(ByVal sIncomingNormalizedText$, ByRef sReturnedMonthNumber$) As Boolean

    Dim sFullWord$, sExtension$, sTestedString$
    
    Dim lDifferenceAt As Long, lMinimumLength As Long
    
    ' 20090904: attempt to distinguish true months from
    '   text in parentheses in $y that is NOT actually
    '   month-like
    ' here are examples of subdivisions that do NOT contain months (most if not all
    '   of these are cases of inverted references created by program:
    '   $y 30 B.C.-68 A.D. (Julio-Claudians)
    '   $y 161-180 (Marcus Aurelius)
    
    ' we must assume that we're presented with the English-language version of month names; if we need
    '   to sort chronological subdivisions in some other language, then we're going to have to
    '   be told what language to expect, and this routine will become a LOT more complicated
    
    
    ' assume that we have a month, unless it turns out that we don't
    SfdSortingFormYMonth = True
    
    'Debug.Print "Test for month: >" + sIncomingNormalizedText$ + "<"
    Select Case Mid(sIncomingNormalizedText$, 1, 3)
        Case "JAN"
            sFullWord$ = "JANUARY "
            sExtension$ = "UARY"
            sReturnedMonthNumber$ = "01"
SSFYM_StandardTest:
            sIncomingNormalizedText$ = NormString(sIncomingNormalizedText$)
            'Debug.Print "Incoming normalized text: >" + sIncomingNormalizedText$ + "< >" + sFullWord$ + "<"
            If sFullWord$ = sIncomingNormalizedText$ + " " Then
                SfdSortingFormYMonth = True
            Else
                sTestedString$ = sIncomingNormalizedText$ + sExtension$ + " "
                lDifferenceAt = CLCL(sFullWord$, sTestedString$)
                'Debug.Print "Difference at " + str(lDifferenceAt) + " >" + sFullWord$ + "< >" + sTestedString$ + "<"
                If lDifferenceAt = 0 Then
                    ' no difference
                    SfdSortingFormYMonth = True
                Else
                    ' difference is WITHIN the string
                    If Mid(sTestedString$, lDifferenceAt, 1) = " " Then
                        ' we have the abbreviation plus a space, which is fine
                        ' you have already set sReturnedMonth$ to the proper month number
                        SfdSortingFormYMonth = True
                    Else
                        SfdSortingFormYMonth = False
                        sReturnedMonthNumber$ = ""
                    End If
                End If
            End If
        Case "FEB"
            sFullWord$ = "FEBRUARY "
            sExtension$ = "RUARY"
            sReturnedMonthNumber$ = "02"
            GoTo SSFYM_StandardTest
        Case "MAR"
            sFullWord$ = "MARCH "
            sExtension$ = "CH"
            sReturnedMonthNumber$ = "03"
            GoTo SSFYM_StandardTest
        Case "APR"
            sFullWord$ = "APRIL "
            sExtension$ = "IL"
            sReturnedMonthNumber$ = "04"
            GoTo SSFYM_StandardTest
        Case "MAY"
            sFullWord$ = "MAY "
            sExtension$ = ""
            sReturnedMonthNumber$ = "05"
            GoTo SSFYM_StandardTest
        Case "JUN"
            sFullWord$ = "JUNE "
            sExtension$ = "E"
            sReturnedMonthNumber$ = "06"
            GoTo SSFYM_StandardTest
        Case "JUL"
            sFullWord$ = "JULY "
            sExtension$ = "Y"
            sReturnedMonthNumber$ = "07"
            GoTo SSFYM_StandardTest
        Case "AUG"
            sFullWord$ = "AUGUST "
            sExtension$ = "UST"
            sReturnedMonthNumber$ = "08"
            GoTo SSFYM_StandardTest
        Case "SEP"
            sFullWord$ = "SEPTEMBER "
            sExtension$ = "TEMBER"
            sReturnedMonthNumber$ = "09"
            GoTo SSFYM_StandardTest
        Case "OCT"
            sFullWord$ = "OCTOBER "
            sExtension$ = "OBER"
            sReturnedMonthNumber$ = "10"
            GoTo SSFYM_StandardTest
        Case "NOV"
            sFullWord$ = "NOVEMBER "
            sExtension$ = "EMBER"
            sReturnedMonthNumber$ = "11"
            GoTo SSFYM_StandardTest
        Case "DEC"
            sFullWord$ = "DECEMBER "
            sExtension$ = "EMBER"
            sReturnedMonthNumber$ = "12"
            GoTo SSFYM_StandardTest
        Case Else
            sReturnedMonthNumber$ = ""
            SfdSortingFormYMonth = False
    End Select
    
End Function

Private Function SfdSortingFormYExceptions(ByRef sSubdivision$, ByVal iSpaceAt%, ByRef bBCPresent As Boolean, ByRef bADPresent As Boolean, ByRef sTextWithoutMarkers$) As Integer

    ' mostly for tidiness, we've separated off from the main subfield $y routine the
    '   handling of certain exceptions, such as "century" subdivisions
    
    Dim iRc%, iRc2%, iHyphenPtr%, sJunk1$, sYear1$, sYear2$
    Dim iCentury1%, iCentury2%
    
    Dim bFound As Boolean
    
    
    ' assume that there's nothing special here
    SfdSortingFormYExceptions = SfdSortingFormYReturn_Nothing%
        
    ' first (and rather major) exception: "century" headings
    ' before I get any grief for any part of the following: I know very well that A.D. centuries
    '   begin in the "one" year and end in the "zero" year, and do not, as held by the
    '   vulgar masses, begin in the "zero" year and end in the "ninety-nine" year
    '   (with a parallel consideration for B.C. centuries)
    ' but given all that, what we're working with here is
    '   library filing practice, and library filing practice has
    '   always had A.D. centuries beginning in the zero year; so that's
    '   how I've implemented the sorting equivalent for century subdivisions
    ' you want to argue about this, find a more appropriate target than me;
    '   I'm over it
    ' references:
    '   ALA rules for filing catalog cards, 1968, rule 32G1
    '   Library of Congress filling rules, 1980, rule 16.7.1
    '   ALA filing rules, 1980, rule 8.7.2
    
    'Debug.Print "YExceptions: >" + sSubdivision$ + "< >" + Mid(sSubdivision$, iSpaceAt% + 1, 4) + "< " + str(iSpaceAt%)
    Select Case NormString(Mid(sSubdivision$, iSpaceAt% + 1, 4))
        Case "CENT" ' as in: "19th century"; "cent" is used in MeSH chronological subdivisions
            ' the net we cast also catches "centuries"; if that's what we have, then
            '   we need to be elsewhere
            ' example: "15th and 16th centuries" in authority 16548; "3rd-6th centuries"
            '   in authority 111794
            If Mid(sSubdivision$, iSpaceAt% + 1, 9) = "CENTURIES" Then
                GoTo SSFYE_Centuries
            End If
            ' in some cases (probably errors!), we have the single word "century" but
            '   we actually have a span joined by "AND"
            ' example: "19th and 20th century" in bib 1723710
            ' SEE JUST BELOW for cases in which we have the word "century" together
            '   with a span joined by hyphens
            If Rat(sSubdivision$, " AND ") > 0 Then
                GoTo SSFYE_Centuries
            End If
            ' the following code should work with any single century; this neatly
            '   provides for infinite expansion, without us having to hard-code
            '   anything
            ' throw away the trailing "century" or "cent"
            sSubdivision$ = Trim(Mid(sSubdivision$, 1, iSpaceAt% - 1))
            ' if we discover that this is a range (despite the singular label), treat it
            '   as if the label had been "centuries" instead of "century"
            ' example: "17th-18th century" in bib 2020076
            iHyphenPtr% = Rat(sSubdivision$, "-")
            If iHyphenPtr% > 0 Then
                ' hyphen is present: we have a range
                ' in the case of monstrous subdivisions that cross the BC/AD boundary, it's likely
                '   we will have the word "century" repeated in the left part of the
                '   number; get rid of this (and, more importantly, its associated
                '   space) before we go looking for other spaces
                ' here's the first century in the range
                sJunk1$ = Trim(Mid(sSubdivision$, 1, iHyphenPtr% - 1))
                ' throw away any stuff in the pre-hyphen text after the century number itself
                ' we define "century number" as any lump that begins with a digit
                For iRc% = 1 To Len(sJunk1$)
                    If InStr("123456789", Mid(sJunk1$, iRc%, 1)) > 0 Then
                        If iRc% = 1 Then
SSFYE_ContinueWithCentury:  ' NOTE label in left margin
                            sJunk1$ = Trim(Mid(sJunk1$, iRc%))
                            iRc% = InStr(sJunk1$, " ")
                            If iRc% > 0 Then
                                sJunk1$ = Mid(sJunk1$, 1, iRc% - 1)
                            End If
                            sSubdivision$ = sJunk1$ + Mid(sSubdivision$, iHyphenPtr%)
                            ' sSubdivision should now read, say, "3rd-5th"
                            ' re-point to the hyphen
                            iHyphenPtr% = Rat(sSubdivision$, "-")
                            Exit For
                        ElseIf Mid(sJunk1$, iRc% - 1, 1) = " " Then
                            GoTo SSFYE_ContinueWithCentury
                        End If
                    End If
                Next
                
                iRc% = InStr(sJunk1$, " ")
                If iRc% > 0 Then
                    ' re-assemble, with just the century numbers themselves
                    sSubdivision$ = Mid(sJunk1$, 1, iRc% - 1) + Mid(sSubdivision$, iHyphenPtr% + 1)
                    ' sSubdivision should now read, say, "3rd-5th"
                    ' re-point to the hyphen
                    iHyphenPtr% = Rat(sSubdivision$, "-")
                End If
            End If
            ' if we get here, it really looks like we have a single
            '   century
            iRc% = Rat(sSubdivision$, " ")
            If iHyphenPtr% > 0 And iHyphenPtr% > iRc% Then
                ' the putative ordinal part of the subdivision contains a hyphen, meaning
                '   that we have a range of centuries (despite the singular label);
                '   pretend that label was plural
                GoTo SSFYC_Centuries
            End If
            If iRc% > 0 Then
                ' we have something in the $y other than the number and
                '   "CENTURY"
                If InStr("123456789", Mid(sSubdivision$, iRc% + 1, 1)) > 0 Then
                    iRc% = Val(Mid(sSubdivision$, iRc% + 1))
                Else
                    iRc% = Val(sSubdivision$)
                End If
            Else
SSFYC_Century:  ' come here from "centuries" case (below) if it turns out that
                '   we actually have a subdivision for a single century
                ' on arrival we should already have thrown away the rightmost word in the
                '   subdivision, so the rightmost remaining word should be where we'll find the
                '   ordinal century number of interest
                iRc% = Val(sSubdivision$)
            End If
            ' create a range for the century, based on LC's declaration
            '   that centuries start in the "00" year and end in the
            '   "99" year
            ' by definition, a century can't bridge the BC/AD span (and we surely
            '   hope no one defines a monstrosity such as "1st century B.C.-1st century A.D." as a
            '   subdivision)
            ' RECALL that if we get here we have only a single century, NOT a span
            If bBCPresent Then
                ' we have a single B.C. century
                ' B.C. centuries run from 00 backwards to 01 (for example, the 1st century B.C. runs
                '   from 0100 to 0001; the second century from 0200 to 0101)
                ' HOWEVER, in parallel with the adjustment we make for A.D. centuries, we're going to
                '   keep the lead digit the same; so centuries are going to run from the 99 year
                '   to the 00 year; so the 1st century B.C. (an exception) runs from 99 to 1; the
                '   2nd century B.C. runs from 199 to 100; the 7th century B.C. runs from 699 to 600
                ' the thousands and hundreds digits in the left number match
                '   the ordinal century number; the corresponding digits in the right number are one less
                '   than the ordinal century number
                iRc% = iRc% - 1
                If iRc% = 0 Then
                    sSubdivision$ = Right(prvsSubfieldYZeroString$ + Trim(str(iRc%)) + "99", SUBFIELD_Y_DATE_SIZE%) + "-" + Right(prvsSubfieldYZeroString$ + Trim(str(iRc% - 1)) + "01", SUBFIELD_Y_DATE_SIZE%)
                Else
                    sSubdivision$ = Right(prvsSubfieldYZeroString$ + Trim(str(iRc%)) + "99", SUBFIELD_Y_DATE_SIZE%) + "-" + Right(prvsSubfieldYZeroString$ + Trim(str(iRc% - 1)) + "00", SUBFIELD_Y_DATE_SIZE%)
                End If
            Else
                ' we have a single A.D. century
                ' A.D. centuries run from 00 to 99 (for example, the 2rd century A.D. runs
                '   from 0100 to 0199; the 9th century from 0801 to 0899)
                ' the thousands and hundreds digits in both numbers are one less than the
                '   ordinal century number
                ' RECALL that what we're going here is creating a range that will be converted by
                '   the "AdjustLeadNumeric" routine in the caller into its final form; specifically,
                '   we DO NOT here subtract the upper number from prvlSubfieldYDateMaximum; that operation
                '   is performed by the caller
                iRc% = iRc% - 1
                If iRc% = 0 Then
                    ' 20090903: special exception for the first century AD (theoretically, 0000-0099):
                    '   we can 't start at "0000" because
                    '   that year doesn't exist, and ends us up in the wrong place; so we're going to use
                    '   the year "1" for this one century instead
                    ' if we go back to separate prefixes for BC and AD dates, then this
                    '   subterfuge should no longer be necessary
                    sSubdivision$ = Right(prvsSubfieldYZeroString$ + "1", SUBFIELD_Y_DATE_SIZE%) + "-" + Right(prvsSubfieldYZeroString$ + Trim(str((iRc% * 100) + 99)), SUBFIELD_Y_DATE_SIZE%)
                Else
                    sSubdivision$ = Right(prvsSubfieldYZeroString$ + Trim(str(iRc%)) + "00", SUBFIELD_Y_DATE_SIZE%) + "-" + Right(prvsSubfieldYZeroString$ + Trim(str((iRc% * 100) + 99)), SUBFIELD_Y_DATE_SIZE%)
                End If
            End If
            SfdSortingFormYExceptions = SfdSortingFormYReturn_AdjustLeadNumeric%
            Exit Function
        Case "CENTURIES" ' as in: "3rd-6th centuries"
            ' NOTE that since we're actually only testing the first 4 characters,
            '   and our comparison is a whole word, we can never arrive here
            '   on our own; we must instead come here via a branch provided in the
            '   "CENT" case above
            ' this structure evolved over time and it's far from elegant, but
            '   for now we'll leave it alone
SSFYE_Centuries:
            ' as above, this should be expandable for all kinds
            '   of centuries
            ' for reasons best known to themselves, LC sometimes uses oddball separators
            '   between centuries instead of hyphens; and of course individual libraries
            '   are all over the map when it comes to following (or, rather, not following) LC
            ' so here we attempt to allow for the possible variations
            ' first, throw away the terminal "centuries"
            'Debug.Print "Subdivision before: >" + sSubdivision$ + "<"
            sSubdivision$ = Trim(Mid(sSubdivision$, 1, iSpaceAt% - 1))
            iRc% = Rat(sSubdivision$, " AND ")
            If iRc% > 0 Then
                sSubdivision$ = Trim(Mid(sSubdivision$, 1, iRc% - 1)) + "-" + Trim(Mid(sSubdivision$, iRc% + SUBFIELD_Y_DATE_SIZE%))
            Else
                iRc% = Rat(sSubdivision$, " & ")
                If iRc% > 0 Then
                    sSubdivision$ = Trim(Mid(sSubdivision$, 1, iRc% - 1)) + "-" + Trim(Mid(sSubdivision$, iRc% + 2))
                Else
                    iRc% = Rat(sSubdivision$, " TO ")
                    If SfdSortingFormYExceptionsToIsOk(sSubdivision$, iRc%) Then
                        'Debug.Print "To is OK 1"
                        sSubdivision$ = Trim(Mid(sSubdivision$, 1, iRc% - 1)) + "-" + Trim(Mid(sSubdivision$, iRc% + 3))
                    Else
                        'Debug.Print "To is not OK 1"
                        ' if we don't have an exception, we hope that we have the normal thing
                        ' BUT make sure that there's no extraneous space around the hyphen
                        '   we expect to find
                        iRc% = Rat(sSubdivision$, "-")
                        If iRc% > 0 Then
                            sSubdivision$ = Trim(Mid(sSubdivision$, 1, iRc% - 1)) + "-" + Trim(Mid(sSubdivision$, iRc% + 1))
                        End If
                    End If
                End If
            End If
            'Debug.Print "Subdivision after:  >" + sSubdivision$ + "<"
            ' the century business may be preceded by a label, which
            '   we don't care about
            iRc% = Rat(sSubdivision$, " ")
            If iRc% > 0 Then
                sSubdivision$ = Trim(Mid(sSubdivision$, iRc% + 1))
            End If
            ' at this point, sSubdivision$ should contain just the ordinal
            '   part of the subdivision ("19th" or "3rd-6th" for example)
            iHyphenPtr% = InStr(sSubdivision$, "-")
            If iHyphenPtr% = 0 Then
                ' we appear to have only a single century, even though the
                '   label is "centuries"
                ' if this thing starts with a number, then
                '   we're going to assume that it is indeed a single
                '   century, but with (stupidly enough) the
                '   a plural rather than a singular accompanying
                '   word
                If InStr("123456789", Mid(sSubdivision$, 1, 1)) > 0 Then
                    GoTo SSFYC_Century
                End If
                ' if we get here, we don't properly know what we have
                ' restore the text to the cleaned-up version of what we started
                '   with, and pretend nothing is wrong
                SfdSortingFormYExceptions = SfdSortingFormYReturn_Normal%
                Exit Function
            End If
            ' if we pass the preceding test, we have a range of centuries (example: 15th-18th centuries)
SSFYC_Centuries:
            ' we branch here if we have "century" subdivision but despite the singular
            '   word we have a range of centuries (example: 15th-18th century)
            ' at this point, sSubdivision$ contains just the ordinal part of the original subdivision
            ' iHyphenPtr% should contain the location of the hyphen
            ' re-formulate the subdivision text to conform to our understanding of reality
            sSubdivision$ = Trim(Mid(sSubdivision$, 1, iHyphenPtr% - 1)) + "-" + Trim(Mid(sSubdivision$, iHyphenPtr% + 1))
            ' re-fetch the location of the hyphen
            iHyphenPtr% = Rat(sSubdivision$, "-")
            ' create a range following the standard pattern (see above notes for
            '   the beginning and ending dates of centuries and so on)
            iCentury1% = Val(Mid(sSubdivision$, 1, iHyphenPtr% - 1)) - 1
            iCentury2% = Val(Mid(sSubdivision$, iHyphenPtr% + 1)) - 1
            If bBCPresent Then
                If bADPresent Then
                    ' opening date is B.C., closing date is A.D.
                    ' we aren't aware that there are any of these, but we'd best allow for
                    '   them just in case (there ARE cases of "normal" subdivisions that
                    '   begin B.C. and end A.D.; and these appear to come out OK)
                    sYear1$ = Right(prvsSubfieldYZeroString$ + Trim(str(iCentury1%)) + "99", SUBFIELD_Y_DATE_SIZE%)
                    sYear2$ = Right(prvsSubfieldYZeroString$ + Trim(str(iCentury2%)) + "00", SUBFIELD_Y_DATE_SIZE%)
                    
                    sSubdivision$ = prvsSubfieldYZeroString$ + sYear1$ + SPANCODE_DIFFERENT_ERA$ + sYear2$
                Else
                    ' both opening and closing dates are B.C.
                    
                    If iCentury1% = 0 Then
                        ' really can't be the case if we have a range!!!!!
                        sYear1$ = "0099"
                    Else
                        sYear1$ = Right(prvsSubfieldYZeroString$ + Trim(str(iCentury1%)) + "99", SUBFIELD_Y_DATE_SIZE%)
                    End If
                    If iCentury2% = 0 Then
                        sYear2$ = "0001"
                    Else
                        sYear2$ = Right(prvsSubfieldYZeroString$ + Trim(str(iCentury2%)) + "00", SUBFIELD_Y_DATE_SIZE%)
                    End If
                    sSubdivision$ = prvsSubfieldYZeroString$ + sYear1$ + SPANCODE_SAME_ERA$ + prvsSubfieldYZeroString$ + sYear2$
                End If
            Else
                ' both dates are A.D.
                
                'sSubdivision$ = Right(prvsSubfieldYZeroString$ + Trim(str(iRc%)) + "00", SUBFIELD_Y_DATE_SIZE%) + "-" + Right(prvsSubfieldYZeroString$ + Trim(str(prvlSubfieldYDateMaximum - ((Val(Mid(sSubdivision$, iHyphenPtr% + 1)) - 1 * 100) + 99))), SUBFIELD_Y_DATE_SIZE%)
                If iCentury1% = 0 Then
                    sSubdivision$ = Right(prvsSubfieldYZeroString$ + "1", SUBFIELD_Y_DATE_SIZE%) + SPANCODE_SAME_ERA$ + Right(prvsSubfieldYZeroString$ + Trim(str(prvlSubfieldYDateMaximum - ((iCentury2% * 100) + 99))), SUBFIELD_Y_DATE_SIZE%)
                Else
                    sSubdivision$ = Right(prvsSubfieldYZeroString$ + Trim(str(iCentury1%)) + "00", SUBFIELD_Y_DATE_SIZE%) + SPANCODE_SAME_ERA$ + Right(prvsSubfieldYZeroString$ + Trim(str(prvlSubfieldYDateMaximum - ((iCentury2% * 100) + 99))), SUBFIELD_Y_DATE_SIZE%)
                End If
            End If
            SfdSortingFormYExceptions = SfdSortingFormYReturn_Normal%
            Exit Function
    End Select
    
    ' end of exceptions dealing with "century" subdivisions of all types
    
    ' additional exceptions follow
    
    ' there are unfortunately several ways to indicate that a span begins at
    '   infinity B.C. (why can't they all be the same?)
    If Mid(sSubdivision$, 1, 6) = "EARLY " Then
        ' the annotations for this case apply generatlly to the following
        '   cases
        iRc% = InStr(sSubdivision$, " TO ")
        If SfdSortingFormYExceptionsToIsOk(sSubdivision$, iRc%) Then
            'Debug.Print "To is OK 2"
            sSubdivision$ = prvsSubfieldYNineString$ + "-" + Trim(Mid(sSubdivision$, iRc% + 3))
            ' we assume that the range extends from infinity B.C. to
            '   the specified date, which is an A.D. date unless
            '   we know otherwise
            If Not bBCPresent Then
                ' the given date must be an AD date, and because we're
                '   adding in a BC date, we must explicitly indicate that
                '   the second date is an AD date
                bADPresent = True
            'Else
                ' the given date is a BC date, so BC is all we have, and
                '   we already know that
            End If
            ' the first date in ALL of these is a BC date
            bBCPresent = True
            SfdSortingFormYExceptions = SfdSortingFormYReturn_AdjustLeadNumeric%
        'Else
            'Debug.Print "To is NOT OK 2"
        End If
    ElseIf Mid(sSubdivision$, 1, 11) = "ANCIENT TO " Then
        sSubdivision$ = prvsSubfieldYNineString$ + "-" + Trim(Mid(sSubdivision$, 12))
        If Not bBCPresent Then
            bADPresent = True
        End If
        bBCPresent = True
        SfdSortingFormYExceptions = SfdSortingFormYReturn_AdjustLeadNumeric%
    ElseIf Mid(sSubdivision$, 1, 7) = "BEFORE " Then
        sSubdivision$ = prvsSubfieldYNineString$ + "-" + Trim(Mid(sSubdivision$, 8))
        If Not bBCPresent Then
            bADPresent = True
        End If
        bBCPresent = True
        SfdSortingFormYExceptions = SfdSortingFormYReturn_AdjustLeadNumeric%
    ElseIf Mid(sSubdivision$, 1, 3) = "TO " Then
        If SfdSortingFormYExceptionsToIsOk(" " + sSubdivision$, 1) Then ' fake out the routine slightly ...
            'Debug.Print "To is OK 3"
            sSubdivision$ = prvsSubfieldYNineString$ + "-" + Trim(Mid(sSubdivision$, SUBFIELD_Y_DATE_SIZE%))
            If Not bBCPresent Then
                bADPresent = True
            End If
            bBCPresent = True
            SfdSortingFormYExceptions = SfdSortingFormYReturn_AdjustLeadNumeric%
        Else
            'Debug.Print "To is NOT OK 3"
            GoTo SSFYE_NormalNoneOfTheAbove
        End If
    Else ' none of the above
SSFYE_NormalNoneOfTheAbove:
        ' this is mostly to allow for the occasional badly-formatted bib heading ...
        iRc% = InStr(sSubdivision$, " TO ")
        If SfdSortingFormYExceptionsToIsOk(sSubdivision$, iRc%) Then
            'Debug.Print "To is OK 4"
            ' if there are any digits to the left of the hyphen, then start with those
            '   digits; otherwise, this is a normal "TO" heading
            bFound = False
            For iRc2% = 1 To iRc% - 1
                If InStr("0123456789", Mid(sSubdivision$, iRc2%, 1)) > 0 Then
                    bFound = True
                    Exit For
                End If
            Next ' irc%
            'Debug.Print "Digits found? " + str(bFound)
            If bFound Then
                sSubdivision$ = Trim(Mid(Mid(sSubdivision$, 1, iRc%), iRc2%)) + "-" + Trim(Mid(sSubdivision$, iRc% + 3))
            Else
                sSubdivision$ = Trim(Mid(sSubdivision$, iRc% + 3))
                iRc% = InStr(sSubdivision$, " ")
                If iRc% > 0 Then
                    sSubdivision$ = Mid(sSubdivision$, 1, iRc% - 1)
                End If
                sSubdivision$ = prvsSubfieldYNineString$ + "-" + sSubdivision$
                If Not bBCPresent Then
                    bADPresent = True
                End If
                bBCPresent = True
                SfdSortingFormYExceptions = SfdSortingFormYReturn_AdjustLeadNumeric%
                Exit Function
            End If
            'Debug.Print "Subdivision: >" + sSubdivision$ + "<"
        'Else
            'Debug.Print "To is NOT OK 4"
        End If
    End If
    
    ' additional exceptions could go here, if we knew of any

End Function

Public Function SfdSortingFormY(ByVal sSfdText$) As String

    ' 20090221 routine and dependents added: generate a sortable equivalent
    '   for a chronological subject subdvision (bibliographic 6XX $y for example)
    ' the goals of this routine are:
    '   1) to get earlier dates before later dates
    '   2) to get broader spans before narrower spans that have the same start date
    '   3) to get BC dates before AD dates
    '
    ' there are some unusual things going on here that bear general explanation (much
    '   of this is referred to again at relevant points)
    ' 1) all dates are expressed as spans. if there is only one date, it is repeated to
    '    create the span ("War of 1812" becomes "1812-1812").  if the span is open
    '    we use an "infinity" marker at the open end (left or right) to make things
    '    come out right ("To 1492" becomes "9999 B.C.-1492; "1945- " becomes "1945-9999")
    ' 2) some dates are "reversed" to achieve the proper sorting order.  for example,
    '    a set of BC dates needs to be sorted with the earliest date first; but sorting
    '    in order by the date as given would produce the wrong order. to achieve
    '    proper order, we "reverse" the date by subtracting the given date from
    '    some arbitrary value (the maximum date allowed for).  or again: dates
    '    expressed as spans need to be sorted with the broader span before the
    '    a narrower span with the same beginning year; to achieve this, we "reverse"
    '    the second date (unless the second date is a BC date)
    ' 3) BC dates are assigned an arbitary prefix that causes them to sort before AD
    '    dates, which are assigned a different arbitrary prefix. any two characters that have
    '    the proper collation order would do the job
    ' 4) we use an arbitrary code to sparate the two dates in a range. if the two
    '    dates are in the same "era" (i.e., both BC or both AD) we use one marker; if
    '    the two dates are in different eras (one BC, one AD) we use a marker that
    '    has a collation order lower than the marker for dates in the same era. this causes
    '    spans that cross the BC/AD divide to file before dates that have the same BC starting
    '    date but end in the BC era.  (the dates that cross from BC to AD are "broader" than
    '    those with the same starting date that don't so cross, so they need to come first).
    '    the collation sequence of these codes should be higher than the codes that mark
    '    the BC and AD dates themselves
    ' 5) if the first date in the range contains a recognizable month (and perhaps day) it's
    '    tacked on to the end of the opening date, after another arbitrary code (whose collating
    '    sequence should be higher than any of the others); we don't even bother to look for
    '    month and day in the second date, becuase of the extremely low likelihood that it would
    '    have any effect on sorting order
    
    
    Dim bBCPresent As Boolean, bADPresent As Boolean
    
    Dim iRc%, iRc2%
    
    Dim sJunk1$, sJunk2$, sDate1$, sDate2$, sTextWithoutMarkers$, sDate1Extension$, sRemainder$
    Dim sDate1Marker$, sDate2Marker$, sSeparator$
    
    
    sSfdText$ = SafeUCase(sSfdText$)
    
    
    ' the following applies generally: we need to know if we're
    '   dealing with two BC dates, two AD dates, or one of each:
    '   * if we have only BC then both dates are BC
    '   * if we have both BC and AD, then the first is BC and the second is AD
    '   * if we have neither, then both dates are AD
    ' sadly (especially in bibliographic records) these important markers
    '   can appear in a number of guises
    SfdSortingFormDandYTestBcAdMarkers sSfdText$, bBCPresent, bADPresent
    
    ' the following applies principally to the 4xx fields our
    '   authority loader generates from authority 1XX fields; but
    '   sadly enough, some bibliographic records have the subdivisions wrong
    ' the following ALSO applies to subfields $y that have month and day
    '   in parens: Venezuela |x History |y Attempted coup, 1992 (February 4)
    ' anyway, the point is: if we have an expression at the right end that's
    '   in parentheses, throw it away, leaving (we hope) just the dates; dealing,
    '   as you do so, with any month and day that may be present
    ' HOWEVER, in a very few cases (at least, for a few old headings) the stuff
    '   in parentheses is in fact the only date in the string
    '   example: -- Five-year plan, Fifth (1946-1950)
    '   example: -- Poland (1941-1945)
    If Right(sSfdText$, 1) = ")" Then
        iRc% = Rat(sSfdText$, " (")
        If iRc% > 0 Then
            sRemainder$ = NormString(Mid(SfdText$, iRc% + 2)) ' converting any hyphen to a space
            'Debug.Print "Remainder: >" + sRemainder$ + "<"
            If InStr("0123456789", Mid(sRemainder$, 1, 1)) = 0 Then
                If SfdSortingFormYMonth(sRemainder$, sDate1Extension$) Then
                    ' the parenthesized addition contains a date; sDate1Extension$ contains
                    '   a character representation of the month number
                    ' is there a day following the month?
                    iRc2% = InStr(sRemainder$, " ")
                    If iRc2% > 0 Then
                        sRemainder$ = Trim(Mid(sRemainder$, iRc2% + 1))
                        iRc2% = InStr(sRemainder$, " ")
                        If iRc2% = 0 Then
                            sDate1Extension$ = sDate1Extension$ + Right("00" + Trim(str(Val(sRemainder$))), 2)
                        Else
                            sDate1Extension$ = sDate1Extension$ + Right("00" + Trim(str(Val(Mid(sRemainder$, 1, iRc2% - 1)))), 2)
                        End If
                    End If
                End If
                ' iRc% still points to the location of the opening
                '   parenthesis
                sSfdText$ = Mid(sSfdText$, 1, iRc% - 1)
            End If
        End If
    End If
    
    ' if we have dates in parentheses but no preceding comma,
    '   replace the parentheses with a comma
    iRc% = Rat(sSfdText$, "(")
    'Debug.Print "Sfd text: >" + sSfdText$ + "< " + str(iRc%)
    If iRc% > 0 Then
        ' todo: would be nice to annotate with an example or two
        If InStr("123456789", Mid(sSfdText$, iRc% + 1, 1)) > 0 Then
            sSfdText$ = Trim(Mid(sSfdText$, 1, iRc% - 1)) + ", " + Trim(Mid(sSfdText$, iRc% + 1))
        End If
    End If
    
    ' convert to uppercase, and remove the BC and AD markers
    sJunk2$ = SfdSortingFormDandYPseudoNormalization(sSfdText$)
    'Debug.Print "Pseudo norm: >" + sJunk2$ + "<"
    
    ' save us a copy of the processed subfield just in case we want it
    '   later
    sTextWithoutMarkers$ = sJunk2$
    
    
    
    ' whew! preliminaries are out of the way
    
    
    iRc% = Rat(sJunk2$, " ")
    If iRc% > 0 Then
        
        ' there are some additional things to get
        '   out of the way before we get to the regular stuff
        ' for the record: during development, I tried two different arrangements of the
        '   tasks performed by the 'exceptions' code; one arrangement like this, as a
        '   separate module, the other in-line within this module.  timings
        '   were consistently faster when the exceptions code was in a separate module; I don't
        '   understand that result, but I believe that the numbers don't lie and we'll keep this as a
        '   separate routine
        Select Case SfdSortingFormYExceptions(sJunk2$, iRc%, bBCPresent, bADPresent, sTextWithoutMarkers$)
            Case SfdSortingFormYReturn_AdjustLeadNumeric%
                'Debug.Print "Returned subdiv, adjust lead: >" + sJunk2$ + "<"
                GoTo SSFY_AdjustLeadNumeric
            Case SfdSortingFormYReturn_Normal% ' not currently used
                'Debug.Print "Returned subdiv, normal: >" + sJunk2$ + "<"
                GoTo SSFY_NormalTreatment
            Case Else ' must be: SfdSortingFormYReturn_Nothing%
                'Debug.Print "Returned subdiv, other: >" + sJunk2$ + "<"
                ' continue immediately below
        End Select
        
        
        ' nothing of note found by the exceptions routine, so we'll assume that we've got
        '   a typical subfield $y here (we're hoping that
        '   it's in the form "<text>, <numeric date>")
        
        ' restore the original subfield text, minus "BC", "AD", and
        '   other unwanted accretions
        sJunk2$ = sTextWithoutMarkers$
        
        ' now that we've got centuries out of the way, remaining $y subfields that begin
        '   with numerals are ready to be examined without further ado
        If InStr("0123456789", Mid(sJunk2$, 1, 1)) > 0 Then
            ' $y begins with numeral: "normalize" the numeric part
            GoTo SSFY_AdjustLeadNumeric
        End If
        
        ' the vast majority of the remainders that end up here will be
        '    in this form: "<text>, <numeric date>"
        ' BUT there is at least one more exception: the date may consist of text, comma, month (and day),
        '   another comma, then the year; so we need to deal with the comma that's part of the date
        '   (and at the same time deal with the month (and day) before we go looking for the
        '   comma that separates the initial text label from the date proper
        ' naturally, we wish that subdivisions weren't structured this way ...
        For iRc% = Len(sJunk2$) To 1 Step -1
            If Mid(sJunk2$, iRc%, 1) = "," Then
                ' if the thing that follows the rightmost comma is a numeral, then
                '   we appear to have the standard <label>,<date> pattern, so nothing
                '   special is needed
                If InStr("0123456789", Mid(Trim(Mid(sJunk2$, iRc% + 1)), 1, 1)) > 0 Then
                    Exit For
                Else
                    ' the rightmost comma is not followed by a numeral
                    If SfdSortingFormYMonth(Trim(Mid(sJunk2$, iRc% + 1)), sDate1Extension$) Then
                        'Debug.Print "Month 1: >" + sSfdText$ + "<"
                        ' the rightmost comma is followed by a month; this function returns in
                        '   sDate1Extension the numeric equivalent for the month label (01-12)
                        ' separate off this entire date lump
                        sRemainder$ = Trim(Mid(sJunk2$, iRc% + 1))
                        iRc% = InStr(sRemainder$, " ")
                        If iRc% > 0 Then
                            ' throw away the month part
                            sRemainder$ = Trim(Mid(sRemainder$, iRc% + 1))
                            ' is there a day plus year here?
                            iRc% = InStr(sRemainder$, " ")
                            If iRc% > 0 Then
                                ' add the day to the month
                                sDate1Extension$ = sDate1Extension$ + Right("00" + Trim(str(Val(Trim(Mid(sRemainder$, 1, iRc% - 1))))), 2)
                                If InStr("123456789", Mid(sRemainder$, iRc% + 1, 1)) > 0 Then
                                    sJunk2$ = Mid(sRemainder$, iRc% + 1)
                                Else
                                    ' shouldn't be happening!
                                    sJunk2$ = sRemainder$
                                End If
                            Else
                                sJunk2$ = sRemainder$
                            End If
                        End If
                        ' regardless of what just happened, we now have a single
                        '   date with no hyphens or anything
                        iRc% = 0
                        GoTo SSFY_AdjustLeadNumeric
                    End If
                End If
            End If
        Next ' irc%
        
        ' if we get here, there was no comma of interest
        
        If iRc% < 1 Then
            ' if we get here, there was no comma at all (interesting or
            '   otherwise)
            ' here's another exception: headings such as "revolution of ..."
            '   and "invasion of ..." that don't involve commas
            iRc% = Rat(UCase(sJunk2$), " OF ")
            If iRc% > 0 Then
                If InStr("0123456789", Mid(Trim(Mid(sJunk2$, iRc% + 4)), 1, 1)) > 0 Then
                    sJunk2$ = Trim(Mid(sJunk2$, iRc% + 4))
                    GoTo SSFY_AdjustLeadNumeric
                End If
            End If
            ' here's an exception for just one 4XX:
            '   Yucatan (Mexico : State) $x History $y Revolucion Indigena de 1847
            ' if the date here boiled down to the same date as the date in the 1XX, we'd
            '   have grounds for complaint, but as it doesn't, we don't (at least, no
            '   grounds that anyone at LC would care about)
            iRc% = Rat(UCase(sJunk2$), " DE ")
            If iRc% > 0 Then
                If InStr("0123456789", Mid(Trim(Mid(sJunk2$, iRc% + 4)), 1, 1)) > 0 Then
                    sJunk2$ = Trim(Mid(sJunk2$, iRc% + 4))
                    GoTo SSFY_AdjustLeadNumeric
                End If
            End If
            
            ' maybe the first date begins with a month?
            If SfdSortingFormYMonth(UCase(sJunk2$), sDate1Extension$) Then
                ' yes, there is a month here; numeric equivalent is now in sDateExtension1$
                'Debug.Print "Month 2: >" + sSfdText$ + "<"
                iRc% = InStr(sJunk2$, " ")
                If iRc% > 0 Then
                    sJunk2$ = Trim(Mid(sJunk2$, iRc% + 1))
                    If Len(sJunk2$) > 3 Then
                        If InStr("123456789", Mid(sJunk2$, 1, 1)) > 0 Then
                            If InStr("0123456789", Mid(sJunk2$, 2, 1)) > 0 Then
                                If InStr("0123456789", Mid(sJunk2$, 3, 1)) > 0 Then
                                    If InStr("0123456789", Mid(sJunk2$, 4, 1)) > 0 Then
                                        ' we have a month and year
                                        GoTo SSFY_AdjustLeadNumeric
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
                ' if we get here, the thing that we thought was a
                '   date extension isn't really
                ' NOTE that at least for subdivisions in LCSH authority records as
                '   of 20090301, we never get here
                sDate1Extension$ = ""
            End If
        
            ' maybe we have something else that's "TO"? (example: Spanish exploration to 1565)
            iRc% = InStr(sJunk2$, " TO ")
            If SfdSortingFormYExceptionsToIsOk(sJunk2$, iRc%) Then
                'Debug.Print "To is OK 5"
                sJunk2$ = Trim(Mid(sJunk2$, iRc% + 4))
                GoTo SSFY_AdjustLeadNumeric
            'Else
                'Debug.Print "To is NOT OK 5"
            End If
            
            ' the $y subfield doesn't contain "text, date", so there's no special treatment
            ' we will make no attempt at chronological sorting for this subfield
            ' most of the things that end up here should be geological eras
            sJunk2$ = NormString(sTextWithoutMarkers$)
            GoTo SSFY_NormalTreatment
        End If
        
        ' if we get here, iRc points to what seems to be a good-looking comma
        If (InStr("0123456789", Mid(Trim(Mid(sJunk2$, iRc% + 1)), 1, 1)) = 0) Then '  And (UCase(Mid(Trim(Mid(sJunk2$, iRc% + 2)), 1, 3)) <> "CA." And InStr("0123456789", Mid(sJunk2$, iRc% + 6, 1)) > 0) Then
            ' $y doesn't contain "text, date": no special treatment
            sJunk2$ = NormString(sSfdText$)
            GoTo SSFY_NormalTreatment
        End If
        
        ' we've got something in the form "<text>, "<numeric date>"; iRc% points
        '   to the comma
        
        ' throw away the text label, so we've got only the date
        sJunk2$ = Trim(Mid(sJunk2$, iRc% + 2))
        
    Else ' 'normalized' subdivision contains no spaces
    
        ' if there isn't a space in the subdivision, we either have something with
        '   dates only, or something in an unrecognized form
        Select Case Mid(sJunk2$, 1, 1)
            Case "-"
                If Not bBCPresent Then
                    bADPresent = True
                'Else
                    ' if BC is present explicitly, then AD is only present
                    '   if it's specified explicitly, which we already detected above
                End If
                ' ALL of these begin infinity BC
                bBCPresent = True
                sJunk2$ = prvsSubfieldYZeroString$ + sJunk2$
                ' having created a span, fall through to SSFY_AdjustLeadNumeric for
                '   standard handling of dates expressed as numerals
            Case "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"
                ' these are all OK; we'll fall through to normal handling at
                '   SSFY_AdjustLeadNumeric; if the rightmost character is a hyphen at
                '   this point, we'll add the closing (infinity) date at that time
            Case Else
                ' $y-with-no-space also has no lead numeral: treat this single word as
                '   plain text
                sJunk2$ = NormString(sSfdText$)
                GoTo SSFY_NormalTreatment
        End Select
        
    End If ' is there a space somewhere in the subfield?
    
SSFY_AdjustLeadNumeric:

    'Debug.Print "Adjust lead numeric to: >" + sJunk2$ + "<"
    ' the basic premise at this point is: we've got a range of dates
    '   separated by a hyphen
    iRc% = InStr(sJunk2$, "-")
    If iRc% = 0 Then
        ' we have only a single date
        ' fake the single date into a span consisting of the
        '   same date for the beginning and the end; after "reversal" of the
        '   second year (see below), this means that the single years will file AFTER
        '   explicit ranges that begin with the same year, giving us the
        '   desired order of broader-before-narrower:
        '     --1918-1933
        '     --Revolution, 1918 <--only a single is present
        sDate1$ = NormString(sJunk2$)
        sDate2$ = sDate1$ ' sJunk2$
    Else
        sDate1$ = NormString(Mid(sJunk2$, 1, iRc% - 1))
        sDate2$ = NormString(Mid(sJunk2$, iRc% + 1))
        If Len(sDate2$) = 0 Then
            sDate2$ = prvsSubfieldYNineString$ ' if A.D., this will be "reversed" to zeroes, which is what we want
        End If
    End If
    
    ' if date1 consists of a year plus month and day, convert
    '   here the extraneous information
    ' we don't believe we have the need to worry about
    '   month and day in date 2--we'll let the chips
    '   fall where they may, as it were
    iRc% = InStr(sDate1$, " ")
    If iRc% > 0 Then
        If SfdSortingFormYMonth(Mid(sDate1$, iRc% + 1), sDate1Extension$) Then
            sRemainder$ = Trim(Mid(sDate1$, iRc% + 1))
            sDate1$ = Mid(sDate1$, 1, iRc% - 1)
        Else
            sRemainder$ = "" ' make sure there's nothing
        End If
        If Len(sRemainder$) > 0 Then
            iRc% = InStr(sRemainder$, " ")
            If iRc% > 0 Then
                sDate1Extension$ = sDate1Extension$ + Right("00" + Trim(str(Val(Trim(Mid(sRemainder$, iRc% + 1))))), 2)
            End If
        End If
    End If
    
    ' remove all of the non-numeric information (including
    '   spaces and punctuation) from each of the two dates
    For iRc% = Len(sDate1$) To 1 Step -1
        If InStr("0123456789", Mid(sDate1$, iRc%, 1)) = 0 Then
            sDate1$ = SafeStuff(sDate1$, iRc%, 1, "")
        End If
    Next ' irc%
    For iRc% = Len(sDate2$) To 1 Step -1
        If InStr("0123456789", Mid(sDate2$, iRc%, 1)) = 0 Then
            sDate2$ = SafeStuff(sDate2$, iRc%, 1, "")
        End If
    Next ' irc%
    ' the dates must each be at least the appropriate length (probably 4 digits); force them
    '   to be longer if necessary
    If Len(sDate1$) < SUBFIELD_Y_DATE_SIZE% Then
        sDate1$ = Right(prvsSubfieldYZeroString$ + sDate1$, SUBFIELD_Y_DATE_SIZE%)
    End If
    Select Case Len(sDate2$)
        Case SUBFIELD_Y_DATE_SIZE%
        Case Is < SUBFIELD_Y_DATE_SIZE%
            sDate2$ = Right(prvsSubfieldYZeroString$ + sDate2$, SUBFIELD_Y_DATE_SIZE%)
        Case Else
            sDate2$ = Mid(sDate2$, 1, SUBFIELD_Y_DATE_SIZE%)
    End Select
    
    ' if the original subfield also contains
    '   A.D., that designation can apply only to the second date following
    '   a B.C. date; if it's not present, then they're
    '   BOTH B.C. dates
    If bBCPresent Then
        ' if the original subfield contains a B.C. date, the first date
        '   must always be the B.C. date
        'sDate1Marker$ = BC_MARKER$
        ' "reverse" this first date by subtracting it from the
        '   maximum value; this causes earlier B.C. dates (which, after subtraction,
        '   have small remainders) to file before later B.C. dates (which, after
        '   subtraction, have large remainders)
        sDate1$ = prvsSubfieldYZeroString$ + Right(prvsSubfieldYZeroString$ + Trim(str(prvlSubfieldYDateMaximum - Val(sDate1$))), SUBFIELD_Y_DATE_SIZE%)
        
        If Not bADPresent Then
            'sDate2Marker$ = BC_MARKER$
            ' the second date is a BC date as well
            ' NOTE that when we have 2 BC dates we DO NOT "reverse" the second date by
            '   subtracting it from some arbitrary value (as we do when the
            '   second date is an AD date); that's because the numeral
            '   as given will by its very nature create the "broader-before-narrower" order
            '   that we want (imaginary example):
            '       512 B.C.-142 B.C.  becomes 9487-0142 larger span than:
            '       512 B.C.-245 B.C.  becomes 9487-0245
            sDate2$ = prvsSubfieldYZeroString$ + sDate2$
        Else
            'sDate2Marker$ = AD_MARKER$
            ' the BC date is followd by an AD date
            ' following the standard practice for AD dates in the scond
            '   position, we "reverse" it; this allows broader headings
            '  to come before narrower ones (same principle as
            '   if the first date were an AD date; see below)
            sDate2$ = Right(prvsSubfieldYZeroString$ + Trim(str(prvlSubfieldYDateMaximum - Val(sDate2$))), SUBFIELD_Y_DATE_SIZE%)
        End If
    Else
        'sDate1Marker$ = AD_MARKER$
        'sDate2Marker$ = AD_MARKER$
        ' we have two AD dates
        ' leave the first date alone
        ' the second date needs to be "reversed", so
        '   broader things come before narrower things
        ' example:
        '   1918-1933        becomes 1918-8066
        '   Revolution, 1918 becomes 1918-8081 (beginning and ending in a single year)
        'Debug.Print "Adjusting DAte 2 '" + sDate2$ + "' via " + str(prvlSubfieldYDateMaximum) + " and zero string: >" + prvsSubfieldYZeroString$ + "<"
        sDate2$ = Right(prvsSubfieldYZeroString$ + Trim(str(prvlSubfieldYDateMaximum - Val(sDate2$))), SUBFIELD_Y_DATE_SIZE%)
    End If
    
    ' add on any month/day associated with the opening date in the span
    If Len(sDate1Extension$) > 0 Then
        sDate1$ = sDate1Marker$ + sDate1$ + DATE_1_EXTENSION_PREFIX$ + sDate1Extension$
    Else
        sDate1$ = sDate1Marker$ + sDate1$
    End If
    
        
    ' reconstruct the sorting form for the two dates, inserting the
    '   appropriate separating code to describe the relationship
    '   of the two dates (do the dates span the B.C./A.D. divide, or not)
    If bBCPresent Then
        If bADPresent Then
            'sJunk2$ = sDate1$ + "-" + sDate2Marker$ + sDate2$
            sJunk2$ = sDate1$ + SPANCODE_DIFFERENT_ERA$ + sDate2Marker$ + sDate2$
        Else
            'sJunk2$ = sDate1$ + "-" + sDate2Marker$ + sDate2$
            sJunk2$ = sDate1$ + SPANCODE_SAME_ERA$ + sDate2Marker$ + sDate2$
        End If
    Else
        'sJunk2$ = sDate1$ + "-" + sDate2Marker$ + sDate2$
        sJunk2$ = sDate1$ + SPANCODE_SAME_ERA$ + sDate2Marker$ + sDate2$
    End If
    
SSFY_NormalTreatment: ' if we branch here, we must sJunk2$ is ready to go (default handling)

    SfdSortingFormY = sJunk2$
    

End Function

Public Property Get FldBoolean1() As Boolean

    ' 20090420: FldBoolean1 and FldBoolean2 added to allow for external
    '   use by external programs; these field-level booleans can be freely written and read by the
    '   outside; within this object, we take no particular notice
    
    If FldPointer > -1 Then
        FldBoolean1 = MarcArray(FldPointer).Boolean1
    Else
        FldBoolean1 = False
    End If

End Property

Public Property Let FldBoolean1(ByVal vNewValue As Boolean)

    ' 20090420: FldBoolean1 and FldBoolean2 added to allow for external
    '   use by external programs; these field-level booleans can be freely written and read by the
    '   outside; within this object, we take no particular notice
    
    If FldPointer > -1 Then
        MarcArray(FldPointer).Boolean1 = vNewValue
    End If
    
End Property
Public Property Get FldBoolean2() As Boolean

    ' 20090420: FldBoolean1 and FldBoolean2 added to allow for external
    '   use by external programs; these field-level booleans can be freely written and read by the
    '   outside; within this object, we take no particular notice
    
    If FldPointer > -1 Then
        FldBoolean2 = MarcArray(FldPointer).Boolean2
    Else
        FldBoolean2 = False
    End If

End Property

Public Property Let FldBoolean2(ByVal vNewValue As Boolean)

    ' 20090420: FldBoolean1 and FldBoolean2 added to allow for external
    '   use by external programs; these field-level booleans can be freely written and read by the
    '   outside; within this object, we take no particular notice
    
    If FldPointer > -1 Then
        MarcArray(FldPointer).Boolean2 = vNewValue
    End If
    
End Property


Public Property Get SfdBoolean1() As Boolean

    ' 20090420: SfdBoolean1 and SfdBoolean2 added to allow for external
    '   use by external programs; these subfield-level booleans can be freely written and read by the
    '   outside; within this object, we take no particular notice
    
    If FldPointer > -1 And SfdPointer > -1 Then
        SfdBoolean1 = MarcArray(FldPointer).Subfield(SfdPointer).Boolean1
    Else
        SfdBoolean1 = False
    End If
    
End Property

Public Property Let SfdBoolean1(ByVal vNewValue As Boolean)

    ' 20090420: SfdBoolean1 and SfdBoolean2 added to allow for external
    '   use by external programs; these subfield-level booleans can be freely written and read by the
    '   outside; within this object, we take no particular notice
    
    If FldPointer > -1 And SfdPointer > -1 Then
        MarcArray(FldPointer).Subfield(SfdPointer).Boolean1 = vNewValue
    End If
    
End Property

Public Property Get Sfdboolean2() As Boolean

    ' 20090420: SfdBoolean1 and SfdBoolean2 added to allow for external
    '   use by external programs; these subfield-level booleans can be freely written and read by the
    '   outside; within this object, we take no particular notice
    
    If FldPointer > -1 And SfdPointer > -1 Then
        Sfdboolean2 = MarcArray(FldPointer).Subfield(SfdPointer).Boolean2
    Else
        Sfdboolean2 = False
    End If
    
End Property

Public Property Let Sfdboolean2(ByVal vNewValue As Boolean)

    ' 20090420: SfdBoolean1 and SfdBoolean2 added to allow for external
    '   use by external programs; these subfield-level booleans can be freely written and read by the
    '   outside; within this object, we take no particular notice
    
    If FldPointer > -1 And SfdPointer > -1 Then
        MarcArray(FldPointer).Subfield(SfdPointer).Boolean2 = vNewValue
    End If
    
End Property


Public Function Default008(ByVal sSingleCharacterMarcFormatCode$, Optional ByVal sSuppliedDateOfCreation$ = "") As String

    Dim sDateOfCreation$
    
    If Len(sSuppliedDateOfCreation$) = 6 Then
        sDateOfCreation$ = sSuppliedDateOfCreation$
    Else
        sDateOfCreation$ = Format(Now, "yyyymmdd")
    End If

    Select Case sSingleCharacterMarcFormatCode$
        Case "A"
            Default008 = sDateOfCreation$ + Mid(m_sDefault008A$, 7)
        Case "B"
            Default008 = sDateOfCreation$ + Mid(m_sDefault008B$, 7)
        Case "D"
            Default008 = sDateOfCreation$ + Mid(m_sDefault008D$, 7)
        Case "F"
            Default008 = sDateOfCreation$ + Mid(m_sDefault008F$, 7)
        Case "H"
            Default008 = sDateOfCreation$ + Mid(m_sDefault008H$, 7)
        Case "M"
            Default008 = sDateOfCreation$ + Mid(m_sDefault008M$, 7)
        Case "P"
            Default008 = sDateOfCreation$ + Mid(m_sDefault008P$, 7)
        Case "Q"
            Default008 = sDateOfCreation$ + Mid(m_sDefault008Q$, 7)
        Case "S"
            Default008 = sDateOfCreation$ + Mid(m_sDefault008S$, 7)
        Case "U"
            Default008 = sDateOfCreation$ + Mid(m_sDefault008U$, 7)
        Case "W"
            Default008 = sDateOfCreation$ + Mid(m_sDefault008W$, 7)
    End Select

End Function

Public Property Get SfdSortingForm(ByVal bSubfieldComesFromPersonalNameHeading As Boolean) As String

    Dim sSfd$
    
    Dim iRc%
    
    
    If FldPointer < 0 Or SfdPointer < 0 Then
        SfdSortingForm = ""
        Exit Property
    End If
    
    Select Case SfdCode
    
        Case "a"
        
            sSfd$ = SfdNormNaco
            iRc% = InStr(sSfd$, ", ")
            If iRc% = 0 Or Not bSubfieldComesFromPersonalNameHeading Then
                ' we want to retain the parenthesis, to force Text+Qualifier
                '   to file ahead of Text+MoreText
                iRc% = InStr(SfdText, "(")
                If iRc% > 0 Then
                    ' normalize the stuff before and after, retaining also the
                    '   open parenthesis itself
                    sSfd$ = NormString(Mid(SfdText, 1, iRc% - 1)) + " (" + NormString(Mid(SfdText, iRc% + 1))
                'Else
                    ' sSfd is already the NACO normalized form, so it's already OK
                End If
            Else
                ' personal name with internal comma: retain the comma
                ' 20080907: remove spaces from multiple surnames and names
                '   with prefixes so they file AFTER the initial word as the whole surname
                ' RECALL in this that we're starting from the NACO form, and NOTE ALSO
                '   that this RETAINS the comma and its trailing space, no problem
                sSfd$ = RemoveSpaces(Mid(sSfd$, 1, iRc% - 1)) + Mid(sSfd$, iRc%)
            End If
    
        Case "d"
        
            sSfd$ = SfdSortingFormD(SfdText)
            
        Case "y"
        
            sSfd$ = SfdSortingFormY(SfdText)
        
        Case Else
        
            sSfd$ = SfdNormNaco
            
    End Select
    
    SfdSortingForm = sSfd$

End Property

Private Sub SfdSortingFormDandYTestBcAdMarkers(ByRef sSfdText$, ByRef bBCPresent As Boolean, ByRef bADPresent As Boolean)

    Dim iRc%
    
    
    ' report on the presence of terms meaning "Before Christ" and "Anno Domini"
    ' NOTE that there is no logic here regarding any combinations discovered in this work;
    '   that logic is the responsibility of the caller
    ' RECALL that we have already done SafeUppercase to the text, so there's
    '   no need to worry with specifying vbTextCompare in our calls to InStr
    
    ' these references to "B.C" neatly cover "B.C.E.", too
    If InStr(sSfdText$, "B.C.") > 0 Then
        bBCPresent = True
        ' if B.C. is preceded by a comma, remove that comma
        iRc% = InStr(sSfdText$, ", B.C.")
        If iRc% > 0 Then
            sSfdText$ = SafeStuff(sSfdText$, iRc%, 1, "")
        Else
            iRc% = InStr(sSfdText$, ",B.C.")
            If iRc% > 0 Then
                sSfdText$ = SafeStuff(sSfdText$, iRc%, 1, " ")
            End If
        End If
    ElseIf InStr(sSfdText$, "B. C.") > 0 Then
        bBCPresent = True
        ' if B. C. is preceded by a comma, remove that comma
        iRc% = InStr(sSfdText$, ", B. C.")
        If iRc% > 0 Then
            sSfdText$ = SafeStuff(sSfdText$, iRc%, 1, "")
        Else
            iRc% = InStr(sSfdText$, ",B. C.")
            If iRc% > 0 Then
                sSfdText$ = SafeStuff(sSfdText$, iRc%, 1, " ")
            End If
        End If
    ElseIf InStr(sSfdText$, " BC") > 0 Then
        bBCPresent = True
        iRc% = InStr(sSfdText$, ", BC")
        If iRc% > 0 Then
            sSfdText$ = SafeStuff(sSfdText$, iRc%, 1, "")
        End If
    Else
        bBCPresent = False
    End If
    
    ' same as above, but now for CE markers
    If InStr(sSfdText$, "C.E.") > 0 Then
        bADPresent = True
        iRc% = InStr(sSfdText$, ", C.E.")
        If iRc% > 0 Then
            sSfdText$ = SafeStuff(sSfdText$, iRc%, 1, "")
        Else
            iRc% = InStr(sSfdText$, ",C.E.")
            If iRc% > 0 Then
                sSfdText$ = SafeStuff(sSfdText$, iRc%, 1, " ")
            End If
        End If
    ElseIf InStr(sSfdText$, "C. E.") > 0 Then
        bADPresent = True
        iRc% = InStr(sSfdText$, ", C. E.")
        If iRc% > 0 Then
            sSfdText$ = SafeStuff(sSfdText$, iRc%, 1, "")
        Else
            iRc% = InStr(sSfdText$, ",C. E.")
            If iRc% > 0 Then
                sSfdText$ = SafeStuff(sSfdText$, iRc%, 1, " ")
            End If
        End If
    Else
        ' same as above, but now for AD markers
        If InStr(sSfdText$, "A.D.") > 0 Then
            bADPresent = True
            iRc% = InStr(sSfdText$, ", A.D.")
            If iRc% > 0 Then
                sSfdText$ = SafeStuff(sSfdText$, iRc%, 1, "")
            Else
                iRc% = InStr(sSfdText$, ",A.D.")
                If iRc% > 0 Then
                    sSfdText$ = SafeStuff(sSfdText$, iRc%, 1, " ")
                End If
            End If
        ElseIf InStr(sSfdText$, "A. D.") > 0 Then
            bADPresent = True
            iRc% = InStr(sSfdText$, ", A. D.")
            If iRc% > 0 Then
                sSfdText$ = SafeStuff(sSfdText$, iRc%, 1, "")
            Else
                iRc% = InStr(sSfdText$, ",A. D.")
                If iRc% > 0 Then
                    sSfdText$ = SafeStuff(sSfdText$, iRc%, 1, " ")
                End If
            End If
        Else
            bADPresent = False
        End If
    End If
    
End Sub

Private Function SfdSortingFormDandYPseudoNormalization(ByVal sSfdText$) As String

    Dim sReturn$
    
    Dim iRc%
    
    ' in a previous step we found out about the BC- and AD-ness of the dates
    ' it is now save to remove the BC and AD markers (they just get in the way)
    ' while we're at it, we can put the text into uppercase
    ' NOTE THAT DO NOT NORMALIZE the text yet--some unresolved issues
    '   depend on the preservation of punctuation (commas and hyphens, especially)
    
    sReturn$ = ReplaceCharacters(sSfdText$, "B.C.E.", " ")
    sReturn$ = ReplaceCharacters(sReturn$, "B. C. E.", " ")
    sReturn$ = ReplaceCharacters(sReturn$, "BCE", " ")
    
    sReturn$ = ReplaceCharacters(sSfdText$, "B.C.", " ")
    sReturn$ = ReplaceCharacters(sReturn$, "B. C.", " ")
    
    sReturn$ = ReplaceCharacters(sReturn$, "C.E.", " ")
    sReturn$ = ReplaceCharacters(sReturn$, "C. E.", " ")
    
    sReturn$ = ReplaceCharacters(sReturn$, "A.D.", " ")
    sReturn$ = ReplaceCharacters(sReturn$, "A. D.", " ")
    sReturn$ = ReplaceCharacters(sReturn$, " AD", " ")
    
    If Mid(sReturn$, 1, 3) = "CA." Then
        sReturn$ = Trim(Mid(sReturn$, 4))
    End If
    
    sReturn$ = ReplaceCharacters(sReturn$, " CA.", " ")
    
    ' remove parentheses
    For iRc% = Len(sReturn$) To 1 Step -1
        If InStr("()[]{}", Mid(sReturn$, iRc%, 1)) > 0 Then
            sReturn$ = SafeStuff(sReturn$, iRc%, 1, "")
        End If
    Next
    
    ' don't need TRAILING commas or full stops
    If InStr(",.", Right(sReturn$, 1)) > 0 Then
        sReturn$ = Trim(Mid(sReturn$, 1, Len(sReturn$) - 1))
    End If
    
    ' one space in any one point is all we need
    ' the result is what we present to the caller
    SfdSortingFormDandYPseudoNormalization = Trim(RemoveRepeatedCharacters(sReturn$, " "))
    
End Function

Private Function SfdSortingFormYExceptionsToIsOk(ByVal sSubdivision$, ByVal iRc%) As Boolean

    ' 20090904: created
    
    ' we have found a $y subdivision that contains "TO" in it
    ' we need to distinguish between subdivisions in which "TO" means "from earliest times
    '   up to ..." some specified date, and situations in which "TO" is an incidental word
    '   in a subdivision constructed according to some other pattern
    ' in other words, we need to determine that the following kinds of subdivisons
    '   are NOT "TO" subdivisions:
    '   $y Ba To Uprising, 1945
    '   $y Cession to the United Staes, 1819
    '   $y Movement to Protect the Constitution, 1917-1923
    '   $y Stuarts, to the Union, 1371-1707
    '   $y Surrender to the British, 1812
    '   $y Transfer of Sovereignty to China, 1997
    ' ... while continuing to recognize the subdivisions like the following as those
    '   calling for treatment as "TO" subdivision:
    '   $y To 1492
    '   $y Ancient to 640 A.D.
    ' the rule that seems to work is this: if the separate word "TO" is followed
    '   immediately by a numeral, then we should treat the subdivision as a "TO" subdivision;
    '   if the word "TO" is followed by anything else, then we should follow the standard
    '   pattern for chronological subdivisions
    
    ' on entry, sSubdivision$ contains the pseudo-normalized subdivision of
    '   interest, and iRc% points to the 4-character sequence " TO "
    ' to satisfy our rule, the fourth character after iRc% must be a numeral
    
    'Debug.Print "Is 'TO' OK? " + str(iRc%) + " >" + sSubdivision$ + "<"
    If iRc% < 1 Then
        SfdSortingFormYExceptionsToIsOk = False
    ElseIf InStr("123456789", Mid(sSubdivision$, iRc% + 4, 1)) > 0 Then
        SfdSortingFormYExceptionsToIsOk = True
    Else
        SfdSortingFormYExceptionsToIsOk = False
    End If

End Function
